/**************************  Release 2_A02 *********************************/  

//Indice su contatori registri
IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'contatori_registri' and iname = 'xk_cont_reg_mod')) THEN
	CREATE UNIQUE INDEX "xk_cont_reg_mod" ON "dba"."contatori_registri" ("id_mod_registro" );
	;
END IF;

//CONTROLLO PROFILI INSOLUTI
update prof_registrazione set  crea_partita='N'  where usa_insoluti='S' and crea_partita='S';


//IL PALLE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_trac_int')) THEN

CREATE TABLE "dba"."tmp_trac_int" 
("id_tmp_trac_int" integer NOT NULL DEFAULT autoincrement, 
"id_tmp_trac_lotti" integer DEFAULT NULL, 
"ubicazione" char(60) DEFAULT NULL, 
"unita_prod" char(60) DEFAULT NULL, 
"mangime" char(60) DEFAULT NULL, 
"trattamento1" char(60) DEFAULT NULL, 
"trattamento2" char(60) DEFAULT NULL, 
"trattamento3" char(60) DEFAULT NULL, 
"trattamento4" char(60) DEFAULT NULL, 
"trattamento5" char(60) DEFAULT NULL, 
"trattamento6" char(60) DEFAULT NULL, 
"trattamento7" char(60) DEFAULT NULL, 
"trattamento8" char(60) DEFAULT NULL, 
"trattamento9" char(60) DEFAULT NULL, 
"trattamento10" char(60) DEFAULT NULL, 
"vac1" char(60) DEFAULT NULL, 
"lotto1" char(15) DEFAULT NULL, 
"data1" date DEFAULT NULL, 
"vac2" char(60) DEFAULT NULL, 
"lotto2" char(15) DEFAULT NULL, 
"data2" date DEFAULT NULL, 
"vac3" char(60) DEFAULT NULL, 
"lotto3" char(15) DEFAULT NULL, 
"data3" date DEFAULT NULL, 
"vac4" char(60) DEFAULT NULL, 
"lotto4" char(15) DEFAULT NULL, 
"data4" date DEFAULT NULL, 
"vac5" char(60) DEFAULT NULL, 
"lotto5" char(15) DEFAULT NULL, 
"data5" date DEFAULT NULL, 
"vac6" char(60) DEFAULT NULL, 
"lotto6" char(15) DEFAULT NULL, 
"data6" date DEFAULT NULL, 
"vac7" char(60) DEFAULT NULL, 
"lotto7" char(15) DEFAULT NULL, 
"data7" date DEFAULT NULL, 
"vac8" char(60) DEFAULT NULL, 
"lotto8" char(15) DEFAULT NULL, 
"data8" date DEFAULT NULL, 
"vac9" char(60) DEFAULT NULL, 
"lotto9" char(15) DEFAULT NULL, 
"data9" date DEFAULT NULL, 
"vac10" char(60) DEFAULT NULL, 
"lotto10" char(15) DEFAULT NULL, 
"data10" date DEFAULT NULL , 
PRIMARY KEY ("id_tmp_trac_int") , 
FOREIGN KEY "fk_tmp_trac_int" ("id_tmp_trac_lotti" ) REFERENCES "dba"."tmp_trac_lotti" ON DELETE CASCADE ) ;
end if;

////////////cortonese
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'lotto'
        AND    CNAME = 'num_lotto_prod2' )) THEN

        ALTER TABLE lotto  ADD
               num_lotto_prod2 integer
        ;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'movimenti_lotto'
        AND    CNAME = 'num_lotto_prod2' )) THEN

        ALTER TABLE movimenti_lotto  ADD
               num_lotto_prod2 integer
        ;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_doc_lotto'
        AND    CNAME = 'num_lotto_prod2' )) THEN

        ALTER TABLE riga_doc_lotto  ADD
               num_lotto_prod2 integer
        ;
END IF;

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
   WHERE  tname = 'lotto' 
	AND 	 iname = 'ix_lotto_prod2')) THEN

	CREATE INDEX ix_lotto_prod2 ON lotto (num_lotto_prod2)
	;
END IF
;

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
   WHERE  tname = 'movimenti_lotto' 
	AND 	 iname = 'ix_mov_lottoprod2')) THEN

	CREATE INDEX ix_mov_lottoprod2 ON movimenti_lotto (num_lotto_prod2)
	;
END IF
;
////////////cortonese

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'id_conto_ratei_attivi' )) THEN 
	alter table par_sistema add id_conto_ratei_attivi integer;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'id_conto_ratei_passivi' )) THEN 
	alter table par_sistema add id_conto_ratei_passivi integer;
end if;

//////////////// OUTLET PARIGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'id_prof_doc_ord_7400_2' )) THEN 
	alter table pers_par_sistema add id_prof_doc_ord_7400_2 integer;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'id_caus_prep_7400_2' )) THEN 
	alter table pers_par_sistema add id_caus_prep_7400_2 integer;
end if;
//////////////// OUTLET PARIGI

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
                  AND      CNAME = 'nome_report_2' )) THEN 
	alter table prof_documento add nome_report_2 char(40);
end if;

////////PAD esplosione con agg. impegnato
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'esp_ordimp')) THEN
	CREATE TABLE "dba"."esp_ordimp" 
	("id_esp_ordimp" integer NOT NULL DEFAULT autoincrement, 
	"id_documento" integer DEFAULT NULL, 
	"esploso" char(1) DEFAULT NULL , 
	PRIMARY KEY ("id_esp_ordimp") , 
	FOREIGN KEY "fk_esp_ordimp1" ("id_documento" ) REFERENCES "dba"."documento" ON DELETE CASCADE ) ;
end if;
/////////////////////////////////////////

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'tipo_riga_doc' )) THEN 
	alter table par_sistema add tipo_riga_doc char(1);
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_registrazione'
                  AND      CNAME = 'usa_ratei' )) THEN 
	alter table prof_registrazione add usa_ratei char(1) DEFAULT 'N';
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'auto_retrieve' )) THEN 
	Alter table par_sistema add auto_retrieve char(1);
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cod_barre_esteso')) THEN

	CREATE TABLE "dba"."cod_barre_esteso" ("id_cod_barre_esteso" integer NOT NULL DEFAULT 		autoincrement, 
	"cod_barre_esteso" char(80) NOT NULL DEFAULT NULL, 
	"id_unita_confezione" integer NOT NULL DEFAULT NULL, 
	"id_azienda" integer NOT NULL DEFAULT 1
	, PRIMARY KEY ("id_cod_barre_esteso") , 
	FOREIGN KEY "fk_cod_barre_est" ("id_unita_confezione" ) REFERENCES "dba"."unita_confezione" ON 		DELETE RESTRICT ) ;
	CREATE UNIQUE INDEX "ix_cod_barre_est" ON "dba"."cod_barre_esteso" ("cod_barre_esteso" , 		"id_azienda" ) ;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento'
                  AND      CNAME = 'id_distinta' )) THEN 
	alter table riga_documento add id_distinta integer;
end if;


//MODIFICA FN_INS_VOCE_MENU
ALTER PROCEDURE "DBA"."fn_ins_voce_menu"(@des_padre char(40), @oggetto char(40),@des_oggetto char(40),@ordine integer) /* parameters,... */
as
begin
 
  declare @li_id_oggetto integer,
  @id_voce_padre integer,
  @id_menu integer,
  @li_return integer,
  @li_app integer,
  @ll_esiste integer,
  @li_sqlstatus integer,
  @li_id_ogg_app integer
  message 'aa'||string(@des_padre)
  if not(@des_padre is null) and @des_padre<>''
    begin
      declare cur_menu dynamic scroll cursor for select voci_menu.id_voci_menu
          from voci_menu where vmenu_voce=@des_padre
      open cur_menu
      select @li_sqlstatus=0
      /**/
      while(@li_sqlstatus=0)
        begin
          fetch next cur_menu into @id_voce_padre
          select @li_sqlstatus=@@sqlstatus
          if(@li_sqlstatus=0)
            begin
              if not(@id_voce_padre is null)
                select @li_return=1
              else
                select @li_return=0
              if(@li_return=1)
                begin
                  message 'ID voce padre:'||string(@id_voce_padre)
                  message 'Oggetto:'||string(@oggetto)
                  //Inserisco sotto voce menu
                  if (@oggetto is null) or (@oggetto='')
                    begin
                      select @li_id_ogg_app=id_voci_menu
                      from voci_menu
                      where vmenu_voce=@des_oggetto
                      message 'sotto menu:'||string(@li_id_ogg_app)
                      if @li_id_ogg_app is null                          
                            insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) values(
                            @id_voce_padre,@des_oggetto,null,@ordine)
                    end
                  /**/
                  else
                     begin
                       select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       if @li_id_oggetto is null
                          begin
                          insert into oggetti (ogg_oggetto) values (@oggetto)
                          select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       end 
                      
                      Select @ll_esiste=max(id_voci_menu) from voci_menu
                      where id_oggetti=@li_id_oggetto and id_voci_menu_padre=@id_voce_padre
                      and vmenu_voce=@des_oggetto
                      message 'hh'||string(@ll_esiste)
                      if @ll_esiste is null
                         begin
                         insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) values(
                         @id_voce_padre,@des_oggetto,@li_id_oggetto,@ordine)
                      end 
                  end  
              end
          end
        end
        close cur_menu
    end
end;


call fn_ins_voce_menu('Altre Stampe Contabili', 'w_partitario_ff', 'Stampa Partitario', 199);

////////////////////STORICO VARIAZIONE PREZZI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'storico_prezzo')) THEN
CREATE TABLE "dba"."storico_prezzo" 
("id_storico_prezzo" integer NOT NULL DEFAULT autoincrement, 
"id_unita_confezione" integer DEFAULT NULL, 
"id_variazione" integer DEFAULT NULL, 
"prezzo" numeric(20,6) DEFAULT NULL, 
"data_var" date DEFAULT NULL , 
PRIMARY KEY ("id_storico_prezzo") , 
FOREIGN KEY "fk_storico_prezzo_1" ("id_unita_confezione" ) 
REFERENCES "dba"."unita_confezione" ON DELETE CASCADE , 
FOREIGN KEY "fk_storico_prezzo_2" ("id_variazione" ) 
REFERENCES "dba"."variazione" ON DELETE CASCADE ) ;
CREATE INDEX "ix_storico_prezzo1" ON "dba"."storico_prezzo" ("id_unita_confezione" , "id_variazione" , "data_var" ) ;

CREATE TRIGGER "t_prezzo_ai".t_prezzo_ai after insert order 1
on "DBA".prezzo
referencing new as new_prz
for each row
begin
 
 declare @id_unita_confezione integer;
 declare @id_variazione integer;
 declare @prezzo decimal(20,6);
 declare @data_var date;
 
 set @id_unita_confezione=new_prz.id_unita_confezione;
 set @id_variazione=new_prz.id_variazione;
 set @prezzo=new_prz.prezzo;
 set @data_var=today(*);

 insert into "dba".storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var) 
 values(@id_unita_confezione, @id_variazione, @prezzo, @data_var)

end;


//////////////////////////////

CREATE TRIGGER "t_prezzo_au".t_prezzo_au after update order 1
on "DBA".prezzo
referencing new as new_prz
for each row
begin
 
 declare @id_unita_confezione integer;
 declare @id_variazione integer;
 declare @prezzo decimal(20,6);
 declare @data_var date;
 declare @id_storico_prezzo integer;
 
 set @id_unita_confezione=new_prz.id_unita_confezione;
 set @id_variazione=new_prz.id_variazione;
 set @prezzo=new_prz.prezzo;
 set @data_var=today(*);

 select id_storico_prezzo into @id_storico_prezzo 
 from storico_prezzo
 where id_unita_confezione = @id_unita_confezione
 and id_variazione = @id_variazione
 and data_var = @data_var;

 if(@id_storico_prezzo is not null) then
 	update storico_prezzo
 	set prezzo = @prezzo
 	where id_unita_confezione = @id_unita_confezione
 	and id_variazione = @id_variazione
 	and data_var = @data_var
 else
 	insert into "dba".storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var) 
 	values(@id_unita_confezione, @id_variazione, @prezzo, @data_var)
 end if

end;

end if;

call fn_ins_voce_menu('Controllo', 'w_storico_prezzi_wz', 'Stampa Storico variazione Prezzi', 410);
////////////////////STORICO VARIAZIONE PREZZI

//Campo bloccare campo iva nella documento
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'blocca_doc_iva' )) THEN 
	alter table par_sistema add blocca_doc_iva char (1);
end if;


call fn_ins_voce_menu('Controllo', 'w_st_ordini_ff', 'Stampa Situazione Ordini', 420);

/////////////Proposta Tipo U.C. nei documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'prop_uc_windoc' )) THEN 
	alter table pers_par_sistema add prop_uc_windoc char (1) DEFAULT NULL;
end if;


//registrazione insoluti
ALTER TRIGGER "t_scade_ai".t_scade_ai after insert order 1
on "DBA".scadenza
referencing new as new_scadenza
for each row
begin
  declare @ll_id_scadenza integer;
  declare @id_riga integer;
  declare @is_stato char(1);
  //
  //
  set @ll_id_scadenza=new_scadenza.id_scadenza;
  set @id_riga=new_scadenza.id_riga_distinta_banca;
  set @is_stato=new_scadenza.esito_pagamento;
  //
  //
  message 'SCADENZA:'+ @is_stato;
  message 'SCADENZA:'+STRING(@ll_id_scadenza);
  if(@id_riga) is null and @is_stato<>'I' then
    print 'INSERT riga is null';
    // bl#17622#
    update scadenza set
      esito_pagamento='E',data_cambiamento_stato=today(*) //now(*)
      where id_scadenza=@ll_id_scadenza
  else
    // bl#17622#
    print 'INSERT riga is not null';
    update scadenza set
      data_cambiamento_stato=today(*) //now(*)
      where id_scadenza=@ll_id_scadenza
  end if
end;


ALTER TRIGGER "t_scade_ad".t_scade_ad before delete order 1
on "DBA".scadenza
referencing old as old_scadenza
for each row
begin
  /*
  Elisa M.		19/09/00		BL8747
  Non e'' possibile cancellare le scadenze gia'' pagate
  */
  declare @ls_esito_pagamento char(1);
  set @ls_esito_pagamento=old_scadenza.esito_pagamento;
  if(@ls_esito_pagamento<>'E') AND (@ls_esito_pagamento<>'I') then
    raiserror 99999 'Non e'' possibile modificare una scadenza con esito diverso da E'
  end if
end;

update prof_registrazione set crea_partita='N' where usa_insoluti='S';

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_aperta'
                  AND      CNAME = 'id_reg_insoluti' )) THEN 
	alter table par_aperta add id_reg_insoluti integer;
end if;

//fine insoluti


//contropartite . non permetteva cambiamento contropartita in
//soggetto gi esistente

ALTER TRIGGER "t_con_movimento_bu".t_con_movimento_bu before update order 2
on "DBA".con_movimento
referencing old as deleted new as inserted
for each row
begin
  /*      Rif. Bolla 7028               Elisa Moneti 10/04/2000
  Non deve essere possibile inserire lo stesso Sogg. Commerciale per pi di una
  volta.  */
  /**/
  declare @li_ga integer;
  declare @li_id_con integer;
  declare @li_sc integer;
  declare @li_ccsc integer;
  declare @li_ar integer;
  declare @li_ccar integer;
  declare @li_caus integer;
  declare @li_pri smallint;
  declare @ls_key char(60);
  declare @li_id_sog_commerciale integer;
  declare @li_app integer;
  /**/
  set @li_ga=inserted.id_gruppo_agenti;
  set @li_sc=inserted.id_sog_commerciale;
  set @li_ccsc=inserted.id_cat_com_sc;
  set @li_ar=inserted.id_articolo;
  set @li_ccar=inserted.id_cat_com_articolo;
  set @li_caus=inserted.id_caus_magazzino;
  set @li_id_sog_commerciale=inserted.id_sog_commerciale;
  set @li_id_con=inserted.id_con_movimento;
  /**/
  set @li_pri=sf_prior_cpt(@li_ga,@li_sc,@li_ccsc,@li_ar,@li_ccar,@li_caus);
  set @ls_key=sf_key_cpt(@li_ga,@li_sc,@li_ccsc,@li_ar,@li_ccar,@li_caus);
  set inserted.priorita=@li_pri;
  set inserted.chiave=@ls_key;
//nell'insert va bene ma nell'update uno c' sicuro 
//quindi il controllo va fatto escludendo quello che
//sto salvando
  select 2 into @li_app
    from con_movimento
    where id_sog_commerciale=@li_id_sog_commerciale
    and id_con_movimento<>@li_id_con;
  if(@li_app=1) then
    raiserror 99999 'Il Sogg. Commerciale specificato e'' gia'' stato inserito '
  end if
end;

//fine contropartite


//Stato soggetto commerciale
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sog_commerciale'
                  AND      CNAME = 'stato_utilizzo' )) THEN 
	alter table sog_commerciale add stato_utilizzo char(1) default 'S';
	update sog_commerciale set stato_utilizzo='S';
end if;


//insoluti a menu in registrazioni contabili
call fn_ins_voce_menu('Registrazioni Contabili', 'w_insoluti_cx', 'Registrazione Insoluti', 8);
//Tracciatura documenti
call fn_ins_voce_menu('Documenti', 'w_estratto_fatture_ff', 'Tracciatura documenti da Fatture', 106);

///////AGGIORNAMENTO WEB
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_cfg'
                  AND      CNAME = 'id_sog_com' )) THEN 
        alter table web_cfg add id_sog_com integer DEFAULT NULL;          
end if;     

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'web_ordine_t')) THEN
		CREATE TABLE "dba"."web_ordine_t" 
		("id_web_ordine_t" integer NOT NULL DEFAULT autoincrement, 
		"id_web_utenti" integer DEFAULT NULL, 
		"note" char(255) DEFAULT NULL, 
		"data_ord" char(10) DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"data_cons" char(10) DEFAULT NULL, 
		"n_righe" integer DEFAULT NULL, 
		"invio_email" char(1) DEFAULT NULL, 
		"email_cliente" char(50) DEFAULT NULL, 
		"import" char(1) DEFAULT 'N' , 
		PRIMARY KEY ("id_web_ordine_t")) ;

	CREATE INDEX "ix_web_ordine_t1" 
	ON "dba"."web_ordine_t" ("id_web_utenti" , "data_ord" , "id_sog_commerciale" ) IN dvindex;
end if;

///////////////////////////////////

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'web_ordine_r')) THEN
	CREATE TABLE "dba"."web_ordine_r" 
	("id_web_ordine_r" integer NOT NULL DEFAULT autoincrement, 
	"id_web_ordine_t" integer NOT NULL DEFAULT NULL, 
	"n_riga" integer DEFAULT NULL, 
	"id_articolo" integer DEFAULT NULL, 
	"sconto1" char(5) DEFAULT NULL, 
	"sconto2" char(5) DEFAULT NULL, 
	"sconto3" char(5) DEFAULT NULL, 
	"quantita" decimal(18,4) DEFAULT NULL, 
	"prezzo" decimal(18,4) DEFAULT NULL , 
	PRIMARY KEY ("id_web_ordine_r") , 
	FOREIGN KEY "fk_web_ordine_r1" ("id_web_ordine_t" ) REFERENCES "dba"."web_ordine_t" ON DELETE CASCADE ) ;

	CREATE UNIQUE INDEX "ix_web_ordine_r1" ON "dba"."web_ordine_r" 
	("id_web_ordine_t" , "n_riga" ) IN dvindex;   
end if;          
////////////////////////

////////////PROPOSTA UTENTE NEI DOCUMENTI (OLMO)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
                  AND      CNAME = 'proponi_doc' )) THEN 
				alter table utenti add proponi_doc char(1) DEFAULT 'S';
				
				update utenti
				set proponi_doc = 'S';
end if;   

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
                  AND      CNAME = 'id_utente' )) THEN 
        alter table documento add id_utente integer DEFAULT NULL;  

	set options fire_triggers = 'OFF';
	update documento
	set id_utente = (select min(id_utenti) from utenti);
	set options fire_triggers = 'ON';        
end if;                                 
////////////////////////////////////////////////


//telefono azienda
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'azienda'
                  AND      CNAME = 'tel_amministrazione' )) THEN 
	alter table azienda add tel_amministrazione char(20);
end if;                                 

/////////Priorit Contropartite Articolo, Soggetto, Causale
ALTER FUNCTION "DBA"."sf_prior_cpt"(in @ga integer,in @sc integer,in @ccsc integer,in @ar integer,in @ccar integer,in @caus integer)
returns smallint
/*
calcolo della priorit della contropartita in base ai parametri passati.
*/
begin
  declare @li_ret smallint;
  declare @li_1 smallint;
  declare @li_2 smallint;
  declare @li_3 smallint;
  /* condizionamento dei parametri di ingresso */
  if @ga is null then set @ga=0
  end if
  ;
  if @sc is null then set @sc=0
  end if
  ;
  if @ccsc is null then set @ccsc=0
  end if
  ;
  if @ar is null then set @ar=0
  end if
  ;
  if @ccar is null then set @ccar=0
  end if
  ;
  if @caus is null then set @caus=0
  end if
  ;
  /* calcolo */
  set @li_1=0;
  set @li_2=0;
  set @li_3=0;
  if @ga>0 then set @li_1=1
  end if
  ;
  if @caus>0 then set @li_1=2
  end if
  ;
  if @ccar>0 then set @li_2=1
  end if
  ;
  if @ar>0 then set @li_2=2
  end if
  ;
  if @ccsc>0 then set @li_3=1
  end if
  ;
  if @sc>0 then set @li_3=2
  end if
  ;
  //set @li_ret=100*@li_1+10*@li_2+@li_3; //Priorit Causale, Articolo, Soggetto
  set @li_ret=100*@li_2+10*@li_3+@li_1; //Priorit Articolo, Soggetto, Causale
  return(@li_ret)
end;

update con_movimento
set priorita = 0;
////////////////////////////////////////////////////


//Creazione voce menu esposizione
call fn_ins_voce_menu('Altre Stampe Contabili', 'w_esposto_ff', 'Stampa Esposizione', 205);

//Altezza righe documento
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'dim_righe_doc' )) THEN 
	alter table par_sistema add dim_righe_doc char (1) DEFAULT NULL;
end if;


//MIGLIORIA CHIUSURA PARTITE 
ALTER TRIGGER "t_con_movimento_bu".t_con_movimento_bu before update order 2
on "DBA".con_movimento
referencing old as deleted new as inserted
for each row
begin
  /*      Rif. Bolla 7028               Elisa Moneti 10/04/2000
  Non deve essere possibile inserire lo stesso Sogg. Commerciale per pi di una
  volta.  */
  /**/
  declare @li_ga integer;
  declare @li_id_con integer;
  declare @li_sc integer;
  declare @li_ccsc integer;
  declare @li_ar integer;
  declare @li_ccar integer;
  declare @li_caus integer;
  declare @li_pri smallint;
  declare @ls_key char(60);
  declare @li_id_sog_commerciale integer;
  declare @li_app integer;
  /**/
  set @li_ga=inserted.id_gruppo_agenti;
  set @li_sc=inserted.id_sog_commerciale;
  set @li_ccsc=inserted.id_cat_com_sc;
  set @li_ar=inserted.id_articolo;
  set @li_ccar=inserted.id_cat_com_articolo;
  set @li_caus=inserted.id_caus_magazzino;
  set @li_id_sog_commerciale=inserted.id_sog_commerciale;
  set @li_id_con=inserted.id_con_movimento;
  /**/
  set @li_pri=sf_prior_cpt(@li_ga,@li_sc,@li_ccsc,@li_ar,@li_ccar,@li_caus);
  set @ls_key=sf_key_cpt(@li_ga,@li_sc,@li_ccsc,@li_ar,@li_ccar,@li_caus);
  set inserted.priorita=@li_pri;
  set inserted.chiave=@ls_key;
//nell'insert va bene ma nell'update uno c' sicuro 
//quindi il controllo va fatto escludendo quello che
//sto salvando
  select 2 into @li_app
    from con_movimento
    where id_sog_commerciale=@li_id_sog_commerciale
    and id_con_movimento<>@li_id_con;
  if(@li_app=1) then
    raiserror 99999 'Il Sogg. Commerciale specificato e'' gia'' stato inserito '
  end if
end;

ALTER TRIGGER t_stato_partita_ai after insert order 1
on "dba".mov_partita
referencing new as new_row
for each row
begin
  declare @imp_par decimal(18,4);
  declare @imp_mov decimal(18,4);
  select sum(importo) into @imp_mov from mov_partita
    where mov_partita.id_par_aperta=new_row.id_par_aperta;
  select importo into @imp_par from par_aperta
    where par_aperta.id_par_aperta=new_row.id_par_aperta;
  if @imp_par<=@imp_mov then
    update par_aperta set stato='C' where id_par_aperta=new_row.id_par_aperta
  end if
end;

//FINE PARTITE


//Parametrizzazione Insoluto
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'tipo_onere' )) THEN 
	alter table par_sistema add tipo_onere char (1) DEFAULT NULL;
	alter table par_sistema add id_conto_onere integer DEFAULT NULL;
end if;


/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_002' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_002','Release 2_01_002  Cometa','S')
        ;

END IF
;
