//INIZIO 2_01_006


//TAGLIE E COLORI

if(not(exists(select 1 from sys.systable where table_name='config_prof_pagamento'))) then
	CREATE TABLE "dba"."config_prof_pagamento" 
	("id_prof_documento" integer NOT NULL DEFAULT NULL, 
	"id_con_pagamento" integer NOT NULL DEFAULT NULL , 
	PRIMARY KEY ("id_prof_documento", "id_con_pagamento")) ;
	CREATE TABLE "dba"."config_prof_utente" 
	("id_prof_documento" integer NOT NULL DEFAULT NULL, 
	"id_utente" integer NOT NULL DEFAULT NULL , 
	PRIMARY KEY ("id_prof_documento", "id_utente")) ;
end if;

if(not(exists(select 1 from sys.systable where table_name='artvar_prezzo'))) then
	CREATE TABLE "dba"."artvar_prezzo" 
	("pk_codice" char(20) NOT NULL DEFAULT NULL, 
	"id_unita_confezione" integer NOT NULL DEFAULT NULL, 
	"id_art_var1" integer DEFAULT NULL, 
	"id_art_var2" integer DEFAULT NULL, 
	"id_art_var3" integer DEFAULT NULL, 
	"id_variazione" integer NOT NULL DEFAULT NULL, 
	"prezzo" numeric(20,6) DEFAULT NULL, 
	"sconto_applicato" numeric(18,2) DEFAULT NULL , 
	PRIMARY KEY ("pk_codice", "id_unita_confezione", "id_variazione") , FOREIGN KEY "fk_prezzo_1" ("id_unita_confezione" ) REFERENCES "dba"."unita_confezione" ON DELETE CASCADE , FOREIGN KEY "fk_prezzo_2" ("id_variazione" ) REFERENCES "dba"."variazione" ON DELETE RESTRICT ) ;
	CREATE INDEX "ix_artvar_prezzo_1" ON "dba"."artvar_prezzo" ("id_variazione" ) ;
	CREATE INDEX "ix_artvar_prezzo_2" ON "dba"."artvar_prezzo" ("id_unita_confezione" ) ;
	CREATE UNIQUE INDEX "XK_ART_VAR1" ON "dba"."art_var1" ("cod_var1" ) ;
	CREATE UNIQUE INDEX "XK_ART_VAR2" ON "dba"."art_var2" ("cod_var2" ) ;
	CREATE UNIQUE INDEX "XK_ART_VAR3" ON "dba"."art_var3" ("cod_var3" ) ;

	CREATE TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	END;
	
	
	
	CREATE TRIGGER "t_artvar_prezzo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	END;

end if;


IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSCOLUMNS WHERE TNAME='con_lis_articolo' AND CNAME='filtra_varianti' )) THEN 
        ALTER TABLE "dba"."con_lis_articolo"  add "filtra_varianti" char(1) DEFAULT 'N';
end if;

if(not(exists(select 1 from sys.systable where table_name='var_con_lis_articolo'))) then
	CREATE TABLE "dba"."var_con_lis_articolo" 
	("id_var_con_lis_articolo" integer NOT NULL DEFAULT autoincrement, 
	"id_con_lis_articolo" integer NOT NULL DEFAULT NULL, 
	"pk_codice" char(20) NOT NULL DEFAULT NULL, 
	"id_unita_confezione" integer DEFAULT NULL, 	
	"id_art_var1" integer DEFAULT NULL, 
	"id_art_var2" integer DEFAULT NULL, 
	"id_art_var3" integer DEFAULT NULL , 
	PRIMARY KEY ("id_var_con_lis_articolo") , 
	FOREIGN KEY "fk_var_con_lis_articolo_1" ("id_unita_confezione" ) REFERENCES "dba"."unita_confezione" ON DELETE RESTRICT ) ;


	CREATE TRIGGER "t_var_con_lis_articolo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."var_con_lis_articolo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
	CREATE TRIGGER "t_var_con_lis_articolo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."var_con_lis_articolo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;

end if;




IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSCOLUMNS WHERE TNAME='riepilogo' AND CNAME='id_art_var1' )) THEN 
	alter table riepilogo add "id_art_var1" integer DEFAULT NULL;
	alter table riepilogo add "id_art_var2" integer DEFAULT NULL;
	alter table riepilogo add "id_art_var3" integer DEFAULT NULL;
	alter table riepilogo add "pk_codice" char(20) null DEFAULT NULL;
	update riepilogo set pk_codice='N@N@N';
	alter table riepilogo modify "pk_codice" char(20) not null DEFAULT NULL;
	alter table riepilogo drop PRIMARY KEY ;
	alter table riepilogo add PRIMARY KEY ("id_esercizio", "id_attivita", "id_articolo", "id_locazione", "anno", "mese", "id_valuta", "pk_codice");
	
	
	
	CREATE TRIGGER "t_riepilogo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."riepilogo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
	CREATE TRIGGER "t_riepilogo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."riepilogo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 varchar;
	    declare @ls_var2 varchar;
	    declare @ls_var3 varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
end if;

if exists (select * from SYS.SYSPROCEDURE where proc_name = 'fn_ultimo_costo_var') then
    drop function fn_ultimo_costo_var;
end if;


	CREATE FUNCTION "DBA"."fn_ultimo_costo_var"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer,in @ai_id_valuta integer, in as_pk_codice char)
	returns dm_Imp_6_Dec
	begin
	  declare @ld_ultimo_costo dm_Imp_6_Dec;
	  declare @li_id_esercizio integer; 
	  declare @li_id_valuta integer; 
	  declare c_ultimo_costo_mag dynamic scroll cursor for select ult_costo, id_valuta
	      from riepilogo where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
	      and id_articolo=@id_articolo and pk_codice=as_pk_codice
	      and id_locazione=any(select id_locazione from locazione where id_magazzino=@id_magazzino)
	      and(riepilogo.anno<@anno or(riepilogo.anno=@anno and riepilogo.mese<=@mese))
	      and(riepilogo.ult_costo is not null and riepilogo.ult_costo>0) 
	      order by anno desc,mese desc,data_ult_costo desc;
	  declare c_ultimo_costo dynamic scroll cursor for select ult_costo, id_valuta
	      from riepilogo where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
	      and id_articolo=@id_articolo and pk_codice=as_pk_codice
	      and(riepilogo.anno<@anno or(riepilogo.anno=@anno and riepilogo.mese<=@mese))
	      and(riepilogo.ult_costo is not null and riepilogo.ult_costo>0) 
	      order by anno desc,mese desc,data_ult_costo desc;
	
	  if(@id_magazzino=0 or @id_magazzino is null) then
	    open c_ultimo_costo;
	    fetch next c_ultimo_costo into @ld_ultimo_costo,@li_id_valuta;
	    close c_ultimo_costo
	  else
	    open c_ultimo_costo_mag;
	    fetch next c_ultimo_costo_mag into @ld_ultimo_costo,@li_id_valuta;
	    close c_ultimo_costo_mag
	  end if
	  ;
	  if(@li_id_valuta>0 and @ai_id_valuta>0 and @li_id_valuta<>@ai_id_valuta and @ld_ultimo_costo>0) then
	    set @ld_ultimo_costo=fn_conv_valuta(@li_id_valuta,@ld_ultimo_costo,@ai_id_valuta)
	  end if
	  ;
	  return(@ld_ultimo_costo)
	end;
	
	
	//SP_GEST_CAUSALE

if exists (select * from SYS.SYSPROCEDURE where proc_name = 'sp_gest_causale_var') then
    drop function sp_gest_causale_var;
end if;
	
	CREATE PROCEDURE "sp_gest_causale_var"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Elisa Moneti      29/01/1999
	  Oggetto: Aggiornamento della "Data Ultimo Scarico"
	
	  Elisa M.              21/06/1999 
	  Gestione Ordinato Clienti e Ordinato Fornitori,
	  in seguito alla cancellazione, inserimento o modifica di una riga documento
	  con una causale di mag. che decrementa uno di questi due valori
	
	  Elisa M.    23/05/2000
	  Aggiornamento dell'ultimo costo sia che la movimentazione sia a peso che in quantita'
	
	  Elisa Moneti  20/09/2000      
	  Rif. Bolla 7889 : Aggiornamento dei riepiloghi di magazzino a peso
	
	  Elisa Moneti  31/08/2001
	  BL#15075# -  gestione Valuta per passaggio all''Euro
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)
	  /*
	  Stefano
	  recupero mp_car_fiscali e md_car_fiscale relativamente alla causale
	  di magazzino per sapere se deve essere aggiornato o no il primo costo
	  */
	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino
	  /*stefano controlo se l'unita' confezione della riga + un'unita' base; se si aggiorno l''ultimo
	  costo altrimenti no*/
	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione
	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      /*
	      Elisa M.        23/05/00
	      Se la movimentazione e' a peso, il prezzo viene calcolato in base al peso,
	      altrimenti in base alla quantita'
	      */
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              /*select @Prezzo=@Valore/@peso_netto*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              /*select @Prezzo=@Valore/@Qta*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        /*          message ' Prezzo:'||string(@Prezzo)*/
	        end
	      /* BL#15075#i*/
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      /* BL#15075#f*/
	      /* Carico i valori di causale di magazzino per il magazzino pricipale*/
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riepilogo.ult_costo,
	        @Data_Ult_Costo=riepilogo.data_ult_costo,
	        @Qta_Rim_Iniziale=riepilogo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riepilogo.val_rim_iniziale,
	        @Qta_Caricata=riepilogo.qta_caricata,
	        @Qta_Scaricata=riepilogo.qta_scaricata,
	        @Val_Caricato=riepilogo.val_caricato,
	        @Val_Scaricato=riepilogo.val_scaricato,
	        @Data_Ult_Scarico=riepilogo.data_ult_scarico,
	        @Qta_Ord_Clienti=riepilogo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riepilogo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riepilogo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riepilogo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riepilogo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riepilogo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riepilogo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riepilogo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riepilogo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riepilogo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riepilogo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riepilogo.qta_gruppo_lib_4,
	        @peso_caricato=riepilogo.peso_caricato,
	        @peso_scaricato=riepilogo.peso_scaricato,
	        @peso_ord_clienti=riepilogo.peso_ord_clienti,
	        @peso_ord_fornitori=riepilogo.peso_ord_fornitori,
	        @peso_vis_clienti=riepilogo.peso_vis_clienti,
	        @peso_vis_fornitori=riepilogo.peso_vis_fornitori,
	        @peso_imp_produzione=riepilogo.peso_imp_produzione,
	        @peso_ord_produzione=riepilogo.peso_ord_produzione,
	        @peso_cl_clienti=riepilogo.peso_cl_clienti,
	        @peso_cl_fornitori=riepilogo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riepilogo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riepilogo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riepilogo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riepilogo.peso_gruppo_lib_4
	        from "dba".riepilogo
	        where(riepilogo.id_esercizio=@Id_Esercizio)
	        and(riepilogo.id_attivita=@Id_Attivita)
	        and(riepilogo.id_articolo=@Id_Articolo)
	        and(riepilogo.pk_codice=@pk_codice)
	        and(riepilogo.id_locazione=@Id_Locazione)
	        and(riepilogo.anno=@Anno)
	        and(riepilogo.mese=@Mese)
	        and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	      /*      message 'ccc'*/
	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)
	      /*      message 'Ultimo Costo:'||@M_Ult_Costo||' Data_ult_costo:'||string(@Data_ult_costo)||' Data:'||string(@LaData)||' U.B.:'||@unita_base*/
	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          /* BL#20265#i */
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          /*select @Ult_Costo=@Prezzo*/
	          /* BL#2026#f*/
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end
	      /*
	      Elisa M.                          21/06/1999
	      Gestione Ordinato Clienti e Ordinato Fornitori
	      */
	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza
	      /*
	      Elisa Moneti
	      29/01/1999
	      Oggetto: Aggiornamento della "Data Ultimo Scarico"
	      */
	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          /*
	          Elisa M.                              21/06/1999
	          Gestione Ordinato Clienti
	          */
	          if @M_Ord_Clienti='-'
	            begin
	              /* STORNO (DELETE e prima parte dell''UPDATE) */
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              /* AGGIUNTA (INSERT e seconda parte dell'UPDATE)
	
	              Verifico che la qta evasa o peso evaso della riga 
	              dalla quale deriva (qui arriva gia' aggiornata
	              della qta e del peso del movimento attuale)
	              non sia maggiore della qta ordinata e del peso ordinato
	              */
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        /*
	        Elisa M.                                21/06/1999
	        Gestione Ordinato Fornitori (come Ordinato Clienti)
	        */
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          /*                       // BL#14237#*/
	          /*          if Substr(@Evento,1,1)='+'*/
	          /*            begin*/
	          /*              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)*/
	          update riepilogo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            /* Elisa M.     21/09/2000      BL7889*/
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            /**/
	            where(riepilogo.id_esercizio=@Id_Esercizio)
	            and(riepilogo.id_attivita=@Id_Attivita)
	            and(riepilogo.id_articolo=@Id_Articolo)
	            and(riepilogo.pk_codice=@pk_codice)
	            and(riepilogo.id_locazione=@Id_Locazione)
	            and(riepilogo.anno=@Anno)
	            and(riepilogo.mese=@Mese)
	            and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              /* BL#14142                */
	              /*              execute sp_ultimo_costo @id_articolo,@LaData,1,@Data_Ult_costo,@Ult_Costo   */
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  /* BL#20265#i */
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  /*select @Ult_Costo=@Prezzo*/
	                  /* BL#2026#f*/
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                /*BL#14142#i*/
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              /*BL#14142#f*/
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,
	                    /* BL#15075#*/
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889*/
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,                    
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889 */
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              message ' -> ',sqlstate
	            end
	        end
	    end
	end;
	
	
	
	//TRIGGER RIGA_DOCUMENTO
	
	
	ALTER TRIGGER "t_evadi_riga_au".t_evadi_riga_au before update order 1
	on "DBA".riga_documento
	referencing old as old_riga_documento new as new_riga_documento
	for each row
	begin
	  /*
	  Elisa Moneti		31/03/1999
	  Gestione di RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti 		06/04/1999
	  Verifico che una riga documento, se con Articolo, deve avere anche o il peso o la
	  quantita'
	
	  Elisa Moneti		18/06/1999
	  Gestione RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti		04/06/2001      BL#13046#
	  Correzione errore SELECT RETURNS MORE THAN ONE ROW
	  Gestione dell'evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_peso_netto_tot decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @peso_netto_evaso decimal(18,4); //BL#13046#
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	
	  declare @ls_old_pk_codice char(20); //Gestione Varianti
	  declare @ls_new_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 varchar;
	  declare @ls_var2 varchar;
	  declare @ls_var3 varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	  if new_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(new_riga_documento.id_art_var1)
	  end if;
	  if new_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(new_riga_documento.id_art_var2)
	  end if;
	  if new_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(new_riga_documento.id_art_var3)
	  end if;
	  SET @ls_new_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	
	  if old_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(old_riga_documento.id_art_var1)
	  end if;
	  if old_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(old_riga_documento.id_art_var2)
	  end if;
	  if old_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(old_riga_documento.id_art_var3)
	  end if;
	  SET @ls_old_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=old_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=old_riga_documento.id_riga_documento;
	  set @ld_qta=old_riga_documento.quantita;
	  set @ld_qtasm=old_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=old_riga_documento.peso_netto;
	  set @ll_id_documento=old_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=old_riga_documento.id_gruppo_agenti;
	  set @ld_prage=old_riga_documento.provv_agente;
	  set @ld_prsub=old_riga_documento.provv_subage;
	  set @ld_prcap=old_riga_documento.provv_carea;
	  set @il_id_azienda=old_riga_documento.id_azienda;
	  set @id_unita_confezione=old_riga_documento.id_unita_confezione;
	  set @prezzo=new_riga_documento.prezzo_netto; 
	  //
	  if @ll_id_riga_ref>0 then
	    /* Storno evasione quantita'' */
	    set @ld_qtatot=(0.0-@ld_qta-@ld_qtasm);
	    /* Storno evasione Peso Netto */
	    set @ld_peso_netto_tot=(0.0-@ld_peso_netto);
	    message ' sp_deriva_riga / t_evadi_riga_au '+string(@ll_id_riga_ref)+' --> '+string(@id_riga_documento);
	    call sp_deriva_riga(@ID_Riga_Documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot)
	  end if
	  ; //
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_documento,@ID_Esercizio,
	    @ID_Attivita from "dba".documento
	    ,"dba".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=old_riga_documento.id_documento));
	  //
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  //
	  /* Detraggo l''old */
	  set @Id_Caus_Magazzino=old_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=old_riga_documento.id_articolo;
	  set @Qta_Un_Base=old_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=old_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=old_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=old_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=old_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=old_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=old_riga_documento.peso_netto_evaso; //BL#13046#
	  //
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ; //
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if;
	
	  set @ll_var1=old_riga_documento.id_art_var1;
	  set @ll_var2=old_riga_documento.id_art_var2;
	  set @ll_var3=old_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_au STORNO  --> '+string(@ID_Riga_Documento)||' Peso:'||string(@ld_peso_netto);
	    call sp_gest_causale_var('-P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_old_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('-S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_old_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ; /* lancio procedura di gestione delle provvigioni */
	  /*
	
	  I Riepiloghi Provvigioni non devono essere aggiornati dalla riga documento
	  ma dalla Contabilizzazione
	
	  execute sp_gest_provvi '-',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	  */
	  /*
	
	  PARTE SECONDA, L''AGGIUNTA (TUTTA LA PARTE INSERTED)
	
	  */
	  /* Codice per la derivazione delle righe, retrieve anche di altri dati */
	  set @ll_id_riga_ref=new_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=new_riga_documento.id_riga_documento;
	  set @ld_qta=new_riga_documento.quantita;
	  set @ld_qtasm=new_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=new_riga_documento.peso_netto;
	  set @ll_id_documento=new_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=new_riga_documento.id_gruppo_agenti;
	  set @ld_prage=new_riga_documento.provv_agente;
	  set @ld_prsub=new_riga_documento.provv_subage;
	  set @ld_prcap=new_riga_documento.provv_carea;
	  set @il_id_azienda=new_riga_documento.id_azienda;
	  set @id_unita_confezione=new_riga_documento.id_unita_confezione;
	  if @ll_id_riga_ref>0 then
	    /* Evasione quantita'' */
	    set @ld_qtatot=@ld_qta+@ld_qtasm;
	    set @ld_peso_netto_tot=@ld_peso_netto;
	    call sp_deriva_riga(@id_riga_documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot)
	  end if
	  ;
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "DBA".documento
	    ,"DBA".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=new_riga_documento.id_documento));
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  //
	  /* Aggiungo il new */
	  set @Id_Caus_Magazzino=new_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=new_riga_documento.id_articolo;
	  set @Qta_Un_Base=new_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=new_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=new_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=new_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=new_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=new_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=new_riga_documento.peso_netto_evaso;
	  /*
	  if not(@id_articolo is null) and(@ld_qta is null or @ld_qta=0) and(@ld_peso_netto is null or @ld_peso_netto=0) then
	  raiserror 99999 'Per movimentare un Articolo specificare la quantita'' o il Peso'
	  end if
	  ;
	  */
	  //
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if;
	
	  set @ll_var1=new_riga_documento.id_art_var1;
	  set @ll_var2=new_riga_documento.id_art_var2;
	  set @ll_var3=new_riga_documento.id_art_var3;
	
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_au AGGIUNTA  --> '+string(@ID_Riga_Documento)||' Peso:'||string(@ld_peso_netto);
	    call sp_gest_causale_var('+P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_new_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('+S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_new_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	/* lancio procedura di gestione delle provvigioni */
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perch l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '+'',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	*/
	/**/
	end;
	
	
	ALTER TRIGGER "t_evadi_riga_ai".t_evadi_riga_ai after insert order 2
	on "DBA".riga_documento
	referencing new as new_riga_documento
	for each row
	begin
	  /*	Elisa Moneti		31/03/1999
	  Gestione di RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti 		01/04/1999
	  Verifico che una riga documento, se con Articolo, deve avere anche o il peso o la
	  quantita'
	
	  Elisa Moneti		21/06/1999
	  Gestione di RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti      13/03/2001
	  In derivazione, se  prevista la gestione del costo di trasporto, deve
	  essere derivato anche questo.
	
	  Elisa M.          25/05/2001
	  BL#12495# - 
	
	  Elisa Moneti		04/06/2001        BL#13046#
	  Gestione dell'evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	  declare @lc_ges_costo_trasporto char(1); 
	  declare @peso_netto_evaso decimal(18,4); 
	  declare @ls_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 varchar;
	  declare @ls_var2 varchar;
	  declare @ls_var3 varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	
	  if new_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(new_riga_documento.id_art_var1)
	  end if;
	  if new_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(new_riga_documento.id_art_var2)
	  end if;
	  if new_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(new_riga_documento.id_art_var3)
	  end if;
	  SET @ls_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=new_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=new_riga_documento.id_riga_documento;
	  set @ld_qta=new_riga_documento.quantita;
	  set @ld_qtasm=new_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=new_riga_documento.peso_netto;
	  set @ll_id_documento=new_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=new_riga_documento.id_gruppo_agenti;
	  set @ld_prage=new_riga_documento.provv_agente;
	  set @ld_prsub=new_riga_documento.provv_subage;
	  set @ld_prcap=new_riga_documento.provv_carea;
	  set @il_id_azienda=new_riga_documento.id_azienda;
	  set @id_unita_confezione=new_riga_documento.id_unita_confezione;
	  set @prezzo=new_riga_documento.prezzo_netto; // BL#18780#
	  //
	  if @ll_id_riga_ref>0 then
	    /* Evasione quantita'' */
	    set @ld_qtatot=@ld_qta+@ld_qtasm;
	    message ' sp_deriva_riga / t_evadi_riga_ai '+string(@ll_id_riga_ref)+' --> '+string(@id_riga_documento);
	    call sp_deriva_riga(@id_riga_documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto);
	    /*
	    Elisa M.        13/03/01        BL#11174#i
	    Riporto il costo di trasporto se previsto nella riga derivata.
	    */
	    select ges_costo_trasporto into @lc_ges_costo_trasporto
	      from pers_par_sistema;
	    if(@lc_ges_costo_trasporto='S') then
	      message 'Riga:'+string(@id_riga_documento);
	      message 'Riga prov.:'+string(@ll_id_riga_ref);
	      insert into costo_tras_riga_doc(id_riga_documento,costo_trasporto)
	        select @id_riga_documento,costo_trasporto
	          from costo_tras_riga_doc
	          where id_riga_documento=@ll_id_riga_ref
	    end if
	  end if
	  ; /*BL#11174#f*/
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "DBA".documento
	    ,"DBA".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=new_riga_documento.id_documento));
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  /* Aggiungo il new */
	  set @Id_Caus_Magazzino=new_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=new_riga_documento.id_articolo;
	  set @Qta_Un_Base=new_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=new_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=new_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=new_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=new_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=new_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=new_riga_documento.peso_netto_evaso; //BL#13046#
	  /*
	  Elisa Moneti
	  */
	  /*  if not(@id_articolo is null) and(@ld_qta is null or @ld_qta=0) and(@ld_peso_netto is null or @ld_peso_netto=0)*/
	  /*    raiserror 99999 'Per movimentare un Articolo specificare la quantita'' o il Peso'*/
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if; 
	  set @ll_var1=new_riga_documento.id_art_var1;
	  set @ll_var2=new_riga_documento.id_art_var2;
	  set @ll_var3=new_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_ai --> '+string(@ID_Riga_Documento);
	    call sp_gest_causale_var('+P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('+S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	/* lancio procedura di gestione delle provvigioni */
	/*
	print 'Calcolo provvigioni:'
	print '  ID Documento         : '||@ll_id_documento
	print '  ID Gruppo Agenti     : '||@ll_id_gruppo_agenti
	print '  Totale riga          : '||@tot_riga_val_az
	print '  Percentuale AGENTE   : '||@ld_prage
	print '  Percentuale SUBAGE   : '||@ld_prsub
	print '  Percentuale CPAREA   : '||@ld_prcap
	print '  ID Azienda           : '||@il_id_azienda
	*/
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perche' l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '+',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	*/
	/**/
	end;
	
	
	ALTER TRIGGER "t_evadi_riga_ad".t_evadi_riga_ad before delete order 1
	on "DBA".riga_documento
	referencing old as old_riga_documento
	for each row
	begin
	  /* Elisa Moneti		31/03/1999
	  Gestione RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti		21/06/1999
	  Gestione RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti      30/04/2001      BL#12430#
	
	  Elisa Moneti		04/06/2001        BL#13046#
	  Gestione dell''evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_peso_netto_tot decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	  declare @peso_netto_evaso decimal(18,4); 
	  declare @ls_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 varchar;
	  declare @ls_var2 varchar;
	  declare @ls_var3 varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	  if old_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(old_riga_documento.id_art_var1);
	  end if;
	  if old_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(old_riga_documento.id_art_var2)
	  end if;
	  if old_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(old_riga_documento.id_art_var3)
	  end if;
	  SET @ls_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=old_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=old_riga_documento.id_riga_documento;
	  set @ld_qta=old_riga_documento.quantita;
	  set @ld_peso_netto=old_riga_documento.peso_netto;
	  set @ld_qtasm=old_riga_documento.qta_sconto_merce;
	  set @ll_id_documento=old_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=old_riga_documento.id_gruppo_agenti;
	  set @ld_prage=old_riga_documento.provv_agente;
	  set @ld_prsub=old_riga_documento.provv_subage;
	  set @ld_prcap=old_riga_documento.provv_carea;
	  set @il_id_azienda=old_riga_documento.id_azienda;
	  set @id_unita_confezione=old_riga_documento.id_unita_confezione;
	  set @prezzo=old_riga_documento.prezzo_netto; // BL#18780#
	  //
	  if @ll_id_riga_ref>0 then
	    /* Storno evasione quantita'' */
	    set @ld_qtatot=(0.0-@ld_qta-@ld_qtasm);
	    /* Storno evasione Peso Netto */
	    set @ld_peso_netto_tot=(0.0-@ld_peso_netto);
	    call sp_deriva_riga(@ID_Riga_Documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot);
	    // BL#15754#
	    update riga_documento as r,documento as d set
	      r.forza_chius_evasione='N',d.evaso_totalmente='N'
	      where r.id_riga_documento=@ll_id_riga_ref
	      and d.id_documento=r.id_documento
	  end if
	  ; //
	  //
	  //
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "dba".documento
	    ,"dba".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=old_riga_documento.id_documento));
	  //
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  /* Detraggo l''old */
	  set @Id_Caus_Magazzino=old_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=old_riga_documento.id_articolo;
	  set @Qta_Un_Base=old_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=old_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=old_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=old_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=old_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=old_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=old_riga_documento.peso_netto_evaso; //BL#13046#
	  //
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if
	  ;
	  /* lancio procedura di gestione dei riepiloghi di magazzino */
	  set @ll_var1=old_riga_documento.id_art_var1;
	  set @ll_var2=old_riga_documento.id_art_var2;
	  set @ll_var3=old_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_ad --> '+string(@ID_Riga_Documento);
	    //message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	    //message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	    call sp_gest_causale_var('-P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('-S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	//
	/* lancio procedura di gestione delle provvigioni */
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perch+ l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '-'',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	
	*/
	/**/
	end;


// FINE TAGLIE COLORI


//ALTERINI GESTIONE 3 U.C. nella riga documento e GESTIONE STATO DOCUMENTI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento'
        AND      CNAME = 'id_alt_uc1' )) THEN 
        alter table riga_documento add "id_alt_uc1" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento'
        AND      CNAME = 'id_alt_uc2' )) THEN 
        alter table riga_documento add "id_alt_uc2" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento'
        AND      CNAME = 'id_alt_uc3' )) THEN 
        alter table riga_documento add "id_alt_uc3" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'alt_pag')) THEN 
        alter table documento add "alt_pag" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'alt_ord' )) THEN 
        alter table documento add "alt_ord" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'id_cat_zona' )) THEN 
        alter table documento add "id_cat_zona" integer DEFAULT NULL;          
end if;

////////////////////////////////////////

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'variante_appoggio' )) THEN 
        alter table par_sistema add "variante_appoggio" integer DEFAULT NULL;          
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'menu_agenti' )) THEN 
        alter table par_sistema add "menu_agenti" char(1) DEFAULT NULL;          
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'tras_ag_mail_admin' )) THEN 
        alter table par_sistema add "tras_ag_mail_admin" char(60) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'trasf_ag_folder_imp' )) THEN 
        alter table par_sistema add "trasf_ag_folder_imp" char(60) DEFAULT NULL;          
end if;


if(not(exists(select 1 from sys.systable where table_name='tmp_ag_riga_doc'))) then
	CREATE TABLE "dba"."tmp_ag_riga_doc" ("id_riga_documento" integer NOT NULL DEFAULT autoincrement, "id_documento" integer NOT NULL DEFAULT NULL, "id_unita_confezione" integer DEFAULT NULL, "id_gruppo_agenti" integer DEFAULT NULL, "num_riga" numeric(6,0) NOT NULL DEFAULT NULL, "id_articolo" integer DEFAULT NULL, "descrizione" long varchar DEFAULT NULL, "id_des_articolo" integer DEFAULT NULL, "quantita" numeric(18,4) DEFAULT 0, "qta_sconto_merce" numeric(18,4) DEFAULT 0, "qta_evasa" numeric(18,4) DEFAULT 0, "fat_con_unita_base" numeric(8,4) DEFAULT NULL, "fat_con_globale" numeric(8,4) DEFAULT NULL, "qta_un_base" numeric(18,4) DEFAULT 0, "qta_evasa_un_base" numeric(18,4) DEFAULT 0, "id_caus_magazzino" integer DEFAULT NULL, "id_locazione_1" integer DEFAULT NULL, "id_locazione_2" integer DEFAULT NULL, "id_valuta" integer NOT NULL DEFAULT NULL, "cambio" numeric(8,4) DEFAULT NULL, "id_listino" integer DEFAULT NULL, "id_con_lis_articolo" integer DEFAULT NULL, "prezzo" numeric(20,6) DEFAULT NULL, 
	"sconto" char(40) DEFAULT NULL, "prezzo_netto" numeric(20,6) DEFAULT NULL, "sconto_riga" numeric(18,4) DEFAULT NULL, "data_prevista_consegna" date DEFAULT NULL, "peso_netto" numeric(18,4) DEFAULT 0, "peso_lordo" numeric(18,4) DEFAULT 0, "dim_l" numeric(18,4) DEFAULT 0, "dim_h" numeric(18,4) DEFAULT 0, "dim_p" numeric(18,4) DEFAULT 0, "num_colli" numeric(8,0) DEFAULT NULL, "id_tab_iva" integer DEFAULT NULL, "val_attribuito" numeric(18,4) DEFAULT NULL, "provv_agente" numeric(5,2) DEFAULT NULL, "provv_subage" numeric(5,2) DEFAULT NULL, "provv_carea" numeric(5,2) DEFAULT NULL, "id_caus_trasporto" integer DEFAULT NULL, "forza_chius_evasione" char(1) DEFAULT NULL, "sospesa" char(1) DEFAULT NULL, "da_stampare" char(1) DEFAULT NULL, "data_inizio_competenza" date DEFAULT NULL, "data_fine_competenza" date DEFAULT NULL, "tot_riga_val_riga" numeric(20,6) DEFAULT NULL, "tot_riga_val_doc" numeric(20,6) DEFAULT NULL, "tot_riga_val_az" numeric(20,6) DEFAULT NULL, "id_riga_doc_provenienza" integer DEFAULT NULL, 
	"id_conto" integer DEFAULT NULL, "id_azienda" integer NOT NULL DEFAULT 1, "id_riga_doc_padre" integer DEFAULT NULL, "provv_imp_agente" numeric(18,4) DEFAULT NULL, "provv_imp_subage" numeric(18,4) DEFAULT NULL, "provv_imp_carea" numeric(18,4) DEFAULT NULL, "id_riga_lotto" integer DEFAULT NULL, "qta_ordinata_fo" numeric(18,4) DEFAULT NULL, "ordinato_fo" char(1) DEFAULT NULL, "peso_netto_evaso" numeric(18,4) DEFAULT NULL, "id_gruppo_agenti_2" integer DEFAULT NULL, "provv_agente_2" numeric(5,2) DEFAULT NULL, "provv_subage_2" numeric(5,2) DEFAULT NULL, "provv_carea_2" numeric(5,2) DEFAULT NULL, "provv_imp_agente_2" numeric(18,4) DEFAULT NULL, "provv_imp_subage_2" numeric(18,4) DEFAULT NULL, "provv_imp_carea_2" numeric(18,4) DEFAULT NULL, "id_art_var1" integer DEFAULT NULL, "id_art_var2" integer DEFAULT NULL, "id_art_var3" integer DEFAULT NULL, "id_distinta" integer DEFAULT NULL, "id_operatore" integer DEFAULT NULL , 
	"id_alt_uc1" integer DEFAULT NULL, "id_alt_uc2" integer DEFAULT NULL, "id_alt_uc3" integer DEFAULT NULL, PRIMARY KEY ("id_riga_documento")) ;
	CREATE UNIQUE INDEX "ix_riga_documento_1" ON "dba"."tmp_ag_riga_doc" ("id_documento" , "num_riga" );
	CREATE TABLE "dba"."tmp_ag_doc" ("id_documento" integer NOT NULL DEFAULT autoincrement, "id_prof_documento" integer NOT NULL DEFAULT NULL, "id_registro" integer NOT NULL DEFAULT NULL, "num_progressivo" numeric(12,0) NOT NULL DEFAULT NULL, "data_registrazione" date NOT NULL DEFAULT NULL, "num_documento" char(16) DEFAULT NULL, "data_documento" date DEFAULT NULL, "data_competenza" date DEFAULT NULL, "id_prof_registrazione" integer DEFAULT NULL, "des_contabile" char(40) DEFAULT NULL, "id_sog_commerciale" integer NOT NULL DEFAULT NULL, "id_destinazione" integer DEFAULT NULL, "id_caus_magazzino" integer DEFAULT NULL, "id_magazzino" integer DEFAULT NULL, "id_magazzino_2" integer DEFAULT NULL, "id_sog_commerciale_fattura" integer DEFAULT NULL, "id_lingua" integer DEFAULT NULL, "id_linguaggio" integer DEFAULT NULL, "id_valuta" integer NOT NULL DEFAULT NULL, "cambio" numeric(8,4) DEFAULT NULL, "id_listino" integer DEFAULT NULL, "id_con_pagamento" integer DEFAULT NULL, "id_gruppo_agenti" integer DEFAULT NULL, 
	"id_banca_sog_commerciale" integer DEFAULT NULL, "origine" char(40) DEFAULT NULL, "interlocutore" char(40) DEFAULT NULL, "data_prev_consegna" date DEFAULT NULL, "note_intestazione" long varchar DEFAULT NULL, "num_colli" numeric(8,0) DEFAULT NULL, "id_unita_misura_peso" integer DEFAULT NULL, "peso_netto" numeric(18,4) DEFAULT 0, "peso_lordo" numeric(18,4) DEFAULT 0, "id_unita_misura_volume" integer DEFAULT NULL, "volume" numeric(18,4) DEFAULT 0, "id_tipo_trasporto" integer DEFAULT NULL, "id_caus_trasporto" integer DEFAULT NULL, "asp_beni" char(40) DEFAULT NULL, "tras_mezzo" char(1) DEFAULT NULL, "id_sog_commerciale_vettore" integer DEFAULT NULL, "id_sog_commerciale_vettore_2" integer DEFAULT NULL, "mezzo_trasporto" char(40) DEFAULT NULL, "targa_mezzo_trasporto" char(40) DEFAULT NULL, "data_trasporto" date DEFAULT NULL, "ora_trasporto" time DEFAULT NULL, "sconto_finanziario" char(40) DEFAULT NULL, "sconto_fin_incondizionato" numeric(18,4) DEFAULT NULL, "sconto_fin_cassa" numeric(5,2) DEFAULT NULL, 
	"data_dec_pagamento" date DEFAULT NULL, "imp_acconto" numeric(18,4) DEFAULT NULL, "id_tipo_pagamento" integer DEFAULT NULL, "stampato" char(1) DEFAULT NULL, "contabilizzato" char(1) DEFAULT NULL, "evaso_totalmente" char(1) DEFAULT NULL, "chius_forzata" char(1) DEFAULT NULL, "sospeso" char(1) DEFAULT NULL, "data_scadenza" date DEFAULT NULL, "creato_in_esenzione" char(1) DEFAULT NULL, "bloccato" char(1) DEFAULT NULL, "prog_globale" numeric(16,0) DEFAULT NULL, "doc_globale" numeric(16,0) DEFAULT NULL, "tipo_fattura" char(1) DEFAULT NULL, "segno_iva" numeric(2,0) DEFAULT 1, "id_documento_padre" integer DEFAULT NULL, "id_azienda" integer NOT NULL DEFAULT 1, "id_tipo_pag_acconto" integer DEFAULT NULL, "id_tab_iva_acconto" integer DEFAULT NULL, "id_val_acconto" integer DEFAULT NULL, "ora_registrazione" time DEFAULT NULL, "id_locazione_1" integer DEFAULT NULL, "id_locazione_2" integer DEFAULT NULL, "storno_anticipi" char(1) DEFAULT NULL, "id_variazione" integer DEFAULT NULL, "bollo" char(20) DEFAULT NULL, 
	"id_gruppo_agenti_2" integer DEFAULT NULL, "data_ric_consegna" date DEFAULT NULL, "num_riga" integer DEFAULT NULL, "id_utente" integer DEFAULT NULL, "alt_pag" char(1) DEFAULT NULL, "id_cat_zona" integer DEFAULT NULL , PRIMARY KEY ("id_documento"));
	CREATE UNIQUE INDEX "ix_documento_1" ON "dba"."tmp_ag_doc" ("id_registro" , "num_progressivo" , "data_registrazione" ) ;          
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'alt_id_prof_cl' )) THEN 
        alter table pers_par_sistema add "alt_id_prof_cl" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'alt_id_prof_pr' )) THEN 
        alter table pers_par_sistema add "alt_id_prof_pr" integer DEFAULT NULL;          
end if;
///////////////////////////////////////////////


/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_006' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_006','Release 2_01_006  Cometa','S')
        ;

END IF
;
