//INIZIO 2_01_007


/* Results of automatic index tuning for analysis Cometa2 */

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'registro' and iname = 'ixc_consult_1')) THEN
	CREATE  INDEX "ixc_consult_1" ON "DBA"."registro" ( tipo_registro ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'riga_documento' and iname = 'ixc_consult_2')) THEN
	CREATE  INDEX "ixc_consult_2" ON "DBA"."riga_documento" ( id_documento ,id_articolo ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'riepilogo' and iname = 'ixc_consult_3')) THEN
	CREATE  INDEX "ixc_consult_3" ON "DBA"."riepilogo" ( id_articolo ,id_locazione ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'documento' and iname = 'ixc_consult_4')) THEN
	CREATE  INDEX "ixc_consult_4" ON "DBA"."documento" ( id_registro ,id_prof_documento ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'unita_confezione' and iname = 'ixc_consult_5')) THEN
	CREATE  INDEX "ixc_consult_5" ON "DBA"."unita_confezione" ( id_unita_misura ,unita_base ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'riepilogo' and iname = 'ixc_consult_6')) THEN
	CREATE  INDEX "ixc_consult_6" ON "DBA"."riepilogo" ( anno ,id_articolo ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'magazzino' and iname = 'ixc_consult_7')) THEN
	CREATE  INDEX "ixc_consult_7" ON "DBA"."magazzino" ( codice ,id_azienda ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'prezzo' and iname = 'ixc_consult_8')) THEN
	CREATE  INDEX "ixc_consult_8" ON "DBA"."prezzo" ( id_variazione ,id_unita_confezione ) in dvindex;
	;
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM sys.sysindexes
        where tname = 'voci_menu' and iname = 'ixc_consult_9')) THEN
	CREATE  INDEX "ixc_consult_9" ON "DBA"."voci_menu" ( header_menu ,id_menu ) in dvindex;
	;
END IF;

//////////////////////////////////////////

//x Alterini (Gestione nota descrittiva in testa documento come destinazione 2)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'id_registro' )) THEN 
        alter table annotazione add "id_registro" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'num_progressivo' )) THEN 
        alter table annotazione add "num_progressivo" numeric(12,0) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'data_registrazione' )) THEN 
        alter table annotazione add "data_registrazione" date DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'tipodest' )) THEN 
        alter table annotazione add "tipodest" char(1) DEFAULT NULL;          
end if;

//Gestione listino Acquisto prezzo futuro
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'alt_id_variaz_fut' )) THEN 
        alter table pers_par_sistema add "alt_id_variaz_fut" integer DEFAULT NULL;          
end if;
////////////////////////////////////////

//Gestione acconti olmo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'gest_acconti' )) THEN 
        alter table par_sistema add "gest_acconti" char(1) DEFAULT 'N';          

	CREATE TABLE "dba"."acconti" 
	("id_acconti" integer NOT NULL DEFAULT autoincrement, 
	 "id_documento" integer NOT NULL DEFAULT NULL, 
	 "id_doc_provenienza" integer NOT NULL DEFAULT NULL, 
	 "importo_usato" numeric(18,4) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_acconti") , 
	FOREIGN KEY "fk_acconti" ("id_documento" ) REFERENCES "dba"."documento" ON DELETE CASCADE ) ;
end if;


//Termoidraulica Commesse
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_qualifica'
        AND      CNAME = 'costo_fisso' )) THEN 
        alter table com_qualifica add "costo_fisso" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_qualifica'
        AND      CNAME = 'trasferta' )) THEN 
        alter table com_qualifica add "trasferta" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_anag_costi'
        AND      CNAME = 'trasferta' )) THEN 
        alter table com_anag_costi add "trasferta" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'trasferta' )) THEN 
        alter table commessa add "trasferta" char(1) DEFAULT NULL;          
end if;
/////////////////////////////////////////


//Controllo prezzi
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'prezzo_su_riga' )) THEN 
        alter table prof_documento add "prezzo_su_riga" char(1) DEFAULT NULL;          
end if;

//////PARIGI Lettori WinCE Skorpio
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'barcabil')) THEN

	CREATE TABLE "dba"."barcabil" (
	"barcode" char(24) DEFAULT NULL, 
	"descrizione" char(40) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'ordpartx')) THEN

	CREATE TABLE "dba"."ordpartx" (
	"numero" char(6) DEFAULT NULL, 
	"data_ord" char(6) DEFAULT NULL, 
	"rag_soc" char(30) DEFAULT NULL, 
	"barcode" char(24) DEFAULT NULL, 
	"qta" char(6) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'conftx')) THEN

	CREATE TABLE "dba"."conftx" (
	"barcode1" char(24) DEFAULT NULL, 
	"barcode2" char(24) DEFAULT NULL, 
	"qta" char(6) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'ordparrx')) THEN

	CREATE TABLE "dba"."ordparrx" (
	"numero" char(6) DEFAULT NULL, 
	"data_ord" char(6) DEFAULT NULL, 
	"barcode" char(24) DEFAULT NULL, 
	"qta" char(6) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'ordpartx_rag')) THEN

	CREATE TABLE "dba"."ordpartx_rag" (
	"numero" char(6) DEFAULT NULL, 
	"data_ord" char(6) DEFAULT NULL, 
	"rag_soc" char(30) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'confrx')) THEN

	CREATE TABLE "dba"."confrx" (
	"barcode" char(24) DEFAULT NULL, 
	"qta" char(6) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'barcodes')) THEN

	CREATE TABLE "dba"."barcodes" (
	"locazione" char(6) DEFAULT NULL, 
	"barcode" char(24) DEFAULT NULL, 
	"qta" char(6) DEFAULT NULL, 
	"id_utente" integer DEFAULT NULL) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'ordpartx'
        AND      CNAME = 'descrizione' )) THEN 
        alter table ordpartx add "descrizione" char(30) DEFAULT NULL;          
end if;
////////////////////////////

//////////PARIGI Agg. Costo rif. in Derivazione
ALTER TRIGGER "t_agg_costo_rif_au".t_agg_costo_rif_au after update order 1
on "DBA".riga_documento
referencing old as old_riga_documento new as new_riga_documento
for each row
begin
  /*
  Elisa M.		23/03/2001		BL#11762#

  Aggiornamento automatico del costo di riferimento dell''articolo = costo di acquisto
  */
  declare li_id_lis_riferimento integer;
  declare lc_mp_ult_costo char(1);
  declare ls_tipo_mov char(1); // BL#19021#
  // Listino di Riferimento
  select id_lis_riferimento into li_id_lis_riferimento
    from parigi_par_sistema;
  //Se Aggiornamento del Listino di Riferimento e'' abilitata e la riga documento ha la causale
  if(li_id_lis_riferimento>0) and(new_riga_documento.id_caus_magazzino>0) then
    select mp_ult_costo into lc_mp_ult_costo
      from caus_magazzino
      where id_caus_magazzino=new_riga_documento.id_caus_magazzino;
    // BL#19021#i - calcolo del costo di riferimento in base al tipo di movimentazione
    select m.tipo into ls_tipo_mov
      from unita_misura as m,unita_confezione as u
      where u.id_unita_confezione=new_riga_documento.id_unita_confezione
      and m.id_unita_misura=u.id_unita_misura;
    if ls_tipo_mov='P' then
      // Se la causale aggiorna l''ultimo costo
      if(lc_mp_ult_costo='S' and new_riga_documento.prezzo_netto>0) then
        // aggiorno il costo di riferimento dell''U.C. impostandolo uguale al costo di acquisto.
        if old_riga_documento.prezzo_netto <> new_riga_documento.prezzo_netto then
        update prezzo,variazione as v,documento as d set
          prezzo=new_riga_documento.prezzo_netto
          where d.id_documento=new_riga_documento.id_documento
          and v.id_listino=li_id_lis_riferimento
          and v.data_inizio<=d.data_registrazione
          and(v.data_fine>=d.data_registrazione or v.data_fine is null)
          and prezzo.id_unita_confezione=new_riga_documento.id_unita_confezione
          and prezzo.id_variazione=v.id_variazione
        end if
      end if
    else
      // BL#19021#f
      // Se la causale aggiorna l''ultimo costo
      if(lc_mp_ult_costo='S' and new_riga_documento.prezzo_netto>0 and new_riga_documento.quantita>0) then
        // aggiorno il costo di riferimento dell''U.C. impostandolo uguale al costo di acquisto.
        if old_riga_documento.prezzo_netto <> new_riga_documento.prezzo_netto then
        update prezzo,variazione as v,documento as d set
          prezzo=new_riga_documento.tot_riga_val_riga/(new_riga_documento.quantita+ifnull(new_riga_documento.qta_sconto_merce,0,new_riga_documento.qta_sconto_merce))
          where d.id_documento=new_riga_documento.id_documento
          and v.id_listino=li_id_lis_riferimento
          and v.data_inizio<=d.data_registrazione
          and(v.data_fine>=d.data_registrazione or v.data_fine is null)
          and prezzo.id_unita_confezione=new_riga_documento.id_unita_confezione
          and prezzo.id_variazione=v.id_variazione
        end if
      end if
    end if
  end if
end;
///////////////////////////////////////////////

//////////Parigi tabella temporanea appoggio per evasione documenti da lettore a barre (esplosione distinte doppie)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_rigdoc_id')) THEN

	CREATE TABLE "dba"."tmp_rigdoc_id" (
	"id_riga_documento" integer DEFAULT NULL) ;
end if;
////////////

/////////////ALTERINI campo campo "Molteplicita" da 18,4 a 20,6
ALTER TABLE unita_confezione
modify molteplicita numeric(20,6) DEFAULT 0;
///////////////////////////////////////////////////////////////


call fn_ins_voce_menu('Documenti', 'w_gen_ordfor_articolo_cx', 'Generazione Ordini Acquisto', 185);

call fn_ins_voce_menu('Stampe Contabili', 'w_controllo_numerazione_cx', 'Controllo progressione scritture', 65);





//CORREZIONE URGENTE TAGLIE E COLORI CREAZIONE PK_CODICE

	ALTER TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	END;
	
	
	
	ALTER TRIGGER "t_artvar_prezzo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	END;



	ALTER TRIGGER "t_var_con_lis_articolo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."var_con_lis_articolo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
	ALTER TRIGGER "t_var_con_lis_articolo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."var_con_lis_articolo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;


	IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_riepilogo_bu')) THEN

	CREATE TRIGGER "t_riepilogo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."riepilogo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;


	END IF;
	
	
	IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_riepilogo_bI')) THEN

	CREATE TRIGGER "t_riepilogo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."riepilogo"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;

	END IF;
	
	
	//TRIGGER RIGA_DOCUMENTO
	
	
	ALTER TRIGGER "t_evadi_riga_au".t_evadi_riga_au before update order 1
	on "DBA".riga_documento
	referencing old as old_riga_documento new as new_riga_documento
	for each row
	begin
	  /*
	  Elisa Moneti		31/03/1999
	  Gestione di RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti 		06/04/1999
	  Verifico che una riga documento, se con Articolo, deve avere anche o il peso o la
	  quantita'
	
	  Elisa Moneti		18/06/1999
	  Gestione RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti		04/06/2001      BL#13046#
	  Correzione errore SELECT RETURNS MORE THAN ONE ROW
	  Gestione dell'evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_peso_netto_tot decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @peso_netto_evaso decimal(18,4); //BL#13046#
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	
	  declare @ls_old_pk_codice char(20); //Gestione Varianti
	  declare @ls_new_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 long varchar;
	  declare @ls_var2 long varchar;
	  declare @ls_var3 long varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	  if new_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(new_riga_documento.id_art_var1)
	  end if;
	  if new_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(new_riga_documento.id_art_var2)
	  end if;
	  if new_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(new_riga_documento.id_art_var3)
	  end if;
	  SET @ls_new_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	
	  if old_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(old_riga_documento.id_art_var1)
	  end if;
	  if old_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(old_riga_documento.id_art_var2)
	  end if;
	  if old_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(old_riga_documento.id_art_var3)
	  end if;
	  SET @ls_old_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=old_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=old_riga_documento.id_riga_documento;
	  set @ld_qta=old_riga_documento.quantita;
	  set @ld_qtasm=old_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=old_riga_documento.peso_netto;
	  set @ll_id_documento=old_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=old_riga_documento.id_gruppo_agenti;
	  set @ld_prage=old_riga_documento.provv_agente;
	  set @ld_prsub=old_riga_documento.provv_subage;
	  set @ld_prcap=old_riga_documento.provv_carea;
	  set @il_id_azienda=old_riga_documento.id_azienda;
	  set @id_unita_confezione=old_riga_documento.id_unita_confezione;
	  set @prezzo=new_riga_documento.prezzo_netto; 
	  //
	  if @ll_id_riga_ref>0 then
	    /* Storno evasione quantita'' */
	    set @ld_qtatot=(0.0-@ld_qta-@ld_qtasm);
	    /* Storno evasione Peso Netto */
	    set @ld_peso_netto_tot=(0.0-@ld_peso_netto);
	    message ' sp_deriva_riga / t_evadi_riga_au '+string(@ll_id_riga_ref)+' --> '+string(@id_riga_documento);
	    call sp_deriva_riga(@ID_Riga_Documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot)
	  end if
	  ; //
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_documento,@ID_Esercizio,
	    @ID_Attivita from "dba".documento
	    ,"dba".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=old_riga_documento.id_documento));
	  //
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  //
	  /* Detraggo l''old */
	  set @Id_Caus_Magazzino=old_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=old_riga_documento.id_articolo;
	  set @Qta_Un_Base=old_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=old_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=old_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=old_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=old_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=old_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=old_riga_documento.peso_netto_evaso; //BL#13046#
	  //
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ; //
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if;
	
	  set @ll_var1=old_riga_documento.id_art_var1;
	  set @ll_var2=old_riga_documento.id_art_var2;
	  set @ll_var3=old_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_au STORNO  --> '+string(@ID_Riga_Documento)||' Peso:'||string(@ld_peso_netto);
	    call sp_gest_causale_var('-P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_old_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('-S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_old_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ; /* lancio procedura di gestione delle provvigioni */
	  /*
	
	  I Riepiloghi Provvigioni non devono essere aggiornati dalla riga documento
	  ma dalla Contabilizzazione
	
	  execute sp_gest_provvi '-',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	  */
	  /*
	
	  PARTE SECONDA, L''AGGIUNTA (TUTTA LA PARTE INSERTED)
	
	  */
	  /* Codice per la derivazione delle righe, retrieve anche di altri dati */
	  set @ll_id_riga_ref=new_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=new_riga_documento.id_riga_documento;
	  set @ld_qta=new_riga_documento.quantita;
	  set @ld_qtasm=new_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=new_riga_documento.peso_netto;
	  set @ll_id_documento=new_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=new_riga_documento.id_gruppo_agenti;
	  set @ld_prage=new_riga_documento.provv_agente;
	  set @ld_prsub=new_riga_documento.provv_subage;
	  set @ld_prcap=new_riga_documento.provv_carea;
	  set @il_id_azienda=new_riga_documento.id_azienda;
	  set @id_unita_confezione=new_riga_documento.id_unita_confezione;
	  if @ll_id_riga_ref>0 then
	    /* Evasione quantita'' */
	    set @ld_qtatot=@ld_qta+@ld_qtasm;
	    set @ld_peso_netto_tot=@ld_peso_netto;
	    call sp_deriva_riga(@id_riga_documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot)
	  end if
	  ;
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "DBA".documento
	    ,"DBA".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=new_riga_documento.id_documento));
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  //
	  /* Aggiungo il new */
	  set @Id_Caus_Magazzino=new_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=new_riga_documento.id_articolo;
	  set @Qta_Un_Base=new_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=new_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=new_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=new_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=new_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=new_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=new_riga_documento.peso_netto_evaso;
	  /*
	  if not(@id_articolo is null) and(@ld_qta is null or @ld_qta=0) and(@ld_peso_netto is null or @ld_peso_netto=0) then
	  raiserror 99999 'Per movimentare un Articolo specificare la quantita'' o il Peso'
	  end if
	  ;
	  */
	  //
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	  //  message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if;
	
	  set @ll_var1=new_riga_documento.id_art_var1;
	  set @ll_var2=new_riga_documento.id_art_var2;
	  set @ll_var3=new_riga_documento.id_art_var3;
	
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_au AGGIUNTA  --> '+string(@ID_Riga_Documento)||' Peso:'||string(@ld_peso_netto);
	    call sp_gest_causale_var('+P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_new_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('+S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_new_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	/* lancio procedura di gestione delle provvigioni */
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perch l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '+'',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	*/
	/**/
	end;
	
	
	ALTER TRIGGER "t_evadi_riga_ai".t_evadi_riga_ai after insert order 2
	on "DBA".riga_documento
	referencing new as new_riga_documento
	for each row
	begin
	  /*	Elisa Moneti		31/03/1999
	  Gestione di RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti 		01/04/1999
	  Verifico che una riga documento, se con Articolo, deve avere anche o il peso o la
	  quantita'
	
	  Elisa Moneti		21/06/1999
	  Gestione di RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti      13/03/2001
	  In derivazione, se  prevista la gestione del costo di trasporto, deve
	  essere derivato anche questo.
	
	  Elisa M.          25/05/2001
	  BL#12495# - 
	
	  Elisa Moneti		04/06/2001        BL#13046#
	  Gestione dell'evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	  declare @lc_ges_costo_trasporto char(1); 
	  declare @peso_netto_evaso decimal(18,4); 
	  declare @ls_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 long varchar;
	  declare @ls_var2 long varchar;
	  declare @ls_var3 long varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	
	  if new_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(new_riga_documento.id_art_var1)
	  end if;
	  if new_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(new_riga_documento.id_art_var2)
	  end if;
	  if new_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(new_riga_documento.id_art_var3)
	  end if;
	  SET @ls_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=new_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=new_riga_documento.id_riga_documento;
	  set @ld_qta=new_riga_documento.quantita;
	  set @ld_qtasm=new_riga_documento.qta_sconto_merce;
	  set @ld_peso_netto=new_riga_documento.peso_netto;
	  set @ll_id_documento=new_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=new_riga_documento.id_gruppo_agenti;
	  set @ld_prage=new_riga_documento.provv_agente;
	  set @ld_prsub=new_riga_documento.provv_subage;
	  set @ld_prcap=new_riga_documento.provv_carea;
	  set @il_id_azienda=new_riga_documento.id_azienda;
	  set @id_unita_confezione=new_riga_documento.id_unita_confezione;
	  set @prezzo=new_riga_documento.prezzo_netto; // BL#18780#
	  //
	  if @ll_id_riga_ref>0 then
	    /* Evasione quantita'' */
	    set @ld_qtatot=@ld_qta+@ld_qtasm;
	    message ' sp_deriva_riga / t_evadi_riga_ai '+string(@ll_id_riga_ref)+' --> '+string(@id_riga_documento);
	    call sp_deriva_riga(@id_riga_documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto);
	    /*
	    Elisa M.        13/03/01        BL#11174#i
	    Riporto il costo di trasporto se previsto nella riga derivata.
	    */
	    select ges_costo_trasporto into @lc_ges_costo_trasporto
	      from pers_par_sistema;
	    if(@lc_ges_costo_trasporto='S') then
	      message 'Riga:'+string(@id_riga_documento);
	      message 'Riga prov.:'+string(@ll_id_riga_ref);
	      insert into costo_tras_riga_doc(id_riga_documento,costo_trasporto)
	        select @id_riga_documento,costo_trasporto
	          from costo_tras_riga_doc
	          where id_riga_documento=@ll_id_riga_ref
	    end if
	  end if
	  ; /*BL#11174#f*/
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "DBA".documento
	    ,"DBA".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=new_riga_documento.id_documento));
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  /* Aggiungo il new */
	  set @Id_Caus_Magazzino=new_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=new_riga_documento.id_articolo;
	  set @Qta_Un_Base=new_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=new_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=new_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=new_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=new_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=new_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=new_riga_documento.peso_netto_evaso; //BL#13046#
	  /*
	  Elisa Moneti
	  */
	  /*  if not(@id_articolo is null) and(@ld_qta is null or @ld_qta=0) and(@ld_peso_netto is null or @ld_peso_netto=0)*/
	  /*    raiserror 99999 'Per movimentare un Articolo specificare la quantita'' o il Peso'*/
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if; 
	  set @ll_var1=new_riga_documento.id_art_var1;
	  set @ll_var2=new_riga_documento.id_art_var2;
	  set @ll_var3=new_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_ai --> '+string(@ID_Riga_Documento);
	    call sp_gest_causale_var('+P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('+S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	/* lancio procedura di gestione delle provvigioni */
	/*
	print 'Calcolo provvigioni:'
	print '  ID Documento         : '||@ll_id_documento
	print '  ID Gruppo Agenti     : '||@ll_id_gruppo_agenti
	print '  Totale riga          : '||@tot_riga_val_az
	print '  Percentuale AGENTE   : '||@ld_prage
	print '  Percentuale SUBAGE   : '||@ld_prsub
	print '  Percentuale CPAREA   : '||@ld_prcap
	print '  ID Azienda           : '||@il_id_azienda
	*/
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perche' l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '+',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	*/
	/**/
	end;
	
	
	ALTER TRIGGER "t_evadi_riga_ad".t_evadi_riga_ad before delete order 1
	on "DBA".riga_documento
	referencing old as old_riga_documento
	for each row
	begin
	  /* Elisa Moneti		31/03/1999
	  Gestione RIGA_DOCUMENTO.PESO_NETTO_EVASO
	
	  Elisa Moneti		21/06/1999
	  Gestione RIEPILOGO.QTA_ORD_CLIENTI
	
	  Elisa Moneti		23/05/2000
	  Gestione RIEPILOGO.ULT_COSTO con movimentazione a peso
	  Passo alla sp_gest_causale anche il peso_netto movimentato
	
	  Elisa Moneti      30/04/2001      BL#12430#
	
	  Elisa Moneti		04/06/2001        BL#13046#
	  Gestione dell''evasione degli ordini a Peso
	  */
	  declare @ll_id_riga_ref integer;
	  declare @il_id_azienda integer;
	  declare @ll_id_documento integer;
	  declare @ll_id_gruppo_agenti integer;
	  declare @ld_qta decimal(18,4);
	  declare @ld_qtasm decimal(18,4);
	  declare @ld_qtatot decimal(18,4);
	  declare @ld_peso_netto decimal(18,4);
	  declare @ld_peso_netto_tot decimal(18,4);
	  declare @ld_prage decimal(5,2);
	  declare @ld_prsub decimal(5,2);
	  declare @ld_prcap decimal(5,2);
	  declare @ID_Esercizio integer;
	  declare @ID_Attivita integer;
	  declare @Id_Caus_Magazzino integer;
	  declare @Data_Registrazione date;
	  declare @Data_Documento date;
	  declare @Anno decimal(4);
	  declare @Mese decimal(2);
	  declare @Prezzo dm_Imp_6_Dec;
	  declare @ID_Riga_Documento integer;
	  declare @ID_Articolo integer;
	  declare @ID_Locazione_1 integer;
	  declare @ID_Locazione_2 integer;
	  declare @Qta_Un_Base decimal(18,4);
	  declare @Tot_Riga_Val_Az decimal(18,4);
	  declare @Qta_Da_Usare decimal(18,4);
	  declare @Qta_Evasa decimal(18,4);
	  declare @Qta_CF decimal(18,4);
	  declare @ls_forza_ch_evas char(1);
	  declare @id_unita_confezione integer;
	  declare @peso_netto_evaso decimal(18,4); 
	  declare @ls_pk_codice char(20); //Gestione Varianti
	  declare @ls_var1 long varchar;
	  declare @ls_var2 long varchar;
	  declare @ls_var3 long varchar;
	  declare @ll_var1 integer;
	  declare @ll_var2 integer;
	  declare @ll_var3 integer;
	  if old_riga_documento.id_art_var1 is null then 
	     set @ls_var1='N'
	  else
	      set @ls_var1=string(old_riga_documento.id_art_var1);
	  end if;
	  if old_riga_documento.id_art_var2 is null then 
	      set @ls_var2='N'
	  else
	      set @ls_var2=string(old_riga_documento.id_art_var2)
	  end if;
	  if old_riga_documento.id_art_var3 is null then 
	      set @ls_var3='N'
	  else
	      set @ls_var3=string(old_riga_documento.id_art_var3)
	  end if;
	  SET @ls_pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	
	
	  /*Codice per la derivazione delle righe, retrieve anche di altri dati*/
	  set @ll_id_riga_ref=old_riga_documento.id_riga_doc_provenienza;
	  set @ID_riga_documento=old_riga_documento.id_riga_documento;
	  set @ld_qta=old_riga_documento.quantita;
	  set @ld_peso_netto=old_riga_documento.peso_netto;
	  set @ld_qtasm=old_riga_documento.qta_sconto_merce;
	  set @ll_id_documento=old_riga_documento.id_documento;
	  set @ll_id_gruppo_agenti=old_riga_documento.id_gruppo_agenti;
	  set @ld_prage=old_riga_documento.provv_agente;
	  set @ld_prsub=old_riga_documento.provv_subage;
	  set @ld_prcap=old_riga_documento.provv_carea;
	  set @il_id_azienda=old_riga_documento.id_azienda;
	  set @id_unita_confezione=old_riga_documento.id_unita_confezione;
	  set @prezzo=old_riga_documento.prezzo_netto; // BL#18780#
	  //
	  if @ll_id_riga_ref>0 then
	    /* Storno evasione quantita'' */
	    set @ld_qtatot=(0.0-@ld_qta-@ld_qtasm);
	    /* Storno evasione Peso Netto */
	    set @ld_peso_netto_tot=(0.0-@ld_peso_netto);
	    call sp_deriva_riga(@ID_Riga_Documento,@ll_id_riga_ref,@ld_qtatot,@ld_peso_netto_tot);
	    // BL#15754#
	    update riga_documento as r,documento as d set
	      r.forza_chius_evasione='N',d.evaso_totalmente='N'
	      where r.id_riga_documento=@ll_id_riga_ref
	      and d.id_documento=r.id_documento
	  end if
	  ; //
	  //
	  //
	  /* Codice per la creazione / storno dei riepiloghi */
	  select documento.data_registrazione,
	    documento.data_documento,
	    registro.id_esercizio,
	    registro.id_attivita into @Data_Registrazione,
	    @Data_Documento,@ID_Esercizio,
	    @ID_Attivita from "dba".documento
	    ,"dba".registro
	    where(registro.id_registro=documento.id_registro)
	    and((documento.id_documento=old_riga_documento.id_documento));
	  //
	  set @Anno=datepart(year,@Data_Registrazione);
	  set @Mese=datepart(month,@Data_Registrazione);
	  /* Detraggo l''old */
	  set @Id_Caus_Magazzino=old_riga_documento.id_caus_magazzino;
	  set @ID_Articolo=old_riga_documento.id_articolo;
	  set @Qta_Un_Base=old_riga_documento.qta_un_base;
	  set @Tot_Riga_Val_Az=old_riga_documento.tot_riga_val_az;
	  set @ID_Locazione_1=old_riga_documento.id_locazione_1;
	  set @ID_Locazione_2=old_riga_documento.id_locazione_2;
	  set @ls_forza_ch_evas=old_riga_documento.forza_chius_evasione;
	  set @Qta_Evasa=old_riga_documento.qta_evasa_un_base;
	  set @peso_netto_evaso=old_riga_documento.peso_netto_evaso; //BL#13046#
	  //
	  if @ls_forza_ch_evas='S' then
	    set @Qta_Da_Usare=@Qta_Evasa;
	    set @ld_peso_netto=@peso_netto_evaso //BL#13046#
	  else
	    set @Qta_Da_Usare=@Qta_Un_Base
	  end if
	  ;
	  if @Qta_Da_usare is null then
	    set @Qta_Da_Usare=0
	  end if
	  ;
	  /* lancio procedura di gestione dei riepiloghi di magazzino */
	  set @ll_var1=old_riga_documento.id_art_var1;
	  set @ll_var2=old_riga_documento.id_art_var2;
	  set @ll_var3=old_riga_documento.id_art_var3;
	  if @ID_Locazione_1 is not null then
	    message ' t_evadi_riga_ad --> '+string(@ID_Riga_Documento);
	    //message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @Qta_Evasa='+string(@Qta_Evasa)+' @Qta_Un_Base='+string(@Qta_Un_Base);
	    //message ' @ls_forza_ch_evas='+string(@ls_forza_ch_evas)+' @peso_netto_evaso='+string(@peso_netto_evaso)+' @ld_peso_netto='+string(@ld_peso_netto);
	    call sp_gest_causale_var('-P',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_1,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	  ;
	  if @ID_Locazione_2 is not null then
	    call sp_gest_causale_var('-S',@Data_Documento,@ID_Esercizio,@ID_Attivita,@ID_Articolo,@ID_Locazione_2,@Anno,@Mese,@Qta_Da_Usare,@Tot_Riga_Val_Az,@Prezzo,@Id_Caus_Magazzino,@id_unita_confezione,@ll_id_riga_ref,@ld_peso_netto,@ls_pk_codice,@ll_var1,@ll_var2,@ll_var3)
	  end if
	//
	/* lancio procedura di gestione delle provvigioni */
	/*  
	Elisa Moneti - 5/11/98
	Commento la chiamata a questa procedura che probabilmente dovr- essere rimossa
	dal Data Base.
	Questo perch+ l'aggiornamento dei Riepiloghi provvigione, non deve
	essere fatto con la creazione di un documento, ma con la contabilizzazione dello stesso.
	
	execute sp_gest_provvi '-'',@ll_id_documento,@ll_id_gruppo_agenti,@tot_riga_val_az,@ld_prage,@ld_prsub,@ld_prcap,@il_id_azienda
	
	*/
	/**/
	end;


update riepilogo set pk_codice=isnull(convert(long varchar,id_art_var1),'N')+'@'+
                               isnull(convert(long varchar,id_art_var2),'N')+'@'+
                               isnull(convert(long varchar,id_art_var3),'N');


update artvar_prezzo set pk_codice=isnull(convert(long varchar,id_art_var1),'N')+'@'+
                               isnull(convert(long varchar,id_art_var2),'N')+'@'+
                               isnull(convert(long varchar,id_art_var3),'N');

update var_con_lis_articolo set pk_codice=isnull(convert(long varchar,id_art_var1),'N')+'@'+
                               isnull(convert(long varchar,id_art_var2),'N')+'@'+
                               isnull(convert(long varchar,id_art_var3),'N');


///FINE CORREZIONE URGENTE 





if(not(exists(select 1 from sys.systable where table_name='var_des_articolo'))) then
	CREATE TABLE "dba"."var_des_articolo" ("id_var_des_articolo" integer NOT NULL DEFAULT autoincrement, 
		 "id_articolo" integer NOT NULL DEFAULT NULL, "id_sog_commerciale" integer DEFAULT NULL, 
		 "id_lingua" integer DEFAULT NULL, "id_linguaggio" integer NOT NULL DEFAULT NULL, 
	         "codice" char(32) DEFAULT NULL, "descrizione" char(40) DEFAULT NULL, 
        	 "des_estesa" long varchar DEFAULT NULL, "id_azienda" integer NOT NULL DEFAULT 1, 
	         "pk_codice" char(20) not null DEFAULT NULL, "id_art_var1" integer DEFAULT NULL, 
	         "id_art_var2" integer DEFAULT NULL, "id_art_var3" integer DEFAULT NULL , 
	         PRIMARY KEY ("id_var_des_articolo") , 
	         FOREIGN KEY "fk_des_articolo_4" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE RESTRICT , 
	         FOREIGN KEY "fk_des_articolo_2" ("id_lingua" ) REFERENCES "dba"."lingua" ON DELETE RESTRICT , 
	         FOREIGN KEY "fk_des_articolo_3" ("id_linguaggio" ) REFERENCES "dba"."linguaggio" ON DELETE RESTRICT , 
	         FOREIGN KEY "fk_des_articolo_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;
	CREATE INDEX "ix_des_articolo_1" ON "dba"."var_des_articolo" ("codice" ) ;

	CREATE TRIGGER "t_var_des_articolo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."var_des_articolo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	END;
	
	
	
	CREATE TRIGGER "t_var_des_articolo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."var_des_articolo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	END;

end if;





///FINE AGGIORNAMENTO TAGLIE COLORI


//////////BOSSI & TURCHI
ALTER PROCEDURE "DBA"."sp_trasf_dati"(@ai_tipo_trasferimento integer,@ai_num_parte integer)
begin
  if(@ai_tipo_trasferimento=1) then
    if(@ai_num_parte=5) then
      message 'So 1';
      call sp_trasf_bossi()
    end if
    ;

    if(@ai_num_parte=4) then
      call sp_trasf_parte4();
      call sp_trasf_parte4_1()
    end if
    ;

    if(@ai_num_parte=0) or(@ai_num_parte=1) then
      call sp_trasf_parte1();
      call sp_trasf_parte1_1()
    end if
    ;
    if(@ai_num_parte=0) or(@ai_num_parte=2) then
      call sp_trasf_parte2();
      call sp_trasf_parte2_1()
    end if
    ;
    if(@ai_num_parte=0) or(@ai_num_parte=3) then
      call sp_trasf_parte3();
      set option fire_triggers='off';
      call sp_trasf_parte3_1();
      set option fire_triggers='on'
    end if
  /*
  Trasferimento Dati "Cometa - Cometa"
  2 = creazione tmp anagrafiche
  2_1 = allineamento anagrafiche
  1 = creazione tmp documenti
  1_1 = allineamento bolle di vendita
  3_1 = allineamento fatture di vendita
  */
  elseif(@ai_tipo_trasferimento=3) then
    if(@ai_num_parte=0) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1();
      call sp_trasf_cometa_parte1();
      call sp_trasf_cometa_parte1_1()
    elseif(@ai_num_parte=1) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1()
    elseif(@ai_num_parte=3) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1();
      call sp_trasf_cometa_parte1();
      call sp_trasf_cometa_parte3_1()
    elseif(@ai_num_parte=7) then
      call sp_trasf_cometa_parte7();
      call sp_trasf_cometa_parte7_1()
    elseif(@ai_num_parte=9) then
      call sp_trasf_cometa_parte9();
      call sp_trasf_cometa_parte9_1()
    end if
  /*
  Caricamento PF provenienti dalla produzione - BOSSI & TURCHI	
  */
  elseif(@ai_tipo_trasferimento=4) then
    call sp_car_lotto_pf()
  end if
end;
////////////////////////




//////////////////////////////////////////
/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_007' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_007','Release 2_01_007  Cometa','S')
        ;

END IF
;

