//INIZIO 2_01_008


/* Results of automatic index tuning for analysis Cometa2 */

//VERSIONE BOSSI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cat_com_sc'
        AND      CNAME = 'id_cat_com_sc_superiore' )) THEN 
	alter table cat_com_sc add id_cat_com_sc_superiore integer;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'bossi_par_sis')) THEN

	CREATE TABLE "dba"."bossi_par_sis"
               ("id_bossi_par_sis" integer NOT NULL DEFAULT 1,
              "id_cpt_sconti" integer NOT NULL ,
              "id_listino_ven_base" integer NOT NULL, 
	      PRIMARY KEY ("id_bossi_par_sis")) ;

	alter table bossi_par_sis add id_cat_com_1 integer;
	alter table bossi_par_sis add id_cat_com_2 integer;
	alter table bossi_par_sis add id_cat_com_3 integer;

	alter table bossi_par_sis add id_prof_doc_storno integer;

	alter table pers_par_sistema add fatt_sconti char(1);

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'storico_sconti')) THEN


	CREATE TABLE "dba"."storico_sconti"
                      ("id_storico_sconti" integer NOT NULL DEFAULT autoincrement,
                     "id_reg_pd" integer NOT NULL ,
                     "id_documento" integer NOT NULL ,
                     "id_cpt_sconto" integer,
                     "id_sog_com" integer  
	       , PRIMARY KEY ("id_storico_sconti")
	       , FOREIGN KEY "fk_storico_sconti" ("id_reg_pd") 
               REFERENCES "dba"."reg_pd" ON DELETE  CASCADE) ;
 
	CREATE UNIQUE INDEX "xk_st_sc"
        ON "dba"."storico_sconti"
        ("id_reg_pd" , "id_cpt_sconto" ) ;
 
	CREATE UNIQUE INDEX "xk_storico_sconti"
        ON "dba"."storico_sconti"
        ("id_storico_sconti" ) ;
 

	CREATE TABLE "dba"."dett_storico_sconti"
                      ("id_dett_storico_sconti" integer NOT NULL DEFAULT autoincrement,
                     "id_storico_sconti" integer NOT NULL ,
                     "id_articolo" integer,
                     "num_riga" integer NOT NULL ,
                     "prezzo_netto" numeric(18,4),
                     "prezzo_listino" numeric(18,4),
                     "qta_peso" numeric(18,4),
                     "prezzo_omaggio" numeric(18,4),
                     "anomalia_prezzo" char(1)  ,
                     "anomalia_conto" char(1)  ,
                     "anomalia_listino" char(1)  ,
                     "anomalia_qta" char(1), 
                     "rigo_anomalia" integer,
		     "id_cpt_valore" integer
              , PRIMARY KEY ("id_dett_storico_sconti")
	      , FOREIGN KEY "fk_dett_st_sc" ("id_storico_sconti") 
	      REFERENCES "dba"."storico_sconti" ON DELETE  CASCADE) ;
 
	alter table storico_sconti add tipo_fatt char(1);
	update storico_sconti set tipo_fatt='N';
	alter table storico_sconti modify tipo_fatt char(1) not null;

	update storico_sconti s , documento d
	 set s.tipo_fatt=d.tipo_fattura
	where s.id_documento=d.id_documento
	and d.tipo_fattura='C';

	alter table dett_storico_sconti add id_riga_prezzo_lotto integer;
	alter table dett_storico_sconti add id_lotto integer;

end if;




IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'sollecito')) THEN

	Create table "dba"."sollecito" (
	   "id_sollecito" integer NOT NULL DEFAULT autoincrement,   
           "vis_logo"  char(1) not null,       
	   "vis_sog" char(1) not null,        
	   "vis_titolo" char(1) not null,      
	   "titolo" char(80),     
	   "vis_dett_scad" char(1) not null,     
	   "testo_dett_scad" long varchar,    
	   "vis_testo_dett_scad" char(1) not null,  
	   "testo" long varchar,        
	   "logo" char(120),         
	   "vis_sotto_sog" char(1) not null,    
	   "sotto_sog" char(255),        
	   "vis_pie_sx" char(1) not null,        
	   "pie_sx" long varchar,       
	   "vis_pie_dx" char(1) not null,      
	   "pie_dx" long varchar,         
	   "cod_sollecito" char(8) not null,    
           "des_sollecito"  char(80) not null      
	, PRIMARY KEY ("id_sollecito")) ;

	//creare profilo storno e settare qui


end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'scadenza'
        AND      CNAME = 'num_sollecito' )) THEN 

		alter table scadenza add num_sollecito integer;
    	alter table scadenza add data_ult_sollecito date;

end if;


update voci_menu set vmenu_order=40 where vmenu_voce='Invio @_mail';
update voci_menu set vmenu_order=100 where vmenu_voce='Piano dei Conti';
update voci_menu set vmenu_order=70 where vmenu_voce='Stampa Anagrafica';
update voci_menu set vmenu_order=80 where vmenu_voce='Stampa Etichette';
update voci_menu set vmenu_order=90 where vmenu_voce='Variazione Dati Anagrafica';
call fn_ins_voce_menu('Anagrafica', 'w_cat_sc_org_cx', 'Organizza Cat. Commerciali', 6);
call fn_ins_voce_menu('Anagrafica', 'w_ins_cat_sc', 'Assegna Cat. Commerciale', 7);
call fn_ins_voce_menu('Anagrafica', 'w_cerca_mail', 'Inserimento @_mail', 45);

call fn_ins_voce_menu('Gestione Scadenze', 'w_list_sollecito', 'Crea Sollecito', 45);
call fn_ins_voce_menu('Gestione Scadenze', 'w_invia_sollecito', 'Invio Sollecito', 55);

call fn_ins_voce_menu('Agenti', 'w_lancio_stp_provvigioni_rpt', 'Estratto Provvigioni', 45);


call fn_ins_voce_menu('Stampe', null , 'Fatturato', 90);
update voci_menu set id_voci_menu_padre=4133 where vmenu_voce='Fatturato' and id_oggetti is null;


call fn_ins_voce_menu('Fatturato', 'w_contab_sconti_cx', 'Contabilizzazione Sconti', 10);
call fn_ins_voce_menu('Fatturato', 'w_visual_cpt', 'Verifica Sconti', 20);
call fn_ins_voce_menu('Fatturato', 'w_naz_vendite', 'Fatturato Nazionale', 30);
call fn_ins_voce_menu('Fatturato', 'w_fatturato_cx', 'Stampa Fatturato Parametrica', 50);
call fn_ins_voce_menu('Fatturato', 'w_confronto_fatt_ag_art_ff', 'Confronto Vendite', 30);
call fn_ins_voce_menu('Fatturato', 'w_confronto_fatt_ag_art_ff', 'Confronto Vendite', 30);




///Prov inccassato

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'con_prov_setup' )) THEN 

	ALTER TABLE PAR_SISTEMA add con_prov_setup char(1) DEFAULT 'N';
	//N niente
	//G gestisci
	//A crea automatico in anagrafica


	ALTER TABLE con_provvigione add promozionale char(1) DEFAULT 'N';

	CREATE TABLE "dba"."con_prov_setup" 
		("id_con_prov_setup" integer NOT NULL DEFAULT autoincrement, 
	         "id_cat_com_sc" integer NOT NULL DEFAULT NULL, 
	         "mesi_validita" integer NOT NULL DEFAULT NULL, 
		 "perc_capo_area" numeric(5,2) DEFAULT NULL, 
	         "imp_capo_area" numeric(18,4) DEFAULT NULL, 
	         "perc_agente" numeric(5,2) DEFAULT NULL, 
	         "imp_agente" numeric(18,4) DEFAULT NULL, 
	         "perc_sub_agente" numeric(5,2) DEFAULT NULL, 
	         "imp_sub_agente" numeric(18,4) DEFAULT NULL, 
	         "perc_inc_ag1" numeric(18,2) DEFAULT NULL, 
	         "perc_inc_ag2" numeric(18,2) DEFAULT NULL , 
	         PRIMARY KEY ("id_con_prov_setup") , 
	         FOREIGN KEY "fk_con_prov_setup_1" ("id_cat_com_sc" ) REFERENCES "dba"."cat_com_sc" ON DELETE RESTRICT ) ;
	CREATE UNIQUE INDEX "xk_con_prov_setup_1" ON "dba"."con_prov_setup" ("id_cat_com_sc" ) ;


	ALTER TABLE DESTINAZIONE add data_prov_setup DATE; 
end if;


ALTER FUNCTION "DBA"."fn_calc_priorita_provv"(in @id_gruppo_agenti integer,in @id_sog_commerciale integer,in @id_cat_com_sc integer,in @id_unita_confezione integer,in @id_art_da integer,in @id_art_a integer,in @id_cat_com_articolo integer,in @id_cat_merceologica integer,in @data_inizio date,in @data_fine date,in @id_anagrafica integer,in @promozione char(1))
returns integer
begin
  /*
  Elisa M.                  21/12/00                BL#10277#
  Chiamata da: T_CON_PROVVIGIONE_AI, T_CON_PROVVIGIONE_AU
  */
  declare @li_return integer;
  set @li_return=0;
  //BL#11088#i

  if @promozione='S' then
     set @li_return=@li_return+40000000	
  end if;

  if(@id_anagrafica is not null) then
     set @li_return=@li_return+30000000
  end if
  ;

  //BL#11088#f
  if(@id_gruppo_agenti is not null) then
    set @li_return=@li_return+10000000
  end if
  ;
  if(@id_sog_commerciale is not null) then
    set @li_return=@li_return+2000000
  end if
  ;
  if(@id_cat_com_sc is not null) then
    set @li_return=@li_return+1000000
  end if
  ;
  if(@id_unita_confezione is not null) then
    set @li_return=@li_return+300000
  end if
  ;
  if(@id_art_da is not null) and(@id_art_a=@id_art_da) then
    set @li_return=@li_return+200000
  else
    if(@id_art_da is not null) or(@id_art_a is not null) then
      set @li_return=@li_return+100000
    end if
  end if
  ;
  if(@id_cat_merceologica is not null) then
    set @li_return=@li_return+10000
  end if
  ;
  if(@id_cat_com_articolo is not null) then
    set @li_return=@li_return+1000
  end if
  ;
  if(@data_inizio is not null) and(@data_fine is not null) then
    set @li_return=@li_return+20
  end if
  ;
  if(@data_inizio is not null) and(@data_fine is null) then
    set @li_return=@li_return+10
  end if
  ;
  return(@li_return)
end;


ALTER TRIGGER "t_con_provvigione_bi".t_con_provvigione_bi before insert order 1
on "DBA".con_provvigione
referencing new as inserted
for each row
begin
  /* 
  Elisa M.     21/12/00   BL#10277# 
  Calcolo e assegno la priorita'' della condizione in inserimento del record.
  Elisa M.      14/02/2001      BL#11088#
  Ho aggiunto id_anagrafica (Produttore)
  */
  declare @li_id_con_prov integer;
  set @li_id_con_prov=0;
  // Verifica Unicit del Record
  select id_con_provvigione into @li_id_con_prov
    from con_provvigione
    where ifnull(id_gruppo_agenti,0,id_gruppo_agenti)=ifnull(inserted.id_gruppo_agenti,0,inserted.id_gruppo_agenti)
    and ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
    and ifnull(id_unita_confezione,0,id_unita_confezione)=ifnull(inserted.id_unita_confezione,0,inserted.id_unita_confezione)
    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
    and ifnull(id_articolo_a,0,id_articolo_a)=ifnull(inserted.id_articolo_a,0,inserted.id_articolo_a)
    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo)
    and ifnull(id_cat_merceologica,0,id_cat_merceologica)=ifnull(inserted.id_cat_merceologica,0,inserted.id_cat_merceologica)
    and ifnull(data_inizio,cast('2999-01-01' as date),data_inizio)=ifnull(inserted.data_inizio,cast('2999-01-01' as date),inserted.data_inizio)
    and ifnull(data_fine,cast('2999-01-01' as date),data_fine)=ifnull(inserted.data_fine,cast('2999-01-01' as date),inserted.data_fine)
    and ifnull(id_anagrafica,0,id_anagrafica)=ifnull(inserted.id_anagrafica,0,inserted.id_anagrafica)
    and id_con_provvigione<>inserted.id_con_provvigione;
  if @li_id_con_prov>0 then
    message 'Condizione di provvigione gia'' esistente: ',@li_id_con_prov,'   ',inserted.id_con_provvigione;
    raiserror 99999 'Condizione di provvigione gia'' esistente ...'+string(@li_id_con_prov)+'   '+string(inserted.id_con_provvigione);
    rollback work
  else
    set inserted.priorita=cast((fn_calc_priorita_provv(inserted.id_gruppo_agenti,inserted.id_sog_commerciale,inserted.id_cat_com_sc,inserted.id_unita_confezione,inserted.id_articolo,inserted.id_articolo_a,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,inserted.data_inizio,inserted.data_fine,inserted.id_anagrafica,inserted.promozionale)) as decimal(18))
  end if
end;


ALTER TRIGGER "t_con_provvigione_bu".t_con_provvigione_bu before update order 2
on "DBA".con_provvigione
referencing old as deleted new as inserted
for each row
begin
  /* 
  Elisa M.     21/12/00   BL#10277# 
  Calcolo e assegno la priorita'' della condizione in modifica del record.
  Elisa M.      14/02/2001      BL#11088#
  Ho aggiunto id_anagrafica (Produttore)
  */
  declare @li_id_con_prov integer;
  // Verifica Unicit record.
  set @li_id_con_prov=0;
  select id_con_provvigione into @li_id_con_prov
    from con_provvigione
    where ifnull(id_gruppo_agenti,0,id_gruppo_agenti)=ifnull(inserted.id_gruppo_agenti,0,inserted.id_gruppo_agenti)
    and ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
    and ifnull(id_unita_confezione,0,id_unita_confezione)=ifnull(inserted.id_unita_confezione,0,inserted.id_unita_confezione)
    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
    and ifnull(id_articolo_a,0,id_articolo_a)=ifnull(inserted.id_articolo_a,0,inserted.id_articolo_a)
    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo)
    and ifnull(id_cat_merceologica,0,id_cat_merceologica)=ifnull(inserted.id_cat_merceologica,0,inserted.id_cat_merceologica)
    and ifnull(data_inizio,cast('2999-01-01' as date),data_inizio)=ifnull(inserted.data_inizio,cast('2999-01-01' as date),inserted.data_inizio)
    and ifnull(data_fine,cast('2999-01-01' as date),data_fine)=ifnull(inserted.data_fine,cast('2999-01-01' as date),inserted.data_fine)
    and ifnull(id_anagrafica,0,id_anagrafica)=ifnull(inserted.id_anagrafica,0,inserted.id_anagrafica)
    and id_con_provvigione<>inserted.id_con_provvigione;
  if @li_id_con_prov>0 then
    message 'Condizione di provvigione gia'' esistente: ',@li_id_con_prov,'   ',inserted.id_con_provvigione;
    raiserror 99999 'Condizione di provvigione gia'' esistente ...'+string(@li_id_con_prov)+'   '+string(inserted.id_con_provvigione);
    rollback work
  else
    set inserted.priorita=cast((fn_calc_priorita_provv(inserted.id_gruppo_agenti,inserted.id_sog_commerciale,inserted.id_cat_com_sc,inserted.id_unita_confezione,inserted.id_articolo,inserted.id_articolo_a,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,inserted.data_inizio,inserted.data_fine,inserted.id_anagrafica,inserted.promozionale)) as decimal(18))
  end if
end;


//*********

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'con_prov_setup'
        AND      CNAME = 'id_gruppo_agenti' )) THEN 

	DELETE FROM con_prov_setup;
	ALTER TABLE con_prov_setup add id_gruppo_agenti integer not null;
	ALTER TABLE con_prov_setup add "perc_capo_area_base" numeric(5,2) DEFAULT NULL;
	ALTER TABLE con_prov_setup add "imp_capo_area_base" numeric(18,4) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "perc_agente_base" numeric(5,2) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "imp_agente_base" numeric(18,4) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "perc_sub_agente_base" numeric(5,2) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "imp_sub_agente_base" numeric(18,4) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "perc_inc_ag1_base" numeric(18,2) DEFAULT NULL; 
	ALTER TABLE con_prov_setup add "perc_inc_ag2_base" numeric(18,2) DEFAULT NULL; 

	DROP INDEX "xk_con_prov_setup_1";
	CREATE UNIQUE INDEX "xk_con_prov_setup_1" ON "dba"."con_prov_setup" ("id_cat_com_sc", "id_gruppo_agenti" ) ;

end if;


//Prov incassato fine


///Lavorazione Articoli

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'usa_trasformazione' )) THEN 
	alter table prof_documento add usa_trasformazione char(1);
	alter table prof_documento add id_locazione_trasf integer;
	alter table prof_documento add id_caus_magazzino_trasf integer;
end if;

///Fine Lavorazione


///DAMAZ

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'perc_ric_listini')) THEN


	CREATE TABLE "dba"."perc_ric_listini" 
	("id_perc_ric_listini" integer NOT NULL DEFAULT autoincrement, 
	"id_sog_commerciale" integer DEFAULT NULL, 
	"id_articolo" integer DEFAULT NULL, 
	"id_cat_com_sc" integer DEFAULT NULL, 
	"id_cat_com_articolo" integer DEFAULT NULL, 
	"perc_ric1" numeric(18,2) DEFAULT NULL, "perc_ric2" numeric(18,2) DEFAULT NULL, 
	"perc_ric3" numeric(18,2) DEFAULT NULL, "perc_ric4" numeric(18,2) DEFAULT NULL, 
	"perc_ric5" numeric(18,2) DEFAULT NULL, "perc_ric6" numeric(18,2) DEFAULT NULL, 
	"id_art_var1" integer DEFAULT NULL, "id_art_var2" integer DEFAULT NULL, 
	"id_art_var3" integer DEFAULT NULL, "priorita" integer NOT NULL DEFAULT NULL , 
	PRIMARY KEY ("id_perc_ric_listini")) ;


	CREATE TRIGGER "t_perc_ric_listini_bi".t_perc_ric_listini_bi before insert order 1
	on "DBA".perc_ric_listini
	referencing new as inserted
	for each row
	begin
	  declare @li_perc_ric_listini integer;
	  set @li_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,null,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
	end;
	
	CREATE TRIGGER "t_perc_ric_listini_bu".t_perc_ric_listini_bu before update order 2
	on "DBA".perc_ric_listini
	referencing old as deleted new as inserted
	for each row
	begin
	  declare @li_perc_ric_listini integer;
	  set @li_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,null,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
	end;

end if;


ALTER TRIGGER "t_perc_ric_listini_bi".t_perc_ric_listini_bi before insert order 1
	on "DBA".perc_ric_listini
	referencing new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,null,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
end;
	
ALTER TRIGGER "t_perc_ric_listini_bu".t_perc_ric_listini_bu before update order 2
	on "DBA".perc_ric_listini
	referencing old as deleted new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,null,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
end;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'perc_ric_listini' )) THEN 
	alter table par_sistema add perc_ric_listini char(1);
end if;



/// fine damaz



////////////////////////

//Serial key e n.licenze
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'serial_key'
        AND      CNAME = 'n_licenze' )) THEN 
	alter table serial_key add n_licenze integer default 1;
end if;

delete from serial_key;
commit;
insert into serial_key(id_azienda, s_key, n_licenze)
values(1, 'DEMO', 1);
commit;
//////////////////////////

///Modifica per Movimentazione Riepiloghi per confezioni non BASE
ALTER PROCEDURE "DBA"."sp_gest_causale_var"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Elisa Moneti      29/01/1999
	  Oggetto: Aggiornamento della "Data Ultimo Scarico"
	
	  Elisa M.              21/06/1999 
	  Gestione Ordinato Clienti e Ordinato Fornitori,
	  in seguito alla cancellazione, inserimento o modifica di una riga documento
	  con una causale di mag. che decrementa uno di questi due valori
	
	  Elisa M.    23/05/2000
	  Aggiornamento dell'ultimo costo sia che la movimentazione sia a peso che in quantita'
	
	  Elisa Moneti  20/09/2000      
	  Rif. Bolla 7889 : Aggiornamento dei riepiloghi di magazzino a peso
	
	  Elisa Moneti  31/08/2001
	  BL#15075# -  gestione Valuta per passaggio all''Euro
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l'unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l'unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)
	  /*
	  Stefano
	  recupero mp_car_fiscali e md_car_fiscale relativamente alla causale
	  di magazzino per sapere se deve essere aggiornato o no il primo costo
	  */
	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino
	  /*stefano controlo se l'unita' confezione della riga + un'unita' base; se si aggiorno l''ultimo
	  costo altrimenti no*/
	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione
/* Controllo che sia l'unita base- Massimo Zurli - Inizio*/
if (@unita_base = 'N') 
    begin
        select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
        from "dba".unita_confezione
        where unita_confezione.unita_base = 'S'
        and unita_confezione.id_articolo = @id_articolo
        select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
        message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
end    
/* Controllo che sia l'unita base - Massimo Zurli - Fine*/
	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      /*
	      Elisa M.        23/05/00
	      Se la movimentazione e' a peso, il prezzo viene calcolato in base al peso,
	      altrimenti in base alla quantita'
	      */
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              /*select @Prezzo=@Valore/@peso_netto*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              /*select @Prezzo=@Valore/@Qta*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        /*          message ' Prezzo:'||string(@Prezzo)*/
	        end
	      /* BL#15075#i*/
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      /* BL#15075#f*/
	      /* Carico i valori di causale di magazzino per il magazzino pricipale*/
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riepilogo.ult_costo,
	        @Data_Ult_Costo=riepilogo.data_ult_costo,
	        @Qta_Rim_Iniziale=riepilogo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riepilogo.val_rim_iniziale,
	        @Qta_Caricata=riepilogo.qta_caricata,
	        @Qta_Scaricata=riepilogo.qta_scaricata,
	        @Val_Caricato=riepilogo.val_caricato,
	        @Val_Scaricato=riepilogo.val_scaricato,
	        @Data_Ult_Scarico=riepilogo.data_ult_scarico,
	        @Qta_Ord_Clienti=riepilogo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riepilogo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riepilogo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riepilogo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riepilogo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riepilogo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riepilogo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riepilogo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riepilogo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riepilogo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riepilogo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riepilogo.qta_gruppo_lib_4,
	        @peso_caricato=riepilogo.peso_caricato,
	        @peso_scaricato=riepilogo.peso_scaricato,
	        @peso_ord_clienti=riepilogo.peso_ord_clienti,
	        @peso_ord_fornitori=riepilogo.peso_ord_fornitori,
	        @peso_vis_clienti=riepilogo.peso_vis_clienti,
	        @peso_vis_fornitori=riepilogo.peso_vis_fornitori,
	        @peso_imp_produzione=riepilogo.peso_imp_produzione,
	        @peso_ord_produzione=riepilogo.peso_ord_produzione,
	        @peso_cl_clienti=riepilogo.peso_cl_clienti,
	        @peso_cl_fornitori=riepilogo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riepilogo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riepilogo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riepilogo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riepilogo.peso_gruppo_lib_4
	        from "dba".riepilogo
	        where(riepilogo.id_esercizio=@Id_Esercizio)
	        and(riepilogo.id_attivita=@Id_Attivita)
	        and(riepilogo.id_articolo=@Id_Articolo)
	        and(riepilogo.pk_codice=@pk_codice)
	        and(riepilogo.id_locazione=@Id_Locazione)
	        and(riepilogo.anno=@Anno)
	        and(riepilogo.mese=@Mese)
	        and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	      /*      message 'ccc'*/
	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)
	      /*      message 'Ultimo Costo:'||@M_Ult_Costo||' Data_ult_costo:'||string(@Data_ult_costo)||' Data:'||string(@LaData)||' U.B.:'||@unita_base*/
	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          /* BL#20265#i */
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          /*select @Ult_Costo=@Prezzo*/
	          /* BL#2026#f*/
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end
	      /*
	      Elisa M.                          21/06/1999
	      Gestione Ordinato Clienti e Ordinato Fornitori
	      */
	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza
	      /*
	      Elisa Moneti
	      29/01/1999
	      Oggetto: Aggiornamento della "Data Ultimo Scarico"
	      */
	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          /*
	          Elisa M.                              21/06/1999
	          Gestione Ordinato Clienti
	          */
	          if @M_Ord_Clienti='-'
	            begin
	              /* STORNO (DELETE e prima parte dell''UPDATE) */
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              /* AGGIUNTA (INSERT e seconda parte dell'UPDATE)
	
	              Verifico che la qta evasa o peso evaso della riga 
	              dalla quale deriva (qui arriva gia' aggiornata
	              della qta e del peso del movimento attuale)
	              non sia maggiore della qta ordinata e del peso ordinato
	              */
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        /*
	        Elisa M.                                21/06/1999
	        Gestione Ordinato Fornitori (come Ordinato Clienti)
	        */
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          /*                       // BL#14237#*/
	          /*          if Substr(@Evento,1,1)='+'*/
	          /*            begin*/
	          /*              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)*/
	          update riepilogo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            /* Elisa M.     21/09/2000      BL7889*/
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            /**/
	            where(riepilogo.id_esercizio=@Id_Esercizio)
	            and(riepilogo.id_attivita=@Id_Attivita)
	            and(riepilogo.id_articolo=@Id_Articolo)
	            and(riepilogo.pk_codice=@pk_codice)
	            and(riepilogo.id_locazione=@Id_Locazione)
	            and(riepilogo.anno=@Anno)
	            and(riepilogo.mese=@Mese)
	            and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              /* BL#14142                */
	              /*              execute sp_ultimo_costo @id_articolo,@LaData,1,@Data_Ult_costo,@Ult_Costo   */
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  /* BL#20265#i */
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  /*select @Ult_Costo=@Prezzo*/
	                  /* BL#2026#f*/
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                /*BL#14142#i*/
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              /*BL#14142#f*/
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,
	                    /* BL#15075#*/
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889*/
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,                    
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889 */
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              message ' -> ',sqlstate
	            end
	        end
	    end
	end;
/////////////////////////////////////////////////////////////////

//Import documenti da file ASCII
call fn_ins_voce_menu('Documenti', 'w_imp_doc_cx', 'Importazione Documenti da File', 190); 



//funzione SENATORI
IF NOT(EXISTS(
	SELECT 1 FROM   SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_ultimo_acquisto')) THEN
	
CREATE FUNCTION "DBA"."fn_ultimo_acquisto"(in @id_art integer,in @id_v1 integer,in @id_v2 integer,in @id_v3 integer, in @id_fo integer)
returns char(60)
/*
Recupero l'Ultimo Acquisto
Argomenti input:
. ID Articolo   (Obbligatorio)
. ID Varianti
. ID Fornitore  (Obbligatorio)
. ID Valuta     (Obbligatorio) - Se 0 il Costo viene mantenuto nella Valuta indicata nella Riga documento.
*/

begin
  declare @id_doc integer;
  declare @id_riga integer;
  declare @id_var1 integer;
  declare @rd_pz decimal(20,6);
  declare @rs_sc char(40);
  declare @rs_test char(40);
  declare @ls_ret char(60);
  declare @rd_data date;
  declare @rn_num integer;
  declare @rs_v1 char;
  //
  //
  Select max(id_riga_documento) into @id_riga from riga_documento r, documento d, registro t
  where d.id_documento=r.id_documento and d.id_registro=t.id_registro and t.tipo_registro='OA'
  and d.id_sog_commerciale=@id_fo and r.id_articolo=@id_art 
  //and (r.id_art_var1=@id_v1 or @id_v1 is null)
  //and (r.id_art_var2=@id_v2 or @id_v2 is null)
  //and (r.id_art_var3=@id_v3 or @id_v3 is null)
  ;

  if sqlcode<>0 then
     return 'Nessun Acquisto'
  else
     Select d.data_registrazione, d.num_progressivo, r.id_art_var1, r.prezzo, r.sconto
     into @rd_data, @rn_num, @id_var1, @rd_pz, @rs_sc from documento d, riga_documento r 
     where r.id_documento=d.id_documento and r.id_riga_documento=@id_riga;
     if sqlcode<>0 then
        return 'Nessun Acquisto'
     else
        Select cod_var1 into @rs_v1 from art_var1 where id_art_var1=@id_var1;
        if @rs_v1 is null then 
           set @rs_v1=''
        end if;
        set @ls_ret=REPEAT(' ',10-LENGTH(@rs_v1))+@rs_v1;
        set @rs_test=isnull(string(@rn_num),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(string(@rd_data),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(string(@rd_pz),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',20-LENGTH(@rs_test))+@rs_test;
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(isnull(@rs_sc,' ')))+isnull(@rs_sc,' ');
        message string(@ls_ret);
     end if;
  end if;

  return @ls_ret;

end;

END IF;

ALTER FUNCTION "DBA"."fn_ultimo_acquisto"(in @id_art integer,in @id_v1 integer,in @id_v2 integer,in @id_v3 integer, in @id_fo integer)
returns char(60)
/*
Recupero l'Ultimo Acquisto
Argomenti input:
. ID Articolo   (Obbligatorio)
. ID Varianti
. ID Fornitore  (Obbligatorio)
. ID Valuta     (Obbligatorio) - Se 0 il Costo viene mantenuto nella Valuta indicata nella Riga documento.
*/

begin
  declare @id_doc integer;
  declare @id_riga integer;
  declare @id_var1 integer;
  declare @rd_pz decimal(20,6);
  declare @rs_sc char(40);
  declare @rs_test char(40);
  declare @ls_ret char(60);
  declare @rd_data date;
  declare @rn_num integer;
  declare @rs_v1 char;
  //
  //
  Select max(id_riga_documento) into @id_riga from riga_documento r, documento d, registro t
  where d.id_documento=r.id_documento and d.id_registro=t.id_registro and t.tipo_registro='OA'
  and d.id_sog_commerciale=@id_fo and r.id_articolo=@id_art 
  //and (r.id_art_var1=@id_v1 or @id_v1 is null)
  //and (r.id_art_var2=@id_v2 or @id_v2 is null)
  //and (r.id_art_var3=@id_v3 or @id_v3 is null)
  ;

  if sqlcode<>0 then
     return 'Nessun Acquisto'
  else
     Select d.data_registrazione, d.num_progressivo, r.id_art_var1, r.prezzo, r.sconto
     into @rd_data, @rn_num, @id_var1, @rd_pz, @rs_sc from documento d, riga_documento r 
     where r.id_documento=d.id_documento and r.id_riga_documento=@id_riga;
     if sqlcode<>0 then
        return 'Nessun Acquisto'
     else
        Select cod_var1 into @rs_v1 from art_var1 where id_art_var1=@id_var1;
        if @rs_v1 is null then 
           set @rs_v1=''
        end if;
        set @ls_ret=REPEAT(' ',10-LENGTH(@rs_v1))+@rs_v1;
        set @rs_test=isnull(string(@rn_num),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(string(@rd_data),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(string(@rd_pz),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',20-LENGTH(@rs_test))+@rs_test;
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(isnull(@rs_sc,' ')))+isnull(@rs_sc,' ');
        message string(@ls_ret);
     end if;
  end if;

  return @ls_ret;

end;


///CORREZIONI MENU


delete from voci_menu where id_voci_menu_padre=4617;
update voci_menu set vmenu_voce='Report Agenti' where vmenu_voce='Stampe'  and id_voci_menu_padre=5393;

call fn_ins_voce_menu('Tabelle di Codifica', 'W_PROF_CESPITE_CX', 'Causali movimentazione cespite', 20);

call fn_ins_voce_menu('Report Agenti','w_stp_sc_provv_gen_cx','Scaglioni di provvigione generali',40);
call fn_ins_voce_menu('Report Agenti','w_stp_agenti_tipol_cx','Tipo Agenti',20);
call fn_ins_voce_menu('Report Agenti','w_stp_perc_ena_cx','Percentuali Enasarco',30);
call fn_ins_voce_menu('Report Agenti','w_st_prezzi_art_cx','Stampa codice articolo',30);
call fn_ins_voce_menu('Report Agenti','w_stp_agenti_anag_cx','Gruppo Agenti',10);


delete from voci_menu where id_voci_menu_padre=4601;
update voci_menu set vmenu_voce='Generiche Articolo' where vmenu_voce='Anagrafica'  and id_voci_menu=4601;


call fn_ins_voce_menu('Generiche Articolo','w_stp_anag_art_cx','Scheda anagrafica articolo',20);
call fn_ins_voce_menu('Generiche Articolo','w_st_prezzi_art_cx','Stampa codice articolo',30);


call fn_ins_voce_menu('Impostazioni','w_par_sis_doc_semp_cx','Parametri Cassa Negozio',3);

/////TREMORI Listini Elettronici
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40art00f')) THEN

	CREATE TABLE y40_y40art00f (
	arartpos CHAR(1), 
	arcatces CHAR(15), 
	arcatcon CHAR(5), 
	arcatomo CHAR(5), 
	arcatscm CHAR(5), 
	arclamat CHAR(5), 
	arclipj CHAR(8), 
	arcocol1 NUMERIC(18,4), 
	arcocol2 NUMERIC(18,4), 
	arcodalt CHAR(20), 
	arcodart CHAR(20), 
	arcodcla CHAR(3), 
	arcoddis CHAR(20), 
	arcodfam CHAR(5), 
	arcodgru CHAR(5), 
	arcodiva CHAR(5), 
	arcodmar CHAR(5), 
	arcodrep CHAR(3), 
	arcodric CHAR(5), 
	arcodsot CHAR(5), 
	ardesart CHAR(40), 
	ardessup CHAR(10), 
	ardesvo2 CHAR(15), 
	ardesvol CHAR(15), 
	ardimal2 NUMERIC(18,4), 
	ardimalt NUMERIC(18,4), 
	ardimla2 NUMERIC(18,4), 
	ardimlar NUMERIC(18,4), 
	ardimlu2 NUMERIC(18,4), 
	ardimlun NUMERIC(18,4), 
	ardtinva CHAR(8), 
	ardtobso CHAR(8), 
	arflcesp CHAR(1), 
	arflcomp CHAR(1), 
	arflcon2 CHAR(1), 
	arflcona CHAR(1), 
	arfldisc CHAR(1), 
	arfldisp CHAR(1), 
	arflesau CHAR(1), 
	arflgis4 CHAR(1), 
	arflinve CHAR(1), 
	arfllott CHAR(1), 
	arflpeco CHAR(1), 
	arflserg CHAR(1), 
	arflstco CHAR(1), 
	arflusep CHAR(1), 
	arflvari CHAR(1), 
	argesmat CHAR(1), 
	argrumer CHAR(5), 
	argrupro CHAR(5), 
	armagpre CHAR(5), 
	armolsup NUMERIC(18,4), 
	armoltip NUMERIC(18,4), 
	arnomenc CHAR(8), 
	aroperat CHAR(1), 
	arpeslo2 NUMERIC(18,4), 
	arpeslor NUMERIC(18,4), 
	arpesne2 NUMERIC(18,4), 
	arpesnet NUMERIC(18,4), 
	arpropre CHAR(1), 
	arpubweb CHAR(1), 
	arpuntov CHAR(10), 
	arpzcon2 NUMERIC(18,4), 
	arpzconf NUMERIC(18,4), 
	arstacod CHAR(1), 
	arstasup CHAR(1), 
	artipart CHAR(2), 
	artipbar CHAR(1), 
	artipco1 CHAR(5), 
	artipco2 CHAR(5), 
	artipges CHAR(1), 
	artipma1 CHAR(5), 
	artipma2 CHAR(5), 
	artippre CHAR(1), 
	artipser CHAR(1), 
	artpcon2 CHAR(3), 
	artpconf CHAR(3), 
	arumdim2 CHAR(3), 
	arumdime CHAR(3), 
	arumsupp CHAR(3), 
	arumvol2 CHAR(3), 
	arumvolu CHAR(3), 
	arunmis1 CHAR(3), 
	arunmis2 CHAR(3), 
	arversione CHAR(20), 
	arvoccen CHAR(15), 
	arvocric CHAR(15), 
	utcc NUMERIC(18,4), 
	utcv NUMERIC(18,4), 
	utdc CHAR(8), 
	utdv CHAR(8)) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40bar00f')) THEN

	CREATE TABLE y40_y40bar00f (
	ca__tipo CHAR(1), 
	caclipj CHAR(8), 
	cacocol3 NUMERIC(18,4), 
	cacodart CHAR(20), 
	cacodcon CHAR(15), 
	cacodice CHAR(20), 
	cacodvar CHAR(20), 
	cadesart CHAR(40), 
	cadessup CHAR(10), 
	cadesvo3 CHAR(15), 
	cadimal3 NUMERIC(18,4), 
	cadimla3 NUMERIC(18,4), 
	cadimlu3 NUMERIC(18,4), 
	cadtinva CHAR(8), 
	cadtobso CHAR(8), 
	caflcon3 CHAR(1), 
	caflstam CHAR(1), 
	camoltip NUMERIC(18,4), 
	caoperat CHAR(1), 
	capeslo3 NUMERIC(18,4), 
	capesne3 NUMERIC(18,4), 
	capuntov CHAR(10), 
	capzcon3 NUMERIC(18,4), 
	catipbar CHAR(1), 
	catipco3 CHAR(5), 
	catipcon CHAR(1), 
	catipma3 CHAR(5), 
	catpcon3 CHAR(3), 
	caumdim3 CHAR(3), 
	caumvol3 CHAR(3), 
	caunimis CHAR(3), 
	caversione CHAR(20), 
	utcc NUMERIC(18,4), 
	utcv NUMERIC(18,4), 
	utdc CHAR(8), 
	utdv CHAR(8)) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40lis00f')) THEN
	
	CREATE TABLE y40_y40lis00f (
	lsclipj CHAR(8), 
	lscodlis CHAR(5), 
	lsdeslis CHAR(40), 
	lsdtinva CHAR(8), 
	lsdtobso CHAR(8), 
	lsflscon CHAR(1), 
	lsivalis CHAR(1), 
	lspuntov CHAR(10), 
	lsquanti CHAR(1), 
	lsvallis CHAR(3), 
	lsversione CHAR(20), 
	utcc NUMERIC(18,4), 
	utcv NUMERIC(18,4), 
	utdc CHAR(8), 
	utdv CHAR(8)) ;
end if;	


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40lid00f')) THEN

	CREATE TABLE y40_y40lid00f (
	cprownum NUMERIC(18,4), 
	liclipj CHAR(8), 
	licodart CHAR(20), 
	licodlis CHAR(5), 
	lidatatt CHAR(8), 
	lidatdis CHAR(8), 
	lipuntov CHAR(10), 
	liversione CHAR(20)) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40scq00f')) THEN

	CREATE TABLE y40_y40scq00f (
	liclipj CHAR(8), 
	licodart CHAR(20), 
	liprezzo NUMERIC(18,4), 
	lipuntov CHAR(10), 
	liquanti NUMERIC(18,4), 
	lirownum NUMERIC(18,4), 
	liscont1 NUMERIC(18,4), 
	liscont2 NUMERIC(18,4), 
	liscont3 NUMERIC(18,4), 
	liscont4 NUMERIC(18,4), 
	liversione CHAR(20)) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40mmt00f')) THEN

	CREATE TABLE y40_y40mmt00f (
	mmalfdoc CHAR(2), 
	mmcaoval NUMERIC(18,4), 
	mmclipj CHAR(8), 
	mmcodcon CHAR(15), 
	mmcodese CHAR(4), 
	mmcodute NUMERIC(18,4), 
	mmcodval CHAR(3), 
	mmdatdoc CHAR(8), 
	mmdatreg CHAR(8), 
	mmdessup CHAR(40), 
	mmflclfr CHAR(1), 
	mmflgiom CHAR(1), 
	mmflrett CHAR(1), 
	mmnumdoc NUMERIC(18,4), 
	mmnumreg NUMERIC(18,4), 
	mmpuntov CHAR(10), 
	mmrifpro CHAR(11), 
	mmscocl1 NUMERIC(18,4), 
	mmscocl2 NUMERIC(18,4), 
	mmscopag NUMERIC(18,4), 
	mmserial CHAR(10), 
	mmserpos CHAR(10), 
	mmtcamag CHAR(5), 
	mmtcolis CHAR(5), 
	mmtipcon CHAR(1), 
	mmvalnaz CHAR(3), 
	mmversione CHAR(20), 
	utcc NUMERIC(18,4), 
	utcv NUMERIC(18,4), 
	utdc CHAR(8), 
	utdv CHAR(8)) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'y40_y40mmd00f')) THEN

	CREATE TABLE y40_y40mmd00f (
	cprownum NUMERIC(18,4), 
	cproword NUMERIC(18,4), 
	mmcaucol CHAR(5), 
	mmcaumag CHAR(5), 
	mmclipj CHAR(8), 
	mmcodart CHAR(20), 
	mmcodatt CHAR(15), 
	mmcodcom CHAR(15), 
	mmcodcos CHAR(5), 
	mmcodice CHAR(20), 
	mmcodlis CHAR(5), 
	mmcodlot CHAR(20), 
	mmcodmag CHAR(5), 
	mmcodmat CHAR(5), 
	mmcodub2 CHAR(20), 
	mmcodubi CHAR(20), 
	mmf2casc CHAR(1), 
	mmf2impe CHAR(1), 
	mmf2lott CHAR(1), 
	mmf2ordi CHAR(1), 
	mmf2rise CHAR(1), 
	mmflcasc CHAR(1), 
	mmflcoco CHAR(1), 
	mmflelgm CHAR(1), 
	mmflimpe CHAR(1), 
	mmfllott CHAR(1), 
	mmflomag CHAR(1), 
	mmflorco CHAR(1), 
	mmflordi CHAR(1), 
	mmflrise CHAR(1), 
	mmflulca CHAR(1), 
	mmflulpv CHAR(1), 
	mmimpcom NUMERIC(18,4), 
	mmimpnaz NUMERIC(18,4), 
	mmkeysal CHAR(20), 
	mmnumrif NUMERIC(18,4), 
	mmprezzo NUMERIC(18,4), 
	mmpuntov CHAR(10), 
	mmqtamov NUMERIC(18,4), 
	mmqtaum1 NUMERIC(18,4), 
	mmscont1 NUMERIC(18,4), 
	mmscont2 NUMERIC(18,4), 
	mmscont3 NUMERIC(18,4), 
	mmscont4 NUMERIC(18,4), 
	mmserial CHAR(10), 
	mmtipatt CHAR(1), 
	mmunimis CHAR(3), 
	mmvalmag NUMERIC(18,4), 
	mmvalult NUMERIC(18,4), 
	mmversione CHAR(20)) ;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'path_ama' )) THEN 
	alter table pers_par_sistema add path_ama char(255);
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'lis_parametri'
        AND      CNAME = 'cod_acq' )) THEN 
	alter table lis_parametri add cod_acq char(30);
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'lis_parametri'
        AND      CNAME = 'cod_ven' )) THEN 
	alter table lis_parametri add cod_ven char(30);
end if;
////////////////////////////////


//ESENZIONE

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'esenzione')) THEN

	CREATE TABLE "dba"."esenzione" ("id_esenzione" integer NOT NULL DEFAULT autoincrement, 
	"id_sog_commerciale" integer NOT NULL DEFAULT NULL, 
	"id_tab_iva" integer NOT NULL DEFAULT NULL, 
	"data_inizio_val" date NOT NULL DEFAULT NULL, 
	"data_fine_val" date DEFAULT NULL, 
	"es_num_ns_prot_documenti" char(10) DEFAULT NULL, 
	"es_data_ns_prot_documenti" date DEFAULT NULL, 
	"es_num_lr_prot_documenti" char(10) DEFAULT NULL, 
	"es_data_lr_prot_documenti" date DEFAULT NULL, 
	"es_uff_iva" char(40) DEFAULT NULL , PRIMARY KEY ("id_esenzione") , 
	FOREIGN KEY "fk_esenzione_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE CASCADE , 
	FOREIGN KEY "fk_esenzione_2" ("id_tab_iva" ) REFERENCES "dba"."tab_iva" ON DELETE CASCADE ) ;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'sconto_etichetta' )) THEN 
	alter table pers_par_sistema add sconto_etichetta char(1);
end if;

///////////////PARIGI WinCE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'conftx'
        AND      CNAME = 'numero' )) THEN 
	alter table conftx add numero char(6);
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'conftx'
        AND      CNAME = 'data_ord' )) THEN 
	alter table conftx add data_ord char(6);
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'conftx'
        AND      CNAME = 'rag_soc' )) THEN 
	alter table conftx add rag_soc char(30);
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'UTENTI'
        AND      CNAME = 'limitazione_vis_acq' )) THEN 
	ALTER TABLE UTENTI ADD limitazione_vis_acq char(1) DEFAULT 'N';
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_sis_doc_semp')) THEN
	CREATE TABLE "dba"."par_sis_doc_semp" 
	("id_par_sis_doc_semp" INTEGER NOT NULL DEFAULT autoincrement, 
	"focus_avvio" char(1) DEFAULT NULL, "dopo_qta" char(1) DEFAULT NULL, 
	"t_arrotonda" char(1) DEFAULT NULL, "somma_art" char(1) DEFAULT NULL, 
	"sound_ok" char(256) DEFAULT NULL, "sound_er" char(256) DEFAULT NULL, 
	"mostra_lis_vendita" char(1) DEFAULT NULL, 
	"id_listino_ven" integer DEFAULT NULL , PRIMARY KEY ("id_par_sis_doc_semp")) ;
END IF;

////CODICE BARRE VARIANTI

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSCOLUMNS WHERE TNAME='cod_barre' AND CNAME='id_art_var1' )) THEN 
	alter table cod_barre add "id_art_var1" integer DEFAULT NULL;
	alter table cod_barre add "id_art_var2" integer DEFAULT NULL;
	alter table cod_barre add "id_art_var3" integer DEFAULT NULL;
	alter table cod_barre add "pk_codice" char(20) null DEFAULT NULL;
	update cod_barre set pk_codice='N@N@N';
	alter table cod_barre modify "pk_codice" char(20) not null DEFAULT NULL;
	
	CREATE TRIGGER "t_cod_barre_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."cod_barre"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
	CREATE TRIGGER "t_cod_barre_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."cod_barre"
	referencing new as new_con
	for each row
	begin
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
	    if new_con.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_con.id_art_var1)
	    end if;
	    if new_con.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_con.id_art_var2)
	    end if;
	    if new_con.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_con.id_art_var3)
	    end if;
		SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	end;
	
	
end if;

IF NOT(EXISTS
   (SELECT 1 FROM  SYS.SYSCOLUMNS WHERE TNAME='par_sis_doc_semp' AND CNAME='lis_ivato' )) THEN 
    ALTER TABLE par_sis_doc_semp add "lis_ivato" char(1) DEFAULT 'N';
end if;


///////////////////Blocco su campo qta documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'qta_su_riga' )) THEN 
	alter table prof_documento add qta_su_riga char(1);
end if;
////////////////////////////////////////////////


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'dett_storico_sconti'
        AND      CNAME = 'id_riga_doc_provenienza' )) THEN 
	alter table dett_storico_sconti add id_riga_doc_provenienza integer;

	update storico_sconti s, dett_storico_sconti t, documento d, riga_documento r
	//select d.id_documento, s.id_documento, r.id_riga_doc_provenienza
	//from storico_sconti s, dett_storico_sconti t, documento d, riga_documento r
	set t.id_riga_doc_provenienza=r.id_riga_doc_provenienza
	where t.id_storico_sconti=s.id_storico_sconti
	and d.id_documento=s.id_documento
	and r.id_documento=d.id_documento
	and r.num_riga=t.num_riga;
end if;

////////////////Aumento descrizione Cat_zona a 120 car.
IF (EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cat_zona'
        AND      CNAME = 'descrizione' )) THEN 
	alter table cat_zona modify descrizione char(120);
end if;

call fn_ins_voce_menu('Altre Stampe Contabili', 'w_partitario_multiconto_ff', 'Partitario Multiconto', 201);

//Sansone - Commesse
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_anag_costi'
        AND      CNAME = 'sospeso' )) THEN 
        alter table com_anag_costi add "sospeso" char(1) DEFAULT NULL;          
end if;

//Parigi - Lettore Palmare
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'ordpartx'
        AND      CNAME = 'giac' )) THEN 
        alter table ordpartx add "giac" char(6) DEFAULT NULL;          
end if;


//correzione senatori

ALTER FUNCTION "DBA"."fn_ultimo_acquisto"(in @id_art integer,in @id_v1 integer,in @id_v2 integer,in @id_v3 integer, in @id_fo integer)
returns char(60)
/*
Recupero l''Ultimo Acquisto
Argomenti input:
. ID Articolo   (Obbligatorio)
. ID Varianti
. ID Fornitore  (Obbligatorio)
. ID Valuta     (Obbligatorio) - Se 0 il Costo viene mantenuto nella Valuta indicata nella Riga documento.
*/

begin
  declare @id_doc integer;
  declare @id_riga integer;
  declare @id_var1 integer;
  declare @rd_pz decimal(20,6);
  declare @ri_pz integer;
  declare @rs_sc char(40);
  declare @rs_pz char(40);
  declare @rs_test char(40);
  declare @ls_ret char(60);
  declare @rd_data date;
  declare @rn_num integer;
  declare @rs_v1 char;
  //
  //
  Select max(id_riga_documento) into @id_riga from riga_documento r, documento d, registro t
  where d.id_documento=r.id_documento and d.id_registro=t.id_registro and t.tipo_registro='OA'
  and d.id_sog_commerciale=@id_fo and r.id_articolo=@id_art 
  //and (r.id_art_var1=@id_v1 or @id_v1 is null)
  //and (r.id_art_var2=@id_v2 or @id_v2 is null)
  //and (r.id_art_var3=@id_v3 or @id_v3 is null)
  ;

  if sqlcode<>0 then
     return 'Nessun Acquisto'
  else
     Select d.data_registrazione, d.num_progressivo, r.id_art_var1, r.prezzo, r.sconto
     into @rd_data, @rn_num, @id_var1, @rd_pz, @rs_sc from documento d, riga_documento r 
     where r.id_documento=d.id_documento and r.id_riga_documento=@id_riga;
     set @ri_pz=truncnum(@rd_pz,0);
     message string(@ri_pz);
     set @rd_pz=@rd_pz - @ri_pz;
     set @rs_pz=string(@ri_pz) +','+ string(right(@rd_pz,6));
     message string(@rd_pz);
     if sqlcode<>0 then
        return 'Nessun Acquisto'
     else
        Select cod_var1 into @rs_v1 from art_var1 where id_art_var1=@id_var1;
        if @rs_v1 is null then 
           set @rs_v1=''
        end if;
        set @ls_ret=REPEAT(' ',10-LENGTH(@rs_v1))+@rs_v1;
        set @rs_test=isnull(string(@rn_num),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(string(@rd_data),' ');
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(@rs_test))+@rs_test;
        set @rs_test=isnull(@rs_pz,' ');
        set @ls_ret=@ls_ret + REPEAT(' ',20-LENGTH(@rs_test))+@rs_test;
        set @ls_ret=@ls_ret + REPEAT(' ',10-LENGTH(isnull(@rs_sc,' ')))+isnull(@rs_sc,' ');
        message string(@ls_ret);
     end if;
  end if;

  return @ls_ret;

end;


//////////////////////////////////////////
/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_008' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_008','Release 2_01_008  Cometa','S')
        ;

END IF
;
