//INIZIO 2_01_009


///variazione tabella percentuale ricarico listini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'perc_ric_listini'
        AND      CNAME = 'id_cat_merceologica' )) THEN 
	ALTER TABLE perc_ric_listini ADD id_cat_merceologica integer DEFAULT NULL;
end if;

ALTER TRIGGER "t_perc_ric_listini_bu".t_perc_ric_listini_bu before update order 2
	on "DBA".perc_ric_listini
	referencing old as deleted new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
end;


ALTER TRIGGER "t_perc_ric_listini_bi".t_perc_ric_listini_bi before insert order 1
	on "DBA".perc_ric_listini
	referencing new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_con_listino(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,null,null,null,null,null,null,null,null)) as decimal(18))
	  end if
end;


///variazione tabella percentuale ricarico listini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'banca_azienda'
        AND      CNAME = 'iban_nazione' )) THEN 

	alter table banca_azienda
	add iban_nazione char(2);
	alter table banca_azienda
	add iban_contr_internazionale char(2);

	alter table banca_sog_commerciale
	add iban_nazione char(2);
	alter table banca_sog_commerciale
	add iban_contr_internazionale char(2);

end if;

//Visualizzazione Giacenza in base all'utente nella Doc. Semp.
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'visgiac' )) THEN 
        
				ALTER TABLE utenti ADD visgiac char(1) DEFAULT NULL;

end if;

//Par. Sistema PARIGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'parigi_par_sistema'
        AND      CNAME = 'id_prof_outlet' )) THEN 
        
				ALTER TABLE parigi_par_sistema ADD id_prof_outlet integer DEFAULT NULL;

end if;


call fn_ins_voce_menu('Articoli', 'w_articolo_ins_vel_cx', 'Inserimento Veloce Articoli', 139);


///Par sis touch screen

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_sis_touch')) THEN

	CREATE TABLE "dba"."par_sis_touch" ("id_par_sis_touch" integer NOT NULL DEFAULT autoincrement, 
				    "id_prof_da" integer NOT NULL DEFAULT NULL, 
                                    "id_sog_da" integer NOT NULL DEFAULT NULL, 
                                    "id_list_da" integer NOT NULL DEFAULT NULL , PRIMARY KEY ("id_par_sis_touch")) ;
end if;


call fn_ins_voce_menu('Impostazioni','w_touch_par_sis_ff','Parametri Touch Screen',3);


//funzione SENATORI
IF NOT(EXISTS(
	SELECT 1 FROM   SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_par_esidisp_var')) THEN

CREATE FUNCTION "DBA"."fn_par_esidisp_var"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer,in @ai_id_prof_documento integer,in @id_v1 integer,in @id_v2 integer,in @id_v3 integer)
returns char(60)
/*
Elisa M.            22/11/2001          BL#17248#

Il calcolo delle esistenze e della disponibilit  parametrico in base al profilo documento.
*/
begin
  declare @ls_cal_giac_costi char(1);
  declare @ls_return char(60);
  declare @ls_var1 long varchar;
  declare @ls_var2 long varchar;
  declare @ls_var3 long varchar;
  declare @ls_pk long varchar;

  if @id_v1 is null then 
     set @ls_var1='N'
  else
     set @ls_var1=string(@id_v1)
  end if;
  if @id_v2 is null then 
     set @ls_var2='N'
  else
     set @ls_var2=string(@id_v2)
  end if;
  if @id_v3 is null then 
     set @ls_var3='N'
  else
     set @ls_var3=string(@id_v3)
  end if;
  SET @ls_pk=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

  //
  message 'fn_par_esidisp';
  select cal_giac_costi into @ls_cal_giac_costi
    from prof_documento
    where id_prof_documento=@ai_id_prof_documento;
  //
  message '@ls_cal_giac_costi:'+@ls_cal_giac_costi;
  if(@ls_cal_giac_costi='S') then
    if (@ls_pk='N@N@N') then
       set @ls_return=cast(fn_esi_disp(@id_azienda,@id_articolo,@id_magazzino,@anno,@mese,@ai_id_prof_documento) as char(60));
    else
       set @ls_return=cast(fn_esi_disp_var(@id_azienda,@id_articolo,@id_magazzino,@anno,@mese,@ai_id_prof_documento,@ls_pk) as char(60));
    end if;
    message '@ls_return:'+@ls_return;
    message 'length(@ls_return):'+string(length(@ls_return));
    message 'SUBSTR(@ls_return, 1, 22):'+SUBSTR(@ls_return,1,22)
  else
    set @ls_return=REPEAT(' ',60)
  end if
  ;
  return(@ls_return)
end;


END IF;



IF NOT(EXISTS(
	SELECT 1 FROM   SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_esi_disp_var')) THEN


CREATE FUNCTION "DBA"."fn_esi_disp_var"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer,in @id_prof_documento integer, @ls_pk long varchar)
returns char(60)
begin
  /*
  Elisa Moneti
  18/03/1999

  Calcolo:
  .     "Esistenza fisica" in base ai parametri di esistenza specificati
  nella tabella PAR_ESISTENZA.
  .     "Esistenza Fiscale" (Carichi - Scarichi)
  .     "Disponibilit-" in base ai parametri di disponibilita specificati

  Argomenti input:
  . ID Azienda  (Obbligatorio)
  . ID Articolo (Obbligatorio)
  . ID Magazzino        
  . Anno                        (Obbligatorio)
  . Mese                        (Obbligatorio)

  Valore di ritorno:
  . 1 - 20    carattere --> Esistenza Fisica
  . 21 - 40 carattere --> Esistenza Fiscale
  . 41 - 60 carattere --> Disponibilit-


  Elisa Moneti          17/05/1999
  Modifica: La condizione di ricerca in RIEPILOGO relativa ad anno e mese:
  . fino all'anno specificato
  . solamente per l'anno specificato, fino al mese specificato.
  all''anno specificato 
  */
  declare @car_fiscali char(1);
  declare @sca_fiscali char(1);
  declare @ord_clienti char(1);
  declare @ord_fornitori char(1);
  declare @vis_clienti char(1);
  declare @vis_fornitori char(1);
  declare @imp_produzione char(1);
  declare @ord_produzione char(1);
  declare @cl_clienti char(1);
  declare @cl_fornitori char(1);
  declare @gr_lib_1 char(1);
  declare @gr_lib_2 char(1);
  declare @gr_lib_3 char(1);
  declare @gr_lib_4 char(1);
  /*    Calcolo Esistenza Fisica */
  declare @li_car_fiscali integer;
  declare @li_sca_fiscali integer;
  declare @li_ord_clienti integer;
  declare @li_ord_fornitori integer;
  declare @li_vis_clienti integer;
  declare @li_vis_fornitori integer;
  declare @li_imp_produzione integer;
  declare @li_ord_produzione integer;
  declare @li_cl_clienti integer;
  declare @li_cl_fornitori integer;
  declare @li_gr_lib_1 integer;
  declare @li_gr_lib_2 integer;
  declare @li_gr_lib_3 integer;
  declare @li_gr_lib_4 integer;
  /* Calcolo Disponibilit- */
  declare @li_car_fiscali_d integer;
  declare @li_sca_fiscali_d integer;
  declare @li_ord_clienti_d integer;
  declare @li_ord_fornitori_d integer;
  declare @li_vis_clienti_d integer;
  declare @li_vis_fornitori_d integer;
  declare @li_imp_produzione_d integer;
  declare @li_ord_produzione_d integer;
  declare @li_cl_clienti_d integer;
  declare @li_cl_fornitori_d integer;
  declare @li_gr_lib_1_d integer;
  declare @li_gr_lib_2_d integer;
  declare @li_gr_lib_3_d integer;
  declare @li_gr_lib_4_d integer;
  declare @li_RowCount integer;
  /* Valori di ritorno */
  declare @lf_esi_fisica float(4);
  declare @ls_esi_fisica char(20);
  declare @lf_esi_fiscale float(4);
  declare @ls_esi_fiscale char(20);
  declare @lf_disponibilita float(4);
  declare @ls_disponibilita char(20);
  declare @ls_return char(60);
  declare @ls_tipo_mov char(1);
  /* 
  Recupero i parametri di esistenza
  */
  select par_esistenza.car_fiscali,
    par_esistenza.sca_fiscali,
    par_esistenza.ord_clienti,
    par_esistenza.ord_fornitori,
    par_esistenza.vis_clienti,
    par_esistenza.vis_fornitori,
    par_esistenza.imp_produzione,
    par_esistenza.ord_produzione,
    par_esistenza.cl_clienti,
    par_esistenza.cl_fornitori,
    par_esistenza.gr_lib_1,
    par_esistenza.gr_lib_2,
    par_esistenza.gr_lib_3,
    par_esistenza.gr_lib_4 into @car_fiscali,
    @sca_fiscali,@ord_clienti,@ord_fornitori,@vis_clienti,
    @vis_clienti,@imp_produzione,@ord_produzione,@cl_clienti,@cl_fornitori,
    @gr_lib_1,@gr_lib_2,@gr_lib_3,
    @gr_lib_4 from par_esistenza;
  //Carichi fiscali
  if not(@car_fiscali is null) then
    if @car_fiscali='+' then
      set @li_car_fiscali=1
    else
      set @li_car_fiscali=-1
    end if
  else
    set @li_car_fiscali=0
  end if
  ;
  // Scarichi fiscali
  if not(@sca_fiscali is null) then
    if @sca_fiscali='+' then
      set @li_sca_fiscali=1
    else
      set @li_sca_fiscali=-1
    end if
  else
    set @li_sca_fiscali=0
  end if
  ;
  // Ordinato Clienti
  if not(@ord_clienti is null) then
    if @ord_clienti='+' then
      set @li_ord_clienti=1
    else
      set @li_ord_clienti=-1
    end if
  else
    set @li_ord_clienti=0
  end if
  ;
  // ordinato fornitori
  if not(@ord_fornitori is null) then
    if @ord_fornitori='+' then
      set @li_ord_fornitori=1
    else
      set @li_ord_fornitori=-1
    end if
  else
    set @li_ord_fornitori=0
  end if
  ;
  // Visione Clienti
  if not(@vis_clienti is null) then
    if @vis_clienti='+' then
      set @li_vis_clienti=1
    else
      set @li_vis_clienti=-1
    end if
  else
    set @li_vis_clienti=0
  end if
  ;
  // Visione Fornitori
  if not(@vis_fornitori is null) then
    if @vis_fornitori='+' then
      set @li_vis_fornitori=1
    else
      set @li_vis_fornitori=-1
    end if
  else
    set @li_vis_fornitori=0
  end if
  ;
  // Impegnato Produzione
  if not(@imp_produzione is null) then
    if @imp_produzione='+' then
      set @li_imp_produzione=1
    else
      set @li_imp_produzione=-1
    end if
  else
    set @li_imp_produzione=0
  end if
  ;
  // Ordinato Produzione
  if not(@ord_produzione is null) then
    if @ord_produzione='+' then
      set @li_ord_produzione=1
    else
      set @li_ord_produzione=-1
    end if
  else
    set @li_ord_produzione=0
  end if
  ;
  // Conto Lavorazione Clienti
  if not(@cl_clienti is null) then
    if @cl_clienti='+' then
      set @li_cl_clienti=1
    else
      set @li_cl_clienti=-1
    end if
  else
    set @li_cl_clienti=0
  end if
  ;
  // Conto Lavorazione Fornitori
  if not(@cl_fornitori is null) then
    if @cl_fornitori='+' then
      set @li_cl_fornitori=1
    else
      set @li_cl_fornitori=-1
    end if
  else
    set @li_cl_fornitori=0
  end if
  ;
  // Gruppo Libero 1
  if not(@gr_lib_1 is null) then
    if @gr_lib_1='+' then
      set @li_gr_lib_1=1
    else
      set @li_gr_lib_1=-1
    end if
  else
    set @li_gr_lib_1=0
  end if
  ;
  // Gruppo Libero 2
  if not(@gr_lib_2 is null) then
    if @gr_lib_2='+' then
      set @li_gr_lib_2=1
    else
      set @li_gr_lib_2=-1
    end if
  else
    set @li_gr_lib_2=0
  end if
  ;
  // Gruppo Libero 3
  if not(@gr_lib_3 is null) then
    if @gr_lib_3='+' then
      set @li_gr_lib_3=1
    else
      set @li_gr_lib_3=-1
    end if
  else
    set @li_gr_lib_3=0
  end if
  ;
  // Gruppo Libero 4
  if not(@gr_lib_4 is null) then
    if @gr_lib_4='+' then
      set @li_gr_lib_4=1
    else
      set @li_gr_lib_4=-1
    end if
  else
    set @li_gr_lib_4=0
  end if
  ;
  /* 
  Recupero i parametri di disponibilita''
  */
  set @li_RowCount=9;
  if(@id_prof_documento>0 and not(@id_prof_documento is null)) then
    select par_disponibilita.car_fiscali,
      par_disponibilita.sca_fiscali,
      par_disponibilita.ord_clienti,
      par_disponibilita.ord_fornitori,
      par_disponibilita.vis_clienti,
      par_disponibilita.vis_fornitori,
      par_disponibilita.imp_produzione,
      par_disponibilita.ord_produzione,
      par_disponibilita.cl_clienti,
      par_disponibilita.cl_fornitori,
      par_disponibilita.gr_lib_1,
      par_disponibilita.gr_lib_2,
      par_disponibilita.gr_lib_3,
      par_disponibilita.gr_lib_4 into @car_fiscali,
      @sca_fiscali,@ord_clienti,
      @ord_fornitori,@vis_clienti,@vis_fornitori,@imp_produzione,
      @ord_produzione,@cl_clienti,@cl_fornitori,@gr_lib_1,
      @gr_lib_2,@gr_lib_3,
      @gr_lib_4 from par_disponibilita
      where id_prof_documento=@id_prof_documento;
    set @li_RowCount=@@RowCount
  end if
  ;
  if(@id_prof_documento=0 or @id_prof_documento is null or @li_RowCount=0) then
    select par_disponibilita.car_fiscali,
      par_disponibilita.sca_fiscali,
      par_disponibilita.ord_clienti,
      par_disponibilita.ord_fornitori,
      par_disponibilita.vis_clienti,
      par_disponibilita.vis_fornitori,
      par_disponibilita.imp_produzione,
      par_disponibilita.ord_produzione,
      par_disponibilita.cl_clienti,
      par_disponibilita.cl_fornitori,
      par_disponibilita.gr_lib_1,
      par_disponibilita.gr_lib_2,
      par_disponibilita.gr_lib_3,
      par_disponibilita.gr_lib_4 into @car_fiscali,
      @sca_fiscali,@ord_clienti,
      @ord_fornitori,@vis_clienti,@vis_fornitori,@imp_produzione,
      @ord_produzione,@cl_clienti,@cl_fornitori,@gr_lib_1,
      @gr_lib_2,@gr_lib_3,
      @gr_lib_4 from par_disponibilita
      where id_prof_documento is null
  end if
  ;
  //
  if not(@car_fiscali is null) then
    if @car_fiscali='+' then
      set @li_car_fiscali_d=1
    else
      set @li_car_fiscali_d=-1
    end if
  else
    set @li_car_fiscali_d=0
  end if
  ;
  if not(@sca_fiscali is null) then
    if @sca_fiscali='+' then
      set @li_sca_fiscali_d=1
    else
      set @li_sca_fiscali_d=-1
    end if
  else
    set @li_sca_fiscali_d=0
  end if
  ;
  if not(@ord_clienti is null) then
    if @ord_clienti='+' then
      set @li_ord_clienti_d=1
    else
      set @li_ord_clienti_d=-1
    end if
  else
    set @li_ord_clienti_d=0
  end if
  ;
  if not(@ord_fornitori is null) then
    if @ord_fornitori='+' then
      set @li_ord_fornitori_d=1
    else
      set @li_ord_fornitori_d=-1
    end if
  else
    set @li_ord_fornitori_d=0
  end if
  ;
  if not(@vis_clienti is null) then
    if @vis_clienti='+' then
      set @li_vis_clienti_d=1
    else
      set @li_vis_clienti_d=-1
    end if
  else
    set @li_vis_clienti_d=0
  end if
  ;
  if not(@vis_fornitori is null) then
    if @vis_fornitori='+' then
      set @li_vis_fornitori_d=1
    else
      set @li_vis_fornitori_d=-1
    end if
  else
    set @li_vis_fornitori_d=0
  end if
  ;
  if not(@imp_produzione is null) then
    if @imp_produzione='+' then
      set @li_imp_produzione_d=1
    else
      set @li_imp_produzione_d=-1
    end if
  else
    set @li_imp_produzione_d=0
  end if
  ;
  if not(@ord_produzione is null) then
    if @ord_produzione='+' then
      set @li_ord_produzione_d=1
    else
      set @li_ord_produzione_d=-1
    end if
  else
    set @li_ord_produzione_d=0
  end if
  ;
  if not(@cl_clienti is null) then
    if @cl_clienti='+' then
      set @li_cl_clienti_d=1
    else
      set @li_cl_clienti_d=-1
    end if
  else
    set @li_cl_clienti_d=0
  end if
  ;
  if not(@cl_fornitori is null) then
    if @cl_fornitori='+' then
      set @li_cl_fornitori_d=1
    else
      set @li_cl_fornitori_d=-1
    end if
  else
    set @li_cl_fornitori_d=0
  end if
  ;
  if not(@gr_lib_1 is null) then
    if @gr_lib_1='+' then
      set @li_gr_lib_1_d=1
    else
      set @li_gr_lib_1_d=-1
    end if
  else
    set @li_gr_lib_1_d=0
  end if
  ;
  if not(@gr_lib_2 is null) then
    if @gr_lib_2='+' then
      set @li_gr_lib_2_d=1
    else
      set @li_gr_lib_2_d=-1
    end if
  else
    set @li_gr_lib_2_d=0
  end if
  ;
  if not(@gr_lib_3 is null) then
    if @gr_lib_3='+' then
      set @li_gr_lib_3_d=1
    else
      set @li_gr_lib_3_d=-1
    end if
  else
    set @li_gr_lib_3_d=0
  end if
  ;
  if not(@gr_lib_4 is null) then
    if @gr_lib_4='+' then
      set @li_gr_lib_4_d=1
    else
      set @li_gr_lib_4_d=-1
    end if
  else
    set @li_gr_lib_4_d=0
  end if
  ;
  //
  /* BL#9800#i*/
  select m.tipo into @ls_tipo_mov
    from unita_confezione as u,unita_misura as m
    where u.id_articolo=@id_articolo
    and u.unita_base='S'
    and m.id_unita_misura=u.id_unita_misura;
  //
  /* Se l''articolo  movimentato a peso, calcolo i valori di magazzino a */
  if(@ls_tipo_mov='P') then
    if @id_magazzino is null or @id_magazzino=0 then
      /* 
      Calcolo l''Esistenza Fisica Totale
      */
      select(IfNull((Sum(Riepilogo.peso_Caricato)*@li_car_fiscali),0,Sum(Riepilogo.peso_Caricato)*@li_car_fiscali)
        +IfNull((Sum(Riepilogo.peso_Scaricato)*@li_sca_fiscali),0,Sum(Riepilogo.peso_Scaricato)*@li_sca_fiscali)
        +IfNull((Sum(Riepilogo.peso_Ord_Clienti)*@li_ord_clienti),0,Sum(Riepilogo.peso_Ord_Clienti)*@li_ord_clienti)
        +IfNull((Sum(Riepilogo.peso_Ord_Fornitori)*@li_ord_fornitori),0,Sum(Riepilogo.peso_Ord_Fornitori)*@li_ord_fornitori)
        +IfNull((Sum(Riepilogo.peso_Vis_Clienti)*@li_vis_clienti),0,Sum(Riepilogo.peso_Vis_Clienti)*@li_vis_clienti)
        +IfNull((Sum(Riepilogo.peso_Vis_Fornitori)*@li_vis_fornitori),0,Sum(Riepilogo.peso_Vis_Fornitori)*@li_vis_fornitori)
        +IfNull((Sum(Riepilogo.peso_Imp_Produzione)*@li_imp_produzione),0,Sum(Riepilogo.peso_Imp_Produzione)*@li_imp_produzione)
        +IfNull((Sum(Riepilogo.peso_Ord_Produzione)*@li_ord_produzione),0,Sum(Riepilogo.peso_Ord_Produzione)*@li_ord_produzione)
        +IfNull((Sum(Riepilogo.peso_CL_Clienti)*@li_cl_clienti),0,Sum(Riepilogo.peso_CL_Clienti)*@li_cl_clienti)
        +IfNull((Sum(Riepilogo.peso_CL_Fornitori)*@li_cl_fornitori),0,Sum(Riepilogo.peso_CL_Fornitori)*@li_cl_fornitori)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_1)*@li_gr_lib_1),0,Sum(Riepilogo.peso_Gruppo_Lib_1)*@li_gr_lib_1)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_2)*@li_gr_lib_2),0,Sum(Riepilogo.peso_Gruppo_Lib_2)*@li_gr_lib_2)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_3)*@li_gr_lib_3),0,Sum(Riepilogo.peso_Gruppo_Lib_3)*@li_gr_lib_3)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_4)*@li_gr_lib_4),0,Sum(Riepilogo.peso_Gruppo_Lib_4)*@li_gr_lib_4)),
        IfNull((Sum(Riepilogo.peso_Caricato)),0,Sum(Riepilogo.peso_Caricato))
        -IfNull((Sum(Riepilogo.peso_Scaricato)),0,Sum(Riepilogo.peso_Scaricato)),
        (IfNull((Sum(Riepilogo.peso_Caricato)*@li_car_fiscali_d),0,Sum(Riepilogo.peso_Caricato)*@li_car_fiscali_d)
        +IfNull((Sum(Riepilogo.peso_Scaricato)*@li_sca_fiscali_d),0,Sum(Riepilogo.peso_Scaricato)*@li_sca_fiscali_d)
        +IfNull((Sum(Riepilogo.peso_Ord_Clienti)*@li_ord_clienti_d),0,Sum(Riepilogo.peso_Ord_Clienti)*@li_ord_clienti_d)
        +IfNull((Sum(Riepilogo.peso_Ord_Fornitori)*@li_ord_fornitori_d),0,Sum(Riepilogo.peso_Ord_Fornitori)*@li_ord_fornitori_d)
        +IfNull((Sum(Riepilogo.peso_Vis_Clienti)*@li_vis_clienti_d),0,Sum(Riepilogo.peso_Vis_Clienti)*@li_vis_clienti_d)
        +IfNull((Sum(Riepilogo.peso_Vis_Fornitori)*@li_vis_fornitori_d),0,Sum(Riepilogo.peso_Vis_Fornitori)*@li_vis_fornitori_d)
        +IfNull((Sum(Riepilogo.peso_Imp_Produzione)*@li_imp_produzione_d),0,Sum(Riepilogo.peso_Imp_Produzione)*@li_imp_produzione_d)
        +IfNull((Sum(Riepilogo.peso_Ord_Produzione)*@li_ord_produzione_d),0,Sum(Riepilogo.peso_Ord_Produzione)*@li_ord_produzione_d)
        +IfNull((Sum(Riepilogo.peso_CL_Clienti)*@li_cl_clienti_d),0,Sum(Riepilogo.peso_CL_Clienti)*@li_cl_clienti_d)
        +IfNull((Sum(Riepilogo.peso_CL_Fornitori)*@li_cl_fornitori_d),0,Sum(Riepilogo.peso_CL_Fornitori)*@li_cl_fornitori_d)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_1)*@li_gr_lib_1_d),0,Sum(Riepilogo.peso_Gruppo_Lib_1)*@li_gr_lib_1_d)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_2)*@li_gr_lib_2_d),0,Sum(Riepilogo.peso_Gruppo_Lib_2)*@li_gr_lib_2_d)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_3)*@li_gr_lib_3_d),0,Sum(Riepilogo.peso_Gruppo_Lib_3)*@li_gr_lib_3_d)
        +IfNull((Sum(Riepilogo.peso_Gruppo_Lib_4)*@li_gr_lib_4_d),0,Sum(Riepilogo.peso_Gruppo_Lib_4)*@li_gr_lib_4_d)) into @lf_esi_fisica,
        @lf_esi_fiscale,
        @lf_disponibilita from riepilogo
        where riepilogo.id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
        and riepilogo.id_articolo=@id_articolo and pk_codice=@ls_pk
        and(riepilogo.anno<@anno
        or(riepilogo.anno=@anno
        and riepilogo.mese<=@mese))
    else
      /*
      Calcolo l''Esistenza Fisica di magazzino
      */
      select IfNull((Sum(Riepilogo.Peso_Caricato)*@li_car_fiscali),0,Sum(Riepilogo.Peso_Caricato)*@li_car_fiscali)
        +IfNull((Sum(Riepilogo.Peso_SCaricato)*@li_sca_fiscali),0,Sum(Riepilogo.Peso_SCaricato)*@li_sca_fiscali)
        +IfNull((Sum(Riepilogo.Peso_Ord_Clienti)*@li_ord_clienti),0,Sum(Riepilogo.Peso_Ord_Clienti)*@li_ord_clienti)
        +IfNull((Sum(Riepilogo.Peso_Ord_Fornitori)*@li_ord_fornitori),0,Sum(Riepilogo.Peso_Ord_Fornitori)*@li_ord_fornitori)
        +IfNull((Sum(Riepilogo.Peso_Vis_Clienti)*@li_vis_clienti),0,Sum(Riepilogo.Peso_Vis_Clienti)*@li_vis_clienti)
        +IfNull((Sum(Riepilogo.Peso_Vis_Fornitori)*@li_vis_fornitori),0,Sum(Riepilogo.Peso_Vis_Fornitori)*@li_vis_fornitori)
        +IfNull((Sum(Riepilogo.Peso_Imp_Produzione)*@li_imp_produzione),0,Sum(Riepilogo.Peso_Imp_Produzione)*@li_imp_produzione)
        +IfNull((Sum(Riepilogo.Peso_Ord_Produzione)*@li_ord_produzione),0,Sum(Riepilogo.Peso_Ord_Produzione)*@li_ord_produzione)
        +IfNull((Sum(Riepilogo.Peso_CL_Clienti)*@li_cl_clienti),0,Sum(Riepilogo.Peso_CL_Clienti)*@li_cl_clienti)
        +IfNull((Sum(Riepilogo.Peso_CL_Fornitori)*@li_cl_fornitori),0,Sum(Riepilogo.Peso_CL_Fornitori)*@li_cl_fornitori)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_1)*@li_gr_lib_1),0,Sum(Riepilogo.Peso_Gruppo_Lib_1)*@li_gr_lib_1)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_2)*@li_gr_lib_2),0,Sum(Riepilogo.Peso_Gruppo_Lib_2)*@li_gr_lib_2)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_3)*@li_gr_lib_3),0,Sum(Riepilogo.Peso_Gruppo_Lib_3)*@li_gr_lib_3)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_4)*@li_gr_lib_4),0,Sum(Riepilogo.Peso_Gruppo_Lib_4)*@li_gr_lib_4),
        IfNull((Sum(Riepilogo.Peso_Caricato)),0,Sum(Riepilogo.Peso_Caricato))
        -IfNull((Sum(Riepilogo.Peso_SCaricato)),0,Sum(Riepilogo.Peso_SCaricato)),
        (IfNull((Sum(Riepilogo.Peso_Caricato)*@li_car_fiscali_d),0,Sum(Riepilogo.Peso_Caricato)*@li_car_fiscali_d)
        +IfNull((Sum(Riepilogo.Peso_SCaricato)*@li_sca_fiscali_d),0,Sum(Riepilogo.Peso_SCaricato)*@li_sca_fiscali_d)
        +IfNull((Sum(Riepilogo.Peso_Ord_Clienti)*@li_ord_clienti_d),0,Sum(Riepilogo.Peso_Ord_Clienti)*@li_ord_clienti_d)
        +IfNull((Sum(Riepilogo.Peso_Ord_Fornitori)*@li_ord_fornitori_d),0,Sum(Riepilogo.Peso_Ord_Fornitori)*@li_ord_fornitori_d)
        +IfNull((Sum(Riepilogo.Peso_Vis_Clienti)*@li_vis_clienti_d),0,Sum(Riepilogo.Peso_Vis_Clienti)*@li_vis_clienti_d)
        +IfNull((Sum(Riepilogo.Peso_Vis_Fornitori)*@li_vis_fornitori_d),0,Sum(Riepilogo.Peso_Vis_Fornitori)*@li_vis_fornitori_d)
        +IfNull((Sum(Riepilogo.Peso_Imp_Produzione)*@li_imp_produzione_d),0,Sum(Riepilogo.Peso_Imp_Produzione)*@li_imp_produzione_d)
        +IfNull((Sum(Riepilogo.Peso_Ord_Produzione)*@li_ord_produzione_d),0,Sum(Riepilogo.Peso_Ord_Produzione)*@li_ord_produzione_d)
        +IfNull((Sum(Riepilogo.Peso_CL_Clienti)*@li_cl_clienti_d),0,Sum(Riepilogo.Peso_CL_Clienti)*@li_cl_clienti_d)
        +IfNull((Sum(Riepilogo.Peso_CL_Fornitori)*@li_cl_fornitori_d),0,Sum(Riepilogo.Peso_CL_Fornitori)*@li_cl_fornitori_d)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_1)*@li_gr_lib_1_d),0,Sum(Riepilogo.Peso_Gruppo_Lib_1)*@li_gr_lib_1_d)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_2)*@li_gr_lib_2_d),0,Sum(Riepilogo.Peso_Gruppo_Lib_2)*@li_gr_lib_2_d)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_3)*@li_gr_lib_3_d),0,Sum(Riepilogo.Peso_Gruppo_Lib_3)*@li_gr_lib_3_d)
        +IfNull((Sum(Riepilogo.Peso_Gruppo_Lib_4)*@li_gr_lib_4_d),0,Sum(Riepilogo.Peso_Gruppo_Lib_4)*@li_gr_lib_4_d)) into @lf_esi_fisica,
        @lf_esi_fiscale,
        @lf_disponibilita from riepilogo
        where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
        and id_articolo=@id_articolo and pk_codice=@ls_pk
        and id_locazione=any(select id_locazione from locazione where id_magazzino=@id_magazzino)
        and(riepilogo.anno<@anno
        or(riepilogo.anno=@anno
        and riepilogo.mese<=@mese))
    end if
  else
    if @id_magazzino is null or @id_magazzino=0 then
      select(IfNull((Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali),0,Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali)
        +IfNull((Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali),0,Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali)
        +IfNull((Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti),0,Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti)
        +IfNull((Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori),0,Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti),0,Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti)
        +IfNull((Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori),0,Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione),0,Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione)
        +IfNull((Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione),0,Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione)
        +IfNull((Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti),0,Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti)
        +IfNull((Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori),0,Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1),0,Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2),0,Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3),0,Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4),0,Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4)),
        IfNull((Sum(Riepilogo.Qta_Caricata)),0,Sum(Riepilogo.Qta_Caricata))
        -IfNull((Sum(Riepilogo.Qta_Scaricata)),0,Sum(Riepilogo.Qta_Scaricata)),
        (IfNull((Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali_d),0,Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali_d)
        +IfNull((Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali_d),0,Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti_d),0,Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori_d),0,Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti_d),0,Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori_d),0,Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione_d),0,Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione_d),0,Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione_d)
        +IfNull((Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti_d),0,Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori_d),0,Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4_d)) into @lf_esi_fisica,
        @lf_esi_fiscale,
        @lf_disponibilita from riepilogo
        where riepilogo.id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
        and riepilogo.id_articolo=@id_articolo and pk_codice=@ls_pk
        and(riepilogo.anno<@anno
        or(riepilogo.anno=@anno
        and riepilogo.mese<=@mese))
    else
      //
      /* 
      Calcolo l''Esistenza Fisica di magazzino 
      */
      select IfNull((Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali),0,Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali)
        +IfNull((Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali),0,Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali)
        +IfNull((Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti),0,Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti)
        +IfNull((Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori),0,Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti),0,Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti)
        +IfNull((Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori),0,Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione),0,Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione)
        +IfNull((Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione),0,Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione)
        +IfNull((Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti),0,Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti)
        +IfNull((Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori),0,Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1),0,Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2),0,Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3),0,Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4),0,Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4),
        IfNull((Sum(Riepilogo.Qta_Caricata)),0,Sum(Riepilogo.Qta_Caricata))
        -IfNull((Sum(Riepilogo.Qta_Scaricata)),0,Sum(Riepilogo.Qta_Scaricata)),
        (IfNull((Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali_d),0,Sum(Riepilogo.Qta_Caricata)*@li_car_fiscali_d)
        +IfNull((Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali_d),0,Sum(Riepilogo.Qta_Scaricata)*@li_sca_fiscali_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti_d),0,Sum(Riepilogo.Qta_Ord_Clienti)*@li_ord_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori_d),0,Sum(Riepilogo.Qta_Ord_Fornitori)*@li_ord_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti_d),0,Sum(Riepilogo.Qta_Vis_Clienti)*@li_vis_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori_d),0,Sum(Riepilogo.Qta_Vis_Fornitori)*@li_vis_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione_d),0,Sum(Riepilogo.Qta_Imp_Produzione)*@li_imp_produzione_d)
        +IfNull((Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione_d),0,Sum(Riepilogo.Qta_Ord_Produzione)*@li_ord_produzione_d)
        +IfNull((Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti_d),0,Sum(Riepilogo.Qta_CL_Clienti)*@li_cl_clienti_d)
        +IfNull((Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori_d),0,Sum(Riepilogo.Qta_CL_Fornitori)*@li_cl_fornitori_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_1)*@li_gr_lib_1_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_2)*@li_gr_lib_2_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_3)*@li_gr_lib_3_d)
        +IfNull((Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4_d),0,Sum(Riepilogo.Qta_Gruppo_Lib_4)*@li_gr_lib_4_d)) into @lf_esi_fisica,
        @lf_esi_fiscale,
        @lf_disponibilita from riepilogo
        where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
        and id_articolo=@id_articolo and pk_codice=@ls_pk
        and id_locazione=any(select id_locazione from locazione where id_magazzino=@id_magazzino)
        and(riepilogo.anno<@anno
        or(riepilogo.anno=@anno
        and riepilogo.mese<=@mese))
    end if
  end if
  ;
  /* 
  Costruisco ls stringa di ritorno 
  */
  /* Esistenza Fisica */
  set @ls_esi_fisica=REPEAT(' ',20-LENGTH(STRING(@lf_esi_fisica)))+STRING(@lf_esi_fisica);
  /* Esistenza Fiscale */
  set @ls_esi_fiscale=REPEAT(' ',20-LENGTH(STRING(@lf_esi_fiscale)))+STRING(@lf_esi_fiscale);
  /* Disponibilita'' */
  set @ls_disponibilita=REPEAT(' ',20-LENGTH(STRING(@lf_disponibilita)))+STRING(@lf_disponibilita);
  /*
  message 'lf_esi_fisica:',string(@lf_esi_fisica);
  message 'lf_esi_fiscale',string(@lf_esi_fiscale);
  message 'lf_disponibilita',string(@lf_disponibilita);
  message 'ls_esi_fisica:',@ls_esi_fisica;
  message 'ls_esi_fiscale',@ls_esi_fiscale;
  message 'ls_disponibilita',@ls_disponibilita;
  */
  set @ls_return=@ls_esi_fisica+@ls_esi_fiscale+@ls_disponibilita;
  /*
  message ' RETURN:',@ls_return,' l:';
  message ' LUNGHEZZA RETURN:'+STRING(length(@ls_return));
  */
  return(@ls_return)
end;


end if;

//Gestione Numeratore Univoco per Alterini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'alt_id_registro' )) THEN 
        
				ALTER TABLE pers_par_sistema ADD alt_id_registro integer DEFAULT NULL;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'registro'
        AND      CNAME = 'max_progressivo' )) THEN 
        
	ALTER TABLE registro ADD max_progressivo integer DEFAULT NULL;

end if;


ALTER FUNCTION "DBA"."fn_par_esidisp_var"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer,in @ai_id_prof_documento integer,in @id_v1 integer,in @id_v2 integer,in @id_v3 integer)
returns char(60)
/*
Elisa M.            22/11/2001          BL#17248#

Il calcolo delle esistenze e della disponibilit  parametrico in base al profilo documento.
*/
begin
  declare @ls_cal_giac_costi char(1);
  declare @ls_return char(60);
  declare @ls_var1 long varchar;
  declare @ls_var2 long varchar;
  declare @ls_var3 long varchar;
  declare @ls_pk long varchar;

  if @id_v1 is null then 
     set @ls_var1='N'
  else
     set @ls_var1=string(@id_v1)
  end if;
  if @id_v2 is null then 
     set @ls_var2='N'
  else
     set @ls_var2=string(@id_v2)
  end if;
  if @id_v3 is null then 
     set @ls_var3='N'
  else
     set @ls_var3=string(@id_v3)
  end if;
  SET @ls_pk=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

  //
  select cal_giac_costi into @ls_cal_giac_costi
    from prof_documento
    where id_prof_documento=@ai_id_prof_documento;
  //
  //message '@ls_cal_giac_costi:'+@ls_cal_giac_costi;

  if @ai_id_prof_documento=0 or (@ai_id_prof_documento is null) then
     set @ls_cal_giac_costi='S'
  end if;
  if(@ls_cal_giac_costi='S') then
    if (@ls_pk='N@N@N') then
       message 'PK_novar'+@ls_pk;
       set @ls_return=cast(fn_esi_disp(@id_azienda,@id_articolo,@id_magazzino,@anno,@mese,@ai_id_prof_documento) as char(60));
    else
       message 'PK_var'+@ls_pk;
       set @ls_return=cast(fn_esi_disp_var(@id_azienda,@id_articolo,@id_magazzino,@anno,@mese,@ai_id_prof_documento,@ls_pk) as char(60));
    end if;
//    message '@ls_return:'+@ls_return;
//    message 'length(@ls_return):'+string(length(@ls_return));
//    message 'SUBSTR(@ls_return, 1, 22):'+SUBSTR(@ls_return,1,22)
  else
    message 'semo qui else';
    set @ls_return=REPEAT(' ',60)
  end if
  ;
  return(@ls_return)
end;


ALTER FUNCTION "DBA"."fn_par_esidisp"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer,in @ai_id_prof_documento integer)
returns char(60)
/*
Elisa M.            22/11/2001          BL#17248#

Il calcolo delle esistenze e della disponibilit  parametrico in base al profilo documento.
*/
begin
  declare @ls_cal_giac_costi char(1);
  declare @ls_return char(60);
  //
  message 'fn_par_esidisp';
  select cal_giac_costi into @ls_cal_giac_costi
    from prof_documento
    where id_prof_documento=@ai_id_prof_documento;
  //
  message '@ls_cal_giac_costi:'+@ls_cal_giac_costi;
  if @ai_id_prof_documento=0 or (@ai_id_prof_documento is null) then
     set @ls_cal_giac_costi='S'
  end if;
  if(@ls_cal_giac_costi='S') then
    set @ls_return=cast(fn_esi_disp(@id_azienda,@id_articolo,@id_magazzino,@anno,@mese,@ai_id_prof_documento) as char(60));
    message '@ls_return:'+@ls_return;
    message 'length(@ls_return):'+string(length(@ls_return));
    message 'SUBSTR(@ls_return, 1, 22):'+SUBSTR(@ls_return,1,22)
  else
    set @ls_return=REPEAT(' ',60)
  end if
  ;
  return(@ls_return)
end;

////////////Stored Procedures di utilit per la gestione dei triggers da pb
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_triggers_on') THEN
	
	CREATE PROCEDURE "DBA"."sp_triggers_on"()
	begin							
	   set option fire_triggers = 'ON';
	end;
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_triggers_off') THEN
	
	CREATE PROCEDURE "DBA"."sp_triggers_off"()
	begin							
	   set option fire_triggers = 'OFF';
	end;
end if;

//Tabella contenente tutti gli id delle connessioni al db
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'id_connection')) THEN
        
				CREATE TABLE "dba"."id_connection" ("id_connection" integer NOT NULL DEFAULT NULL) ;
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'load_connections') THEN
        
				CREATE PROCEDURE "DBA"."load_connections"()
				begin
				  declare @loop_status integer;
				  declare @id_conn integer;
				  declare @id_conn_app integer;
				
				  delete from id_connection;
				  commit;
				
				  SELECT connection_property( 'number' ) into @id_conn; //Recupero id connessione corrente
				  SELECT NEXT_CONNECTION( NULL ) into @id_conn_app; //Recupero id prima connessione
				  if (@id_conn <> @id_conn_app) then 
				    insert into id_connection(id_connection)
				    values(@id_conn_app);
				    commit;
				    //DROP CONNECTION @id_conn_app;
				  end if
				;
				  set @loop_status=0;
				  lp1:
				  while(@loop_status=0) loop
				    SELECT NEXT_CONNECTION(@id_conn_app) into @id_conn_app;
				    if (@id_conn_app is null) then 
				        set @loop_status=1
				    else
				       if (@id_conn <> @id_conn_app) then 
				        insert into id_connection(id_connection)
				        values(@id_conn_app);
				        commit;
				        //DROP CONNECTION @id_conn_app;
				      end if       
				    end if
				  end loop lp1
				  ;				  
				end;
end if;				
///////////////////////////////////////////////////////


//Richiesta dati anagrafica
call fn_ins_voce_menu('Anagrafica', 'w_richiesta_dati_anag_cx' , 'Richiesta Dati Anagrafici', 85);


//par sistem trasforma documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'ch_trasf_del' )) THEN 
        
				ALTER TABLE par_sistema ADD ch_trasf_del char(1) DEFAULT NULL;

end if;

///////Causale per righe si storno nei documenti semp. per alterini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'alt_id_caus_neg' )) THEN 
        
				ALTER TABLE pers_par_sistema ADD alt_id_caus_neg integer DEFAULT NULL;

end if;
///////////////////////////////////////////////////////////////////



///SENATORI VAR_CON_LIS_ARTICOLO

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'var_con_lis_articolo')) THEN
 
CREATE TABLE var_con_lis_articolo ("id_var_con_lis_articolo" integer NOT NULL DEFAULT autoincrement, 
"applicazione" char(1) NOT NULL DEFAULT NULL, 
"id_unita_confezione" integer DEFAULT NULL, 
"id_sog_commerciale" integer DEFAULT NULL, 
"id_cat_com_sc" integer DEFAULT NULL, 
"id_articolo" integer NOT NULL DEFAULT NULL, 
"id_art_var1" integer NOT NULL DEFAULT NULL, 
"id_art_var2" integer DEFAULT NULL, 
"id_art_var3" integer DEFAULT NULL, 
"pk_codice" char(20) NOT NULL DEFAULT NULL, 
"id_cat_com_articolo" integer DEFAULT NULL, 
"id_sog_commerciale_fornitore" integer DEFAULT NULL, 
"id_anagrafica" integer DEFAULT NULL, 
"id_listino" integer DEFAULT NULL, 
"data_inizio" date NOT NULL DEFAULT NULL, 
"data_fine" date DEFAULT NULL, 
"qta_minima" numeric(18,4) DEFAULT 0, 
"qta_massima" numeric(18,4) DEFAULT 0, 
"tipo_applicazione" char(1) DEFAULT 'S', 
"id_valuta" integer DEFAULT NULL, 
"cambio" numeric(8,4) DEFAULT NULL, 
"importo" numeric(20,6) DEFAULT NULL, 
"percentuali" char(40) DEFAULT NULL, 
"spesa" char(40) DEFAULT NULL, 
"spesa_fissa" numeric(18,4) DEFAULT NULL, 
"priorita" numeric(14,0) DEFAULT NULL, 
"id_azienda" integer NOT NULL DEFAULT 1, 
"id_destinazione" integer DEFAULT NULL, 
"tras_mezzo" char(1) DEFAULT NULL, 
"id_tipo_trasporto" integer DEFAULT NULL, 
"id_cat_merceologica" integer DEFAULT NULL, 
"stato" char(1) DEFAULT NULL, 
"ultimo_sconto" char(1) DEFAULT NULL, 
"filtra_varianti" char(1) DEFAULT 'N' , 
PRIMARY KEY ("id_var_con_lis_articolo") , 
FOREIGN KEY "fk_var_con_lis_articolo_8" ("id_anagrafica" ) REFERENCES "dba"."anagrafica" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_7" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_5" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_3" ("id_cat_com_articolo" ) REFERENCES "dba"."cat_com_articolo" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_6" ("id_cat_com_sc" ) REFERENCES "dba"."cat_com_sc" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_13" ("id_cat_merceologica" ) REFERENCES "dba"."cat_merceologica" ON DELETE SET NULL , 
FOREIGN KEY "fk_var_con_lis_articolo_9" ("id_destinazione" ) REFERENCES "dba"."destinazione" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_2" ("id_listino" ) REFERENCES "dba"."listino" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_10" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_11" ("id_sog_commerciale_fornitore" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_12" ("id_tipo_trasporto" ) REFERENCES "dba"."tipo_trasporto" ON DELETE CASCADE , 
FOREIGN KEY "fk_var_con_lis_articolo_4" ("id_unita_confezione" ) REFERENCES "dba"."unita_confezione" ON DELETE RESTRICT , 
FOREIGN KEY "fk_var_con_lis_articolo_1" ("id_valuta" ) REFERENCES "dba"."valuta" ON DELETE RESTRICT ) ;



CREATE TRIGGER "t_var_con_lis_articolo_bi".t_var_con_lis_articolo_bi before insert order 1
on "DBA".var_con_lis_articolo
referencing new as inserted
for each row
begin
  /* 
  Elisa M.     20/12/00   BL#10276# 
  Calcolo e assegno la priorita'' della condizione in inserimento del record.
  #BL10277#
  Ho aggiunto la categoria merceologica come parametro.
  */
 declare @li_id_con_lis_articolo integer;
 declare @ls_var1 long varchar;
 declare @ls_var2 long varchar;
 declare @ls_var3 long varchar;
 if inserted.id_art_var1 is null then 
    set @ls_var1='N'
 else
    set @ls_var1=string(inserted.id_art_var1)
 end if;
 if inserted.id_art_var2 is null then 
    set @ls_var2='N'
 else
    set @ls_var2=string(inserted.id_art_var2)
 end if;
 if inserted.id_art_var3 is null then 
    set @ls_var3='N'
 else
    set @ls_var3=string(inserted.id_art_var3)
 end if;
 SET inserted.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

 
  set @li_id_con_lis_articolo=0;
  select id_var_con_lis_articolo into @li_id_con_lis_articolo
    from var_con_lis_articolo
    where ifnull(id_destinazione,0,id_destinazione)=ifnull(inserted.id_destinazione,0,inserted.id_destinazione)
    and ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
    and ifnull(id_unita_confezione,0,id_unita_confezione)=ifnull(inserted.id_unita_confezione,0,inserted.id_unita_confezione)
    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo)
    and ifnull(id_cat_merceologica,0,id_cat_merceologica)=ifnull(inserted.id_cat_merceologica,0,inserted.id_cat_merceologica)
    and ifnull(data_inizio,cast('2999-01-01' as date),data_inizio)=ifnull(inserted.data_inizio,cast('2999-01-01' as date),inserted.data_inizio)
    and ifnull(data_fine,cast('2999-01-01' as date),data_fine)=ifnull(inserted.data_fine,cast('2999-01-01' as date),inserted.data_fine)
    and ifnull(id_sog_commerciale_fornitore,0,id_sog_commerciale_fornitore)=ifnull(inserted.id_sog_commerciale_fornitore,0,inserted.id_sog_commerciale_fornitore)
    and ifnull(id_anagrafica,0,id_anagrafica)=ifnull(inserted.id_anagrafica,0,inserted.id_anagrafica)
    and ifnull(qta_minima,0,qta_minima)=ifnull(inserted.qta_minima,0,inserted.qta_minima)
    and ifnull(qta_massima,0,qta_massima)=ifnull(inserted.qta_massima,0,inserted.qta_massima)
    and ifnull(applicazione,'',applicazione)=ifnull(inserted.applicazione,'',inserted.applicazione)
    and ifnull(tipo_applicazione,'',tipo_applicazione)=ifnull(inserted.tipo_applicazione,'',inserted.tipo_applicazione)
    and ifnull(id_art_var1,'',id_art_var1)=ifnull(inserted.id_art_var1,'',inserted.id_art_var1)
    and ifnull(id_art_var2,'',id_art_var2)=ifnull(inserted.id_art_var2,'',inserted.id_art_var2)
    and ifnull(id_art_var3,'',id_art_var3)=ifnull(inserted.id_art_var3,'',inserted.id_art_var3);
  message 'Condizione di listino: ',@li_id_con_lis_articolo;
  if @li_id_con_lis_articolo>0 then
    message 'Condizione di listino gia'' esistente: ',@li_id_con_lis_articolo,'  ',inserted.id_var_con_lis_articolo;
    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_con_lis_articolo)+'  '+string(inserted.id_var_con_lis_articolo);
    rollback work
  else
    set inserted.priorita=cast((fn_calc_priorita_con_listino(inserted.id_destinazione,inserted.id_sog_commerciale,inserted.id_cat_com_sc,inserted.id_unita_confezione,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,inserted.id_sog_commerciale_fornitore,inserted.id_anagrafica,inserted.data_inizio,inserted.data_fine,inserted.qta_minima,inserted.qta_massima,inserted.tras_mezzo,inserted.id_tipo_trasporto)) as decimal(18))
  end if
end;


CREATE TRIGGER "t_var_con_lis_articolo_bu".t_var_con_lis_articolo_bu before update order 2
on "DBA".var_con_lis_articolo
referencing old as deleted new as inserted
for each row
begin
  /*
  Elisa M.     20/12/00   BL#10276#
  Calcolo e assegno la priorita'' della condizione in modifica.
  #BL10277#
  Ho aggiunto la categoria merceologica come parametro.
  */
  declare @li_id_con_lis_articolo integer;
  declare @ls_var1 long varchar;
  declare @ls_var2 long varchar;
  declare @ls_var3 long varchar;
  if inserted.id_art_var1 is null then 
     set @ls_var1='N'
  else
     set @ls_var1=string(inserted.id_art_var1)
  end if;
  if inserted.id_art_var2 is null then 
      set @ls_var2='N'
  else
      set @ls_var2=string(inserted.id_art_var2)
  end if;
  if inserted.id_art_var3 is null then 
      set @ls_var3='N'
  else
      set @ls_var3=string(inserted.id_art_var3)
  end if;
  SET inserted.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

  set @li_id_con_lis_articolo=0;
  select id_var_con_lis_articolo into @li_id_con_lis_articolo
    from var_con_lis_articolo
    where ifnull(id_destinazione,0,id_destinazione)=ifnull(inserted.id_destinazione,0,inserted.id_destinazione)
    and ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
    and ifnull(id_unita_confezione,0,id_unita_confezione)=ifnull(inserted.id_unita_confezione,0,inserted.id_unita_confezione)
    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo)
    and ifnull(id_cat_merceologica,0,id_cat_merceologica)=ifnull(inserted.id_cat_merceologica,0,inserted.id_cat_merceologica)
    and ifnull(data_inizio,cast('2999-01-01' as date),data_inizio)=ifnull(inserted.data_inizio,cast('2999-01-01' as date),inserted.data_inizio)
    and ifnull(data_fine,cast('2999-01-01' as date),data_fine)=ifnull(inserted.data_fine,cast('2999-01-01' as date),inserted.data_fine)
    and ifnull(id_sog_commerciale_fornitore,0,id_sog_commerciale_fornitore)=ifnull(inserted.id_sog_commerciale_fornitore,0,inserted.id_sog_commerciale_fornitore)
    and ifnull(id_anagrafica,0,id_anagrafica)=ifnull(inserted.id_anagrafica,0,inserted.id_anagrafica)
    and ifnull(qta_minima,0,qta_minima)=ifnull(inserted.qta_minima,0,inserted.qta_minima)
    and ifnull(qta_massima,0,qta_massima)=ifnull(inserted.qta_massima,0,inserted.qta_massima)
    and ifnull(applicazione,'',applicazione)=ifnull(inserted.applicazione,'',inserted.applicazione)
    and ifnull(tipo_applicazione,'',tipo_applicazione)=ifnull(inserted.tipo_applicazione,'',inserted.tipo_applicazione)
    and ifnull(id_art_var1,'',id_art_var1)=ifnull(inserted.id_art_var1,'',inserted.id_art_var1)
    and ifnull(id_art_var2,'',id_art_var2)=ifnull(inserted.id_art_var2,'',inserted.id_art_var2)
    and ifnull(id_art_var3,'',id_art_var3)=ifnull(inserted.id_art_var3,'',inserted.id_art_var3);
  if @li_id_con_lis_articolo>0 then
    message 'Condizione di listino gia'' esistente: ',@li_id_con_lis_articolo,inserted.id_var_con_lis_articolo;
    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_con_lis_articolo)+' '+string(inserted.id_var_con_lis_articolo);
    rollback work
  else
    set inserted.priorita=cast((fn_calc_priorita_con_listino(inserted.id_destinazione,inserted.id_sog_commerciale,inserted.id_cat_com_sc,inserted.id_unita_confezione,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,inserted.id_sog_commerciale_fornitore,inserted.id_anagrafica,inserted.data_inizio,inserted.data_fine,inserted.qta_minima,inserted.qta_massima,inserted.tras_mezzo,inserted.id_tipo_trasporto)) as decimal(18))
  end if
end;

end if;


//INDICE UNIVOCO SU DOCUMENTO
//IF NOT(EXISTS(
//	SELECT 1 
//   FROM   SYS.SYSINDEXES
//  WHERE  tname = 'documento' 
//	AND 	 iname = 'ix_doc_unico')) THEN
//
//	CREATE UNIQUE INDEX ix_doc_unico ON documento ("id_registro" , "num_progressivo" )
//	;
//
//END IF
//;

//INDICE UNIVOCO SU DOCUMENTO
//IF (EXISTS(
//	SELECT 1 
//   FROM   SYS.SYSINDEXES
//   WHERE  tname = 'documento' 
//	AND 	 iname = 'ix_doc_unico')) THEN
//
//  DROP INDEX ix_documento_1;
//END IF
//;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_perc_ric_listini')) THEN
	CREATE TABLE "dba"."par_perc_ric_listini" ("id_par_perc_ric_listini" integer NOT NULL DEFAULT autoincrement, "id_lis1" integer DEFAULT NULL, "id_lis2" integer DEFAULT NULL, "id_lis3" integer DEFAULT NULL, "id_lis4" integer DEFAULT NULL, "id_lis5" integer DEFAULT NULL, "id_lis6" integer DEFAULT NULL , PRIMARY KEY ("id_par_perc_ric_listini")) ;
end if;

//Indice per velocizzare caricamento listini elettronici
IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
  WHERE  tname = 'lis_listino' 
	AND 	 iname = 'ix_lis_listino_2')) THEN

	CREATE INDEX "ix_lis_listino_2" ON "dba"."lis_listino" ("precodice" , "codice" , "data_inizio_validita" ) 
	;

END IF
;

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
  WHERE  tname = 'lis_listino' 
	AND 	 iname = 'ixc_lis_listino_1')) THEN
	CREATE  INDEX "ixc_lis_listino_1" ON "DBA"."lis_listino" ( codice );
END IF
;	

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
  WHERE  tname = 'y40_y40art00f' 
	AND 	 iname = 'ixc_y40_y40art00f_1')) THEN
	CREATE  INDEX "ixc_y40_y40art00f_1" ON "DBA"."y40_y40art00f" ( arcodart );
END IF
;	

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
  WHERE  tname = 'y40_y40bar00f' 
	AND 	 iname = 'ixc_y40_y40bar00f_1')) THEN
	CREATE  INDEX "ixc_y40_y40bar00f_1" ON "DBA"."y40_y40bar00f" ( cacodart );
	END IF
;	
/////////////////////////////////////////////////////////////////////////

//Gestione Spese documento su calcolo ultimo costo riepiloghi dai documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'ult_costo_spese' )) THEN 
        
				ALTER TABLE prof_documento ADD "ult_costo_spese" char(1) DEFAULT 'N';

end if;
/////////////////////////////////////////////////////////////


call fn_ins_voce_menu('Gestione Scadenze','w_gen_scad_partita_lt','Generazione Scadenze',1200);


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sis_doc_semp'
        AND      CNAME = 'dopo_stampa' )) THEN 

	alter table par_sis_doc_semp add dopo_stampa char(1);

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sis_doc_semp'
        AND      CNAME = 'doc_aperti' )) THEN 

	alter table par_sis_doc_semp add doc_aperti char(1);
	alter table par_sis_doc_semp add ord_aperti char(1);
	alter table par_sis_doc_semp add ddt_aperti char(1);
	alter table par_sis_doc_semp add fat_aperti char(1);

end if;

//////////////////////////
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_caus_mag')) THEN
        
				CREATE TABLE "dba"."par_caus_mag" (
				"id_par_caus_mag" integer NOT NULL DEFAULT autoincrement, 
				"id_caus_mag" integer DEFAULT NULL , 
				PRIMARY KEY ("id_par_caus_mag")) ;
				
end if;
//////////////////////////

///Stampa Movimenti per Causale
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_tipo_mov') THEN

CREATE FUNCTION "DBA"."fn_tipo_mov"(in @id_caus_magazzino integer,in @mag_pd char(1))
returns char(3)
begin
  declare ls_return char(3);
  /*
  Recupero il tipo di movimento che la causale effettua.
  Modificata in modo che indichi anche se si tratta di un carico o di uno scarico

  Argomenti di Input
  . ID Causale di Magazzino
  . 'P' --> Magazzino di partenza
  . 'D' --> Magazzino di destinazione

  Valore di ritorno:
  . CF = Carico Fiscale
  . SF = Scarico Fiscale
  . OC = Ordinato Clienti
  . OF = Ordinato Fornitori
  . VC = Visione Clienti
  . VF = Visione Fornitori
  . IP= Impegnato Produzione
  . OP = Ordinato Produzione
  . LC = C/Lav. Clienti
  . LF = C/Lav. Fornitori
  . G1 = Gruppo lib. 1
  . G2 = Gruppo lib. 2
  . G3 = Gruppo lib. 3
  . G4 = Gruppo lib. 4
  */
  declare @car_fiscali char(1);
  declare @scar_fiscali char(1);
  declare @ord_clienti char(1);
  declare @ord_fornitori char(1);
  declare @vis_clienti char(1);
  declare @vis_fornitori char(1);
  declare @imp_produzione char(1);
  declare @ord_produzione char(1);
  declare @cl_clienti char(1);
  declare @cl_fornitori char(1);
  declare @gr_lib_1 char(1);
  declare @gr_lib_2 char(1);
  declare @gr_lib_3 char(1);
  declare @gr_lib_4 char(1);
  declare @ls_return char(100);
  if(@mag_pd='P') then
    /* Magazzino di partenza */
    select mp_car_fiscali,
      mp_scar_fiscali,
      mp_ord_clienti,
      mp_ord_fornitori,
      mp_vis_clienti,
      mp_vis_fornitori,
      mp_imp_produzione,
      mp_ord_produzione,
      mp_qta_cl_clienti,
      mp_qta_cl_fornitori,
      mp_gruppo_lib_1,
      mp_gruppo_lib_2,
      mp_gruppo_lib_3,
      mp_gruppo_lib_4 into @car_fiscali,
      @scar_fiscali,@ord_clienti,@ord_fornitori,@vis_clienti,@vis_fornitori,
      @imp_produzione,@ord_produzione,@cl_clienti,@cl_fornitori,@gr_lib_1,@gr_lib_2,@gr_lib_3,
      @gr_lib_4 from caus_magazzino
      where id_caus_magazzino=@id_caus_magazzino
  else
    /* Magazzino di destinazione */
    select md_car_fiscali,
      md_scar_fiscali,
      md_ord_clienti,
      md_ord_fornitori,
      md_vis_clienti,
      md_vis_fornitori,
      md_imp_produzione,
      md_ord_produzione,
      md_qta_cl_clienti,
      md_qta_cl_fornitori,
      md_gruppo_lib_1,
      md_gruppo_lib_2,
      md_gruppo_lib_3,
      md_gruppo_lib_4 into @car_fiscali,
      @scar_fiscali,@ord_clienti,@ord_fornitori,@vis_clienti,@vis_fornitori,
      @imp_produzione,@ord_produzione,@cl_clienti,@cl_fornitori,@gr_lib_1,@gr_lib_2,@gr_lib_3,
      @gr_lib_4 from caus_magazzino
      where id_caus_magazzino=@id_caus_magazzino
  end if
  ;
  message ' cf:',@car_fiscali,' Sf:',@scar_fiscali,' OC:',@ord_clienti,'OF:',@ord_fornitori,'VC:',@vis_clienti,'VF:',@vis_fornitori,'IP:',
    @imp_produzione,'OP:',@ord_produzione,'LC:',@cl_clienti,'LF:',@cl_fornitori,'GR1:',@gr_lib_1,'GR2:',@gr_lib_2,'GR3:',@gr_lib_3,'GR4:',
    @gr_lib_4;
  if not(@car_fiscali is null) then
    if (@car_fiscali = '-') then
        set @ls_return='CF-'
    else
        set @ls_return='CF+'
    end if
  else
    if not(@scar_fiscali is null) then
      if (@scar_fiscali = '-') then
         set @ls_return='SF-'
      else
         set @ls_return='SF+'
      end if
    else
      if not(@ord_clienti is null) then
        if (@ord_clienti = '-') then
           set @ls_return='OC-'
        else
           set @ls_return='OC+'
        end if
      else
        if not(@ord_fornitori is null) then
          if (@ord_fornitori = '-') then
             set @ls_return='OF-'
          else
             set @ls_return='OF+'
          end if         
        else
          if not(@vis_clienti is null) then
            if (@vis_clienti = '-') then
               set @ls_return='VC-'
            else
               set @ls_return='VC+'
            end if            
          else
            if not(@vis_fornitori is null) then
              if (@vis_fornitori = '-') then
                 set @ls_return='VF-'
              else
                 set @ls_return='VF+'
              end if            
            else
              if not(@imp_produzione is null) then
                if (@imp_produzione = '-') then
                   set @ls_return='IP-'
                else
                   set @ls_return='IP+'
                end if               
              else
                if not(@ord_produzione is null) then
                  if (@ord_produzione = '-') then
                     set @ls_return='OP-'
                  else
                     set @ls_return='OP+'
                  end if                 
                else
                  if not(@cl_clienti is null) then
                    if (@cl_clienti = '-') then
                       set @ls_return='LC-'
                    else
                       set @ls_return='LC+'
                    end if                   
                  else
                    if not(@cl_fornitori is null) then
                      if (@cl_fornitori = '-') then
                         set @ls_return='LF-'
                      else
                         set @ls_return='LF+'
                      end if                     
                    else
                      if not(@gr_lib_1 is null) then
                        if (@gr_lib_1 = '-') then
                           set @ls_return='G1-'
                        else
                           set @ls_return='G1+'
                        end if                       
                      else
                        if not(@gr_lib_2 is null) then
                          if (@gr_lib_2 = '-') then
                             set @ls_return='G2-'
                          else
                             set @ls_return='G2+'
                          end if                         
                        else
                          if not(@gr_lib_3 is null) then
                            if (@gr_lib_3 = '-') then
                               set @ls_return='G3-'
                            else
                               set @ls_return='G3+'
                            end if                          
                          else
                            if not(@gr_lib_4 is null) then
                              if (@gr_lib_4 = '-') then
                                 set @ls_return='G4-'
                              else
                                 set @ls_return='G4+'
                              end if                             
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  ;
  message 'RETURN:',@LS_RETURN;
  return(@ls_return)
end;

end if;
///////////////////////////////


call fn_ins_voce_menu('Altre Stampe Contabili', 'w_partitario_sintetico_ff', 'Partitario Sintetico', 291);


//TRIGGER CANCELLAZIONE ARTVAR_PREZZO

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_art_vlis1_ad')) THEN


	CREATE TRIGGER "t_art_vlis1_ad".t_art_vlis1_ad after delete order 1
	on "DBA".art_vlis1
	referencing old as old_row
	for each row
	begin
	  delete from artvar_prezzo where id_art_var1=old_row.id_art_var1
	  and id_art_var2 is null and id_art_var3 is null;
      
	  update artvar_prezzo set id_art_var1=null where id_art_var1=old_row.id_art_var1;
	end;

	CREATE TRIGGER "t_art_vlis2_ad".t_art_vlis2_ad after delete order 1
	on "DBA".art_vlis2
	referencing old as old_row
	for each row
	begin
	  delete from artvar_prezzo where id_art_var2=old_row.id_art_var2
	  and id_art_var1 is null and id_art_var3 is null;
      
	  update artvar_prezzo set id_art_var2=null where id_art_var2=old_row.id_art_var2;
	end;

	CREATE TRIGGER "t_art_vlis3_ad".t_art_vlis3_ad after delete order 1
	on "DBA".art_vlis3
	referencing old as old_row
	for each row
	begin
	  delete from artvar_prezzo where id_art_var3=old_row.id_art_var3
	  and id_art_var2 is null and id_art_var1 is null;
      
	  update artvar_prezzo set id_art_var3=null where id_art_var3=old_row.id_art_var3;
	end;

end if;


/////Tabella temp. per saldo iniziale stampa mov. articoli

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_st_movart')) THEN
CREATE TABLE "dba"."tmp_st_movart" (
"id_tmp_st_movart" integer NOT NULL DEFAULT autoincrement, 
"id_utente" integer DEFAULT NULL, 
"id_articolo" integer DEFAULT NULL, 
"saldo" numeric(18,4) DEFAULT NULL , 
PRIMARY KEY ("id_tmp_st_movart")) ;
CREATE UNIQUE INDEX "ix_tmp_st_movart" ON "dba"."tmp_st_movart" ("id_utente" , "id_articolo" ) ;

end if;
//////////////////////////////////////////////////////////

////////Cod.Intrastat su cat.commercialearticolo x Senatori
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cat_com_articolo'
        AND      CNAME = 'cod_intrastat' )) THEN

        ALTER TABLE cat_com_articolo ADD cod_intrastat char(40) DEFAULT NULL;

end if;
///////////////////////////////



//Par. Sistema
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_tipo_pag_contanti' )) THEN 
        
	alter table par_sistema add id_tipo_pag_contanti integer;

end if;


//DISTINTA BANCA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_dis_banca'
        AND      CNAME = 'tipo_riga_distinta' )) THEN 
        
	ALTER TABLE riga_dis_banca ADD tipo_riga_distinta char(1) DEFAULT 'N';

end if;

//Personalizzazione valorizzazione distinta PAD
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_dist'
        AND      CNAME = 'prezzo' )) THEN 

				ALTER TABLE tmp_dist ADD prezzo numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'valdist_pad' )) THEN 

				ALTER TABLE pers_par_sistema ADD valdist_pad char(1) DEFAULT 'N';
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'costo_orario' )) THEN 
        
        ALTER TABLE distinta ADD costo_orario numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'ricarico_mat' )) THEN 
        
        ALTER TABLE distinta ADD ricarico_mat numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'costo_mat' )) THEN 
        
        ALTER TABLE distinta ADD costo_mat numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'costo_ric_mat' )) THEN 
        
        ALTER TABLE distinta ADD costo_ric_mat numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'tempo_mont' )) THEN 
        
        ALTER TABLE distinta ADD tempo_mont numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'tempo_prep' )) THEN 
        
        ALTER TABLE distinta ADD tempo_prep numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'tempo_coll' )) THEN 
        
        ALTER TABLE distinta ADD tempo_coll numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'costo_agg' )) THEN 
        
        ALTER TABLE distinta ADD costo_agg numeric(18,4) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'tipo_ric_pers' )) THEN 
        
        ALTER TABLE distinta ADD tipo_ric_pers char(1) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'prezzo_ven' )) THEN 
        
        ALTER TABLE distinta ADD prezzo_ven numeric(18,4) DEFAULT NULL;
end if;
//////////////////////////////////////////////

//DPA per il palle
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mezzo_trasporto'
        AND      CNAME = 'codice_aut' )) THEN 
        
        ALTER TABLE mezzo_trasporto ADD codice_aut char(20) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mezzo_trasporto'
        AND      CNAME = 'data_aut' )) THEN 
        
        ALTER TABLE mezzo_trasporto ADD data_aut date DEFAULT NULL;
end if;
//////////////////


//BANCA AZIENDA IN SCADENZA FORNITORI
ALTER TRIGGER "t_scade_ai".t_scade_ai after insert order 1
on "DBA".scadenza
referencing new as new_scadenza
for each row
begin
  declare @ll_id_scadenza integer;
  declare @id_riga integer;
  declare @is_stato char(1);
  declare @ll_banca_app integer;
  declare @is_tipo char(1);
  declare @ll_anag integer;
  declare @ll_banca_az integer;
  
  
  set @ll_id_scadenza=new_scadenza.id_scadenza;
  set @id_riga=new_scadenza.id_riga_distinta_banca;
  set @is_stato=new_scadenza.esito_pagamento;
  select tipo, id_anagrafica into @is_tipo, @ll_anag from sog_commerciale
  where id_sog_commerciale=new_scadenza.id_sog_commerciale;
  select max(id_banca_appoggio) into @ll_banca_app from banca_sog_commerciale 
  where id_anagrafica=@ll_anag and modo_uso='N';
  select max(id_banca_azienda) into @ll_banca_az from banca_azienda 
  where id_banca_appoggio=@ll_banca_app;

  
  
  message 'SCADENZA:'+ @is_stato;
  message 'SCADENZA:'+STRING(@ll_id_scadenza);
  if(@id_riga) is null and @is_stato<>'I' then
    print @ll_banca_app;
    print @is_tipo;
    if @is_tipo='F' and @ll_banca_az is not null then
        update scadenza set esito_pagamento='E',
                            data_cambiamento_stato=today(*),
                            id_banca_azienda=@ll_banca_az
          where id_scadenza=@ll_id_scadenza
    else
        update scadenza set
          esito_pagamento='E',data_cambiamento_stato=today(*) 
          where id_scadenza=@ll_id_scadenza
    end if
  else
    print 'INSERT riga is not null';
    update scadenza set
      data_cambiamento_stato=today(*) 
      where id_scadenza=@ll_id_scadenza
  end if
end;


//Gestione Scheda Articolo Senatori
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'scheda_articolo' )) THEN 
        
				ALTER TABLE pers_par_sistema ADD scheda_articolo char(1) DEFAULT 'N';

end if;



//////////////////////////////////////////
/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_009' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_009','Release 2_01_009  Cometa','S')
        ;

END IF
;
