//INIZIO 2_01_010


//ESENZIONE

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'esenzione'
        AND      CNAME = 'data_recez_doc' )) THEN 
        
				ALTER TABLE esenzione ADD data_recez_doc DATE DEFAULT NULL;

end if;

//MAIL UTENTE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'UTENTI'
        AND      CNAME = 'mail' )) THEN 
        
	ALTER TABLE utenti ADD mail char(40) DEFAULT NULL;

end if;



//MARGINE doc
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PAR_SISTEMA'
        AND      CNAME = 'margine' )) THEN 
        
	ALTER TABLE par_sistema ADD margine char(1) DEFAULT NULL;

end if;

//Madero gestione pancali
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_caus_car_pan' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD id_caus_car_pan integer DEFAULT NULL;
end if;     

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_caus_sca_pan' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD id_caus_sca_pan integer DEFAULT NULL;
end if;    

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_locaz_pan' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD id_locaz_pan integer DEFAULT NULL;
end if;    
/////////////////////////



//STORICO PREZZI

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'var_storico_prezzo')) THEN

	CREATE TABLE var_storico_prezzo ("id_var_storico_prezzo" integer NOT NULL DEFAULT autoincrement, "id_unita_confezione" integer DEFAULT NULL, 
                                     "id_variazione" integer DEFAULT NULL, "prezzo" numeric(20,6) DEFAULT NULL, "data_var" date DEFAULT NULL, 
                                     "id_art_var1" integer DEFAULT NULL, "id_art_var2" integer DEFAULT NULL, "id_art_var3" integer DEFAULT NULL, 
                                     "pk_codice" char(20) DEFAULT NULL , PRIMARY KEY ("id_var_storico_prezzo") , 
                 FOREIGN KEY "fk_storico_prezzo_1" ("id_unita_confezione" ) REFERENCES "dba"."unita_confezione" ON DELETE CASCADE , 
                 FOREIGN KEY "fk_storico_prezzo_2" ("id_variazione" ) REFERENCES "dba"."variazione" ON DELETE CASCADE ) ;

CREATE INDEX "ix_storico_prezzo1" ON "dba"."var_storico_prezzo" ("id_unita_confezione" , "id_variazione" , "data_var" ) ;

End if;


ALTER TRIGGER "t_artvar_prezzo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        declare @data_var date;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

        insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
        values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);

END;


 
ALTER TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
        declare @data_var date;
        declare @id_storico_prezzo integer;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
        select id_var_storico_prezzo into @id_storico_prezzo 
        from var_storico_prezzo
        where id_unita_confezione = new_pz.id_unita_confezione
        and id_variazione = new_pz.id_variazione
        and pk_codice=new_pz.pk_codice 
        and data_var = @data_var;
        if(@id_storico_prezzo is not null) then
        	update var_storico_prezzo
         	set prezzo = new_pz.prezzo
         	where id_var_storico_prezzo = @id_storico_prezzo
        else
            insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
            values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
        end if

	END;


//FINE STORICO VARIANTI


//Ricalcolo cespite
call fn_ins_voce_menu('Gestione Calcolo Ammortamenti', 'w_ricalcolo_cespite_wz', 'Ricalcolo Cespiti', 201);

//Gestione Immagini (DA ATTIVARE)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'gest_immagini' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD gest_immagini char(1);
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'art_immagini')) THEN

	CREATE TABLE "dba"."art_immagini" (
        "id_art_immagini" integer NOT NULL DEFAULT autoincrement, 
        "id_articolo" integer NOT NULL DEFAULT NULL, 
        "immagine" char(255) DEFAULT NULL, 
        "descrizione" long varchar DEFAULT NULL, 
        "predefinita" char(1) DEFAULT NULL , 
        PRIMARY KEY ("id_art_immagini")) ;
end if;

call fn_ins_voce_menu('Articoli', 'w_art_immagini_cx', 'Gestione Allegati Articolo', 250);
call fn_ins_voce_menu('Articoli', 'w_art_immagini_import', 'Importazione Allegati Articolo', 260);

/////////////////////////////////



//permessi UTENTE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'UTENTI'
        AND      CNAME = 'permessi_listini' )) THEN 
        
	ALTER TABLE utenti ADD permessi_listini char(1) DEFAULT 'N';
	CREATE INDEX "xk_art_var_prezzo_var1" ON "dba"."artvar_prezzo" ("id_art_var1" ) ;
	CREATE UNIQUE INDEX "xk_art_var_id" ON "dba"."art_var1" ("id_art_var1" ) ;

end if;


//ins veloce sansone

CREATE PROCEDURE "DBA"."sp_sans"()
begin				
declare @ls_cod char(8);
select codice into @ls_cod FROM azienda;
if @ls_cod='SANSONE' then
	update oggetti set ogg_oggetto='w_sans_articolo_ins_vel_cx' 
	where ogg_oggetto='w_articolo_ins_vel_cx';
end if;
end;

call sp_sans;
drop procedure sp_sans;

//Importazione/esportazione Listini DAMAz
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'impexp_list' )) THEN 

	ALTER TABLE pers_par_sistema ADD impexp_list char(1) default null;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_forn_impexp_list' )) THEN 

	ALTER TABLE pers_par_sistema ADD id_forn_impexp_list integer default null;

end if;
//////////////////////////

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'sys_art_veloce')) THEN

	CREATE TABLE "dba"."sys_art_veloce" 
	("id_sys_art_veloce" integer NOT NULL DEFAULT autoincrement, 
	"id_cat_codifica" integer NOT NULL DEFAULT NULL, 
	"pos1" char(20) default null, "pos2" char(20) default null, 
	"pos3" char(20) default null, "pos4" char(20) default null, "pos5" char(20) default null, "pos6" char(20) default null, 
	"pos7" char(20) default null, "pos8" char(20) default null, "pos9" char(20) default null, 
	"vis_lis" char(1) DEFAULT NULL, "vis_for" char(1) DEFAULT NULL, "vis_var" char(1) DEFAULT NULL,"vis_uc" char(1) DEFAULT NULL, 
	"id_tipo_cod_barre" integer DEFAULT NULL, "id_cat_com_articolo" integer DEFAULT NULL, 
	"id_cat_merceologica" integer DEFAULT NULL, "id_uc" integer DEFAULT NULL,
	"id_gruppo_articoli" integer DEFAULT NULL, "id_cat_fiscale" integer DEFAULT NULL,
	"id_tab_iva" integer DEFAULT NULL, "id_reparto" integer DEFAULT NULL, PRIMARY KEY ("id_sys_art_veloce"));


	CREATE TABLE "dba"."sys_modulo" 
	("id_sys_modulo" integer NOT NULL DEFAULT autoincrement, 
	"art_veloce" char(1),
	"anag_veloce" char(1),
	"fatturato" char(1),
	"dich_intento" char(1),
	PRIMARY KEY ("id_sys_modulo"));


end if;


call fn_ins_voce_menu('Impostazioni', 'w_sys_art_veloce', 'Sys Articolo', 2);
call fn_ins_voce_menu('Anagrafica', 'w_invia_lettera', 'Invio Comunicazioni', 47);
call fn_ins_voce_menu('Anagrafica', 'w_list_sollecito', 'Crea Comunicazioni', 48);
call fn_ins_voce_menu('Altre Stampe Contabili', 'w_partitario_contrassegno_ff', 'Partitario Vettori', 295);
call fn_ins_voce_menu('Stampe Contabili', 'w_dich_intento_wz', 'Dichiarazione Intento', 105);


//tipo blocco
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'insoluto_tipo_blocco' )) THEN 
        
	ALTER TABLE par_sistema ADD insoluto_tipo_blocco char(1) DEFAULT NULL;

end if;


//sollecito
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sollecito'
        AND      CNAME = 'dati_azienda' )) THEN 
        
	ALTER TABLE sollecito ADD dati_azienda char(1) DEFAULT NULL;

end if;


//DAMAZ
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'perc_ric_listini'
        AND      CNAME = 'perc_ric7' )) THEN 
        
	ALTER TABLE perc_ric_listini ADD perc_ric7 numeric(18,2) DEFAULT NULL;
	ALTER TABLE perc_ric_listini ADD perc_ric8 numeric(18,2) DEFAULT NULL;
	ALTER TABLE par_perc_ric_listini ADD id_lis7 integer DEFAULT NULL; 
	ALTER TABLE par_perc_ric_listini ADD id_lis8 integer DEFAULT NULL;
end if;

update oggetti set ogg_oggetto='w_doc_da_fatturare_ff' 
where ogg_oggetto='w_or_doc_da_fatturare_st';


call fn_ins_voce_menu('Stampe Contabili', 'w_st_liq_iva_sosp_aperte_rpt', 'Registrazioni in Sospese Iva', 103);

call fn_ins_voce_menu('Anagrafica', 'w_anag_travasa_dati_ff', 'Trasferimento Anagrafica', 3);


/////////////ALTERINI campo campo "Molteplicita" da 20,6 a 20,12
ALTER TABLE unita_confezione
modify molteplicita numeric(20,12) DEFAULT 0;
///////////////////////////////////////////////////////////////

//ITIESSE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'destinazione'
        AND      CNAME = 'id_tab_iva' )) THEN 
        
	ALTER TABLE destinazione ADD id_tab_iva integer DEFAULT NULL;

end if;


//Stampa Riepiloghi mensile
call fn_ins_voce_menu('Controllo', 'w_riep_art_mese_parigi_cx', 'Stampa riepiloghi x Mese', 112);

//Controllo se ricalcolare il prezzo al cambio della quantit sui documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'no_ricalc_prz' )) THEN 
        
	ALTER TABLE prof_documento ADD no_ricalc_prz char(1) DEFAULT 'N';

end if;
///////////////////////////////////////////////////////////////////////////


call fn_ins_voce_menu('Documento', 'w_stampa_doc_mail_ff', 'Documenti @_Mail', 3);


alter table cast_cpt_documento drop primary key;
alter table cast_cpt_documento ADD PRIMARY KEY ("id_documento", "id_conto", "tipo_riga_cpt");


ALTER TABLE "DBA"."cast_cpt_documento" ALTER "tipo_riga_cpt" drop CONSTRAINT "ASA105";
ALTER TABLE "DBA"."cast_cpt_documento" ALTER "tipo_riga_cpt" add CONSTRAINT "ASA105" check(@col in( 'C','S','I','N','A','Y') );

//IVA OMAGGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PAR_SISTEMA'
        AND      CNAME = 'id_tab_iva_omaggi' )) THEN 
        
	ALTER TABLE par_sistema ADD id_tab_iva_omaggi integer DEFAULT NULL;

end if;


IF EXISTS(SELECT 1 FROM SYSCONSTRAINT c , systable t WHERE t.table_id=c.table_id
	  and t.table_name='cast_iva_documento' and  c.CONSTRAINT_NAME = 'ASA112' ) THEN 
        ALTER TABLE cast_iva_documento modify val_imponibile dm_Imp_Valuta;
        ALTER TABLE cast_iva_documento modify val_tot_imp_v dm_Imp_Valuta;
        ALTER TABLE cast_iva_documento modify val_tot_imp_l dm_Imp_Valuta;
        
        ALTER TABLE "DBA"."cast_iva_documento" ALTER "val_imponibile" drop CONSTRAINT "ASA112";
        ALTER TABLE "DBA"."cast_iva_documento" ALTER "val_tot_imp_l" drop CONSTRAINT "ASA115";
        ALTER TABLE "DBA"."cast_iva_documento" ALTER "val_imp_scontato" drop CONSTRAINT "ASA113";        

end if;

IF NOT (EXISTS(SELECT 1 FROM tab_iva WHERE  id_tab_iva = 999 )) THEN 
	insert into  tab_iva (id_tab_iva, codice, des_breve, des_estesa, tipo_iva, per_aliquota, per_detrazione, ges_plafond, ges_oper_intracomunitarie, ges_beni_strumentali)
	values (999, 'ESOM', 'ES.ST.OMAGGI', 'ESENTE STORNO OMAGGI', 'C', 0, 0, 'N', 'N', 'N');
	update par_sistema set id_tab_iva_omaggi=999;
end if;


//TASSELLI - Ricalcolo prezzi Documenti per Articolo
call fn_ins_voce_menu('Documenti', 'w_agg_prz_art', 'Ricalcolo prezzi Documenti per Articolo', 125);



//CONTROPARTITE ACQUISTI
ALTER PROCEDURE "DBA"."sp_calc_cpt"(@al_idsc integer,@al_idar integer,@al_idag integer,@as_tipo char(1),@al_idaz integer,@al_idconto integer output,@al_id_caus integer) as
begin
  declare @ll_idccsc integer,
  @ll_idccar integer,
  @ll_stat integer,
  @ll_idcnt integer
  declare cur_cpt dynamic scroll cursor for select id_conto
      from "dba".con_movimento
      where(id_sog_commerciale=@al_idsc or id_sog_commerciale is null)
      and(id_cat_com_sc=@ll_idccsc or id_cat_com_sc is null)
      and(id_articolo=@al_idar or id_articolo is null)
      and(id_cat_com_articolo=@ll_idccar or id_cat_com_articolo is null)
      and(id_gruppo_agenti=@al_idag or id_gruppo_agenti is null)
      and(id_caus_magazzino=@al_id_caus or id_caus_magazzino is null)
      and(applicazione=@as_tipo) and(id_azienda=@al_idaz) order by
      priorita desc
  /**/
  if @al_idsc is not null begin
      select @ll_idccsc=(select sog_commerciale.id_cat_com_sc
          from "dba".sog_commerciale
          where sog_commerciale.id_sog_commerciale=@al_idsc)
    end
  if @al_idar is not null begin
      select @ll_idccar=(select articolo.id_cat_com_articolo
          from "dba".articolo
          where articolo.id_articolo=@al_idar)
    end
  /**/
  open cur_cpt
  select @ll_stat=0
  fetch next cur_cpt into @ll_idcnt
  select @ll_stat=@@sqlstatus
  close cur_cpt
  /*	
  Elisa Moneti	22/04/99
  Se non  stata recuperata una Contropartita valida, prendo quella
  impostata nei Parametri di Sistema
  */
  if @ll_idcnt is null or @ll_idcnt=0 begin
      select @ll_idcnt=id_conto_predefinito
      from par_sistema
      if @as_tipo='A' begin
         select @ll_idcnt=id_conto_predefinito_acq
         from par_sistema
      end
    end
  if @ll_stat is not null begin
      select @al_idconto=@ll_idcnt
    end
end;

/////////////////////Sconto su visualizzazione Listini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'scn_su_listino' )) THEN 

	ALTER TABLE pers_par_sistema ADD scn_su_listino char(1) DEFAULT 'N';

end if;

//ABILITAZIONE CANCELLAZIONE DOCUMENTI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'ABILITA_CANC' )) THEN 
        
	ALTER TABLE prof_documento ADD ABILITA_CANC char(1) DEFAULT 'N';

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'alt_par_stampa')) THEN
	CREATE TABLE "dba"."alt_par_stampa" ("id_alt_par_stampa" integer NOT NULL DEFAULT autoincrement, 
                                             "classe_finestra" char(40) DEFAULT NULL, 
                                             "titolo_finestra" char(40) DEFAULT NULL, 
                                             "nome_report" char(40) DEFAULT NULL, 
                                             "argomento" char(2) NOT NULL DEFAULT 'GN', 
                                             "cat_report" char(1) NOT NULL DEFAULT 'G', 
                                             "note" long varchar DEFAULT NULL, 
                                             "nome_campo_db_cod" char(40) DEFAULT NULL, 
                                             "nome_campo_db_des" char(40) DEFAULT NULL, 
                                             "nome_campo_instampa" char(40) DEFAULT NULL, 
                                             "nome_dddw_sl" char(40) DEFAULT NULL, 
                                             "nome_dddw_codice" char(40) DEFAULT NULL, 
                                             "nome_dddw_descrizione" char(40) DEFAULT NULL, 
                                             "tipo_serve" char(1) NOT NULL DEFAULT NULL, 
                                             "no_param" char(1) NOT NULL DEFAULT NULL, 
					     "use_completa_semplificata" char(1) NOT NULL DEFAULT NULL , 
                                             PRIMARY KEY ("id_alt_par_stampa")) ;
end if;

//Correzione trigger update storico_prezzo
IF (EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_prezzo_au')) THEN

	ALTER TRIGGER "t_prezzo_au".t_prezzo_au after update order 1
	on "DBA".prezzo
	referencing new as new_prz
	for each row
	begin
 
	declare @id_unita_confezione integer;
	declare @id_variazione integer;
	declare @prezzo decimal(20,6);
	declare @data_var date;
	declare @id_storico_prezzo integer;
	 
	set @id_unita_confezione=new_prz.id_unita_confezione;
	set @id_variazione=new_prz.id_variazione;
	set @prezzo=new_prz.prezzo;
	set @data_var=today(*);

	select max(id_storico_prezzo) into @id_storico_prezzo 
	from storico_prezzo
	where id_unita_confezione = @id_unita_confezione
 	and id_variazione = @id_variazione
	and data_var = @data_var;

 	if(@id_storico_prezzo is not null) and (@id_storico_prezzo > 0) then
 		//update storico_prezzo
 		//set prezzo = @prezzo
 		//where id_unita_confezione = @id_unita_confezione
 		//and id_variazione = @id_variazione
 		//and data_var = @data_var
 		update storico_prezzo
	 	set prezzo = @prezzo
	 	where id_storico_prezzo = @id_storico_prezzo

	 else
	 	insert into "dba".storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var) 
	 	values(@id_unita_confezione, @id_variazione, @prezzo, @data_var)
 	end if

	end;

end if;




//INDICE VAR DES ART
IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
  WHERE  tname = 'var_des_articolo' 
	AND 	 iname = 'ix_var_des_art_1')) THEN

	CREATE INDEX ix_var_des_art_1 ON var_des_articolo ("id_articolo" , "id_art_var1" );
END IF;


call fn_ins_voce_menu('Agenti', 'w_ag_prov_documento_cx', 'Provvigioni Agente', 41);

call fn_ins_voce_menu('Gestione PDC CEE', 'w_verifica_bil_cee_cx', 'Verifica Conti Esclusi', 8);
call fn_ins_voce_menu('Gestione PDC CEE', 'w_ins_rif_bil_cee_lt', 'Inserimento Veloce', 9);

IF (EXISTS(
	SELECT 1 FROM   SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_esi_lotti')) THEN
        
ALTER FUNCTION "DBA"."fn_esi_lotti"(in @id_lotto integer,in @id_magazzino integer,in @fino_al date,in @id_valuta_f integer)
				returns char(80)
				begin
				  /*
				  Elisa Moneti  05/06/2001      BL#13259#
				  07/02/2002      BL#18197#
				
				  Calcolo:
				  . 	"Esistenza Fiscale" (Carichi - Scarichi)
				
				  Argomenti input:
				  . ID Lotto    (Obbligatorio)
				  . ID Magazzino	(Obbligatorio, se 0 tutti i magazzini)
				  . Fino Al     (Obbligatorio)
				
				  Valore di ritorno:
				  . 1 - 20 	carattere --> Esistenza Fisica
				  */
				  //
				  //
				  declare @ld_carichi decimal(18,4);
				  declare @ld_scarichi decimal(18,4);
				  declare @ls_carichi char(20);
				  declare @ls_scarichi char(20);
				  declare @ld_costo_acquisto decimal(18,4);
				  declare @ls_costo_acquisto char(20);
				  /* Valori di ritorno */
				  declare @ld_esi_fisica decimal(18,4);
				  declare @ls_esi_fisica char(20);
				  declare @ls_tipo_mov char(1);
				  //
				  select m.tipo into @ls_tipo_mov
				    from unita_confezione as u,unita_misura as m,lotto as l
				    where l.id_lotto=@id_lotto
				    and u.id_articolo=l.id_articolo
				    and u.unita_base='S'
				    and m.id_unita_misura=u.id_unita_misura;
				  //
				  message ' Tipo Movimentazione:'+@ls_tipo_mov;
				  //
				  if(@ls_tipo_mov='P') then
				    if @id_magazzino=0 then
				      /* 
				      Calcolo l''Esistenza Fisica Totale a Peso
				      */
				      //      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(r.prezzo_netto) 
				
				
				      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				        @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='C'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro;
				
				      //select (Sum(ifnull(r.peso_netto,0, if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi, 
				      //@ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      //  where l.id_lotto=@id_lotto
				      //  and rl.id_lotto=l.id_lotto
				      //  and r.id_riga_lotto=rl.id_riga_lotto
				      //  and c.id_caus_magazzino=r.id_caus_magazzino
				      //  and c.gestisce_lotti='C'
				      //  and d.id_documento=r.id_documento
				      //  and d.data_registrazione<=@fino_al
				      //  and d.id_registro = reg.id_registro;
				
				      //
				      message ' CARICHI A PESO:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				      //
				
				      //select(Sum(ifnull(r.peso_netto,0,r.peso_netto))) into @ld_scarichi
				      //  from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				      //  where l.id_lotto=@id_lotto
				      //  and rl.id_lotto=l.id_lotto
				      //  and r.id_riga_lotto=rl.id_riga_lotto
				      //  and c.id_caus_magazzino=r.id_caus_magazzino
				      //  and c.gestisce_lotti='S'
				      //  and d.id_documento=r.id_documento
				      //  and d.data_registrazione<=@fino_al;
				
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_scarichi
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='S'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro;
				
				      //
				      message ' SCARICHI A PESO:'+string(@ld_scarichi)
				    end if
				  else //
				    //
				    /* 
				    Calcolo l''Esistenza Fisica Totale a Quantit
				    */
				    //    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(r.prezzo_netto) into @ld_carichi,
				    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				      @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='C'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al;
				
				    //select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				    //  @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				    //  where l.id_lotto=@id_lotto
				    //  and rl.id_lotto=l.id_lotto
				    //  and r.id_riga_lotto=rl.id_riga_lotto
				    //  and c.id_caus_magazzino=r.id_caus_magazzino
				    //  and c.gestisce_lotti='C'
				    //  and d.id_documento=r.id_documento
				    //  and d.data_registrazione<=@fino_al
                    //  and d.id_registro = reg.id_registro;
				    //
				    message ' CARICHI A QUANTITA:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				    //
				    //
				    //select(Sum(ifnull(r.quantita,0,r.quantita))) into @ld_scarichi
				    //  from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				    //  where l.id_lotto=@id_lotto
				    //  and rl.id_lotto=l.id_lotto
				    //  and r.id_riga_lotto=rl.id_riga_lotto
				    //  and c.id_caus_magazzino=r.id_caus_magazzino
				    //  and c.gestisce_lotti='S'
				    //  and d.id_documento=r.id_documento
				    //  and d.data_registrazione<=@fino_al;
				
				    select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_scarichi
				      from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='S'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al
                      and d.id_registro = reg.id_registro;
				    //
				    message ' SCARICHI A QUANTITA:'+string(@ld_scarichi)
				  end if //
				  ; //
				  set @ld_esi_fisica=ifnull(@ld_carichi,0,@ld_carichi)-ifnull(@ld_scarichi,0,@ld_scarichi);
				  message ' CARICHI:'+string(@ld_carichi)+' SCARICHI:'+string(@ld_scarichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				  /* 
				  Costruisco ls stringa di ritorno 
				  */
				  /* Esistenza Fisica */
				  set @ls_esi_fisica=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica))))+STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica));
				  /* Carichi */
				  set @ls_carichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_carichi,0,@ld_carichi))))+STRING(ifnull(@ld_carichi,0,@ld_carichi));
				  /* Scarichi */
				  set @ls_scarichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_scarichi,0,@ld_scarichi))))+STRING(ifnull(@ld_scarichi,0,@ld_scarichi));
				  /* Costo Acquisto */
				  set @ls_costo_acquisto=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto))))+STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto));
				  //
				  return(STRING(@ls_esi_fisica,@ls_carichi,@ls_scarichi,@ls_costo_acquisto))
				end;
END if;


//MARGINE doc
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'blocco_articolo' )) THEN 
        
	alter table utenti add blocco_articolo char(1);

end if;


//NUOVE PROVINCE
IF NOT(EXISTS(
        SELECT 1 
        FROM   provincia
        WHERE  cod_provincia = 'OT' )) THEN 
        
	insert into provincia (cod_provincia, des_provincia, regione, nazione , cap)
	values ('OT','Olbia Tempio Pausania','Sardegna','IT','07020');

	insert into provincia (cod_provincia, des_provincia, regione, nazione , cap)
	values ('OG','Ogliastra','Sardegna','IT','08000');

	insert into provincia (cod_provincia, des_provincia, regione, nazione , cap)
	values ('CI','Carbonia Iglesias','Sardegna','IT','08000');

	insert into provincia (cod_provincia, des_provincia, regione, nazione , cap)
	values ('VS','Medio Campidano','Sardegna','IT','08000');


end if;


//distinta base
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'qta_referenze' )) THEN 
        
	alter table distinta add "qta_referenze" numeric(18,4) DEFAULT NULL;

end if;


//Disabilita tasto RC sui documenti (Tremori)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'disabilita_rc' )) THEN 
        
	ALTER TABLE prof_documento ADD disabilita_rc char(1) DEFAULT 'N';

end if;

//Nuovo dopo Stampa 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'nuovo_dopo_stampa' )) THEN 
        
	ALTER TABLE prof_documento ADD nuovo_dopo_stampa char(1) DEFAULT 'N';

end if;
///////////////////////////////////////////////////////////////////////////

//Rettifica Lotti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_lotto_retinv_file')) THEN
        
        CREATE TABLE "dba"."tmp_lotto_retinv_file" (
        "id_tmp_lotto_retinv_file" integer NOT NULL DEFAULT autoincrement, 
        "id_articolo" integer NOT NULL DEFAULT NULL, 
        "id_lotto" integer NOT NULL DEFAULT NULL, 
        "qta" decimal(18,4) DEFAULT NULL , 
        PRIMARY KEY ("id_tmp_lotto_retinv_file")) ;
end if;        



IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTrigger
        WHERE  Trigger_name = 't_artvar_prezzo_bu')) THEN

	create TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
        declare @data_var date;
        declare @id_storico_prezzo integer;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
 --       select id_var_storico_prezzo into @id_storico_prezzo 
 --       from var_storico_prezzo
 --       where id_unita_confezione = new_pz.id_unita_confezione
 --       and id_variazione = new_pz.id_variazione
 --       and pk_codice=new_pz.pk_codice 
 --       and data_var = @data_var;
 --       if(@id_storico_prezzo is not null) then
 --       	update var_storico_prezzo
 --        	set prezzo = new_pz.prezzo
 --        	where id_var_storico_prezzo = @id_storico_prezzo
 --       else
 --          insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
 --           values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
 --       end if

	END;

end if;

ALTER TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
        declare @data_var date;
        declare @id_storico_prezzo integer;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
		SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
 --       select id_var_storico_prezzo into @id_storico_prezzo 
 --       from var_storico_prezzo
 --       where id_unita_confezione = new_pz.id_unita_confezione
 --       and id_variazione = new_pz.id_variazione
 --       and pk_codice=new_pz.pk_codice 
 --       and data_var = @data_var;
 --       if(@id_storico_prezzo is not null) then
 --       	update var_storico_prezzo
 --        	set prezzo = new_pz.prezzo
 --        	where id_var_storico_prezzo = @id_storico_prezzo
 --       else
 --          insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
 --           values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
 --       end if

	END;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTrigger
        WHERE  Trigger_name = 't_artvar_prezzo_bI')) THEN

cREATE TRIGGER "t_artvar_prezzo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        declare @data_var date;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

  --      insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
  --      values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);

END;

END IF;


ALTER TRIGGER "t_artvar_prezzo_bi" BEFORE INSERT
	ORDER 1 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        declare @data_var date;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;

  --      insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
  --      values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);

END;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTrigger
        WHERE  Trigger_name = 't_artvar_prezzo_AU')) THEN

create TRIGGER "t_artvar_prezzo_au" AFTER UPDATE
	ORDER 3 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
        declare @data_var date;
        declare @id_storico_prezzo integer;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
        select max(id_var_storico_prezzo) into @id_storico_prezzo 
        from var_storico_prezzo
        where id_unita_confezione = new_pz.id_unita_confezione
        and id_variazione = new_pz.id_variazione
        and pk_codice=new_pz.pk_codice 
        and data_var = @data_var;
        message 'oo';
        if(@id_storico_prezzo is not null) then
        	update var_storico_prezzo
         	set prezzo = new_pz.prezzo
         	where id_var_storico_prezzo = @id_storico_prezzo;
            
        else
            insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
            values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
            
        end if

	END;
END IF;

ALTER TRIGGER "t_artvar_prezzo_au" AFTER UPDATE
	ORDER 3 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
	    declare @ls_var3 long varchar;
        declare @data_var date;
        declare @id_storico_prezzo integer;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
	        set @ls_var2=string(new_pz.id_art_var2)
	    end if;
	    if new_pz.id_art_var3 is null then 
	        set @ls_var3='N'
	    else
	        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
        select max(id_var_storico_prezzo) into @id_storico_prezzo 
        from var_storico_prezzo
        where id_unita_confezione = new_pz.id_unita_confezione
        and id_variazione = new_pz.id_variazione
        and pk_codice=new_pz.pk_codice 
        and data_var = @data_var;
        message 'oo';
        if(@id_storico_prezzo is not null) then
        	update var_storico_prezzo
         	set prezzo = new_pz.prezzo
         	where id_var_storico_prezzo = @id_storico_prezzo;
            
        else
            insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
            values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
            
        end if

	END;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTrigger
        WHERE  Trigger_name = 't_artvar_prezzo_AI')) THEN



create TRIGGER "t_artvar_prezzo_ai" AFTER INSERT
	ORDER 2 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        declare @data_var date;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    
        message 'pp';
        insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
        values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
        
END;

END IF;

ALTER TRIGGER "t_artvar_prezzo_ai" AFTER INSERT
	ORDER 2 ON "DBA"."artvar_prezzo"
	REFERENCING NEW AS new_pz
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    declare @ls_var1 long varchar;
	    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        declare @data_var date;
        set @data_var=today(*);
	    if new_pz.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(new_pz.id_art_var1)
	    end if;
	    if new_pz.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(new_pz.id_art_var2)
		    end if;
	    	if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(new_pz.id_art_var3)
	    end if;
	    
        message 'pp';
        insert into "dba".var_storico_prezzo(id_unita_confezione, id_variazione, prezzo, data_var, id_art_var1, id_art_var2, id_art_var3, pk_codice) 
        values(new_pz.id_unita_confezione, new_pz.id_variazione, new_pz.prezzo, @data_var, new_pz.id_art_var1, new_pz.id_art_var2, new_pz.id_art_var3, new_pz.pk_codice);
        
END;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTrigger
        WHERE  Trigger_name = 't_artvar_prezzo_AD')) THEN


create TRIGGER "t_artvar_prezzo_ad".t_artvar_prezzo_ad after delete on "DBA".Artvar_prezzo
referencing old as old_row
for each row /* Watcom only

order 1

*/
/* Watcom only

for each row

*/
begin
  /* Moneti Elisa
  Data:                 08/01/1999
  Oggetto:      Con la cancellazione di un Articolo, deve essere cancellato automaticamente,
  tutto cio' che automaticamente e' stato creato: Unita' Confezioni e Prezzi dei Listini. Se
  l'Articolo  stato movimentato, la cancellazione fallisce.
  */

  declare @ls_var1 long varchar;
  declare @ls_var2 long varchar;
  declare @ls_var3 long varchar;

	    if old_row.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(old_row.id_art_var1)
	    end if;
	    if old_row.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(old_row.id_art_var2)
		    end if;
	    	if old_row.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(old_row.id_art_var3)
	    end if;
	    
        message 'pp';
        delete from "dba".var_storico_prezzo where id_unita_confezione=old_row.id_unita_confezione
        and pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
        
end;

END IF;

ALTER TRIGGER "t_artvar_prezzo_ad".t_artvar_prezzo_ad after delete on "DBA".Artvar_prezzo
referencing old as old_row
for each row /* Watcom only

order 1

*/
/* Watcom only

for each row

*/
begin
  /* Moneti Elisa
  Data:                 08/01/1999
  Oggetto:      Con la cancellazione di un Articolo, deve essere cancellato automaticamente,
  tutto cio' che automaticamente e' stato creato: Unita' Confezioni e Prezzi dei Listini. Se
  l'Articolo  stato movimentato, la cancellazione fallisce.
  */

  declare @ls_var1 long varchar;
  declare @ls_var2 long varchar;
  declare @ls_var3 long varchar;

	    if old_row.id_art_var1 is null then 
	       set @ls_var1='N'
	    else
	        set @ls_var1=string(old_row.id_art_var1)
	    end if;
	    if old_row.id_art_var2 is null then 
	        set @ls_var2='N'
	    else
        	set @ls_var2=string(old_row.id_art_var2)
		    end if;
	    	if old_row.id_art_var3 is null then 
		        set @ls_var3='N'
	    	else
		        set @ls_var3=string(old_row.id_art_var3)
	    end if;
	    
        message 'pp';
        delete from "dba".var_storico_prezzo where id_unita_confezione=old_row.id_unita_confezione
        and pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
        
end;


//Rettifica Inventariale da file 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_ret_inv_bc'
        AND      CNAME = 'qta' )) THEN 
        
	ALTER TABLE tmp_ret_inv_bc ADD qta numeric(18,4) DEFAULT NULL;

end if;

//Blocco Derivazione Fornitori
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'blocco_deriv_fo' )) THEN 
        
	ALTER TABLE par_sistema add blocco_deriv_fo char(1);

end if;


//CONTROLLO PROGRESSIVO SU PROFILI DOCUIMENTI
ALTER TABLE "DBA"."prof_documento" ALTER "ric_num_progressivo" drop CONSTRAINT "ASA760";
ALTER TABLE "DBA"."prof_documento" ALTER "ric_num_progressivo" add CONSTRAINT "ASA760" check(@col in('N','L','M','O','R'));

///EXPORT FATTURE FORMATO EURITMO (Codici PAM
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'codpam')) THEN
        
				CREATE TABLE "dba"."codpam" (
				"id_codpam" integer NOT NULL DEFAULT autoincrement, 
				"id_sog_commerciale" integer DEFAULT NULL, 
				"id_destinazione" integer DEFAULT NULL, 
				"codpam" char(20) DEFAULT NULL , 
				PRIMARY KEY ("id_codpam")) ;
				
end if;				
/////////////////////////////////

//Rettifica Inventariale da file con prezzo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_ret_inv_bc'
        AND      CNAME = 'prz' )) THEN 
        
	ALTER TABLE tmp_ret_inv_bc ADD prz numeric(20,6) DEFAULT NULL;

end if;

//Boccino stampa listino ultimo prezzo pagato
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_ultprz_cli')) THEN
        
				CREATE TABLE "dba"."tmp_ultprz_cli" (
				"id_tmp_ultprz_cli" integer NOT NULL DEFAULT autoincrement, 
				"id_sog_commerciale" integer NOT NULL DEFAULT NULL, 
				"id_articolo" integer NOT NULL DEFAULT NULL, 
				"prezzo" decimal(20,6) DEFAULT NULL, 
				"prezzo_netto" decimal(20,6) DEFAULT NULL, 
				"sconto" char(10) DEFAULT NULL , 
				PRIMARY KEY ("id_tmp_ultprz_cli")) ;
				
				CREATE UNIQUE INDEX "ix_tmp_ultprz_cli" ON "dba"."tmp_ultprz_cli" (
				"id_sog_commerciale" , 
				"id_articolo" ) ;
		
end if;		

///EXPORT FATTURE FORMATO EURITMO (Codici PAM articoli
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'codartpam')) THEN
        
				CREATE TABLE "dba"."codartpam" (
				"id_codartpam" integer NOT NULL DEFAULT autoincrement, 
				"id_articolo" integer DEFAULT NULL, 
				"codartpam" char(20) DEFAULT NULL , 
				PRIMARY KEY ("id_codartpam")) ;
				
end if;				
/////////////////////////////////

//////Damaz proposta listini per utility importazione / esportazione
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'impexp_id_listexp' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD impexp_id_listexp integer DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'impexp_id_listimp' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD impexp_id_listimp integer DEFAULT NULL;
end if; 

//Damaz gestione tasto per creazione condizioni di listino da documento
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'crea_clis' )) THEN 
        
	ALTER TABLE prof_documento ADD crea_clis char(1) DEFAULT 'N';

end if;
///////////////////////////////////////////////////////////////////////

////Visualizzazione eventuali articoli sostitutivi della w_pers_documento_ordine_cx sottoposta a condizione
////per migliorare le prestazioni su alcuni DB
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'vis_artsost' )) THEN 
        
        ALTER TABLE pers_par_sistema ADD vis_artsost char(1) DEFAULT 'N';
        
        update pers_par_sistema
        set vis_artsost = 'N';
        commit;
end if; 
////////////////// 

//////////////////////////////////////////
/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_010' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_010','Release 2_01_010  Cometa','S')
        ;

END IF
;

