//INIZIO 2_01_014

//Sansone (resoconto commesse)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'previsione' )) THEN 
        
				alter table commessa add previsione numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'sviluppo' )) THEN 
        
				alter table commessa add sviluppo numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'conteggio' )) THEN 
        
				alter table commessa add conteggio numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'sconto' )) THEN 
        
				alter table commessa add sconto numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'fatturazione' )) THEN 
        
				alter table commessa add fatturazione numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'incasso' )) THEN 
        
				alter table commessa add incasso numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'utile' )) THEN 
        
				alter table commessa add utile numeric(18,4) default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'perc_prop_cm' )) THEN 
        
				alter table commessa add perc_prop_cm numeric(5,2) default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'perc_prop_dl' )) THEN 
        
				alter table commessa add perc_prop_dl numeric(5,2) default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'perc_prop_uc' )) THEN 
        
				alter table commessa add perc_prop_uc numeric(5,2) default null;
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'san_resoconto_sal')) THEN
		
		CREATE TABLE "dba"."san_resoconto_sal" ("id_san_resoconto_sal" integer NOT NULL DEFAULT autoincrement, "id_commessa" integer NOT NULL DEFAULT NULL, "data_op" date DEFAULT NULL, "descrizione" long varchar DEFAULT NULL, "importo" numeric(18,4) DEFAULT NULL , PRIMARY KEY ("id_san_resoconto_sal") , FOREIGN KEY "fk_san_resoconto_sal_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE ) ;
		CREATE INDEX "ix_san_resoconto_sal_1" ON "dba"."san_resoconto_sal" ("id_commessa" , "data_op" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'san_resoconto_fat')) THEN
		
		CREATE TABLE "dba"."san_resoconto_fat" ("id_san_resoconto_fat" integer NOT NULL DEFAULT autoincrement, "id_commessa" integer NOT NULL DEFAULT NULL, "data_op" date DEFAULT NULL, "descrizione" long varchar DEFAULT NULL, "importo" numeric(18,4) DEFAULT NULL , PRIMARY KEY ("id_san_resoconto_fat") , FOREIGN KEY "fk_san_resoconto_fat_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE ) ;
		CREATE INDEX "ix_san_resoconto_fat_1" ON "dba"."san_resoconto_fat" ("id_commessa" , "data_op" ) ;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'san_resoconto_inc')) THEN
		
		CREATE TABLE "dba"."san_resoconto_inc" ("id_san_resoconto_inc" integer NOT NULL DEFAULT autoincrement, "id_commessa" integer NOT NULL DEFAULT NULL, "data_op" date DEFAULT NULL, "descrizione" long varchar DEFAULT NULL, "importo" numeric(18,4) DEFAULT NULL , PRIMARY KEY ("id_san_resoconto_inc") , FOREIGN KEY "fk_san_resoconto_inc_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE ) ;
		CREATE INDEX "ix_san_resoconto_inc_1" ON "dba"."san_resoconto_inc" ("id_commessa" , "data_op" ) ;
end if;		
///////////////////////////////////////////////////////////////////



//PARIGI BANCA SU DESTINAZIONE

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'destinazione'
        AND      CNAME = 'id_banca_sog_commerciale' )) THEN 
        
	ALTER TABLE destinazione ADD "id_banca_sog_commerciale" integer DEFAULT NULL 
end if;

//****



//BLOCCO FIDO AUT 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PAR_SISTEMA'
        AND      CNAME = 'fido_blocco_aut' )) THEN 
        
	ALTER TABLE PAR_SISTEMA ADD fido_blocco_aut char(1) DEFAULT NULL;
end if;


//ROTTURA PARAMETRICA SOG PER  DESTINAZIONE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'SOG_COMMERCIALE'
        AND      CNAME = 'FAT_ROT_DEST' )) THEN 
        
	ALTER TABLE SOG_COMMERCIALE ADD FAT_ROT_DEST char(1) DEFAULT NULL;
end if;

//DESTINAZIONE PROPOSTA AUTOMATICA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'DESTINAZIONE'
        AND      CNAME = 'PROPOSTA' )) THEN 
        
	ALTER TABLE DESTINAZIONE ADD PROPOSTA CHAR(1) DEFAULT 'N';
	UPDATE DESTINAZIONE SET PROPOSTA ='N';
end if; 

///controllo ricalcolo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'LOG_RIC_MAG')) THEN
		
		CREATE TABLE "dba"."LOG_RIC_MAG" ("id_LOG_RIC_MAG" integer NOT NULL DEFAULT autoincrement, "DATA_LOG" DATE NOT NULL DEFAULT NULL, "descrizione" long varchar DEFAULT NULL, "ora" time DEFAULT now()) ;

end if;		


//PAR SISTEMA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'cespiti_calc_fraz' )) THEN 
        
	ALTER TABLE par_sistema ADD cespiti_calc_fraz CHAR(1) DEFAULT 'N';
	ALTER TABLE par_sistema ADD data_ric_mag date DEFAULT null;

end if; 

//TASTO PANICO
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_panic') THEN
		
			CREATE PROCEDURE "DBA"."sp_panic"()
				begin
				    set option fire_triggers = 'OFF';				    
				
                    truncate table movimenti_lotto;
                    truncate table riga_doc_lotto;
                    truncate table lotto;
                    truncate table riepilogo;
				    truncate table spesa_documento;
				    truncate table cast_iva_documento;
				    truncate table cast_cpt_documento;

				    update scadenza
                    set id_documento = null;

                    truncate table alb_riga_documento;
                    truncate table ute_documento;
				    truncate table riga_documento;
				    truncate table documento;

                    commit;          		

				    set option fire_triggers = 'ON';
				end;
end if;				
///////////////////////////////////////////////


//CARTELLA SCANNER
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'ut_scan' )) THEN 
        
	ALTER TABLE "dba"."utenti" ADD  "ut_scan" long varchar DEFAULT NULL;
end if; 




//ARTICOLO PAD
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'articolo'
        AND      CNAME = 'cod_produttore' )) THEN 
        
	ALTER TABLE articolo ADD cod_produttore CHAR(80) DEFAULT NULL;
	ALTER TABLE articolo ADD cod_alternativa CHAR(80) DEFAULT NULL;

end if; 



///controllo ricalcolo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'fat_parametrico')) THEN
		

	CREATE TABLE "dba"."fat_parametrico" ("id_fat_parametrico" integer NOT NULL DEFAULT autoincrement, "id_documento" integer NOT NULL DEFAULT NULL, "id_prof_documento" integer NOT NULL DEFAULT NULL, 
        	                              "id_registro" integer NOT NULL DEFAULT NULL, "tipo_registro" char(2) NOT NULL DEFAULT NULL, "num_progressivo" integer NOT NULL DEFAULT NULL, 
                	                      "data_registrazione" date NOT NULL DEFAULT NULL, "segno_iva" integer NOT NULL DEFAULT NULL, "id_sog_comerciale" integer NOT NULL DEFAULT NULL, 
                        	              "id_destinazione" integer DEFAULT NULL, "id_riga_documento" integer NOT NULL DEFAULT NULL, "id_articolo" integer DEFAULT NULL, "des_articolo" char(256) DEFAULT NULL, 
                                	      "tipo_um" char(1) DEFAULT NULL, "quantita" numeric(20,6) DEFAULT NULL, "tot_scontato" numeric(20,6) DEFAULT NULL, "id_reg_pd" integer NOT NULL DEFAULT NULL, 
	                                      "id_cpt" integer DEFAULT NULL, "id_gruppo_agenti" integer DEFAULT NULL, "id_gruppo_agenti_2" integer DEFAULT NULL , "id_var1" integer DEFAULT NULL , 
	PRIMARY KEY ("id_fat_parametrico") , 
	FOREIGN KEY "fk_fat_parametrico_id_art" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE RESTRICT , 
	FOREIGN KEY "fk_fat_parametrico_id_reg" ("id_reg_pd" ) REFERENCES "dba"."reg_pd" ON DELETE CASCADE , 
	FOREIGN KEY "fk_fat_parametrico_id_sog" ("id_sog_comerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;

	CREATE INDEX "xk_fat_parametrico_id_doc" ON "dba"."fat_parametrico" ("id_documento" ) ;
	CREATE UNIQUE INDEX "xk_fat_parametrico_id_riga_doc" ON "dba"."fat_parametrico" ("id_riga_documento" ) ;
	CREATE INDEX "xk_fat_parametrico_id_reg" ON "dba"."fat_parametrico" ("id_reg_pd" ) ;
	CREATE INDEX "xk_fat_parametrico_data" ON "dba"."fat_parametrico" ("data_registrazione" ) ;
	CREATE INDEX "xk_fat_parametrico_id_art" ON "dba"."fat_parametrico" ("id_articolo" ) ;
	CREATE INDEX "xk_fat_parametrico_id_sog" ON "dba"."fat_parametrico" ("id_sog_comerciale" ) ;

	ALTER TABLE sys_modulo ADD pdf_mail char(1) DEFAULT NULL;
	ALTER TABLE sys_modulo ADD arky char(1) DEFAULT NULL;
	ALTER TABLE sys_modulo ADD block_note char(1) DEFAULT NULL;

	CREATE TABLE "dba"."arky_alb_str" ("id_arky_alb_str" integer NOT NULL DEFAULT autoincrement, "id_arky_str" integer NOT NULL DEFAULT NULL, "id_arky_alb_padre" integer NOT NULL DEFAULT NULL, "nome_folder" char(8) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_arky_alb_str")) ;
	CREATE TABLE "dba"."arky_note" ("id_arky_note" integer NOT NULL DEFAULT autoincrement, "id_ut_ins" integer NOT NULL DEFAULT NULL, "id_per_ut" integer NOT NULL DEFAULT NULL, "data_nota" date NOT NULL DEFAULT NULL, "cod_nota" char(40) NOT NULL DEFAULT NULL, "des_nota" long varchar NOT NULL DEFAULT NULL, "urgenza" char(1) NOT NULL DEFAULT NULL, "ora_nota" time DEFAULT NULL, "stato_nota" char(1) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_arky_note")) ;
	CREATE TABLE "dba"."arky_sis" ("id_arky_sis" integer NOT NULL DEFAULT autoincrement, "dir_arky" long varchar NOT NULL DEFAULT NULL, "dir_scan" long varchar DEFAULT NULL, "canc_file_scan" char(1) DEFAULT NULL, "tipo_pref_file" char(1) DEFAULT NULL, "des_pref" char(80) DEFAULT NULL , PRIMARY KEY ("id_arky_sis")) ;
	CREATE TABLE "dba"."arky_str" ("id_arky_str" integer NOT NULL DEFAULT autoincrement, "des_str" char(20) NOT NULL DEFAULT NULL, "table_str" char(20) DEFAULT NULL, "param_str" char(4) DEFAULT NULL, "id" char(20) DEFAULT NULL, "cod" char(20) DEFAULT NULL, "des" char(20) DEFAULT NULL , PRIMARY KEY ("id_arky_str")) ;
	CREATE UNIQUE INDEX "xk_arky_str_1" ON "dba"."arky_str" ("des_str" ) ;


	CREATE TRIGGER "t_arky_str_ai" AFTER INSERT
	ORDER 1 ON "DBA"."arky_str"
	REFERENCING NEW AS new_str
	FOR EACH ROW 
	BEGIN
	    insert into "dba".arky_alb_str(id_arky_str, id_arky_alb_padre, nome_folder) 
	    values(new_str.id_arky_str, 0, 'CODICE');

	END;

end if;	


//aliquota esenzione su spesa
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'spesa'
        AND      CNAME = 'id_tab_iva_es' )) THEN 
        
	ALTER TABLE spesa ADD id_tab_iva_es integer DEFAULT NULL;
end if; 



//outlook office su utente 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'tipo_mail' )) THEN 
        
	ALTER TABLE utenti ADD tipo_mail char(1) DEFAULT 'N';
	UPDATE utenti set tipo_mail='N';
end if; 


//ARKY NOTE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'arky_note'
        AND      CNAME = 'id_nota_padre' )) THEN 
        
	ALTER TABLE arky_note add id_nota_padre integer default null;
end if; 



//PAR SISTEMA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'dir_prev' )) THEN 
        
	ALTER TABLE par_sistema ADD dir_prev CHAR(256) DEFAULT NULL;

end if; 


//Verifica Aggiornamento Listini
call fn_ins_voce_menu('Utilit', 'w_stampa_pag_libinv_cx', 'Stampa Libro Inventari', 90);


///////////////////////////////////trasf dati parigi
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte9_1') THEN
		
ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte9_1"()
on exception resume
/*
Elisa M. 
Rif. Bolla  4743      05/03/2001

CHIAMATA DA: sp_trasf_dati

Allineamento tabelle anagrafiche per il trasferimento delle Bolle di Vendita

SQLSTATUS
0 The fetch statement completed successfully
1 The fetch statement resulted in an error
2 There is no more data in the result set
*/
begin
  declare err_notfound exception for sqlstate value '02000';
  declare invalid_foreign_key exception for sqlstate value '23503';
  declare row_not_found exception for sqlstate value '02000';
  declare ok exception for sqlstate value '00000';
  declare @li_sqlstatus integer;
  declare @ls_sqlstate char(5);
  declare li_errori integer;
  declare li_max_id_sc integer;
  declare li_max_id_sc_p integer;
  declare @id_unita_conf_base_new integer;
  declare @id_articolo_new integer;
  declare @id_unita_confezione_new integer;

  insert into tmp_log(note) values('');
  insert into tmp_log(note) values('Data Trasferimento: '+string(dateformat(today(*),'dd-mm-yyyy')));
  insert into tmp_log(note) values('');
  insert into tmp_log(note) values('INIZIO ALLINEAMENTO ANAGRAFICHE - '+string(dateformat(Now(*),'hh:mm:ss')));
  insert into tmp_log(note) values('*********************************************************************************');
  commit work;
  /*
  Allineamento della tabella TIPO MAGAZZINO
  */
  insert into tipo_magazzino(codice,descrizione)
    select codice,descrizione
      from tmp_tipo_magazzino
      where not codice=any(select codice from tipo_magazzino);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   TIPO MAGAZZINO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   TIPO MAGAZZINO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando il TIPO MAGAZZINO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando il TIPO MAGAZZINO - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  /*
  Allineamento della tabella MAGAZZINO

  insert into magazzino(codice,descrizione,indirizzo,cap,localita,
    provincia,nazione,note,giac_globale,id_tipo_magazzino,id_azienda)
    select m.codice,m.descrizione,m.indirizzo,m.cap,m.localita,m.provincia,m.nazione,
      m.note,m.giac_globale,
      (select id_tipo_magazzino
        from tipo_magazzino
        where codice=t.codice),1
      from tmp_magazzino as m,tmp_tipo_magazzino as t
      where t.id_tipo_magazzino=m.id_tipo_magazzino
      and not m.codice=any(select codice from magazzino);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   MAGAZZINO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   MAGAZZINO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando il MAGAZZINO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando il MAGAZZINO - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  */
  //
  //
  /*
  Allineamento della tabella LINGUA
  */
  insert into lingua(codice,descrizione)
    select codice,descrizione
      from tmp_lingua
      where not codice=any(select codice from lingua);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   LINGUA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   LINGUA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. LINGUA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. LINGUA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  /*
  Allineamento della tabella LINGUAGGIO
  */
  insert into linguaggio(codice,descrizione)
    select codice,descrizione
      from tmp_linguaggio
      where not codice=any(select codice from linguaggio);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   LINGUAGGIO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   LINGUAGGIO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. LINGUAGGIO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. LINGUAGGIO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella VALUTA
  */
  insert into valuta(codice,descrizione,simbolo,cambio,cifra_arrotondamento,tipo_arrotondamento,
    parita_euro,dec_significativi)
    select codice,descrizione,simbolo,cambio,cifra_arrotondamento,tipo_arrotondamento,
      parita_euro,dec_significativi
      from tmp_valuta
      where not codice=any(select codice from valuta);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   VALUTA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   VALUTA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. VALUTA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. VALUTA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  //
  /*
  Allineamento della tabella LISTINO
  */
  //insert into listino(codice,descrizione,tipo,id_valuta,id_azienda,lis_base)
  //  select l.codice,l.descrizione,l.tipo,
  //    (select id_valuta
  //      from valuta
  //      where codice=v.codice),1,lis_base
  //    from tmp_listino as l,tmp_valuta as v
  //    where v.id_valuta=l.id_valuta
  //    and not l.codice=any(select codice from listino);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   LISTINO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   LISTINO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. LISTINO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. LISTINO- SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //
  //
  /*
  Allineamento della tabella VARIAZIONE
  */
  //insert into variazione(id_listino,data_inizio,data_fine,cambio,max_osc_positiva,max_osc_negativa,
  //  prezzi_ivati)
  //  select(select id_listino
  //      from listino
  //      where codice=l.codice),
  //    v.data_inizio,v.data_fine,v.cambio,v.max_osc_positiva,v.max_osc_negativa,
  //    v.prezzi_ivati
  //    from tmp_variazione as v,tmp_listino as l
  //    where l.id_listino=v.id_listino
  //    and not l.codice||v.data_inizio||ifnull(v.data_fine,'',v.data_fine)
  //    =any(select ll.codice||lv.data_inizio||ifnull(lv.data_fine,'',lv.data_fine)
  //      from listino as ll,variazione as lv
  //      where lv.id_listino=ll.id_listino);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   VARIAZIONE - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   VARIAZIONE - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. VARIAZIONE - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. VARIAZIONE- SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //
  //
  /*
  Allineamento della tabella CON_PAGAMENTO
  */
  insert into CON_PAGAMENTO(codice,
    descrizione,
    sconto_cassa)
    select codice,
      descrizione,
      sconto_cassa
      from TMP_CON_PAGAMENTO
      where not CODICE=any(select CODICE from CON_PAGAMENTO);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CON_PAGAMENTO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CON_PAGAMENTO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CON_PAGAMENTO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CON_PAGAMENTO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  /*
  Allineamento della tabella UNITA_MISURA
  */
  insert into UNITA_MISURA(simbolo,descrizione,tipo,id_unita_misura_riferimento,conversione)
    select simbolo,descrizione,tipo,null,conversione
      from TMP_UNITA_MISURA
      where not simbolo=any(select simbolo from UNITA_MISURA);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   UNITA_MISURA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   UNITA_MISURA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. UNITA_MISURA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. UNITA_MISURA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //  
  //
  /*
  Allineamento della tabella TIPO_TRASPORTO
  */
  insert into tipo_trasporto(codice,
    descrizione,
    spese_gestite)
    select codice,
      descrizione,
      spese_gestite
      from TMP_tipo_trasporto
      where not codice=any(select codice from tipo_trasporto);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   TIPO_TRASPORTO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   TIPO_TRASPORTO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. TIPO_TRASPORTO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TIPO_TRASPORTO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //  
  //
  //  
  //
  /*
  Allineamento della tabella CAUS_TRASPORTO
  */
  insert into caus_trasporto(codice,
    descrizione)
    select codice,
      descrizione
      from TMP_CAUS_TRASPORTO
      where not codice=any(select codice from CAUS_TRASPORTO);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAUS_TRASPORTO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAUS_TRASPORTO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CAUS_TRASPORTO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAUS_TRASPORTO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //  
  //
  /*
  Allineamento della tabella TIPO_PAGAMENTO
  */
  insert into tipo_pagamento(codice,id_gruppo_esp_sospeso,descrizione,mod_stampa,
    ges_cessioni,spese_gestite,perc_tratte,arr_bollo_tratta,imp_min_bollo_tratta,
    id_prof_reg_dare,id_prof_reg_avere,premi_penalita)
    select codice,
      (select id_gruppo_esp_sospeso
        from gruppo_esp_sospeso
        where codice=tmp_tipo_pagamento.cod_gruppo_esp_sospeso),
      descrizione,mod_stampa,ges_cessioni,spese_gestite,
      perc_tratte,arr_bollo_tratta,imp_min_bollo_tratta,
      ifnull(id_prof_reg_dare,null,ifnull((select id_prof_registrazione
        from prof_registrazione
        where codice=tmp_tipo_pagamento.cod_prof_reg_dare),0,
      (select id_prof_registrazione
        from prof_registrazione
        where codice=tmp_tipo_pagamento.cod_prof_reg_dare))),
      ifnull(id_prof_reg_avere,null,ifnull((select id_prof_registrazione
        from prof_registrazione
        where codice=tmp_tipo_pagamento.cod_prof_reg_avere),0,
      (select id_prof_registrazione
        from prof_registrazione
        where codice=tmp_tipo_pagamento.cod_prof_reg_avere))),
      premi_penalita
      from tmp_tipo_pagamento
      where not codice=any(select codice from tipo_pagamento);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   TIPO_PAGAMENTO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   TIPO_PAGAMENTO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. TIPO_PAGAMENTO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TIPO_PAGAMENTO - SQLSTATE:'
      +@ls_sqlstate)
  end if
  ;
  //  
  //
  /*
  Allineamento della tabella AREA

  insert into area(codice,descrizione,id_azienda)
    select codice,descrizione,id_azienda
      from tmp_area
      where not codice=any(select codice from area);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   AREA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   AREA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. AREA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. AREA - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  */
  //  
  //
  /*
  Allineamento della tabella LOCAZIONE

  insert into locazione(id_magazzino,id_area,corsia,scaffale,ripiano,posizione,id_azienda)
    select(select id_magazzino
        from magazzino
        where codice=tmp_locazione.cod_magazzino),
      (select id_area
        from area
        where codice=tmp_locazione.cod_area),
      corsia,scaffale,ripiano,posizione,1
      from tmp_locazione
      where not ifnull(cod_magazzino,'',cod_magazzino)||ifnull(cod_area,'',cod_area)
      ||ifnull(corsia,'',corsia)||ifnull(scaffale,'',scaffale)
      ||ifnull(ripiano,'',ripiano)||ifnull(posizione,'',posizione)
      =any(select ifnull(m.codice,'',m.codice)||ifnull(a.codice,'',a.codice)
        ||ifnull(l.corsia,'',l.corsia)||ifnull(l.scaffale,'',l.scaffale)
        ||ifnull(l.ripiano,'',l.ripiano)||ifnull(l.posizione,'',l.posizione)
        from locazione as l,magazzino as m,area as a
        where m.id_magazzino=l.id_magazzino
        and a.id_area=*l.id_area);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   LOCAZIONE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   LOCAZIONE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. LOCAZIONE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. LOCAZIONE - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  */
  //  
  //
  /*
  Allineamento della tabella CAUS_MAGAZZINO
  */
  insert into caus_magazzino(codice,
    descrizione,mag_par_richiesto,mag_des_richiesto,gen_doc_successivi,mp_qta_rim_iniziale,
    mp_val_rim_iniziale,mp_car_fiscali,mp_val_caricato,mp_scar_fiscali,mp_val_scaricato,
    mp_ord_clienti,mp_ord_fornitori,mp_vis_clienti,mp_vis_fornitori,mp_imp_produzione,
    mp_ord_produzione,mp_qta_cl_clienti,mp_qta_cl_fornitori,mp_qta_cl_terzi,
    mp_gruppo_lib_1,mp_gruppo_lib_2,mp_gruppo_lib_3,mp_gruppo_lib_4,mp_ult_costo,
    md_qta_rim_iniziale,md_val_rim_iniziale,md_car_fiscali,md_val_caricato,
    md_scar_fiscali,md_val_scaricato,md_ord_clienti,md_ord_fornitori,md_vis_clienti,
    md_vis_fornitori,md_imp_produzione,md_ord_produzione,md_qta_cl_clienti,md_qta_cl_fornitori,
    md_qta_cl_terzi,md_gruppo_lib_1,md_gruppo_lib_2,md_gruppo_lib_3,md_gruppo_lib_4,
    md_ult_costo,id_azienda,gestisce_lotti,mp_ult_scarico,tipo_valorizzazione,
    md_ult_scarico)
    select codice,descrizione,mag_par_richiesto,mag_des_richiesto,gen_doc_successivi,mp_qta_rim_iniziale,
      mp_val_rim_iniziale,mp_car_fiscali,mp_val_caricato,mp_scar_fiscali,mp_val_scaricato,
      mp_ord_clienti,mp_ord_fornitori,mp_vis_clienti,mp_vis_fornitori,mp_imp_produzione,
      mp_ord_produzione,mp_qta_cl_clienti,mp_qta_cl_fornitori,mp_qta_cl_terzi,
      mp_gruppo_lib_1,mp_gruppo_lib_2,mp_gruppo_lib_3,mp_gruppo_lib_4,mp_ult_costo,
      md_qta_rim_iniziale,md_val_rim_iniziale,md_car_fiscali,md_val_caricato,
      md_scar_fiscali,md_val_scaricato,md_ord_clienti,md_ord_fornitori,md_vis_clienti,
      md_vis_fornitori,md_imp_produzione,md_ord_produzione,md_qta_cl_clienti,md_qta_cl_fornitori,
      md_qta_cl_terzi,md_gruppo_lib_1,md_gruppo_lib_2,md_gruppo_lib_3,md_gruppo_lib_4,
      md_ult_costo,id_azienda,gestisce_lotti,mp_ult_scarico,tipo_valorizzazione,md_ult_scarico
      from tmp_caus_magazzino
      where not codice=any(select codice from caus_magazzino);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAUS_MAGAZZINO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAUS_MAGAZZINO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CAUS_MAGAZZINO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAUS_MAGAZZINO - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //  
  //
  //  
  //
  /*
  Allineamento della tabella TAB_IVA
  */
  insert into tab_iva(codice,des_breve,des_estesa,tipo_iva,per_aliquota,
    per_detrazione,per_ventilazione,ges_plafond,ges_oper_intracomunitarie,
    imp_min_fattura,imp_bollo_fattura,ges_beni_rivendita,ges_beni_strumentali)
    select codice,des_breve,des_estesa,tipo_iva,per_aliquota,
      per_detrazione,per_ventilazione,ges_plafond,ges_oper_intracomunitarie,
      imp_min_fattura,imp_bollo_fattura,ges_beni_rivendita,ges_beni_strumentali
      from tmp_tab_iva
      where not codice=any(select codice from tab_iva);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   TAB_IVA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   TAB_IVA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. TAB_IVA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TAB_IVA - SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //  
  //
  /*
  Allineamento della tabella BILANCIO_CEE
  */
  //insert into bilancio_cee(descrizione,
  //  riferimento,tipo,pos1,
  //  pos2,pos3,pos4,flag,SEGNO,saldo1,
  //  saldo2)
  //  select descrizione,riferimento,tipo,pos1,
  //    pos2,pos3,pos4,flag,SEGNO,saldo1,saldo2
  //    from tmp_bilancio_cee
  //    where not riferimento=any(select riferimento from bilancio_cee);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   BILANCIO_CEE - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   BILANCIO_CEE - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. BILANCIO_CEE - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. BILANCIO_CEE - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //
  /*
  Allineamento della tabella PDC
  */
  //insert into pdc(codice,descrizione)
  //  select codice,descrizione
  //    from tmp_pdc
  //    where not codice=any(select codice from pdc);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   PDC - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   PDC - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. PDC - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. PDC - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //
  /*
  Allineamento della tabella MASTRO
  */
  //insert into mastro(id_pdc,codice,descrizione,tipo,id_azienda,id_bilancio_cee)
  //  select(select id_pdc
  //      from pdc
  //      where codice=tmp_mastro.cod_pdc),
  //    codice,descrizione,tipo,1,
  //    (select id_bilancio_cee from bilancio_cee where riferimento=tmp_mastro.rif_bilancio_cee)
  //    from tmp_mastro
  //    where not codice||cod_pdc
  //    =any(select m.codice||p.codice
  //      from mastro as m,pdc as p
  //      where p.id_pdc=m.id_pdc);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   MASTRO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   MASTRO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. MASTRO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. MASTRO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //
  /*
  Allineamento della tabella SOTTOMASTRO
  */
  //insert into sottomastro(id_mastro,codice,descrizione,uso,id_azienda,id_bilancio_cee)
  //  select(select m.id_mastro
  //      from mastro as m,pdc as p
  //      where m.codice=tmp_sottomastro.cod_mastro
  //      and p.codice=tmp_sottomastro.cod_pdc
  //      and m.id_pdc=p.id_pdc),codice,descrizione,uso,1,
  //    (select id_bilancio_cee from bilancio_cee where riferimento=tmp_sottomastro.rif_bilancio_cee)
  //    from tmp_sottomastro
  //    where not cod_mastro||codice
  //    =any(select m.codice||s.codice
  //      from mastro as m,sottomastro as s
  //      where s.id_mastro=m.id_mastro);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   SOTTOMASTRO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   SOTTOMASTRO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. SOTTOMASTRO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SOTTOMASTRO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //
  /*
  Allineamento della tabella TITOLO
  */
  //insert into titolo(titolo)
  //  select titolo
  //    from tmp_titolo
  //    where not trim(titolo)=any(select trim(titolo) from titolo);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   TITOLO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   TITOLO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. TITOLO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TITOLO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  //  
  //
  /*
  Allineamento della tabella ATT_SVOLTA
  */
  //insert into att_svolta(codice,descrizione)
  //  select codice,descrizione
  //    from tmp_att_svolta
  //    where not codice=any(select codice from att_svolta);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   ATT_SVOLTA - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   ATT_SVOLTA - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. ATT_SVOLTA - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. ATT_SVOLTA - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella TRIBUTO
  */
  //insert into tributo(codice,cod_tributo,descrizione,gruppo,per_imponibile,
  //  per_tributo,inizio_per_validita,fine_per_validita,mod_fiscale)
  //  select codice,cod_tributo,descrizione,gruppo,per_imponibile,per_tributo,inizio_per_validita,
  //    fine_per_validita,mod_fiscale
  //    from tmp_tributo
  //    where not codice=any(select codice from tributo);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   TRIBUTO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   TRIBUTO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. TRIBUTO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TRIBUTO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  /*
  Allineamento della tabella ANAGRAFICA
  BL#13377# -	Correzione Anagrafica
  */
  //insert into anagrafica(rag_soc_1,
  //  rag_soc_2,indirizzo,cap,localita,provincia,nazione,cod_fiscale,par_iva,
  //  id_lingua,id_linguaggio,nat_giuridica,prov_contabile,id_valuta,id_tipo_trasporto,
  //  id_titolo,id_att_svolta,id_tributo,cog_ritenute,nome_ritenute,sesso,ind_ritenute,
  //  cap_ritenute,loc_ritenute,prov_ritenute,naz_ritenute,data_nas_ritenute,luogo_nas_ritenute,
  //  prov_nas_ritenute,naz_nas_ritenute,con_previdenziale,cassa_previdenza,rit_previdenziale,
  //  isc_enasarco,per_enasarco_agente,per_enasarco_conto_agente,id_azienda,
  //  bollo,codice)
  //  select rag_soc_1,rag_soc_2,indirizzo,cap,localita,provincia,nazione,cod_fiscale,par_iva,
  //    (select id_lingua from lingua where codice=tmp_anagrafica.cod_lingua),
  //    (select id_linguaggio from linguaggio where codice=tmp_anagrafica.cod_linguaggio),
  //    nat_giuridica,prov_contabile,
  //    (select id_valuta from valuta where codice=tmp_anagrafica.cod_valuta),
  //    (select id_tipo_trasporto from tipo_trasporto where codice=tmp_anagrafica.cod_tipo_trasporto),
  //    (select id_titolo from titolo where trim(titolo)=trim(tmp_anagrafica.titolo)),
  //    (select id_att_svolta from att_svolta where codice=tmp_anagrafica.cod_att_svolta),
  //    (select id_tributo from tributo where codice=tmp_anagrafica.cod_tributo),cog_ritenute,
  //    nome_ritenute,sesso,ind_ritenute,
  //    cap_ritenute,loc_ritenute,prov_ritenute,naz_ritenute,data_nas_ritenute,
  //    luogo_nas_ritenute,
  //    prov_nas_ritenute,naz_nas_ritenute,con_previdenziale,cassa_previdenza,rit_previdenziale,
  //    isc_enasarco,per_enasarco_agente,per_enasarco_conto_agente,
  //    1,bollo,codice
  //    from tmp_anagrafica
  //    where rag_soc_1 is not null
  //    and not codice=any(select codice
  //      from anagrafica
  //      where codice=tmp_anagrafica.codice);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   ANAGRAFICA - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   ANAGRAFICA - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. ANAGRAFICA - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. ANAGRAFICA - SQLSTATE:'
  //    +@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella GRUPPO
  BL#13377# -	Correzione Anagrafica
  */
  //insert into gruppo(codice,descrizione,id_anagrafica,note,fido,id_azienda)
  //  select tg.codice,tg.descrizione,
  //    (select id_anagrafica
  //      from anagrafica
  //      where codice=ta.codice),tg.note,tg.fido,tg.id_azienda
  //    from tmp_gruppo as tg,tmp_anagrafica as ta
  //    where ta.id_anagrafica=tg.id_anagrafica
  //    and not tg.codice=any(select codice from gruppo);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   GRUPPO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   GRUPPO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. GRUPPO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. GRUPPO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella CONTO
  */
  //insert into conto(codice,id_sottomastro,descrizione,id_gruppo,ges_par_aperte,id_azienda,id_bilancio_cee)
  //  select tc.codice,
  //    (select id_sottomastro
  //      from sottomastro as s,mastro as m,pdc as p
  //      where p.codice=tc.cod_pdc
  //      and m.codice=tc.cod_mastro
  //      and m.id_pdc=p.id_pdc
  //      and s.codice=tc.cod_sottomastro
  //      and s.id_mastro=m.id_mastro),
  //    tc.descrizione,
  //    (select id_gruppo from gruppo where codice=tc.cod_gruppo),
  //    tc.ges_par_aperte,1,
  //    (select id_bilancio_cee from bilancio_cee where riferimento=tc.rif_bilancio_cee)
  //    from tmp_conto as tc
  //    where not codice||cod_sottomastro||cod_mastro||cod_pdc
  //    =any(select c.codice||s.codice||m.codice||p.codice
  //      from conto as c,sottomastro as s,mastro as m,pdc as p
  //      where s.id_sottomastro=c.id_sottomastro
  //      and m.id_mastro=s.id_mastro
  //      and p.id_pdc=m.id_pdc
  //      and p.codice=tc.cod_pdc
  //      and m.codice=tc.cod_mastro
  //      and s.codice=tc.cod_sottomastro);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   CONTO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   CONTO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. CONTO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CONTO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  //select "MAX"(id_sog_commerciale) into li_max_id_sc
  //  from sog_commerciale;
  //  
  //  
  /*
  Allineamento della tabella SOG_COMMERCIALE
  N.B.: Nei campi non obbligatori se non viene trovato l'id corrispondente, non viene
  dato nessun errore, pero' tutti i valori mancanti dovrebbero essere stati
  inseriti prima (conto, ecc...).

  BL#13377#	-	Modifica AK ANAGRAFICA
  */
  //insert into sog_commerciale(codice,
  //  id_anagrafica,tipo,id_conto,data_acquisizione,data_trasformazione,ns_cod_soggetto,
  //  id_linguaggio,id_cat_attivita,id_cat_com_sc,id_cat_zona,id_magazzino,fido,
  //  extrafido,con_fido,id_con_pagamento,data_dec_pagamenti,giorno_fisso_pagamenti,scad_raggruppate,
  //  id_banca_sog_commerciale,id_listino,id_tipo_trasporto,id_sog_com_vettore,per_fatturazione,
  //  modo_fatturazione,con_fattura,fat_sos_iva,id_tab_iva,num_ns_prot_documenti,data_ns_prot_documenti,
  //  num_lr_prot_documenti,data_lr_prot_documenti,uff_iva,id_prof_registrazione,id_tributo,
  //  id_att_svolta,id_gruppo_agenti,id_azienda,id_tipo_agente,imp_fisso,id_valuta,giorni_franchigia,
  //  id_val_prov_agente,crea_gruppo_agenti,imp_fisso_ult_elab,imp_premio_budget,ult_elab_definitivo,
  //  prec_elab_definitivo,id_tab_iva_fat_prov,id_gruppo_Agenti_2,
  //  id_sog_com_vettore_2)
  //  select codice,
  //    (select id_anagrafica
  //      from anagrafica
  //      where codice=tmp_sog_commerciale.codice_anagrafica) as id_anagrafica_l,
  //    tipo,
  //    (select id_conto from conto where codice=tmp_sog_commerciale.cod_conto),
  //    data_acquisizione,data_trasformazione,ns_cod_soggetto,
  //    (select id_linguaggio from linguaggio where codice=tmp_sog_commerciale.cod_linguaggio),
  //    (select id_cat_attivita from cat_attivita where codice=tmp_sog_commerciale.cod_cat_attivita),
  //    (select id_cat_com_sc from cat_com_sc where codice=tmp_sog_commerciale.cod_cat_com_sc),
  //    (select id_cat_zona from cat_zona where codice=tmp_sog_commerciale.cod_cat_zona),
  //    (select id_magazzino from magazzino where codice=tmp_sog_commerciale.cod_magazzino),fido,
  //    extrafido,con_fido,
  //    (select id_con_pagamento from con_pagamento where codice=tmp_sog_commerciale.cod_con_pagamento),
  //    data_dec_pagamenti,giorno_fisso_pagamenti,scad_raggruppate,
  //    (select id_banca_sog_commerciale
  //      from banca_sog_commerciale as bs,banca_appoggio as ba
  //      where bs.id_anagrafica=id_anagrafica_l
  //      and ba.cod_abi=tmp_sog_commerciale.cod_abi
  //      and ba.cod_cab=tmp_sog_commerciale.cod_cab
  //      and bs.id_banca_appoggio=ba.id_banca_appoggio),
  //    (select id_listino from listino where codice=tmp_sog_commerciale.cod_listino),
  //    (select id_tipo_trasporto
  //      from tipo_trasporto
  //      where codice=tmp_sog_commerciale.cod_tipo_trasporto),
  //    null,per_fatturazione,modo_fatturazione,con_fattura,fat_sos_iva,
  //    (select id_tab_iva from tab_iva where codice=tmp_sog_commerciale.cod_tab_iva),
  //    num_ns_prot_documenti,data_ns_prot_documenti,
  //    num_lr_prot_documenti,data_lr_prot_documenti,uff_iva,
  //    (select id_prof_registrazione from prof_registrazione
  //      where codice=tmp_sog_commerciale.id_prof_registrazione),
  //    (select id_tributo from tributo where codice=tmp_sog_commerciale.cod_tributo),
  //    (select id_att_svolta from att_svolta where codice=tmp_sog_commerciale.cod_att_svolta),
  //    (select id_gruppo_agenti from gruppo_agenti where codice=tmp_sog_commerciale.cod_gruppo_agenti),
  //    1,(select id_tipo_agente from tipo_agente where codice=tmp_sog_commerciale.cod_tipo_agente),
  //    imp_fisso,(select id_valuta from valuta where codice=tmp_sog_commerciale.cod_valuta),
  //    giorni_franchigia,
  //    (select id_valuta from valuta where codice=cod_val_prov_agente),crea_gruppo_agenti,
  //    imp_fisso_ult_elab,imp_premio_budget,ult_elab_definitivo,
  //    prec_elab_definitivo,(select id_tab_iva from tab_iva where codice=tmp_sog_commerciale.cod_tab_iva_fat_prov),
  //    (select codice from gruppo_agenti where codice=tmp_sog_commerciale.cod_gruppo_Agenti_2),
  //    null
  //    from tmp_sog_commerciale
  //    where not codice=any(select codice from sog_commerciale where codice=tmp_sog_commerciale.codice)
  //    and codice is not null;
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   SOG_COMMERCIALE - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   SOG_COMMERCIALE - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. SOG_COMMERCIALE - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SOG_COMMERCIALE - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  //  
  //select "MAX"(id_sog_commerciale) into li_max_id_sc_p
  //  from sog_commerciale;
  //  
  //  
  // Aggiorno i vettori nei sogg. commerciali passati.
  //update sog_commerciale as s
  //  ,tmp_sog_commerciale as t set
  //  s.id_sog_com_vettore=(select sv.id_sog_commerciale
  //    from sog_commerciale as sv
  //    where sv.codice=t.cod_sog_com_vettore),
  //  s.id_sog_com_vettore_2=(select sv.id_sog_commerciale
  //    from sog_commerciale as sv
  //    where sv.codice=t.cod_sog_com_vettore_2)
  //  where t.codice=s.codice
  //  and s.id_sog_commerciale>=li_max_id_sc
  //  and s.id_sog_commerciale<=li_max_id_sc_p;
  //  
  //
  //
  /*
  Allineamento della tabella DESTINAZIONE
  */
  //insert into destinazione(id_sog_commerciale,
  //  id_cat_attivita,rag_soc_1,rag_soc_2,id_cat_com_sc,id_cat_zona,
  //  indirizzo,cap,localita,provincia,nazione,tipo_destinazione,id_magazzino,
  //  id_gruppo_agenti,id_azienda,id_gruppo_Agenti_2,
  //  id_con_pagamento,codice)
  //  select(select id_sog_commerciale
  //      from sog_commerciale
  //      where codice=ts.codice),
  //    (select id_cat_attivita
  //      from cat_attivita
  //      where codice=tca.codice),
  //    t.rag_soc_1,t.rag_soc_2,
  //    (select id_cat_com_sc
  //      from cat_com_sc
  //      where codice=tcc.codice),
  //    (select id_cat_zona
  //      from cat_zona
  //      where codice=tcz.codice),
  //    t.indirizzo,t.cap,t.localita,t.provincia,t.nazione,t.tipo_destinazione,
  //    null,
  //    (select id_gruppo_agenti
  //      from gruppo_agenti
  //      where codice=tga1.codice),
  //    1,
  //    (select id_gruppo_agenti
  //      from gruppo_agenti
  //      where codice=tga2.codice),
  //    (select id_con_pagamento
  //      from con_pagamento
  //      where codice=tcp.codice),t.codice
  //    from tmp_destinazione as t,tmp_sog_commerciale as ts,tmp_cat_attivita as tca
  //    ,tmp_cat_com_sc as tcc,tmp_cat_zona as tcz,tmp_locazione as tl,tmp_area as ta
  //    ,tmp_magazzino as tm,tmp_con_pagamento as tcp,tmp_gruppo_agenti as tga1
  //    ,tmp_gruppo_agenti as tga2
  //    where ts.id_sog_commerciale=t.id_sog_commerciale
  //    and tca.id_cat_attivita=*t.id_cat_attivita
  //    and tcc.id_cat_com_sc=*t.id_cat_com_sc
  //    and tcz.id_cat_zona=*t.id_cat_zona
  //    and tcp.id_con_pagamento=*t.id_con_pagamento
  //    and tga1.id_gruppo_agenti=*t.id_gruppo_agenti
  //    and tga2.id_gruppo_agenti=*t.id_gruppo_agenti_2
  //    and tl.id_locazione=*t.id_magazzino
  //    and tm.id_magazzino=*tl.id_magazzino
  //    and ta.id_area=*tl.id_area
  //    and not t.codice=any(select d.codice
  //      from destinazione as d,sog_commerciale as s
  //      where s.id_sog_commerciale=d.id_sog_commerciale
  //      and s.codice=ts.codice
  //      and d.codice=t.codice);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   DESTINAZIONE - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   DESTINAZIONE - record trasferiti:'+string(@@rowcount));
  //  commit work
  //else
  //  message '   Si e'' verificato un errore importando le DESTINAZIONI - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando le DESTINAZIONI - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //
  //
  /*
  Allineamento della tabella TAB_ATTIVITA
  */
  //insert into tab_attivita(codice,descrizione)
  //  select codice,descrizione
  //    from tmp_tab_attivita
  //    where not codice=any(select codice from tab_attivita);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   TAB_ATTIVITA - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   TAB_ATTIVITA - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. TAB_ATTIVITA - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. TAB_ATTIVITA - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  //  
  //  
  /*
  Allineamento della tabella ATTIVITA
  */
  //insert into attivita(id_tab_attivita,descrizione,ges_ventilazione,liq_iva,tipo_contabilita,
  //  id_azienda,attuale_plafond)
  //  select(select id_tab_attivita from tab_attivita where codice=tmp_attivita.cod_tab_attivita),
  //    descrizione,ges_ventilazione,liq_iva,tipo_contabilita,id_azienda,attuale_plafond
  //    from tmp_attivita
  //    where not cod_tab_attivita||descrizione
  //    =any(select t.codice||a.descrizione
  //      from tab_attivita as t,attivita as a
  //      where a.id_tab_attivita=t.id_tab_attivita);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   ATTIVITA - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   ATTIVITA - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. ATTIVITA - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. ATTIVITA - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella MOD_REGISTRO
  */
  //insert into mod_registro(tipo_registro,numero,descrizione,id_attivita,usa_prorata,
  //  iva_sospensione,ges_sco_giornaliero,id_azienda)
  //  select tipo_registro,numero,descrizione,
  //    (select id_attivita from attivita as a,tab_attivita as t
  //      where t.codice=tmp_mod_registro.cod_tab_attivita
  //     and a.id_tab_attivita=t.id_tab_attivita
  //      and a.descrizione=tmp_mod_registro.des_attivita),usa_prorata,
  //    iva_sospensione,ges_sco_giornaliero,1
  //    from tmp_mod_registro
  //    where not tipo_registro||numero
  //    =any(select tipo_registro||numero
  //      from mod_registro);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   MOD_REGISTRO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   MOD_REGISTRO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. MOD_REGISTRO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. MOD_REGISTRO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella ESERCIZIO
  */
  //insert into esercizio(codice,data_inizio,data_fine,bloccato,ult_data_stampa_bollato,
  //  num_progressivo,id_azienda,riporto,prog_scritture,id_valuta)
  //  select codice,data_inizio,data_fine,bloccato,ult_data_stampa_bollato,
  //    num_progressivo,1,riporto,prog_scritture,(select id_valuta from valuta
  //      where codice=tmp_esercizio.cod_valuta)
  //    from tmp_esercizio
  //    where not codice
  //    =any(select codice
  //      from esercizio);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   ESERCIZIO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   ESERCIZIO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. ESERCIZIO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. ESERCIZIO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella REGISTRO
  */
  //insert into registro(id_esercizio,tipo_registro,id_mod_registro,numero,
  //  descrizione,id_attivita,usa_prorata,iva_sospensione,ges_sco_giornaliero,id_azienda,PERC_PRORATA)
  //  select(select id_esercizio from esercizio where codice=tmp_registro.cod_esercizio),
  //    tipo_registro,(select id_mod_registro from mod_registro
  //      where tipo_registro=tmp_registro.mod_tipo_registro
  //      and numero=tmp_registro.mod_num_registro),numero,
  //    descrizione,
  //    (select id_attivita from attivita as a,tab_attivita as t
  //      where t.codice=tmp_registro.cod_tab_attivita
  //      and a.id_tab_attivita=t.id_tab_attivita
  //      and a.descrizione=tmp_registro.des_attivita),
  //    usa_prorata,iva_sospensione,ges_sco_giornaliero,1,PERC_PRORATA
  //    from tmp_registro
  //    where not cod_esercizio||tipo_registro||numero
  //    =any(select e.codice||r.tipo_registro||r.numero
  //      from esercizio as e,registro as r
  //      where r.id_esercizio=e.id_esercizio);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   REGISTRO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   REGISTRO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. REGISTRO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. REGISTRO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //  
  /*
  Allineamento della tabella PROF_DOCUMENTO
  N.B.: I magazzini non li riporto perch+ non vengono usati, vengono usate solo
  le locazioni che includono anche il magazzino.
  */
  //insert into prof_documento(id_caus_magazzino_prop,id_prof_registrazione,codice,
  //  descrizione,des_stampa,tipo_registro,ric_id_registro,ric_num_progressivo,id_mod_registro_prop,
  //  con_data_progressiva,ric_num_documento,note_intestazione_prop,ric_id_caus_magazzino,int_consentiti,
  //  ric_id_sog_comm,id_sog_comm_prop,ric_id_magazzino_1,id_magazzino_1_prop,ric_id_magazzino_2,
  //  id_magazzino_2_prop,ric_id_sog_comm_fattura,id_sog_comm_fattura_prop,ric_lingua_linguaggio,
  //  id_linguaggio_prop,id_lingua_prop,ric_id_valuta,id_valuta_prop,ric_id_listino,
  //  id_listino_prop,ric_id_con_pagamento,id_con_pagamento_prop,ric_scadenze,ric_id_sog_comm_agente,
  //  ric_provvigioni,ric_data_consegna,gg_consegna,ric_sconti_finanziari,spese_gestite,
  //  ric_acconti,ric_date_competenza,ric_colli_documento,ric_pesi,ric_volumi,ric_id_tipo_trasporto,
  //  ric_id_caus_trasporto,ric_asp_beni,aspetto_beni_prop,ric_trasp_mezzo,trasp_mezzo_prop,
  //  ric_id_sog_comm_vettore_1,id_sog_comm_vettore_1_prop,ric_mezzo_trasporto,ric_data_trasporto,
  //  stampabile,stampa_immediata,ges_pac_list,ges_evas_parziale,ges_db,ges_matricole,
  //  con_dis_articoli,ges_chius_forzata,ges_stato_documento,tipo_raggruppamento,usa_int_fattura,
  //  contabilizzabile,des_contabile,ric_id_unita_confezione_riga,ric_quantita_riga,quantita_prop_riga,
  //  ric_unita_base_riga,ric_unita_prezzo_riga,ric_id_caus_magazzino_riga,ric_locazione_1_riga,
  //  ric_locazione_2_riga,ric_data_prev_consegna_riga,ric_pesi_riga,ric_dim_riga,ric_colli_riga,
  //  ric_id_valuta_riga,ric_id_listino_riga,ric_prezzo_riga,ric_sconto_riga,ric_prezzo_netto_riga,
  //  ric_sconto_riga_riga,ric_id_tab_iva_riga,ric_id_sog_comm_agente_riga,ric_provvigioni_riga,
  //  ric_val_attribuito_riga,ric_date_competenza_riga,ric_contropartite_riga,evas_virtuale,
  //  stampa_bloccante,contr_esen_der,cambio_rical_der,stato_scad_generata,pas_di_sblocco,
  //  pas_chiu_forz,tipo_fattura,nome_report,id_azienda,ric_tipo_fattura,id_locazione_1_prop,
  //  id_locazione_2_prop,ric_data_documento,fat_anticipo,id_caus_trasporto_prop,id_sog_comm_vettore_2_prop,
  //  ric_data_scadenza,gg_scadenza,non_vis_pag_trasporto,non_vis_pag_totali,non_vis_pag_contropartite,
  //  con_scorta_articoli)
  //  select(select id_caus_magazzino
  //      from caus_magazzino
  //      where codice=tmp_prof_documento.cod_caus_magazzino_prop),
  //    (select id_prof_registrazione
  //      from prof_registrazione
  //      where codice=tmp_prof_documento.cod_prof_registrazione),
  //    codice,descrizione,des_stampa,tipo_registro,ric_id_registro,ric_num_progressivo,
  //    (select id_mod_registro
  //      from mod_registro
  //      where tipo_registro=tmp_prof_documento.mod_tipo_registro
  //      and numero=tmp_prof_documento.mod_num_registro),
  //    con_data_progressiva,ric_num_documento,note_intestazione_prop,ric_id_caus_magazzino,
  //    int_consentiti,ric_id_sog_comm,id_sog_comm_prop,ric_id_magazzino_1,
  //    null,ric_id_magazzino_2,null,ric_id_sog_comm_fattura,
  //    (select id_sog_commerciale from sog_commerciale where codice=tmp_prof_documento.cod_sog_comm_prop),
  //    ric_lingua_linguaggio,
  //    (select id_linguaggio from linguaggio where codice=tmp_prof_documento.cod_linguaggio_prop),
  //    (select id_lingua from lingua where codice=tmp_prof_documento.cod_lingua_prop),
  //    ric_id_valuta,(select id_valuta from valuta where codice=cod_valuta_prop),
  //    ric_id_listino,(select id_listino from listino where codice=tmp_prof_documento.cod_listino_prop),
  //    ric_id_con_pagamento,
  //    (select id_con_pagamento from con_pagamento where codice=tmp_prof_documento.cod_con_pagamento_prop),
  //    ric_scadenze,ric_id_sog_comm_agente,ric_provvigioni,ric_data_consegna,gg_consegna,ric_sconti_finanziari,
  //    spese_gestite,ric_acconti,ric_date_competenza,ric_colli_documento,ric_pesi,ric_volumi,
  //    ric_id_tipo_trasporto,
  //    ric_id_caus_trasporto,ric_asp_beni,aspetto_beni_prop,ric_trasp_mezzo,trasp_mezzo_prop,
  //    ric_id_sog_comm_vettore_1,
  //    (select id_sog_commerciale from sog_commerciale where codice=tmp_prof_documento.cod_sog_comm_vettore_1_prop),
  //    ric_mezzo_trasporto,ric_data_trasporto,
  //    stampabile,stampa_immediata,ges_pac_list,ges_evas_parziale,ges_db,ges_matricole,
  //    con_dis_articoli,ges_chius_forzata,ges_stato_documento,tipo_raggruppamento,usa_int_fattura,
  //    contabilizzabile,des_contabile,ric_id_unita_confezione_riga,ric_quantita_riga,quantita_prop_riga,
  //    ric_unita_base_riga,ric_unita_prezzo_riga,ric_id_caus_magazzino_riga,ric_locazione_1_riga,
  //    ric_locazione_2_riga,ric_data_prev_consegna_riga,ric_pesi_riga,ric_dim_riga,ric_colli_riga,
  //    ric_id_valuta_riga,ric_id_listino_riga,ric_prezzo_riga,ric_sconto_riga,ric_prezzo_netto_riga,
  //    ric_sconto_riga_riga,ric_id_tab_iva_riga,ric_id_sog_comm_agente_riga,ric_provvigioni_riga,
  //    ric_val_attribuito_riga,ric_date_competenza_riga,ric_contropartite_riga,evas_virtuale,
  //    stampa_bloccante,contr_esen_der,cambio_rical_der,stato_scad_generata,pas_di_sblocco,
  //    pas_chiu_forz,tipo_fattura,nome_report,1,ric_tipo_fattura,
  //    (select l.id_locazione
  //      from locazione as l,magazzino as m,area as a
  //      where a.codice=tmp_prof_documento.cod_area_1
  //      and m.codice=tmp_prof_documento.cod_magazzino_1
  //      and l.id_magazzino=m.id_magazzino
  //      and l.id_area=a.id_area
  //      and ifnull(l.corsia,'',l.corsia)=ifnull(tmp_prof_documento.corsia_1,'',tmp_prof_documento.corsia_1)
  //      and ifnull(l.scaffale,'',l.scaffale)=ifnull(tmp_prof_documento.scaffale_1,'',tmp_prof_documento.scaffale_1)
  //      and ifnull(l.ripiano,'',l.ripiano)=ifnull(tmp_prof_documento.ripiano_1,'',tmp_prof_documento.ripiano_1)
  //      and ifnull(l.posizione,'',l.posizione)=ifnull(tmp_prof_documento.posizione_1,'',tmp_prof_documento.posizione_1)),
  //    (select l.id_locazione
  //      from locazione as l,magazzino as m,area as a
  //      where a.codice=tmp_prof_documento.cod_area_2
  //      and m.codice=tmp_prof_documento.cod_magazzino_2
  //      and l.id_magazzino=m.id_magazzino
  //      and l.id_area=a.id_area
  //      and ifnull(l.corsia,'',l.corsia)=ifnull(tmp_prof_documento.corsia_2,'',tmp_prof_documento.corsia_2)
  //      and ifnull(l.scaffale,'',l.scaffale)=ifnull(tmp_prof_documento.scaffale_2,'',tmp_prof_documento.scaffale_2)
  //      and ifnull(l.ripiano,'',l.ripiano)=ifnull(tmp_prof_documento.ripiano_2,'',tmp_prof_documento.ripiano_2)
  //      and ifnull(l.posizione,'',l.posizione)=ifnull(tmp_prof_documento.posizione_2,'',tmp_prof_documento.posizione_2)),
  //    ric_data_documento,fat_anticipo,
  //    (select id_caus_trasporto from caus_trasporto where codice=tmp_prof_documento.cod_caus_trasporto_prop),
  //    (select id_sog_commerciale from sog_commerciale where codice=tmp_prof_documento.cod_sog_comm_vettore_2_prop),
  //    ric_data_scadenza,gg_scadenza,non_vis_pag_trasporto,non_vis_pag_totali,
  //    non_vis_pag_contropartite,
  //    con_scorta_articoli
  //    from tmp_prof_documento
  //    where not codice=any(select codice from prof_documento where codice=tmp_prof_documento.codice);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   PROF_DOCUMENTO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   PROF_DOCUMENTO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. PROF_DOCUMENTO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. PROF_DOCUMENTO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //  
  //      
  /*
  CODIFICA ARTICOLI     -   Inizio
  */
  /*
  Allineamento della tabella SCOMPOSIZIONE
  */
  insert into scomposizione(codice,descrizione,id_azienda)
    select codice,descrizione,1
      from tmp_scomposizione
      where not codice=any(select codice from scomposizione);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   SCOMPOSIZIONE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   SCOMPOSIZIONE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. SCOMPOSIZIONE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SCOMPOSIZIONE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //
  //
  /*
  Allineamento della tabella CAT_CODIFICA
  */
  insert into cat_codifica(codice,id_scomposizione,descrizione,lun_fissa,id_azienda)
    select tmp_cat_codifica.codice,
      (select id_scomposizione
        from scomposizione
        where codice=tmp_scomposizione.codice),
      tmp_cat_codifica.descrizione,tmp_cat_codifica.lun_fissa,1
      from tmp_cat_codifica,tmp_scomposizione
      where tmp_scomposizione.id_scomposizione=tmp_cat_codifica.id_scomposizione
      and not tmp_cat_codifica.codice||tmp_scomposizione.codice
      =any(select c.codice||s.codice
        from cat_codifica as c,scomposizione as s
        where s.id_scomposizione=c.id_scomposizione
        and c.codice=tmp_cat_codifica.codice
        and s.codice=tmp_scomposizione.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAT_CODIFICA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAT_CODIFICA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CAT_CODIFICA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAT_CODIFICA - SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //  
  //
  /*
  Allineamento della tabella PARTE_REGOLA
  */
  insert into parte_regola(num_sezione,id_scomposizione,descrizione,lunghezza,
    progressivo,variante,id_azienda)
    select tmp_parte_regola.num_sezione,
      (select id_scomposizione
        from scomposizione
        where codice=tmp_scomposizione.codice),
      tmp_parte_regola.descrizione,tmp_parte_regola.lunghezza,tmp_parte_regola.progressivo,
      tmp_parte_regola.variante,1
      from tmp_parte_regola,tmp_scomposizione
      where tmp_scomposizione.id_scomposizione=tmp_parte_regola.id_scomposizione
      and not tmp_parte_regola.num_sezione||tmp_scomposizione.codice
      =any(select p.num_sezione||s.codice
        from parte_regola as p,scomposizione as s
        where s.id_scomposizione=p.id_scomposizione
        and p.num_sezione=tmp_parte_regola.num_sezione
        and s.codice=tmp_scomposizione.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   PARTE_REGOLA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   PARTE_REGOLA - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. PARTE_REGOLA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. PARTE_REGOLA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //  
  //
  /*
  Allineamento della tabella COD_PARTE
  */
  insert into cod_parte(id_cat_codifica,id_parte_regola,mas_input,tipo_richiesta,
    val_proposto,car_riempimento,solo_in_elenco,id_azienda)
    select(select c.id_cat_codifica
        from cat_codifica as c,scomposizione as s
        where s.id_scomposizione=c.id_scomposizione
        and c.codice=tc.codice
        and s.codice=ts.codice),
      (select p.id_parte_regola
        from parte_regola as p,scomposizione as s
        where s.id_scomposizione=p.id_scomposizione
        and p.num_sezione=tp.num_sezione
        and s.codice=ts.codice),
      mas_input,tipo_richiesta,val_proposto,car_riempimento,solo_in_elenco,1
      from tmp_cod_parte as t
      ,tmp_cat_codifica as tc
      ,tmp_parte_regola as tp
      ,tmp_scomposizione as ts
      where tc.id_cat_codifica=t.id_cat_codifica
      and tp.id_parte_regola=t.id_parte_regola
      and ts.id_scomposizione=tc.id_scomposizione
      and not tc.codice||ts.codice||tp.num_sezione
      =any(select c.codice||s.codice||p.num_sezione
        from cod_parte as l
        ,cat_codifica as c
        ,parte_regola as p
        ,scomposizione as s
        where c.id_cat_codifica=l.id_cat_codifica
        and p.id_parte_regola=l.id_parte_regola
        and s.id_scomposizione=c.id_scomposizione
        and s.codice=ts.codice
        and c.codice=tc.codice
        and p.num_sezione=tp.num_sezione);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   COD_PARTE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   COD_PARTE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. COD_PARTE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. COD_PARTE - SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //  
  //
  /*
  Allineamento della tabella SCELTA_PARTE
  */
  insert into scelta_parte(id_cod_parte,scelta,descrizione)
    select(select p.id_cod_parte
        from cod_parte as p,cat_codifica as c,scomposizione as s,parte_regola as pr
        where c.id_cat_codifica=p.id_cat_codifica
        and s.id_scomposizione=c.id_scomposizione
        and pr.id_parte_regola=p.id_parte_regola
        and s.codice=ts.codice
        and c.codice=tc.codice
        and pr.num_sezione=tpr.num_sezione),
      scelta,tsp.descrizione
      from tmp_scelta_parte as tsp,tmp_cod_parte as tp,tmp_cat_codifica as tc,tmp_scomposizione as ts
      ,tmp_parte_regola as tpr
      where tp.id_cod_parte=tsp.id_cod_parte
      and tc.id_cat_codifica=tp.id_cat_codifica
      and ts.id_scomposizione=tc.id_scomposizione
      and tpr.id_parte_regola=tp.id_parte_regola
      and not tc.codice||ts.codice||tpr.num_sezione||tsp.scelta
      =any(select c.codice||s.codice||pr.num_sezione||sp.scelta
        from scelta_parte as sp,cod_parte as p,cat_codifica as c,scomposizione as s
        ,parte_regola as pr
        where p.id_cod_parte=sp.id_cod_parte
        and c.id_cat_codifica=p.id_cat_codifica
        and s.id_scomposizione=c.id_scomposizione
        and pr.id_parte_regola=p.id_parte_regola);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   SCELTA_PARTE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   SCELTA_PARTE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. SCELTA_PARTE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SCELTA_PARTE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //
  /*
  Allineamento della tabella CAT_COM_ARTICOLO
  */
  insert into cat_com_articolo(codice,descrizione,id_tab_iva,id_azienda)
    select tc.codice,tc.descrizione,
      (select id_tab_iva
        from tab_iva
        where codice=ti.codice),1
      from tmp_cat_com_articolo as tc,tmp_tab_iva as ti
      where ti.id_tab_iva=tc.id_tab_iva
      and not tc.codice=any(select codice
        from cat_com_articolo
        where codice=tc.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAT_COM_ARTICOLO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAT_COM_ARTICOLO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CAT_COM_ARTICOLO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAT_COM_ARTICOLO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella REG_FISCALE
  */
  insert into reg_fiscale(codice,descrizione)
    select codice,descrizione
      from tmp_reg_fiscale
      where not codice=any(select codice
        from reg_fiscale);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   REG_FISCALE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   REG_FISCALE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. REG_FISCALE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. REG_FISCALE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella CAT_MERCEOLOGICA
  */
  insert into cat_merceologica(codice,descrizione,id_reg_fiscale,
    id_cat_mer_superiore,id_anag_modello,
    id_tipo_parte,id_azienda)
    select tc.codice,tc.descrizione,
      (select id_reg_fiscale
        from reg_fiscale
        where codice=tr.codice),
      null, //id_cat_mer_superiore,
      null,
      null,
      1
      from tmp_cat_merceologica as tc,tmp_reg_fiscale as tr
      where tr.id_reg_fiscale=tc.id_reg_fiscale
      and not tc.codice=any(select codice
        from cat_com_articolo
        where codice=tc.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAT_MERCEOLOGICA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAT_MERCEOLOGICA - record trasferiti:'+string(@@rowcount));
    update cat_merceologica
      ,tmp_cat_merceologica as t1,tmp_cat_merceologica as t2,cat_merceologica as cm set
      cat_merceologica.id_cat_mer_superiore=cm.codice
      where t1.codice=cat_merceologica.codice
      and t2.id_cat_merceologica=t1.id_cat_mer_superiore
      and cm.codice=t2.codice
  else
    message '   Si e'' verificato un errore importando la tab. CAT_MERCEOLOGICA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAT_MERCEOLOGICA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella CAT_FISCALE
  */
  insert into cat_fiscale(codice,descrizione)
    select codice,descrizione
      from tmp_cat_fiscale
      where not codice=any(select codice
        from cat_fiscale);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CAT_FISCALE - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CAT_FISCALE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CAT_FISCALE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CAT_FISCALE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  //
  //
  /*
  Allineamento della tabella GRUPPO_ARTICOLI
  */
  insert into gruppo_articoli(codice,
    descrizione,
    id_azienda)
    select codice,
      descrizione,
      1
      from tmp_gruppo_articoli
      where not codice=any(select codice
        from gruppo_articoli);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   GRUPPO_ARTICOLI - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   GRUPPO_ARTICOLI - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. GRUPPO_ARTICOLI - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. GRUPPO_ARTICOLI- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella REPARTO
  */
  insert into reparto(codice,
    descrizione,
    id_azienda)
    select codice,
      descrizione,
      1
      from tmp_reparto
      where not codice=any(select codice
        from reparto);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   REPARTO - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   REPARTO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. REPARTO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. REPARTO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  //
  //
  /*
  Allineamento della tabella CIF
*/
  insert into cif(Codice,
    Cambio,
    Coefficiente,
    ID_azienda)
    select Codice,
      Cambio,
      Coefficiente,
      ID_azienda
      from tmp_cif
      where not codice=any(select codice
        from cif);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   CIF - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   CIF - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. CIF - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. CIF- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  
  //
  //
  /*
  Allineamento della tabella SPESA_CIF

  insert into spesa_cif(id_cif,id_spesa,
    percentuale)
    select(select id_cif
        from cif
        where codice=tmp_cif.codice),
      (select id_spesa
        from spesa
        where codice=tmp_spesa.codice),
      tmp_spesa_cif.percentuale
      from tmp_spesa_cif,tmp_cif,tmp_spesa
      where tmp_cif.id_cif=tmp_spesa_cif.id_cif
      and tmp_spesa.id_spesa=tmp_spesa_cif.id_spesa
      and not tmp_cif.codice||tmp_spesa.codice=any(select c.codice||s.codice
        from cif as c,spesa as s,spesa_cif as sc
        where c.id_cif=sc.id_cif
        and s.id_spesa=sc.id_spesa
        and c.codice=tmp_cif.codice
        and s.codice=tmp_spesa.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   SPESA_CIF - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   SPESA_CIF - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. SPESA_CIF - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SPESA_CIF- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  */
  
    /*
  Allineamento della tabella SPESA
 */
  insert into spesa(codice,descrizione,tipo_importo,percentuale,importo,id_tab_iva,id_conto_acquisti,
  id_conto_vendite, segue_esenzione, mod_cal_iva)
    select
        codice,
        descrizione,
   			tipo_importo,
   			percentuale,
   			importo,
   			(select ti.id_tab_iva
   			 from tab_iva ti, tmp_tab_iva tm
   			 where ti.codice = tm.codice
   			 and tm.id_tab_iva = tmp_spesa.id_tab_iva),
   			 (select id_conto_predefinito_acq
   			  from par_sistema),
   			 (select id_conto_predefinito
   			  from par_sistema),
   			  segue_esenzione, 
   			  mod_cal_iva
        from tmp_spesa
        where not codice=any(select codice
        from spesa);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   SPESA - record trasferiti:'+string(@@rowcount);
    insert into tmp_log(note) values('   SPESA_CIF - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. SPESA - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. SPESA- SQLSTATE:'+@ls_sqlstate)
  end if
  ;
  
  //
  //
  //
  //
  /*
  Allineamento della tabella UNITA_CONF_BASE  
  */
  insert into unita_conf_base(codice,
    id_unita_misura,
    descrizione,
    app_conversione,
    fat_conversione,
    tipo_conversione,
    molteplicita,
    qta_minima,
    qta_massima,
    id_unita_mis_peso,
    peso_netto,
    peso_lordo,
    id_unita_mis_volume,
    dim_l,
    dim_h,
    dim_p,
    unita_base,
    unita_prezzo,
    unita_documenti,
    unita_produzione,
    id_azienda,
    tipo_stampa_etichette,
    num_colli)
    select tuc.codice + '@',
      null,
      tuc.descrizione,
      tuc.app_conversione,
      tuc.fat_conversione,
      tuc.tipo_conversione,
      tuc.molteplicita,
      tuc.qta_minima,
      tuc.qta_massima,
      null,
      tuc.peso_netto,
      tuc.peso_lordo,
      null,
      tuc.dim_l,
      tuc.dim_h,
      tuc.dim_p,
      tuc.unita_base,
      tuc.unita_prezzo,
      tuc.unita_documenti,
      tuc.unita_produzione,
      1,
      tuc.tipo_stampa_etichette,
      tuc.num_colli
      from tmp_unita_conf_base as tuc,tmp_unita_misura as tum
      ,tmp_unita_misura as tump,tmp_unita_misura as tumv
      where tum.id_unita_misura=*tuc.id_unita_misura
      and tump.id_unita_misura=*tuc.id_unita_mis_peso
      and tumv.id_unita_misura=*tuc.id_unita_mis_volume
      and not tuc.codice=any(select u.codice
        from unita_conf_base as u
        where u.codice=tuc.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   UNITA_CONF_BASE - record trasferiti:'+string(@@rowcount);
      //set @id_unita_conf_base_new=@@identity;
      //if(@id_unita_conf_base_new is null) then
      //  message 'id_unita_conf_base_new E'' NULL'
      //else
        update unita_conf_base as uc
        set uc.id_unita_misura = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_conf_base as tuc
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_misura
                               and tuc.codice = left(uc.codice, length(uc.codice) -1))
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_conf_base = @id_unita_conf_base_new;
    
        update unita_conf_base as uc
        set uc.id_unita_mis_peso = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_conf_base as tuc
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_mis_peso
                               and tuc.codice = left(uc.codice, length(uc.codice) -1))
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_conf_base = @id_unita_conf_base_new;
    
        update unita_conf_base as uc
        set uc.id_unita_mis_volume = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_conf_base as tuc
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_mis_volume
                               and tuc.codice = left(uc.codice, length(uc.codice) -1))
        where right(uc.codice, 1) = '@';

        update unita_conf_base as uc
        set uc.codice = left(uc.codice, length(uc.codice) -1)
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_conf_base = @id_unita_conf_base_new;
      //end if;
       insert into tmp_log(note) values('   UNITA_CONF_BASE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. UNITA_CONF_BASE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. UNITA_CONF_BASE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

  //
  //
  /*
  Allineamento della tabella ARTICOLO

  BL##13377#	-	Modifica AK ANAGRAFICA
  */
  insert into articolo(id_cat_codifica,
    codice,
    descrizione,
    immagine,
    rif_catalogo,
    id_cat_com_articolo,
    id_cat_merceologica,
    id_cat_fiscale,
    id_gruppo_articoli,
    des_breve,
    id_reparto,
    id_anagrafica,
    id_sog_commerciale,
    id_tab_iva,
    cod_intrastat,
    data_ora_creazione,
    data_ora_ult_cambiamento,
    data_ora_ult_var_stato,
    stampa_in_inventario,
    stampa_in_listini,
    stampa_in_giornale,
    stampa_in_schede,
    ges_lotti,
    ges_matricole,
    ges_produzione,
    note,
    utilizzabile,
    stato,
    ges_locazioni,
    giorni_invenduto,
    id_azienda,
    ID_Cif,
    costo_aggiuntivo,
    id_valuta,
    ID_unita_conf_base,
    prod_interna,
    id_sog_comm_variante,
    stampa_in_catalogo,
    giorni_durata)
    select(select id_cat_codifica
        from cat_codifica as c,scomposizione as s
        where s.id_scomposizione=c.id_scomposizione
        and c.codice=tcc.codice
        and s.codice=ts.codice),
      ifnull(ta.codice,'@',ta.codice + '@'),
      ta.descrizione,
      ta.immagine,
      ta.rif_catalogo,
      (select id_cat_com_articolo
        from cat_com_articolo
        where codice=tc.codice),
      null,
      null,
      null,
      ta.des_breve,
      null,
      null,
      null,
      null,
      ta.cod_intrastat,
      datetime(today(*)),
      datetime(today(*)),
      datetime(today(*)),
      ta.stampa_in_inventario,
      ta.stampa_in_listini,
      ta.stampa_in_giornale,
      ta.stampa_in_schede,
      ta.ges_lotti,
      ta.ges_matricole,
      ta.ges_produzione,
      null, 
      ta.utilizzabile,
      ta.stato,
      ta.ges_locazioni,
      ta.giorni_invenduto,
      1,
      null,
      ta.costo_aggiuntivo,
      null,
      null,
      ta.prod_interna,
      null,
      ta.stampa_in_catalogo,
      ta.giorni_durata
      from tmp_articolo as ta,tmp_cat_codifica as tcc,tmp_scomposizione as ts
      ,tmp_cat_com_articolo as tc
      ,tmp_cat_merceologica as tcm,tmp_cat_fiscale as tcf,tmp_gruppo_articoli as tga
      ,tmp_reparto as tr
      ,tmp_tab_iva as tti
      ,tmp_valuta as tv
      where tcc.id_cat_codifica=ta.id_cat_codifica
      and ts.id_scomposizione=tcc.id_scomposizione
      and tc.id_cat_com_articolo=ta.id_cat_com_articolo
      and tcm.id_cat_merceologica=*ta.id_cat_merceologica
      and tcf.id_cat_fiscale=*ta.id_cat_fiscale
      and tga.id_gruppo_articoli=*ta.id_gruppo_articoli
      and tr.id_reparto=*ta.id_reparto
      and tti.id_tab_iva=*ta.id_tab_iva
      and tv.id_valuta=*ta.id_valuta
      and not ta.codice=any(select codice from articolo where codice=ta.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   ARTICOLO - record trasferiti:'+string(@@rowcount);
       //update cat_merceologica
       //,tmp_cat_merceologica as t1,tmp_cat_merceologica as t2,cat_merceologica as cm set
      //cat_merceologica.id_cat_mer_superiore=cm.codice
      //where t1.codice=cat_merceologica.codice
      //and t2.id_cat_merceologica=t1.id_cat_mer_superiore
      //and cm.codice=t2.codice;

      //set @id_articolo_new=@@identity;
      //if(@id_articolo_new is null) then
      //  message 'id_articolo_new E'' NULL'
      //else
        update articolo as a
        set a.id_cat_merceologica = (select c.id_cat_merceologica
                                     from cat_merceologica as c, tmp_cat_merceologica as tcm, tmp_articolo as ta
                                     where c.codice=tcm.codice
                                     and tcm.id_cat_merceologica=ta.id_cat_merceologica
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.id_cat_fiscale = (select c.id_cat_fiscale
                                     from cat_fiscale as c, tmp_cat_fiscale as tcf, tmp_articolo as ta
                                     where c.codice=tcf.codice
                                     and tcf.id_cat_fiscale=ta.id_cat_fiscale
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.id_gruppo_articoli = (select c.id_gruppo_articoli
                                     from gruppo_articoli as c, tmp_gruppo_articoli as tga, tmp_articolo as ta
                                     where c.codice=tga.codice
                                     and tga.id_gruppo_articoli=ta.id_gruppo_articoli
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.id_reparto = (select c.id_reparto
                                     from reparto as c, tmp_reparto as tr, tmp_articolo as ta
                                     where c.codice=tr.codice
                                     and tr.id_reparto=ta.id_reparto
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.id_tab_iva = (select c.id_tab_iva
                                     from tab_iva as c, tmp_tab_iva as tti, tmp_articolo as ta
                                     where c.codice=tti.codice
                                     and tti.id_tab_iva=ta.id_tab_iva
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;
    
        update articolo as a
        set a.id_valuta = (select c.id_valuta
                                     from valuta as c, tmp_valuta as tv, tmp_articolo as ta
                                     where c.codice=tv.codice
                                     and tv.id_valuta=ta.id_valuta
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.ID_unita_conf_base = (select c.ID_unita_conf_base
                                     from unita_conf_base as c, tmp_unita_conf_base as tucb, tmp_articolo as ta
                                     where c.codice=tucb.codice
                                     and tucb.id_unita_conf_base=ta.id_unita_conf_base
                                     and ta.codice = left(a.codice, length(a.codice) -1))
        where right(a.codice, 1) = '@';
        //where a.id_articolo = @id_articolo_new;

        update articolo as a
        set a.codice = left(a.codice, length(a.codice) -1)
        where right(a.codice, 1) = '@';

      //end if;
      insert into tmp_log(note) values('   ARTICOLO - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. ARTICOLO - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. ARTICOLO- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

//Aggiornamento descrizioni articolo
update articolo as a, tmp_articolo as ta
set a.descrizione = ta.descrizione, a.des_breve = ta.des_breve
where a.codice = ta.codice;


  //
  //
  /*
  Allineamento della tabella UNITA_CONFEZIONE
  */
  insert into unita_confezione(id_articolo,
    codice,
    id_unita_misura,
    descrizione,
    app_conversione,
    fat_conversione,
    tipo_conversione,
    molteplicita,
    qta_minima,
    qta_massima,
    id_unita_mis_peso,
    peso_netto,
    peso_lordo,
    id_unita_mis_volume,
    dim_l,
    dim_h,
    dim_p,
    unita_base,
    unita_prezzo,
    unita_documenti,
    unita_produzione,
    id_azienda,
    tipo_stampa_etichette,
    num_colli)
    select(select id_articolo
				        from articolo
				        where codice=ifnull(ta.codice,'',ta.codice)),
      tuc.codice + '@',
      null,
      tuc.descrizione,
      tuc.app_conversione,
      tuc.fat_conversione,
      tuc.tipo_conversione,
      tuc.molteplicita,
      tuc.qta_minima,
      tuc.qta_massima,
      null,
      tuc.peso_netto,
      tuc.peso_lordo,
      null,
      tuc.dim_l,
      tuc.dim_h,
      tuc.dim_p,
      tuc.unita_base,
      tuc.unita_prezzo,
      tuc.unita_documenti,
      tuc.unita_produzione,
      1,
      tuc.tipo_stampa_etichette,
      tuc.num_colli
      from tmp_unita_confezione as tuc,tmp_articolo as ta
      where ta.id_articolo=tuc.id_articolo
      and not ta.codice||tuc.codice=any(select a.codice||u.codice
        from articolo as a,unita_confezione as u
        where u.id_articolo=a.id_articolo
        and a.codice=ta.codice
        and u.codice=tuc.codice);
  set @ls_sqlstate=sqlstate;
  if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
    message '   UNITA_CONFEZIONE - record trasferiti:'+string(@@rowcount);
      //set @id_unita_confezione_new=@@identity;
      //if(@id_unita_confezione_new is null) then
      //  message 'id_unita_confezione_new E'' NULL'
      //else
        update unita_confezione as uc
        set uc.id_unita_misura = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_confezione as tuc, articolo a, tmp_articolo ta
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_misura
                               and tuc.codice = left(uc.codice, length(uc.codice) -1)
                               and uc.id_Articolo = a.id_articolo
                               and tuc.id_articolo = ta.id_articolo
                               and a.codice = ta.codice)
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_confezione = @id_unita_confezione_new;
    
        update unita_confezione as uc
        set uc.id_unita_mis_peso = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_confezione as tuc, articolo a, tmp_articolo ta
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_mis_peso
                               and tuc.codice = left(uc.codice, length(uc.codice) -1)
                               and uc.id_Articolo = a.id_articolo
                               and tuc.id_articolo = ta.id_articolo
                               and a.codice = ta.codice)
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_confezione = @id_unita_confezione_new;
    
        update unita_confezione as uc
        set uc.id_unita_mis_volume = (select u.id_unita_misura
                               from unita_misura as u, tmp_unita_misura as tum, tmp_unita_confezione as tuc, articolo a, tmp_articolo ta
                               where u.simbolo=tum.simbolo
                               and tum.id_unita_misura=tuc.id_unita_mis_volume
                               and tuc.codice = left(uc.codice, length(uc.codice) -1)
                               and uc.id_Articolo = a.id_articolo
                               and tuc.id_articolo = ta.id_articolo
                               and a.codice = ta.codice)
        where right(uc.codice, 1) = '@';
        //where uc.id_unita_confezione = @id_unita_confezione_new;

        update unita_confezione as uc
        set uc.codice = left(uc.codice, length(uc.codice) -1)
        where right(uc.codice, 1) = '@';

        ////imposto unita_misura base dove non c''
        update unita_confezione as uc, tmp_unita_confezione as tuc
        set uc.id_unita_misura = (select ucb.id_unita_misura
                                  from unita_conf_base ucb, par_sistema ps
                                  where ps.id_unita_conf_base = ucb.id_unita_conf_base)
        where uc.id_unita_misura is null
        and uc.codice = tuc.codice;

      //end if;
    insert into tmp_log(note) values('   UNITA_CONFEZIONE - record trasferiti:'+string(@@rowcount))
  else
    message '   Si e'' verificato un errore importando la tab. UNITA_CONFEZIONE - SQLSTATE:'+@ls_sqlstate;
    insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. UNITA_CONFEZIONE- SQLSTATE:'+@ls_sqlstate)
  end if
  ;

//Aggiornamento descrizioni U.C.
update unita_confezione as uc, tmp_unita_confezione as tuc
set uc.descrizione = tuc.descrizione
where uc.codice = tuc.codice;

  //
  //
  //
  //
  /*
  Allineamento della tabella BANCA_APPOGGIO
  */
  //insert into banca_appoggio(cod_abi,
  //  den_abi,
  //  cod_cab,
  //  den_cab,
  //  indirizzo,
  //  cap,
  //  localita,
  //  provincia,
  //  nazione,
  //  filiale,
  //  con_interbancaria,
  //  giorni_franchigia)
  //  select cod_abi,
  //    den_abi,
  //    cod_cab,
  //    den_cab,
  //    indirizzo,
  //    cap,
  //    localita,
  //    provincia,
  //    nazione,
  //    filiale,
  //    con_interbancaria,
  //    giorni_franchigia
  //    from tmp_banca_appoggio
  //    where not cod_abi||cod_cab
  //    =any(select cod_abi||cod_cab
  //      from banca_appoggio
  //      where cod_abi=tmp_banca_appoggio.cod_abi
  //      and cod_cab=tmp_banca_appoggio.cod_cab);
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   BANCA_APPOGGIO - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   BANCA_APPOGGIO - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. BANCA_APPOGGIO - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. BANCA_APPOGGIO - SQLSTATE:'+@ls_sqlstate)
  //end if
  //;
  //
  //
  /*
  ALLINEAMENTO ANAGRAFICA BANCA_SOG_COMMERCIALE

  BL#13377#	-	Modifica AK ANAGRAFICA
  */
  //insert into banca_sog_commerciale(id_anagrafica,
  //  id_banca_appoggio,
  //  conto_corrente,
  //  cin,
  //  modo_uso,id_azienda)
  //  select(select id_anagrafica
  //      from anagrafica
  //      where codice=ta.codice),
  //    (select id_banca_appoggio
  //      from banca_appoggio
  //      where cod_abi=tba.cod_abi
  //      and cod_cab=tba.cod_cab) as id_banca,
  //    tbs.conto_corrente,
  //    tbs.cin,
  //    tbs.modo_uso,
  //    1
  //    from tmp_banca_sog_commerciale as tbs,tmp_banca_appoggio as tba,tmp_anagrafica as ta
  //    where tba.id_banca_appoggio=tbs.id_banca_appoggio
  //    and ta.id_anagrafica=tbs.id_anagrafica
  //    and not ta.codice||tba.cod_abi||tba.cod_cab
  //    =any(select a.codice||ba.cod_abi||ba.cod_cab
  //      from banca_sog_commerciale as bs,banca_appoggio as ba,anagrafica as a
  //      where ba.id_banca_appoggio=bs.id_banca_appoggio
  //      and a.id_anagrafica=bs.id_anagrafica
  //      and a.codice=ta.codice
  //      and ba.cod_abi=tba.cod_abi
  //      and ba.cod_cab=tba.cod_cab)
  //    and id_banca is not null;
  //
  //
  //set @ls_sqlstate=sqlstate;
  //if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
  //  message '   BANCA_SOG_COMMERCIALE - record trasferiti:'+string(@@rowcount);
  //  insert into tmp_log(note) values('   BANCA_SOG_COMMERCIALE - record trasferiti:'+string(@@rowcount))
  //else
  //  message '   Si e'' verificato un errore importando la tab. BANCA_SOG_COMMERCIALE - SQLSTATE:'+@ls_sqlstate;
  //  insert into tmp_log(note) values('   Si e'' verificato un errore importando la tab. BANCA_SOG_COMMERCIALE - SQLSTATE:'+@ls_sqlstate)
  //end if
  ;
  //
  //
  //
  message '*********************************************************************************';
  insert into tmp_log(note) values('*********************************************************************************');
  message 'FINE ALLINEAMENTO TABELLE ANAGRAFICHE - '+string(dateformat(Now(*),'hh:mm:ss'));
  insert into tmp_log(note) values('FINE ALLINEAMENTO TABELLE ANAGRAFICHE - '+string(dateformat(Now(*),'hh:mm:ss')));
  commit work;
  select "COUNT"(*) into li_errori
    from tmp_log
    where note like '%SQLSTATE%';
  //
  if(li_errori>0) then
    insert into tmp_log(note) values('Controllare il report, il trasferimento e'' terminato con '+string(li_errori)+' errori')
  end if
  ;
  commit work
//
end;
end if;



//UTENTI NOTE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'ins_note' )) THEN 
        
	ALTER TABLE "dba"."utenti" ADD  "ins_note" char(1) DEFAULT 'T';
	UPDATE UTENTI SET ins_note='G';
end if; 


//MAIL FATTURE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sog_commerciale'
        AND      CNAME = 'mail_fatturazione' )) THEN 
        
	ALTER TABLE "dba"."sog_commerciale" ADD  "mail_fatturazione" long varchar DEFAULT NULL;

	update sog_commerciale s set s.mail_fatturazione=(select max(t.num_riferimento) from telefono t 
	       where t.id_anagrafica=s.id_anagrafica and tipo='M');

	ALTER TABLE sys_modulo ADD fat_mail char(1) DEFAULT NULL;
	update sys_modulo set fat_mail='N';

end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PAR_SISTEMA'
        AND      CNAME = 'id_tipo_cod_barre_def' )) THEN 
        
	ALTER TABLE PAR_SISTEMA ADD id_tipo_cod_barre_def integer DEFAULT NULL;
end if;

//PAD rettifica impegnato
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_impegnato') THEN

		CREATE FUNCTION "DBA"."fn_impegnato"(in @id_azienda integer,in @id_articolo integer,in @id_magazzino integer,in @anno integer,in @mese integer)
		returns char(40)
		begin
		  /*

		  Argomenti input:
		  . ID Azienda	(Obbligatorio)
		  . ID Articolo	(Obbligatorio)
		  . ID Magazzino	
		  . Anno			(Obbligatorio)
		  . Mese			(Obbligatorio)

		  Valore di ritorno:
		  . 1  - 20  carattere --> Impegnato Magazzino

		  */
		  declare @lf_imp_produzione float(4);
		  declare @ls_imp_produzione char(20);
		  declare @ls_tipo_mov char(1);
		  //
		  // Tipo di movimentazione dell''Articolo
		  select m.tipo into @ls_tipo_mov
		    from unita_confezione as u,unita_misura as m
		    where u.id_articolo=@id_articolo
		    and u.unita_base='S'
		    and m.id_unita_misura=u.id_unita_misura;
		  //
		  if(@ls_tipo_mov='P') then
		    // Movimentazione a Peso
		    if @id_magazzino is null or @id_magazzino=0 then
		      // Calcolo su tutti i magazzino
		      select IfNull((Sum(riepilogo.peso_imp_produzione)),0,Sum(riepilogo.peso_imp_produzione)) into @lf_imp_produzione
		        from riepilogo
		        where riepilogo.id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
		        and riepilogo.id_articolo=@id_articolo
		        and(riepilogo.anno<@anno
		        or(riepilogo.anno=@anno
		        and riepilogo.mese<=@mese))
		    else
		      // Calcolo sul magazzino specificato
		      select IfNull((Sum(riepilogo.peso_imp_produzione)),0,Sum(riepilogo.peso_imp_produzione)) into @lf_imp_produzione
		        from riepilogo
		        where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
		        and id_articolo=@id_articolo
		        and id_locazione=any(select id_locazione from locazione where id_magazzino=@id_magazzino)
		        and(riepilogo.anno<@anno
		        or(riepilogo.anno=@anno
		        and riepilogo.mese<=@mese))
		    end if
		  else
		    // Movimentazione a quantita''
		    if @id_magazzino is null or @id_magazzino=0 then
		      // Calcolo su tutti i magazzino
		      select IfNull((Sum(riepilogo.qta_imp_produzione)),0,Sum(riepilogo.qta_imp_produzione)) into @lf_imp_produzione
		        from riepilogo
		        where riepilogo.id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
		        and riepilogo.id_articolo=@id_articolo
		        and(riepilogo.anno<@anno
		        or(riepilogo.anno=@anno
		        and riepilogo.mese<=@mese))
		    else
		      // Calcolo sul magazzino specificato
		      select IfNull((Sum(riepilogo.qta_imp_produzione)),0,Sum(riepilogo.qta_imp_produzione)) into @lf_imp_produzione
		        from riepilogo
		        where id_attivita=(select id_attivita from azienda where id_azienda=@id_azienda)
		        and id_articolo=@id_articolo
		        and id_locazione=any(select id_locazione from locazione where id_magazzino=@id_magazzino)
		        and(riepilogo.anno<@anno
		        or(riepilogo.anno=@anno
		        and riepilogo.mese<=@mese))
		    end if
		  end if
		  ;
		  /*  */
		  set @ls_imp_produzione=REPEAT(' ',20-LENGTH(STRING(@lf_imp_produzione)))+STRING(@lf_imp_produzione);
		  message 'lf_imp_produzione:',string(@lf_imp_produzione);
		  message 'ls_imp_produzione',@ls_imp_produzione;
		  //
		  return(@ls_imp_produzione)
		end;
		
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PERS_PAR_SISTEMA'
        AND      CNAME = 'id_prof_impmag_ret' )) THEN 
        
	ALTER TABLE PERS_PAR_SISTEMA ADD id_prof_impmag_ret integer DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PERS_PAR_SISTEMA'
        AND      CNAME = 'id_caucar_impmag_ret' )) THEN 
        
	ALTER TABLE PERS_PAR_SISTEMA ADD id_caucar_impmag_ret integer DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'PERS_PAR_SISTEMA'
        AND      CNAME = 'id_causca_impmag_ret' )) THEN 
        
	ALTER TABLE PERS_PAR_SISTEMA ADD id_causca_impmag_ret integer DEFAULT NULL;
end if;
////////////////////////////////////////////////////

//Madero per euritmo conad
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'CODPAM'
        AND      CNAME = 'codconad' )) THEN 
        
	ALTER TABLE CODPAM ADD codconad char(20) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'CODARTPAM'
        AND      CNAME = 'codartconad' )) THEN 
        
	ALTER TABLE CODARTPAM ADD codartconad char(20) DEFAULT NULL;
end if;
/////////////////////


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'rch_tmp_err')) THEN		
	CREATE TABLE "dba"."rch_tmp_err" ("id_rch_tmp_err" integer NOT NULL DEFAULT autoincrement, "data_doc" date DEFAULT NULL, "ora_doc" time DEFAULT NULL, "cod_err" long varchar DEFAULT NULL , PRIMARY KEY ("id_rch_tmp_err")) ;

end if;		



//apertura veloce menu
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'win_veloce' )) THEN 
        
	ALTER TABLE utenti ADD win_veloce char(80) DEFAULT NULL;
end if; 


//NUOVA FUNZIONE VALUTA

//PAD rettifica impegnato
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_conv_val_mov') THEN

	CREATE FUNCTION "DBA"."fn_conv_val_mov"(in @li_id_valuta_i integer,in @ld_importo dm_Imp_6_Dec,in @li_id_valuta_f integer,in @ld_cc dm_Imp_6_Dec)
	returns dm_Imp_6_Dec
	begin
	  /*
	  Elisa M.    14/08/2001      BL#15049#
	  */
	  declare @ld_importo_valuta dm_Imp_6_Dec;
	  declare @ld_cambio_i decimal(18,4);
	  declare @ld_parita_euro_i decimal(18,4);
	  declare @ld_cambio_f decimal(18,4);
	  declare @ld_parita_euro_f decimal(18,4);
	  declare @li_id_val_lire integer;
	  //
	  set @ld_importo_valuta=@ld_importo;
	  // Valuta EURO
	  if(@ld_importo is null or @ld_importo=0) then
	    return(null)
	  end if
	  ;
	  if @li_id_valuta_i<>@li_id_valuta_f then
	      set @ld_importo_valuta=@ld_importo *  @ld_cc 
	  end if
	  ;
	  //
	  //
	  return(@ld_importo_valuta)
	end
end if;


//GENESI (ordinamento letture inventario SKORPIO)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'barcodes'
        AND      CNAME = 'id_barcodes' )) THEN 
        
	ALTER TABLE barcodes ADD id_barcodes integer DEFAULT NULL;
end if; 





//Partitario Ordinato
call fn_ins_voce_menu('Partitario Ordinato', 'w_partitario_ord_ff', 'Partitario Ordinato', 105);


//Taseeli inevasi
call fn_ins_voce_menu('Controllo', 'w_24_ristampa_ord_inevasi_rpt', 'Ordini inevasi x Cliente', 421);

call fn_ins_voce_menu('Controllo', 'w_esi_art_inv_cx', 'Stampa Inventariale', 31);

call fn_ins_voce_menu('Utility', 'w_rettifica_impmag_cx', 'Documento di rettifica Impegnato Mag.', 409);

//CASSA PARIGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'rch_tmp_log'
        AND      CNAME = 'id_scontrino' )) THEN 
        
	ALTER TABLE rch_tmp_log ADD id_scontrino integer NULL DEFAULT NULL;
end if; 




ALTER VIEW ws_liquidazione_iva (id_esercizio,id_attivita,tipo_registro,data_comp_liq_iva,id_reg_pd,segno_reg_iva,imponibile,imposta,id_tab_iva,codice,des_breve,tipo_iva,per_aliquota,per_detrazione,per_ventilazione,ges_plafond,usa_prorata,ges_sco_giornaliero,st_liquidazione,st_reg_iva,st_reg_iva_regpd,ges_beni_strumentali,ges_beni_rivendita,id_registro,descrizione,id_mod_registro) AS 
select esercizio.id_esercizio,reg_pd.id_attivita,registro.tipo_registro,
 reg_pd.data_comp_liq_iva,reg_pd.id_reg_pd,reg_pd.segno_reg_iva,mov_iva.imponibile,
 mov_iva.imposta,mov_iva.id_tab_iva,tab_iva.codice,tab_iva.des_breve,tab_iva.tipo_iva,
 tab_iva.per_aliquota,tab_iva.per_detrazione,tab_iva.per_ventilazione,tab_iva.ges_plafond,
 registro.usa_prorata,registro.ges_sco_giornaliero,reg_pd.st_liquidazione,
 mov_iva.st_reg_iva,reg_pd.st_reg_iva as st_reg_iva_regpd,
 tab_iva.ges_beni_strumentali,tab_iva.ges_beni_rivendita,
 registro.id_registro,registro.descrizione,mod_registro.id_mod_registro from
 dba.attivita,dba.esercizio,dba.mov_iva,dba.reg_pd,
 dba.registro,dba.tab_iva,dba.mod_registro where
 (reg_pd.id_reg_pd = mov_iva.id_reg_pd) and(
 registro.id_registro = reg_pd.id_registro) and(
 registro.id_esercizio = esercizio.id_esercizio) and(
 registro.id_attivita = attivita.id_attivita) and(
 registro.id_mod_registro = mod_registro.id_mod_registro) and(
 tab_iva.id_tab_iva = mov_iva.id_tab_iva) and(
 (registro.tipo_registro = 'IA') or(
 registro.tipo_registro = 'IC') or(
 registro.tipo_registro = 'IV'))
;






/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
//DA ESEGUIRE IN TUTTI GLI SCRIPT


IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'TMP_FATTURATO') THEN
	DROP TABLE TMP_FATTURATO;
end if; 


CREATE TABLE "dba"."tmp_fatturato" 
("cod_1" char(32) DEFAULT NULL, "des_1" char(80) DEFAULT NULL, "cod_2" char(32) DEFAULT NULL, 
"des_2" char(80) DEFAULT NULL, "cod_3" char(32) DEFAULT NULL, "des_3" char(80) DEFAULT NULL, 
"cod_4" char(32) DEFAULT NULL, "des_4" char(80) DEFAULT NULL, "imp_1" numeric(18,4) DEFAULT NULL, 
"imp_2" numeric(18,4) DEFAULT NULL, "cod_art" char(32) DEFAULT NULL, "des_art" char(80) DEFAULT NULL, 
"quantita" numeric(20,6) DEFAULT NULL, "peso_netto" numeric(20,6) DEFAULT NULL, 
"prezzo_netto" numeric(20,6) DEFAULT NULL, "num_progressivo" integer DEFAULT NULL, 
"data_registrazione" date DEFAULT NULL, "id_documento" integer DEFAULT NULL, "id_articolo" integer DEFAULT NULL, 
"id_tmp_fatturato" integer NOT NULL DEFAULT autoincrement, "segno_iva" integer DEFAULT NULL) ;


///////////////////////////////
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_014' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_014','Release 2_01_014  Cometa','S')
        ;

END IF
;

