//INIZIO 2_05_001

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tipo_gara')) THEN

		CREATE TABLE "dba"."tipo_gara" (
		"id_tipo_gara" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) NOT NULL DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , 
		PRIMARY KEY ("id_tipo_gara")) ;
		CREATE UNIQUE INDEX "ix_tipo_gara_1" ON "dba"."tipo_gara" ("codice" ) ;		
end if;



IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tipo_proc_gara')) THEN
		
		CREATE TABLE "dba"."tipo_proc_gara" (
		"id_tipo_proc_gara" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) NOT NULL DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , PRIMARY KEY ("id_tipo_proc_gara")) ;
		CREATE UNIQUE INDEX "ix_tipo_proc_gara_1" ON "dba"."tipo_proc_gara" ("codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cat_gara')) THEN
		
		CREATE TABLE "dba"."cat_gara" (
		"id_cat_gara" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) NOT NULL DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , PRIMARY KEY ("id_cat_gara")) ;
		CREATE UNIQUE INDEX "ix_cat_gara_1" ON "dba"."cat_gara" ("codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'gest_gara')) THEN
		
		CREATE TABLE "dba"."gest_gara" (
		"id_gest_gara" integer NOT NULL DEFAULT autoincrement, 
		"id_commessa_stato" integer DEFAULT NULL, 
		"num_gara" char(30) NOT NULL DEFAULT NULL, 
		"id_tipo_gara" integer DEFAULT NULL, 
		"id_tipo_proc_gara" integer DEFAULT NULL, 
		"data_arrivo" date DEFAULT NULL, 
		"data_scadenza" date DEFAULT NULL, 
		"lista_cat" char(1) DEFAULT NULL, 
		"sopralluogo" char(1) DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"oggetto" long varchar DEFAULT NULL, 
		"imp_sog_rib" numeric(18,4) DEFAULT NULL, 
		"imp_sic_man" numeric(18,4) DEFAULT NULL, 
		"id_cat_gara" integer DEFAULT NULL, 
		"data_apertura" date DEFAULT NULL, 
		"imp_off_cli" numeric(18,4) DEFAULT NULL, 
		"perc_rib_1" numeric(3,2) DEFAULT NULL, 
		"perc_rib_2" numeric(3,2) DEFAULT NULL, 
		"perc_agg_rib" numeric(3,2) DEFAULT NULL, 
		"id_anagrafica" integer DEFAULT NULL , PRIMARY KEY ("id_gest_gara")) ;
		CREATE UNIQUE INDEX "ix_num_gara_1" ON "dba"."gest_gara" ("num_gara" , "id_gest_gara" ) ;
end if;

call fn_ins_voce_menu('Codici a Barre', 'w_stampa_etichette_free', 'Stampa Etichetta Libera', 81);


IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'gest_riepart')) THEN 
		
	ALTER TABLE par_sistema ADD gest_riepart char(1);
	ALTER TABLE par_sistema ADD gest_riepart_locazione integer;

	update par_sistema set gest_riepart='S';

	update par_sistema set gest_riepart=isnull(vis_disp_art_sw,'N');

	if ((SELECT codice FROM   AZIENDA)='SENATORI') or ((SELECT codice FROM   AZIENDA)='CREART') then
	   update par_sistema set gest_riepart='N';
	end if;	

	if ((SELECT codice FROM   AZIENDA)='PARIGI') then
	   update par_sistema set gest_riepart_locazione=0;
	end if;	

end if;



ALTER PROCEDURE "DBA"."sp_gest_causale_var"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Elisa Moneti      29/01/1999
	  Oggetto: Aggiornamento della "Data Ultimo Scarico"
	
	  Elisa M.              21/06/1999 
	  Gestione Ordinato Clienti e Ordinato Fornitori,
	  in seguito alla cancellazione, inserimento o modifica di una riga documento
	  con una causale di mag. che decrementa uno di questi due valori
	
	  Elisa M.    23/05/2000
	  Aggiornamento dell'ultimo costo sia che la movimentazione sia a peso che in quantita'
	
	  Elisa Moneti  20/09/2000      
	  Rif. Bolla 7889 : Aggiornamento dei riepiloghi di magazzino a peso
	
	  Elisa Moneti  31/08/2001
	  BL#15075# -  gestione Valuta per passaggio all''Euro
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l''unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer,
      @parsis_riepuc char(1),
      @parsis_riepart char(1)
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)
	  /*
	  Stefano
	  recupero mp_car_fiscali e md_car_fiscale relativamente alla causale
	  di magazzino per sapere se deve essere aggiornato o no il primo costo
	  */
	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino
	  /*stefano controlo se l'unita' confezione della riga + un'unita' base; se si aggiorno l''ultimo
	  costo altrimenti no*/
	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione
/* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
if (@unita_base = 'N') 
    begin
        select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
        from "dba".unita_confezione
        where unita_confezione.unita_base = 'S'
        and unita_confezione.id_articolo = @id_articolo
        select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
        message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
end    
/* Controllo che sia l''unita base - Massimo Zurli - Fine*/
	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      /*
	      Elisa M.        23/05/00
	      Se la movimentazione e' a peso, il prezzo viene calcolato in base al peso,
	      altrimenti in base alla quantita'
	      */
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              /*select @Prezzo=@Valore/@peso_netto*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              /*select @Prezzo=@Valore/@Qta*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        /*          message ' Prezzo:'||string(@Prezzo)*/
	        end
	      /* BL#15075#i*/
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      /* BL#15075#f*/
	      /* Carico i valori di causale di magazzino per il magazzino pricipale*/
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riepilogo.ult_costo,
	        @Data_Ult_Costo=riepilogo.data_ult_costo,
	        @Qta_Rim_Iniziale=riepilogo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riepilogo.val_rim_iniziale,
	        @Qta_Caricata=riepilogo.qta_caricata,
	        @Qta_Scaricata=riepilogo.qta_scaricata,
	        @Val_Caricato=riepilogo.val_caricato,
	        @Val_Scaricato=riepilogo.val_scaricato,
	        @Data_Ult_Scarico=riepilogo.data_ult_scarico,
	        @Qta_Ord_Clienti=riepilogo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riepilogo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riepilogo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riepilogo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riepilogo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riepilogo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riepilogo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riepilogo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riepilogo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riepilogo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riepilogo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riepilogo.qta_gruppo_lib_4,
	        @peso_caricato=riepilogo.peso_caricato,
	        @peso_scaricato=riepilogo.peso_scaricato,
	        @peso_ord_clienti=riepilogo.peso_ord_clienti,
	        @peso_ord_fornitori=riepilogo.peso_ord_fornitori,
	        @peso_vis_clienti=riepilogo.peso_vis_clienti,
	        @peso_vis_fornitori=riepilogo.peso_vis_fornitori,
	        @peso_imp_produzione=riepilogo.peso_imp_produzione,
	        @peso_ord_produzione=riepilogo.peso_ord_produzione,
	        @peso_cl_clienti=riepilogo.peso_cl_clienti,
	        @peso_cl_fornitori=riepilogo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riepilogo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riepilogo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riepilogo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riepilogo.peso_gruppo_lib_4
	        from "dba".riepilogo
	        where(riepilogo.id_esercizio=@Id_Esercizio)
	        and(riepilogo.id_attivita=@Id_Attivita)
	        and(riepilogo.id_articolo=@Id_Articolo)
	        and(riepilogo.pk_codice=@pk_codice)
	        and(riepilogo.id_locazione=@Id_Locazione)
	        and(riepilogo.anno=@Anno)
	        and(riepilogo.mese=@Mese)
	        and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	      /*      message 'ccc'*/
	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)
	      /*      message 'Ultimo Costo:'||@M_Ult_Costo||' Data_ult_costo:'||string(@Data_ult_costo)||' Data:'||string(@LaData)||' U.B.:'||@unita_base*/
	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          /* BL#20265#i */
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          /*select @Ult_Costo=@Prezzo*/
	          /* BL#2026#f*/
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end
	      /*
	      Elisa M.                          21/06/1999
	      Gestione Ordinato Clienti e Ordinato Fornitori
	      */
	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza
	      /*
	      Elisa Moneti
	      29/01/1999
	      Oggetto: Aggiornamento della "Data Ultimo Scarico"
	      */
	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          /*
	          Elisa M.                              21/06/1999
	          Gestione Ordinato Clienti
	          */
	          if @M_Ord_Clienti='-'
	            begin
	              /* STORNO (DELETE e prima parte dell''UPDATE) */
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              /* AGGIUNTA (INSERT e seconda parte dell'UPDATE)
	
	              Verifico che la qta evasa o peso evaso della riga 
	              dalla quale deriva (qui arriva gia' aggiornata
	              della qta e del peso del movimento attuale)
	              non sia maggiore della qta ordinata e del peso ordinato
	              */
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        /*
	        Elisa M.                                21/06/1999
	        Gestione Ordinato Fornitori (come Ordinato Clienti)
	        */
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          /*                       // BL#14237#*/
	          /*          if Substr(@Evento,1,1)='+'*/
	          /*            begin*/
	          /*              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)*/
	          update riepilogo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            /* Elisa M.     21/09/2000      BL7889*/
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            /**/
	            where(riepilogo.id_esercizio=@Id_Esercizio)
	            and(riepilogo.id_attivita=@Id_Attivita)
	            and(riepilogo.id_articolo=@Id_Articolo)
	            and(riepilogo.pk_codice=@pk_codice)
	            and(riepilogo.id_locazione=@Id_Locazione)
	            and(riepilogo.anno=@Anno)
	            and(riepilogo.mese=@Mese)
	            and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              /* BL#14142                */
	              /*              execute sp_ultimo_costo @id_articolo,@LaData,1,@Data_Ult_costo,@Ult_Costo   */
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  /* BL#20265#i */
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  /*select @Ult_Costo=@Prezzo*/
	                  /* BL#2026#f*/
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                /*BL#14142#i*/
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              /*BL#14142#f*/
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,
	                    /* BL#15075#*/
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889*/
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,                    
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889 */
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              message ' -> ',sqlstate
	            end
	        end

  select @parsis_riepart=par_sistema.gest_riepart
	 from "dba".par_sistema

     if(@parsis_riepart = 'S') begin
    	execute "dba".sp_gest_caus_art_riepilogo @Evento, @LaData, @ID_Esercizio, @ID_Attivita, @ID_Articolo, @ID_Locazione, @Anno, @Mese, @Qta, @Valore, @Prezzo, @ID_Caus_Magazzino, @id_unita_confezione, @ll_id_riga_doc_provenienza, @peso_netto, @pk_codice, @id_var1, @id_var2, @id_var3
	  end 

     select @parsis_riepuc=par_sistema.gest_riepuc
	 from "dba".par_sistema
	 
     if(@parsis_riepuc = 'S') begin
        execute "dba".sp_gest_causale_var_uc @Evento, @LaData, @ID_Esercizio, @ID_Attivita, @ID_Articolo, @ID_Locazione, @Anno, @Mese, @Qta, @Valore, @Prezzo, @ID_Caus_Magazzino, @id_unita_confezione, @ll_id_riga_doc_provenienza, @peso_netto, @pk_codice, @id_var1, @id_var2, @id_var3
     end 


	//////***  solo quando servira per varianti - execute "dba".sp_gest_caus_art_riep_var @Evento, @LaData, @ID_Esercizio, @ID_Attivita, @ID_Articolo, @ID_Locazione, @Anno, @Mese, @Qta, @Valore, @Prezzo, @ID_Caus_Magazzino, @id_unita_confezione, @ll_id_riga_doc_provenienza, @peso_netto, @pk_codice, @id_var1, @id_var2, @id_var3


	    end
end;



ALTER PROCEDURE "DBA"."sp_gest_caus_art_riepilogo"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Riccardo    02/2011
	  Oggetto: Riepiloghi per Articolo - Variante
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l''unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer,
      @li_par_sis_loc integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)

      select @li_par_sis_loc=par_sistema.gest_riepart_locazione
	  from "dba".par_sistema

       if not(@li_par_sis_loc is null) and not(@ID_Locazione is null) and @ID_Locazione<>@li_par_sis_loc 
        begin
    	  message 'sp_gest_causale --->'
	      message 'riga scartata'
        end 
       else
        begin


	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino

	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione


    if (@unita_base = 'N') 
        begin
            select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
            from "dba".unita_confezione
            where unita_confezione.unita_base = 'S'
            and unita_confezione.id_articolo = @id_articolo
            select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
            message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
    end    


	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riep_articolo.ult_costo,
	        @Data_Ult_Costo=riep_articolo.data_ult_costo,
	        @Qta_Rim_Iniziale=riep_articolo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riep_articolo.val_rim_iniziale,
	        @Qta_Caricata=riep_articolo.qta_caricata,
	        @Qta_Scaricata=riep_articolo.qta_scaricata,
	        @Val_Caricato=riep_articolo.val_caricato,
	        @Val_Scaricato=riep_articolo.val_scaricato,
	        @Data_Ult_Scarico=riep_articolo.data_ult_scarico,
	        @Qta_Ord_Clienti=riep_articolo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riep_articolo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riep_articolo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riep_articolo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riep_articolo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riep_articolo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riep_articolo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riep_articolo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riep_articolo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riep_articolo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riep_articolo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riep_articolo.qta_gruppo_lib_4,
	        @peso_caricato=riep_articolo.peso_caricato,
	        @peso_scaricato=riep_articolo.peso_scaricato,
	        @peso_ord_clienti=riep_articolo.peso_ord_clienti,
	        @peso_ord_fornitori=riep_articolo.peso_ord_fornitori,
	        @peso_vis_clienti=riep_articolo.peso_vis_clienti,
	        @peso_vis_fornitori=riep_articolo.peso_vis_fornitori,
	        @peso_imp_produzione=riep_articolo.peso_imp_produzione,
	        @peso_ord_produzione=riep_articolo.peso_ord_produzione,
	        @peso_cl_clienti=riep_articolo.peso_cl_clienti,
	        @peso_cl_fornitori=riep_articolo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riep_articolo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riep_articolo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riep_articolo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riep_articolo.peso_gruppo_lib_4
	        from "dba".riep_articolo
	        where(riep_articolo.id_articolo=@Id_Articolo)

	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)

	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end

	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza

	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          if @M_Ord_Clienti='-'
	            begin
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          update riep_articolo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            where (riep_articolo.id_articolo=@Id_Articolo)

	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riep_articolo(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4) 
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riep_articolo(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4) 

	                end
	              message ' -> ',sqlstate
	            end
	        end
	    end
	end
end;


///TABELLE NOTE

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'stad_nota')) THEN

	CREATE TABLE "dba"."stad_nota" ("id_nota" integer NOT NULL DEFAULT autoincrement, "tipo_provenienza" char(1) NOT NULL DEFAULT NULL, 
			"id_provenienza" integer DEFAULT NULL, "data_creazione" date NOT NULL DEFAULT NULL, "stato" char(1) NOT NULL DEFAULT NULL, 
			"csoci" char(4) NOT NULL DEFAULT NULL, "data_allarme" date DEFAULT NULL, "des_provenienza" char(120) NOT NULL DEFAULT NULL, 
			"char_id" char(256) DEFAULT NULL, "importo" numeric(20,6) DEFAULT NULL , PRIMARY KEY ("id_nota")) ;
	CREATE TABLE "dba"."stad_ntct" ("tipo_provenienza" char(1) NOT NULL DEFAULT NULL, "cat_provenienza" char(80) NOT NULL DEFAULT NULL, 
			"win_sw" char(80) DEFAULT NULL, "fil_sw" char(80) DEFAULT NULL, "sql_sw" char(256) DEFAULT NULL , PRIMARY KEY ("tipo_provenienza")) ;
	CREATE TABLE "dba"."stad_ntgr" ("id_note_gruppi" integer NOT NULL DEFAULT autoincrement, "cod_gruppo" char(8) NOT NULL DEFAULT NULL, 
			"des_gruppo" char(80) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_note_gruppi")) ;
	CREATE UNIQUE INDEX "xk_stad_ntgr_2" ON "dba"."stad_ntgr" ("cod_gruppo" ) ;
	CREATE TABLE "dba"."stad_ntre" ("id_regole_invio" integer NOT NULL DEFAULT autoincrement, "tipo_provenienza" char(1) NOT NULL DEFAULT NULL, 
			"id_note_gruppi" integer NOT NULL DEFAULT NULL, "csoci" char(4) DEFAULT NULL, "sog_numeratore" char(4) DEFAULT NULL, 
			"cod_sog_commerciale" char(8) DEFAULT NULL, "priorita" integer NOT NULL DEFAULT NULL, "cod_articolo" char(32) DEFAULT NULL, 
			"ctipo_dmaga" char(4) DEFAULT NULL, "cmaga" char(8) DEFAULT NULL , PRIMARY KEY ("id_regole_invio")) ;
	CREATE TABLE "dba"."stad_ntrw" ("id_riga_nota" integer NOT NULL DEFAULT autoincrement, "id_nota" integer NOT NULL DEFAULT NULL, "id_utente" integer NOT NULL DEFAULT NULL, 
			"stato" char(1) DEFAULT NULL, "tipo_nota" char(1) NOT NULL DEFAULT NULL, "data_inserimento" date NOT NULL DEFAULT today(*), "data_avviso" date DEFAULT NULL, 
			"livello_priorita" char(1) DEFAULT 'D', "valutazione_risposta" char(1) DEFAULT NULL, "risposta" long varchar NOT NULL DEFAULT NULL, "durata" integer DEFAULT NULL , 
			PRIMARY KEY ("id_riga_nota") , FOREIGN KEY "fk_stad_ntrw_1" ("id_nota" ) REFERENCES "dba"."stad_nota" ON DELETE CASCADE ) ;
	CREATE TABLE "dba"."stad_ntug" ("id_note_utgr" integer NOT NULL DEFAULT autoincrement, "id_note_gruppi" integer NOT NULL DEFAULT NULL, "id_utenti" integer NOT NULL DEFAULT NULL , 
			PRIMARY KEY ("id_note_utgr") , FOREIGN KEY "fk_stad_ntug_1" ("id_note_gruppi" ) REFERENCES "dba"."stad_ntgr" ON DELETE RESTRICT ) ;
	CREATE UNIQUE INDEX "xk_stad_ntug_2" ON "dba"."stad_ntug" ("id_note_gruppi" , "id_utenti" ) ;
	CREATE TABLE "dba"."stad_ntut" ("id_ut_nota" integer NOT NULL DEFAULT autoincrement, "id_nota" integer NOT NULL DEFAULT NULL, "id_utente" integer NOT NULL DEFAULT NULL, 
			"stato" char(1) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_ut_nota") , FOREIGN KEY "fk_stad_ntut_1" ("id_nota" ) REFERENCES "dba"."stad_nota" ON DELETE CASCADE ) ;
	CREATE TABLE "dba"."stad_parsis" ("id_parsis" integer NOT NULL DEFAULT 1, "dir_report" char(256) DEFAULT NULL, "dir_immagini" char(256) DEFAULT NULL, "dir_allegati" char(256) DEFAULT NULL, 
			"dir_export" char(256) DEFAULT NULL , PRIMARY KEY ("id_parsis")) ;


	insert into stad_nota (id_nota, tipo_provenienza, id_provenienza,  data_creazione, stato, csoci, des_provenienza)
	select id_arky_note, 'A', 0,  data_nota, stato_nota, '    ', cod_nota from arky_note;
	insert into stad_ntrw (id_riga_nota, id_nota, id_utente, stato,  tipo_nota, data_inserimento, livello_priorita, risposta)
	select id_arky_note, id_arky_note, id_per_ut, stato_nota, 'A', data_nota, 'D', des_nota from arky_note;
	insert into stad_ntut (id_nota, id_utente, stato)
	select id_arky_note, id_per_ut, stato_nota from arky_note;

	call fn_ins_voce_menu('Personalizzazioni', null, 'COMUNICAZIONI', 0);
	call fn_ins_voce_menu('COMUNICAZIONI', 'w_nota_brows_wz', 'Gestione Note', 10);
	call fn_ins_voce_menu('COMUNICAZIONI', 'w_nota_ff', 'Inserimento Nota', 20);
	call fn_ins_voce_menu('COMUNICAZIONI', 'w_nota_gruppi_lt', 'Gruppi Utenti', 25);
	call fn_ins_voce_menu('COMUNICAZIONI', 'w_note_reg_invio_lt', 'Regole Invio', 30);


end if;


IF (SELECT count() FROM   voci_menu WHERE  vmenu_voce = 'Plug-In')=0 THEN

	insert into voci_menu ( id_menu, vmenu_voce, vmenu_order, header_menu, header_vis )
	select id_menu, 'Plug-In', vmenu_order, 'N', header_vis from voci_menu where  header_vis='S' and header_menu='I';
	update voci_menu set vmenu_order=13 where  header_vis='S' and header_menu='I';

	update voci_menu v1 
	set v1.id_voci_menu_padre=(select v2.id_voci_menu from voci_menu v2 
	where v2.id_menu=(select v3.id_menu from voci_menu v3 where v3.id_voci_menu=v1.id_voci_menu_padre) and v2.header_menu='N') where v1.vmenu_voce='Corrispondenza';

	update voci_menu v1 
	set v1.id_voci_menu_padre=(select v2.id_voci_menu from voci_menu v2 
	where v2.id_menu=(select v3.id_menu from voci_menu v3 where v3.id_voci_menu=v1.id_voci_menu_padre) and v2.header_menu='N') where v1.vmenu_voce='Allegati';

	update voci_menu v1 
	set v1.id_voci_menu_padre=(select v2.id_voci_menu from voci_menu v2 
	where v2.id_menu=(select v3.id_menu from voci_menu v3 where v3.id_voci_menu=v1.id_voci_menu_padre) and v2.header_menu='N') where v1.vmenu_voce='Comunicazioni';

end if;

/////////
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'nazione'
        AND      CNAME = 'cod_territorio')) THEN 
		
		ALTER TABLE nazione ADD cod_territorio char(3);
		update nazione set cod_territorio = '238'  where descrizione like 'abudhabi';
		update nazione set cod_territorio = '002'  where descrizione like 'afghanistan';
		update nazione set cod_territorio = '239'  where descrizione like 'ajman';
		update nazione set cod_territorio = '292'  where descrizione like 'isole aland';
		update nazione set cod_territorio = '087'  where descrizione like 'albania';
		update nazione set cod_territorio = '003'  where descrizione like 'algeria';
		update nazione set cod_territorio = '148'  where descrizione like 'samoa americane';
		update nazione set cod_territorio = '004'  where descrizione like 'andorra';
		update nazione set cod_territorio = '133'  where descrizione like 'angola';
		update nazione set cod_territorio = '209'  where descrizione like 'anguilla';
		update nazione set cod_territorio = '180'  where descrizione like 'antartide';
		update nazione set cod_territorio = '197'  where descrizione like 'antigua e barbuda';
		update nazione set cod_territorio = '251'  where descrizione like 'antille olandesi';
		update nazione set cod_territorio = '005'  where descrizione like 'arabia saudita';
		update nazione set cod_territorio = '006'  where descrizione like 'argentina';
		update nazione set cod_territorio = '266'  where descrizione like 'armenia';
		update nazione set cod_territorio = '212'  where descrizione like 'aruba';
		update nazione set cod_territorio = '227'  where descrizione like 'ascension';
		update nazione set cod_territorio = '007'  where descrizione like 'australia';
		update nazione set cod_territorio = '008'  where descrizione like 'austria';
		update nazione set cod_territorio = '268'  where descrizione like 'azerbaijan';
		update nazione set cod_territorio = '234'  where descrizione like 'isole azzorre';
		update nazione set cod_territorio = '160'  where descrizione like 'bahamas';
		update nazione set cod_territorio = '169'  where descrizione like 'bahrain';
		update nazione set cod_territorio = '130'  where descrizione like 'bangladesh';
		update nazione set cod_territorio = '118'  where descrizione like 'barbados';
		update nazione set cod_territorio = '009'  where descrizione like 'belgio';
		update nazione set cod_territorio = '198'  where descrizione like 'belize';
		update nazione set cod_territorio = '158'  where descrizione like 'benin';
		update nazione set cod_territorio = '207'  where descrizione like 'bermuda';
		update nazione set cod_territorio = '097'  where descrizione like 'bhutan';
		update nazione set cod_territorio = '264'  where descrizione like 'bielorussia';
		update nazione set cod_territorio = '010'  where descrizione like 'bolivia';
		update nazione set cod_territorio = '274'  where descrizione like 'bosnia erzegovina';
		update nazione set cod_territorio = '098'  where descrizione like 'botswana';
		update nazione set cod_territorio = '280'  where descrizione like 'isola bouvet';
		update nazione set cod_territorio = '011'  where descrizione like 'brasile';
		update nazione set cod_territorio = '125'  where descrizione like 'brunei darussalam';
		update nazione set cod_territorio = '012'  where descrizione like 'bulgaria';
		update nazione set cod_territorio = '142'  where descrizione like 'burkina faso';
		update nazione set cod_territorio = '025'  where descrizione like 'burundi';
		update nazione set cod_territorio = '135'  where descrizione like 'cambogia';
		update nazione set cod_territorio = '119'  where descrizione like 'camerun';
		update nazione set cod_territorio = '013'  where descrizione like 'canada';
		update nazione set cod_territorio = '100'  where descrizione like 'isole canarie';
		update nazione set cod_territorio = '188'  where descrizione like 'capo verde';
		update nazione set cod_territorio = '256'  where descrizione like 'isole caroline';
		update nazione set cod_territorio = '211'  where descrizione like 'isole cayman';
		update nazione set cod_territorio = '275'  where descrizione like 'repubblica ceca';
		update nazione set cod_territorio = '143'  where descrizione like 'repubblica centroafricana';
		update nazione set cod_territorio = '246'  where descrizione like 'ceuta';
		update nazione set cod_territorio = '230'  where descrizione like 'chafarinas';
		update nazione set cod_territorio = '255'  where descrizione like 'isole chagos';
		update nazione set cod_territorio = '282'  where descrizione like 'isola di natale';
		update nazione set cod_territorio = '144'  where descrizione like 'ciad';
		update nazione set cod_territorio = '015'  where descrizione like 'cile';
		update nazione set cod_territorio = '016'  where descrizione like 'cina';
		update nazione set cod_territorio = '101'  where descrizione like 'cipro';
		update nazione set cod_territorio = '093'  where descrizione like 'citt del vaticano';
		update nazione set cod_territorio = '223'  where descrizione like 'clipperton';
		update nazione set cod_territorio = '281'  where descrizione like 'isole cocos';
		update nazione set cod_territorio = '017'  where descrizione like 'colombia';
		update nazione set cod_territorio = '176'  where descrizione like 'comore';
		update nazione set cod_territorio = '145'  where descrizione like 'congo';
		update nazione set cod_territorio = '018'  where descrizione like 'repubblica del congo';
		update nazione set cod_territorio = '237'  where descrizione like 'isole cook';
		update nazione set cod_territorio = '074'  where descrizione like 'corea del nord';
		update nazione set cod_territorio = '084'  where descrizione like 'corea del sud';
		update nazione set cod_territorio = '146'  where descrizione like 'costa davorio';
		update nazione set cod_territorio = '019'  where descrizione like 'costa rica';
		update nazione set cod_territorio = '261'  where descrizione like 'croazia';
		update nazione set cod_territorio = '020'  where descrizione like 'cuba';
		update nazione set cod_territorio = '021'  where descrizione like 'danimarca';
		update nazione set cod_territorio = '192'  where descrizione like 'dominica';
		update nazione set cod_territorio = '063'  where descrizione like 'repubblica dominicana';
		update nazione set cod_territorio = '240'  where descrizione like 'dubai';
		update nazione set cod_territorio = '024'  where descrizione like 'ecuador';
		update nazione set cod_territorio = '023'  where descrizione like 'egitto';
		update nazione set cod_territorio = '277'  where descrizione like 'eritrea';
		update nazione set cod_territorio = '257'  where descrizione like 'estonia';
		update nazione set cod_territorio = '026'  where descrizione like 'etiopia';
		update nazione set cod_territorio = '204'  where descrizione like 'isole faroe';
		update nazione set cod_territorio = '190'  where descrizione like 'isole falkland';
		update nazione set cod_territorio = '161'  where descrizione like 'fiji';
		update nazione set cod_territorio = '027'  where descrizione like 'filippine';
		update nazione set cod_territorio = '028'  where descrizione like 'finlandia';
		update nazione set cod_territorio = '029'  where descrizione like 'francia';
		update nazione set cod_territorio = '241'  where descrizione like 'fuijayrah';
		update nazione set cod_territorio = '157'  where descrizione like 'gabon';
		update nazione set cod_territorio = '164'  where descrizione like 'gambia';
		update nazione set cod_territorio = '267'  where descrizione like 'georgia';
		update nazione set cod_territorio = '094'  where descrizione like 'germania';
		update nazione set cod_territorio = '112'  where descrizione like 'ghana';
		update nazione set cod_territorio = '082'  where descrizione like 'giamaica';
		update nazione set cod_territorio = '088'  where descrizione like 'giappone';
		update nazione set cod_territorio = '102'  where descrizione like 'gibilterra';
		update nazione set cod_territorio = '113'  where descrizione like 'gibuti';
		update nazione set cod_territorio = '122'  where descrizione like 'giordania';
		update nazione set cod_territorio = '228'  where descrizione like 'gough';
		update nazione set cod_territorio = '032'  where descrizione like 'grecia';
		update nazione set cod_territorio = '156'  where descrizione like 'grenada';
		update nazione set cod_territorio = '200'  where descrizione like 'groenlandia';
		update nazione set cod_territorio = '214'  where descrizione like 'guadalupa';
		update nazione set cod_territorio = '154'  where descrizione like 'guam';
		update nazione set cod_territorio = '033'  where descrizione like 'guatemala';
		update nazione set cod_territorio = '123'  where descrizione like 'guyana francese';
		update nazione set cod_territorio = '201'  where descrizione like 'guernsey';
		update nazione set cod_territorio = '137'  where descrizione like 'guinea';
		update nazione set cod_territorio = '185'  where descrizione like 'guinea-bissau';
		update nazione set cod_territorio = '167'  where descrizione like 'guinea equatoriale';
		update nazione set cod_territorio = '159'  where descrizione like 'guyana';
		update nazione set cod_territorio = '034'  where descrizione like 'haiti';
		update nazione set cod_territorio = '284'  where descrizione like 'isola heard e isole mcdonald';
		update nazione set cod_territorio = '035'  where descrizione like 'honduras';
		update nazione set cod_territorio = '103'  where descrizione like 'hong kong';
		update nazione set cod_territorio = '114'  where descrizione like 'india';
		update nazione set cod_territorio = '129'  where descrizione like 'indonesia';
		update nazione set cod_territorio = '039'  where descrizione like 'iran';
		update nazione set cod_territorio = '038'  where descrizione like 'iraq';
		update nazione set cod_territorio = '040'  where descrizione like 'eire';
		update nazione set cod_territorio = '041'  where descrizione like 'islanda';
		update nazione set cod_territorio = '252'  where descrizione like 'isole americane del pacifico';
		update nazione set cod_territorio = '182'  where descrizione like 'israele';
		update nazione set cod_territorio = '202'  where descrizione like 'jerseyc';
		update nazione set cod_territorio = '269'  where descrizione like 'kazakhistan';
		update nazione set cod_territorio = '116'  where descrizione like 'kenya';
		update nazione set cod_territorio = '270'  where descrizione like 'kirghizistan';
		update nazione set cod_territorio = '194'  where descrizione like 'kiribati';
		update nazione set cod_territorio = '291'  where descrizione like 'kosovo';
		update nazione set cod_territorio = '126'  where descrizione like 'kuwait';
		update nazione set cod_territorio = '136'  where descrizione like 'laos';
		update nazione set cod_territorio = '089'  where descrizione like 'lesotho';
		update nazione set cod_territorio = '258'  where descrizione like 'lettonia';
		update nazione set cod_territorio = '095'  where descrizione like 'libano';
		update nazione set cod_territorio = '044'  where descrizione like 'liberia';
		update nazione set cod_territorio = '045'  where descrizione like 'libia';
		update nazione set cod_territorio = '090'  where descrizione like 'liechtenstein';
		update nazione set cod_territorio = '259'  where descrizione like 'lituania';
		update nazione set cod_territorio = '092'  where descrizione like 'lussemburgo';
		update nazione set cod_territorio = '059'  where descrizione like 'macao';
		update nazione set cod_territorio = '278'  where descrizione like 'macedonia';
		update nazione set cod_territorio = '104'  where descrizione like 'madagascar';
		update nazione set cod_territorio = '235'  where descrizione like 'madeira';
		update nazione set cod_territorio = '056'  where descrizione like 'malawi';
		update nazione set cod_territorio = '106'  where descrizione like 'malesia';
		update nazione set cod_territorio = '127'  where descrizione like 'maldive';
		update nazione set cod_territorio = '149'  where descrizione like 'mali';
		update nazione set cod_territorio = '105'  where descrizione like 'malta';
		update nazione set cod_territorio = '203'  where descrizione like 'manisola';
		update nazione set cod_territorio = '219'  where descrizione like 'isole marianne settentrionali';
		update nazione set cod_territorio = '107'  where descrizione like 'marocco';
		update nazione set cod_territorio = '217'  where descrizione like 'isole marshall';
		update nazione set cod_territorio = '213'  where descrizione like 'martinica';
		update nazione set cod_territorio = '141'  where descrizione like 'mauritania';
		update nazione set cod_territorio = '128'  where descrizione like 'maurizius';
		update nazione set cod_territorio = '226'  where descrizione like 'mayotte';
		update nazione set cod_territorio = '231'  where descrizione like 'melilla';
		update nazione set cod_territorio = '046'  where descrizione like 'messico';
		update nazione set cod_territorio = '215'  where descrizione like 'stati federati della micronesia';
		update nazione set cod_territorio = '177'  where descrizione like 'isole midway';
		update nazione set cod_territorio = '265'  where descrizione like 'moldavia';
		update nazione set cod_territorio = '110'  where descrizione like 'mongolia';
		update nazione set cod_territorio = '290'  where descrizione like 'montenegro';
		update nazione set cod_territorio = '208'  where descrizione like 'montserrat';
		update nazione set cod_territorio = '134'  where descrizione like 'mozambico';
		update nazione set cod_territorio = '083'  where descrizione like 'myanmar';
		update nazione set cod_territorio = '206'  where descrizione like 'namibia';
		update nazione set cod_territorio = '109'  where descrizione like 'nauru';
		update nazione set cod_territorio = '115'  where descrizione like 'nepal';
		update nazione set cod_territorio = '047'  where descrizione like 'nicaragua';
		update nazione set cod_territorio = '150'  where descrizione like 'niger';
		update nazione set cod_territorio = '117'  where descrizione like 'nigeria';
		update nazione set cod_territorio = '205'  where descrizione like 'niue';
		update nazione set cod_territorio = '285'  where descrizione like 'isola norfolk';
		update nazione set cod_territorio = '048'  where descrizione like 'norvegia';
		update nazione set cod_territorio = '253'  where descrizione like 'nuova caledonia';
		update nazione set cod_territorio = '049'  where descrizione like 'nuova zelanda';
		update nazione set cod_territorio = '163'  where descrizione like 'oman';
		update nazione set cod_territorio = '050'  where descrizione like 'paesi bassi';
		update nazione set cod_territorio = '036'  where descrizione like 'pakistan';
		update nazione set cod_territorio = '216'  where descrizione like 'palau';
		update nazione set cod_territorio = '279'  where descrizione like 'palestina';
		update nazione set cod_territorio = '051'  where descrizione like 'panama';
		update nazione set cod_territorio = '186'  where descrizione like 'papua nuova guinea';
		update nazione set cod_territorio = '052'  where descrizione like 'paraguay';
		update nazione set cod_territorio = '232'  where descrizione like 'penondealhucemas';
		update nazione set cod_territorio = '233'  where descrizione like 'penondevelezdelagomera';
		update nazione set cod_territorio = '053'  where descrizione like 'per';
		update nazione set cod_territorio = '175'  where descrizione like 'pitcairn';
		update nazione set cod_territorio = '225'  where descrizione like 'polinesia francese';
		update nazione set cod_territorio = '054'  where descrizione like 'polonia';
		update nazione set cod_territorio = '055'  where descrizione like 'portogallo';
		update nazione set cod_territorio = '220'  where descrizione like 'porto rico';
		update nazione set cod_territorio = '091'  where descrizione like 'monaco';
		update nazione set cod_territorio = '168'  where descrizione like 'qatar';
		update nazione set cod_territorio = '242'  where descrizione like 'raselkaimah';
		update nazione set cod_territorio = '031'  where descrizione like 'regno unito';
		update nazione set cod_territorio = '247'  where descrizione like 'reunion';
		update nazione set cod_territorio = '061'  where descrizione like 'romania';
		update nazione set cod_territorio = '151'  where descrizione like 'ruanda';
		update nazione set cod_territorio = '262'  where descrizione like 'federazione russa';
		update nazione set cod_territorio = '166'  where descrizione like 'sahara occidentale';
		update nazione set cod_territorio = '195'  where descrizione like 'saint kitts e nevis';
		update nazione set cod_territorio = '199'  where descrizione like 'santa lucia';
		update nazione set cod_territorio = '222'  where descrizione like 'saint martin settentrionale';
		update nazione set cod_territorio = '248'  where descrizione like 'saint pierre e miquelon';
		update nazione set cod_territorio = '191'  where descrizione like 'isole solomon';
		update nazione set cod_territorio = '064'  where descrizione like 'el salvador';
		update nazione set cod_territorio = '131'  where descrizione like 'samoa';
		update nazione set cod_territorio = '293'  where descrizione like 'saint barthelemy';
		update nazione set cod_territorio = '037'  where descrizione like 'san marino';
		update nazione set cod_territorio = '187'  where descrizione like 'sao tome e principe';
		update nazione set cod_territorio = '152'  where descrizione like 'senegal';
		update nazione set cod_territorio = '189'  where descrizione like 'seychelles';
		update nazione set cod_territorio = '289'  where descrizione like 'serbia e montenegro';
		update nazione set cod_territorio = '243'  where descrizione like 'sharjah';
		update nazione set cod_territorio = '153'  where descrizione like 'sierra leone';
		update nazione set cod_territorio = '147'  where descrizione like 'singapore';
		update nazione set cod_territorio = '065'  where descrizione like 'siria';
		update nazione set cod_territorio = '276'  where descrizione like 'slovacchia';
		update nazione set cod_territorio = '260'  where descrizione like 'slovenia';
		update nazione set cod_territorio = '066'  where descrizione like 'somalia';
		update nazione set cod_territorio = '283'  where descrizione like 'sud georgia e isole sandwich';
		update nazione set cod_territorio = '067'  where descrizione like 'spagna';
		update nazione set cod_territorio = '085'  where descrizione like 'sri lanka';
		update nazione set cod_territorio = '254'  where descrizione like 'sant elena';
		update nazione set cod_territorio = '196'  where descrizione like 'saint vincent e grenadine';
		update nazione set cod_territorio = '069'  where descrizione like 'stati uniti america';
		update nazione set cod_territorio = '078'  where descrizione like 'sud africa';
		update nazione set cod_territorio = '070'  where descrizione like 'sudan';
		update nazione set cod_territorio = '124'  where descrizione like 'suriname';
		update nazione set cod_territorio = '286'  where descrizione like 'svalbard e jan mayen';
		update nazione set cod_territorio = '068'  where descrizione like 'svezia';
		update nazione set cod_territorio = '071'  where descrizione like 'svizzera';
		update nazione set cod_territorio = '138'  where descrizione like 'swaziland';
		update nazione set cod_territorio = '272'  where descrizione like 'tagikistan';
		update nazione set cod_territorio = '022'  where descrizione like 'taiwan';
		update nazione set cod_territorio = '057'  where descrizione like 'tanzania';
		update nazione set cod_territorio = '183'  where descrizione like 'territori francesi del sud';
		update nazione set cod_territorio = '245'  where descrizione like 'territorio britannici oceano indiano';
		update nazione set cod_territorio = '072'  where descrizione like 'tailandia';
		update nazione set cod_territorio = '287'  where descrizione like 'timor est';
		update nazione set cod_territorio = '155'  where descrizione like 'togo';
		update nazione set cod_territorio = '236'  where descrizione like 'tokelau';
		update nazione set cod_territorio = '162'  where descrizione like 'tonga';
		update nazione set cod_territorio = '120'  where descrizione like 'trinidad e tobago';
		update nazione set cod_territorio = '229'  where descrizione like 'tristandacunha';
		update nazione set cod_territorio = '075'  where descrizione like 'tunisia';
		update nazione set cod_territorio = '076'  where descrizione like 'turchia';
		update nazione set cod_territorio = '273'  where descrizione like 'turkmenistan';
		update nazione set cod_territorio = '210'  where descrizione like 'isole turks e caicos';
		update nazione set cod_territorio = '193'  where descrizione like 'tuvalu';
		update nazione set cod_territorio = '263'  where descrizione like 'ucraina';
		update nazione set cod_territorio = '132'  where descrizione like 'uganda';
		update nazione set cod_territorio = '244'  where descrizione like 'ummalqaiwain';
		update nazione set cod_territorio = '077'  where descrizione like 'ungheria';
		update nazione set cod_territorio = '080'  where descrizione like 'uruguay';
		update nazione set cod_territorio = '271'  where descrizione like 'uzbekistan';
		update nazione set cod_territorio = '121'  where descrizione like 'vanuatu';
		update nazione set cod_territorio = '081'  where descrizione like 'venezuela';
		update nazione set cod_territorio = '221'  where descrizione like 'isole vergini americane';
		update nazione set cod_territorio = '249'  where descrizione like 'isole vergini britanniche';
		update nazione set cod_territorio = '062'  where descrizione like 'vietnam';
		update nazione set cod_territorio = '178'  where descrizione like 'isole wake';
		update nazione set cod_territorio = '218'  where descrizione like 'wallis e futuna';
		update nazione set cod_territorio = '042'  where descrizione like 'yemen';
		update nazione set cod_territorio = '058'  where descrizione like 'zambia';
		update nazione set cod_territorio = '073'  where descrizione like 'zimbabwe';		
		
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'doc_contratto')) THEN
		
		CREATE TABLE "dba"."doc_contratto" (
		"id_doc_contratto" integer NOT NULL DEFAULT autoincrement, 
		"stato" char(1) NOT NULL DEFAULT 'A', 
		"codice" char(40) NOT NULL DEFAULT NULL, 
		"id_conto" integer NOT NULL DEFAULT NULL, 
		"id_registro" integer NOT NULL DEFAULT NULL, 
		"num_progressivo" integer NOT NULL DEFAULT NULL, 
		"data_registrazione" date NOT NULL DEFAULT NULL, 
		"id_documento" integer DEFAULT NULL, 
		"id_reg_pd" integer DEFAULT NULL, 
		"multi_esercizio" char(1) NOT NULL DEFAULT 'N', 
		"id_esercizio" integer DEFAULT NULL, 
		"tipo_comunicazione" char(1) NOT NULL DEFAULT 'N', 
		"importo_previsto" decimal(18,4) DEFAULT NULL , 
		PRIMARY KEY ("id_doc_contratto") , 
		FOREIGN KEY "fk_doc_contratti_doc" ("id_documento" ) REFERENCES "dba"."documento" ON DELETE CASCADE , 
		FOREIGN KEY "fk_doc_contratto_reg" ("id_reg_pd" ) REFERENCES "dba"."reg_pd" ON DELETE CASCADE ) ;
		CREATE UNIQUE INDEX "xk_doc_contratto" ON "dba"."doc_contratto" ("id_doc_contratto" ) ;	
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'nc_rif_doc')) THEN
		
		CREATE TABLE "dba"."nc_rif_doc" (
		"id_nc_rif_doc" integer NOT NULL DEFAULT autoincrement, 
		"id_reg_nc" integer NOT NULL DEFAULT NULL, 
		"num_prog_nc" integer NOT NULL DEFAULT NULL, 
		"data_reg_nc" date NOT NULL DEFAULT NULL, 
		"id_reg_fat" integer NOT NULL DEFAULT NULL, 
		"num_prog_fat" integer NOT NULL DEFAULT NULL, 
		"data_reg_fat" date NOT NULL DEFAULT NULL, 
		"num_doc_fat" char(20) NOT NULL DEFAULT NULL, 
		"data_doc_fat" date NOT NULL DEFAULT NULL, 
		"id_reg_pd_nc" integer DEFAULT NULL, 
		"id_doc_nc" integer DEFAULT NULL , 
		PRIMARY KEY ("id_nc_rif_doc") , 
		FOREIGN KEY "fk_nc_rif_doc_2" ("id_doc_nc" ) REFERENCES "dba"."documento" ON DELETE CASCADE , 
		FOREIGN KEY "fk_nc_rif_doc_1" ("id_reg_pd_nc" ) REFERENCES "dba"."reg_pd" ON DELETE CASCADE ) ;
		CREATE UNIQUE INDEX "xk_nc_rif_doc_1" ON "dba"."nc_rif_doc" ("num_prog_nc" , "id_reg_fat" ) ;
		
		call fn_ins_voce_menu('Anagrafica', 'w_3000_contratti_wz', 'Inserimento Contratti', 140);
		call fn_ins_voce_menu('Anagrafica', 'w_controllo_3000_note_di_credito_ff', 'Riferimenti Variazioni', 145);
end if;
////////////////



//comunicazione 3000 euro
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tab_iva'
        AND      CNAME = 'usa_comunicazioni')) THEN 
			
	ALTER TABLE tab_iva ADD usa_comunicazioni char(1) DEFAULT 'S';
	UPDATE tab_iva set usa_comunicazioni='S';
end if;


IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'nc_rif_doc'
        AND      CNAME = 'id_reg_pd_fat')) THEN 

	ALTER TABLE nc_rif_doc ADD id_reg_pd_fat integer DEFAULT NULL; 
	ALTER TABLE nc_rif_doc ADD FOREIGN KEY "fk_nc_rif_doc_3" ("id_reg_pd_fat" ) REFERENCES "dba"."reg_pd" ON DELETE CASCADE ;
end if;

////////////////////////////

///Velardo
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'gest_gara'
        AND      CNAME = 'link')) THEN 
		
		ALTER TABLE gest_gara ADD "link" char(250) DEFAULT NULL;
		
end if;		
///////////////////////




IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 't3000_rec1')) THEN


	CREATE TABLE "dba"."t3000_rec1" ("id_3000_rec1" integer NOT NULL DEFAULT autoincrement, "tipo" char(1) NOT NULL DEFAULT NULL, "cod_fiscale" char(16) NOT NULL DEFAULT NULL, "data_doc" date NOT NULL DEFAULT NULL, "mod_pag" char(1) NOT NULL DEFAULT NULL, "importo" decimal(18,2) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_3000_rec1")) ;
	CREATE TABLE "dba"."t3000_rec2" ("id_3000_rec2" integer NOT NULL DEFAULT autoincrement, "tipo" char(1) NOT NULL DEFAULT NULL, "par_iva" char(16) NOT NULL DEFAULT NULL, "data_doc" date NOT NULL DEFAULT NULL, "num_doc" char(20) NOT NULL DEFAULT NULL, "mod_pag" char(1) NOT NULL DEFAULT NULL, "imponibile" decimal(18,2) NOT NULL DEFAULT NULL, "imposta" decimal(18,2) NOT NULL DEFAULT NULL, "tipo_op" char(1) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_3000_rec2")) ;
	CREATE TABLE "dba"."t3000_rec3" ("id_3000_rec3" integer NOT NULL DEFAULT autoincrement, "tipo" char(1) NOT NULL DEFAULT NULL, "cognome" char(80) NOT NULL DEFAULT NULL, "nome" char(80) NOT NULL DEFAULT NULL, "data_nascita" date NOT NULL DEFAULT NULL, "com_nascita" char(80) NOT NULL DEFAULT NULL, "prov_nascita" char(2) NOT NULL DEFAULT NULL, "cod_paese_residenza" char(3) NOT NULL DEFAULT NULL, "rag_soc_1" char(80) NOT NULL DEFAULT NULL, "localita" char(80) NOT NULL DEFAULT NULL, "cod_territorio" char(3) NOT NULL DEFAULT NULL, "indirizzo" char(80) NOT NULL DEFAULT NULL, "data_doc" date NOT NULL DEFAULT NULL, "num_doc" char(20) NOT NULL DEFAULT NULL, "mod_pag" char(1) NOT NULL DEFAULT NULL, "imponibile" decimal(18,2) NOT NULL DEFAULT NULL, "imposta" decimal(18,2) NOT NULL DEFAULT NULL, "tipo_op" char(1) NOT NULL DEFAULT NULL, "anagrafica_nat_giuridica" char(1) DEFAULT NULL NOT NULL , PRIMARY KEY ("id_3000_rec3")) ;
	CREATE TABLE "dba"."t3000_rec4" ("id_3000_rec4" integer NOT NULL DEFAULT autoincrement, "tipo" char(1) NOT NULL DEFAULT NULL, "par_iva" char(16) NOT NULL DEFAULT NULL, "cod_fiscale" char(16) NOT NULL DEFAULT NULL, "data_doc" date NOT NULL DEFAULT NULL, "num_doc" char(20) NOT NULL DEFAULT NULL, "imponibile" decimal(18,2) NOT NULL DEFAULT NULL, "imposta" decimal(18,2) NOT NULL DEFAULT NULL, "data_fat" date NOT NULL DEFAULT NULL, "num_fat" char(20) NOT NULL DEFAULT NULL, "tipo_op" char(1) NOT NULL DEFAULT NULL, "anagrafica_nat_giuridica" char(1) DEFAULT NULL NOT NULL , PRIMARY KEY ("id_3000_rec4")) ;
	CREATE TABLE "dba"."t3000_rec5" ("id_3000_rec5" integer NOT NULL DEFAULT autoincrement, "tipo" char(1) NOT NULL DEFAULT NULL, "cognome" char(80) NOT NULL DEFAULT NULL, "nome" char(80) NOT NULL DEFAULT NULL, "data_nascita" date NOT NULL DEFAULT NULL, "com_nascita" char(80) NOT NULL DEFAULT NULL, "prov_nascita" char(2) NOT NULL DEFAULT NULL, "cod_paese_residenza" char(3) NOT NULL DEFAULT NULL, "rag_soc_1" char(80) NOT NULL DEFAULT NULL, "localita" char(80) NOT NULL DEFAULT NULL, "cod_territorio" char(3) NOT NULL DEFAULT NULL, "indirizzo" char(80) NOT NULL DEFAULT NULL, "data_doc" date NOT NULL DEFAULT NULL, "num_doc" char(20) NOT NULL DEFAULT NULL, "imponibile" decimal(18,2) NOT NULL DEFAULT NULL, "imposta" decimal(18,2) NOT NULL DEFAULT NULL, "data_fat" date DEFAULT NULL, "num_fat" char(20) DEFAULT NULL, "tipo_op" char(1) DEFAULT NULL, "anagrafica_nat_giuridica" char(1) DEFAULT NULL NOT NULL, PRIMARY KEY ("id_3000_rec5")) ;


end if;




/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
//DA ESEGUIRE IN TUTTI GLI SCRIPT


IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'TMP_FATTURATO') THEN
	DROP TABLE TMP_FATTURATO;
end if; 



CREATE TABLE "dba"."tmp_fatturato" 
("cod_1" char(32) DEFAULT NULL, "des_1" char(80) DEFAULT NULL, "cod_2" char(32) DEFAULT NULL, 
"des_2" char(80) DEFAULT NULL, "cod_3" char(32) DEFAULT NULL, "des_3" char(80) DEFAULT NULL, 
"cod_4" char(32) DEFAULT NULL, "des_4" char(80) DEFAULT NULL, "imp_1" numeric(18,4) DEFAULT NULL, 
"imp_2" numeric(18,4) DEFAULT NULL, "cod_art" char(32) DEFAULT NULL, "des_art" char(80) DEFAULT NULL, 
"quantita" numeric(20,6) DEFAULT NULL, "peso_netto" numeric(20,6) DEFAULT NULL, 
"prezzo_netto" numeric(20,6) DEFAULT NULL, "num_progressivo" integer DEFAULT NULL, 
"data_registrazione" date DEFAULT NULL, "id_documento" integer DEFAULT NULL, "id_articolo" integer DEFAULT NULL, 
"id_tmp_fatturato" integer NOT NULL DEFAULT autoincrement, "segno_iva" integer DEFAULT NULL) ;


//////
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_05_001' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_05_001','Release 2_05_001  Cometa','S')
        ;

END IF
;

