//INIZIO 2_01_011

//Esportazione allegati Clienti/Fornitori su File
call fn_ins_voce_menu('Anagrafica', 'w_allegati_file_cx', 'Export Allegati CL/FO su File', 110);


//CASSA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sis_doc_semp'
        AND      CNAME = 'lancia_cassa' )) THEN 
        
	ALTER TABLE par_sis_doc_semp add lancia_cassa char(1);
	ALTER TABLE par_sis_doc_semp add prof_param char(2);

end if;

//Trasferimento Documenti Cometa (IMPORT/EXPORT) su File
call fn_ins_voce_menu('Documenti', 'w_export_docs_cx', 'Trasf. Documenti Cometa (EXPORT su File)', 200);
call fn_ins_voce_menu('Documenti', 'w_imp_docs_cx', 'Trasf. Documenti Cometa (IMPORT da File)', 210);

//Id Tab.Iva Default
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_tab_iva_default' )) THEN 
        
        ALTER TABLE par_sistema ADD id_tab_iva_default integer DEFAULT NULL;
end if;  
////////////////////

//Correzione problema long varchar su triggers riepilogo
ALTER TRIGGER "t_riepilogo_bi" BEFORE INSERT
 ORDER 1 ON "DBA"."riepilogo"
 referencing new as new_con
 for each row
 begin
     declare @ls_var1 long varchar;
     declare @ls_var2 long varchar;
     declare @ls_var3 long varchar;
     if new_con.id_art_var1 is null then
        set @ls_var1='N'
     else
         set @ls_var1=string(new_con.id_art_var1)
     end if;
     if new_con.id_art_var2 is null then
         set @ls_var2='N'
     else
         set @ls_var2=string(new_con.id_art_var2)
     end if;
     if new_con.id_art_var3 is null then
         set @ls_var3='N'
     else
         set @ls_var3=string(new_con.id_art_var3)
     end if;
  SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
 end;
 
 
 
ALTER TRIGGER "t_riepilogo_bu" BEFORE UPDATE
 ORDER 1 ON "DBA"."riepilogo"
 referencing new as new_con
 for each row
 begin
     declare @ls_var1 long varchar;
     declare @ls_var2 long varchar;
     declare @ls_var3 long varchar;
     if new_con.id_art_var1 is null then
        set @ls_var1='N'
     else
         set @ls_var1=string(new_con.id_art_var1)
     end if;
     if new_con.id_art_var2 is null then
         set @ls_var2='N'
     else
         set @ls_var2=string(new_con.id_art_var2)
     end if;
     if new_con.id_art_var3 is null then
         set @ls_var3='N'
     else
         set @ls_var3=string(new_con.id_art_var3)
     end if;
  SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
 end;
 ////////////////////////////////
 
 //////////Implementazione trasferimento e aggiornamento listino Lasagna su trasferimentoi dati Parigi
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_import_doc') THEN
         
				ALTER PROCEDURE "DBA"."sp_trasf_import_doc"(@id_eser integer, @id_prof_doc integer, @id_sog_com integer, @id_var integer, @id_varven integer, @id_varlas integer)
				begin
				      call sp_trasf_cometa_parte8();
				      call sp_trasf_cometa_parte8_1(@id_eser, @id_prof_doc, @id_sog_com, @id_var, @id_varven, @id_varlas);
				
				end;
END IF;

IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte8') THEN
        
				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte8"()
				begin
				
				  declare @li_record integer;
				  //
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create global temporary table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      ) on commit preserve rows
				  end if
				  ;
				
				  if(exists(select 1 from sys.systable where table_name='tmp_documento')) then
				    drop table tmp_documento
				  end if
				  ;
				 
				  create global temporary table
				    "dba".tmp_documento(
				    id_documento integer not null,
				    id_prof_documento integer not null,
				    id_registro integer not null,
				    num_progressivo decimal(12) not null,
				    data_registrazione date not null,
				    num_documento char(16) null,
				    data_documento date null,
				    data_competenza date null,
				    id_prof_registrazione integer null,
				    des_contabile char(40) null,
				    id_sog_commerciale integer not null,
				    id_destinazione integer null,
				    id_caus_magazzino integer null,
				    id_magazzino integer null,
				    id_magazzino_2 integer null,
				    id_sog_commerciale_fattura integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    id_valuta integer not null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_pagamento integer null,
				    id_gruppo_agenti integer null,
				    id_banca_sog_commerciale integer null,
				    origine char(40) null,
				    interlocutore char(40) null,
				    data_prev_consegna date null,
				    note_intestazione long varchar null,
				    num_colli decimal(8) null,
				    id_unita_misura_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_misura_volume integer null,
				    volume decimal(18,4) null default 0,
				    id_tipo_trasporto integer null,
				    id_caus_trasporto integer null,
				    asp_beni char(40) null,
				    tras_mezzo char(1) null,
				    id_sog_commerciale_vettore integer null,
				    id_sog_commerciale_vettore_2 integer null,
				    mezzo_trasporto char(40) null,
				    targa_mezzo_trasporto char(40) null,
				    data_trasporto date null,
				    ora_trasporto time null,
				    sconto_finanziario char(40) null,
				    sconto_fin_incondizionato decimal(18,4) null,
				    sconto_fin_cassa decimal(5,2) null,
				    data_dec_pagamento date null,
				    imp_acconto decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    stampato char(1) null,
				    contabilizzato char(1) null,
				    evaso_totalmente char(1) null,
				    chius_forzata char(1) null,
				    sospeso char(1) null,
				    data_scadenza date null,
				    creato_in_esenzione char(1) null,
				    bloccato char(1) null,
				    prog_globale decimal(16) null,
				    doc_globale decimal(16) null,
				    tipo_fattura char(1) null,
				    segno_iva decimal(2) null default 1,
				    id_documento_padre integer null,
				    id_azienda integer not null default 1,
				    id_tipo_pag_acconto integer null,
				    id_tab_iva_acconto integer null,
				    id_val_acconto integer null,
				    ora_registrazione time null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    storno_anticipi char(1) null,
				    id_variazione integer null,
				    bollo char(20) null,
				    id_gruppo_agenti_2 integer null,
				    data_ric_consegna date null,
				    num_riga integer null,
				    id_utente integer null,
				    alt_pag char(1) null,
				    alt_ord char(1) null,
				    id_cat_zona integer null,
				    primary key(id_documento),
				    ) on commit preserve rows;
				  //
				  create unique index xak1tmp_documento on
				    "dba".tmp_documento(id_registro asc,num_progressivo asc,data_registrazione asc);
				  //
				  load into table tmp_documento from 'C:\\windows\\temp\\documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_documento;
				  //
				  message 'tabella TMP DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - RIGHE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_riga_documento')) then
				    drop table tmp_riga_documento
				  end if
				  ;
				  create global temporary table "dba".tmp_riga_documento(
				    id_riga_documento integer not null,
				    id_documento integer null,
				    id_unita_confezione integer null,
				    id_gruppo_agenti integer null,
				    num_riga decimal(4) null,
				    id_articolo integer null,
				    descrizione long varchar null,
				    id_des_articolo integer null,
				    quantita decimal(18,4) null,
				    qta_sconto_merce decimal(18,4) null,
				    qta_evasa decimal(18,4) null,
				    fat_con_unita_base decimal(8,4) null,
				    fat_con_globale decimal(8,4) null,
				    qta_un_base decimal(18,4) null,
				    qta_evasa_un_base decimal(18,4) null,
				    id_caus_magazzino integer null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_lis_articolo integer null,
				    prezzo decimal(18,4) null,
				    sconto char(40) null,
				    prezzo_netto decimal(18,4) null,
				    sconto_riga decimal(18,4) null,
				    data_prevista_consegna date null,
				    peso_netto decimal(18,4) null,
				    peso_lordo decimal(18,4) null,
				    dim_l decimal(18,4) null,
				    dim_h decimal(18,4) null,
				    dim_p decimal(18,4) null,
				    num_colli decimal(8) null,
				    id_tab_iva integer null,
				    val_attribuito decimal(18,4) null,
				    provv_agente decimal(5,2) null,
				    provv_subage decimal(5,2) null,
				    provv_carea decimal(5,2) null,
				    id_caus_trasporto integer null,
				    forza_chius_evasione char(1) null,
				    sospesa char(1) null,
				    da_stampare char(1) null,
				    data_inizio_competenza date null,
				    data_fine_competenza date null,
				    tot_riga_val_riga decimal(18,4) null,
				    tot_riga_val_doc decimal(18,4) null,
				    tot_riga_val_az decimal(18,4) null,
				    id_riga_doc_provenienza integer null,
				    id_conto integer null,
				    id_azienda integer null,
				    id_riga_doc_padre integer null,
				    provv_imp_agente decimal(18,4) null,
				    provv_imp_subage decimal(18,4) null,
				    provv_imp_carea decimal(18,4) null,
				    id_riga_lotto integer null,
				    qta_ordinata_fo decimal(18,4) null,
				    ordinato_fo char(1) null,
				    peso_netto_evaso decimal(18,4) null,
				    id_gruppo_Agenti_2 integer null,
				    provv_agente_2 decimal(5,2) null,
				    provv_subage_2 decimal(5,2) null,
				    provv_carea_2 decimal(5,2) null,
				    provv_imp_agente_2 decimal(18,4) null,
				    provv_imp_subage_2 decimal(18,4) null,
				    provv_imp_carea_2 decimal(18,4) null,
				    id_art_var1 integer null,
				    id_art_var2 integer null,
				    id_art_var3 integer null,
				    id_distinta integer null,
				    id_operatore integer null,
				    id_alt_uc1 integer null,
				    id_alt_uc2 integer null,
				    id_alt_uc3 integer null,
				    articolo_codice char(32),
				    uc_codice char(8),
				    primary key(id_riga_documento),
				    ) on commit preserve rows;
				  //
				  create unique index ak1_tmp_riga_documento on tmp_riga_documento(id_documento asc,num_riga asc);
				  load into table tmp_riga_documento from 'C:\\windows\\temp\\riga_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_riga_documento;
				  //
				  message 'tabella TMP RIGA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_iva_documento')) then
				    drop table tmp_cast_iva_documento
				  end if
				  ;
				  create global temporary table "dba".tmp_cast_iva_documento(
				    id_documento integer not null,
				    id_tab_iva integer not null,
				    val_omaggi decimal(18,4) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    val_tot_imp_v decimal(18,4) null,
				    val_tot_imp_l decimal(18,4) null,
				    val_tot_iva_v decimal(18,4) null,
				    val_tot_iva_l decimal(18,4) null,
				    primary key(id_documento,id_tab_iva),
				    ) on commit preserve rows;
				  //
				  load into table tmp_cast_iva_documento from 'C:\\windows\\temp\\cast_iva_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_iva_documento;
				  //
				  message 'tabella TMP CAST IVA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO CONTROPARTITE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_cpt_documento')) then
				    drop table tmp_cast_cpt_documento
				  end if
				  ;
				  //
				  create global temporary table "dba".tmp_cast_cpt_documento(
				    id_documento integer not null,
				    id_conto integer not null,
				    tipo_riga_cpt char(1) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_omaggi decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    primary key(id_documento,id_conto),
				    ) on commit preserve rows;
				  //
				  load into table tmp_cast_cpt_documento from 'C:\\windows\\temp\\cast_cpt_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_cpt_documento;
				  //
				  message 'tabella TMP CAST CPT DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SPESE DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_documento')) then
				    drop table tmp_spesa_documento
				  end if
				  ;
				  //
				  create global temporary table "dba".tmp_spesa_documento(
				    id_documento integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
				    primary key(id_documento,
				    id_spesa),
				    ) on commit preserve rows;
				  //
				  message 'tabella TMP SPESA DOCUMENTO Inizio Load:';
				  load into table tmp_spesa_documento from 'C:\\windows\\temp\\spesa_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_documento;
				  //
				  message 'tabella TMP SPESA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SCADENZE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scadenza')) then
				    drop table tmp_scadenza
				  end if
				  ;
				  //
				  create global temporary table "dba".tmp_scadenza(
				    id_scadenza integer not null,
				    tipo_scadenza char(1) null,
				    id_sog_commerciale integer null,
				    data_scadenza date null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    imp_valuta decimal(18,4) null,
				    importo decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    id_banca_azienda integer null,
				    id_banca_sog_commerciale integer null,
				    note long varchar null,
				    ces_denominazione char(40) null,
				    ces_indirizzo char(40) null,
				    ces_cap char(10) null,
				    ces_localita char(40) null,
				    ces_provincia char(5) null,
				    ces_doc_originale char(16) null,
				    ces_data_documento date null,
				    stato_scadenza char(1) null,
				    data_cambiamento_stato date null,
				    esito_pagamento char(1) null,
				    scadenza_da_raggruppare char(1) null,
				    id_riga_distinta_banca integer null,
				    id_documento integer null,
				    id_par_aperta integer null,
				    id_scadenza_padre integer null,
				    id_azienda integer null,
				    cod_sog_commerciale char(8) null,
				    primary key(id_scadenza),
				    ) on commit preserve rows;
				  //
				  load into table tmp_scadenza from 'C:\\windows\\temp\\scadenza.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scadenza;
				  //
				  message 'tabella TMP SCADENZA record trasferiti:'+string(@li_record);
				  //
				  
					if(exists(select 1 from sys.systable where table_name='tmp_agglist')) then
					    drop table tmp_agglist
					  end if
					  ;
					  //
					  create global temporary table "dba".tmp_agglist(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(articolo_codice, uc_codice),
					    ) on commit preserve rows;
					  //
					  load into table tmp_agglist from 'C:\\windows\\temp\\agglist.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglist;
				  //
				  message 'tabella TMP AGGLIST record trasferiti:'+string(@li_record);
				  //
				  
					if(exists(select 1 from sys.systable where table_name='tmp_agglistv')) then
					    drop table tmp_agglistv
					  end if
					  ;
					  //
					  create global temporary table "dba".tmp_agglistv(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(articolo_codice, uc_codice),
					    ) on commit preserve rows;
					  //
					  load into table tmp_agglistv from 'C:\\windows\\temp\\agglistv.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglistv;
				  //
				  message 'tabella TMP AGGLISTV record trasferiti:'+string(@li_record);
				  //
				
				
					if(exists(select 1 from sys.systable where table_name='tmp_agglistl')) then
					    drop table tmp_agglistl
					  end if
					  ;
					  //
					  create global temporary table "dba".tmp_agglistl(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(articolo_codice, uc_codice),
					    ) on commit preserve rows;
					  //
					  load into table tmp_agglistl from 'C:\\windows\\temp\\agglistl.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglistv;
				  //
				  message 'tabella TMP AGGLISTV record trasferiti:'+string(@li_record);
				  //
				
					if(exists(select 1 from sys.systable where table_name='tmp_codbarre')) then
					    drop table tmp_codbarre
					  end if
					  ;
					  //
					  create global temporary table "dba".tmp_codbarre(
					    id_cod_barre integer null,
					    id_tipo_cod_barre integer null,
					    codice char(32) null,
					    id_unita_confezione integer null,
					    id_azienda integer null,
					    gen_automatica char(1) null,
				        id_art_var1 integer null,
				        id_art_var2 integer null,
				        id_art_var3 integer null,
				        pk_codice char(20) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
					    tcb_codice char(8) null,
				      primary key(id_cod_barre),
					    ) on commit preserve rows;
					  //
					  load into table tmp_codbarre from 'C:\\windows\\temp\\cod_barre.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_codbarre;
				  //
				  message 'tabella TMP COD_BARRE record trasferiti:'+string(@li_record);
				  //  
								           
				  message 'FINE LOAD ... ';
				  message 'INIZIO CREAZIONE INDICI PK ... ';
				  //
				  create unique index xpk_tmp_documento on tmp_documento(id_documento asc);
				  //
				  create unique index xpk_tmp_riga_documento on tmp_riga_documento(id_riga_documento asc);
				  //
				  message 'FINE CREAZIONE INDICI PK ... '
				//
				end;
END IF;
				
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte8_1') THEN
        
				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte8_1"(@id_eser integer, @id_prof_doc integer, @id_sog_com integer, @id_var integer, @id_varven integer, @id_varlas integer)
				on exception resume
				
				begin
				  declare err_notfound exception for sqlstate value '02000';
				  declare invalid_foreign_key exception for sqlstate value '23503';
				  declare row_not_found exception for sqlstate value '02000';
				  declare ok exception for sqlstate value '00000';
				  declare column_cannot_be_null exception for sqlstate value '23502';
				  declare @ls_message char(80);
				  declare @li_id_doc_app integer;
				  declare @ll_num_suggerito_min integer; 
				  declare @ll_num_suggerito_max integer; 
				  declare @ld_data_prec date; 
				  declare @ld_data_succ date;
				  declare @data_registrazione2 date;
				  declare li_errori integer;
				  declare @li_id_pdc integer;
				  declare @li_id_valuta integer;
				  declare @li_sqlstatus integer;
				  declare @li_sqlstatus2 integer;
				  declare @li_sqlstatus3 integer;
				  declare @li_sqlstatus4 integer;
				  declare @li_sqlstatus7 integer;
				  declare @li_doc_letti integer;
				  declare @li_doc_inseriti integer;
				  declare @errore decimal;
				  declare @id_documento_new integer;
				  declare @ld_data_ric_consegna date;
				  declare @li_num_riga integer;
				  /* Variabili per Fetch della testa del documento */
				  declare @id_documento integer;
				  declare @id_prof_documento integer;
				  declare @id_registro integer;
				  declare @num_progressivo decimal(12);
				  declare @num_progressivo2 decimal(12);
				  declare @data_registrazione date;
				  declare @num_documento char(16);
				  declare @data_documento date;
				  declare @data_competenza date;
				  declare @id_prof_registrazione integer;
				  declare @des_contabile char(40);
				  declare @id_sog_commerciale integer;
				  declare @id_destinazione integer;
				  declare @id_caus_magazzino integer;
				  declare @id_magazzino integer;
				  declare @id_magazzino_2 integer;
				  declare @id_sog_commerciale_fattura integer;
				  declare @id_lingua integer;
				  declare @id_linguaggio integer;
				  declare @id_valuta integer;
				  declare @cambio decimal(8,4);
				  declare @id_listino integer;
				  declare @id_con_pagamento integer;
				  declare @id_gruppo_agenti integer;
				  declare @id_banca_sog_commerciale integer;
				  declare @origine char(40);
				  declare @interlocutore char(40);
				  declare @data_prev_consegna date;
				  declare @note_intestazione long varchar;
				  declare @num_colli decimal(8);
				  declare @id_unita_misura_peso integer;
				  declare @peso_netto decimal(18,4);
				  declare @peso_lordo decimal(18,4);
				  declare @id_unita_misura_volume integer;
				  declare @volume decimal(18,4);
				  declare @id_tipo_trasporto integer;
				  declare @id_caus_trasporto integer;
				  declare @asp_beni char(40);
				  declare @tras_mezzo char(1);
				  declare @id_sog_commerciale_vettore integer;
				  declare @id_sog_commerciale_vettore_2 integer;
				  declare @mezzo_trasporto char(40);
				  declare @targa_mezzo_trasporto char(40);
				  declare @data_trasporto date;
				  declare @ora_trasporto time;
				  declare @sconto_finanziario char(40);
				  declare @sconto_fin_incondizionato decimal(18,4);
				  declare @sconto_fin_cassa decimal(5,2);
				  declare @data_dec_pagamento date;
				  declare @imp_acconto decimal(18,4);
				  declare @id_tipo_pagamento integer;
				  declare @stampato char(1);
				  declare @contabilizzato char(1);
				  declare @evaso_totalmente char(1);
				  declare @chius_forzata char(1);
				  declare @sospeso char(1);
				  declare @data_scadenza date;
				  declare @creato_in_esenzione char(1);
				  declare @bloccato char(1);
				  declare @prog_globale decimal(16);
				  declare @doc_globale decimal(16);
				  declare @tipo_fattura char(1);
				  declare @segno_iva decimal(2);
				  declare @id_documento_padre integer;
				  declare @id_azienda integer;
				  declare @ID_Tipo_Pag_Acconto integer;
				  declare @ID_Tab_Iva_Acconto integer;
				  declare @ID_Val_Acconto integer;
				  declare @ora_registrazione time;
				  declare @id_locazione_1 integer;
				  declare @id_locazione_2 integer;
				  declare @storno_anticipi char(1);
				  declare @id_variazione integer;
				  declare @bollo char(20);
				  declare @id_gruppo_Agenti_2 integer;
				  declare @id_utente integer;
				  declare @cod_sog_commerciale char(8); //BL#10859#  
				  declare @cod_sog_commerciale_fattura char(8); //BL#10859#    
				  declare @cod_sog_commerciale_vettore char(8); //BL#10859#    
				  declare @cod_sog_commerciale_vettore_2 char(8); //BL#10859#      
				  declare @cod_caus_magazzino char(8);
				  declare @rag_soc_1_des char(40);
				  declare @rag_soc_2_des char(40);
				  declare @indirizzo_des char(40);
				  declare @cod_mag_1 char(8);
				  declare @cod_mag_2 char(8);
				  declare @cod_listino char(8);
				  declare @cod_con_pagamento char(8);
				  declare @rag_soc_1 char(40);
				  declare @rag_soc_2 char(40);
				  declare @cod_abi char(5);
				  declare @cod_cab char(5);
				  declare @corsia_loc1 char(5);
				  declare @scaffale_loc1 char(5);
				  declare @ripiano_loc1 char(5);
				  declare @posizione_loc1 char(5);
				  declare @corsia_loc2 char(5);
				  declare @scaffale_loc2 char(5);
				  declare @ripiano_loc2 char(5);
				  declare @posizione_loc2 char(5);
				  declare @cod_mag_loc1 char(8);
				  declare @cod_area_loc1 char(8);
				  declare @cod_mag_loc2 char(8);
				  declare @cod_area_loc2 char(8);
				  declare @ls_sqlstate char(10);
				  declare @ll_id_prof_reg integer;
				  declare @ls_tipo_registro char(2);
				  declare @ll_id_sog_com_2 integer;
				  declare @ll_id_mod_reg integer;
				  declare @ll_nr_cifre_arrot integer;
				  declare @ls_tipo_arrotondamento char(2);
				  declare @ld_val_imp decimal(18,4);
				  declare @ld_val_impsco decimal(18,4);
				  declare @ld_valoma decimal(18,4);
				  declare @ld_valspe decimal(18,4);
				  declare @id_conto_pred_acq integer;
				  declare @id_conto_iva_ia integer;
				  declare @id_conto_sog integer;
				  declare @prezzo decimal(18,4);
					declare @articolo_codice char(32);
					declare @uc_codice char(10);
				  declare @id_var_app integer;
				  declare @id_uc_app integer;  
				  declare @id_cod_barre integer; 
					declare @id_tipo_cod_barre integer;
				  declare @cod_barre_codice char(20);
				  declare @id_unita_confezione integer;
					declare @gen_automatica char(1);
					declare @tcb_codice char(8);
					declare @art_app char(32);
					
				    
				  /*
				  Cursore per la testa del documento
				  */
				  declare cur_documento dynamic scroll cursor for select tmp_documento.id_documento,
				      tmp_documento.id_prof_documento,
				      tmp_documento.id_registro,
				      tmp_documento.num_progressivo,
				      tmp_documento.data_registrazione,
				      tmp_documento.num_documento,
				      tmp_documento.data_documento,
				      tmp_documento.data_competenza,
				      tmp_documento.id_prof_registrazione,
				      tmp_documento.des_contabile,
				      tmp_documento.id_sog_commerciale,
				      tmp_documento.id_destinazione,
				      tmp_documento.id_caus_magazzino,
				      tmp_documento.id_magazzino,
				      tmp_documento.id_magazzino_2,
				      tmp_documento.id_sog_commerciale_fattura,
				      tmp_documento.id_lingua,
				      tmp_documento.id_linguaggio,
				      tmp_documento.id_valuta,
				      tmp_documento.cambio,
				      tmp_documento.id_listino,
				      tmp_documento.id_con_pagamento,
				      tmp_documento.id_gruppo_agenti,
				      tmp_documento.id_banca_sog_commerciale,
				      tmp_documento.origine,
				      tmp_documento.interlocutore,
				      tmp_documento.data_prev_consegna,
				      tmp_documento.note_intestazione,
				      tmp_documento.num_colli,
				      tmp_documento.id_unita_misura_peso,
				      tmp_documento.peso_netto,
				      tmp_documento.peso_lordo,
				      tmp_documento.id_unita_misura_volume,
				      tmp_documento.volume,
				      tmp_documento.id_tipo_trasporto,
				      tmp_documento.id_caus_trasporto,
				      tmp_documento.asp_beni,
				      tmp_documento.tras_mezzo,
				      tmp_documento.id_sog_commerciale_vettore,
				      tmp_documento.id_sog_commerciale_vettore_2,
				      tmp_documento.mezzo_trasporto,
				      tmp_documento.targa_mezzo_trasporto,
				      tmp_documento.data_trasporto,
				      tmp_documento.ora_trasporto,
				      tmp_documento.sconto_finanziario,
				      tmp_documento.sconto_fin_incondizionato,
				      tmp_documento.sconto_fin_cassa,
				      tmp_documento.data_dec_pagamento,
				      tmp_documento.imp_acconto,
				      tmp_documento.id_tipo_pagamento,
				      tmp_documento.stampato,
				      tmp_documento.contabilizzato,
				      tmp_documento.evaso_totalmente,
				      tmp_documento.chius_forzata,
				      tmp_documento.sospeso,
				      tmp_documento.data_scadenza,
				      tmp_documento.creato_in_esenzione,
				      tmp_documento.bloccato,
				      tmp_documento.prog_globale,
				      tmp_documento.doc_globale,
				      tmp_documento.tipo_fattura,
				      tmp_documento.segno_iva,
				      tmp_documento.id_documento_padre,
				      tmp_documento.id_azienda,
				      tmp_documento.ID_Tipo_Pag_Acconto,
				      tmp_documento.ID_Tab_Iva_Acconto,
				      tmp_documento.ID_Val_Acconto,
				      tmp_documento.ora_registrazione,
				      tmp_documento.id_locazione_1,
				      tmp_documento.id_locazione_2,
				      tmp_documento.storno_anticipi,
				      tmp_documento.id_variazione,
				      tmp_documento.bollo,
				      tmp_documento.id_gruppo_Agenti_2,
				      tmp_documento.data_ric_consegna,
				      tmp_documento.num_riga,
				      tmp_documento.id_utente
				      from tmp_documento;
				
				  	  declare cur_listino dynamic scroll cursor for select tmp_agglist.prezzo,
				  	  tmp_agglist.articolo_codice,
				  	  tmp_agglist.uc_codice
				      from tmp_agglist;  
				
				  	  declare cur_listinov dynamic scroll cursor for select tmp_agglistv.prezzo,
				  	  tmp_agglistv.articolo_codice,
				  	  tmp_agglistv.uc_codice
				      from tmp_agglistv;
				
				  	  declare cur_listinol dynamic scroll cursor for select tmp_agglistl.prezzo,
				  	  tmp_agglistl.articolo_codice,
				  	  tmp_agglistl.uc_codice
				      from tmp_agglistl;
				      
				  	  declare cur_barre dynamic scroll cursor for select tmp_codbarre.id_cod_barre,
				  	  tmp_codbarre.id_tipo_cod_barre,
				  	  tmp_codbarre.codice,
				  	  tmp_codbarre.id_unita_confezione,
				  	  tmp_codbarre.id_azienda,
				  	  tmp_codbarre.gen_automatica,
				  	  tmp_codbarre.articolo_codice,
				  	  tmp_codbarre.uc_codice,
				  	  tmp_codbarre.tcb_codice
				      from tmp_codbarre;       
				
				  /**/
				  //set option FIRE_TRIGGERS='OFF';
				  insert into tmp_log(note) values('');
				  insert into tmp_log(note) values('Data Trasferimento: '+string(dateformat(today(*),'dd-mm-yyyy')));
				  insert into tmp_log(note) values('');
				  insert into tmp_log(note) values('INIZIO TRASFERIMENTO DOCUMENTI - '+string(dateformat(Now(*),'hh:mm:ss')));
				  insert into tmp_log(note) values('*********************************************************************************');
				  commit work;
				  open cur_documento;
				  /**/
				  //  message ' RECORD LETTI DAL CURSORE:'+string(@@rowcount);
				  /**/
				  set @li_sqlstatus=0;
				  set @li_doc_letti=0;
				  set @li_doc_inseriti=0;
				  lp1:
				  while(@li_sqlstatus<>2) loop
				    fetch next cur_documento into @id_documento,
				      @id_prof_documento,
				      @id_registro,
				      @num_progressivo,
				      @data_registrazione,
				      @num_documento,
				      @data_documento,
				      @data_competenza,
				      @id_prof_registrazione,
				      @des_contabile,
				      @id_sog_commerciale,
				      @id_destinazione,
				      @id_caus_magazzino,
				      @id_magazzino,
				      @id_magazzino_2,
				      @id_sog_commerciale_fattura,
				      @id_lingua,
				      @id_linguaggio,
				      @id_valuta,
				      @cambio,
				      @id_listino,
				      @id_con_pagamento,
				      @id_gruppo_agenti,
				      @id_banca_sog_commerciale,
				      @origine,
				      @interlocutore,
				      @data_prev_consegna,
				      @note_intestazione,
				      @num_colli,
				      @id_unita_misura_peso,
				      @peso_netto,
				      @peso_lordo,
				      @id_unita_misura_volume,
				      @volume,
				      @id_tipo_trasporto,
				      @id_caus_trasporto,
				      @asp_beni,
				      @tras_mezzo,
				      @id_sog_commerciale_vettore,
				      @id_sog_commerciale_vettore_2,
				      @mezzo_trasporto,
				      @targa_mezzo_trasporto,
				      @data_trasporto,
				      @ora_trasporto,
				      @sconto_finanziario,
				      @sconto_fin_incondizionato,
				      @sconto_fin_cassa,
				      @data_dec_pagamento,
				      @imp_acconto,
				      @id_tipo_pagamento,
				      @stampato,
				      @contabilizzato,
				      @evaso_totalmente,
				      @chius_forzata,
				      @sospeso,
				      @data_scadenza,
				      @creato_in_esenzione,
				      @bloccato,
				      @prog_globale,
				      @doc_globale,
				      @tipo_fattura,
				      @segno_iva,
				      @id_documento_padre,
				      @id_azienda,
				      @ID_Tipo_Pag_Acconto,
				      @ID_Tab_Iva_Acconto,
				      @ID_Val_Acconto,
				      @ora_registrazione,
				      @id_locazione_1,
				      @id_locazione_2,
				      @storno_anticipi,
				      @id_variazione,
				      @bollo,
				      @id_gruppo_Agenti_2,
				      @ld_data_ric_consegna,
				      @li_num_riga,
				      @id_utente;
				    set @li_sqlstatus=@@sqlstatus;
				    message ' SQLSTATUS:'+STRING(@li_sqlstatus);
				    /**/
				    if(@li_sqlstatus=0) then // fetch
				      set @li_doc_letti=@li_doc_letti+1;
				      message ' RECORD LETTI:'+string(@li_doc_letti);
				
				            set @id_conto_sog=0;
				            set @id_conto_pred_acq=0;
				            set @id_conto_iva_ia=0;
				
					        select id_conto
				        	into @id_conto_sog
				        	from sog_commerciale
				        	where id_sog_commerciale = @id_sog_com;
				
				            select id_conto_predefinito_acq, id_conto_iva_ia
				            into @id_conto_pred_acq, @id_conto_iva_ia
				            from par_sistema;            
				
							select tipo_registro, id_sog_comm_prop, id_caus_magazzino_prop, id_mod_registro_prop, id_valuta_prop,
					       		 id_locazione_1_prop, id_locazione_2_prop, id_prof_registrazione
							into @ls_tipo_registro, @ll_id_sog_com_2, @id_caus_magazzino, @ll_id_mod_reg, @id_valuta,
					         @id_locazione_1, @id_locazione_2, @ll_id_prof_reg
							from prof_documento
							where prof_documento.id_prof_documento=@id_prof_doc;	
				
							select id_magazzino
							into @id_magazzino
							from locazione
							where id_locazione=@id_locazione_1;
				
							select id_magazzino
							into @id_magazzino_2
							from locazione
							where id_locazione=@id_locazione_2;
							
							SELECT Max(registro.id_registro)
							INTO @id_registro  
							FROM registro  
							WHERE ( registro.id_esercizio = @id_eser ) AND  
							(registro.id_mod_registro = @ll_id_mod_reg );		
							
							select id_listino
							into @id_listino
							from variazione
							where id_variazione = @id_var;
					
					        SELECT valuta.cifra_arrotondamento,
					        valuta.tipo_arrotondamento
					        INTO @ll_nr_cifre_arrot ,
					    	 @ls_tipo_arrotondamento
					        FROM valuta  
					        WHERE valuta.id_valuta = @id_valuta;
					
					        select id_con_pagamento, id_banca_sog_commerciale
					        into @id_con_pagamento, @id_banca_sog_commerciale
					        from sog_commerciale
					        where id_sog_commerciale = @id_sog_com;
					        if(@id_con_pagamento is null) then
					           select id_con_pagamento
				        	   into @id_con_pagamento
				        	   from con_pagamento
				        	   where descrizione like '%contanti%';
				        	end if
				        	;
				
					        //recupera l''id_cat_com_sc
					        //select id_cat_com_sc, id_listino
				        	//into @ll_id_cat_com_sc, @ll_id_listino
				        	//from sog_commerciale
				        	//where id_sog_commerciale = @id_sog_com;	  
					
				        	select min(id_utente)
				        	into @id_utente
				        	from utenti; 
				          
				      /* Inserimento documento */
				      set @num_progressivo2 = null;
				      set @data_registrazione2 = null;
				      call sp_Ges_NumProg_DataReg(0, @id_registro, @num_progressivo2, @data_registrazione2, @ls_message, @ll_num_suggerito_min, @ll_num_suggerito_max, @ld_data_prec, @ld_data_succ, @li_id_doc_app);
				
				      insert into documento(id_prof_documento,
				        id_registro,
				        num_progressivo,
				        data_registrazione,
				        num_documento,
				        data_documento,
				        data_competenza,
				        id_prof_registrazione,
				        des_contabile,
				        id_sog_commerciale,
				        id_destinazione,
				        id_caus_magazzino,
				        id_magazzino,
				        id_magazzino_2,
				        id_sog_commerciale_fattura,
				        //id_lingua,
				        //id_linguaggio,
				        id_valuta,
				        cambio,
				        //id_listino,
				        id_con_pagamento,
				        id_gruppo_agenti,
				        id_banca_sog_commerciale,
				        //origine,
				        //interlocutore,
				        data_prev_consegna,
				        note_intestazione,
				        num_colli,
				        //id_unita_misura_peso,
				        peso_netto,
				        peso_lordo,
				        //id_unita_misura_volume,
				        volume,
				        //id_tipo_trasporto,
				        //id_caus_trasporto,
				        asp_beni,
				        tras_mezzo,
				        //id_sog_commerciale_vettore,
				        //id_sog_commerciale_vettore_2,
				        mezzo_trasporto,
				        targa_mezzo_trasporto,
				        data_trasporto,
				        ora_trasporto,
				        sconto_finanziario,
				        sconto_fin_incondizionato,
				        sconto_fin_cassa,
				        data_dec_pagamento,
				        imp_acconto,
				        //id_tipo_pagamento,
				        stampato,
				        contabilizzato,
				        evaso_totalmente,
				        chius_forzata,
				        sospeso,
				        data_scadenza,
				        creato_in_esenzione,
				        bloccato,
				        //prog_globale,
				        //doc_globale,
				        tipo_fattura,
				        segno_iva,
				        //id_documento_padre,
				        id_azienda,
				        //ID_Tipo_Pag_Acconto,
				        //ID_Tab_Iva_Acconto,
				        //ID_Val_Acconto,
				        ora_registrazione,
				        id_locazione_1,
				        id_locazione_2,
				        storno_anticipi,
				        //id_variazione,
				        bollo,
				        //id_gruppo_Agenti_2,
				        data_ric_consegna,
				        num_riga,
				        id_utente) values(
				        @id_prof_doc,
				        @id_registro,
				        @num_progressivo2,
				        @data_registrazione,
				        @num_progressivo2,
				        @data_registrazione,
				        @data_competenza,
				        @ll_id_prof_reg,
				        @des_contabile,
				        @id_sog_com,
				        null,
				        @id_caus_magazzino,
				        @id_magazzino,
				        @id_magazzino_2,
				        @id_sog_com,
				        //@id_lingua,
				        //@id_linguaggio,
				        @id_valuta,
				        1,
				        //@id_listino,
				        @id_con_pagamento,
				        null,
				        @id_banca_sog_commerciale,
				        //@origine,
				        //@interlocutore,
				        @data_prev_consegna,
				        @note_intestazione,
				        @num_colli,
				        //@id_unita_misura_peso,
				        @peso_netto,
				        @peso_lordo,
				        //@id_unita_misura_volume,
				        @volume,
				        //@id_tipo_trasporto,
				        //@id_caus_trasporto,
				        @asp_beni,
				        @tras_mezzo,
				        //@id_sog_commerciale_vettore,
				        //@id_sog_commerciale_vettore_2,
				        @mezzo_trasporto,
				        @targa_mezzo_trasporto,
				        @data_trasporto,
				        @ora_trasporto,
				        @sconto_finanziario,
				        @sconto_fin_incondizionato,
				        @sconto_fin_cassa,
				        @data_dec_pagamento,
				        @imp_acconto,
				        //@id_tipo_pagamento,
				        @stampato,
				        @contabilizzato,
				        @evaso_totalmente,
				        @chius_forzata,
				        @sospeso,
				        @data_scadenza,
				        @creato_in_esenzione,
				        @bloccato,
				        //@prog_globale,
				        //@doc_globale,
				        @tipo_fattura,
				        @segno_iva,
				        //@id_documento_padre,
				        1,
				        //@ID_Tipo_Pag_Acconto,
				        //@ID_Tab_Iva_Acconto,
				        //@ID_Val_Acconto,
				        @ora_registrazione,
				        @id_locazione_1,
				        @id_locazione_2,
				        @storno_anticipi,
				        //@id_var,
				        @bollo,
				        //@id_gruppo_Agenti_2,
				        @ld_data_ric_consegna,
				        @li_num_riga,
				        @id_utente);
				      set @ls_sqlstate=sqlstate;
				      message 'SQLSTATE:'+@ls_sqlstate+' Documento:'+string(@id_documento);
				      set @id_documento_new=@@identity;
				      if(@id_documento_new is null) then
				        message 'ID DOCUMENTO NEW E'' NULL'
				      end if
				      ;
				      message ' ID DOCUMENTO NEW:'+STRING(@id_documento_new);
				      //      if(@@error=0) then
				      message 'SQLSTATE:'+@ls_sqlstate+' Documento New:'+string(@id_documento_new);
				      if(@ls_sqlstate='00000') and(@id_documento_new>0) then
				        //        commit work;
				        message '--SQLSTATE:'+@ls_sqlstate;
				        /* ID del documento inserito */
				        /**/
				        message 'DOCUMENTO Id Cava:'+string(@id_documento)+' Id Sede:'+string(@id_documento_new)+' Prot/Data:'+string(@num_progressivo)+'  '+string(@data_registrazione)+' - record trasferiti:'+string(@@rowcount);
				        insert into tmp_log(note) values('DOCUMENTO Id Cava:'+string(@id_documento)+' Id Sede:'+string(@id_documento_new)+' Prot/Data:'+string(@num_progressivo)+'  '+string(@data_registrazione)+' - record trasferiti:'+string(@@rowcount));
				        /**/
				        set @li_doc_inseriti=@li_doc_inseriti+1;
				        /* CAST IVA DOCUMENTO
				        Per ogni documento inserito correttamente, inserisco i relativi record di 
				        CAST_IVA_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
				        */
				        insert into cast_iva_documento(id_documento,
				          id_tab_iva,
				          val_omaggi,
				          val_imponibile,
				          val_imp_scontato,
				          val_spese,
				          val_tot_imp_v,
				          val_tot_imp_l,
				          val_tot_iva_v,
				          val_tot_iva_l)
				          select @id_documento_new,
				            (select tab_iva.id_tab_iva 
				             from tab_iva, tmp_tab_iva
				             where tab_iva.codice = tmp_tab_iva.codice
				             and tmp_cast_iva_documento.id_tab_iva = tmp_tab_iva.id_tab_iva),
				            val_omaggi,
				            val_imponibile,
				            val_imp_scontato,
				            val_spese,
				            val_tot_imp_v,
				            val_tot_imp_l,
				            val_tot_iva_v,
				            val_tot_iva_l
				            from tmp_cast_iva_documento
				            where id_documento=@id_documento;
				        set @ls_sqlstate=sqlstate;
				        //      if(@@error=0) then
				        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				          message '   CAST IVA DOCUMENTO - record trasferiti:'+string(@@rowcount);
				          insert into tmp_log(note) values('   CAST IVA DOCUMENTO - record trasferiti:'+string(@@rowcount))
				        else
				          message '   Si e'' verificato un errore importando le righe del Castelletto Iva del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
				          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del Castelletto Iva del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
				        end if
				        ; /* CAST CPT DOCUMENTO
				        Per ogni documento inserito correttamente, inserisco i relativi record di 
				        CAST_CPT_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
				        */
				
				          set @ld_val_imp=0;
				          set @ld_val_impsco=0;
				          set @ld_valoma=0;
				          set @ld_valspe=0;
				          select val_imponibile, val_imp_scontato, val_omaggi, val_spese
				          into @ld_val_imp, @ld_val_impsco, @ld_valoma, @ld_valspe
				          from tmp_cast_cpt_documento
				          where id_documento=@id_documento
				          and tipo_riga_cpt = 'S';
				
				        insert into cast_cpt_documento(id_documento,
				          id_conto,
				          tipo_riga_cpt,
				          val_imponibile,
				          val_imp_scontato,
				          val_omaggi,
				          val_spese)
				          select @id_documento_new,
				            @id_conto_sog,
				            'S',
				            @ld_val_imp,
				            @ld_val_impsco,
				            @ld_valoma,
				            @ld_valspe;
				
				          set @ld_val_imp=0;
				          set @ld_val_impsco=0;
				          set @ld_valoma=0;
				          set @ld_valspe=0;
				          select val_imponibile, val_imp_scontato, val_omaggi, val_spese
				          into @ld_val_imp, @ld_val_impsco, @ld_valoma, @ld_valspe
				          from tmp_cast_cpt_documento
				          where id_documento=@id_documento
				          and tipo_riga_cpt = 'I';
				
				        insert into cast_cpt_documento(id_documento,
				          id_conto,
				          tipo_riga_cpt,
				          val_imponibile,
				          val_imp_scontato,
				          val_omaggi,
				          val_spese)
				          select @id_documento_new,
				            @id_conto_iva_ia,
				            'I',
				            @ld_val_imp,
				            @ld_val_impsco,
				            @ld_valoma,
				            @ld_valspe;
				
				          set @ld_val_imp=0;
				          set @ld_val_impsco=0;
				          set @ld_valoma=0;
				          set @ld_valspe=0;
				          select sum(val_imponibile), sum(val_imp_scontato), sum(val_omaggi), sum(val_spese)
				          into @ld_val_imp, @ld_val_impsco, @ld_valoma, @ld_valspe
				          from tmp_cast_cpt_documento
				          where id_documento=@id_documento
				          and tipo_riga_cpt = 'C';
				
				        insert into cast_cpt_documento(id_documento,
				          id_conto,
				          tipo_riga_cpt,
				          val_imponibile,
				          val_imp_scontato,
				          val_omaggi,
				          val_spese)
				          select @id_documento_new,
				            @id_conto_pred_acq,
				            'C',
				            @ld_val_imp,
				            @ld_val_impsco,
				            @ld_valoma,
				            @ld_valspe;
				
				        //insert into cast_cpt_documento(id_documento,
				        //  id_conto,
				        //  tipo_riga_cpt,
				        //  val_imponibile,
				        // val_imp_scontato,
				        //  val_omaggi,
				        //  val_spese)
				        //  select @id_documento_new,
				        //    id_conto,
				        //    tipo_riga_cpt,
				        //    val_imponibile,
				        //    val_imp_scontato,
				        //    val_omaggi,
				        //    val_spese
				        //    from tmp_cast_cpt_documento
				        //    where id_documento=@id_documento;
				        set @ls_sqlstate=sqlstate;
				        //      if(@@error=0) then
				        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				          message '   CAST CPT DOCUMENTO - record trasferiti:'+string(@@rowcount);
				          insert into tmp_log(note) values('   CAST CPT DOCUMENTO - record trasferiti:'+string(@@rowcount))
				        else
				          message '   Si e'' verificato un errore importando le righe del Castelletto Contropartita del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
				          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del Castelletto Contropartita del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
				        end if
				        ; /* SPESA DOCUMENTO
				        Per ogni documento inserito correttamente, inserisco i relativi record di 
				        SPESA_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
				        */
				        insert into spesa_documento(id_documento,
				          id_spesa,
				          percentuale,
				          importo,
				          id_tab_iva)
				          select @id_documento_new,
				            (select spesa.id_spesa
				             from spesa, tmp_spesa
				             where spesa.codice = tmp_spesa.codice
				             and tmp_spesa.id_spesa = tmp_spesa_documento.id_spesa),
				            tmp_spesa_documento.percentuale,
				            tmp_spesa_documento.importo,
				            (select tab_iva.id_tab_iva 
				             from tab_iva, tmp_tab_iva
				             where tab_iva.codice = tmp_tab_iva.codice
				             and tmp_spesa_documento.id_tab_iva = tmp_tab_iva.id_tab_iva)
				            from tmp_spesa_documento
				            where id_documento=@id_documento;
				        set @ls_sqlstate=sqlstate;
				        //      if(@@error=0) then
				        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				          message '   SPESA DOCUMENTO - record trasferiti:'+string(@@rowcount);
				          insert into tmp_log(note) values('   SPESA DOCUMENTO - record trasferiti:'+string(@@rowcount))
				        else
				          if(@ls_sqlstate<>'02000') then
				            message '   Si e'' verificato un errore importando le righe delle spese del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
				            insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe delle spese del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
				          end if
				        end if
				        ; 
				        /* SCADENZA
				        Per ogni documento inserito correttamente, inserisco i relativi record di 
				        SCADENZA associandole al nuovo ID Documento assegnato al record.
				
				        insert into scadenza(tipo_scadenza,
				          id_sog_commerciale,
				          data_scadenza,
				          id_valuta,
				          cambio,
				          imp_valuta,
				          importo,
				          id_tipo_pagamento,
				          id_banca_azienda,
				          id_banca_sog_commerciale,
				          note,
				          ces_denominazione,
				          ces_indirizzo,
				          ces_cap,
				          ces_localita,
				          ces_provincia,
				          ces_doc_originale,
				          ces_data_documento,
				          stato_scadenza,
				          data_cambiamento_stato,
				          esito_pagamento,
				          scadenza_da_raggruppare,
				          id_riga_distinta_banca,
				          id_documento,
				          id_par_aperta,
				          id_scadenza_padre,
				          id_azienda)
				          select tipo_scadenza,
				            id_sog_commerciale,
				            data_scadenza,
				            id_valuta,
				            cambio,
				            imp_valuta,
				            importo,
				            id_tipo_pagamento,
				            null, //id_banca_azienda,
				            id_banca_sog_commerciale,
				            //id_banca_sog_commerciale,
				            note,
				            ces_denominazione,
				            ces_indirizzo,
				            ces_cap,
				            ces_localita,
				            ces_provincia,
				            ces_doc_originale,
				            ces_data_documento,
				            stato_scadenza,
				            data_cambiamento_stato,
				            esito_pagamento,
				            scadenza_da_raggruppare,
				            null, //id_riga_distinta_banca,
				            @id_documento_new,
				            null, //id_par_aperta,
				            null, //id_scadenza_padre,
				            1
				            from tmp_scadenza
				            where id_documento=@id_documento;
				        set @ls_sqlstate=sqlstate;
				        //      if(@@error=0) then
				        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				          message '   SCADENZA - record trasferiti:'+string(@@rowcount);
				          insert into tmp_log(note) values('   SCADENZA - record trasferiti:'+string(@@rowcount))
				        else
				          if(@ls_sqlstate<>'02000') then
				            message '   Si e'' verificato un errore importando le righe delle scadenze del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
				            insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe delle scadenze del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
				          end if
				        end if
				        ;
				        */
				        /* RIGA DOCUMENTO 
				        Per ogni documento inserito correttamente, inserisco le righe 
				        associandole al nuovo ID Documento assegnato al record.
				        */
				        set @ls_sqlstate='';
				        insert into riga_documento(id_documento,
				          id_unita_confezione,
				          id_gruppo_agenti,
				          num_riga,
				          id_articolo,
				          descrizione,
				          id_des_articolo,
				          quantita,
				          qta_sconto_merce,
				          qta_evasa,
				          fat_con_unita_base,
				          fat_con_globale,
				          qta_un_base,
				          qta_evasa_un_base,
				          id_caus_magazzino,
				          id_locazione_1,
				          id_locazione_2,
				          id_valuta,
				          cambio,
				          id_listino,
				          id_con_lis_articolo,
				          prezzo,
				          sconto,
				          prezzo_netto,
				          sconto_riga,
				          data_prevista_consegna,
				          peso_netto,
				          peso_lordo,
				          dim_l,
				          dim_h,
				          dim_p,
				          num_colli,
				          id_tab_iva,
				          val_attribuito,
				          provv_agente,
				          provv_subage,
				          provv_carea,
				          id_caus_trasporto,
				          forza_chius_evasione,
				          sospesa,
				          da_stampare,
				          data_inizio_competenza,
				          data_fine_competenza,
				          tot_riga_val_riga,
				          tot_riga_val_doc,
				          tot_riga_val_az,
				          id_riga_doc_provenienza,
				          id_conto,
				          id_azienda,
				          id_riga_doc_padre,
				          provv_imp_agente,
				          provv_imp_subage,
				          provv_imp_carea,
				          id_riga_lotto,
				          qta_ordinata_fo,
				          ordinato_fo,
				          peso_netto_evaso,
				          id_gruppo_Agenti_2,
				          provv_agente_2,
				          provv_subage_2,
				          provv_carea_2,
				          provv_imp_agente_2,
				          provv_imp_subage_2,
				          provv_imp_carea_2)
				          select @id_documento_new,
				            (select min(id_unita_confezione) from unita_confezione uc, articolo a
				             where uc.id_articolo = a.id_articolo
				             and a.codice = tr.articolo_codice
				             and uc.codice = tr.uc_codice),
				            null,
				            tr.num_riga,
				            (select id_articolo from articolo a
				             where a.codice = tr.articolo_codice),
				            tr.descrizione,
				            null,
				            tr.quantita,
				            tr.qta_sconto_merce,
				            tr.qta_evasa,
				            tr.fat_con_unita_base,
				            tr.fat_con_globale,
				            tr.qta_un_base,
				            tr.qta_evasa_un_base,
				            @id_caus_magazzino,
				            @id_locazione_1,
				            @id_locazione_2,
				            @id_valuta,
				            tr.cambio,
				            null,
				            null,
				            tr.prezzo,
				            tr.sconto,
				            tr.prezzo_netto,
				            tr.sconto_riga,
				            tr.data_prevista_consegna,
				            tr.peso_netto,
				            tr.peso_lordo,
				            tr.dim_l,
				            tr.dim_h,
				            tr.dim_p,
				            tr.num_colli,
				            (select id_tab_iva from articolo a
				             where a.codice = tr.articolo_codice),
				            tr.val_attribuito,
				            tr.provv_agente,
				            tr.provv_subage,
				            tr.provv_carea,
				            null,
				            tr.forza_chius_evasione,
				            tr.sospesa,
				            tr.da_stampare,
				            tr.data_inizio_competenza,
				            tr.data_fine_competenza,
				            tr.tot_riga_val_riga,
				            tr.tot_riga_val_doc,
				            tr.tot_riga_val_az,
				            null,
				            tr.id_conto,
				            1,
				            null,
				            tr.provv_imp_agente,
				            tr.provv_imp_subage,
				            tr.provv_imp_carea,
				            null,
				            tr.qta_ordinata_fo,
				            tr.ordinato_fo,
				            tr.peso_netto_evaso,
				            null,
				            tr.provv_agente_2,
				            tr.provv_subage_2,
				            tr.provv_carea_2,
				            tr.provv_imp_agente_2,
				            tr.provv_imp_subage_2,
				            tr.provv_imp_carea_2
				            from tmp_riga_documento as tr
				            where tr.id_documento=@id_documento;
				        set @ls_sqlstate=sqlstate;
				        message 'SQLSTATE:'+@ls_sqlstate+' Riga Documento:'+string(@id_documento);
				        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				          message '   RIGHE DOCUMENTO - record trasferiti:'+string(@@rowcount);
				          insert into tmp_log(note) values('   RIGHE DOCUMENTO - record trasferiti:'+string(@@rowcount))
				        else
				          message '   Si e'' verificato un errore importando le righe del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
				          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
				        end if  
				      else
				        /**/
				        // l''Inserimento di un record in DOCUMENTO + andato in errore
				        rollback work;
				        message ' 3) @ls_sqlstate:'+@ls_sqlstate;
				        if(@ls_sqlstate='23503') then
				          message '     Verificare che i riferimenti alle anagrafiche siano allineati (cond. di pagamento ecc..)';
				          insert into tmp_log(note) values('     Verificare che i riferimenti alle anagrafiche siano allineati (cond. di pagamento ecc..)')
				        elseif(@ls_sqlstate='23502') then
				          message '     Colonna NULL';
				          insert into tmp_log(note) values('     Colonna NULL')
				        else
				          message 'Si e'' verificato un errore importando il documento Id Cava:'+string(@id_documento)+' SQLSTATE:'+@ls_sqlstate;
				          insert into tmp_log(note) values('Si e'' verificato un errore importando il documento Id Cava:'+string(@id_documento)+' SQLSTATE:'+@ls_sqlstate)
				        end if
				      end if
				    end if
				  end loop lp1
				  ;
				
				        ///////////AGGIORNAMENTO LISTINO ACQ SE PASSATO COME PARAMETRO
				        if(@id_var is not null) then
				     		    open cur_listino;   
								set @li_sqlstatus2=0;
								  lp2:
								  while(@li_sqlstatus2<>2) loop
								    fetch next cur_listino into @prezzo,
								    @articolo_codice,
								    @uc_codice;
								      
								    set @li_sqlstatus2=@@sqlstatus;
								    message ' SQLSTATUS:'+STRING(@li_sqlstatus2);
				
								    if(@li_sqlstatus2=0) then // fetch
								    	 select p.id_variazione, p.id_unita_confezione
								    	 into @id_var_app, @id_uc_app
								    	 from prezzo p, unita_confezione uc, articolo a
								    	 where p.id_variazione = @id_var
								    	 and p.id_unita_confezione = uc.id_unita_confezione
								    	 and uc.codice = @uc_codice
								    	 and uc.id_articolo = a.id_articolo
								    	 and a.codice = @articolo_codice;
								    	 set @ls_sqlstate=sqlstate;
				                         if(@ls_sqlstate='00000') then
								    	 		update prezzo
								    	 		set prezzo = @prezzo
								    	 		where id_variazione = @id_var
								    	 		and id_unita_confezione = @id_uc_app;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                    message 'LIST UPD OK:';
				                                else
				                                    message 'LIST UPD ERRORE:';
				                                end if
								    	 else
								    	 		select uc.id_unita_confezione
								    	 		into @id_uc_app
								    	 		from unita_confezione uc, articolo a
								    	 		where uc.codice = @uc_codice
								    	 		and uc.id_articolo = a.id_articolo
								    	 		and a.codice = @articolo_codice;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000') then
								    	 		    insert into prezzo (id_variazione, id_unita_confezione, prezzo)
								    	 		    values(@id_var, @id_uc_app, @prezzo);
				    				    	        set @ls_sqlstate=sqlstate;
				                                    if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                        message 'LIST INS OK:';
				                                    else
				                                        message 'LIST INS ERRORE:';
				                                    end if
				                                end if
								    	 end if
								    end if
				  				end loop lp2					
				        end if;
				        //////////////////////////////////////////////////////////
				
				        ///////////AGGIORNAMENTO LISTINO VEN SE PASSATO COME PARAMETRO
				        if(@id_varven is not null) then
				     		    open cur_listinov;   
								set @li_sqlstatus4=0;
								  lp4:
								  while(@li_sqlstatus4<>2) loop
								    fetch next cur_listinov into @prezzo,
								    @articolo_codice,
								    @uc_codice;
								      
								    set @li_sqlstatus4=@@sqlstatus;
								    message ' SQLSTATUS:'+STRING(@li_sqlstatus4);
				
								    if(@li_sqlstatus4=0) then // fetch
								    	 select p.id_variazione, p.id_unita_confezione
								    	 into @id_var_app, @id_uc_app
								    	 from prezzo p, unita_confezione uc, articolo a
								    	 where p.id_variazione = @id_varven
								    	 and p.id_unita_confezione = uc.id_unita_confezione
								    	 and uc.codice = @uc_codice
								    	 and uc.id_articolo = a.id_articolo
								    	 and a.codice = @articolo_codice;
								    	 set @ls_sqlstate=sqlstate;
				                         if(@ls_sqlstate='00000') then
								    	 		update prezzo
								    	 		set prezzo = @prezzo
								    	 		where id_variazione = @id_varven
								    	 		and id_unita_confezione = @id_uc_app;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                    message 'LIST UPD VEN OK:';
				                                else
				                                    message 'LIST UPD VEN ERRORE:';
				                                end if
								    	 else
								    	 		select uc.id_unita_confezione
								    	 		into @id_uc_app
								    	 		from unita_confezione uc, articolo a
								    	 		where uc.codice = @uc_codice
								    	 		and uc.id_articolo = a.id_articolo
								    	 		and a.codice = @articolo_codice;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000') then
								    	 		    insert into prezzo (id_variazione, id_unita_confezione, prezzo)
								    	 		    values(@id_varven, @id_uc_app, @prezzo);
				    				    	        set @ls_sqlstate=sqlstate;
				                                    if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                        message 'LIST INS VEN OK:';
				                                    else
				                                        message 'LIST INS VEN ERRORE:';
				                                    end if
				                                end if
								    	 end if
								    end if
				  				end loop lp4					
				        end if;
				        //////////////////////////////////////////////////////////
				
				        ///////////AGGIORNAMENTO LISTINO LAS SE PASSATO COME PARAMETRO
				        if(@id_varlas is not null) then
				     		    open cur_listinol;   
								set @li_sqlstatus7=0;
								  lp7:
								  while(@li_sqlstatus7<>2) loop
								    fetch next cur_listinol into @prezzo,
								    @articolo_codice,
								    @uc_codice;
								      
								    set @li_sqlstatus7=@@sqlstatus;
								    message ' SQLSTATUS:'+STRING(@li_sqlstatus7);
				
								    if(@li_sqlstatus7=0) then // fetch
								    	 select p.id_variazione, p.id_unita_confezione
								    	 into @id_var_app, @id_uc_app
								    	 from prezzo p, unita_confezione uc, articolo a
								    	 where p.id_variazione = @id_varlas
								    	 and p.id_unita_confezione = uc.id_unita_confezione
								    	 and uc.codice = @uc_codice
								    	 and uc.id_articolo = a.id_articolo
								    	 and a.codice = @articolo_codice;
								    	 set @ls_sqlstate=sqlstate;
				                         if(@ls_sqlstate='00000') then
								    	 		update prezzo
								    	 		set prezzo = @prezzo
								    	 		where id_variazione = @id_varlas
								    	 		and id_unita_confezione = @id_uc_app;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                    message 'LIST UPD LAS OK:';
				                                else
				                                    message 'LIST UPD LAS ERRORE:';
				                                end if
								    	 else
								    	 		select uc.id_unita_confezione
								    	 		into @id_uc_app
								    	 		from unita_confezione uc, articolo a
								    	 		where uc.codice = @uc_codice
								    	 		and uc.id_articolo = a.id_articolo
								    	 		and a.codice = @articolo_codice;
								    	        set @ls_sqlstate=sqlstate;
				                                if(@ls_sqlstate='00000') then
								    	 		    insert into prezzo (id_variazione, id_unita_confezione, prezzo)
								    	 		    values(@id_varlas, @id_uc_app, @prezzo);
				    				    	        set @ls_sqlstate=sqlstate;
				                                    if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                                        message 'LIST INS LAS OK:';
				                                    else
				                                        message 'LIST INS LAS ERRORE:';
				                                    end if
				                                end if
								    	 end if
								    end if
				  				end loop lp7					
				        end if;
				        //////////////////////////////////////////////////////////
				        
				        ///////////AGGIORNAMENTO COD_BARRE
				   		  open cur_barre;   
								set @li_sqlstatus3=0;
							  lp3:
							  while(@li_sqlstatus3<>2) loop
							    fetch next cur_barre into @id_cod_barre,
							    @id_tipo_cod_barre,
							    @cod_barre_codice,
							    @id_unita_confezione,
							    @id_azienda,
							    @gen_automatica,
							    @articolo_codice,
							    @uc_codice,
							    @tcb_codice;
							      
							    set @li_sqlstatus3=@@sqlstatus;
							    message ' SQLSTATUS:'+STRING(@li_sqlstatus3);
				
							    if(@li_sqlstatus3=0) then // fetch
										 select a.codice
										 into @art_app
										 from cod_barre c, articolo a, unita_confezione uc
										 where c.codice = @cod_barre_codice
										 and c.id_unita_confezione = uc.id_unita_confezione
										 and uc.id_articolo = a.id_articolo;
										 set @ls_sqlstate=sqlstate;
				             if(@ls_sqlstate='00000') then
				             		if left(@art_app, 3) = 'LAS' then
				
				                          insert into tmp_logbar(oldcod, newcod)
				                          values(@art_app, @articolo_codice);
				
				             			 delete from cod_barre
				             			 where codice = @cod_barre_codice;
				             			            			 
				             			 update articolo
				             			 set utilizzabile = 'N'
				             			 where codice = @art_app;
				             			 
				             			 insert into cod_barre (id_tipo_cod_barre, codice, id_unita_confezione, id_azienda, gen_automatica)
				             			 select (select id_tipo_cod_barre
				             			         from tipo_cod_barre
				             			         where codice = @tcb_codice),
				             			         @cod_barre_codice,
				             			        (select u.id_unita_confezione
				             			         from unita_confezione u, articolo a
				             			         where u.codice = @uc_codice
				             			         and u.id_articolo = a.id_articolo
				             			         and a.codice = @articolo_codice),
				             			        1,
				             			        @gen_automatica
				             			 from tmp_codbarre tcb
				             			 where tcb.id_cod_barre=@id_cod_barre;
				    				    set @ls_sqlstate=sqlstate;
				                        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                            message 'COD.BARRE INS OK:';
				                        else
				                            message 'COD.BARRE INS ERRORE:';
				                        end if
				             		end if 
				             else
				           			 insert into cod_barre (id_tipo_cod_barre, codice, id_unita_confezione, id_azienda, gen_automatica)
				           			 select (select id_tipo_cod_barre
				           			         from tipo_cod_barre
				           			         where codice = @tcb_codice),
				           			         @cod_barre_codice,
				           			        (select u.id_unita_confezione
				           			         from unita_confezione u, articolo a
				           			         where u.codice = @uc_codice
				           			         and u.id_articolo = a.id_articolo
				           			         and a.codice = @articolo_codice),
				           			        1,
				           			        @gen_automatica
				           			 from tmp_codbarre tcb
				           			 where tcb.id_cod_barre=@id_cod_barre;    
				
				     				    set @ls_sqlstate=sqlstate;
				                        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
				                            message 'COD.BARRE INS OK:';
				                        else
				                            message 'COD.BARRE INS ERRORE:';
				                        end if        
				             end if
							    end if
								end loop lp3					
								;
				        //////////////////////////////////////////////////////////        
				
				  //set option FIRE_TRIGGERS='ON';
				  // Loop della FETCH
				  message ' SQLSTATUS 3:'+STRING(@li_sqlstatus);
				  message 'TABELLA DOCUMENTO - record trasferiti:'+string(@li_doc_inseriti);
				  insert into tmp_log(note) values('TABELLA DOCUMENTO record trasferiti: '+string(@li_doc_inseriti));
				  message 'TABELLA DOCUMENTO record trasferiti: '+string(@li_doc_inseriti);
				  insert into tmp_log(note) values('*********************************************************************************');
				  message '*********************************************************************************';
				  insert into tmp_log(note) values('FINE TRASFERIMENTO DOCUMENTI - '+string(dateformat(Now(*),'hh:mm:ss')));
				  message 'FINE TRASFERIMENTO DOCUMENTI - '+string(dateformat(Now(*),'hh:mm:ss'));
				  commit work;
				  set @ls_sqlstate=sqlstate;
				  message ' 5) @ls_sqlstate commit:'+@ls_sqlstate;
				  close cur_documento;
				  set @ls_sqlstate=sqlstate;
				  message ' 4) @ls_sqlstate close cursore:'+@ls_sqlstate;
				  message ' SQLSTATUS 4:'+STRING(@li_sqlstatus);
				  select "COUNT"(*) into li_errori
				    from tmp_log
				    where note like '%SQLSTATE%';
				  //
				  if(li_errori>0) then
				    insert into tmp_log(note) values('Controllare il report, il trasferimento e'' terminato con '+string(li_errori)+' errori')
				  end if
				  ;
				  commit work
				//
				end;
END IF;				
//////////////////////////////////////////////////////////////////////////////////////////////////////


//ALT DOCUMENTO

IF EXISTS(SELECT 1 FROM   SYSPROCEDURE
   WHERE  PROC_NAME = 'fn_alt_riep_art_var') THEN
   DROP PROCEDURE fn_alt_riep_art_var;
END IF;

CREATE FUNCTION "DBA"."fn_alt_riep_art_var"(in @rd_art integer,in @rd_da date,in @rd_a date,in @rd_maga integer, @id_var1 integer)
returns char(40)
begin
  declare @Qta_Evasa decimal(18,4);
  declare @peso decimal(18,4);
  declare @ID_Locazione_2 integer;
  declare @ID_Locazione_1 integer;
  declare @cmp_car char(1);
  declare @cmp_scar char(1);
  declare @cmd_car char(1);
  declare @cmd_scar char(1);
  declare @ut char(1);
  declare @ls_car char(20);
  declare @ls_scar char(20);
  declare @ls_return char(40);
  declare @li_sqlstatus integer;
  declare @tot_car decimal(18,4);
  declare @tot_scar decimal(18,4);
  declare @tot_cmp_car decimal(18,4);
  declare @tot_cmp_scar decimal(18,4);
  declare @tot_cmd_car decimal(18,4);
  declare @tot_cmd_scar decimal(18,4);
  declare @tot_val decimal(18,4);
  declare @maga_1 integer;
  declare @maga_2 integer;
  declare cur_art dynamic scroll cursor for select r.qta_un_base,
      r.peso_netto,r.id_locazione_2,r.id_locazione_1,
      c.mp_car_fiscali,c.mp_scar_fiscali,c.md_car_fiscali,
      c.md_scar_fiscali,u.tipo
      from alt_documento as d
      ,alt_riga_documento as r
      ,caus_magazzino as c
      ,unita_confezione as uf
      ,unita_misura as u
      where r.id_documento=d.id_documento 
      and (r.id_art_var1=@id_var1 or @id_var1 is null)
      and c.id_caus_magazzino=r.id_caus_magazzino
      and uf.id_unita_confezione=r.id_unita_confezione
      and u.id_unita_misura=uf.id_unita_misura
      and d.data_registrazione>=@rd_da
      and d.data_registrazione<=@rd_a
      and r.id_articolo=@rd_art
//      and(c.mp_car_fiscali is not null
//      or c.mp_scar_fiscali is not null
//      or c.md_car_fiscali is not null
//      or c.md_scar_fiscali is not null)
;
  set @li_sqlstatus=0;
  set @TOT_car=0;
  set @TOT_scar=0;
  set @TOT_val=0;
  set @tot_cmp_car=0;
  set @tot_cmd_car=0;
  set @tot_cmp_scar=0;
  set @tot_cmd_scar=0;
  open cur_art;
  fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
    @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,@ut;
  while sqlcode=0 loop
    //    message 'code',string(sqlcode);
    set @tot_cmp_car=0;
    set @tot_cmd_car=0;
    set @tot_cmp_scar=0;
    set @tot_cmd_scar=0;
    if sqlcode<>0 then
      set @TOT_car=0;
      set @TOT_scar=0;
      set @TOT_val=0;
      leave cicloDispLoop
    end if
    ;
    message ' maga:'+string(@rd_maga);
    if @ut='P' then
      set @Tot_val=@peso
    else
      set @Tot_val=@qta_evasa
    end if
    ;
    message ' tot:'+string(@tot_cmp_car)+'  '+string(@tot_cmd_car);
    set @TOT_car=0;
    set @TOT_scar=@TOT_scar+@tot_val;
    fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
      @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,
      @ut
  end loop
  ;
  set @ls_car=REPEAT(' ',20-LENGTH(STRING(@TOT_car)))+STRING(@TOT_car);
  set @ls_scar=REPEAT(' ',20-LENGTH(STRING(@TOT_scar)))+STRING(@TOT_scar);
  set @ls_return=@ls_car+@ls_scar;
  message ' retu:'+@ls_return;
  return(@ls_return)
end;

IF EXISTS(SELECT 1 FROM   SYSPROCEDURE
   WHERE  PROC_NAME = 'fn_alt_riep_art') THEN
   DROP PROCEDURE fn_alt_riep_art;
END IF;

CREATE FUNCTION "DBA"."fn_alt_riep_art"(in @rd_art integer,in @rd_da date,in @rd_a date,in @rd_maga integer)
returns char(40)
begin
  declare @Qta_Evasa decimal(18,4);
  declare @peso decimal(18,4);
  declare @ID_Locazione_2 integer;
  declare @ID_Locazione_1 integer;
  declare @cmp_car char(1);
  declare @cmp_scar char(1);
  declare @cmd_car char(1);
  declare @cmd_scar char(1);
  declare @ut char(1);
  declare @ls_car char(20);
  declare @ls_scar char(20);
  declare @ls_return char(40);
  declare @li_sqlstatus integer;
  declare @tot_car decimal(18,4);
  declare @tot_scar decimal(18,4);
  declare @tot_cmp_car decimal(18,4);
  declare @tot_cmp_scar decimal(18,4);
  declare @tot_cmd_car decimal(18,4);
  declare @tot_cmd_scar decimal(18,4);
  declare @tot_val decimal(18,4);
  declare @maga_1 integer;
  declare @maga_2 integer;
  declare cur_art dynamic scroll cursor for select r.qta_un_base,
      r.peso_netto,r.id_locazione_2,r.id_locazione_1,
      c.mp_car_fiscali,c.mp_scar_fiscali,c.md_car_fiscali,
      c.md_scar_fiscali,u.tipo
      from alt_documento as d
      ,alt_riga_documento as r
      ,caus_magazzino as c
      ,unita_confezione as uf
      ,unita_misura as u
      where r.id_documento=d.id_documento
      and c.id_caus_magazzino=r.id_caus_magazzino
      and uf.id_unita_confezione=r.id_unita_confezione
      and u.id_unita_misura=uf.id_unita_misura
      and d.data_registrazione>=@rd_da
      and d.data_registrazione<=@rd_a
      and r.id_articolo=@rd_art
//      and(c.mp_car_fiscali is not null
//      or c.mp_scar_fiscali is not null
//      or c.md_car_fiscali is not null
//      or c.md_scar_fiscali is not null)
;
  set @li_sqlstatus=0;
  set @TOT_car=0;
  set @TOT_scar=0;
  set @TOT_val=0;
  set @tot_cmp_car=0;
  set @tot_cmd_car=0;
  set @tot_cmp_scar=0;
  set @tot_cmd_scar=0;
  open cur_art;
  fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
    @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,@ut;
  while sqlcode=0 loop
    //    message 'code',string(sqlcode);
    set @tot_cmp_car=0;
    set @tot_cmd_car=0;
    set @tot_cmp_scar=0;
    set @tot_cmd_scar=0;
    if sqlcode<>0 then
      set @TOT_car=0;
      set @TOT_scar=0;
      set @TOT_val=0;
      leave cicloDispLoop
    end if
    ;
    message ' maga:'+string(@rd_maga);
    if @ut='P' then
      set @Tot_val=@peso
    else
      set @Tot_val=@qta_evasa
    end if
    ;
    message ' tot:'+string(@tot_cmp_car)+'  '+string(@tot_cmd_car);
    set @TOT_car=0;
    set @TOT_scar=@TOT_scar+@tot_val;
    fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
      @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,
      @ut
  end loop
  ;
  set @ls_car=REPEAT(' ',20-LENGTH(STRING(@TOT_car)))+STRING(@TOT_car);
  set @ls_scar=REPEAT(' ',20-LENGTH(STRING(@TOT_scar)))+STRING(@TOT_scar);
  set @ls_return=@ls_car+@ls_scar;
  message ' retu:'+@ls_return;
  return(@ls_return)
end;


IF EXISTS(SELECT 1 FROM   SYSPROCEDURE
   WHERE  PROC_NAME = 'fn_riep_art_var') THEN
   DROP PROCEDURE fn_riep_art_var;
END IF;


CREATE FUNCTION "DBA"."fn_riep_art_var"(in @rd_art integer,in @rd_da date,in @rd_a date,in @rd_maga integer, @id_var1 integer)
returns char(40)
begin
  declare @Qta_Evasa decimal(18,4);
  declare @peso decimal(18,4);
  declare @ID_Locazione_2 integer;
  declare @ID_Locazione_1 integer;
  declare @cmp_car char(1);
  declare @cmp_scar char(1);
  declare @cmd_car char(1);
  declare @cmd_scar char(1);
  declare @ut char(1);
  declare @ls_car char(20);
  declare @ls_scar char(20);
  declare @ls_return char(40);
  declare @li_sqlstatus integer;
  declare @tot_car decimal(18,4);
  declare @tot_scar decimal(18,4);
  declare @tot_cmp_car decimal(18,4);
  declare @tot_cmp_scar decimal(18,4);
  declare @tot_cmd_car decimal(18,4);
  declare @tot_cmd_scar decimal(18,4);
  declare @tot_val decimal(18,4);
  declare @maga_1 integer;
  declare @maga_2 integer;
  declare cur_art dynamic scroll cursor for select r.qta_un_base,
      r.peso_netto,r.id_locazione_2,r.id_locazione_1,
      c.mp_car_fiscali,c.mp_scar_fiscali,c.md_car_fiscali,
      c.md_scar_fiscali,u.tipo
      from documento as d
      ,riga_documento as r
      ,caus_magazzino as c
      ,unita_confezione as uf
      ,unita_misura as u
      where r.id_documento=d.id_documento 
      and (r.id_art_var1=@id_var1 or @id_var1 is null)
      and c.id_caus_magazzino=r.id_caus_magazzino
      and uf.id_unita_confezione=r.id_unita_confezione
      and u.id_unita_misura=uf.id_unita_misura
      and d.data_registrazione>=@rd_da
      and d.data_registrazione<=@rd_a
      and r.id_articolo=@rd_art
      and(c.mp_car_fiscali is not null
      or c.mp_scar_fiscali is not null
      or c.md_car_fiscali is not null
      or c.md_scar_fiscali is not null);
  set @li_sqlstatus=0;
  set @TOT_car=0;
  set @TOT_scar=0;
  set @TOT_val=0;
  set @tot_cmp_car=0;
  set @tot_cmd_car=0;
  set @tot_cmp_scar=0;
  set @tot_cmd_scar=0;
  open cur_art;
  fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
    @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,@ut;
  while sqlcode=0 loop
    //    message 'code',string(sqlcode);
    set @tot_cmp_car=0;
    set @tot_cmd_car=0;
    set @tot_cmp_scar=0;
    set @tot_cmd_scar=0;
    if sqlcode<>0 then
      set @TOT_car=0;
      set @TOT_scar=0;
      set @TOT_val=0;
      leave cicloDispLoop
    end if
    ;
    message ' maga:'+string(@rd_maga);
    if @ut='P' then
      set @Tot_val=@peso
    else
      set @Tot_val=@qta_evasa
    end if
    ;
    if @rd_maga=0 then
      set @maga_1=0;
      set @maga_2=0
    else
      select id_magazzino into @maga_1 from locazione where id_locazione=@id_locazione_1;
      if @maga_1 is null then
        set @maga_1=999
      end if
      ;
      select id_magazzino into @maga_2 from locazione where id_locazione=@id_locazione_2;
      if @maga_2 is null then
        set @maga_2=999
      end if
    end if
    ;
    message ' maga_1:'+string(@maga_1);
    if @maga_1=@rd_maga then
      if @cmp_car='+' then
        set @tot_cmp_car=@tot_val
      else
        if @cmp_car='-' then
          set @tot_cmp_car=@tot_val*(-1)
        else
          set @tot_cmp_car=0
        end if
      end if
    end if
    ;
    if @maga_1=@rd_maga then
      if @cmp_scar='+' then
        set @tot_cmp_scar=@tot_val
      else
        if @cmp_scar='-' then
          set @tot_cmp_scar=@tot_val*(-1)
        else
          set @tot_cmp_scar=0
        end if
      end if
    end if
    ;
    message ' maga_2:'+string(@maga_2);
    if @maga_2=@rd_maga then
      if @cmd_car='+' then
        set @tot_cmd_car=@tot_val
      else
        if @cmd_car='-' then
          set @tot_cmd_car=@tot_val*(-1)
        else
          set @tot_cmd_car=0
        end if
      end if
    end if
    ;
    if @maga_2=@rd_maga then
      if @cmd_scar='+' then
        set @tot_cmd_scar=@tot_val
      else
        if @cmd_scar='-' then
          set @tot_cmd_scar=@tot_val*(-1)
        else
          set @tot_cmd_scar=0
        end if
      end if
    end if
    ;
    message ' tot:'+string(@tot_cmp_car)+'  '+string(@tot_cmd_car);
    set @TOT_car=@TOT_car+@tot_cmp_car+@tot_cmd_car;
    set @TOT_scar=@TOT_scar+@tot_cmp_scar+@tot_cmd_scar;
    fetch next cur_art into @qta_evasa,@peso,@id_locazione_2,@id_locazione_1,
      @cmp_car,@cmp_scar,@cmd_car,@cmd_scar,
      @ut
  end loop
  ;
  set @ls_car=REPEAT(' ',20-LENGTH(STRING(@TOT_car)))+STRING(@TOT_car);
  set @ls_scar=REPEAT(' ',20-LENGTH(STRING(@TOT_scar)))+STRING(@TOT_scar);
  set @ls_return=@ls_car+@ls_scar;
  message ' retu:'+@ls_return;
  return(@ls_return)
end;


//MODULO PACKING LIST
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sys_modulo'
        AND      CNAME = 'paking_list' )) THEN 
        
	ALTER TABLE sys_modulo add "paking_list" char(1) DEFAULT NULL;

end if;



//RIGA distinta base
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_distinta'
        AND      CNAME = 'riga_perc_provv' )) THEN 
        
	alter table riga_distinta add "riga_perc_provv" numeric(18,4) DEFAULT NULL;

end if;



//Nuova Derivazione Fornitori
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'new_deriv_fo' )) THEN 
        
	ALTER TABLE par_sistema add new_deriv_fo char(1);
	if (select codice from azienda)<>'PARIGI' then
		update par_sistema set new_deriv_fo='S';
	end if;

end if;


//distinta base
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'importo_minimo' )) THEN 
        
	alter table distinta add "importo_minimo" numeric(18,4) DEFAULT NULL;

end if;

//PRE SLIP
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'parigi_op_distinta' )) THEN 
	
	alter table par_sistema add "parigi_op_distinta" char(1) DEFAULT NULL;	
        
end if;


//PARIGI DISTINTA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'tipo_min_doc' )) THEN 
        
	ALTER TABLE prof_documento add tipo_min_doc char(1);
	ALTER TABLE prof_documento add imp_min_doc numeric(18,2);

end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'parigi_par_sistema'
        AND      CNAME = 'id_prof_ord_agenti' )) THEN 
        
	ALTER TABLE parigi_par_sistema add id_prof_ord_agenti integer;

end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'blocca_esplosione' )) THEN 
        
	ALTER TABLE distinta add blocca_esplosione char(1);

end if;


//PACKING LIST
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'usa_packing_list' )) THEN 
        
	ALTER TABLE prof_documento add usa_packing_list char(1);

end if;


//Esportazione allegati Clienti/Fornitori su File
call fn_ins_voce_menu('Anagrafica', 'w_controllo_allegati_clfo_ff', 'Controllo Allegati CL/FO', 112);

//Correzione import listini elettronici ANGAISA
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_listino_angaisa') THEN
        
				ALTER PROCEDURE "DBA"."sp_listino_angaisa"(in @id_azienda integer,in @precodice char(8))
				on exception resume
				begin
				  /*
				  Creazione:            Massimo Zurli   22/02/2006
				  Aggiornamento:        Massimo Zurli   22/02/2006
				
				
				  */
				  /* Stored procedure in Watcom SQL per creare e caricare i dati 
				  nelle tabelle temporanee 
				
				
				  Parametri in ingresso
				  - id_azienda
				
				  */
				  /*Struttura del file in input
				  TipoRec						T	1		1			T=Testata R=Riga V=Variazione CodArt N=Nota tecnic
				  FornCod						T	12	2			Codice del fornitore
				  FornRgs						T	35	14		Ragione sociale
				  FornList					    T	12	49		Sigla o numero listino
				  EAN13							T	13	61		Codice EAN13
				  CodArt						T	15	74		Codice articolo fornitore
				  DesArt1						T	50	89		Descrizione articolo
				  DesArt2						T	50	139		Descrizione articolo
				  CodiceFAM					    T	20	189		Codice della famiglia
				  UmBase						T	3		209		Unit di misura come tabella 
				  UmAlter						T	3		212		Unit di misura alternativa
				  Quantita					    N	10	215	2	Quantit articolo
				  PrezzoListino			        N	15	225	4	Prezzo dell'articolo
				  CodiceIva					    T	6		240		Codice da tabella IVA
				  Scelta						N	3		246		Codice della tabella SCELTA
				  Spallettizzabile	            T	1		249		Flag spallettizzabile Si/No
				  Moltiplicatore		        N	7		250	2	Coefficiente del prezzo unitario
				  CoeffSuperficie		        N	8		257	4	Settore piastrelle(moltiplicatore collegato)
				  Note							T	35	265		Campo per eventuali commenti
				  CatSc							T	12	300		Categoria di  sconto
				  MinAcq						N	10	312	2	Quantit minima acquistabile 
				  TipoPrezzo				    T	1		322		Indica se il prezzo  riferito all'unit base o alternativa
				  Stato							T	1		323		Stato del prodotto da tabella STATO
				  CodArtCm					    T	15	324		Indica l''esistenza di confezionamenti alternativi
				  Filler						T	62	339		Campo vuoto
				  */
				  declare @li_record integer;
				  declare @ls_sqlstate char(5);
				  declare err_notfound exception for sqlstate value '02000';
				  declare @data_letta char(8);
				  declare @data_validita date;
				  //begin
				  /* Distruggo la tabella d''appoggio */
				  if(exists(select 1 from sys.systable where table_name = 'tmp_listino')) then
				    drop table DBA.tmp_listino
				  end if;
				  /* Tabella di appoggio per i vari records letti */
				  if(not(exists(select 1 from sys.systable where table_name = 'tmp_listino'))) then
				    create table dba.tmp_listino(
				      note long varchar null, //id integer not null default autoincrement,
				      )
				  end if; //,
				  //      primary key(id)
				  /*  Caricamento dei dati nella tabella temporanea */
				    load into table tmp_listino from 'C:\ANGAISA.DAT' format ascii DELIMITED BY '\x09' ;
				  commit work;
				  /* Pulizia della tabella del listino */
				  delete from lis_listino where precodice = @precodice;
				  /* Lettura della data di validit */
				  /* Caricamento della tabello listino */
				  select convert(date,substr(note,106,8)) into @data_validita
				    from tmp_listino where
				    substr(note,1,1) = 'T';
				  /* Caricamento della tabello listino */
				  insert into lis_listino(id_azienda,
				    precodice,
				    codice,
				    descrizione,
				    codice_confezione,
				    prezzo,
				    cat_prezzo,
				    codice_valuta,
				    data_inizio_validita,
				    tipo_codice_barre,
				    codice_barre,
				    prezzo_acq)
				    select @id_azienda, // id_azienda
				      @precodice, // precodice
				      trim(substr(note,74,15)), // codice
				      trim(substr(note,89,50)), // descrizione
				      trim(substr(note,209,3)), // codice_confezione
				      (convert(numeric(18,4),trim(substr(note,225,15))))/10000, // prezzo, tolgo i quattro decimali
				      trim(substr(note,300,12)),'E', // cat_prezzo
				      @data_validita,'EAN13',
				      // codice_valuta
				      // data_inizio_validita
				      // tipo_codice_barre
				      trim(substr(note,61,13)), // codice_barre
				      (convert(numeric(18,4),trim(substr(note,225,15))))/10000 from // prezzo_acq, tolgo i quattro decimali
				      tmp_listino where
				      substr(note,1,1) = 'R'
				end; // end procedura    
				    
END IF;

//SOLLECITI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sollecito'
        AND      CNAME = 'pie_testo' )) THEN 
        
	ALTER TABLE sollecito ADD pie_testo long varchar DEFAULT NULL;

end if;


//DISTINTA PARIGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'cat_distinta' )) THEN 
        
	ALTER TABLE distinta ADD cat_distinta char(1) DEFAULT NULL;

end if;

//Velocizzazione allegati cl/fo
IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
   WHERE  tname = 'anagrafica' 
	 AND 	 iname = 'ixc_allegati_1')) THEN  
	 
	 CREATE INDEX "ixc_allegati_1" ON "DBA"."anagrafica" ( par_iva );	 
	 
END IF;

IF NOT(EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
   WHERE  tname = 'anagrafica' 
	 AND 	 iname = 'ixc_allegati_2')) THEN  
	 
	 CREATE INDEX "ixc_allegati_2" ON "DBA"."anagrafica" ( cod_fiscale );
	 
END IF;	 
///////////////////////////////


//RISCOSSINONE ASSEGNI ALTERINI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mov_scadenza'
        AND      CNAME = 'id_doc_riscossione' )) THEN 



	ALTER TABLE mov_scadenza add "id_doc_riscossione" integer DEFAULT NULL;
	ALTER TABLE mov_scadenza add "id_scad_riscossione" integer DEFAULT NULL;

	insert into scadenza (id_scadenza, id_valuta, id_azienda , id_tipo_pagamento, stato_scadenza, tipo_scadenza,
		      esito_pagamento, data_cambiamento_stato, note, importo, imp_valuta, cambio, data_scadenza)
	( select 0, 3 , 1 , min(id_tipo_pagamento) , 'P' , 'A', 'P' , '1900-01-01', 'APPOGGIO', 0, 1, 0 , '1900-01-01' from tipo_pagamento);

end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mov_scadenza'
        AND      CNAME = 'id_ins_riscossione' )) THEN 



	ALTER TABLE mov_scadenza add "id_ins_riscossione" integer DEFAULT NULL;


end if;


IF NOT(EXISTS(select 1 from sysforeignkeys 
	where role='fk_mov_ins_risc_pb9')) THEN 
	ALTER TABLE mov_scadenza ADD FOREIGN KEY "fk_mov_ins_risc_pb9" ("id_ins_riscossione" ) REFERENCES "dba"."scadenza" ON DELETE CASCADE ;
end if;




//Id con_pagamento rimessa diretta
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_con_pag_rim_dir' )) THEN 
        
        ALTER TABLE par_sistema ADD id_con_pag_rim_dir integer DEFAULT NULL;
end if; 


//Id conto contropartita per riscossione 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_conto_cpt_risc' )) THEN 
        
        ALTER TABLE par_sistema ADD id_conto_cpt_risc integer DEFAULT NULL;
end if; 

//Id conto contropartita per riscossione 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_prof_reg_risc' )) THEN 
        
        ALTER TABLE par_sistema ADD id_prof_reg_risc integer DEFAULT NULL;
end if; 


//Id conto contropartita per riscossione 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mov_iva'
        AND      CNAME = 'chk_allegati' )) THEN 
        
	alter table mov_iva add chk_allegati char(1) default 'N';
end if; 



//Correzione trigger update storico_prezzo
IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_Mov_Scad_Agg_Assegni_bd')) THEN

	CREATE TRIGGER "t_Mov_Scad_Agg_Assegni_bd".t_Mov_Scad_Agg_Assegni_bd before delete order 1
	on "DBA".Mov_Scadenza
	referencing old as old_Mov
	for each row
	begin
	  /* [RICCARDO -- ALTERINI]
	  Ricreo il movimento di assegno che verr cancellato dal cascade del mov_partita . */
	  if ((old_Mov.id_scad_riscossione>0 and old_Mov.id_scad_riscossione is not null) or  (old_Mov.id_ins_riscossione>0 and old_Mov.id_ins_riscossione is not null)) and old_mov.id_scadenza>0 then
	     insert into mov_scadenza ("id_scadenza", "data", "importo", "imp_valuta", "note", "id_azienda", 
	                               "id_doc_riscossione", "id_scad_riscossione", "id_ins_riscossione") 
	                       values (0, old_Mov.data, old_Mov.importo, old_Mov.imp_valuta, old_Mov.note, old_Mov.id_azienda, 
	                               old_Mov.id_doc_riscossione, old_Mov.id_scad_riscossione, old_mov.id_ins_riscossione) 
	  end if
	end;

end if;



update par_sistema set margine='S';

//Parigi per evasione ordini da terminale
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_doc_ord_7400_3' )) THEN 
        
	alter table pers_par_sistema add id_prof_doc_ord_7400_3 integer default null;
end if; 
/////////////////////////////////////////

//Parigi per ordinamento per codice importazione ordini da terminalino
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'f7400_evaord'
        AND      CNAME = 'id_distinta' )) THEN 
        
	alter table f7400_evaord add id_distinta integer default null;
end if; 
/////////////////////////////////////////

//Acquisti RCH Onda
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'rc_rchonda' )) THEN 
        
	alter table pers_par_sistema add rc_rchonda char(1) default null;
end if; 
////////////////////

//RC Sweda Micropos
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'rc_sweda' )) THEN 
        
	alter table pers_par_sistema add rc_sweda char(1) default null;
end if; 
////////////////////

//Trasferimento Dati GIESSE (Adattamento per Cometa2)
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte1') THEN

				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte1"()
				begin
				  /*
				  Elisa M. 
				  Rif. Bolla  7473
				
				  CHIAMATA DA 
				  sp_trasf_dati
				  */
				  /* Stored procedure in Watcom SQL per creare e caricare i dati 
				  nelle tabelle temporanee 
				  */
				  declare @li_record integer;
				  //
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create   table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      )  
				  end if
				  ;
				  /*
				  BOLLE DI VENDITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_documento')) then
				    drop table tmp_documento
				  end if
				  ;
				  create   table
				    "dba".tmp_documento(
				    id_documento integer not null,
				    id_prof_documento integer not null,
				    id_registro integer not null,
				    num_progressivo decimal(12) not null,
				    data_registrazione date not null,
				    num_documento char(16) null,
				    data_documento date null,
				    data_competenza date null,
				    id_prof_registrazione integer null,
				    des_contabile char(40) null,
				    id_sog_commerciale integer not null,
				    id_destinazione integer null,
				    id_caus_magazzino integer null,
				    id_magazzino integer null,
				    id_magazzino_2 integer null,
				    id_sog_commerciale_fattura integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    id_valuta integer not null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_pagamento integer null,
				    id_gruppo_agenti integer null,
				    id_banca_sog_commerciale integer null,
				    origine char(40) null,
				    interlocutore char(40) null,
				    data_prev_consegna date null,
				    note_intestazione long varchar null,
				    num_colli decimal(8) null,
				    id_unita_misura_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_misura_volume integer null,
				    volume decimal(18,4) null default 0,
				    id_tipo_trasporto integer null,
				    id_caus_trasporto integer null,
				    asp_beni char(40) null,
				    tras_mezzo char(1) null,
				    id_sog_commerciale_vettore integer null,
				    id_sog_commerciale_vettore_2 integer null,
				    mezzo_trasporto char(40) null,
				    targa_mezzo_trasporto char(40) null,
				    data_trasporto date null,
				    ora_trasporto time null,
				    sconto_finanziario char(40) null,
				    sconto_fin_incondizionato decimal(18,4) null,
				    sconto_fin_cassa decimal(5,2) null,
				    data_dec_pagamento date null,
				    imp_acconto decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    stampato char(1) null,
				    contabilizzato char(1) null,
				    evaso_totalmente char(1) null,
				    chius_forzata char(1) null,
				    sospeso char(1) null,
				    data_scadenza date null,
				    creato_in_esenzione char(1) null,
				    bloccato char(1) null,
				    prog_globale decimal(16) null,
				    doc_globale decimal(16) null,
				    tipo_fattura char(1) null,
				    segno_iva decimal(2) null default 1,
				    id_documento_padre integer null,
				    id_azienda integer not null default 1,
				    id_tipo_pag_acconto integer null,
				    id_tab_iva_acconto integer null,
				    id_val_acconto integer null,
				    ora_registrazione time null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    storno_anticipi char(1) null,
				    id_variazione integer null,
				    bollo char(20) null,
				    id_gruppo_agenti_2 integer null,
                    data_ric_consegna date null, //17.10.07
                    id_utente integer null,  //17.10.07
                    alt_pag char(1) null, //17.10.07
                    alt_ord char(1) null, //17.10.07
                    id_cat_zona integer null,  //17.10.07
				    primary key(id_documento),
				    )  ;
				  //
				  create unique index xak1tmp_documento on
				    "dba".tmp_documento(id_registro asc,num_progressivo asc,data_registrazione asc);
				  //
				  load into table tmp_documento from 'C:\\windows\\temp\\documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_documento;
				  //
				  message 'tabella TMP DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - RIGHE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_riga_documento')) then
				    drop table tmp_riga_documento
				  end if
				  ;
				  create   table "dba".tmp_riga_documento(
				    id_riga_documento integer not null,
				    id_documento integer null,
				    id_unita_confezione integer null,
				    id_gruppo_agenti integer null,
				    num_riga decimal(4) null,
				    id_articolo integer null,
				    descrizione long varchar null,
				    id_des_articolo integer null,
				    quantita decimal(18,4) null,
				    qta_sconto_merce decimal(18,4) null,
				    qta_evasa decimal(18,4) null,
				    fat_con_unita_base decimal(8,4) null,
				    fat_con_globale decimal(8,4) null,
				    qta_un_base decimal(18,4) null,
				    qta_evasa_un_base decimal(18,4) null,
				    id_caus_magazzino integer null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_lis_articolo integer null,
				    prezzo decimal(18,4) null,
				    sconto char(40) null,
				    prezzo_netto decimal(18,4) null,
				    sconto_riga decimal(18,4) null,
				    data_prevista_consegna date null,
				    peso_netto decimal(18,4) null,
				    peso_lordo decimal(18,4) null,
				    dim_l decimal(18,4) null,
				    dim_h decimal(18,4) null,
				    dim_p decimal(18,4) null,
				    num_colli decimal(8) null,
				    id_tab_iva integer null,
				    val_attribuito decimal(18,4) null,
				    provv_agente decimal(5,2) null,
				    provv_subage decimal(5,2) null,
				    provv_carea decimal(5,2) null,
				    id_caus_trasporto integer null,
				    forza_chius_evasione char(1) null,
				    sospesa char(1) null,
				    da_stampare char(1) null,
				    data_inizio_competenza date null,
				    data_fine_competenza date null,
				    tot_riga_val_riga decimal(18,4) null,
				    tot_riga_val_doc decimal(18,4) null,
				    tot_riga_val_az decimal(18,4) null,
				    id_riga_doc_provenienza integer null,
				    id_conto integer null,
				    id_azienda integer null,
				    id_riga_doc_padre integer null,
				    provv_imp_agente decimal(18,4) null,
				    provv_imp_subage decimal(18,4) null,
				    provv_imp_carea decimal(18,4) null,
				    id_riga_lotto integer null,
				    qta_ordinata_fo decimal(18,4) null,
				    ordinato_fo char(1) null,
				    peso_netto_evaso decimal(18,4) null,
				    id_gruppo_Agenti_2 integer null,
				    provv_agente_2 decimal(5,2) null,
				    provv_subage_2 decimal(5,2) null,
				    provv_carea_2 decimal(5,2) null,
				    provv_imp_agente_2 decimal(18,4) null,
				    provv_imp_subage_2 decimal(18,4) null,
				    provv_imp_carea_2 decimal(18,4) null,
                    id_distinta integer null, //17.10.07
                    id_art_var1 integer null, //17.10.07
                    id_art_var2 integer null, //17.10.07
                    id_art_var3 integer null, //17.10.07
                    id_operatore integer null, //17.10.07
                    id_alt_uc1 integer null, //17.10.07
                    id_alt_uc2 integer null, //17.10.07
                    id_alt_uc3 integer null, //17.10.07
				    primary key(id_riga_documento),
				    )  ;
				  //
				  create unique index ak1_tmp_riga_documento on tmp_riga_documento(id_documento asc,num_riga asc);
				  load into table tmp_riga_documento from 'C:\\windows\\temp\\riga_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_riga_documento;
				  //
				  message 'tabella TMP RIGA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_iva_documento')) then
				    drop table tmp_cast_iva_documento
				  end if
				  ;
				  create   table "dba".tmp_cast_iva_documento(
				    id_documento integer not null,
				    id_tab_iva integer not null,
				    val_omaggi decimal(18,4) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    val_tot_imp_v decimal(18,4) null,
				    val_tot_imp_l decimal(18,4) null,
				    val_tot_iva_v decimal(18,4) null,
				    val_tot_iva_l decimal(18,4) null,
				    primary key(id_documento,id_tab_iva),
				    )  ;
				  //
				  load into table tmp_cast_iva_documento from 'C:\\windows\\temp\\cast_iva_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_iva_documento;
				  //
				  message 'tabella TMP CAST IVA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO CONTROPARTITE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_cpt_documento')) then
				    drop table tmp_cast_cpt_documento
				  end if
				  ;
				  //
				  create   table "dba".tmp_cast_cpt_documento(
				    id_documento integer not null,
				    id_conto integer not null,
				    tipo_riga_cpt char(1) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_omaggi decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    primary key(id_documento,id_conto),
				    )  ;
				  //
				  load into table tmp_cast_cpt_documento from 'C:\\windows\\temp\\cast_cpt_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_cpt_documento;
				  //
				  message 'tabella TMP CAST CPT DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SPESE DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_documento')) then
				    drop table tmp_spesa_documento
				  end if
				  ;
				  //
				  create   table "dba".tmp_spesa_documento(
				    id_documento integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
                    mantieni char(1) null, //17.10.07
				    primary key(id_documento,
				    id_spesa),
				    )  ;
				  //
				  message 'tabella TMP SPESA DOCUMENTO Inizio Load:';
				  load into table tmp_spesa_documento from 'C:\\windows\\temp\\spesa_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_documento;
				  //
				  message 'tabella TMP SPESA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SCADENZE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scadenza')) then
				    drop table tmp_scadenza
				  end if
				  ;
				  //
				  create   table "dba".tmp_scadenza(
				    id_scadenza integer not null,
				    tipo_scadenza char(1) null,
				    id_sog_commerciale integer null,
				    data_scadenza date null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    imp_valuta decimal(18,4) null,
				    importo decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    id_banca_azienda integer null,
				    id_banca_sog_commerciale integer null,
				    note long varchar null,
				    ces_denominazione char(40) null,
				    ces_indirizzo char(40) null,
				    ces_cap char(10) null,
				    ces_localita char(40) null,
				    ces_provincia char(5) null,
				    ces_doc_originale char(16) null,
				    ces_data_documento date null,
				    stato_scadenza char(1) null,
				    data_cambiamento_stato date null,
				    esito_pagamento char(1) null,
				    scadenza_da_raggruppare char(1) null,
				    id_riga_distinta_banca integer null,
				    id_documento integer null,
				    id_par_aperta integer null,
				    id_scadenza_padre integer null,
				    id_azienda integer null,
                    num_sollecito integer null, //17.10.07
                    data_ult_sollecito date null, //17.10.07
				    cod_sog_commerciale char(8) null,
				    primary key(id_scadenza),
				    )  ;
				  //
				  load into table tmp_scadenza from 'C:\\windows\\temp\\scadenza.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scadenza;
				  //
				  message 'tabella TMP SCADENZA record trasferiti:'+string(@li_record);
				  //
				  message 'FINE LOAD ... ';
				  message 'INIZIO CREAZIONE INDICI PK ... ';
				  //
				  create unique index xpk_tmp_documento on tmp_documento(id_documento asc);
				  //
				  create unique index xpk_tmp_riga_documento on tmp_riga_documento(id_riga_documento asc);
				  //
				  message 'FINE CREAZIONE INDICI PK ... '
				//
				end;        
        
end if;        

IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte2') THEN
        
				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte2"()
				begin
				  /*
				  Elisa M. 	05/02/2001
				
				  CHIAMATA DA 
				  sp_trasf_dati
				  */
				  /* Stored procedure in Watcom SQL per creare e caricare i dati 
				  nelle tabelle temporanee 
				  */
				  declare @li_record integer;
				  /*
				  TABELLA DI LOG
				  */
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create   table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      )  
				  end if
				  ;
				  /*
				  ANAGRAFICA TIPO MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_magazzino')) then
				    drop table tmp_tipo_magazzino
				  end if
				  ;
				  //
				  //create   table "dba".tmp_tipo_magazzino(
				    create table "dba".tmp_tipo_magazzino(
				    id_tipo_magazzino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_tipo_magazzino),
				    ) ;
				  //
				  load into table tmp_tipo_magazzino from 'C:\\windows\\temp\\tipo_magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_magazzino;
				  //
				  message 'tabella TMP TIPO MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  if(exists(select 1 from sys.systable where table_name='tmp_magazzino')) then
				    drop table tmp_magazzino
				  end if
				  ;
				  //
				  create table "dba".tmp_magazzino(
				    id_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    note long varchar null,
				    giac_globale char(1) null,
				    id_tipo_magazzino integer null,
				    id_azienda integer null,
				    primary key(id_magazzino),
				    );
				  //
				  load into table tmp_magazzino from 'C:\\windows\\temp\\magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_magazzino;
				  //
				  message 'tabella TMP MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_lingua')) then
				    drop table tmp_lingua
				  end if
				  ;
				  //
				  create table "dba".tmp_lingua(
				    id_lingua integer not null,
				    codice char(5) null,
				    descrizione char(40) null,
				    primary key(id_lingua),
				    ) ;
				  //
				  load into table tmp_lingua from 'C:\\windows\\temp\\lingua.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_lingua;
				  //
				  message 'tabella TMP LINGUA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUAGGIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_linguaggio')) then
				    drop table tmp_linguaggio
				  end if
				  ;
				  //
				  create table "dba".tmp_linguaggio(
				    id_linguaggio integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_linguaggio),
				    ) ;
				  //
				  load into table tmp_linguaggio from 'C:\\windows\\temp\\linguaggio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_linguaggio;
				  //
				  message 'tabella TMP LINGUAGGIO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA VALUTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_valuta')) then
				    drop table tmp_valuta
				  end if
				  ;
				  //
				  create table "dba".tmp_valuta(
				    id_valuta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    simbolo char(5) null,
				    cambio decimal(8,4) null,
				    cifra_arrotondamento decimal(3) null,
				    tipo_arrotondamento char(1) null,
				    parita_euro decimal(8,4) null,
				    dec_significativi decimal(1) null,
				    primary key(id_valuta),
				    ) ;
				  //
				  load into table tmp_valuta from 'C:\\windows\\temp\\valuta.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_valuta;
				  //
				  message 'tabella TMP VALUTA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LISTINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_listino')) then
				    drop table tmp_listino
				  end if
				  ;
				  //
				  create table "dba".tmp_listino(
				    id_listino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_valuta integer null,
				    id_azienda integer null,
				    lis_base char(1) null,
                    lis_pref char(1) null,  //17.10.07
				    primary key(id_listino),
				    ) ;
				  //
				  load into table tmp_listino from 'C:\\windows\\temp\\listino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_listino;
				  //
				  message 'tabella TMP LISTINO record trasferiti:'+string(@li_record);
				  //    
				  //  
				  /*
				  ANAGRAFICA VARIAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_variazione')) then
				    drop table tmp_variazione
				  end if
				  ;
				  //
				  create table "dba".tmp_variazione(
				    id_variazione integer not null,
				    id_listino integer null,
				    data_inizio date null,
				    data_fine date null,
				    cambio decimal(8,4) null,
				    max_osc_positiva decimal(5,2) null,
				    max_osc_negativa decimal(5,2) null,
				    prezzi_ivati char(1) null,
				    primary key(id_variazione),
				    ) ;
				  //
				  load into table tmp_variazione from 'C:\\windows\\temp\\variazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_variazione;
				  //
				  message 'tabella TMP VARIAZIONE record trasferiti:'+string(@li_record);
				  //    
				  if(exists(select 1 from sys.systable where table_name='tmp_con_pagamento')) then
				    drop table tmp_con_pagamento
				  end if
				  ;
				  //
				  create table "dba".tmp_con_pagamento(
				    id_con_pagamento integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    sconto_cassa decimal(5,2) null,
				    primary key(id_con_pagamento),
				    ) ; //
				  load into table tmp_con_pagamento from 'C:\\windows\\temp\\con_pagamento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_con_pagamento;
				  //
				  message 'tabella TMP CON PAGAMENTO record trasferiti:'+string(@li_record);
				  /*
				  ANAGRAFICA UNITA MISURA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_misura')) then
				    drop table tmp_unita_misura
				  end if
				  ;
				  //
				  create table "dba".tmp_unita_misura(
				    id_unita_misura integer not null,
				    simbolo char(5) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_unita_misura_riferimento integer null,
				    conversione decimal(8,4) null,
                    n_decimali integer null,    //17.10.07
				    //simbolo_ur char(5) null, //17.10.07
				    primary key(id_unita_misura),
				    ) ;
				  //
				  load into table tmp_unita_misura from 'C:\\windows\\temp\\unita_misura.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_misura;
				  //
				  message 'tabella TMP UNITA MISURA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_trasporto')) then
				    drop table tmp_tipo_trasporto
				  end if
				  ;
				  //
				  create table "dba".tmp_tipo_trasporto(
				    id_tipo_trasporto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    spese_gestite char(15) null,
				    primary key(id_tipo_trasporto),
				    ) ; //
				  load into table tmp_tipo_trasporto from 'C:\\windows\\temp\\tipo_trasporto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_trasporto;
				  //
				  message 'tabella TMP TIPO TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_trasporto')) then
				    drop table tmp_caus_trasporto
				  end if
				  ;
				  //
				  create table "dba".tmp_caus_trasporto(
				    id_caus_trasporto integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_caus_trasporto),
				    ) ; //
				  load into table tmp_caus_trasporto from 'C:\\windows\\temp\\caus_trasporto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_trasporto;
				  //
				  message 'tabella TMP CAUS TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO PAGAMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_pagamento')) then
				    drop table tmp_tipo_pagamento
				  end if
				  ;
				  //
				  create table "dba".tmp_tipo_pagamento(
				    id_tipo_pagamento integer not null,
				    codice char(4) null,
				    id_gruppo_esp_sospeso integer null,
				    descrizione char(40) null,
				    mod_stampa char(40) null,
				    ges_cessioni char(1) null,
				    spese_gestite char(15) null,
				    perc_tratte decimal(5,2) null,
				    arr_bollo_tratta decimal(14) null,
				    imp_min_bollo_tratta decimal(14) null,
				    id_prof_reg_dare integer null,
				    id_prof_reg_avere integer null,
				    premi_penalita char(1) null,
				    cod_gruppo_esp_sospeso char(4) null,
				    cod_prof_reg_dare char(8) null,
				    cod_prof_reg_avere char(8) null,
				    primary key(id_tipo_pagamento),
				    ) ;
				  load into table tmp_tipo_pagamento from 'C:\\windows\\temp\\tipo_pagamento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_pagamento;
				  //
				  message 'tabella TMP TIPO PAGAMENTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA AREA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_area')) then
				    drop table tmp_area
				  end if
				  ;
				  //
				  create   table "dba".tmp_area(
				    id_area integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_area),
				    )  ;
				  load into table tmp_area from 'C:\\windows\\temp\\area.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_area;
				  //
				  message 'tabella TMP AREA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA LOCAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_locazione')) then
				    drop table tmp_locazione
				  end if
				  ;
				  //
				  create   table "dba".tmp_locazione(
				    id_locazione integer not null default autoincrement,
				    id_magazzino integer not null,
				    id_area integer null,
				    corsia char(5) null,
				    scaffale char(5) null,
				    ripiano char(5) null,
				    posizione char(5) null,
				    id_azienda integer null,
				    cod_magazzino char(8) null,
				    cod_area char(8) null,
				    primary key(id_locazione),
				    )  ;
				  load into table tmp_locazione from 'C:\\windows\\temp\\locazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_locazione;
				  //
				  message 'tabella TMP LOCAZIONE record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS_MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_magazzino')) then
				    drop table tmp_caus_magazzino
				  end if
				  ;
				  //
				  create   table "dba".tmp_caus_magazzino(
				    id_caus_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    mag_par_richiesto char(1) null,
				    mag_des_richiesto char(1) null,
				    gen_doc_successivi char(1) null,
				    mp_qta_rim_iniziale char(1) null,
				    mp_val_rim_iniziale char(1) null,
				    mp_car_fiscali char(1) null,
				    mp_val_caricato char(1) null,
				    mp_scar_fiscali char(1) null,
				    mp_val_scaricato char(1) null,
				    mp_ord_clienti char(1) null,
				    mp_ord_fornitori char(1) null,
				    mp_vis_clienti char(1) null,
				    mp_vis_fornitori char(1) null,
				    mp_imp_produzione char(1) null,
				    mp_ord_produzione char(1) null,
				    mp_qta_cl_clienti char(1) null,
				    mp_qta_cl_fornitori char(1) null,
				    mp_qta_cl_terzi char(1) null,
				    mp_gruppo_lib_1 char(1) null,
				    mp_gruppo_lib_2 char(1) null,
				    mp_gruppo_lib_3 char(1) null,
				    mp_gruppo_lib_4 char(1) null,
				    mp_ult_costo char(1) null,
				    md_qta_rim_iniziale char(1) null,
				    md_val_rim_iniziale char(1) null,
				    md_car_fiscali char(1) null,
				    md_val_caricato char(1) null,
				    md_scar_fiscali char(1) null,
				    md_val_scaricato char(1) null,
				    md_ord_clienti char(1) null,
				    md_ord_fornitori char(1) null,
				    md_vis_clienti char(1) null,
				    md_vis_fornitori char(1) null,
				    md_imp_produzione char(1) null,
				    md_ord_produzione char(1) null,
				    md_qta_cl_clienti char(1) null,
				    md_qta_cl_fornitori char(1) null,
				    md_qta_cl_terzi char(1) null,
				    md_gruppo_lib_1 char(1) null,
				    md_gruppo_lib_2 char(1) null,
				    md_gruppo_lib_3 char(1) null,
				    md_gruppo_lib_4 char(1) null,
				    md_ult_costo char(1) null,
				    id_azienda integer null,
				    gestisce_lotti char(1) null,
				    mp_ult_scarico char(1) null,
				    md_ult_scarico char(1) null,
				    tipo_valorizzazione char(1) null,
				    primary key(id_caus_magazzino),
				    )  ;
				  load into table tmp_caus_magazzino from 'C:\\windows\\temp\\caus_magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_magazzino;
				  //
				  message 'tabella TMP CAUS MAGAZZINO record trasferiti:'+string(@li_record);
				  //    
				  //    
				  /*
				  ANAGRAFICA TAB_IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_iva')) then
				    drop table tmp_tab_iva
				  end if
				  ;
				  //
				  create   table "dba".tmp_tab_iva(
				    id_tab_iva integer not null,
				    codice char(8) null,
				    des_breve char(20) null,
				    des_estesa long varchar null,
				    tipo_iva char(1) null,
				    per_aliquota decimal(5,2) null,
				    per_detrazione decimal(5,2) null,
				    per_ventilazione decimal(5,2) null,
				    ges_plafond char(1) null,
				    ges_oper_intracomunitarie char(1) null,
				    imp_min_fattura decimal(14) null,
				    imp_bollo_fattura decimal(14) null,
				    ges_beni_rivendita char(1) null,
				    ges_beni_strumentali char(1) null,
                    rcharge char(1) null, //17.10.07
				    primary key(id_tab_iva),
				    )  ;
				  load into table tmp_tab_iva from 'C:\\windows\\temp\\tab_iva.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_iva;
				  //
				  message 'tabella TAB_IVA record trasferiti:'+string(@li_record);
				  //    
				  //
				  // ANAGRAFICHE CONDIVISE E TABELLE ANAGRAFICHE SULLE QUALI SI BASA  
				  //    
				  //
				  /*
				  ANAGRAFICA BILANCIO_CEE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_bilancio_cee')) then
				    drop table tmp_bilancio_cee
				  end if
				  ;
				  //
				  create   table "dba".tmp_bilancio_cee(
				    id_bilancio_cee integer not null,
				    descrizione varchar(80) null,
				    riferimento decimal(5) null,
				    tipo char(2) null,
				    pos1 char(4) null,
				    pos2 char(4) null,
				    pos3 char(4) null,
				    pos4 char(4) null,
				    flag char(1) null,
				    segno char(2) null,
				    saldo1 decimal(18,4) null,
				    saldo2 decimal(18,4) null,
				    primary key(id_bilancio_cee),
				    )  ;
				  load into table tmp_bilancio_cee from 'C:\\windows\\temp\\bilancio_cee.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_bilancio_cee;
				  //
				  message 'tabella BILANCIO_CEE record trasferiti:'+string(@li_record);
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA PDC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_pdc')) then
				    drop table tmp_pdc
				  end if
				  ;
				  //
				  create   table "dba".tmp_pdc(
				    id_pdc integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_pdc),
				    )  ;
				  load into table tmp_pdc from 'C:\\windows\\temp\\pdc.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_pdc;
				  //
				  message 'tabella PDC record trasferiti:'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA MASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mastro')) then
				    drop table tmp_mastro
				  end if
				  ;
				  //
				  create   table "dba".tmp_mastro(
				    id_mastro integer not null,
				    id_pdc integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_pdc char(15) null,
				    primary key(id_mastro),
				    )  ;
				  load into table tmp_mastro from 'C:\\windows\\temp\\mastro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mastro;
				  //
				  message 'tabella MASTRO record trasferiti:'+string(@li_record);
				  //        
				  //    
				  //
				  /*
				  ANAGRAFICA SOTTOMASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sottomastro')) then
				    drop table tmp_sottomastro
				  end if
				  ;
				  //
				  create   table "dba".tmp_sottomastro(
				    id_sottomastro integer not null,
				    id_mastro integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    uso char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    primary key(id_sottomastro),
				    )  ;
				  load into table tmp_sottomastro from 'C:\\windows\\temp\\sottomastro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sottomastro;
				  //
				  message 'tabella SOTTOMASTRO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA TITOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_titolo')) then
				    drop table tmp_titolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_titolo(
				    id_titolo integer not null,
				    titolo char(40) null,
				    primary key(id_titolo),
				    )  ;
				  load into table tmp_titolo from 'C:\\windows\\temp\\titolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_titolo;
				  //
				  message 'tabella TITOLO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA ATT_SVOLTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_att_svolta')) then
				    drop table tmp_att_svolta
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_att_svolta(
				    id_att_svolta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_att_svolta),
				    )  ;
				  load into table tmp_att_svolta from 'C:\\windows\\temp\\att_svolta.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_att_svolta;
				  //
				  message 'tabella ATT_SVOLTA record trasferiti:'+string(@li_record);
				  //            
				  //    
				  //
				  /*
				  ANAGRAFICA TRIBUTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tributo')) then
				    drop table tmp_tributo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_tributo(
				    id_tributo integer not null,
				    codice char(8) null,
				    cod_tributo char(4) null,
				    descrizione char(80) null,
				    gruppo char(2) null,
				    per_imponibile decimal(5,2) null,
				    per_tributo decimal(5,2) null,
				    inizio_per_validita date null,
				    fine_per_validita date null,
				    mod_fiscale char(10) null,
				    primary key(id_tributo),
				    )  ;
				  load into table tmp_tributo from 'C:\\windows\\temp\\tributo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tributo;
				  //
				  message 'tabella TRIBUTO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //
				  /*
				  ANAGRAFICA ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_anagrafica')) then
				    drop table tmp_anagrafica
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_anagrafica(
				    id_anagrafica integer not null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    cod_fiscale char(16) null,
				    par_iva char(16) null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    nat_giuridica char(1) null,
				    prov_contabile char(1) null,
				    id_valuta integer null,
				    id_tipo_trasporto integer null,
				    id_titolo integer null,
				    id_att_svolta integer null,
				    id_tributo integer null,
				    cog_ritenute char(40) null,
				    nome_ritenute char(40) null,
				    sesso char(1) null,
				    ind_ritenute char(40) null,
				    cap_ritenute char(10) null,
				    loc_ritenute char(40) null,
				    prov_ritenute char(5) null,
				    naz_ritenute char(5) null,
				    data_nas_ritenute date null,
				    luogo_nas_ritenute char(40) null,
				    prov_nas_ritenute char(5) null,
				    naz_nas_ritenute char(5) null,
				    con_previdenziale decimal(5,2) null,
				    cassa_previdenza decimal(5,2) null,
				    rit_previdenziale decimal(5,2) null,
				    isc_enasarco char(1) null,
				    per_enasarco_agente decimal(5,2) null,
				    per_enasarco_conto_agente decimal(5,2) null,
				    id_azienda integer null,
				    bollo char(20) null,
				    codice integer null, //BL#13377#
				    cod_lingua char(15) null,
				    cod_linguaggio char(15) null,
				    cod_valuta char(15) null,
				    cod_tipo_trasporto char(15) null,
				    titolo char(40) null,
				    cod_att_svolta char(15) null,
				    cod_tributo char(15) null,
				    primary key(id_anagrafica),
				    )  ;
				  load into table tmp_anagrafica from 'C:\\windows\\temp\\anagrafica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_anagrafica;
				  //
				  message 'tabella ANAGRAFICA record trasferiti:'+string(@li_record);
				  //                
				  //    
				  //
				  /*
				  ANAGRAFICA GRUPPO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo')) then
				    drop table tmp_gruppo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_gruppo(
				    id_gruppo integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_anagrafica integer null,
				    note long varchar null,
				    fido decimal(14) null,
				    id_azienda integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    primary key(id_gruppo),
				    )  ;
				  load into table tmp_gruppo from 'C:\\windows\\temp\\gruppo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo;
				  //
				  message 'tabella GRUPPO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA CONTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_conto')) then
				    drop table tmp_conto
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_conto(
				    id_conto integer not null,
				    codice char(8) null,
				    id_sottomastro integer null,
				    descrizione char(40) null,
				    id_gruppo integer null,
				    ges_par_aperte char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    cod_gruppo char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    rif_bilancio_cee decimal(5) null,
				    primary key(id_conto),
				    )  ;
				  load into table tmp_conto from 'C:\\windows\\temp\\conto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_conto;
				  //
				  message 'tabella CONTO record trasferiti:'+string(@li_record);
				  //              
				  //      
				  //    
				  //
				  /*
				  ANAGRAFICA CAT_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_attivita')) then
				    drop table tmp_cat_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_attivita(
				    id_cat_attivita integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_attivita),
				    )  ;
				  load into table tmp_cat_attivita from 'C:\\windows\\temp\\cat_attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_attivita;
				  //
				  message 'tabella CAT_ATTIVITA record trasferiti:'+string(@li_record);
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_COM_SC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_sc')) then
				    drop table tmp_cat_com_sc
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_com_sc(
				    id_cat_com_sc integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
                    id_cat_com_sc_superiore integer null, //17.10.07
				    primary key(id_cat_com_sc),
				    )  ;
				  load into table tmp_cat_com_sc from 'C:\\windows\\temp\\cat_com_sc.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_sc;
				  //
				  message 'tabella CAT_COM_SC record trasferiti:'+string(@li_record);
				  //              
				  //          
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_ZONA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_zona')) then
				    drop table tmp_cat_zona
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_zona(
				    id_cat_zona integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_zona),
				    )  ;
				  load into table tmp_cat_zona from 'C:\\windows\\temp\\cat_zona.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_zona;
				  //
				  message 'tabella CAT_ZONA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SOG_COMMERCIALE
				
				  BL#13377#	-	Modifica AK ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sog_commerciale')) then
				    drop table tmp_sog_commerciale
				  end if
				  ;
				  //
				  //
				  create   table
				    "dba".tmp_sog_commerciale(
				    id_sog_commerciale integer not null,
				    codice char(8) null,
				    id_anagrafica integer null,
				    tipo char(1) null,
				    id_conto integer null,
				    data_acquisizione date null,
				    data_trasformazione date null,
				    ns_cod_soggetto char(20) null,
				    id_linguaggio integer null,
				    id_cat_attivita integer null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    id_magazzino integer null,
				    fido decimal(14) null,
				    extrafido decimal(14) null,
				    con_fido char(1) null,
				    id_con_pagamento integer null,
				    data_dec_pagamenti char(1) null,
				    giorno_fisso_pagamenti decimal(2) null,
				    scad_raggruppate char(1) null,
				    id_banca_sog_commerciale integer null,
				    id_listino integer null,
				    id_tipo_trasporto integer null,
				    id_sog_com_vettore integer null,
				    per_fatturazione char(1) null,
				    modo_fatturazione char(1) null,
				    con_fattura char(1) null,
				    fat_sos_iva char(1) null,
				    id_tab_iva integer null,
				    num_ns_prot_documenti char(10) null,
				    data_ns_prot_documenti date null,
				    num_lr_prot_documenti char(10) null,
				    data_lr_prot_documenti date null,
				    uff_iva char(40) null,
				    id_prof_registrazione integer null,
				    id_tributo integer null,
				    id_att_svolta integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer not null default 1,
				    id_tipo_agente integer null,
				    imp_fisso decimal(18,4) null,
				    id_valuta integer null,
				    giorni_franchigia decimal(3) null,
				    id_val_prov_agente integer null,
				    crea_gruppo_agenti char(1) null,
				    imp_fisso_ult_elab decimal(18,4) null,
				    imp_premio_budget decimal(18,4) null,
				    ult_elab_definitivo date null,
				    prec_elab_definitivo date null,
				    id_tab_iva_fat_prov integer null,
				    id_gruppo_agenti_2 integer null,
				    id_sog_com_vettore_2 integer null,
				    spese_gestite char(15) null,
                    archiviazione char(1) null, //17.10.07
                    gest_pdf char(1) null, //17.10.07
                    stato_utilizzo char(1) null, //17.10.07
				    cod_conto char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    cod_linguaggio char(15) null,
				    cod_cat_attivita char(15) null,
				    cod_cat_com_sc char(15) null,
				    cod_cat_zona char(15) null,
				    cod_magazzino char(15) null,
				    cod_con_pagamento char(15) null,
				    cod_abi char(5) null,
				    cod_cab char(5) null,
				    codice_anagrafica integer null,
				    cod_listino char(15) null,
				    cod_tipo_trasporto char(15) null,
				    cod_sog_com_vettore char(15) null,
				    cod_tab_iva char(15) null,
				    cod_prof_registrazione char(15) null,
				    cod_tributo char(15) null,
				    cod_att_svolta char(15) null,
				    cod_gruppo_agenti char(15) null,
				    cod_tipo_agente char(15) null,
				    cod_valuta char(15) null,
				    cod_val_prov_agente char(15) null,
				    cod_tab_iva_fat_prov char(15) null,
				    cod_gruppo_Agenti_2 char(15) null,
				    cod_sog_com_vettore_2 char(15) null,
				    primary key(id_sog_commerciale),
				    )  ;
				  load into table tmp_sog_commerciale from 'C:\\windows\\temp\\sog_commerciale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sog_commerciale;
				  //
				  message 'tabella SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //              
				  //              
				  /*
				  ANAGRAFICA TAB_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_attivita')) then
				    drop table tmp_tab_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_tab_attivita(
				    id_tab_attivita integer not null,
				    codice char(8) null,
				    descrizione long varchar null,
				    primary key(id_tab_attivita),
				    )  ;
				  load into table tmp_tab_attivita from 'C:\\windows\\temp\\tab_attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_attivita;
				  //
				  message 'tabella TAB_ATTIVITA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_attivita')) then
				    drop table tmp_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_attivita(
				    id_attivita integer null,
				    id_tab_attivita integer null,
				    descrizione char(40) null,
				    ges_ventilazione char(1) null,
				    liq_iva char(1) null,
				    tipo_contabilita char(1) null default 'O',
				    id_azienda integer not null default 1,
				    attuale_plafond decimal(18,4) null,
				    cod_tab_attivita char(15) null,
				    )  ;
				  load into table tmp_attivita from 'C:\\windows\\temp\\attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_attivita;
				  //
				  message 'tabella ATTIVITA record trasferiti:'+string(@li_record);
				  //  
				  //
				  /*
				  ANAGRAFICA MOD_REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mod_registro')) then
				    drop table tmp_mod_registro
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_mod_registro(
				    id_mod_registro integer not null,
				    tipo_registro char(2) null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_mod_registro),
				    )  ;
				  load into table tmp_mod_registro from 'C:\\windows\\temp\\mod_registro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mod_registro;
				  //
				  message 'tabella MOD_REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ESERCIZIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_esercizio')) then
				    drop table tmp_esercizio
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_esercizio(
				    id_esercizio integer not null,
				    codice char(4) null,
				    data_inizio date null,
				    data_fine date null,
				    bloccato char(1) null,
				    ult_data_stampa_bollato date null,
				    num_progressivo decimal(8) null,
				    id_azienda integer null,
				    riporto decimal(18,4) null,
				    prog_scritture char(1) null,
				    id_valuta integer null,
                    stato_cespite char(1) null, //17.10.07
				    cod_valuta char(15) null,
				    primary key(id_esercizio),
				    )  ;
				  load into table tmp_esercizio from 'C:\\windows\\temp\\esercizio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_esercizio;
				  //
				  message 'tabella ESERCIZIO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_registro')) then
				    drop table tmp_registro
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_registro(
				    id_registro integer not null,
				    id_esercizio integer null,
				    tipo_registro char(2) null,
				    id_mod_registro integer null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    perc_prorata decimal(5,2) null,
                    max_progressivo integer null, //17.10.07
				    cod_esercizio char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_registro),
				    )  ;
				  load into table tmp_registro from 'C:\\windows\\temp\\registro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_registro;
				  //
				  message 'tabella REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //
				  //
				  /*
				  ANAGRAFICA PROF_DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_documento')) then
				    drop table tmp_prof_documento
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_prof_documento(
				    cod_caus_magazzino_prop char(15) null,
				    cod_prof_registrazione char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_sog_comm_prop char(15) null,
				    cod_sog_comm_fattura_prop char(15) null,
				    cod_linguaggio_prop char(15) null,
				    cod_lingua_prop char(15) null,
				    cod_valuta_prop char(15) null,
				    cod_listino_prop char(15) null,
				    cod_con_pagamento_prop char(15) null,
				    cod_sog_comm_vettore_1_prop char(15) null,
				    cod_magazzino_1 char(15) null,
				    cod_area_1 char(15) null,
				    corsia_1 char(15) null,
				    ripiano_1 char(15) null,
				    scaffale_1 char(15) null,
				    posizione_1 char(15) null,
				    cod_magazzino_2 char(15) null,
				    cod_area_2 char(15) null,
				    corsia_2 char(15) null,
				    ripiano_2 char(15) null,
				    scaffale_2 char(15) null,
				    posizione_2 char(15) null,
				    cod_caus_trasporto_prop char(15) null,
				    cod_sog_comm_vettore_2_prop char(15) null,
				    id_prof_documento integer not null,
				    id_caus_magazzino_prop integer null,
				    id_prof_registrazione integer null,
				    codice char(8) null,
				    descrizione char(40) null,
				    des_stampa char(40) null,
				    tipo_registro char(2) null,
				    ric_id_registro char(1) null,
				    ric_num_progressivo char(1) null,
				    id_mod_registro_prop integer null,
				    con_data_progressiva char(1) null,
				    ric_num_documento char(1) null default 'M',
				    note_intestazione_prop long varchar null,
				    ric_id_caus_magazzino char(1) null default 'M',
				    int_consentiti char(6) null,
				    ric_id_sog_comm char(1) null default 'M',
				    id_sog_comm_prop integer null,
				    ric_id_magazzino_1 char(1) null default 'M',
				    id_magazzino_1_prop integer null,
				    ric_id_magazzino_2 char(1) null default 'M',
				    id_magazzino_2_prop integer null,
				    ric_id_sog_comm_fattura char(1) null default 'M',
				    id_sog_comm_fattura_prop integer null,
				    ric_lingua_linguaggio char(1) null default 'M',
				    id_linguaggio_prop integer null,
				    id_lingua_prop integer null,
				    ric_id_valuta char(1) null default 'M',
				    id_valuta_prop integer null,
				    ric_id_listino char(1) null default 'M',
				    id_listino_prop integer null,
				    ric_id_con_pagamento char(1) null default 'M',
				    id_con_pagamento_prop integer null,
				    ric_scadenze char(1) null default 'M',
				    ric_id_sog_comm_agente char(1) null default 'M',
				    ric_provvigioni char(1) null default 'M',
				    ric_data_consegna char(1) null default 'M',
				    gg_consegna decimal(4) null,
				    ric_sconti_finanziari char(1) null default 'M',
				    spese_gestite char(15) null,
				    ric_acconti char(1) null default 'M',
				    ric_date_competenza char(1) null default 'M',
				    ric_colli_documento char(1) null default 'M',
				    ric_pesi char(1) null default 'M',
				    ric_volumi char(1) null default 'M',
				    ric_id_tipo_trasporto char(1) null default 'M',
				    ric_id_caus_trasporto char(1) null default 'M',
				    ric_asp_beni char(1) null default 'M',
				    aspetto_beni_prop char(40) null,
				    ric_trasp_mezzo char(1) null default 'M',
				    trasp_mezzo_prop char(1) null,
				    ric_id_sog_comm_vettore_1 char(1) null default 'M',
				    ric_id_sog_comm_vettore_2 char(1) null default 'M',
				    id_sog_comm_vettore_1_prop integer null,
				    ric_mezzo_trasporto char(1) null default 'M',
				    ric_data_trasporto char(1) null default 'M',
				    stampabile char(1) null,
				    stampa_immediata char(1) null,
				    ges_pac_list char(1) null,
				    ges_evas_parziale char(1) null,
				    ges_db char(1) null,
				    ges_matricole char(1) null,
				    con_dis_articoli char(1) null,
				    ges_chius_forzata char(1) null,
				    ges_stato_documento char(1) null,
				    tipo_raggruppamento char(1) null,
				    usa_int_fattura char(1) null,
				    contabilizzabile char(1) null,
				    des_contabile char(40) null,
				    ric_id_unita_confezione_riga char(1) null default 'M',
				    ric_quantita_riga char(1) null default 'M',
				    quantita_prop_riga decimal(18,4) null default 0,
				    ric_unita_base_riga char(1) null default 'M',
				    ric_unita_prezzo_riga char(1) null default 'M',
				    ric_id_caus_magazzino_riga char(1) null default 'M',
				    ric_locazione_1_riga char(1) null default 'M',
				    ric_locazione_2_riga char(1) null default 'M',
				    ric_data_prev_consegna_riga char(1) null default 'M',
				    ric_pesi_riga char(1) null default 'M',
				    ric_dim_riga char(1) null default 'M',
				    ric_colli_riga char(1) null default 'M',
				    ric_id_valuta_riga char(1) null default 'M',
				    ric_id_listino_riga char(1) null default 'M',
				    ric_prezzo_riga char(1) null default 'M',
				    ric_sconto_riga char(1) null default 'M',
				    ric_prezzo_netto_riga char(1) null default 'M',
				    ric_sconto_riga_riga char(1) null default 'M',
				    ric_id_tab_iva_riga char(1) null default 'M',
				    ric_id_sog_comm_agente_riga char(1) null default 'M',
				    ric_provvigioni_riga char(1) null default 'M',
				    ric_val_attribuito_riga char(1) null default 'M',
				    ric_date_competenza_riga char(1) null default 'M',
				    ric_contropartite_riga char(1) null default 'M',
				    evas_virtuale char(1) null,
				    stampa_bloccante char(1) null,
				    contr_esen_der char(1) null,
				    cambio_rical_der char(1) null,
				    stato_scad_generata char(1) null default 'N',
				    pas_di_sblocco char(20) null,
				    pas_chiu_forz char(20) null,
				    tipo_fattura char(1) null,
				    nome_report char(40) null,
				    id_azienda integer null default 1,
				    ric_tipo_fattura char(1) null default 'M',
				    id_locazione_1_prop integer null,
				    id_locazione_2_prop integer null,
				    ric_data_documento char(1) null default 'M',
				    fat_anticipo char(1) null,
				    id_caus_trasporto_prop integer null,
				    id_sog_comm_vettore_2_prop integer null,
				    ric_data_scadenza char(1) null default 'M',
				    gg_scadenza decimal(4) null,
				    non_vis_pag_trasporto char(1) null,
				    non_vis_pag_totali char(1) null,
				    non_vis_pag_contropartite char(1) null,
				    con_scorta_articoli char(1) null,
                    blocco_ricalcolo char(1) null, //17.10.07
                    cal_giac_costi char(1) null, //17.10.07
                    calc_prz_esp_dist char(1) null, //17.10.07
                    sal_automatico integer null, //17.10.07
                    arrot decimal(4,4) null default 0, //17.10.07
                    stampa_in_dett char(1) null, //17.10.07
                    archiviazione_report char(80) null, //17.10.07
                    nome_report_2 char(40) null, //17.10.07
                    stdoc_copie char(1) null, //17.10.07
                    tipo_invio_report char(1) null, //17.10.07
                    gest_doc_alt char(1) null, //17.10.07
                    prezzo_su_riga char(1) null, //17.10.07
                    usa_trasformazione char(1) null, //17.10.07
                    id_locazione_trasf integer null, //17.10.07
                    id_caus_magazzino_trasf integer null, //17.10.07
                    qta_su_riga char(1) null, //17.10.07
                    ult_costo_spese char(1) null, //17.10.07
                    no_ricalc_prz char(1) null, //17.10.07
                    abilita_canc char(1) null, //17.10.07
                    disabilita_rc char(1) null, //17.10.07
                    nuovo_dopo_stampa char(1) null, //17.10.07
                    crea_clis char(1) null, //17.10.07
                    tipo_min_doc char(1) null, //17.10.07
                    imp_min_doc decimal(18,2) null default 0, //17.10.07
                    usa_packing_list char(1) null, //17.10.07
				    primary key(id_prof_documento),
				    )  ;
				  load into table tmp_prof_documento from 'C:\\windows\\temp\\prof_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_documento;
				  //
				  message 'tabella PROF_DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA DESTINAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_destinazione')) then
				    drop table tmp_destinazione
				  end if
				  ;
				  //
				  create   table "dba".tmp_destinazione(
				    id_destinazione integer not null,
				    id_sog_commerciale integer null,
				    id_cat_attivita integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    tipo_destinazione char(1) null,
				    id_magazzino integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer null,
				    id_gruppo_Agenti_2 integer null,
				    id_con_pagamento integer null,
				    codice integer null,
                    data_prov_setup date null, //17.10.07
                    id_tab_iva integer null, //17.10.07
				    primary key(id_destinazione),
				    )  ;
				  //
				  load into table tmp_destinazione from 'C:\\windows\\temp\\destinazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_destinazione;
				  //
				  message 'tabella TMP DESTINAZIONE record trasferiti:'+string(@li_record);
				  //
				  // CODIFICA ARTICOLI # I
				  /*
				  ANAGRAFICA SCOMPOSIZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scomposizione')) then
				    drop table tmp_scomposizione
				  end if
				  ;
				  //
				  create   table "dba".tmp_scomposizione(
				    id_scomposizione integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_scomposizione),
				    )  ;
				  //
				  load into table tmp_scomposizione from 'C:\\windows\\temp\\scomposizione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scomposizione;
				  //
				  message 'tabella TMP SCOMPOSIZIONE record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA CAT_CODIFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_codifica')) then
				    drop table tmp_cat_codifica
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_codifica(
				    id_cat_codifica integer not null,
				    codice char(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lun_fissa char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_codifica),
				    )  ;
				  //
				  load into table tmp_cat_codifica from 'C:\\windows\\temp\\cat_codifica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_codifica;
				  //
				  message 'tabella TMP CAT_CODIFICA record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA PARTE_REGOLA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_parte_regola')) then
				    drop table tmp_parte_regola
				  end if
				  ;
				  //
				  create   table "dba".tmp_parte_regola(
				    id_parte_regola integer not null,
				    num_sezione decimal(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lunghezza decimal(4) not null,
				    progressivo char(1) null,
				    variante char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_parte_regola),
				    )  ;
				  //
				  load into table tmp_parte_regola from 'C:\\windows\\temp\\parte_regola.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_parte_regola;
				  //
				  message 'tabella TMP PARTE_REGOLA record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA COD_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cod_parte')) then
				    drop table tmp_cod_parte
				  end if
				  ;
				  //
				  create   table "dba".tmp_cod_parte(
				    id_cod_parte integer not null,
				    id_cat_codifica integer null,
				    id_parte_regola integer null,
				    mas_input char(32) null,
				    tipo_richiesta char(1) null default 'R',
				    val_proposto char(32) null,
				    car_riempimento char(1) null,
				    solo_in_elenco char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cod_parte),
				    )  ;
				  //
				  load into table tmp_cod_parte from 'C:\\windows\\temp\\cod_parte.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cod_parte;
				  //
				  message 'tabella TMP COD_PARTE record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SCELTA_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scelta_parte')) then
				    drop table tmp_scelta_parte
				  end if
				  ;
				  //
				  create   table "dba".tmp_scelta_parte(
				    id_scelta_parte integer not null,
				    id_cod_parte integer not null,
				    scelta char(32) null,
				    descrizione char(40) null,
                    art_par char(1) null, //17.10.07
				    primary key(id_scelta_parte),
				    )  ;
				  //
				  load into table tmp_scelta_parte from 'C:\\windows\\temp\\scelta_parte.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scelta_parte;
				  //
				  message 'tabella TMP SCELTA_PARTE record importati'+string(@li_record);
				  //
				  // CODIFICA ARTICOLI # F
				  //
				  //
				  /*
				  ANAGRAFICA CAT_COM_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_articolo')) then
				    drop table tmp_cat_com_articolo
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_com_articolo(
				    id_cat_com_articolo integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_tab_iva integer not null default autoincrement,
				    id_azienda integer not null default 1,
                    cod_intrastat char(40) null, //17.10.07
				    primary key(id_cat_com_articolo),
				    )  ;
				  //
				  load into table tmp_cat_com_articolo from 'C:\\windows\\temp\\cat_com_articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_articolo;
				  //
				  message 'tabella TMP CAT_COM_ARTICOLO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REG_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reg_fiscale')) then
				    drop table tmp_reg_fiscale
				  end if
				  ;
				  //
				  create   table "dba".tmp_reg_fiscale(
				    id_reg_fiscale integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_reg_fiscale),
				    )  ;
				  //
				  load into table tmp_reg_fiscale from 'C:\\windows\\temp\\reg_fiscale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reg_fiscale;
				  //
				  message 'tabella TMP REG_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_MERCEOLOGICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_merceologica')) then
				    drop table tmp_cat_merceologica
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_merceologica(
				    id_cat_merceologica integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_reg_fiscale integer null,
				    id_cat_mer_superiore integer null,
				    id_anag_modello integer null,
				    id_tipo_parte integer null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_merceologica),
				    )  ;
				  //
				  load into table tmp_cat_merceologica from 'C:\\windows\\temp\\cat_merceologica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_merceologica;
				  //
				  message 'tabella TMP CAT_MERCEOLOGICA record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_fiscale')) then
				    drop table tmp_cat_fiscale
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_fiscale(
				    id_cat_fiscale integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    primary key(id_cat_fiscale),
				    )  ;
				  //
				  load into table tmp_cat_fiscale from 'C:\\windows\\temp\\cat_fiscale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_fiscale;
				  //
				  message 'tabella TMP CAT_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA GRUPPO_ARTICOLI
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_articoli')) then
				    drop table tmp_gruppo_articoli
				  end if
				  ;
				  //
				  create   table "dba".tmp_gruppo_articoli(
				    id_gruppo_articoli integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_gruppo_articoli),
				    )  ;
				  //
				  load into table tmp_gruppo_articoli from 'C:\\windows\\temp\\gruppo_articoli.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_articoli;
				  //
				  message 'tabella TMP GRUPPO_ARTICOLI record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REPARTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reparto')) then
				    drop table tmp_reparto
				  end if
				  ;
				  //
				  create   table "dba".tmp_reparto(
				    id_reparto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_reparto),
				    )  ;
				  //
				  load into table tmp_reparto from 'C:\\windows\\temp\\reparto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reparto;
				  //
				  message 'tabella TMP REPARTO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA UNITA_CONF_BASE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_conf_base')) then
				    drop table tmp_unita_conf_base
				  end if
				  ;
				  //
				  create   table "dba".tmp_unita_conf_base(
				    id_unita_conf_base integer not null,
				    codice char(8) not null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) not null,
				    fat_conversione decimal(8,4) not null,
				    tipo_conversione char(1) not null,
				    molteplicita decimal(18,4) null default 1,
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null default 'S',
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null default 'S',
				    unita_produzione char(1) null,
				    id_azienda integer not null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    id_articolo integer null,
				    primary key(id_unita_conf_base),
				    )  ; //
				  load into table tmp_unita_conf_base from 'C:\\windows\\temp\\unita_conf_base.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_conf_base;
				  //
				  message 'tabella TMP UNITA_CONF_BASE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cif')) then
				    drop table tmp_cif
				  end if
				  ;
				  //
				  create   table "dba".tmp_cif(
				    id_cif integer not null,
				    codice char(8) not null,
				    cambio decimal(8,4) null,
				    coefficiente decimal(5,2) null,
				    id_azienda integer not null default 1,
				    primary key(id_cif), //
				    )  ;
				  load into table tmp_cif from 'C:\\windows\\temp\\cif.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cif;
				  //
				  message 'tabella TMP CIF record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA SPESA_CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_cif')) then
				    drop table tmp_spesa_cif
				  end if
				  ;
				  //
				  create   table "dba".tmp_spesa_cif(
				    id_cif integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    primary key(id_cif,
				    id_spesa),
				    )  ;
				  load into table tmp_spesa_cif from 'C:\\windows\\temp\\spesa_cif.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_cif;
				  //
				  message 'tabella TMP SPESA_CIF record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_articolo')) then
				    drop table tmp_articolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_articolo(
				    id_articolo integer not null,
				    id_cat_codifica integer null,
				    codice char(32) null,
				    descrizione char(80) null,
				    immagine char(255) null,
				    rif_catalogo char(20) null,
				    id_cat_com_articolo integer null,
				    id_cat_merceologica integer null,
				    id_cat_fiscale integer null,
				    id_gruppo_articoli integer null,
				    des_breve char(40) null,
				    id_reparto integer null,
				    id_anagrafica integer null,
				    id_sog_commerciale integer null,
				    id_tab_iva integer null,
				    cod_intrastat char(40) null,
				    data_ora_creazione timestamp null default getdate(*),
				    data_ora_ult_cambiamento timestamp null default getdate(*),
				    data_ora_ult_var_stato timestamp null default getdate(*),
				    stampa_in_inventario char(1) null default 'S',
				    stampa_in_listini char(1) null default 'S',
				    stampa_in_giornale char(1) null default 'S',
				    stampa_in_schede char(1) null default 'S',
				    ges_lotti char(1) null default 'N',
				    ges_matricole char(1) null default 'N',
				    ges_produzione char(1) null default 'N',
				    note long varchar null,
				    utilizzabile char(1) null,
				    stato char(1) null,
				    ges_locazioni char(1) null,
				    giorni_invenduto decimal(4) null,
				    id_azienda integer null default 1,
				    id_cif integer null,
				    costo_aggiuntivo decimal(18,4) null,
				    id_valuta integer null,
				    id_unita_conf_base integer null,
				    prod_interna char(1) null,
				    id_sog_comm_variante integer null,
				    stampa_in_catalogo char(1) null default 'S',
				    giorni_durata integer null,
                    id_art_imballo integer null, //17.10.07
				    primary key(id_articolo),
				    )  ;
				  //
				  create unique index xak1tmp_articolo on
				    "dba".tmp_articolo(codice asc,id_azienda asc);
				  //
				  load into table tmp_articolo from 'C:\\windows\\temp\\articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_articolo;
				  //
				  message 'tabella ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA UNITA_CONFEZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_confezione')) then
				    drop table tmp_unita_confezione
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_unita_confezione(
				    id_unita_confezione integer not null,
				    id_articolo integer null,
				    codice char(8) null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) null,
				    fat_conversione decimal(8,4) null,
				    tipo_conversione char(1) null,
				    molteplicita decimal(20,12) null default 0, //17.10.07
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null,
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null,
				    unita_produzione char(1) null,
				    id_azienda integer null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    primary key(id_unita_confezione),
				    )  ;
				  //
				  create unique index xak1tmp_unita_confezione on
				    "dba".tmp_unita_confezione(id_articolo asc,codice asc);
				  //
				  load into table tmp_unita_confezione from 'C:\\windows\\temp\\unita_confezione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_confezione;
				  //
				  message 'tabella UNITA_CONFEZIONE record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA DES_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_des_articolo')) then
				    drop table tmp_des_articolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_des_articolo(
				    id_des_articolo integer not null,
				    id_articolo integer null,
				    id_sog_commerciale integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    codice char(32) null,
				    descrizione char(40) null,
				    des_estesa long varchar null,
				    id_azienda integer null default 1,
				    primary key(id_des_articolo),
				    )  ;
				  //
				  create unique index tmp_des_articolo_ak001 on
				    "dba".tmp_des_articolo(id_articolo asc,id_sog_commerciale asc,id_lingua asc,id_linguaggio asc);
				  //
				  load into table tmp_des_articolo from 'C:\\windows\\temp\\des_articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_des_articolo;
				  //
				  message 'tabella DES_ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA GRUPPO_AGENTI
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_agenti')) then
				    drop table tmp_gruppo_agenti
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_gruppo_agenti(
				    id_gruppo_agenti integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    id_sog_com_capo_area integer null,
				    id_sog_com_agente integer null,
				    id_sog_com_sub_agente integer null,
				    sconto_riga char(1) null,
				    sconto_finanziario char(1) null,
				    sconto_fin_cassa char(1) null,
				    sconto_fin_incondizionato char(1) null,
				    rip_per_fatturato decimal(5,2) null,
				    rip_per_incassato decimal(5,2) null,
				    mod_liq_provvigione char(1) null,
				    id_azienda integer null default 1,
				    inc_ult_elab decimal(5,2) null,
				    fat_ult_elab decimal(5,2) null,
				    primary key(id_gruppo_agenti),
				    )  ;
				  //
				  create unique index tmp_gruppo_agentiak001 on
				    "dba".tmp_gruppo_agenti(codice asc,id_azienda asc);
				  //
				  load into table tmp_gruppo_agenti from 'C:\\windows\\temp\\gruppo_agenti.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_agenti;
				  //
				  message 'tabella GRUPPO_AGENTI record trasferiti:'+string(@li_record);
				  //  
				  //  
				  //      
				  /*
				  ANAGRAFICA PROF_REGISTRAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_registrazione')) then
				    drop table tmp_prof_registrazione
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_prof_registrazione(
				    id_prof_registrazione integer not null default autoincrement,
				    codice char(8) not null,
				    descrizione char(40) null,
				    tipo_registrazione char(1) not null,
				    id_mod_registro integer not null,
				    id_valuta integer null,
				    id_tab_iva integer null,
				    id_conto_iva integer null,
				    des_contabile char(40) null,
				    ges_oper_intracomunitarie char(1) null,
				    usa_pagamenti char(1) null,
				    usa_con_effetti char(1) null,
				    usa_insoluti char(1) null,
				    crea_partita char(1) null,
				    tipo_fattura char(1) null default 'N',
				    id_azienda integer not null default 1,
                    usa_ratei char(1) null, //17.10.07
				    primary key(id_prof_registrazione),
				    )  ;
				  //
				  create unique index xak1tmp_prof_registrazione on
				    "dba".tmp_prof_registrazione(codice asc,id_azienda asc);
				  //
				  load into table tmp_prof_registrazione from 'C:\\windows\\temp\\prof_registrazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_registrazione;
				  //
				  message 'tabella TMP_PROF_REGISTRAZIONE record trasferiti:'+string(@li_record);
				  //    
				  //  
				  //      
				  /*
				  ANAGRAFICA SPESA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa')) then
				    drop table tmp_spesa
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_spesa(
				    id_spesa integer not null default autoincrement,
				    codice char(1) not null,
				    descrizione char(40) null,
				    tipo_importo char(1) null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
				    id_conto_acquisti integer not null,
				    id_conto_vendite integer not null,
				    segue_esenzione char(1) null,
				    mod_cal_iva char(1) null,
                    id_valuta integer null, //17.10.07
				    primary key(id_spesa),
				    )  ;
				  //
				  create unique index xak1tmp_spesa on
				    "dba".TMP_spesa(codice asc);
				  //
				  load into table tmp_spesa from 'C:\\windows\\temp\\spesa.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa;
				  //
				  message 'tabella TMP_SPESA record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //      
				  /*
				  ANAGRAFICA BANCA_APPOGGIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_appoggio')) then
				    drop table tmp_banca_appoggio
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_banca_appoggio(
				    id_banca_appoggio integer not null,
				    cod_abi char(5) null,
				    den_abi char(40) null,
				    cod_cab char(5) null,
				    den_cab char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null default 'IT',
				    filiale char(40) null,
				    con_interbancaria char(1) null,
				    giorni_franchigia decimal(3) null,
				    primary key(id_banca_appoggio),
				    )  ;
				  //
				  create unique index xak1tmp_banca_appoggio on
				    "dba".tmp_banca_appoggio(cod_abi asc,cod_cab asc);
				  //
				  load into table tmp_banca_appoggio from 'C:\\windows\\temp\\banca_appoggio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_appoggio;
				  //
				  message 'tabella TMP_BANCA_APPOGGIO record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //      
				  /*
				  ANAGRAFICA BANCA_SOG_COMMERCIALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_sog_commerciale')) then
				    drop table tmp_banca_sog_commerciale
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_banca_sog_commerciale(
				    id_banca_sog_commerciale integer not null default autoincrement,
				    id_anagrafica integer null,
				    id_banca_appoggio integer not null,
				    conto_corrente char(20) null,
				    cin char(1) null,
				    modo_uso char(1) not null,
				    id_azienda integer not null default 1,
                    iban_nazione char(2) null, //17.10.07
                    iban_contr_internazionale char(2) null, //17.10.07
				    primary key(id_banca_sog_commerciale),
				    )  ;
				  //
				  create index xif107tmp_banca_sog_commerciale on
				    "dba".tmp_banca_sog_commerciale(id_banca_appoggio asc);
				  //
				  load into table tmp_banca_sog_commerciale from 'C:\\windows\\temp\\banca_sog_commerciale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_sog_commerciale;
				  //
				  message 'tabella TMP_BANCA_SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //        
				  message 'FINE LOAD ... ';
				  //
				  message 'INIZIO CREAZIONE INDICI PK  ... ';
				  //
				  create index xpk_tmp_anagrafica on tmp_anagrafica(id_anagrafica asc);
				  create index xpk_tmp_area on tmp_area(id_area asc);
				  create index xpk_tmp_articolo on tmp_articolo(id_articolo asc);
				  create index xpk_tmp_att_svolta on tmp_att_svolta(id_att_svolta asc);
				  create index xpk_tmp_banca_appoggio on tmp_banca_appoggio(id_banca_appoggio asc);
				  create index xpk_tmp_banca_sog_commerciale on tmp_banca_sog_commerciale(id_banca_sog_commerciale asc);
				  create index xpk_tmp_bilancio_cee on tmp_bilancio_cee(id_bilancio_cee asc);
				  create index xpk_tmp_cat_attivita on tmp_cat_attivita(id_cat_attivita asc);
				  create index xpk_tmp_cat_codifica on tmp_cat_codifica(id_cat_codifica asc);
				  create index xpk_tmp_cat_com_articolo on tmp_cat_com_articolo(id_cat_com_articolo asc);
				  create index xpk_tmp_cat_com_sc on tmp_cat_com_sc(id_cat_com_sc asc);
				  create index xpk_tmp_cat_fiscale on tmp_cat_fiscale(id_cat_fiscale asc);
				  create index xpk_tmp_cat_merceologica on tmp_cat_merceologica(id_cat_merceologica asc);
				  create index xpk_tmp_cat_zona on tmp_cat_zona(id_cat_zona asc);
				  create index xpk_tmp_caus_magazzino on tmp_caus_magazzino(id_caus_magazzino asc);
				  create index xpk_tmp_caus_trasporto on tmp_caus_trasporto(id_caus_trasporto asc);
				  create index xpk_tmp_cif on tmp_cif(id_cif asc);
				  create index xpk_tmp_cod_parte on tmp_cod_parte(id_cod_parte asc);
				  create index xpk_tmp_con_pagamento on tmp_con_pagamento(id_con_pagamento asc);
				  create index xpk_tmp_conto on tmp_conto(id_conto asc);
				  create index xpk_tmp_des_articolo on tmp_des_articolo(id_des_articolo asc);
				  create index xpk_tmp_destinazione on tmp_destinazione(id_destinazione asc);
				  create index xpk_tmp_esercizio on tmp_esercizio(id_esercizio asc);
				  create index xpk_tmp_gruppo on tmp_gruppo(id_gruppo asc);
				  create index xpk_tmp_gruppo_agenti on tmp_gruppo_agenti(id_gruppo_agenti asc);
				  create index xpk_tmp_gruppo_articoli on tmp_gruppo_articoli(id_gruppo_articoli asc);
				  create index xpk_tmp_lingua on tmp_lingua(id_lingua asc);
				  create index xpk_tmp_linguaggio on tmp_linguaggio(id_linguaggio asc);
				  create index xpk_tmp_listino on tmp_listino(id_listino asc);
				  create index xpk_tmp_locazione on tmp_locazione(id_locazione asc);
				  create index xpk_tmp_magazzino on tmp_magazzino(id_magazzino asc);
				  create index xpk_tmp_mastro on tmp_mastro(id_mastro asc);
				  create index xpk_tmp_mod_registro on tmp_mod_registro(id_mod_registro asc);
				  create index xpk_tmp_parte_regola on tmp_parte_regola(id_parte_regola asc);
				  create index xpk_tmp_pdc on tmp_pdc(id_pdc asc);
				  create index xpk_tmp_prof_documento on tmp_prof_documento(id_prof_documento asc);
				  create index xpk_tmp_prof_registrazione on tmp_prof_registrazione(id_prof_registrazione asc);
				  create index xpk_tmp_reg_fiscale on tmp_reg_fiscale(id_reg_fiscale asc);
				  create index xpk_tmp_registro on tmp_registro(id_registro asc);
				  create index xpk_tmp_reparto on tmp_reparto(id_reparto asc);
				  create index xpk_tmp_scelta_parte on tmp_scelta_parte(id_scelta_parte asc);
				  create index xpk_tmp_scomposizione on tmp_scomposizione(id_scomposizione asc);
				  create index xpk_tmp_sog_commerciale on tmp_sog_commerciale(id_sog_commerciale asc);
				  create index xpk_tmp_sottomastro on tmp_sottomastro(id_sottomastro asc);
				  create index xpk_tmp_spesa on tmp_spesa(id_spesa asc);
				  create index xpk_tmp_tab_attivita on tmp_tab_attivita(id_tab_attivita asc);
				  create index xpk_tmp_tab_iva on tmp_tab_iva(id_tab_iva asc);
				  create index xpk_tmp_tipo_magazzino on tmp_tipo_magazzino(id_tipo_magazzino asc);
				  create index xpk_tmp_tipo_pagamento on tmp_tipo_pagamento(id_tipo_pagamento asc);
				  create index xpk_tmp_tipo_trasporto on tmp_tipo_trasporto(id_tipo_trasporto asc);
				  create index xpk_tmp_titolo on tmp_titolo(id_titolo asc);
				  create index xpk_tmp_tributo on tmp_tributo(id_tributo asc);
				  create index xpk_tmp_unita_conf_base on tmp_unita_conf_base(id_unita_conf_base asc);
				  create index xpk_tmp_unita_confezione on tmp_unita_confezione(id_unita_confezione asc);
				  create index xpk_tmp_unita_misura on tmp_unita_misura(id_unita_misura asc);
				  create index xpk_tmp_valuta on tmp_valuta(id_valuta asc);
				  create index xpk_tmp_variazione on tmp_variazione(id_variazione asc);
				  //
				  message 'FINE CREAZIONE INDICI PK  ... '
				//
				end;				
        
end if;         
///////////////////////////



//DESTINAZIONE - STATO
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'destinazione'
        AND      CNAME = 'stato_utilizzo' )) THEN 
        
	ALTER  TABLE "dba"."destinazione" add "stato_utilizzo" char(1) DEFAULT 'S';
	update destinazione set stato_utilizzo='S';
end if; 
////////////////////


ALTER PROCEDURE "DBA"."fn_ins_voce_menu"(@des_padre char(40), @oggetto char(40),@des_oggetto char(40),@ordine integer) /* parameters,... */
as
begin
 
  declare @li_id_oggetto integer,
  @id_voce_padre integer,
  @id_menu integer,
  @conta integer,
  @li_return integer,
  @li_app integer,
  @ll_esiste integer,
  @li_sqlstatus integer,
  @li_id_ogg_app integer
  message 'aa'||string(@des_padre)
  if not(@des_padre is null) and @des_padre<>''
    begin
      declare cur_menu dynamic scroll cursor for select voci_menu.id_voci_menu
          from voci_menu where vmenu_voce=@des_padre
      open cur_menu
      select @li_sqlstatus=0
      select @conta=0
      /**/
      while @li_sqlstatus=0 and @conta<5
        begin
          fetch next cur_menu into @id_voce_padre
          select @li_sqlstatus=@@sqlstatus
          select @conta=@conta + 1
          if(@li_sqlstatus=0)
            begin
              if not(@id_voce_padre is null)
                select @li_return=1
              else
                select @li_return=0
              if(@li_return=1)
                begin
                  message 'ID voce padre:'||string(@id_voce_padre)
                  message 'Oggetto:'||string(@oggetto)
                  //Inserisco sotto voce menu
                  if (@oggetto is null) or (@oggetto='')
                    begin
                      select @li_id_ogg_app=id_voci_menu
                      from voci_menu
                      where vmenu_voce=@des_oggetto
                      message 'sotto menu:'||string(@li_id_ogg_app)
                      if @li_id_ogg_app is null                          
                            insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) values(
                            @id_voce_padre,@des_oggetto,null,@ordine)
                    end
                  /**/
                  else
                     begin
                       select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       if @li_id_oggetto is null
                          begin
                          insert into oggetti (ogg_oggetto) values (@oggetto)
                          select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       end 
                      
                      Select @ll_esiste=max(id_voci_menu) from voci_menu
                      where id_oggetti=@li_id_oggetto and id_voci_menu_padre=@id_voce_padre
                      and vmenu_voce=@des_oggetto
                      message 'hh'||string(@ll_esiste)
                      if @ll_esiste is null
                         begin
                         insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) values(
                         @id_voce_padre,@des_oggetto,@li_id_oggetto,@ordine)
                      end 
                  end  
              end
          end
        end
        close cur_menu
    end
end;






////BILANCIO CEE

DELETE from voci_menu where id_voci_menu_padre in  (select id_voci_menu from voci_menu where vmenu_voce='Gestione PDC CEE');

call fn_ins_voce_menu('Gestione PDC CEE', 'W_test_bilancio_cee_ff', 'Gestione PDC CEE', 5);
call fn_ins_voce_menu('Gestione PDC CEE', 'W_verifica_bil_cee_cx', 'Verifica Saldi Bilancio', 10);
call fn_ins_voce_menu('Gestione PDC CEE', 'W_ins_rif_bil_cee_lt', 'Inserimento Riferimenti CEE', 15);
call fn_ins_voce_menu('Gestione PDC CEE', 'W_test_stampa_riferimenti_rpt', 'Stampa Riferimenti CEE', 20);




//BILANCIO CEE

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'bilancio_cee'
        AND      CNAME = 'prefisso' )) THEN 
        

drop TABLE "dba"."bilancio_cee";
CREATE TABLE "dba"."bilancio_cee" ("id_bilancio_cee" integer NOT NULL DEFAULT autoincrement, "descrizione" varchar(80) DEFAULT NULL, "riferimento" numeric(5,0) NOT NULL DEFAULT NULL, "tipo" char(2) DEFAULT NULL, "prefisso" char(8) DEFAULT NULL, "posizione" char(4) DEFAULT NULL, "flag" char(1) DEFAULT NULL, "saldo1" numeric(18,4) DEFAULT NULL, "saldo2" numeric(18,4) DEFAULT NULL, "id_bil_padre" integer DEFAULT NULL , PRIMARY KEY ("id_bilancio_cee")) ;

insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (1,'Crediti verso soci per versamenti ancora dovuti',0,'A','A)','001','A',0.0000,0.0000,873);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (3,'Da richiamare',2,'A',null,'003','N',0.0000,0.0000,1);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (5,'Immobilizzazioni Immateriali',0,'A','I -','005','B',0.0000,0.0000,4);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (7,'Costi di ricerca, di sviluppo e di pubblicit',4,'A','2)','007','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (9,'Concessioni, licenze, marchi e diritti simili',6,'A','4)','009','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (11,'Immobilizzazioni in corso e acconti',8,'A','6)','011','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (13,'Immobilizzazioni materiali',0,'A','II -','013','B',0.0000,0.0000,4);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (15,'Costo Storico',10,'A',null,'015','N',0.0000,0.0000,14);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (17,'Investimenti da reddito',12,'A',null,'017','N',0.0000,0.0000,14);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (19,'Impianti e macchinari',0,'A','2)','019','C',0.0000,0.0000,13);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (21,'Fondi ammortamento',15,'A',null,'021','N',0.0000,0.0000,19);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (23,'Costo Storico',16,'A',null,'023','N',0.0000,0.0000,22);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (25,'Altri beni',0,'A','4)','025','C',0.0000,0.0000,13);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (27,'Fondi ammortamento',19,'A',null,'027','N',0.0000,0.0000,25);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (29,'Beni acquisiti in leasing',20,'A',null,'029','N',0.0000,0.0000,28);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (31,'Partecipazioni in:',0,'A','1)','031','C',0.0000,0.0000,30);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (33,'Imprese collegate',22,'A','b)','033','N',0.0000,0.0000,31);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (35,'Altre imprese',24,'A','d)','035','N',0.0000,0.0000,31);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (37,'Verso imprese controllate',0,'A','a)','037','D',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (39,'Oltre 12 mesi',26,'A',null,'039','N',0.0000,0.0000,37);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (41,'Entro 12 mesi',27,'A',null,'041','N',0.0000,0.0000,40);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (43,'Verso controllanti',0,'A','c)','043','N',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (45,'Oltre 12 mesi',30,'A',null,'045','N',0.0000,0.0000,43);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (47,'Entro 12 mesi',31,'A',null,'047','N',0.0000,0.0000,46);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (49,'Altri titoli',33,'A','3)','049','N',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (51,'Attivo circolante',0,'A','C)','051','A',0.0000,0.0000,873);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (53,'Materie prime, sussidiarie e di consumo',35,'A','1)','053','N',0.0000,0.0000,52);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (55,'Lavori in corso su ordinazione',37,'A','3)','055','N',0.0000,0.0000,52);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (57,'Acconti',39,'A','5)','057','N',0.0000,0.0000,52);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (59,'Verso clienti',0,'A','1)','059','C',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (61,'Oltre 12 mesi',41,'A',null,'061','N',0.0000,0.0000,59);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (63,'Entro 12 mesi',42,'A',null,'063','N',0.0000,0.0000,62);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (65,'Verso imprese collegate',0,'A','3)','065','C',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (67,'Oltre 12 mesi',45,'A',null,'067','N',0.0000,0.0000,65);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (69,'Entro 12 mesi',46,'A',null,'069','N',0.0000,0.0000,68);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (71,'Crediti tributari',48,'A','4-bis)','071','N',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (73,'Verso altri',0,'A','5)','073','C',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (75,'Oltre 12 mesi',51,'A',null,'075','N',0.0000,0.0000,73);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (77,'Attivit finanziarie',0,'A','III -','077','B',0.0000,0.0000,51);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (79,'Partecipazione in imprese collegate',54,'A','2)','079','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (81,'Altre partecipazioni',56,'A','4)','081','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (83,'Altri titoli',58,'A','6)','083','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (85,'Depositi bancari e postali',59,'A','1)','085','N',0.0000,0.0000,84);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (87,'Denaro e valori in cassa',61,'A','3)','087','N',0.0000,0.0000,84);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (89,'Ratei attivi della gestione operativa',62,'A',null,'089','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (91,'Risconti attivi a b/t',64,'A',null,'091','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (93,'Risconti attivi della gestione non operativa',66,'A',null,'093','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (95,'Patrimonio netto',0,'B','A)','096','A',0.0000,0.0000,874);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (97,'Riserva da sopraprezzo delle azioni',69,'B','II -','098','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (99,'Riserva legale',71,'B','IV -','100','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (101,'Riserve statuarie',73,'B','VI -','102','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (103,'Utili (perdite) portati a nuovo',75,'B','VIII -','104','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (105,'Quota dell''utile a riserva',76,'B',null,'106','N',0.0000,0.0000,104);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (107,'Risultato delle operazioni di leasing',78,'B',null,'108','N',0.0000,0.0000,104);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (109,'Per trattamento di quiescenza e obblighi simili',79,'B','1)','110','N',0.0000,0.0000,108);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (111,'Entro 12 mesi',80,'B',null,'112','N',0.0000,0.0000,110);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (113,'Altri',0,'B','3)','114','C',0.0000,0.0000,108);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (115,'Oltre 12 mesi',83,'B',null,'116','N',0.0000,0.0000,113);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (117,'Entro 12 mesi',84,'B',null,'118','N',0.0000,0.0000,116);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (119,'Debiti',0,'B','D)','120','A',0.0000,0.0000,874);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (121,'Entro 12 mesi',86,'B',null,'122','N',0.0000,0.0000,120);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (123,'Obbligazioni convertibili',0,'B','2)','124','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (125,'Oltre 12 mesi',89,'B',null,'126','N',0.0000,0.0000,123);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (127,'Entro 12 mesi',90,'B',null,'128','N',0.0000,0.0000,126);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (129,'Debiti verso banche',0,'B','4)','130','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (131,'Oltre 12 mesi',93,'B',null,'132','N',0.0000,0.0000,129);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (133,'Entro 12 mesi',94,'B',null,'134','N',0.0000,0.0000,132);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (135,'Acconti',96,'B','6)','136','N',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (137,'Entro 12 mesi',97,'B',null,'138','N',0.0000,0.0000,136);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (139,'di cui per iva',99,'B',null,'140','N',0.0000,0.0000,136);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (141,'Entro 12 mesi',100,'B',null,'142','N',0.0000,0.0000,140);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (143,'Debiti verso imprese controllate',0,'B','9)','144','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (145,'Entro 12 mesi',102,'B',null,'146','N',0.0000,0.0000,144);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (147,'Non finanziari',0,'B',null,'148','D',0.0000,0.0000,143);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (149,'Oltre 12 mesi',105,'B',null,'150','N',0.0000,0.0000,147);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (151,'Finanziari',0,'B',null,'152','D',0.0000,0.0000,150);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (153,'Oltre 12 mesi',107,'B',null,'154','N',0.0000,0.0000,151);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (155,'Entro 12 mesi',108,'B',null,'156','N',0.0000,0.0000,154);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (157,'Debiti verso controllanti',0,'B','11)','158','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (159,'Entro 12 mesi',110,'B',null,'160','N',0.0000,0.0000,158);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (161,'Non finanziari',0,'B',null,'162','D',0.0000,0.0000,157);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (163,'Oltre 12 mesi',113,'B',null,'164','N',0.0000,0.0000,161);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (165,'Entro 12 mesi',114,'B',null,'166','N',0.0000,0.0000,164);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (167,'Debiti verso istituti di previdenza e sicurezza sociale',0,'B','13)','168','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (169,'Oltre 12 mesi',117,'B',null,'170','N',0.0000,0.0000,167);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (171,'Entro 12 mesi',118,'B',null,'172','N',0.0000,0.0000,170);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (173,'Debiti verso societ di leasing',0,'B',null,'174','C',0.0000,0.0000,170);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (175,'Oltre 12 mesi',121,'B',null,'176','N',0.0000,0.0000,173);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (177,'Ratei passivi della gestione operativa',122,'B',null,'178','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (179,'Risconti passivi a b/t',124,'B',null,'180','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (181,'Aggio su prestiti',126,'B',null,'182','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (2,'Richiamati',1,'A',null,'002','N',0.0000,0.0000,1);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (4,'Immobilizzazioni',0,'A','B)','004','A',0.0000,0.0000,873);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (6,'Costi di impianto e di ampliamento',3,'A','1)','006','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (8,'Diritti di brevetto industriale e utilizzazione delle opere dell''ingegno',5,'A','3)','008','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (10,'Avviamento',7,'A','5)','010','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (12,'Altre',9,'A','7)','012','N',0.0000,0.0000,5);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (14,'Terreni e fabbricati',0,'A','1)','014','C',0.0000,0.0000,13);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (16,'Fondi ammortamento',11,'A',null,'016','N',0.0000,0.0000,14);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (18,'Fondi di ammortamento',13,'A',null,'018','N',0.0000,0.0000,14);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (20,'Costo Storico',14,'A',null,'020','N',0.0000,0.0000,19);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (22,'Attrezzature Industriali e commerciali',0,'A','3)','022','C',0.0000,0.0000,13);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (24,'Fondi ammortamento',17,'A',null,'024','N',0.0000,0.0000,22);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (26,'Costo Storico',18,'A',null,'026','N',0.0000,0.0000,25);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (28,'Immobilizzazioni in corso e acconti',0,'A','5)','028','C',0.0000,0.0000,13);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (30,'Immobilizzazioni Finanziarie',0,'A','III -','030','B',0.0000,0.0000,4);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (32,'Imprese controllate',21,'A','a)','032','N',0.0000,0.0000,31);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (34,'Imprese controllanti',23,'A','c)','034','N',0.0000,0.0000,31);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (36,'Crediti',0,'A','2)','036','C',0.0000,0.0000,30);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (38,'Entro 12 mesi',25,'A',null,'038','N',0.0000,0.0000,37);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (40,'Verso imprese collegate',0,'A','b)','040','D',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (42,'Oltre 12 mesi',28,'A',null,'042','N',0.0000,0.0000,40);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (44,'Entro 12 mesi',29,'A',null,'044','N',0.0000,0.0000,43);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (46,'Verso altri',0,'A','d)','046','N',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (48,'Oltre 12 mesi',32,'A',null,'048','N',0.0000,0.0000,46);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (50,'Azioni proprie',34,'A','4)','050','N',0.0000,0.0000,36);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (52,'Rimanenze',0,'A','I -','052','B',0.0000,0.0000,51);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (54,'Prodotti in corso di lavorazione e semilavorati',36,'A','2)','054','N',0.0000,0.0000,52);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (56,'Prodotti finiti e merci',38,'A','4)','056','N',0.0000,0.0000,52);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (58,'Crediti',0,'A','II -','058','B',0.0000,0.0000,51);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (60,'Entro 12 mesi',40,'A',null,'060','N',0.0000,0.0000,59);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (62,'Verso imprese controllate',0,'A','2)','062','C',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (64,'Oltre 12 mesi',43,'A',null,'064','N',0.0000,0.0000,62);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (66,'Entro 12 mesi',44,'A',null,'066','N',0.0000,0.0000,65);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (68,'Verso controllanti',0,'A','4)','068','C',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (70,'Oltre 12 mesi',47,'A',null,'070','N',0.0000,0.0000,68);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (72,'Imposte anticipate',49,'A','4-ter)','072','N',0.0000,0.0000,58);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (74,'Entro 12 mesi',50,'A',null,'074','N',0.0000,0.0000,73);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (76,'Acconti per servizi',52,'A',null,'076','N',0.0000,0.0000,73);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (78,'Partecipazione in imprese controllate',53,'A','1)','078','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (80,'Partecipazione in imprese cntrollanti',55,'A','3)','080','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (82,'Azioni proprie',57,'A','5)','082','N',0.0000,0.0000,77);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (84,'Disponibilit liquide',0,'A','IV -','084','B',0.0000,0.0000,51);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (86,'Assegni',60,'A','2)','086','N',0.0000,0.0000,84);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (88,'Ratei e Risconti',0,'A','D)','088','A',0.0000,0.0000,873);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (90,'Ratei attivi della gestione non operativa',63,'A',null,'090','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (92,'Risconti attivi a m-l/t',65,'A',null,'092','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (94,'Disaggio su prestiti',67,'A',null,'094','N',0.0000,0.0000,88);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (96,'Capitale',68,'B','I -','097','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (98,'Riserva di rivalutazione',70,'B','III -','099','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (100,'Riserva per azioni proprie in portafoglio',72,'B','V -','101','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (102,'Altre riserve',74,'B','VII -','103','N',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (104,'Utile (perdita) dell''esercizio',0,'B','IX -','105','C',0.0000,0.0000,95);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (106,'Quota dell''utile agli azionisti',77,'B',null,'107','N',0.0000,0.0000,104);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (108,'Fondi per rischi ed oneri',0,'B','B)','109','A',0.0000,0.0000,874);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (110,'Per imposte anche differite',0,'B','2)','111','C',0.0000,0.0000,108);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (112,'Oltre 12 mesi',81,'B',null,'113','N',0.0000,0.0000,110);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (114,'Entro 12 mesi',82,'B',null,'115','N',0.0000,0.0000,113);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (116,'Trattamento di fine rapporto di lavoro subordinato',0,'B','C)','117','A',0.0000,0.0000,874);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (118,'Oltre 12 mesi',85,'B',null,'119','N',0.0000,0.0000,116);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (120,'Obbligazioni',0,'B','1)','121','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (122,'Oltre 12 mesi',87,'B',null,'123','N',0.0000,0.0000,120);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (124,'Entro 12 mesi',88,'B',null,'125','N',0.0000,0.0000,123);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (126,'Debiti verso soci per finanziamenti',0,'B','3)','127','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (128,'Oltre 12 mesi',91,'B',null,'129','N',0.0000,0.0000,126);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (130,'Entro 12 mesi',92,'B',null,'131','N',0.0000,0.0000,129);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (132,'Debiti verso altri finanziatori',0,'B','5)','133','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (134,'Oltre 12 mesi',95,'B',null,'135','N',0.0000,0.0000,132);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (136,'Debiti verso fornitori',0,'B','7)','137','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (138,'Oltre 12 mesi',98,'B',null,'139','N',0.0000,0.0000,136);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (140,'Debiti rappresentati da titoli di credito',0,'B','8)','141','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (142,'Oltre 12 mesi',101,'B',null,'143','N',0.0000,0.0000,140);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (144,'Finanziari',0,'B',null,'145','D',0.0000,0.0000,143);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (146,'Oltre 12 mesi',103,'B',null,'147','N',0.0000,0.0000,144);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (148,'Entro 12 mesi',104,'B',null,'149','N',0.0000,0.0000,147);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (150,'Debiti verso imprese collegate',0,'B','10)','151','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (152,'Entro 12 mesi',106,'B',null,'153','N',0.0000,0.0000,151);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (154,'Non finanziari',0,'B',null,'155','D',0.0000,0.0000,150);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (156,'Oltre 12 mesi',109,'B',null,'157','N',0.0000,0.0000,154);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (158,'Finanziari',0,'B',null,'159','D',0.0000,0.0000,157);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (160,'Oltre 12 mesi',111,'B',null,'161','N',0.0000,0.0000,158);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (162,'Entro 12 mesi',112,'B',null,'163','N',0.0000,0.0000,161);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (164,'Debiti tributari',0,'B','12)','165','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (166,'Oltre 12 mesi',115,'B',null,'167','N',0.0000,0.0000,164);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (168,'Entro 12 mesi',116,'B',null,'169','N',0.0000,0.0000,167);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (170,'Altri debiti',0,'B','14)','171','C',0.0000,0.0000,119);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (172,'Oltre 12 mesi',119,'B',null,'173','N',0.0000,0.0000,170);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (174,'Entro 12 mesi',120,'B',null,'175','N',0.0000,0.0000,173);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (176,'Ratei e risconti',0,'B','E)','177','A',0.0000,0.0000,874);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (178,'Ratei passivi della gestione non operativa',123,'B',null,'179','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (180,'Risconti passivi a m-l/t',125,'B',null,'181','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (182,'Contributi in conto capitale',127,'B',null,'183','N',0.0000,0.0000,176);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (207,'Valore della produzione',0,'E','A)','209','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (208,'Ricavi delle vendite e delle prestazioni',147,'E','1)','210','N',0.0000,0.0000,207);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (209,'Variazioni delle rimanenze di prodotti in corso di lavorazione',148,'E','2)','211','N',0.0000,0.0000,207);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (210,'Variazione dei lavori in corso su ordinazione',149,'E','3)','212','N',0.0000,0.0000,207);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (211,'Incrementi alle immobilizzazioni per lavori interni',150,'E','4)','213','N',0.0000,0.0000,207);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (212,'Altri ricavi e proventi',0,'E','5)','214','C',0.0000,0.0000,207);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (213,'Altri ricavi operativi',151,'E',null,'215','N',0.0000,0.0000,212);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (214,'Altri ricavi non operativi',152,'E',null,'216','N',0.0000,0.0000,212);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (215,'Costi della produzione',0,'E','B)','217','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (216,'Per materie prime, sussidiari, di consumo e merci',153,'E','6)','218','N',0.0000,0.0000,215);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (217,'Per servizi',154,'E','7)','219','N',0.0000,0.0000,215);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (218,'Per godimento di beni terzi',155,'E','8)','220','N',0.0000,0.0000,215);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (219,'Per il personale',0,'E','9)','221','C',0.0000,0.0000,215);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (220,'Salari e stipendi',156,'E','a)','222','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (221,'Oneri sociali',157,'E','b)','223','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (222,'Trattamento di fine rapporto',158,'E','c)','224','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (223,'Trattamento di quiescenze e simili',159,'E','d)','225','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (224,'Altri costi',160,'E','e)','226','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (225,'Ammortamenti e svalutazioni',0,'E','10)','227','C',0.0000,0.0000,215);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (226,'Ammortamento delle immobilizzazioni immateriali',161,'E','a)','228','N',0.0000,0.0000,225);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (227,'Ammortamento delle immobilizzazioni materiali',162,'E','b)','229','N',0.0000,0.0000,225);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (228,'Altre svalutazioni delle immobilizzazioni',163,'E','c)','230','N',0.0000,0.0000,225);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (229,'Svalutazioni dei crediti nell''attivo circolante e delle disponibilit liquide',164,'E','d)','231','N',0.0000,0.0000,225);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (230,'Variazione delle rimanenze di materie prime, sussidiarie, diconsumo e merci',165,'E','11)','232','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (231,'Accantonamenti per rischi',166,'E','12)','233','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (232,'Altri accantonamenti',167,'E','13)','234','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (233,'Oneri diversi di gestione',168,'E','14)','235','N',0.0000,0.0000,219);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (234,'Differenza tra valore e costi della produzione  (A - B)',0,'E',null,'236','B',null,null,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (235,'Proventi e oneri finanziari',0,'E','C)','237','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (236,'Proventi da partecipazioni',169,'E','15)','238','N',0.0000,0.0000,235);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (237,'Altri proventi finanziari',0,'E','16)','239','C',0.0000,0.0000,235);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (238,'Da crediti iscritti nelle immobilizzazioni',170,'E','a)','240','N',0.0000,0.0000,237);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (239,'Da titoli iscritti nelle immobilizzazioni che non costituiscono partecipazioni',171,'E','b)','241','N',0.0000,0.0000,237);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (240,'Da titoli iscritti nell''attivo circolante che non costituiscono partecipazioni',172,'E','c)','242','N',0.0000,0.0000,237);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (241,'Proventi diversi dai precedenti',173,'E','d)','243','N',0.0000,0.0000,237);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (263,'Oneri',188,'E','21)','265','N',0.0000,0.0000,261);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (242,'Interessi ed altri oneri finanziari',174,'E','17)','244','N',0.0000,0.0000,235);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (243,'Utili e perdite su cambi',0,'E','17-bis)','245','C',0.0000,0.0000,235);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (244,'Utili su cambi',0,'E',null,'246','D',0.0000,0.0000,243);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (245,'dalla gestione operativa',175,'E','-','247','N',0.0000,0.0000,244);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (246,'da investimenti dell''area extra-caratteristica',176,'E','-','248','N',0.0000,0.0000,244);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (247,'dalla gestione finanziaria',177,'E','-','249','N',0.0000,0.0000,244);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (248,'Perdite su cambi',0,'E',null,'250','D',0.0000,0.0000,243);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (249,'dalla gestione operativa',178,'E','-','251','N',0.0000,0.0000,248);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (250,'da investimenti dell''area extra-caratteristica',179,'E','-','252','N',0.0000,0.0000,248);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (251,'dalla gestione finanziaria',180,'E','-','253','N',0.0000,0.0000,248);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (252,'Rettifiche di valore di attivit finanziarie',0,'E','D)','254','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (253,'Rivalutazioni',0,'E','18)','255','C',0.0000,0.0000,252);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (254,'Di partecipazioni',181,'E','a)','256','N',0.0000,0.0000,253);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (255,'Di immobilizzazioni finanziarie che non costituiscono partecipazioni',182,'E','b)','257','N',0.0000,0.0000,253);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (256,'Di titoli iscritti nell''attivo circolante che non costituiscono partecipazione',183,'E','c)','258','N',0.0000,0.0000,253);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (257,'Svalutazioni',0,'E','19)','259','C',0.0000,0.0000,252);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (258,'Di partecipazioni',184,'E','a)','260','N',0.0000,0.0000,257);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (259,'Di immobilizzazioni finanziarie che non costituiscono partecipazioni',185,'E','b)','261','N',0.0000,0.0000,257);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (260,'Di titoli iscritti nell''attivo circolante che non costituiscono partecipazione',186,'E','c)','262','N',0.0000,0.0000,257);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (261,'Proventi e oneri straordinari',0,'E','E)','263','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (262,'Proventi',187,'E','20)','264','N',0.0000,0.0000,261);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (264,'Risultati prima delle imposte',0,'E',null,'266','B',null,null,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (265,'Imposte sul reddito dell''esercizio, correnti differite e anticipate',189,'E','22)','267','N',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (266,'Utile perdita di esercizio',190,'E','23)','268','A',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (183,'Garanzie prestate a:',0,'C','A)','185','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (184,'Imprese controllate',128,'C','a)','186','N',0.0000,0.0000,183);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (185,'Imprese collegate',129,'C','b)','187','N',0.0000,0.0000,183);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (186,'Imprese controllanti',130,'C','c)','188','N',0.0000,0.0000,183);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (187,'Terzi',0,'C','d)','189','C',0.0000,0.0000,183);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (188,'Fideiussioni',131,'C',null,'190','N',0.0000,0.0000,187);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (189,'Avalli',132,'C',null,'191','N',0.0000,0.0000,187);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (190,'Garanzie reali',133,'C',null,'192','N',0.0000,0.0000,187);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (191,'Garanzie personali',134,'C',null,'193','N',0.0000,0.0000,187);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (192,'Garanzie ricevute da',0,'C','B)','194','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (193,'Imprese controllate',135,'C','a)','195','N',0.0000,0.0000,192);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (194,'Imprese collegate',136,'C','b)','196','N',0.0000,0.0000,192);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (195,'Imprese controllanti',137,'C','c)','197','N',0.0000,0.0000,192);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (196,'Terzi',0,'C','d)','198','C',0.0000,0.0000,192);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (197,'Fideiussioni',138,'C',null,'199','N',0.0000,0.0000,196);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (198,'Avalli',139,'C',null,'200','N',0.0000,0.0000,196);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (199,'Garanzie reali',140,'C',null,'201','N',0.0000,0.0000,196);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (200,'Garanzie personali',141,'C',null,'202','N',0.0000,0.0000,196);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (201,'Altri conti d''ordine',0,'C','C)','203','B',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (202,'Effetti ceduti allo sconto',142,'C','1)','204','N',0.0000,0.0000,201);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (203,'Merci in viaggio/sdoganamento',143,'C','2)','205','N',0.0000,0.0000,201);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (204,'Lettere di credito aperte',144,'C','3)','206','N',0.0000,0.0000,201);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (205,'Beni di terzi in locazione/deposito',145,'C','4)','207','N',0.0000,0.0000,201);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (206,'Altri conti d''ordine',146,'C','5)','208','N',0.0000,0.0000,201);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (873,'TOTALE ATTIVO',0,'A',null,'095','0',0.0000,0.0000,0);
insert into bilancio_cee (id_bilancio_cee, descrizione, riferimento, tipo, prefisso, posizione, flag, saldo1, saldo2, id_bil_padre) values (874,'TOTALE PASSIVO',0,'B',null,'184','0',0.0000,0.0000,0);






update conto set id_bilancio_cee=null where id_bilancio_cee=427;
update conto set id_bilancio_cee=208 where id_bilancio_cee=428;
update conto set id_bilancio_cee=209 where id_bilancio_cee=429;
update conto set id_bilancio_cee=210 where id_bilancio_cee=430;
update conto set id_bilancio_cee=211 where id_bilancio_cee=431;
update conto set id_bilancio_cee=null where id_bilancio_cee=432;
update conto set id_bilancio_cee=213 where id_bilancio_cee=433;
update conto set id_bilancio_cee=214 where id_bilancio_cee=434;
update conto set id_bilancio_cee=null where id_bilancio_cee=435;
update conto set id_bilancio_cee=null where id_bilancio_cee=436;
update conto set id_bilancio_cee=226 where id_bilancio_cee=437;
update conto set id_bilancio_cee=227 where id_bilancio_cee=438;
update conto set id_bilancio_cee=228 where id_bilancio_cee=439;
update conto set id_bilancio_cee=229 where id_bilancio_cee=440;
update conto set id_bilancio_cee=230 where id_bilancio_cee=441;
update conto set id_bilancio_cee=231 where id_bilancio_cee=442;
update conto set id_bilancio_cee=232 where id_bilancio_cee=443;
update conto set id_bilancio_cee=233 where id_bilancio_cee=444;
update conto set id_bilancio_cee=216 where id_bilancio_cee=445;
update conto set id_bilancio_cee=217 where id_bilancio_cee=446;
update conto set id_bilancio_cee=218 where id_bilancio_cee=447;
update conto set id_bilancio_cee=null where id_bilancio_cee=448;
update conto set id_bilancio_cee=220 where id_bilancio_cee=449;
update conto set id_bilancio_cee=221 where id_bilancio_cee=450;
update conto set id_bilancio_cee=222 where id_bilancio_cee=451;
update conto set id_bilancio_cee=223 where id_bilancio_cee=452;
update conto set id_bilancio_cee=224 where id_bilancio_cee=453;
update conto set id_bilancio_cee=null where id_bilancio_cee=454;
update conto set id_bilancio_cee=null where id_bilancio_cee=455;
update conto set id_bilancio_cee=null where id_bilancio_cee=456;
update conto set id_bilancio_cee=null where id_bilancio_cee=457;
update conto set id_bilancio_cee=169 where id_bilancio_cee=458;
update conto set id_bilancio_cee=null where id_bilancio_cee=459;
update conto set id_bilancio_cee=null where id_bilancio_cee=460;
update conto set id_bilancio_cee=238 where id_bilancio_cee=461;
update conto set id_bilancio_cee=null where id_bilancio_cee=462;
update conto set id_bilancio_cee=null where id_bilancio_cee=463;
update conto set id_bilancio_cee=null where id_bilancio_cee=464;
update conto set id_bilancio_cee=239 where id_bilancio_cee=465;
update conto set id_bilancio_cee=null where id_bilancio_cee=466;
update conto set id_bilancio_cee=241 where id_bilancio_cee=467;
update conto set id_bilancio_cee=242 where id_bilancio_cee=468;
update conto set id_bilancio_cee=null where id_bilancio_cee=470;
update conto set id_bilancio_cee=null where id_bilancio_cee=471;
update conto set id_bilancio_cee=null where id_bilancio_cee=472;
update conto set id_bilancio_cee=null where id_bilancio_cee=473;
update conto set id_bilancio_cee=null where id_bilancio_cee=474;
update conto set id_bilancio_cee=254 where id_bilancio_cee=475;
update conto set id_bilancio_cee=255 where id_bilancio_cee=476;
update conto set id_bilancio_cee=256 where id_bilancio_cee=477;
update conto set id_bilancio_cee=null where id_bilancio_cee=478;
update conto set id_bilancio_cee=258 where id_bilancio_cee=479;
update conto set id_bilancio_cee=259 where id_bilancio_cee=480;
update conto set id_bilancio_cee=260 where id_bilancio_cee=481;
update conto set id_bilancio_cee=null where id_bilancio_cee=482;
update conto set id_bilancio_cee=null where id_bilancio_cee=483;
update conto set id_bilancio_cee=262 where id_bilancio_cee=484;
update conto set id_bilancio_cee=262 where id_bilancio_cee=485;
update conto set id_bilancio_cee=262 where id_bilancio_cee=486;
update conto set id_bilancio_cee=null where id_bilancio_cee=487;
update conto set id_bilancio_cee=263 where id_bilancio_cee=488;
update conto set id_bilancio_cee=263 where id_bilancio_cee=489;
update conto set id_bilancio_cee=null where id_bilancio_cee=490;
update conto set id_bilancio_cee=null where id_bilancio_cee=491;
update conto set id_bilancio_cee=null where id_bilancio_cee=605;
update conto set id_bilancio_cee=265 where id_bilancio_cee=492;
update conto set id_bilancio_cee=null where id_bilancio_cee=493;
update conto set id_bilancio_cee=null where id_bilancio_cee=494;
update conto set id_bilancio_cee=null where id_bilancio_cee=495;
update conto set id_bilancio_cee=266 where id_bilancio_cee=496;

update conto set id_bilancio_cee=null where id_bilancio_cee=497;
update conto set id_bilancio_cee=184 where id_bilancio_cee=498;
update conto set id_bilancio_cee=185 where id_bilancio_cee=499;
update conto set id_bilancio_cee=186 where id_bilancio_cee=500;
update conto set id_bilancio_cee=null where id_bilancio_cee=501;
update conto set id_bilancio_cee=188 where id_bilancio_cee=502;
update conto set id_bilancio_cee=189 where id_bilancio_cee=503;
update conto set id_bilancio_cee=190 where id_bilancio_cee=504;
update conto set id_bilancio_cee=191 where id_bilancio_cee=505;
update conto set id_bilancio_cee=null where id_bilancio_cee=506;
update conto set id_bilancio_cee=193 where id_bilancio_cee=507;
update conto set id_bilancio_cee=194 where id_bilancio_cee=508;
update conto set id_bilancio_cee=195 where id_bilancio_cee=509;
update conto set id_bilancio_cee=197 where id_bilancio_cee=510;
update conto set id_bilancio_cee=198 where id_bilancio_cee=511;
update conto set id_bilancio_cee=199 where id_bilancio_cee=512;
update conto set id_bilancio_cee=200 where id_bilancio_cee=513;
update conto set id_bilancio_cee=201 where id_bilancio_cee=514;
update conto set id_bilancio_cee=null where id_bilancio_cee=515;
update conto set id_bilancio_cee=202 where id_bilancio_cee=516;
update conto set id_bilancio_cee=203 where id_bilancio_cee=517;
update conto set id_bilancio_cee=204 where id_bilancio_cee=518;
update conto set id_bilancio_cee=205 where id_bilancio_cee=519;
update conto set id_bilancio_cee=206 where id_bilancio_cee=520;

update conto set id_bilancio_cee=2 where id_bilancio_cee=405;
update conto set id_bilancio_cee=null where id_bilancio_cee=406;
update conto set id_bilancio_cee=null where id_bilancio_cee=407;
update conto set id_bilancio_cee=6 where id_bilancio_cee=408;
update conto set id_bilancio_cee=7 where id_bilancio_cee=412;
update conto set id_bilancio_cee=8 where id_bilancio_cee=413;
update conto set id_bilancio_cee=9 where id_bilancio_cee=414;
update conto set id_bilancio_cee=10 where id_bilancio_cee=415;
update conto set id_bilancio_cee=11 where id_bilancio_cee=416;
update conto set id_bilancio_cee=12 where id_bilancio_cee=417;
update conto set id_bilancio_cee=null where id_bilancio_cee=409;
update conto set id_bilancio_cee=12 where id_bilancio_cee=410;
update conto set id_bilancio_cee=21 where id_bilancio_cee=418;
update conto set id_bilancio_cee=24 where id_bilancio_cee=419;
update conto set id_bilancio_cee=27 where id_bilancio_cee=420;
update conto set id_bilancio_cee=29 where id_bilancio_cee=421;
update conto set id_bilancio_cee=null where id_bilancio_cee=422;
update conto set id_bilancio_cee=null where id_bilancio_cee=423;
update conto set id_bilancio_cee=32 where id_bilancio_cee=424;
update conto set id_bilancio_cee=33 where id_bilancio_cee=425;
update conto set id_bilancio_cee=35 where id_bilancio_cee=426;
update conto set id_bilancio_cee=null where id_bilancio_cee=544;
update conto set id_bilancio_cee=39 where id_bilancio_cee=545;
update conto set id_bilancio_cee=42 where id_bilancio_cee=546;
update conto set id_bilancio_cee=45 where id_bilancio_cee=547;
update conto set id_bilancio_cee=48 where id_bilancio_cee=548;
update conto set id_bilancio_cee=null where id_bilancio_cee=549;
update conto set id_bilancio_cee=38 where id_bilancio_cee=550;
update conto set id_bilancio_cee=41 where id_bilancio_cee=551;
update conto set id_bilancio_cee=44 where id_bilancio_cee=552;
update conto set id_bilancio_cee=47 where id_bilancio_cee=553;
update conto set id_bilancio_cee=49 where id_bilancio_cee=554;
update conto set id_bilancio_cee=50 where id_bilancio_cee=555;
update conto set id_bilancio_cee=null where id_bilancio_cee=411;
update conto set id_bilancio_cee=null where id_bilancio_cee=556;
update conto set id_bilancio_cee=53 where id_bilancio_cee=557;
update conto set id_bilancio_cee=54 where id_bilancio_cee=558;
update conto set id_bilancio_cee=55 where id_bilancio_cee=559;
update conto set id_bilancio_cee=56 where id_bilancio_cee=560;
update conto set id_bilancio_cee=57 where id_bilancio_cee=561;
update conto set id_bilancio_cee=null where id_bilancio_cee=562;
update conto set id_bilancio_cee=60 where id_bilancio_cee=563;
update conto set id_bilancio_cee=63 where id_bilancio_cee=564;
update conto set id_bilancio_cee=66 where id_bilancio_cee=565;
update conto set id_bilancio_cee=69 where id_bilancio_cee=566;
update conto set id_bilancio_cee=74 where id_bilancio_cee=567;
update conto set id_bilancio_cee=null where id_bilancio_cee=568;
update conto set id_bilancio_cee=61 where id_bilancio_cee=569;
update conto set id_bilancio_cee=64 where id_bilancio_cee=570;
update conto set id_bilancio_cee=67 where id_bilancio_cee=571;
update conto set id_bilancio_cee=70 where id_bilancio_cee=606;
update conto set id_bilancio_cee=75 where id_bilancio_cee=572;
update conto set id_bilancio_cee=null where id_bilancio_cee=573;
update conto set id_bilancio_cee=78 where id_bilancio_cee=574;
update conto set id_bilancio_cee=79 where id_bilancio_cee=575;
update conto set id_bilancio_cee=81 where id_bilancio_cee=576;
update conto set id_bilancio_cee=82 where id_bilancio_cee=577;
update conto set id_bilancio_cee=83 where id_bilancio_cee=578;
update conto set id_bilancio_cee=null where id_bilancio_cee=579;
update conto set id_bilancio_cee=85 where id_bilancio_cee=580;
update conto set id_bilancio_cee=86 where id_bilancio_cee=581;
update conto set id_bilancio_cee=87 where id_bilancio_cee=582;
update conto set id_bilancio_cee=null where id_bilancio_cee=583;
update conto set id_bilancio_cee=null where id_bilancio_cee=584;
update conto set id_bilancio_cee=96 where id_bilancio_cee=585;
update conto set id_bilancio_cee=97 where id_bilancio_cee=586;
update conto set id_bilancio_cee=98 where id_bilancio_cee=587;
update conto set id_bilancio_cee=99 where id_bilancio_cee=588;
update conto set id_bilancio_cee=null where id_bilancio_cee=593;
update conto set id_bilancio_cee=100 where id_bilancio_cee=589;
update conto set id_bilancio_cee=101 where id_bilancio_cee=590;
update conto set id_bilancio_cee=102 where id_bilancio_cee=591;
update conto set id_bilancio_cee=103 where id_bilancio_cee=592;
update conto set id_bilancio_cee=null where id_bilancio_cee=594;
update conto set id_bilancio_cee=109 where id_bilancio_cee=595;
update conto set id_bilancio_cee=111 where id_bilancio_cee=596;
update conto set id_bilancio_cee=114 where id_bilancio_cee=597;
update conto set id_bilancio_cee=117 where id_bilancio_cee=598;
update conto set id_bilancio_cee=null where id_bilancio_cee=599;
update conto set id_bilancio_cee=122 where id_bilancio_cee=600;
update conto set id_bilancio_cee=160 where id_bilancio_cee=525;
update conto set id_bilancio_cee=null where id_bilancio_cee=526;
update conto set id_bilancio_cee=169 where id_bilancio_cee=527;
update conto set id_bilancio_cee=170 where id_bilancio_cee=528;
update conto set id_bilancio_cee=125 where id_bilancio_cee=601;
update conto set id_bilancio_cee=131 where id_bilancio_cee=602;
update conto set id_bilancio_cee=134 where id_bilancio_cee=603;
update conto set id_bilancio_cee=135 where id_bilancio_cee=604;
update conto set id_bilancio_cee=137 where id_bilancio_cee=521;
update conto set id_bilancio_cee=null where id_bilancio_cee=522;
update conto set id_bilancio_cee=146 where id_bilancio_cee=523;
update conto set id_bilancio_cee=153 where id_bilancio_cee=524;
update conto set id_bilancio_cee=null where id_bilancio_cee=529;
update conto set id_bilancio_cee=121 where id_bilancio_cee=530;
update conto set id_bilancio_cee=159 where id_bilancio_cee=539;
update conto set id_bilancio_cee=166 where id_bilancio_cee=540;
update conto set id_bilancio_cee=168 where id_bilancio_cee=541;
update conto set id_bilancio_cee=171 where id_bilancio_cee=542;
update conto set id_bilancio_cee=124 where id_bilancio_cee=531;
update conto set id_bilancio_cee=130 where id_bilancio_cee=532;
update conto set id_bilancio_cee=133 where id_bilancio_cee=533;
update conto set id_bilancio_cee=null where id_bilancio_cee=534;
update conto set id_bilancio_cee=137 where id_bilancio_cee=535;
update conto set id_bilancio_cee=null where id_bilancio_cee=536;
update conto set id_bilancio_cee=145 where id_bilancio_cee=537;
update conto set id_bilancio_cee=152 where id_bilancio_cee=538;
update conto set id_bilancio_cee=null where id_bilancio_cee=543;



update sottomastro set id_bilancio_cee=null where id_bilancio_cee=427;
update sottomastro set id_bilancio_cee=208 where id_bilancio_cee=428;
update sottomastro set id_bilancio_cee=209 where id_bilancio_cee=429;
update sottomastro set id_bilancio_cee=210 where id_bilancio_cee=430;
update sottomastro set id_bilancio_cee=211 where id_bilancio_cee=431;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=432;
update sottomastro set id_bilancio_cee=213 where id_bilancio_cee=433;
update sottomastro set id_bilancio_cee=214 where id_bilancio_cee=434;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=435;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=436;
update sottomastro set id_bilancio_cee=226 where id_bilancio_cee=437;
update sottomastro set id_bilancio_cee=227 where id_bilancio_cee=438;
update sottomastro set id_bilancio_cee=228 where id_bilancio_cee=439;
update sottomastro set id_bilancio_cee=229 where id_bilancio_cee=440;
update sottomastro set id_bilancio_cee=230 where id_bilancio_cee=441;
update sottomastro set id_bilancio_cee=231 where id_bilancio_cee=442;
update sottomastro set id_bilancio_cee=232 where id_bilancio_cee=443;
update sottomastro set id_bilancio_cee=233 where id_bilancio_cee=444;
update sottomastro set id_bilancio_cee=216 where id_bilancio_cee=445;
update sottomastro set id_bilancio_cee=217 where id_bilancio_cee=446;
update sottomastro set id_bilancio_cee=218 where id_bilancio_cee=447;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=448;
update sottomastro set id_bilancio_cee=220 where id_bilancio_cee=449;
update sottomastro set id_bilancio_cee=221 where id_bilancio_cee=450;
update sottomastro set id_bilancio_cee=222 where id_bilancio_cee=451;
update sottomastro set id_bilancio_cee=223 where id_bilancio_cee=452;
update sottomastro set id_bilancio_cee=224 where id_bilancio_cee=453;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=454;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=455;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=456;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=457;
update sottomastro set id_bilancio_cee=169 where id_bilancio_cee=458;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=459;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=460;
update sottomastro set id_bilancio_cee=238 where id_bilancio_cee=461;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=462;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=463;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=464;
update sottomastro set id_bilancio_cee=239 where id_bilancio_cee=465;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=466;
update sottomastro set id_bilancio_cee=241 where id_bilancio_cee=467;
update sottomastro set id_bilancio_cee=242 where id_bilancio_cee=468;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=470;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=471;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=472;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=473;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=474;
update sottomastro set id_bilancio_cee=254 where id_bilancio_cee=475;
update sottomastro set id_bilancio_cee=255 where id_bilancio_cee=476;
update sottomastro set id_bilancio_cee=256 where id_bilancio_cee=477;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=478;
update sottomastro set id_bilancio_cee=258 where id_bilancio_cee=479;
update sottomastro set id_bilancio_cee=259 where id_bilancio_cee=480;
update sottomastro set id_bilancio_cee=260 where id_bilancio_cee=481;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=482;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=483;
update sottomastro set id_bilancio_cee=262 where id_bilancio_cee=484;
update sottomastro set id_bilancio_cee=262 where id_bilancio_cee=485;
update sottomastro set id_bilancio_cee=262 where id_bilancio_cee=486;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=487;
update sottomastro set id_bilancio_cee=263 where id_bilancio_cee=488;
update sottomastro set id_bilancio_cee=263 where id_bilancio_cee=489;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=490;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=491;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=605;
update sottomastro set id_bilancio_cee=265 where id_bilancio_cee=492;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=493;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=494;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=495;
update sottomastro set id_bilancio_cee=266 where id_bilancio_cee=496;

update sottomastro set id_bilancio_cee=null where id_bilancio_cee=497;
update sottomastro set id_bilancio_cee=184 where id_bilancio_cee=498;
update sottomastro set id_bilancio_cee=185 where id_bilancio_cee=499;
update sottomastro set id_bilancio_cee=186 where id_bilancio_cee=500;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=501;
update sottomastro set id_bilancio_cee=188 where id_bilancio_cee=502;
update sottomastro set id_bilancio_cee=189 where id_bilancio_cee=503;
update sottomastro set id_bilancio_cee=190 where id_bilancio_cee=504;
update sottomastro set id_bilancio_cee=191 where id_bilancio_cee=505;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=506;
update sottomastro set id_bilancio_cee=193 where id_bilancio_cee=507;
update sottomastro set id_bilancio_cee=194 where id_bilancio_cee=508;
update sottomastro set id_bilancio_cee=195 where id_bilancio_cee=509;
update sottomastro set id_bilancio_cee=197 where id_bilancio_cee=510;
update sottomastro set id_bilancio_cee=198 where id_bilancio_cee=511;
update sottomastro set id_bilancio_cee=199 where id_bilancio_cee=512;
update sottomastro set id_bilancio_cee=200 where id_bilancio_cee=513;
update sottomastro set id_bilancio_cee=201 where id_bilancio_cee=514;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=515;
update sottomastro set id_bilancio_cee=202 where id_bilancio_cee=516;
update sottomastro set id_bilancio_cee=203 where id_bilancio_cee=517;
update sottomastro set id_bilancio_cee=204 where id_bilancio_cee=518;
update sottomastro set id_bilancio_cee=205 where id_bilancio_cee=519;
update sottomastro set id_bilancio_cee=206 where id_bilancio_cee=520;

update sottomastro set id_bilancio_cee=2 where id_bilancio_cee=405;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=406;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=407;
update sottomastro set id_bilancio_cee=6 where id_bilancio_cee=408;
update sottomastro set id_bilancio_cee=7 where id_bilancio_cee=412;
update sottomastro set id_bilancio_cee=8 where id_bilancio_cee=413;
update sottomastro set id_bilancio_cee=9 where id_bilancio_cee=414;
update sottomastro set id_bilancio_cee=10 where id_bilancio_cee=415;
update sottomastro set id_bilancio_cee=11 where id_bilancio_cee=416;
update sottomastro set id_bilancio_cee=12 where id_bilancio_cee=417;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=409;
update sottomastro set id_bilancio_cee=12 where id_bilancio_cee=410;
update sottomastro set id_bilancio_cee=21 where id_bilancio_cee=418;
update sottomastro set id_bilancio_cee=24 where id_bilancio_cee=419;
update sottomastro set id_bilancio_cee=27 where id_bilancio_cee=420;
update sottomastro set id_bilancio_cee=29 where id_bilancio_cee=421;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=422;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=423;
update sottomastro set id_bilancio_cee=32 where id_bilancio_cee=424;
update sottomastro set id_bilancio_cee=33 where id_bilancio_cee=425;
update sottomastro set id_bilancio_cee=35 where id_bilancio_cee=426;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=544;
update sottomastro set id_bilancio_cee=39 where id_bilancio_cee=545;
update sottomastro set id_bilancio_cee=42 where id_bilancio_cee=546;
update sottomastro set id_bilancio_cee=45 where id_bilancio_cee=547;
update sottomastro set id_bilancio_cee=48 where id_bilancio_cee=548;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=549;
update sottomastro set id_bilancio_cee=38 where id_bilancio_cee=550;
update sottomastro set id_bilancio_cee=41 where id_bilancio_cee=551;
update sottomastro set id_bilancio_cee=44 where id_bilancio_cee=552;
update sottomastro set id_bilancio_cee=47 where id_bilancio_cee=553;
update sottomastro set id_bilancio_cee=49 where id_bilancio_cee=554;
update sottomastro set id_bilancio_cee=50 where id_bilancio_cee=555;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=411;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=556;
update sottomastro set id_bilancio_cee=53 where id_bilancio_cee=557;
update sottomastro set id_bilancio_cee=54 where id_bilancio_cee=558;
update sottomastro set id_bilancio_cee=55 where id_bilancio_cee=559;
update sottomastro set id_bilancio_cee=56 where id_bilancio_cee=560;
update sottomastro set id_bilancio_cee=57 where id_bilancio_cee=561;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=562;
update sottomastro set id_bilancio_cee=60 where id_bilancio_cee=563;
update sottomastro set id_bilancio_cee=63 where id_bilancio_cee=564;
update sottomastro set id_bilancio_cee=66 where id_bilancio_cee=565;
update sottomastro set id_bilancio_cee=69 where id_bilancio_cee=566;
update sottomastro set id_bilancio_cee=74 where id_bilancio_cee=567;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=568;
update sottomastro set id_bilancio_cee=61 where id_bilancio_cee=569;
update sottomastro set id_bilancio_cee=64 where id_bilancio_cee=570;
update sottomastro set id_bilancio_cee=67 where id_bilancio_cee=571;
update sottomastro set id_bilancio_cee=70 where id_bilancio_cee=606;
update sottomastro set id_bilancio_cee=75 where id_bilancio_cee=572;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=573;
update sottomastro set id_bilancio_cee=78 where id_bilancio_cee=574;
update sottomastro set id_bilancio_cee=79 where id_bilancio_cee=575;
update sottomastro set id_bilancio_cee=81 where id_bilancio_cee=576;
update sottomastro set id_bilancio_cee=82 where id_bilancio_cee=577;
update sottomastro set id_bilancio_cee=83 where id_bilancio_cee=578;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=579;
update sottomastro set id_bilancio_cee=85 where id_bilancio_cee=580;
update sottomastro set id_bilancio_cee=86 where id_bilancio_cee=581;
update sottomastro set id_bilancio_cee=87 where id_bilancio_cee=582;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=583;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=584;
update sottomastro set id_bilancio_cee=96 where id_bilancio_cee=585;
update sottomastro set id_bilancio_cee=97 where id_bilancio_cee=586;
update sottomastro set id_bilancio_cee=98 where id_bilancio_cee=587;
update sottomastro set id_bilancio_cee=99 where id_bilancio_cee=588;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=593;
update sottomastro set id_bilancio_cee=100 where id_bilancio_cee=589;
update sottomastro set id_bilancio_cee=101 where id_bilancio_cee=590;
update sottomastro set id_bilancio_cee=102 where id_bilancio_cee=591;
update sottomastro set id_bilancio_cee=103 where id_bilancio_cee=592;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=594;
update sottomastro set id_bilancio_cee=109 where id_bilancio_cee=595;
update sottomastro set id_bilancio_cee=111 where id_bilancio_cee=596;
update sottomastro set id_bilancio_cee=114 where id_bilancio_cee=597;
update sottomastro set id_bilancio_cee=117 where id_bilancio_cee=598;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=599;
update sottomastro set id_bilancio_cee=122 where id_bilancio_cee=600;
update sottomastro set id_bilancio_cee=160 where id_bilancio_cee=525;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=526;
update sottomastro set id_bilancio_cee=169 where id_bilancio_cee=527;
update sottomastro set id_bilancio_cee=170 where id_bilancio_cee=528;
update sottomastro set id_bilancio_cee=125 where id_bilancio_cee=601;
update sottomastro set id_bilancio_cee=131 where id_bilancio_cee=602;
update sottomastro set id_bilancio_cee=134 where id_bilancio_cee=603;
update sottomastro set id_bilancio_cee=135 where id_bilancio_cee=604;
update sottomastro set id_bilancio_cee=137 where id_bilancio_cee=521;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=522;
update sottomastro set id_bilancio_cee=146 where id_bilancio_cee=523;
update sottomastro set id_bilancio_cee=153 where id_bilancio_cee=524;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=529;
update sottomastro set id_bilancio_cee=121 where id_bilancio_cee=530;
update sottomastro set id_bilancio_cee=159 where id_bilancio_cee=539;
update sottomastro set id_bilancio_cee=166 where id_bilancio_cee=540;
update sottomastro set id_bilancio_cee=168 where id_bilancio_cee=541;
update sottomastro set id_bilancio_cee=171 where id_bilancio_cee=542;
update sottomastro set id_bilancio_cee=124 where id_bilancio_cee=531;
update sottomastro set id_bilancio_cee=130 where id_bilancio_cee=532;
update sottomastro set id_bilancio_cee=133 where id_bilancio_cee=533;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=534;
update sottomastro set id_bilancio_cee=137 where id_bilancio_cee=535;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=536;
update sottomastro set id_bilancio_cee=145 where id_bilancio_cee=537;
update sottomastro set id_bilancio_cee=152 where id_bilancio_cee=538;
update sottomastro set id_bilancio_cee=null where id_bilancio_cee=543;




update mastro set id_bilancio_cee=null where id_bilancio_cee=427;
update mastro set id_bilancio_cee=208 where id_bilancio_cee=428;
update mastro set id_bilancio_cee=209 where id_bilancio_cee=429;
update mastro set id_bilancio_cee=210 where id_bilancio_cee=430;
update mastro set id_bilancio_cee=211 where id_bilancio_cee=431;
update mastro set id_bilancio_cee=null where id_bilancio_cee=432;
update mastro set id_bilancio_cee=213 where id_bilancio_cee=433;
update mastro set id_bilancio_cee=214 where id_bilancio_cee=434;
update mastro set id_bilancio_cee=null where id_bilancio_cee=435;
update mastro set id_bilancio_cee=null where id_bilancio_cee=436;
update mastro set id_bilancio_cee=226 where id_bilancio_cee=437;
update mastro set id_bilancio_cee=227 where id_bilancio_cee=438;
update mastro set id_bilancio_cee=228 where id_bilancio_cee=439;
update mastro set id_bilancio_cee=229 where id_bilancio_cee=440;
update mastro set id_bilancio_cee=230 where id_bilancio_cee=441;
update mastro set id_bilancio_cee=231 where id_bilancio_cee=442;
update mastro set id_bilancio_cee=232 where id_bilancio_cee=443;
update mastro set id_bilancio_cee=233 where id_bilancio_cee=444;
update mastro set id_bilancio_cee=216 where id_bilancio_cee=445;
update mastro set id_bilancio_cee=217 where id_bilancio_cee=446;
update mastro set id_bilancio_cee=218 where id_bilancio_cee=447;
update mastro set id_bilancio_cee=null where id_bilancio_cee=448;
update mastro set id_bilancio_cee=220 where id_bilancio_cee=449;
update mastro set id_bilancio_cee=221 where id_bilancio_cee=450;
update mastro set id_bilancio_cee=222 where id_bilancio_cee=451;
update mastro set id_bilancio_cee=223 where id_bilancio_cee=452;
update mastro set id_bilancio_cee=224 where id_bilancio_cee=453;
update mastro set id_bilancio_cee=null where id_bilancio_cee=454;
update mastro set id_bilancio_cee=null where id_bilancio_cee=455;
update mastro set id_bilancio_cee=null where id_bilancio_cee=456;
update mastro set id_bilancio_cee=null where id_bilancio_cee=457;
update mastro set id_bilancio_cee=169 where id_bilancio_cee=458;
update mastro set id_bilancio_cee=null where id_bilancio_cee=459;
update mastro set id_bilancio_cee=null where id_bilancio_cee=460;
update mastro set id_bilancio_cee=238 where id_bilancio_cee=461;
update mastro set id_bilancio_cee=null where id_bilancio_cee=462;
update mastro set id_bilancio_cee=null where id_bilancio_cee=463;
update mastro set id_bilancio_cee=null where id_bilancio_cee=464;
update mastro set id_bilancio_cee=239 where id_bilancio_cee=465;
update mastro set id_bilancio_cee=null where id_bilancio_cee=466;
update mastro set id_bilancio_cee=241 where id_bilancio_cee=467;
update mastro set id_bilancio_cee=242 where id_bilancio_cee=468;
update mastro set id_bilancio_cee=null where id_bilancio_cee=470;
update mastro set id_bilancio_cee=null where id_bilancio_cee=471;
update mastro set id_bilancio_cee=null where id_bilancio_cee=472;
update mastro set id_bilancio_cee=null where id_bilancio_cee=473;
update mastro set id_bilancio_cee=null where id_bilancio_cee=474;
update mastro set id_bilancio_cee=254 where id_bilancio_cee=475;
update mastro set id_bilancio_cee=255 where id_bilancio_cee=476;
update mastro set id_bilancio_cee=256 where id_bilancio_cee=477;
update mastro set id_bilancio_cee=null where id_bilancio_cee=478;
update mastro set id_bilancio_cee=258 where id_bilancio_cee=479;
update mastro set id_bilancio_cee=259 where id_bilancio_cee=480;
update mastro set id_bilancio_cee=260 where id_bilancio_cee=481;
update mastro set id_bilancio_cee=null where id_bilancio_cee=482;
update mastro set id_bilancio_cee=null where id_bilancio_cee=483;
update mastro set id_bilancio_cee=262 where id_bilancio_cee=484;
update mastro set id_bilancio_cee=262 where id_bilancio_cee=485;
update mastro set id_bilancio_cee=262 where id_bilancio_cee=486;
update mastro set id_bilancio_cee=null where id_bilancio_cee=487;
update mastro set id_bilancio_cee=263 where id_bilancio_cee=488;
update mastro set id_bilancio_cee=263 where id_bilancio_cee=489;
update mastro set id_bilancio_cee=null where id_bilancio_cee=490;
update mastro set id_bilancio_cee=null where id_bilancio_cee=491;
update mastro set id_bilancio_cee=null where id_bilancio_cee=605;
update mastro set id_bilancio_cee=265 where id_bilancio_cee=492;
update mastro set id_bilancio_cee=null where id_bilancio_cee=493;
update mastro set id_bilancio_cee=null where id_bilancio_cee=494;
update mastro set id_bilancio_cee=null where id_bilancio_cee=495;
update mastro set id_bilancio_cee=266 where id_bilancio_cee=496;

update mastro set id_bilancio_cee=null where id_bilancio_cee=497;
update mastro set id_bilancio_cee=184 where id_bilancio_cee=498;
update mastro set id_bilancio_cee=185 where id_bilancio_cee=499;
update mastro set id_bilancio_cee=186 where id_bilancio_cee=500;
update mastro set id_bilancio_cee=null where id_bilancio_cee=501;
update mastro set id_bilancio_cee=188 where id_bilancio_cee=502;
update mastro set id_bilancio_cee=189 where id_bilancio_cee=503;
update mastro set id_bilancio_cee=190 where id_bilancio_cee=504;
update mastro set id_bilancio_cee=191 where id_bilancio_cee=505;
update mastro set id_bilancio_cee=null where id_bilancio_cee=506;
update mastro set id_bilancio_cee=193 where id_bilancio_cee=507;
update mastro set id_bilancio_cee=194 where id_bilancio_cee=508;
update mastro set id_bilancio_cee=195 where id_bilancio_cee=509;
update mastro set id_bilancio_cee=197 where id_bilancio_cee=510;
update mastro set id_bilancio_cee=198 where id_bilancio_cee=511;
update mastro set id_bilancio_cee=199 where id_bilancio_cee=512;
update mastro set id_bilancio_cee=200 where id_bilancio_cee=513;
update mastro set id_bilancio_cee=201 where id_bilancio_cee=514;
update mastro set id_bilancio_cee=null where id_bilancio_cee=515;
update mastro set id_bilancio_cee=202 where id_bilancio_cee=516;
update mastro set id_bilancio_cee=203 where id_bilancio_cee=517;
update mastro set id_bilancio_cee=204 where id_bilancio_cee=518;
update mastro set id_bilancio_cee=205 where id_bilancio_cee=519;
update mastro set id_bilancio_cee=206 where id_bilancio_cee=520;

update mastro set id_bilancio_cee=2 where id_bilancio_cee=405;
update mastro set id_bilancio_cee=null where id_bilancio_cee=406;
update mastro set id_bilancio_cee=null where id_bilancio_cee=407;
update mastro set id_bilancio_cee=6 where id_bilancio_cee=408;
update mastro set id_bilancio_cee=7 where id_bilancio_cee=412;
update mastro set id_bilancio_cee=8 where id_bilancio_cee=413;
update mastro set id_bilancio_cee=9 where id_bilancio_cee=414;
update mastro set id_bilancio_cee=10 where id_bilancio_cee=415;
update mastro set id_bilancio_cee=11 where id_bilancio_cee=416;
update mastro set id_bilancio_cee=12 where id_bilancio_cee=417;
update mastro set id_bilancio_cee=null where id_bilancio_cee=409;
update mastro set id_bilancio_cee=12 where id_bilancio_cee=410;
update mastro set id_bilancio_cee=21 where id_bilancio_cee=418;
update mastro set id_bilancio_cee=24 where id_bilancio_cee=419;
update mastro set id_bilancio_cee=27 where id_bilancio_cee=420;
update mastro set id_bilancio_cee=29 where id_bilancio_cee=421;
update mastro set id_bilancio_cee=null where id_bilancio_cee=422;
update mastro set id_bilancio_cee=null where id_bilancio_cee=423;
update mastro set id_bilancio_cee=32 where id_bilancio_cee=424;
update mastro set id_bilancio_cee=33 where id_bilancio_cee=425;
update mastro set id_bilancio_cee=35 where id_bilancio_cee=426;
update mastro set id_bilancio_cee=null where id_bilancio_cee=544;
update mastro set id_bilancio_cee=39 where id_bilancio_cee=545;
update mastro set id_bilancio_cee=42 where id_bilancio_cee=546;
update mastro set id_bilancio_cee=45 where id_bilancio_cee=547;
update mastro set id_bilancio_cee=48 where id_bilancio_cee=548;
update mastro set id_bilancio_cee=null where id_bilancio_cee=549;
update mastro set id_bilancio_cee=38 where id_bilancio_cee=550;
update mastro set id_bilancio_cee=41 where id_bilancio_cee=551;
update mastro set id_bilancio_cee=44 where id_bilancio_cee=552;
update mastro set id_bilancio_cee=47 where id_bilancio_cee=553;
update mastro set id_bilancio_cee=49 where id_bilancio_cee=554;
update mastro set id_bilancio_cee=50 where id_bilancio_cee=555;
update mastro set id_bilancio_cee=null where id_bilancio_cee=411;
update mastro set id_bilancio_cee=null where id_bilancio_cee=556;
update mastro set id_bilancio_cee=53 where id_bilancio_cee=557;
update mastro set id_bilancio_cee=54 where id_bilancio_cee=558;
update mastro set id_bilancio_cee=55 where id_bilancio_cee=559;
update mastro set id_bilancio_cee=56 where id_bilancio_cee=560;
update mastro set id_bilancio_cee=57 where id_bilancio_cee=561;
update mastro set id_bilancio_cee=null where id_bilancio_cee=562;
update mastro set id_bilancio_cee=60 where id_bilancio_cee=563;
update mastro set id_bilancio_cee=63 where id_bilancio_cee=564;
update mastro set id_bilancio_cee=66 where id_bilancio_cee=565;
update mastro set id_bilancio_cee=69 where id_bilancio_cee=566;
update mastro set id_bilancio_cee=74 where id_bilancio_cee=567;
update mastro set id_bilancio_cee=null where id_bilancio_cee=568;
update mastro set id_bilancio_cee=61 where id_bilancio_cee=569;
update mastro set id_bilancio_cee=64 where id_bilancio_cee=570;
update mastro set id_bilancio_cee=67 where id_bilancio_cee=571;
update mastro set id_bilancio_cee=70 where id_bilancio_cee=606;
update mastro set id_bilancio_cee=75 where id_bilancio_cee=572;
update mastro set id_bilancio_cee=null where id_bilancio_cee=573;
update mastro set id_bilancio_cee=78 where id_bilancio_cee=574;
update mastro set id_bilancio_cee=79 where id_bilancio_cee=575;
update mastro set id_bilancio_cee=81 where id_bilancio_cee=576;
update mastro set id_bilancio_cee=82 where id_bilancio_cee=577;
update mastro set id_bilancio_cee=83 where id_bilancio_cee=578;
update mastro set id_bilancio_cee=null where id_bilancio_cee=579;
update mastro set id_bilancio_cee=85 where id_bilancio_cee=580;
update mastro set id_bilancio_cee=86 where id_bilancio_cee=581;
update mastro set id_bilancio_cee=87 where id_bilancio_cee=582;
update mastro set id_bilancio_cee=null where id_bilancio_cee=583;
update mastro set id_bilancio_cee=null where id_bilancio_cee=584;
update mastro set id_bilancio_cee=96 where id_bilancio_cee=585;
update mastro set id_bilancio_cee=97 where id_bilancio_cee=586;
update mastro set id_bilancio_cee=98 where id_bilancio_cee=587;
update mastro set id_bilancio_cee=99 where id_bilancio_cee=588;
update mastro set id_bilancio_cee=null where id_bilancio_cee=593;
update mastro set id_bilancio_cee=100 where id_bilancio_cee=589;
update mastro set id_bilancio_cee=101 where id_bilancio_cee=590;
update mastro set id_bilancio_cee=102 where id_bilancio_cee=591;
update mastro set id_bilancio_cee=103 where id_bilancio_cee=592;
update mastro set id_bilancio_cee=null where id_bilancio_cee=594;
update mastro set id_bilancio_cee=109 where id_bilancio_cee=595;
update mastro set id_bilancio_cee=111 where id_bilancio_cee=596;
update mastro set id_bilancio_cee=114 where id_bilancio_cee=597;
update mastro set id_bilancio_cee=117 where id_bilancio_cee=598;
update mastro set id_bilancio_cee=null where id_bilancio_cee=599;
update mastro set id_bilancio_cee=122 where id_bilancio_cee=600;
update mastro set id_bilancio_cee=160 where id_bilancio_cee=525;
update mastro set id_bilancio_cee=null where id_bilancio_cee=526;
update mastro set id_bilancio_cee=169 where id_bilancio_cee=527;
update mastro set id_bilancio_cee=170 where id_bilancio_cee=528;
update mastro set id_bilancio_cee=125 where id_bilancio_cee=601;
update mastro set id_bilancio_cee=131 where id_bilancio_cee=602;
update mastro set id_bilancio_cee=134 where id_bilancio_cee=603;
update mastro set id_bilancio_cee=135 where id_bilancio_cee=604;
update mastro set id_bilancio_cee=137 where id_bilancio_cee=521;
update mastro set id_bilancio_cee=null where id_bilancio_cee=522;
update mastro set id_bilancio_cee=146 where id_bilancio_cee=523;
update mastro set id_bilancio_cee=153 where id_bilancio_cee=524;
update mastro set id_bilancio_cee=null where id_bilancio_cee=529;
update mastro set id_bilancio_cee=121 where id_bilancio_cee=530;
update mastro set id_bilancio_cee=159 where id_bilancio_cee=539;
update mastro set id_bilancio_cee=166 where id_bilancio_cee=540;
update mastro set id_bilancio_cee=168 where id_bilancio_cee=541;
update mastro set id_bilancio_cee=171 where id_bilancio_cee=542;
update mastro set id_bilancio_cee=124 where id_bilancio_cee=531;
update mastro set id_bilancio_cee=130 where id_bilancio_cee=532;
update mastro set id_bilancio_cee=133 where id_bilancio_cee=533;
update mastro set id_bilancio_cee=null where id_bilancio_cee=534;
update mastro set id_bilancio_cee=137 where id_bilancio_cee=535;
update mastro set id_bilancio_cee=null where id_bilancio_cee=536;
update mastro set id_bilancio_cee=145 where id_bilancio_cee=537;
update mastro set id_bilancio_cee=152 where id_bilancio_cee=538;
update mastro set id_bilancio_cee=null where id_bilancio_cee=543;


end if; 



///FINE BILANCIO CEE


///VOCI CESPITE

DELETE from voci_menu where vmenu_voce='Stampe Libro Cespiti' and id_voci_menu_padre in  (select id_voci_menu from voci_menu where vmenu_voce='Ammortamenti');

call fn_ins_voce_menu('Ammortamenti', 'w_quote_cespite_ff', 'Storico Cespiti/Movimenti', 101);
call fn_ins_voce_menu('Ammortamenti', 'w_sintetica_ff', 'Stampa Dettagliata', 110);
call fn_ins_voce_menu('Ammortamenti', 'w_stp_elenco_attivi_rpt', 'Elenco Attivi', 115);
call fn_ins_voce_menu('Ammortamenti', 'w_dett_cespite_ff', 'Libro Ammortamenti', 120);


//distinta base
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'salta_lis_pref' )) THEN 
        
	alter table distinta add "salta_lis_pref" char(1) DEFAULT NULL;

end if;

//Id  riscossione inso per assegni
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_prof_reg_risc_ins' )) THEN 
        
        ALTER TABLE par_sistema ADD id_prof_reg_risc_ins integer DEFAULT NULL;

	begin				
	declare @ls_cod char(8);
	select codice into @ls_cod FROM azienda;
	if @ls_cod='ALTERINI' then
	        UPDATE par_sistema set id_prof_reg_risc_ins=98
    end if
	end;

end if; 


//////////////////////////////////////////
/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_011' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_011','Release 2_01_011  Cometa','S')
        ;

END IF
;

