//INIZIO 2_01_012

//Rettifica Ordinato CLI/FOR 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_ordcli_ret' )) THEN 
        
				alter table pers_par_sistema add id_prof_ordcli_ret integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_caucar_ordcli_ret' )) THEN 
        
				alter table pers_par_sistema add id_caucar_ordcli_ret integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_causca_ordcli_ret' )) THEN 
        
				alter table pers_par_sistema add id_causca_ordcli_ret integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_ordfor_ret' )) THEN 
        
				alter table pers_par_sistema add id_prof_ordfor_ret integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_caucar_ordfor_ret' )) THEN 
        
				alter table pers_par_sistema add id_caucar_ordfor_ret integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_causca_ordfor_ret' )) THEN 
        
				alter table pers_par_sistema add id_causca_ordfor_ret integer default null;
end if; 

call fn_ins_voce_menu('Utility', 'w_rettifica_ordcli_cx', 'Documento di rettifica Ordinato Clienti', 406);
call fn_ins_voce_menu('Utility', 'w_rettifica_ordfor_cx', 'Documento di rettifica Ordinato Fornitori', 408);
///////////////////////////////////////////

//Assegni Alterini
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'MOV_SCADENZA'
        AND      CNAME = 'STATO_ASS' )) THEN 

	ALTER TABLE MOV_SCADENZA ADD STATO_ASS CHAR(1) DEFAULT 'A';
	UPDATE MOV_SCADENZA SET STATO_ASS='A';
	UPDATE MOV_SCADENZA SET STATO_ASS='B' WHERE ID_SCADENZA=0;

end if;


ALTER TRIGGER "t_Mov_Scad_Agg_Assegni_bd".t_Mov_Scad_Agg_Assegni_bd before delete order 1
	on "DBA".Mov_Scadenza
	referencing old as old_Mov
	for each row
	begin
	  /* [RICCARDO -- ALTERINI]
	  Ricreo il movimento di assegno che verr cancellato dal cascade del mov_partita . */

	  if ((old_Mov.id_scad_riscossione>0 and old_Mov.id_scad_riscossione is not null) or  (old_Mov.id_ins_riscossione>0 and old_Mov.id_ins_riscossione is not null)) and old_mov.id_scadenza>0 then
	     insert into mov_scadenza ("id_scadenza", "data", "importo", "imp_valuta", "note", "id_azienda", 
	                               "id_doc_riscossione", "id_scad_riscossione", "id_ins_riscossione") 
	                       values (0, old_Mov.data, old_Mov.importo, old_Mov.imp_valuta, old_Mov.note, old_Mov.id_azienda, 
	                               old_Mov.id_doc_riscossione, old_Mov.id_scad_riscossione, old_mov.id_ins_riscossione) 
      else
          if old_mov.id_scadenza=0 and old_mov.stato_ass='B' then
             raiserror 99999 'Non e'' possibile modificare un movimento assegni con esito bloccato'
          end if
      end if
end;
//////////////////

//Stampa controllo magaz.
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'alterini_stat_venduto')) THEN
        
				CREATE TABLE "dba"."alterini_stat_venduto" (
				"id_azienda" integer NOT NULL DEFAULT autoincrement, 
				"id_esercizio" integer NOT NULL DEFAULT autoincrement, 
				"esercizio_codice" char(4) NOT NULL DEFAULT NULL, 
				"mese" numeric(2,0) DEFAULT NULL, 
				"giorno" numeric(8,0) DEFAULT NULL, 
				"id_articolo" integer NOT NULL DEFAULT autoincrement, 
				"articolo_codice" char(32) DEFAULT NULL, 
				"articolo_descrizione" char(80) DEFAULT NULL, 
				"cat_mer_codice" char(8) NOT NULL DEFAULT NULL, 
				"cat_mer_descrizione" char(40) DEFAULT NULL, 
				"cat_com_codice" char(8) NOT NULL DEFAULT NULL, 
				"cat_com_descrizione" char(40) DEFAULT NULL, 
				"qta_esistenza_iniziale" numeric(20,6) DEFAULT NULL, 
				"costo_medio_iniziale" numeric(20,6) DEFAULT NULL, 
				"qta_car" numeric(20,6) DEFAULT NULL, 
				"val_car" numeric(20,6) DEFAULT NULL, 
				"qta_scar_bc" numeric(20,6) DEFAULT NULL, 
				"val_scar_bc" numeric(20,6) DEFAULT NULL, 
				"qta_scar_vb" numeric(20,6) DEFAULT NULL, 
				"val_scar_vb" numeric(20,6) DEFAULT NULL, 
				"qta_scar_vb1" numeric(20,6) DEFAULT NULL, 
				"val_scar_vb1" numeric(20,6) DEFAULT NULL, 
				"qta_scar_vb2" numeric(20,6) DEFAULT NULL, 
				"val_scar_vb2" numeric(20,6) DEFAULT NULL, 
				"qta_esistenza_finale" numeric(20,6) DEFAULT NULL, 
				"costo_medio_finale" numeric(20,6) DEFAULT NULL, 
				"val_marg_bc" numeric(20,6) DEFAULT NULL, 
				"val_marg_vb" numeric(20,6) DEFAULT NULL, 
				"val_marg_vb1" numeric(20,6) DEFAULT NULL, 
				"val_marg_vb2" numeric(20,6) DEFAULT NULL, 
				"val_esistenza_iniziale" numeric(20,6) DEFAULT NULL, 
				"val_esistenza_finale" numeric(20,6) DEFAULT NULL) ;
				CREATE INDEX "ix_alterini_stat_1" ON "dba"."alterini_stat_venduto" ("esercizio_codice" , "articolo_codice" , "mese" ) in dvindex;
				CREATE INDEX "ix_alterini_stat_2" ON "dba"."alterini_stat_venduto" ("esercizio_codice" , "cat_com_codice" , "mese" ) in dvindex;        
END IF;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'alterini_stat_causali')) THEN

				create table alterini_stat_causali
				(
				id_azienda dm_id
				,id_caus_magazzino dm_id
				,segno_stat integer
				);  
END IF;				  

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_alterini_stat_venduto') THEN

				CREATE PROCEDURE "DBA"."sp_alterini_stat_venduto"(@li_id_azienda dm_id, @ld_data_inizio date, @ld_data_fine date, @ls_articolo_da char(32), @ls_articolo_a char(32))
				/* 
				
				Questa procedura, personalizzata per il cliente Alterini,
				estrae tutti i dati dei movimenti per articolo, con il saldo di giacenza valido
				alla fine del periodo indicato.
				
				
				
				Massimo Zurli
				Creato 			12/11/07
				Aggiornato 	17/11/07
				
				
				Vedi documentazione 
				C:\Documenti\start\clienti\Alterini\Alterini_302.doc
				
				*/
				
				
				BEGIN
					  declare @li_rows integer;
					  declare @ls_sqlstate char(5);  
					  declare @ls_sqlstate_var char(5); 
					  declare @ls_sqlstate_insert char(5);
					  declare @li_risultato char(100);
						declare @li_id_valuta  dm_id;
						declare @id_magazzino dm_id;
						declare @li_insert integer;
				  	--
						
				
						declare @li_id_articolo_prec dm_id;
						declare @ls_anno_prec dm_Cod_A4;
						declare @li_mese_prec numeric(2,0);
						declare @ls_profilo_codice_prec char(8);
				
						-- Costo finale
						declare @li_id_articolo_costo dm_id;
				
				    /*Dichiaro un cursore per cercare gli articoli*/
				    -- Variabili cursore
						declare @li_id_esercizio dm_id;
						declare @ls_esercizio_codice dm_Cod_A4;
						declare @ls_anno dm_Cod_A4;
						declare @li_mese numeric(2,0);
						declare @ls_profilo_codice char(8);
						declare @li_qta_pro numeric(20,6);
						declare @li_val_pro numeric(20,6);
						declare @li_giorno numeric(8,0);
						declare @li_id_articolo dm_id;
						declare @li_articolo_codice char(32);
						declare @ls_articolo_descrizione char(80);
						declare @ls_cat_mer_codice dm_Cod_A8;
						declare @ls_cat_mer_descrizione dm_Descrizione;
						declare @ls_cat_com_codice dm_Cod_A8;
						declare @ls_cat_com_descrizione dm_Descrizione;
						declare @li_qta_esistenza_iniziale numeric(20,6);
						declare @li_costo_medio_iniziale numeric(20,6);
						declare @li_qta_car numeric(20,6);
						declare @li_val_car numeric(20,6);
						declare @li_qta_scar_bc numeric(20,6);
						declare @li_val_scar_bc numeric(20,6);
						declare @li_qta_scar_vb numeric(20,6);
						declare @li_val_scar_vb numeric(20,6);
						declare @li_qta_scar_vb1 numeric(20,6);
						declare @li_val_scar_vb1 numeric(20,6);
						declare @li_qta_scar_vb2 numeric(20,6);
						declare @li_val_scar_vb2 numeric(20,6);
						declare @li_qta_esistenza_finale numeric(20,6);
						declare @li_costo_medio_finale numeric(20,6);
						declare @li_val_marg_bc numeric(20,6);
						declare @li_val_marg_vb numeric(20,6);
						declare @li_val_marg_vb1 numeric(20,6);
						declare @li_val_marg_vb2 numeric(20,6);
						declare @li_val_esistenza_iniziale numeric(20,6);
						declare @li_val_esistenza_finale numeric(20,6);
						-- Cursore
				    declare cur_articoli dynamic scroll cursor for 
						select 		
						ca.codice
						,ca.descrizione
						,cc.codice
						,cc.descrizione
						,a.codice
						,a.descrizione
						,a.id_articolo
						--,fn_esi_disp(@li_id_azienda, a.id_articolo ,@id_magazzino,@ls_esercizio_codice,12,@li_id_valuta)
						,se1.anno
						,se1.mese
						,se1.codice_pro
						,se1.qta
						,se1.valore
						FROM  articolo a, cat_com_articolo cc, cat_merceologica ca ,
						(
							select 
							year(d.data_documento) as anno
							,month(d.data_documento) as mese 
							,a.id_articolo as id_articolo
							,p.codice as codice_pro	
							--,sum(ifnull(r.qta_un_base,0,r.qta_un_base)*d.segno_iva) as qta
							,sum(ifnull(r.quantita,0,r.quantita)*c.segno_stat) as qta
							--,sum(ifnull(r.tot_riga_val_az,0,r.tot_riga_val_az)) as valore
							,sum(ifnull(r.prezzo_netto,0,r.prezzo_netto)*ifnull(r.quantita,0,r.quantita)*c.segno_stat) as valore
							from 
							documento  			d
							,riga_documento r
							,articolo 			a
							,prof_documento p
							,alterini_stat_causali c
							where d.data_documento>=@ld_data_inizio
							and d.data_documento  <=@ld_data_fine
							and r.id_documento=d.id_documento
							and r.id_caus_magazzino=c.id_caus_magazzino
							and a.id_articolo=r.id_articolo
							and a.id_articolo=r.id_articolo
							and d.id_prof_documento = p.id_prof_documento
							and p.codice in ('BC', 'CC','INV')
							and a.codice >= @ls_articolo_da
							and a.codice <= @ls_articolo_a
							group by year(d.data_documento), month(d.data_documento), a.id_articolo, p.codice
							union
							select 
							year(d.data_documento) as anno
							,month(d.data_documento) as mese
							,a.id_articolo as id_articolo
							,p.codice as codice_pro
							--,sum(ifnull(r.qta_un_base,0,r.qta_un_base)*d.segno_iva) as qta
							,sum(ifnull(r.quantita,0,r.quantita)*c.segno_stat) as qta
							--,sum(ifnull(r.tot_riga_val_az,0,r.tot_riga_val_az)*d.segno_iva) as valore
							,sum(ifnull(r.prezzo_netto,0,r.prezzo_netto)*ifnull(r.quantita,0,r.quantita)*c.segno_stat) as valore
							from 
							alt_documento  			d
							,alt_riga_documento r
							,articolo 			a
							,prof_documento p
							,alterini_stat_causali c
							where d.data_documento>=@ld_data_inizio
							and d.data_documento  <=@ld_data_fine
							and r.id_documento=d.id_documento
							and r.id_caus_magazzino=c.id_caus_magazzino
							and a.id_articolo=r.id_articolo
							and a.id_articolo=r.id_articolo
							and d.id_prof_documento = p.id_prof_documento
							and p.codice in ('VB', 'VB1','VB2')
							and a.codice >= @ls_articolo_da
							and a.codice <= @ls_articolo_a
							group by year(d.data_documento), month(d.data_documento), a.id_articolo, p.codice   ) se1		
						where a.id_azienda = @li_id_azienda
						and a.id_cat_com_articolo = cc.id_cat_com_articolo 
						and a.id_cat_merceologica = ca.id_cat_merceologica 
						and a.id_articolo = se1.id_articolo
						and a.codice >= @ls_articolo_da
						and a.codice <= @ls_articolo_a
						order by a.codice, se1.anno, se1.mese, se1.codice_pro;
				
						-- Cursore del costo medio finale
						declare cur_costo_finale dynamic scroll cursor for 		
							select 
							id_articolo,
							sum(
										ifnull(val_esistenza_iniziale,0,val_esistenza_iniziale)+
										ifnull(val_car,0,val_car)
									)
							/
							sum(
										ifnull(qta_esistenza_iniziale,0,qta_esistenza_iniziale)+ 
										ifnull(qta_car,0,qta_car)
									)
							from alterini_stat_venduto
							where id_azienda = @li_id_azienda
							and id_esercizio = @li_id_esercizio
							and mese >= month(@ld_data_inizio)
							and mese <= month(@ld_data_fine)
							and (articolo_codice >= @ls_articolo_da or @ls_articolo_da is null)
							and (articolo_codice <= @ls_articolo_a  or @ls_articolo_a  is null)
							and (qta_esistenza_iniziale <> 0 or qta_car <> 0)
							group by id_azienda, id_articolo ;				
				
				    
						//Traccio il momento di inizio elaborazione
				    message '**** Inizio Elaborazione ' || string(now(*));
				
				    /* Imposto le variabili base*/
						set @li_id_valuta = 3;
						set @id_magazzino = 3;
						set @li_insert = 0; -- Imposto il contatore per capire se inserire o meno il record
						
						if year(@ld_data_inizio) <> year(@ld_data_fine) then
							raiserror 99999 'Non  possibile elaborare pi di un esercizio alla volta'
						end if;
						
						select
						id_esercizio 
						,codice		
						into 
						@li_id_esercizio
						,@ls_esercizio_codice
						from esercizio
						where id_azienda = @li_id_azienda
						and data_inizio <= @ld_data_inizio
						and data_fine 	>= @ld_data_inizio ;
						set @ls_sqlstate=sqlstate;
								if(@ls_sqlstate <> '00000') then
								    message 'Errore su esercizio - stato: ' ||  @ls_sqlstate;				    
								end if;
						
						
						/* Inizio articoli*/
						-- Azzero i dati nella tabella d'appoggio
						delete alterini_stat_venduto
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and mese >= month(@ld_data_inizio)
						and mese <= month(@ld_data_fine)
						and (articolo_codice >= @ls_articolo_da or @ls_articolo_da is null)
						and (articolo_codice <= @ls_articolo_a  or @ls_articolo_a  is null)
						;
						
						/* Determino quelli con giacenza*/
						set @li_id_articolo_prec = 0;
						set @ls_anno_prec = '0';
						set @li_mese_prec = 0;
						set @ls_profilo_codice_prec = '0';
						open cur_articoli with hold;
				    set @ls_sqlstate = '00000';
				    
				    while @ls_sqlstate = '00000' loop
								fetch next cur_articoli into
										@ls_cat_mer_codice
										,@ls_cat_mer_descrizione
										,@ls_cat_com_codice
										,@ls_cat_com_descrizione
										,@li_articolo_codice
										,@ls_articolo_descrizione
										,@li_id_articolo
										--,@li_risultato 
										,@ls_anno
										,@li_mese
										,@ls_profilo_codice
										,@li_qta_pro
										,@li_val_pro
									  ;
								set @ls_sqlstate=sqlstate;
								if(@ls_sqlstate <> '00000') then
								    message 'Errore su fetch articolo' || @li_articolo_codice || ' stato ' ||  @ls_sqlstate;				    
								else 
										set @li_qta_esistenza_finale= convert(numeric(20,4),trim(substr(@li_risultato,1,20)));
								end if;
															
								//Azzero le variabili prima della lettura dei valori
								set @li_qta_car = 0;
								set @li_val_car = 0;
								set @li_qta_scar_bc = 0;
								set @li_val_scar_bc = 0;
								set @li_qta_scar_vb = 0;
								set @li_val_scar_vb = 0;
								set @li_qta_scar_vb1 = 0;
								set @li_val_scar_vb1 = 0;
								set @li_qta_scar_vb2 = 0;
								set @li_val_scar_vb2 = 0;
								set @li_qta_esistenza_finale = 0;
								set @li_costo_medio_finale = 0;
								set @li_val_marg_bc = 0;
								set @li_val_marg_vb = 0;
								set @li_val_marg_vb1 = 0;
								set @li_val_marg_vb2 = 0;
								set @li_val_esistenza_iniziale = 0;
								set @li_val_esistenza_finale = 0;
								--
								set @li_qta_esistenza_iniziale = 0;
								set @li_costo_medio_iniziale = 0;
										
								
								/* Sospesa
								if @li_id_articolo_prec <> @li_id_articolo then
									set @li_qta_esistenza_iniziale = 0;
									set @li_costo_medio_iniziale = 0;
								end if;*/
					
								if @li_id_articolo_prec = @li_id_articolo
										and @ls_anno_prec = @ls_anno
										and @li_mese_prec = @li_mese then
											case  @ls_profilo_codice 
												when 'INV' then
												-- Determino il costo iniziale per l'anno 2007
													select 
													max(ifnull(r.prezzo_netto,0,r.prezzo_netto))
													into 
													@li_costo_medio_iniziale
													from 
													documento  			d
													,riga_documento r
													,articolo 			a
													,prof_documento p
													where r.id_documento=d.id_documento
													and a.id_articolo=r.id_articolo
													and d.id_prof_documento = p.id_prof_documento
													and p.codice in ('Z01','Z02','Z03','Z04')
													and a.id_articolo = @li_id_articolo;
													--message 'Costo medio iniziale upt ' || @li_costo_medio_iniziale || ' articolo ' ||  @li_id_articolo;				    
													update alterini_stat_venduto
													set qta_esistenza_iniziale = @li_qta_pro,
													--costo_medio_iniziale = @li_val_pro
													costo_medio_iniziale = ifnull(@li_costo_medio_iniziale,0,@li_costo_medio_iniziale) -- Questa variazione  valida solo per il 2007
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;										
												when 'CC' then
													update alterini_stat_venduto
													set qta_car = @li_qta_pro,
													val_car = @li_val_pro
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;
												when 'BC' then
													update alterini_stat_venduto
													set qta_scar_bc = @li_qta_pro,
													val_scar_bc = @li_val_pro
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;
												when 'VB' then
													update alterini_stat_venduto
													set qta_scar_vb = @li_qta_pro,
													val_scar_vb = @li_val_pro
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;
												when 'VB1' then
													update alterini_stat_venduto
													set qta_scar_vb1 = @li_qta_pro,
													val_scar_vb1 = @li_val_pro
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;
												when 'VB2' then
													update alterini_stat_venduto
													set qta_scar_vb2 = @li_qta_pro,
													val_scar_vb2 = @li_val_pro
													where id_azienda = @li_id_azienda
													and esercizio_codice = @ls_anno
													and mese = @li_mese
													and id_articolo = @li_id_articolo;
							  	end case;															
				
								else
									-- Azzero le variabili
									set @li_id_articolo_prec = @li_id_articolo;
									set @ls_anno_prec = @ls_anno;
									set @li_mese_prec = @li_mese;
									set @ls_profilo_codice_prec = @ls_profilo_codice;		
									set @li_insert = 0; -- Imposto il contatore per capire se inserire o meno il record	
									
									case  @ls_profilo_codice
												when 'INV' then
													set @li_qta_esistenza_iniziale = @li_qta_pro;
													set @li_costo_medio_iniziale = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro;
													-- Determino il costo iniziale per l'anno 2007
													select 
													max(ifnull(r.prezzo_netto,0,r.prezzo_netto))
													into 
													@li_costo_medio_iniziale
													from 
													documento  			d
													,riga_documento r
													,articolo 			a
													,prof_documento p
													where r.id_documento=d.id_documento
													and a.id_articolo=r.id_articolo
													and d.id_prof_documento = p.id_prof_documento
													and p.codice in ('Z01','Z02','Z03','Z04')
													and a.id_articolo = @li_id_articolo;
													set @li_costo_medio_iniziale = ifnull(@li_costo_medio_iniziale,0,@li_costo_medio_iniziale);
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
													--message 'Costo medio iniziale ins ' || @li_costo_medio_iniziale || ' articolo ' ||  @li_id_articolo;
												when 'CC' then
													set @li_qta_car = @li_qta_pro;
													set @li_val_car = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro;
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
												when 'BC' then									
													set @li_qta_scar_bc = @li_qta_pro;
													set @li_val_scar_bc = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro*-1;
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
												when 'VB' then									
													set @li_qta_scar_vb = @li_qta_pro;
													set @li_val_scar_vb = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro*-1;
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
												when 'VB1' then									
													set @li_qta_scar_vb1 = @li_qta_pro;
													set @li_val_scar_vb1 = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro*-1;
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
												when 'VB2' then									
													set @li_qta_scar_vb2 = @li_qta_pro;
													set @li_val_scar_vb2 = @li_val_pro;
													set @li_qta_esistenza_finale = @li_qta_pro*-1;
													set @li_insert = 1; -- Imposto il contatore per capire se inserire o meno il record
												else
													set @li_insert = 0; -- Imposto il contatore per capire se inserire o meno il record
							  end case;			
							  --message 'Insert articolo' || @li_articolo_codice || ' stato ' || @li_insert || ' profilo ' || @ls_profilo_codice ;	
							  if @li_insert = 1 then -- Test sull'inserimento di righe vuote
									-- Scrivo i dati nella tabella d'appoggio
									insert into alterini_stat_venduto
									(
									id_azienda
									,id_esercizio
									,esercizio_codice
									,mese
									,giorno
									,id_articolo
									,articolo_codice
									,articolo_descrizione
									,cat_mer_codice
									,cat_mer_descrizione
									,cat_com_codice
									,cat_com_descrizione
									,qta_esistenza_iniziale
									,costo_medio_iniziale
									,qta_car
									,val_car
									,qta_scar_bc
									,val_scar_bc
									,qta_scar_vb
									,val_scar_vb
									,qta_scar_vb1
									,val_scar_vb1
									,qta_scar_vb2
									,val_scar_vb2
									,qta_esistenza_finale
									,costo_medio_finale
									,val_marg_bc
									,val_marg_vb
									,val_marg_vb1
									,val_marg_vb2
									,val_esistenza_iniziale
									,val_esistenza_finale
									)
									values
									(
									@li_id_azienda													
									,@li_id_esercizio
									,@ls_esercizio_codice
									,@li_mese
									,@li_giorno
									,@li_id_articolo
									,@li_articolo_codice
									,@ls_articolo_descrizione
									,@ls_cat_mer_codice
									,@ls_cat_mer_descrizione
									,@ls_cat_com_codice
									,@ls_cat_com_descrizione
									,@li_qta_esistenza_iniziale
									,@li_costo_medio_iniziale
									,@li_qta_car
									,@li_val_car
									,@li_qta_scar_bc
									,@li_val_scar_bc
									,@li_qta_scar_vb
									,@li_val_scar_vb
									,@li_qta_scar_vb1
									,@li_val_scar_vb1
									,@li_qta_scar_vb2
									,@li_val_scar_vb2
									,@li_qta_esistenza_finale
									,@li_costo_medio_finale
									,@li_val_marg_bc
									,@li_val_marg_vb
									,@li_val_marg_vb1
									,@li_val_marg_vb2
									,@li_val_esistenza_iniziale
									,@li_val_esistenza_finale
									);
									set @ls_sqlstate_insert=sqlstate;
									if(@ls_sqlstate_insert <> '00000') then
										message 'Errore su inserimento statistica' || @li_id_articolo || ' stato ' ||  @ls_sqlstate;				    
									else 
										--message 'Inserito articolo' || @li_id_articolo ;
										set @ls_sqlstate_insert = '00000';
									end if;
							 end if;			-- Fine Test sull'inserimento di righe vuote
							end if;														
									
				    end loop;
						close cur_articoli;
						/* Fine articoli */
						
						-- Aggiorno la giacenza finale
						message 'Update giacenza e valore' ;
				  	update alterini_stat_venduto
						set qta_esistenza_finale = qta_esistenza_iniziale + qta_car - qta_scar_bc - qta_scar_vb - qta_scar_vb1 - qta_scar_vb2,
						val_esistenza_iniziale = qta_esistenza_iniziale * costo_medio_iniziale
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio;		
						
						-- Aggiorno il costo finale
						message 'Update costo medio valore finale' ;
						open cur_costo_finale with hold;
				    set @ls_sqlstate = '00000';    
				    while @ls_sqlstate = '00000' loop
								fetch next cur_costo_finale into
								  @li_id_articolo_costo,
									@li_costo_medio_finale;
								set @ls_sqlstate=sqlstate;
								if(@ls_sqlstate <> '00000') then
								    message 'Fine estrazione costo medio' || ' stato ' ||  @ls_sqlstate;				    
								else 
										--set @li_costo_medio_finale= 0;
						--				message 'Costo medio' || @li_costo_medio_finale || ' articolo ' ||  @li_id_articolo_costo;				    
								end if;
						
						
					  	update alterini_stat_venduto
							set costo_medio_finale = @li_costo_medio_finale ,
							val_esistenza_finale = qta_esistenza_finale * @li_costo_medio_finale
							where id_azienda = @li_id_azienda
							and id_esercizio = @li_id_esercizio
							and mese <= month(@ld_data_fine)
							and id_articolo = @li_id_articolo_costo;		
								
						end loop;
						close cur_costo_finale;
						
						-- Aggiorno il margine
						-- BC
						message 'Margine BC ' ;
				  	update alterini_stat_venduto
						--set val_marg_bc = (val_scar_bc / qta_scar_bc )-costo_medio_finale	-- Differenza sul ricavo/costo	
						set val_marg_bc = ((val_scar_bc / qta_scar_bc )-costo_medio_finale)*qta_scar_bc -- Ricavo
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and (qta_scar_bc)  <> 0;		
						-- VB
						message 'Margine VB ' ;
						update alterini_stat_venduto
						--set val_marg_vb = (val_scar_vb / qta_scar_vb )-costo_medio_finale	-- Differenza sul ricavo/costo
						set val_marg_vb = ((val_scar_vb / qta_scar_vb )-costo_medio_finale)*qta_scar_vb -- Ricavo 
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and (qta_scar_vb)  <> 0;		
						-- VB1
						message 'Margine VB1 ' ;
						update alterini_stat_venduto
						--set val_marg_vb1 = (val_scar_vb1 / qta_scar_vb1 )-costo_medio_finale	-- Differenza sul ricavo/costo
						set val_marg_vb1 = ((val_scar_vb1 / qta_scar_vb1 )-costo_medio_finale)*qta_scar_vb1  -- Ricavo
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and (qta_scar_vb1)  <> 0;			
						-- VB2
						message 'Margine VB2 ' ;
						update alterini_stat_venduto
						--set val_marg_vb2 = (val_scar_vb2 / qta_scar_vb2 )-costo_medio_finale	-- Differenza sul ricavo/costo
						set val_marg_vb2 = ((val_scar_vb2 / qta_scar_vb2 )-costo_medio_finale)*qta_scar_vb2 -- Ricavo
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and (qta_scar_vb2)  <> 0;	
				
				
						/* Come ultima operazione faccio pulizia dei record con tutti i valori vuoti*/
						delete alterini_stat_venduto
						where id_azienda = @li_id_azienda
						and id_esercizio = @li_id_esercizio
						and mese >= month(@ld_data_inizio)
						and mese <= month(@ld_data_fine)
						and (articolo_codice >= @ls_articolo_da or @ls_articolo_da is null)
						and (articolo_codice <= @ls_articolo_a  or @ls_articolo_a  is null)
						and qta_esistenza_iniziale+qta_car+qta_scar_bc+qta_scar_vb+qta_scar_vb1+qta_scar_vb2=0;
				
					//Traccio il momento di fine elaborazione
				  message '**** Fine Elaborazione ' || string(now(*));
				
				end;
     
END IF;        
///////////////////////////
        

call fn_ins_voce_menu('Documento', 'w_stampa_doc_pagamenti_ff', 'Stampa Dettaglio Pagamenti', 25);



//BLOCCO PAGAMENTI SU PROFILI SELEZIONATI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'con_pagamento'
        AND      CNAME = 'segui_blocco_prof' )) THEN 
        
	alter table con_pagamento add segui_blocco_prof char(1) default 'N';
end if; 

//PACKING LIST - ASP BENI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'asp_beni'
        AND      CNAME = 'usa_packing' )) THEN 
        
	alter table asp_beni add usa_packing char(1) default 'N';
	update asp_beni set usa_packing='N';
end if; 

//PACKING LIST - ASP BENI
IF (EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'usa_packing_list' )) THEN 
        
	alter table prof_documento drop usa_packing_list;
end if; 

//COMMESSE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'dest_locaz' )) THEN 
        
				alter table par_sistema_commesse add dest_locaz char(1) default null;
end if; 

//////////////////////PERSONALIZZAZIONE CCT
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_par_sistema')) THEN
        
				CREATE TABLE "dba"."cct_par_sistema" (
				"id_cct_par_sistema" integer NOT NULL DEFAULT autoincrement, 
				"id_sottomastro" integer DEFAULT NULL , 
				"id_prof_documento" integer DEFAULT NULL , 
				"id_locazione" integer DEFAULT NULL , 								
				PRIMARY KEY ("id_cct_par_sistema")) ;				
end if;				

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_sogcom')) THEN
        
				CREATE TABLE "dba"."cct_sogcom" (
				"id_cct_sogcom" integer NOT NULL DEFAULT autoincrement, 
				"codice" char(8) DEFAULT NULL, 
				"rag_soc_1" char(30) DEFAULT NULL, 
				"rag_soc_2" char(30) DEFAULT NULL, 
				"indirizzo" char(30) DEFAULT NULL, 
				"cap" char(7) DEFAULT NULL, 
				"citta" char(30) DEFAULT NULL, 
				"codice_iso" char(2) DEFAULT NULL, 
				"partita_iva" char(12) DEFAULT NULL, 
				"codice_lingua" char(1) DEFAULT NULL, 
				"telefono" char(20) DEFAULT NULL, 
				"telex" char(20) DEFAULT NULL, 
				"fax" char(20) DEFAULT NULL, 
				"email" char(50) DEFAULT NULL, 
				"codice_fatturazione" char(8) DEFAULT NULL, 
				"codice_valuta" char(3) DEFAULT NULL, 
				"note" char(60) DEFAULT NULL , 
				PRIMARY KEY ("id_cct_sogcom")) ;

				CREATE UNIQUE INDEX "ix_cct_sogcom_1" ON "dba"."cct_sogcom" ("codice" ) in dvindex;
				CREATE INDEX "ix_cct_sogcom_2" ON "dba"."cct_sogcom" ("rag_soc_1" , "codice" ) in dvindex;				
end if;				

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_documento')) THEN
        
				CREATE TABLE "dba"."cct_documento" (
				"id_documento" integer NOT NULL DEFAULT NULL, 
				"id_esercizio" integer DEFAULT NULL, 
				"registro" char(5) DEFAULT NULL, 
				"num_progressivo" integer DEFAULT NULL, 
				"data_registrazione" char(8) DEFAULT NULL, 
				"cod_sogcom" char(8) DEFAULT NULL, 
				"tipo_sogcom" integer NOT NULL DEFAULT NULL, 
				"destinazione" char(50) DEFAULT NULL, 
				"indirizzo1_dest" char(50) DEFAULT NULL, 
				"indirizzo2_dest" char(50) DEFAULT NULL, 
				"indirizzo3_dest" char(50) DEFAULT NULL, 
				"indirizzo4_dest" char(50) DEFAULT NULL, 
				"cap_dest" char(12) DEFAULT NULL, 
				"localita_dest" char(50) DEFAULT NULL, 
				"prov_dest" char(5) DEFAULT NULL, 
				"nazione_dest" char(3) DEFAULT NULL, 
				"note_intestazione" char(60) DEFAULT NULL, 
				"tipo_trasporto" char(50) DEFAULT NULL, 
				"vettore" char(50) DEFAULT NULL, 
				"cod_valuta" char(3) DEFAULT NULL, 
				"tipo_bolla" integer DEFAULT NULL, 
				"elaborata" integer DEFAULT NULL, 
				"fatturata" integer DEFAULT NULL, 
				"data_fattura" char(8) DEFAULT NULL, 
				"anno_fattura" integer DEFAULT NULL, 
				"tipo_doc" char(2) DEFAULT NULL, 
				"num_fattura" char(8) DEFAULT NULL, 
				"id_utente" char(10) DEFAULT NULL, 
				"id_programma" char(10) DEFAULT NULL, 
				"id_stazione_lavoro" char(10) DEFAULT NULL, 
				"data_ultimo_agg" char(8) DEFAULT NULL, 
				"ora_ultimo_agg" integer DEFAULT NULL , 
				"id_f55scctt" integer DEFAULT NULL ,
				PRIMARY KEY ("id_documento", "tipo_sogcom")) ;
				
				CREATE UNIQUE INDEX "ix_cct_documento_1" ON "dba"."cct_documento" ("id_documento" , "tipo_sogcom" ) ;        
end if;        

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_riga_documento')) THEN
        
				CREATE TABLE "dba"."cct_riga_documento" (
				"num_riga" integer NOT NULL DEFAULT NULL, 
				"tipo_riga" char(1) DEFAULT NULL, 
				"id_documento" integer NOT NULL DEFAULT NULL, 
				"tipo_sogcom" integer NOT NULL DEFAULT NULL, 
				"num_packing" integer DEFAULT NULL, 
				"cod_lavorazione" char(20) DEFAULT NULL, 
				"des_lavorazione1" char(60) DEFAULT NULL, 
				"des_lavorazione2" char(60) DEFAULT NULL, 
				"des_lavorazione3" char(60) DEFAULT NULL, 
				"des_lavorazione4" char(60) DEFAULT NULL, 
				"des_lavorazione5" char(60) DEFAULT NULL, 
				"des_lavorazione6" char(60) DEFAULT NULL, 
				"des_lavorazione7" char(60) DEFAULT NULL, 
				"des_lavorazione8" char(60) DEFAULT NULL, 
				"um" char(2) DEFAULT NULL, 
				"num_colli" integer DEFAULT NULL, 
				"qta_spedita" numeric(15,3) DEFAULT NULL, 
				"prezzo" numeric(15,5) DEFAULT NULL, 
				"id_utente" char(10) DEFAULT NULL, 
				"id_programma" char(10) DEFAULT NULL, 
				"id_stazione_lavoro" char(10) DEFAULT NULL, 
				"data_ultimo_agg" char(8) DEFAULT NULL, 
				"ora_ultimo_agg" integer DEFAULT NULL, 
				"purchase_order" char(10) DEFAULT NULL , 
				"id_f55scctt" integer DEFAULT NULL ,
				PRIMARY KEY ("id_documento", "tipo_sogcom", "num_riga") , 
				FOREIGN KEY "fk_cct_riga_documento_1" ("id_documento", "tipo_sogcom" ) REFERENCES "dba"."cct_documento" ON DELETE CASCADE ) ;
				
				CREATE UNIQUE INDEX "ix_cct_riga_documento_1" ON "dba"."cct_riga_documento" ("id_documento" , "tipo_sogcom" , "num_riga" ) ;        
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_doc_ext')) THEN
        
				CREATE TABLE "dba"."cct_doc_ext" (
				"id_documento" integer NOT NULL DEFAULT NULL, 
				"id_documento_cct" integer DEFAULT NULL, 
				"tipo_sogcom_cct" integer DEFAULT NULL, 
				"tipo_bolla" integer DEFAULT NULL, 
				"data_fattura" char(8) DEFAULT NULL, 
				"anno_fattura" integer DEFAULT NULL, 
				"tipo_doc" char(2) DEFAULT NULL, 
				"num_fattura" char(8) DEFAULT NULL, 
				"dest_rag_soc1" char(50) DEFAULT NULL, 
				"dest_ind1" char(50) DEFAULT NULL, 
				"dest_ind2" char(50) DEFAULT NULL, 
				"dest_ind3" char(50) DEFAULT NULL, 
				"dest_ind4" char(50) DEFAULT NULL, 
				"dest_cap" char(12) DEFAULT NULL, 
				"dest_citta" char(50) DEFAULT NULL, 
				"dest_prov" char(5) DEFAULT NULL, 
				"dest_naz" char(3) DEFAULT NULL , 
				"trasmesso" integer DEFAULT 1 , 
				"id_f55scctt" integer DEFAULT NULL ,
				PRIMARY KEY ("id_documento") , 
				FOREIGN KEY "fk_cct_doc_ext_1" ("id_documento" ) REFERENCES "dba"."documento" ON DELETE CASCADE ) ;   
				        
end if;          

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_rigadoc_ext')) THEN
        
				CREATE TABLE "dba"."cct_rigadoc_ext" (
				"id_riga_documento" integer NOT NULL DEFAULT NULL, 
				"id_documento_cct" integer DEFAULT NULL, 
				"tipo_sogcom_cct" integer DEFAULT NULL, 
				"num_riga_cct" integer DEFAULT NULL, 
				"num_packing" integer DEFAULT NULL, 
				"um" char(2) DEFAULT NULL, 
				"purchase_order" char(10) DEFAULT NULL , 
				"id_f55scctt" integer DEFAULT NULL ,
				PRIMARY KEY ("id_riga_documento") , 
				FOREIGN KEY "fk_rigadoc_ext_1" ("id_riga_documento" ) REFERENCES "dba"."riga_documento" ON DELETE CASCADE ) ;        
end if;            

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cct_doc_ext_deleted')) THEN
        
				CREATE TABLE "dba"."cct_doc_ext_deleted" ("id_f55scctt" integer DEFAULT NULL) ;
				CREATE INDEX "ix_cct_doc_ext_deleted_1" ON "dba"."cct_doc_ext_deleted" ("id_f55scctt" ) ;

end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_documento'
        AND      CNAME = 'id_f55scctt' )) THEN 
        
        alter table cct_documento add id_f55scctt integer default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_riga_documento'
        AND      CNAME = 'id_f55scctt' )) THEN 
        
        alter table cct_riga_documento add id_f55scctt integer default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_doc_ext'
        AND      CNAME = 'trasmesso' )) THEN 
        
        alter table cct_doc_ext add trasmesso integer default 1;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_doc_ext'
        AND      CNAME = 'id_f55scctt' )) THEN 
        
        alter table cct_doc_ext add id_f55scctt integer default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'id_f55scctt' )) THEN 
        
        alter table cct_rigadoc_ext add id_f55scctt integer default null;
end if;
       
IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_agg_cct_ext_ad')) THEN
        
				CREATE TRIGGER "t_agg_cct_ext_ad" BEFORE DELETE
				ORDER 2 ON "DBA"."riga_documento" 
				REFERENCING OLD AS old_riga_documento
				FOR EACH ROW 
				BEGIN
					  declare @ll_id_riga_ref integer;
				      declare @ll_id_doc_ctt integer;
				      declare @ls_tipo_reg char(2);
				
					  set @ll_id_riga_ref=old_riga_documento.id_riga_doc_provenienza;
				
					  select registro.tipo_registro
					    into @ls_tipo_reg from "dba".documento,"dba".registro
					    where(registro.id_registro=documento.id_registro)
					    and((documento.id_documento=old_riga_documento.id_documento));
				
					  if @ll_id_riga_ref>0 and @ls_tipo_reg = 'IV' then
						select d.id_documento			
						into @ll_id_doc_ctt 
						from "dba".documento as d, "dba".riga_documento as r
						where d.id_documento = r.id_documento
						and r.id_riga_documento = @ll_id_riga_ref;
				
					    update cct_doc_ext as c
				          set c.data_fattura='', c.anno_fattura=0, c.num_fattura='', c.trasmesso = 1
					      where c.id_documento=@ll_id_doc_ctt
					  end if
					  ; //
				END      
end if;    

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_agg_cct_ext_del_ad')) THEN
				CREATE TRIGGER "t_agg_cct_ext_del_ad" BEFORE DELETE
				ORDER 1 ON "DBA"."cct_doc_ext"
				REFERENCING OLD AS old_cct_doc_ext
				FOR EACH ROW
				BEGIN
					 declare @ll_id_f55scctt integer;
				
				   set @ll_id_f55scctt=old_cct_doc_ext.id_f55scctt;
					 if @ll_id_f55scctt>0 then
				        insert into cct_doc_ext_deleted (id_f55scctt)
				        values (@ll_id_f55scctt)
					 end if
					 ; //
				END;        
end if;       

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'cod_lavorazione' )) THEN 
        
        alter table cct_rigadoc_ext add cod_lavorazione char(20) DEFAULT NULL;
end if;    

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione1' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione1 char(60) DEFAULT NULL;
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione2' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione2 char(60) DEFAULT NULL;
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione3' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione3 char(60) DEFAULT NULL;
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione4' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione4 char(60) DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione5' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione5 char(60) DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione6' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione6 char(60) DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione7' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione7 char(60) DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_rigadoc_ext'
        AND      CNAME = 'des_lavorazione8' )) THEN 
        
        alter table cct_rigadoc_ext add des_lavorazione8 char(60) DEFAULT NULL;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_sogcom'
        AND      CNAME = 'cod_fiscale' )) THEN 
        
        alter table cct_sogcom add cod_fiscale char(16) DEFAULT NULL;
end if; 
///////////////////////////////////////////



call fn_ins_voce_menu('Ammortamenti', 'w_stp_fondo_ff', 'Stampa Ammortamenti', 121);

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'storico_valuta')) THEN

	CREATE TABLE "dba"."storico_valuta" ("id_storico_valuta" integer NOT NULL DEFAULT autoincrement, 
	"id_valuta" integer NOT NULL DEFAULT NULL, 
	"data_var" date NOT NULL DEFAULT NULL, 
	"cambio" numeric(8,4) NOT NULL DEFAULT NULL, 
	"parita_euro" numeric(8,4) DEFAULT NULL , PRIMARY KEY ("id_storico_valuta")) ;

	CREATE TRIGGER "t_valuta_au" AFTER UPDATE OF "parita_euro"
	ORDER 1 ON "DBA"."valuta"
	REFERENCING NEW AS new_val
	FOR EACH ROW /* WHEN( search_condition ) */
	BEGIN
	    insert into storico_valuta (id_valuta, data_var, "cambio", "parita_euro")
	    values ( new_val.id_valuta , today(), new_val.cambio, new_val.parita_euro);
	END;

end if;



IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_prof_pagamenti' )) THEN 
	ALTER TABLE "dba"."par_sistema" ADD "id_prof_pagamenti" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_prof_riscossioni" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_abb_pas" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_pag_cpt" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_abb_att" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_camb_pas" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_camb_att" integer DEFAULT NULL;
end if;

//TRASFERIMENTO DATI PARIGI
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte8') THEN
        
				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte8"()
				begin
				
				  declare @li_record integer;
				  //
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create  table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      )  
				  end if
				  ;
				
				  if(exists(select 1 from sys.systable where table_name='tmp_documento')) then
				    drop table tmp_documento
				  end if
				  ;
				 
				  create  table
				    "dba".tmp_documento(
				    id_documento integer not null,
				    id_prof_documento integer not null,
				    id_registro integer not null,
				    num_progressivo decimal(12) not null,
				    data_registrazione date not null,
				    num_documento char(16) null,
				    data_documento date null,
				    data_competenza date null,
				    id_prof_registrazione integer null,
				    des_contabile char(40) null,
				    id_sog_commerciale integer not null,
				    id_destinazione integer null,
				    id_caus_magazzino integer null,
				    id_magazzino integer null,
				    id_magazzino_2 integer null,
				    id_sog_commerciale_fattura integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    id_valuta integer not null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_pagamento integer null,
				    id_gruppo_agenti integer null,
				    id_banca_sog_commerciale integer null,
				    origine char(40) null,
				    interlocutore char(40) null,
				    data_prev_consegna date null,
				    note_intestazione long varchar null,
				    num_colli decimal(8) null,
				    id_unita_misura_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_misura_volume integer null,
				    volume decimal(18,4) null default 0,
				    id_tipo_trasporto integer null,
				    id_caus_trasporto integer null,
				    asp_beni char(40) null,
				    tras_mezzo char(1) null,
				    id_sog_commerciale_vettore integer null,
				    id_sog_commerciale_vettore_2 integer null,
				    mezzo_trasporto char(40) null,
				    targa_mezzo_trasporto char(40) null,
				    data_trasporto date null,
				    ora_trasporto time null,
				    sconto_finanziario char(40) null,
				    sconto_fin_incondizionato decimal(18,4) null,
				    sconto_fin_cassa decimal(5,2) null,
				    data_dec_pagamento date null,
				    imp_acconto decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    stampato char(1) null,
				    contabilizzato char(1) null,
				    evaso_totalmente char(1) null,
				    chius_forzata char(1) null,
				    sospeso char(1) null,
				    data_scadenza date null,
				    creato_in_esenzione char(1) null,
				    bloccato char(1) null,
				    prog_globale decimal(16) null,
				    doc_globale decimal(16) null,
				    tipo_fattura char(1) null,
				    segno_iva decimal(2) null default 1,
				    id_documento_padre integer null,
				    id_azienda integer not null default 1,
				    id_tipo_pag_acconto integer null,
				    id_tab_iva_acconto integer null,
				    id_val_acconto integer null,
				    ora_registrazione time null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    storno_anticipi char(1) null,
				    id_variazione integer null,
				    bollo char(20) null,
				    id_gruppo_agenti_2 integer null,
				    data_ric_consegna date null,
				    num_riga integer null,
				    id_utente integer null,
				    alt_pag char(1) null,
				    alt_ord char(1) null,
				    id_cat_zona integer null,
				    primary key(id_documento),
				    )  ;
				  //
				  create unique index xak1tmp_documento on
				    "dba".tmp_documento(id_registro asc,num_progressivo asc,data_registrazione asc);
				  //
				  load into table tmp_documento from 'C:\\windows\\temp\\documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_documento;
				  //
				  message 'tabella TMP DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - RIGHE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_riga_documento')) then
				    drop table tmp_riga_documento
				  end if
				  ;
				  create  table "dba".tmp_riga_documento(
				    id_riga_documento integer not null,
				    id_documento integer null,
				    id_unita_confezione integer null,
				    id_gruppo_agenti integer null,
				    num_riga decimal(4) null,
				    id_articolo integer null,
				    descrizione long varchar null,
				    id_des_articolo integer null,
				    quantita decimal(18,4) null,
				    qta_sconto_merce decimal(18,4) null,
				    qta_evasa decimal(18,4) null,
				    fat_con_unita_base decimal(8,4) null,
				    fat_con_globale decimal(8,4) null,
				    qta_un_base decimal(18,4) null,
				    qta_evasa_un_base decimal(18,4) null,
				    id_caus_magazzino integer null,
				    id_locazione_1 integer null,
				    id_locazione_2 integer null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    id_listino integer null,
				    id_con_lis_articolo integer null,
				    prezzo decimal(18,4) null,
				    sconto char(40) null,
				    prezzo_netto decimal(18,4) null,
				    sconto_riga decimal(18,4) null,
				    data_prevista_consegna date null,
				    peso_netto decimal(18,4) null,
				    peso_lordo decimal(18,4) null,
				    dim_l decimal(18,4) null,
				    dim_h decimal(18,4) null,
				    dim_p decimal(18,4) null,
				    num_colli decimal(8) null,
				    id_tab_iva integer null,
				    val_attribuito decimal(18,4) null,
				    provv_agente decimal(5,2) null,
				    provv_subage decimal(5,2) null,
				    provv_carea decimal(5,2) null,
				    id_caus_trasporto integer null,
				    forza_chius_evasione char(1) null,
				    sospesa char(1) null,
				    da_stampare char(1) null,
				    data_inizio_competenza date null,
				    data_fine_competenza date null,
				    tot_riga_val_riga decimal(18,4) null,
				    tot_riga_val_doc decimal(18,4) null,
				    tot_riga_val_az decimal(18,4) null,
				    id_riga_doc_provenienza integer null,
				    id_conto integer null,
				    id_azienda integer null,
				    id_riga_doc_padre integer null,
				    provv_imp_agente decimal(18,4) null,
				    provv_imp_subage decimal(18,4) null,
				    provv_imp_carea decimal(18,4) null,
				    id_riga_lotto integer null,
				    qta_ordinata_fo decimal(18,4) null,
				    ordinato_fo char(1) null,
				    peso_netto_evaso decimal(18,4) null,
				    id_gruppo_Agenti_2 integer null,
				    provv_agente_2 decimal(5,2) null,
				    provv_subage_2 decimal(5,2) null,
				    provv_carea_2 decimal(5,2) null,
				    provv_imp_agente_2 decimal(18,4) null,
				    provv_imp_subage_2 decimal(18,4) null,
				    provv_imp_carea_2 decimal(18,4) null,
				    id_art_var1 integer null,
				    id_art_var2 integer null,
				    id_art_var3 integer null,
				    id_distinta integer null,
				    id_operatore integer null,
				    id_alt_uc1 integer null,
				    id_alt_uc2 integer null,
				    id_alt_uc3 integer null,
				    articolo_codice char(32),
				    uc_codice char(8),
				    primary key(id_riga_documento),
				    )  ;
				  //
				  create unique index ak1_tmp_riga_documento on tmp_riga_documento(id_documento asc,num_riga asc);
				  load into table tmp_riga_documento from 'C:\\windows\\temp\\riga_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_riga_documento;
				  //
				  message 'tabella TMP RIGA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_iva_documento')) then
				    drop table tmp_cast_iva_documento
				  end if
				  ;
				  create  table "dba".tmp_cast_iva_documento(
				    id_documento integer not null,
				    id_tab_iva integer not null,
				    val_omaggi decimal(18,4) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    val_tot_imp_v decimal(18,4) null,
				    val_tot_imp_l decimal(18,4) null,
				    val_tot_iva_v decimal(18,4) null,
				    val_tot_iva_l decimal(18,4) null,
				    primary key(id_documento,id_tab_iva),
				    )  ;
				  //
				  load into table tmp_cast_iva_documento from 'C:\\windows\\temp\\cast_iva_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_iva_documento;
				  //
				  message 'tabella TMP CAST IVA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - CASTELLETTO CONTROPARTITE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cast_cpt_documento')) then
				    drop table tmp_cast_cpt_documento
				  end if
				  ;
				  //
				  create  table "dba".tmp_cast_cpt_documento(
				    id_documento integer not null,
				    id_conto integer not null,
				    tipo_riga_cpt char(1) null,
				    val_imponibile decimal(18,4) null,
				    val_imp_scontato decimal(18,4) null,
				    val_omaggi decimal(18,4) null,
				    val_spese decimal(18,4) null,
				    primary key(id_documento,id_conto),
				    )  ;
				  //
				  load into table tmp_cast_cpt_documento from 'C:\\windows\\temp\\cast_cpt_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cast_cpt_documento;
				  //
				  message 'tabella TMP CAST CPT DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SPESE DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_documento')) then
				    drop table tmp_spesa_documento
				  end if
				  ;
				  //
				  create  table "dba".tmp_spesa_documento(
				    id_documento integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
				    primary key(id_documento,
				    id_spesa),
				    )  ;
				  //
				  message 'tabella TMP SPESA DOCUMENTO Inizio Load:';
				  load into table tmp_spesa_documento from 'C:\\windows\\temp\\spesa_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_documento;
				  //
				  message 'tabella TMP SPESA DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  /*
				  BOLLE DI VENDITA - SCADENZE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scadenza')) then
				    drop table tmp_scadenza
				  end if
				  ;
				  //
				  create  table "dba".tmp_scadenza(
				    id_scadenza integer not null,
				    tipo_scadenza char(1) null,
				    id_sog_commerciale integer null,
				    data_scadenza date null,
				    id_valuta integer null,
				    cambio decimal(8,4) null,
				    imp_valuta decimal(18,4) null,
				    importo decimal(18,4) null,
				    id_tipo_pagamento integer null,
				    id_banca_azienda integer null,
				    id_banca_sog_commerciale integer null,
				    note long varchar null,
				    ces_denominazione char(40) null,
				    ces_indirizzo char(40) null,
				    ces_cap char(10) null,
				    ces_localita char(40) null,
				    ces_provincia char(5) null,
				    ces_doc_originale char(16) null,
				    ces_data_documento date null,
				    stato_scadenza char(1) null,
				    data_cambiamento_stato date null,
				    esito_pagamento char(1) null,
				    scadenza_da_raggruppare char(1) null,
				    id_riga_distinta_banca integer null,
				    id_documento integer null,
				    id_par_aperta integer null,
				    id_scadenza_padre integer null,
				    id_azienda integer null,
				    cod_sog_commerciale char(8) null,
				    primary key(id_scadenza),
				    )  ;
				  //
				  load into table tmp_scadenza from 'C:\\windows\\temp\\scadenza.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scadenza;
				  //
				  message 'tabella TMP SCADENZA record trasferiti:'+string(@li_record);
				  //
				  
					if(exists(select 1 from sys.systable where table_name='tmp_agglist')) then
					    drop table tmp_agglist
					  end if
					  ;
					  // 17.12.07
					  //create  table "dba".tmp_agglist(
					  //  prezzo decimal(18,4) null,
					  //  articolo_codice char(32) null,
					  //  uc_codice char(10) null,
				      //        primary key(articolo_codice, uc_codice),
					  //  )  ;
					  create  table "dba".tmp_agglist(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(prezzo, articolo_codice, uc_codice),
					    )  ;
					  //
					  load into table tmp_agglist from 'C:\\windows\\temp\\agglist.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglist;
				  //
				  message 'tabella TMP AGGLIST record trasferiti:'+string(@li_record);
				  //
				  
					if(exists(select 1 from sys.systable where table_name='tmp_agglistv')) then
					    drop table tmp_agglistv
					  end if
					  ;
					  // 17.12.07
					  //create  table "dba".tmp_agglistv(
					  //  prezzo decimal(18,4) null,
					  //  articolo_codice char(32) null,
					  //  uc_codice char(10) null,
				      //        primary key(articolo_codice, uc_codice),
					  //  )  ;
					  create  table "dba".tmp_agglistv(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(prezzo, articolo_codice, uc_codice),
					    )  ;
					  //
					  load into table tmp_agglistv from 'C:\\windows\\temp\\agglistv.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglistv;
				  //
				  message 'tabella TMP AGGLISTV record trasferiti:'+string(@li_record);
				  //
				
				
					if(exists(select 1 from sys.systable where table_name='tmp_agglistl')) then
					    drop table tmp_agglistl
					  end if
					  ;
					  // 17.12.07
					  //create  table "dba".tmp_agglistl(
					  //  prezzo decimal(18,4) null,
					  //  articolo_codice char(32) null,
					  //  uc_codice char(10) null,
				      //        primary key(articolo_codice, uc_codice),
					  //  )  ;
					  create  table "dba".tmp_agglistl(
					    prezzo decimal(18,4) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
				              primary key(prezzo, articolo_codice, uc_codice),
					    )  ;
					  //
					  load into table tmp_agglistl from 'C:\\windows\\temp\\agglistl.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_agglistv;
				  //
				  message 'tabella TMP AGGLISTV record trasferiti:'+string(@li_record);
				  //
				
					if(exists(select 1 from sys.systable where table_name='tmp_codbarre')) then
					    drop table tmp_codbarre
					  end if
					  ;
					  //
					  create  table "dba".tmp_codbarre(
					    id_cod_barre integer null,
					    id_tipo_cod_barre integer null,
					    codice char(32) null,
					    id_unita_confezione integer null,
					    id_azienda integer null,
					    gen_automatica char(1) null,
				        id_art_var1 integer null,
				        id_art_var2 integer null,
				        id_art_var3 integer null,
				        pk_codice char(20) null,
					    articolo_codice char(32) null,
					    uc_codice char(10) null,
					    tcb_codice char(8) null,
				      primary key(id_cod_barre),
					    )  ;
					  //
					  load into table tmp_codbarre from 'C:\\windows\\temp\\cod_barre.txt' format 'ASCII' delimited by ';' quotes off;
					  //
					  commit work;  
				  //
				  select "count"(*) into @li_record
				    from tmp_codbarre;
				  //
				  message 'tabella TMP COD_BARRE record trasferiti:'+string(@li_record);
				  //  
								           
				  message 'FINE LOAD ... ';
				  message 'INIZIO CREAZIONE INDICI PK ... ';
				  //
				  create unique index xpk_tmp_documento on tmp_documento(id_documento asc);
				  //
				  create unique index xpk_tmp_riga_documento on tmp_riga_documento(id_riga_documento asc);
				  //
				  message 'FINE CREAZIONE INDICI PK ... '
				//
				end;        
END IF;        

IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte9') THEN
        
				ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte9"()
				begin
				
				  declare @li_record integer;
				
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      ) 
				  end if
				  ;
				  /*
				  ANAGRAFICA TIPO MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_magazzino')) then
				    drop table tmp_tipo_magazzino
				  end if
				  ;
				  //
				  create  table "dba".tmp_tipo_magazzino(
				    id_tipo_magazzino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_tipo_magazzino),
				    )  ;
				  //
				  load into table tmp_tipo_magazzino from 'C:\\windows\\temp\\tipo_magazzino.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_magazzino;
				  //
				  message 'tabella TMP TIPO MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  if(exists(select 1 from sys.systable where table_name='tmp_magazzino')) then
				    drop table tmp_magazzino
				  end if
				  ;
				  //
				  create  table "dba".tmp_magazzino(
				    id_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    note long varchar null,
				    giac_globale char(1) null,
				    id_tipo_magazzino integer null,
				    id_azienda integer null,
				    primary key(id_magazzino),
				    )  ;
				  //
				  load into table tmp_magazzino from 'C:\\windows\\temp\\magazzino.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_magazzino;
				  //
				  message 'tabella TMP MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_lingua')) then
				    drop table tmp_lingua
				  end if
				  ;
				  //
				  create  table "dba".tmp_lingua(
				    id_lingua integer not null,
				    codice char(5) null,
				    descrizione char(40) null,
				    primary key(id_lingua),
				    )  ;
				  //
				  load into table tmp_lingua from 'C:\\windows\\temp\\lingua.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_lingua;
				  //
				  message 'tabella TMP LINGUA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUAGGIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_linguaggio')) then
				    drop table tmp_linguaggio
				  end if
				  ;
				  //
				  create  table "dba".tmp_linguaggio(
				    id_linguaggio integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_linguaggio),
				    )  ;
				  //
				  load into table tmp_linguaggio from 'C:\\windows\\temp\\linguaggio.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_linguaggio;
				  //
				  message 'tabella TMP LINGUAGGIO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA VALUTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_valuta')) then
				    drop table tmp_valuta
				  end if
				  ;
				  //
				  create  table "dba".tmp_valuta(
				    id_valuta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    simbolo char(5) null,
				    cambio decimal(8,4) null,
				    cifra_arrotondamento decimal(3) null,
				    tipo_arrotondamento char(1) null,
				    parita_euro decimal(8,4) null,
				    dec_significativi decimal(1) null,
				    primary key(id_valuta),
				    )  ;
				  //
				  load into table tmp_valuta from 'C:\\windows\\temp\\valuta.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_valuta;
				  //
				  message 'tabella TMP VALUTA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LISTINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_listino')) then
				    drop table tmp_listino
				  end if
				  ;
				  //
				  create  table "dba".tmp_listino(
				    id_listino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_valuta integer null,
				    id_azienda integer null,
				    lis_base char(1) null,
				    primary key(id_listino),
				    )  ;
				  //
				  load into table tmp_listino from 'C:\\windows\\temp\\listino.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_listino;
				  //
				  message 'tabella TMP LISTINO record trasferiti:'+string(@li_record);
				  //    
				  //  
				  
				  /*
				  ANAGRAFICA VARIAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_variazione')) then
				    drop table tmp_variazione
				  end if
				  ;
				  //
				  create  table "dba".tmp_variazione(
				    id_variazione integer not null,
				    id_listino integer null,
				    data_inizio date null,
				    data_fine date null,
				    cambio decimal(8,4) null,
				    max_osc_positiva decimal(5,2) null,
				    max_osc_negativa decimal(5,2) null,
				    prezzi_ivati char(1) null,
				    primary key(id_variazione),
				    )  ;
				  //
				  load into table tmp_variazione from 'C:\\windows\\temp\\variazione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_variazione;
				  //
				  message 'tabella TMP VARIAZIONE record trasferiti:'+string(@li_record);
				  //    
				  if(exists(select 1 from sys.systable where table_name='tmp_con_pagamento')) then
				    drop table tmp_con_pagamento
				  end if
				  ;
				  //
				  create  table "dba".tmp_con_pagamento(
				    id_con_pagamento integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    sconto_cassa decimal(5,2) null,
				    primary key(id_con_pagamento),
				    )  ; //
				  load into table tmp_con_pagamento from 'C:\\windows\\temp\\con_pagamento.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_con_pagamento;
				  //
				  message 'tabella TMP CON PAGAMENTO record trasferiti:'+string(@li_record);
				  /*
				  ANAGRAFICA UNITA MISURA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_misura')) then
				    drop table tmp_unita_misura
				  end if
				  ;
				  //
				  create  table "dba".tmp_unita_misura(
				    id_unita_misura integer not null,
				    simbolo char(5) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_unita_misura_riferimento integer null,
				    conversione decimal(8,4) null,
				    simbolo_ur char(5) null,
				    primary key(id_unita_misura),
				    )  ;
				  //
				  load into table tmp_unita_misura from 'C:\\windows\\temp\\unita_misura.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_misura;
				  //
				  message 'tabella TMP UNITA MISURA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_trasporto')) then
				    drop table tmp_tipo_trasporto
				  end if
				  ;
				  //
				  create  table "dba".tmp_tipo_trasporto(
				    id_tipo_trasporto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    spese_gestite char(15) null,
				    primary key(id_tipo_trasporto),
				    )  ; //
				  load into table tmp_tipo_trasporto from 'C:\\windows\\temp\\tipo_trasporto.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_trasporto;
				  //
				  message 'tabella TMP TIPO TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_trasporto')) then
				    drop table tmp_caus_trasporto
				  end if
				  ;
				  //
				  create  table "dba".tmp_caus_trasporto(
				    id_caus_trasporto integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_caus_trasporto),
				    )  ; //
				  load into table tmp_caus_trasporto from 'C:\\windows\\temp\\caus_trasporto.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_trasporto;
				  //
				  message 'tabella TMP CAUS TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO PAGAMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_pagamento')) then
				    drop table tmp_tipo_pagamento
				  end if
				  ;
				  //
				  create  table "dba".tmp_tipo_pagamento(
				    id_tipo_pagamento integer not null,
				    codice char(4) null,
				    id_gruppo_esp_sospeso integer null,
				    descrizione char(40) null,
				    mod_stampa char(40) null,
				    ges_cessioni char(1) null,
				    spese_gestite char(15) null,
				    perc_tratte decimal(5,2) null,
				    arr_bollo_tratta decimal(14) null,
				    imp_min_bollo_tratta decimal(14) null,
				    id_prof_reg_dare integer null,
				    id_prof_reg_avere integer null,
				    premi_penalita char(1) null,
				    cod_gruppo_esp_sospeso char(4) null,
				    cod_prof_reg_dare char(8) null,
				    cod_prof_reg_avere char(8) null,
				    primary key(id_tipo_pagamento),
				    )  ;
				  load into table tmp_tipo_pagamento from 'C:\\windows\\temp\\tipo_pagamento.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_pagamento;
				  //
				  message 'tabella TMP TIPO PAGAMENTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA AREA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_area')) then
				    drop table tmp_area
				  end if
				  ;
				  //
				  create  table "dba".tmp_area(
				    id_area integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_area),
				    )  ;
				  load into table tmp_area from 'C:\\windows\\temp\\area.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_area;
				  //
				  message 'tabella TMP AREA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA LOCAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_locazione')) then
				    drop table tmp_locazione
				  end if
				  ;
				  //
				  create  table "dba".tmp_locazione(
				    id_locazione integer not null default autoincrement,
				    id_magazzino integer not null,
				    id_area integer null,
				    corsia char(5) null,
				    scaffale char(5) null,
				    ripiano char(5) null,
				    posizione char(5) null,
				    id_azienda integer null,
				    cod_magazzino char(8) null,
				    cod_area char(8) null,
				    primary key(id_locazione),
				    )  ;
				  load into table tmp_locazione from 'C:\\windows\\temp\\locazione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_locazione;
				  //
				  message 'tabella TMP LOCAZIONE record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS_MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_magazzino')) then
				    drop table tmp_caus_magazzino
				  end if
				  ;
				  //
				  create  table "dba".tmp_caus_magazzino(
				    id_caus_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    mag_par_richiesto char(1) null,
				    mag_des_richiesto char(1) null,
				    gen_doc_successivi char(1) null,
				    mp_qta_rim_iniziale char(1) null,
				    mp_val_rim_iniziale char(1) null,
				    mp_car_fiscali char(1) null,
				    mp_val_caricato char(1) null,
				    mp_scar_fiscali char(1) null,
				    mp_val_scaricato char(1) null,
				    mp_ord_clienti char(1) null,
				    mp_ord_fornitori char(1) null,
				    mp_vis_clienti char(1) null,
				    mp_vis_fornitori char(1) null,
				    mp_imp_produzione char(1) null,
				    mp_ord_produzione char(1) null,
				    mp_qta_cl_clienti char(1) null,
				    mp_qta_cl_fornitori char(1) null,
				    mp_qta_cl_terzi char(1) null,
				    mp_gruppo_lib_1 char(1) null,
				    mp_gruppo_lib_2 char(1) null,
				    mp_gruppo_lib_3 char(1) null,
				    mp_gruppo_lib_4 char(1) null,
				    mp_ult_costo char(1) null,
				    md_qta_rim_iniziale char(1) null,
				    md_val_rim_iniziale char(1) null,
				    md_car_fiscali char(1) null,
				    md_val_caricato char(1) null,
				    md_scar_fiscali char(1) null,
				    md_val_scaricato char(1) null,
				    md_ord_clienti char(1) null,
				    md_ord_fornitori char(1) null,
				    md_vis_clienti char(1) null,
				    md_vis_fornitori char(1) null,
				    md_imp_produzione char(1) null,
				    md_ord_produzione char(1) null,
				    md_qta_cl_clienti char(1) null,
				    md_qta_cl_fornitori char(1) null,
				    md_qta_cl_terzi char(1) null,
				    md_gruppo_lib_1 char(1) null,
				    md_gruppo_lib_2 char(1) null,
				    md_gruppo_lib_3 char(1) null,
				    md_gruppo_lib_4 char(1) null,
				    md_ult_costo char(1) null,
				    id_azienda integer null,
				    gestisce_lotti char(1) null,
				    mp_ult_scarico char(1) null,
				    md_ult_scarico char(1) null,
				    tipo_valorizzazione char(1) null,
				    primary key(id_caus_magazzino),
				    )  ;
				  load into table tmp_caus_magazzino from 'C:\\windows\\temp\\caus_magazzino.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_magazzino;
				  //
				  message 'tabella TMP CAUS MAGAZZINO record trasferiti:'+string(@li_record);
				  //    
				  //    
				  /*
				  ANAGRAFICA TAB_IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_iva')) then
				    drop table tmp_tab_iva
				  end if
				  ;
				  //
				  create  table "dba".tmp_tab_iva(
				    id_tab_iva integer not null,
				    codice char(8) null,
				    des_breve char(20) null,
				    des_estesa long varchar null,
				    tipo_iva char(1) null,
				    per_aliquota decimal(5,2) null,
				    per_detrazione decimal(5,2) null,
				    per_ventilazione decimal(5,2) null,
				    ges_plafond char(1) null,
				    ges_oper_intracomunitarie char(1) null,
				    imp_min_fattura decimal(14) null,
				    imp_bollo_fattura decimal(14) null,
				    ges_beni_rivendita char(1) null,
				    ges_beni_strumentali char(1) null,
				    primary key(id_tab_iva),
				    )  ;
				  load into table tmp_tab_iva from 'C:\\windows\\temp\\tab_iva.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_iva;
				  //
				  message 'tabella TAB_IVA record trasferiti:'+string(@li_record);
				  //    
				  //
				  // ANAGRAFICHE CONDIVISE E TABELLE ANAGRAFICHE SULLE QUALI SI BASA  
				  //    
				  //
				  /*
				  ANAGRAFICA BILANCIO_CEE
				
				  if(exists(select 1 from sys.systable where table_name='tmp_bilancio_cee')) then
				    drop table tmp_bilancio_cee
				  end if
				  ;
				  //
				  create  table "dba".tmp_bilancio_cee(
				    id_bilancio_cee integer not null,
				    descrizione varchar(80) null,
				    riferimento decimal(5) null,
				    tipo char(2) null,
				    pos1 char(4) null,
				    pos2 char(4) null,
				    pos3 char(4) null,
				    pos4 char(4) null,
				    flag char(1) null,
				    segno char(2) null,
				    saldo1 decimal(18,4) null,
				    saldo2 decimal(18,4) null,
				    primary key(id_bilancio_cee),
				    )  ;
				  load into table tmp_bilancio_cee from 'C:\\windows\\temp\\bilancio_cee.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_bilancio_cee;
				  //
				  message 'tabella BILANCIO_CEE record trasferiti:'+string(@li_record);
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA PDC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_pdc')) then
				    drop table tmp_pdc
				  end if
				  ;
				  //
				  create  table "dba".tmp_pdc(
				    id_pdc integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_pdc),
				    )  ;
				  load into table tmp_pdc from 'C:\\windows\\temp\\pdc.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_pdc;
				  //
				  message 'tabella PDC record trasferiti:'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA MASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mastro')) then
				    drop table tmp_mastro
				  end if
				  ;
				  //
				  create  table "dba".tmp_mastro(
				    id_mastro integer not null,
				    id_pdc integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_pdc char(15) null,
				    primary key(id_mastro),
				    )  ;
				  load into table tmp_mastro from 'C:\\windows\\temp\\mastro.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mastro;
				  //
				  message 'tabella MASTRO record trasferiti:'+string(@li_record);
				  //        
				  //    
				  //
				  /*
				  ANAGRAFICA SOTTOMASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sottomastro')) then
				    drop table tmp_sottomastro
				  end if
				  ;
				  //
				  create  table "dba".tmp_sottomastro(
				    id_sottomastro integer not null,
				    id_mastro integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    uso char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    primary key(id_sottomastro),
				    )  ;
				  load into table tmp_sottomastro from 'C:\\windows\\temp\\sottomastro.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sottomastro;
				  //
				  message 'tabella SOTTOMASTRO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA TITOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_titolo')) then
				    drop table tmp_titolo
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_titolo(
				    id_titolo integer not null,
				    titolo char(40) null,
				    primary key(id_titolo),
				    )  ;
				  load into table tmp_titolo from 'C:\\windows\\temp\\titolo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_titolo;
				  //
				  message 'tabella TITOLO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA ATT_SVOLTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_att_svolta')) then
				    drop table tmp_att_svolta
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_att_svolta(
				    id_att_svolta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_att_svolta),
				    )  ;
				  load into table tmp_att_svolta from 'C:\\windows\\temp\\att_svolta.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_att_svolta;
				  //
				  message 'tabella ATT_SVOLTA record trasferiti:'+string(@li_record);
				  //            
				  //    
				  //
				  /*
				  ANAGRAFICA TRIBUTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tributo')) then
				    drop table tmp_tributo
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_tributo(
				    id_tributo integer not null,
				    codice char(8) null,
				    cod_tributo char(4) null,
				    descrizione char(80) null,
				    gruppo char(2) null,
				    per_imponibile decimal(5,2) null,
				    per_tributo decimal(5,2) null,
				    inizio_per_validita date null,
				    fine_per_validita date null,
				    mod_fiscale char(10) null,
				    primary key(id_tributo),
				    )  ;
				  load into table tmp_tributo from 'C:\\windows\\temp\\tributo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tributo;
				  //
				  message 'tabella TRIBUTO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //
				  /*
				  ANAGRAFICA ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_anagrafica')) then
				    drop table tmp_anagrafica
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_anagrafica(
				    id_anagrafica integer not null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    cod_fiscale char(16) null,
				    par_iva char(16) null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    nat_giuridica char(1) null,
				    prov_contabile char(1) null,
				    id_valuta integer null,
				    id_tipo_trasporto integer null,
				    id_titolo integer null,
				    id_att_svolta integer null,
				    id_tributo integer null,
				    cog_ritenute char(40) null,
				    nome_ritenute char(40) null,
				    sesso char(1) null,
				    ind_ritenute char(40) null,
				    cap_ritenute char(10) null,
				    loc_ritenute char(40) null,
				    prov_ritenute char(5) null,
				    naz_ritenute char(5) null,
				    data_nas_ritenute date null,
				    luogo_nas_ritenute char(40) null,
				    prov_nas_ritenute char(5) null,
				    naz_nas_ritenute char(5) null,
				    con_previdenziale decimal(5,2) null,
				    cassa_previdenza decimal(5,2) null,
				    rit_previdenziale decimal(5,2) null,
				    isc_enasarco char(1) null,
				    per_enasarco_agente decimal(5,2) null,
				    per_enasarco_conto_agente decimal(5,2) null,
				    id_azienda integer null,
				    bollo char(20) null,
					 codice integer,				//BL#13377#
				    cod_lingua char(15) null,
				    cod_linguaggio char(15) null,
				    cod_valuta char(15) null,
				    cod_tipo_trasporto char(15) null,
				    titolo char(40) null,
				    cod_att_svolta char(15) null,
				    cod_tributo char(15) null,
				    primary key(id_anagrafica),
				    )  ;
				  load into table tmp_anagrafica from 'C:\\windows\\temp\\anagrafica.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_anagrafica;
				  //
				  message 'tabella ANAGRAFICA record trasferiti:'+string(@li_record);
				  //                
				  //    
				  //
				  /*
				  ANAGRAFICA GRUPPO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo')) then
				    drop table tmp_gruppo
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_gruppo(
				    id_gruppo integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_anagrafica integer null,
				    note long varchar null,
				    fido decimal(14) null,
				    id_azienda integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    primary key(id_gruppo),
				    )  ;
				  load into table tmp_gruppo from 'C:\\windows\\temp\\gruppo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo;
				  //
				  message 'tabella GRUPPO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA CONTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_conto')) then
				    drop table tmp_conto
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_conto(
				    id_conto integer not null,
				    codice char(8) null,
				    id_sottomastro integer null,
				    descrizione char(40) null,
				    id_gruppo integer null,
				    ges_par_aperte char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    cod_gruppo char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    rif_bilancio_cee decimal(5) null,
				    primary key(id_conto),
				    )  ;
				  load into table tmp_conto from 'C:\\windows\\temp\\conto.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_conto;
				  //
				  message 'tabella CONTO record trasferiti:'+string(@li_record);
				  //              
				  //      
				  //    
				  //
				  /*
				  ANAGRAFICA CAT_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_attivita')) then
				    drop table tmp_cat_attivita
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_cat_attivita(
				    id_cat_attivita integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_attivita),
				    )  ;
				  load into table tmp_cat_attivita from 'C:\\windows\\temp\\cat_attivita.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_attivita;
				  //
				  message 'tabella CAT_ATTIVITA record trasferiti:'+string(@li_record);
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_COM_SC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_sc')) then
				    drop table tmp_cat_com_sc
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_cat_com_sc(
				    id_cat_com_sc integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_com_sc),
				    )  ;
				  load into table tmp_cat_com_sc from 'C:\\windows\\temp\\cat_com_sc.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_sc;
				  //
				  message 'tabella CAT_COM_SC record trasferiti:'+string(@li_record);
				  //              
				  //          
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_ZONA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_zona')) then
				    drop table tmp_cat_zona
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_cat_zona(
				    id_cat_zona integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_zona),
				    )  ;
				  load into table tmp_cat_zona from 'C:\\windows\\temp\\cat_zona.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_zona;
				  //
				  message 'tabella CAT_ZONA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SOG_COMMERCIALE
				
					BL#13377#	-	Modifica AK ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sog_commerciale')) then
				    drop table tmp_sog_commerciale
				  end if
				  ;
				  //
				  //
				  create  table
				    "dba".tmp_sog_commerciale(
				    id_sog_commerciale integer not null,
				    codice char(8) null,
				    id_anagrafica integer null,
				    tipo char(1) null,
				    id_conto integer null,
				    data_acquisizione date null,
				    data_trasformazione date null,
				    ns_cod_soggetto char(20) null,
				    id_linguaggio integer null,
				    id_cat_attivita integer null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    id_magazzino integer null,
				    fido decimal(14) null,
				    extrafido decimal(14) null,
				    con_fido char(1) null,
				    id_con_pagamento integer null,
				    data_dec_pagamenti char(1) null,
				    giorno_fisso_pagamenti decimal(2) null,
				    scad_raggruppate char(1) null,
				    id_banca_sog_commerciale integer null,
				    id_listino integer null,
				    id_tipo_trasporto integer null,
				    id_sog_com_vettore integer null,
				    per_fatturazione char(1) null,
				    modo_fatturazione char(1) null,
				    con_fattura char(1) null,
				    fat_sos_iva char(1) null,
				    id_tab_iva integer null,
				    num_ns_prot_documenti char(10) null,
				    data_ns_prot_documenti date null,
				    num_lr_prot_documenti char(10) null,
				    data_lr_prot_documenti date null,
				    uff_iva char(40) null,
				    id_prof_registrazione integer null,
				    id_tributo integer null,
				    id_att_svolta integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer not null default 1,
				    id_tipo_agente integer null,
				    imp_fisso decimal(18,4) null,
				    id_valuta integer null,
				    giorni_franchigia decimal(3) null,
				    id_val_prov_agente integer null,
				    crea_gruppo_agenti char(1) null,
				    imp_fisso_ult_elab decimal(18,4) null,
				    imp_premio_budget decimal(18,4) null,
				    ult_elab_definitivo date null,
				    prec_elab_definitivo date null,
				    id_tab_iva_fat_prov integer null,
				    id_gruppo_agenti_2 integer null,
				    id_sog_com_vettore_2 integer null,
				    spese_gestite char(15) null,
				    cod_conto char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    cod_linguaggio char(15) null,
				    cod_cat_attivita char(15) null,
				    cod_cat_com_sc char(15) null,
				    cod_cat_zona char(15) null,
				    cod_magazzino char(15) null,
				    cod_con_pagamento char(15) null,
				    cod_abi char(5) null,
				    cod_cab char(5) null,
				    codice_anagrafica integer null,
				    cod_listino char(15) null,
				    cod_tipo_trasporto char(15) null,
				    cod_sog_com_vettore char(15) null,
				    cod_tab_iva char(15) null,
				    cod_prof_registrazione char(15) null,
				    cod_tributo char(15) null,
				    cod_att_svolta char(15) null,
				    cod_gruppo_agenti char(15) null,
				    cod_tipo_agente char(15) null,
				    cod_valuta char(15) null,
				    cod_val_prov_agente char(15) null,
				    cod_tab_iva_fat_prov char(15) null,
				    cod_gruppo_Agenti_2 char(15) null,
				    cod_sog_com_vettore_2 char(15) null,
				    primary key(id_sog_commerciale),
				    )  ;
				  load into table tmp_sog_commerciale from 'C:\\windows\\temp\\sog_commerciale.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sog_commerciale;
				  //
				  message 'tabella SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //              
				  //              
				  /*
				  ANAGRAFICA TAB_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_attivita')) then
				    drop table tmp_tab_attivita
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_tab_attivita(
				    id_tab_attivita integer not null,
				    codice char(8) null,
				    descrizione long varchar null,
				    primary key(id_tab_attivita),
				    )  ;
				  load into table tmp_tab_attivita from 'C:\\windows\\temp\\tab_attivita.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_attivita;
				  //
				  message 'tabella TAB_ATTIVITA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_attivita')) then
				    drop table tmp_attivita
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_attivita(
				    id_attivita integer null,
				    id_tab_attivita integer null,
				    descrizione char(40) null,
				    ges_ventilazione char(1) null,
				    liq_iva char(1) null,
				    tipo_contabilita char(1) null default 'O',
				    id_azienda integer not null default 1,
				    attuale_plafond decimal(18,4) null,
				    cod_tab_attivita char(15) null,
				    )  ;
				  load into table tmp_attivita from 'C:\\windows\\temp\\attivita.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_attivita;
				  //
				  message 'tabella ATTIVITA record trasferiti:'+string(@li_record);
				  //  
				  //
				  /*
				  ANAGRAFICA MOD_REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mod_registro')) then
				    drop table tmp_mod_registro
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_mod_registro(
				    id_mod_registro integer not null,
				    tipo_registro char(2) null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_mod_registro),
				    )  ;
				  load into table tmp_mod_registro from 'C:\\windows\\temp\\mod_registro.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mod_registro;
				  //
				  message 'tabella MOD_REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ESERCIZIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_esercizio')) then
				    drop table tmp_esercizio
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_esercizio(
				    id_esercizio integer not null,
				    codice char(4) null,
				    data_inizio date null,
				    data_fine date null,
				    bloccato char(1) null,
				    ult_data_stampa_bollato date null,
				    num_progressivo decimal(8) null,
				    id_azienda integer null,
				    riporto decimal(18,4) null,
				    prog_scritture char(1) null,
				    id_valuta integer null,
				    cod_valuta char(15) null,
				    primary key(id_esercizio),
				    )  ;
				  load into table tmp_esercizio from 'C:\\windows\\temp\\esercizio.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_esercizio;
				  //
				  message 'tabella ESERCIZIO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_registro')) then
				    drop table tmp_registro
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_registro(
				    id_registro integer not null,
				    id_esercizio integer null,
				    tipo_registro char(2) null,
				    id_mod_registro integer null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    perc_prorata decimal(5,2) null,
				    cod_esercizio char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_registro),
				    )  ;
				  load into table tmp_registro from 'C:\\windows\\temp\\registro.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_registro;
				  //
				  message 'tabella REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //
				  //
				  /*
				  ANAGRAFICA PROF_DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_documento')) then
				    drop table tmp_prof_documento
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_prof_documento(
				    cod_caus_magazzino_prop char(15) null,
				    cod_prof_registrazione char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_sog_comm_prop char(15) null,
				    cod_sog_comm_fattura_prop char(15) null,
				    cod_linguaggio_prop char(15) null,
				    cod_lingua_prop char(15) null,
				    cod_valuta_prop char(15) null,
				    cod_listino_prop char(15) null,
				    cod_con_pagamento_prop char(15) null,
				    cod_sog_comm_vettore_1_prop char(15) null,
				    cod_magazzino_1 char(15) null,
				    cod_area_1 char(15) null,
				    corsia_1 char(15) null,
				    ripiano_1 char(15) null,
				    scaffale_1 char(15) null,
				    posizione_1 char(15) null,
				    cod_magazzino_2 char(15) null,
				    cod_area_2 char(15) null,
				    corsia_2 char(15) null,
				    ripiano_2 char(15) null,
				    scaffale_2 char(15) null,
				    posizione_2 char(15) null,
				    cod_caus_trasporto_prop char(15) null,
				    cod_sog_comm_vettore_2_prop char(15) null,
				    id_prof_documento integer not null,
				    id_caus_magazzino_prop integer null,
				    id_prof_registrazione integer null,
				    codice char(8) null,
				    descrizione char(40) null,
				    des_stampa char(40) null,
				    tipo_registro char(2) null,
				    ric_id_registro char(1) null,
				    ric_num_progressivo char(1) null,
				    id_mod_registro_prop integer null,
				    con_data_progressiva char(1) null,
				    ric_num_documento char(1) null default 'M',
				    note_intestazione_prop long varchar null,
				    ric_id_caus_magazzino char(1) null default 'M',
				    int_consentiti char(6) null,
				    ric_id_sog_comm char(1) null default 'M',
				    id_sog_comm_prop integer null,
				    ric_id_magazzino_1 char(1) null default 'M',
				    id_magazzino_1_prop integer null,
				    ric_id_magazzino_2 char(1) null default 'M',
				    id_magazzino_2_prop integer null,
				    ric_id_sog_comm_fattura char(1) null default 'M',
				    id_sog_comm_fattura_prop integer null,
				    ric_lingua_linguaggio char(1) null default 'M',
				    id_linguaggio_prop integer null,
				    id_lingua_prop integer null,
				    ric_id_valuta char(1) null default 'M',
				    id_valuta_prop integer null,
				    ric_id_listino char(1) null default 'M',
				    id_listino_prop integer null,
				    ric_id_con_pagamento char(1) null default 'M',
				    id_con_pagamento_prop integer null,
				    ric_scadenze char(1) null default 'M',
				    ric_id_sog_comm_agente char(1) null default 'M',
				    ric_provvigioni char(1) null default 'M',
				    ric_data_consegna char(1) null default 'M',
				    gg_consegna decimal(4) null,
				    ric_sconti_finanziari char(1) null default 'M',
				    spese_gestite char(15) null,
				    ric_acconti char(1) null default 'M',
				    ric_date_competenza char(1) null default 'M',
				    ric_colli_documento char(1) null default 'M',
				    ric_pesi char(1) null default 'M',
				    ric_volumi char(1) null default 'M',
				    ric_id_tipo_trasporto char(1) null default 'M',
				    ric_id_caus_trasporto char(1) null default 'M',
				    ric_asp_beni char(1) null default 'M',
				    aspetto_beni_prop char(40) null,
				    ric_trasp_mezzo char(1) null default 'M',
				    trasp_mezzo_prop char(1) null,
				    ric_id_sog_comm_vettore_1 char(1) null default 'M',
				    ric_id_sog_comm_vettore_2 char(1) null default 'M',
				    id_sog_comm_vettore_1_prop integer null,
				    ric_mezzo_trasporto char(1) null default 'M',
				    ric_data_trasporto char(1) null default 'M',
				    stampabile char(1) null,
				    stampa_immediata char(1) null,
				    ges_pac_list char(1) null,
				    ges_evas_parziale char(1) null,
				    ges_db char(1) null,
				    ges_matricole char(1) null,
				    con_dis_articoli char(1) null,
				    ges_chius_forzata char(1) null,
				    ges_stato_documento char(1) null,
				    tipo_raggruppamento char(1) null,
				    usa_int_fattura char(1) null,
				    contabilizzabile char(1) null,
				    des_contabile char(40) null,
				    ric_id_unita_confezione_riga char(1) null default 'M',
				    ric_quantita_riga char(1) null default 'M',
				    quantita_prop_riga decimal(18,4) null default
				    0,
				    ric_unita_base_riga char(1) null default 'M',
				    ric_unita_prezzo_riga char(1) null default 'M',
				    ric_id_caus_magazzino_riga char(1) null default 'M',
				    ric_locazione_1_riga char(1) null default 'M',
				    ric_locazione_2_riga char(1) null default 'M',
				    ric_data_prev_consegna_riga char(1) null default 'M',
				    ric_pesi_riga char(1) null default 'M',
				    ric_dim_riga char(1) null default 'M',
				    ric_colli_riga char(1) null default 'M',
				    ric_id_valuta_riga char(1) null default 'M',
				    ric_id_listino_riga char(1) null default 'M',
				    ric_prezzo_riga char(1) null default 'M',
				    ric_sconto_riga char(1) null default 'M',
				    ric_prezzo_netto_riga char(1) null default 'M',
				    ric_sconto_riga_riga char(1) null default 'M',
				    ric_id_tab_iva_riga char(1) null default 'M',
				    ric_id_sog_comm_agente_riga char(1) null default 'M',
				    ric_provvigioni_riga char(1) null default 'M',
				    ric_val_attribuito_riga char(1) null default 'M',
				    ric_date_competenza_riga char(1) null default 'M',
				    ric_contropartite_riga char(1) null default 'M',
				    evas_virtuale char(1) null,
				    stampa_bloccante char(1) null,
				    contr_esen_der char(1) null,
				    cambio_rical_der char(1) null,
				    stato_scad_generata char(1) null default 'N',
				    pas_di_sblocco char(20) null,
				    pas_chiu_forz char(20) null,
				    tipo_fattura char(1) null,
				    nome_report char(40) null,
				    id_azienda integer null default 1,
				    ric_tipo_fattura char(1) null default 'M',
				    id_locazione_1_prop integer null,
				    id_locazione_2_prop integer null,
				    ric_data_documento char(1) null default 'M',
				    fat_anticipo char(1) null,
				    id_caus_trasporto_prop integer null,
				    id_sog_comm_vettore_2_prop integer null,
				    ric_data_scadenza char(1) null default 'M',
				    gg_scadenza decimal(4) null,
				    non_vis_pag_trasporto char(1) null,
				    non_vis_pag_totali char(1) null,
				    non_vis_pag_contropartite char(1) null,
				    con_scorta_articoli char(1) null,
				    primary key(id_prof_documento),
				    )  ;
				  load into table tmp_prof_documento from 'C:\\windows\\temp\\prof_documento.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_documento;
				  //
				  message 'tabella PROF_DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA DESTINAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_destinazione')) then
				    drop table tmp_destinazione
				  end if
				  ;
				  //
				  create  table "dba".tmp_destinazione(
				    id_destinazione integer not null,
				    id_sog_commerciale integer null,
				    id_cat_attivita integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    tipo_destinazione char(1) null,
				    id_magazzino integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer null,
				    id_gruppo_Agenti_2 integer null,
				    id_con_pagamento integer null,
				    codice integer null,
				    primary key(id_destinazione),
				    )  ;
				  //
				  load into table tmp_destinazione from 'C:\\windows\\temp\\destinazione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_destinazione;
				  //
				  message 'tabella TMP DESTINAZIONE record trasferiti:'+string(@li_record);
				  //
				  */
				  // CODIFICA ARTICOLI # I
				  /*
				  ANAGRAFICA SCOMPOSIZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scomposizione')) then
				    drop table tmp_scomposizione
				  end if
				  ;
				  //
				  create  table "dba".tmp_scomposizione(
				    id_scomposizione integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_scomposizione),
				    )  ;
				  //
				  load into table tmp_scomposizione from 'C:\\windows\\temp\\scomposizione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scomposizione;
				  //
				  message 'tabella TMP SCOMPOSIZIONE record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA CAT_CODIFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_codifica')) then
				    drop table tmp_cat_codifica
				  end if
				  ;
				  //
				  create  table "dba".tmp_cat_codifica(
				    id_cat_codifica integer not null,
				    codice char(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lun_fissa char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_codifica),
				    )  ;
				  //
				  load into table tmp_cat_codifica from 'C:\\windows\\temp\\cat_codifica.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_codifica;
				  //
				  message 'tabella TMP CAT_CODIFICA record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA PARTE_REGOLA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_parte_regola')) then
				    drop table tmp_parte_regola
				  end if
				  ;
				  //
				  create  table "dba".tmp_parte_regola(
				    id_parte_regola integer not null,
				    num_sezione decimal(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lunghezza decimal(4) not null,
				    progressivo char(1) null,
				    variante char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_parte_regola),
				    )  ;
				  //
				  load into table tmp_parte_regola from 'C:\\windows\\temp\\parte_regola.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_parte_regola;
				  //
				  message 'tabella TMP PARTE_REGOLA record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA COD_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cod_parte')) then
				    drop table tmp_cod_parte
				  end if
				  ;
				  //
				  create  table "dba".tmp_cod_parte(
				    id_cod_parte integer not null,
				    id_cat_codifica integer null,
				    id_parte_regola integer null,
				    mas_input char(32) null,
				    tipo_richiesta char(1) null default 'R',
				    val_proposto char(32) null,
				    car_riempimento char(1) null,
				    solo_in_elenco char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cod_parte),
				    )  ;
				  //
				  load into table tmp_cod_parte from 'C:\\windows\\temp\\cod_parte.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cod_parte;
				  //
				  message 'tabella TMP COD_PARTE record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SCELTA_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scelta_parte')) then
				    drop table tmp_scelta_parte
				  end if
				  ;
				  //
				  create  table "dba".tmp_scelta_parte(
				    id_scelta_parte integer not null,
				    id_cod_parte integer not null,
				    scelta char(32) null,
				    descrizione char(40) null,
				    primary key(id_scelta_parte),
				    )  ;
				  //
				  load into table tmp_scelta_parte from 'C:\\windows\\temp\\scelta_parte.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scelta_parte;
				  //
				  message 'tabella TMP SCELTA_PARTE record importati'+string(@li_record);
				  //
				  // CODIFICA ARTICOLI # F
				  //
				  //
				  /*
				  ANAGRAFICA CAT_COM_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_articolo')) then
				    drop table tmp_cat_com_articolo
				  end if
				  ;
				  //
				  create  table "dba".tmp_cat_com_articolo(
				    id_cat_com_articolo integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_tab_iva integer not null default autoincrement,
				    id_azienda integer not null default 1,
				    primary key(id_cat_com_articolo),
				    )  ;
				  //
				  load into table tmp_cat_com_articolo from 'C:\\windows\\temp\\cat_com_articolo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_articolo;
				  //
				  message 'tabella TMP CAT_COM_ARTICOLO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REG_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reg_fiscale')) then
				    drop table tmp_reg_fiscale
				  end if
				  ;
				  //
				  create  table "dba".tmp_reg_fiscale(
				    id_reg_fiscale integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_reg_fiscale),
				    )  ;
				  //
				  load into table tmp_reg_fiscale from 'C:\\windows\\temp\\reg_fiscale.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reg_fiscale;
				  //
				  message 'tabella TMP REG_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_MERCEOLOGICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_merceologica')) then
				    drop table tmp_cat_merceologica
				  end if
				  ;
				  //
				  create  table "dba".tmp_cat_merceologica(
				    id_cat_merceologica integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_reg_fiscale integer null,
				    id_cat_mer_superiore integer null,
				    id_anag_modello integer null,
				    id_tipo_parte integer null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_merceologica),
				    )  ;
				  //
				  load into table tmp_cat_merceologica from 'C:\\windows\\temp\\cat_merceologica.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_merceologica;
				  //
				  message 'tabella TMP CAT_MERCEOLOGICA record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_fiscale')) then
				    drop table tmp_cat_fiscale
				  end if
				  ;
				  //
				  create  table "dba".tmp_cat_fiscale(
				    id_cat_fiscale integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    primary key(id_cat_fiscale),
				    )  ;
				  //
				  load into table tmp_cat_fiscale from 'C:\\windows\\temp\\cat_fiscale.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_fiscale;
				  //
				  message 'tabella TMP CAT_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA GRUPPO_ARTICOLI
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_articoli')) then
				    drop table tmp_gruppo_articoli
				  end if
				  ;
				  //
				  create  table "dba".tmp_gruppo_articoli(
				    id_gruppo_articoli integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_gruppo_articoli),
				    )  ;
				  //
				  load into table tmp_gruppo_articoli from 'C:\\windows\\temp\\gruppo_articoli.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_articoli;
				  //
				  message 'tabella TMP GRUPPO_ARTICOLI record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REPARTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reparto')) then
				    drop table tmp_reparto
				  end if
				  ;
				  //
				  create  table "dba".tmp_reparto(
				    id_reparto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_reparto),
				    )  ;
				  //
				  load into table tmp_reparto from 'C:\\windows\\temp\\reparto.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reparto;
				  //
				  message 'tabella TMP REPARTO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA UNITA_CONF_BASE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_conf_base')) then
				    drop table tmp_unita_conf_base
				  end if
				  ;
				  //
				  create  table "dba".tmp_unita_conf_base(
				    id_unita_conf_base integer not null,
				    codice char(8) not null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) not null,
				    fat_conversione decimal(8,4) not null,
				    tipo_conversione char(1) not null,
				    molteplicita decimal(18,4) null default 1,
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null default 'S',
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null default 'S',
				    unita_produzione char(1) null,
				    id_azienda integer not null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    id_articolo integer null,
				    primary key(id_unita_conf_base),
				    )  ; //
				  load into table tmp_unita_conf_base from 'C:\\windows\\temp\\unita_conf_base.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_conf_base;
				  //
				  message 'tabella TMP UNITA_CONF_BASE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cif')) then
				    drop table tmp_cif
				  end if
				  ;
				  //
				  create  table "dba".tmp_cif(
				    id_cif integer not null,
				    codice char(8) not null,
				    cambio decimal(8,4) null,
				    coefficiente decimal(5,2) null,
				    id_azienda integer not null default 1,
				    primary key(id_cif), //
				    )  ;
				  load into table tmp_cif from 'C:\\windows\\temp\\cif.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cif;
				  //
				  message 'tabella TMP CIF record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA SPESA_CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_cif')) then
				    drop table tmp_spesa_cif
				  end if
				  ;
				  //
				  create  table "dba".tmp_spesa_cif(
				    id_cif integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    primary key(id_cif,
				    id_spesa),
				    )  ;
				  load into table tmp_spesa_cif from 'C:\\windows\\temp\\spesa_cif.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_cif;
				  //
				  message 'tabella TMP SPESA_CIF record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_articolo')) then
				    drop table tmp_articolo
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_articolo(
				    id_articolo integer not null,
				    id_cat_codifica integer null,
				    codice char(32) null,
				    descrizione char(80) null,
				    immagine char(255) null,
				    rif_catalogo char(20) null,
				    id_cat_com_articolo integer null,
				    id_cat_merceologica integer null,
				    id_cat_fiscale integer null,
				    id_gruppo_articoli integer null,
				    des_breve char(40) null,
				    id_reparto integer null,
				    id_anagrafica integer null,
				    id_sog_commerciale integer null,
				    id_tab_iva integer null,
				    cod_intrastat char(40) null,
				    data_ora_creazione timestamp null default getdate(*),
				    data_ora_ult_cambiamento timestamp null default getdate(*),
				    data_ora_ult_var_stato timestamp null default getdate(*),
				    stampa_in_inventario char(1) null default 'S',
				    stampa_in_listini char(1) null default 'S',
				    stampa_in_giornale char(1) null default 'S',
				    stampa_in_schede char(1) null default 'S',
				    ges_lotti char(1) null default 'N',
				    ges_matricole char(1) null default 'N',
				    ges_produzione char(1) null default 'N',
				    note long varchar null,
				    utilizzabile char(1) null,
				    stato char(1) null,
				    ges_locazioni char(1) null,
				    giorni_invenduto decimal(4) null,
				    id_azienda integer null default 1,
				    id_cif integer null,
				    costo_aggiuntivo decimal(18,4) null,
				    id_valuta integer null,
				    id_unita_conf_base integer null,
				    prod_interna char(1) null,
				    id_sog_comm_variante integer null,
				    stampa_in_catalogo char(1) null default 'S',
				    giorni_durata integer null,
                    id_art_imballo integer null,
				    primary key(id_articolo),
				    )  ;
				  //
				  create unique index xak1tmp_articolo on
				    "dba".tmp_articolo(codice asc,id_azienda asc);
				  //
				  load into table tmp_articolo from 'C:\\windows\\temp\\articolo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_articolo;
				  //
				  message 'tabella ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA UNITA_CONFEZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_confezione')) then
				    drop table tmp_unita_confezione
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_unita_confezione(
				    id_unita_confezione integer not null,
				    id_articolo integer null,
				    codice char(8) null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) null,
				    fat_conversione decimal(8,4) null,
				    tipo_conversione char(1) null,
				    molteplicita decimal(18,4) null default 0,
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null,
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null,
				    unita_produzione char(1) null,
				    id_azienda integer null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    primary key(id_unita_confezione),
				    )  ;
				  //
				  create unique index xak1tmp_unita_confezione on
				    "dba".tmp_unita_confezione(id_articolo asc,codice asc);
				  //
				  load into table tmp_unita_confezione from 'C:\\windows\\temp\\unita_confezione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_confezione;
				  //
				  message 'tabella UNITA_CONFEZIONE record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA DES_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_des_articolo')) then
				    drop table tmp_des_articolo
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_des_articolo(
				    id_des_articolo integer not null,
				    id_articolo integer null,
				    id_sog_commerciale integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    codice char(32) null,
				    descrizione char(40) null,
				    des_estesa long varchar null,
				    id_azienda integer null default 1,
				    primary key(id_des_articolo),
				    )  ;
				  //
				  create unique index tmp_des_articolo_ak001 on
				    "dba".tmp_des_articolo(id_articolo asc,id_sog_commerciale asc,id_lingua asc,id_linguaggio asc);
				  //
				  load into table tmp_des_articolo from 'C:\\windows\\temp\\des_articolo.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_des_articolo;
				  //
				  message 'tabella DES_ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA GRUPPO_AGENTI
				
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_agenti')) then
				    drop table tmp_gruppo_agenti
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_gruppo_agenti(
				    id_gruppo_agenti integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    id_sog_com_capo_area integer null,
				    id_sog_com_agente integer null,
				    id_sog_com_sub_agente integer null,
				    sconto_riga char(1) null,
				    sconto_finanziario char(1) null,
				    sconto_fin_cassa char(1) null,
				    sconto_fin_incondizionato char(1) null,
				    rip_per_fatturato decimal(5,2) null,
				    rip_per_incassato decimal(5,2) null,
				    mod_liq_provvigione char(1) null,
				    id_azienda integer null default 1,
				    inc_ult_elab decimal(5,2) null,
				    fat_ult_elab decimal(5,2) null,
				    primary key(id_gruppo_agenti),
				    )  ;
				  //
				  create unique index tmp_gruppo_agentiak001 on
				    "dba".tmp_gruppo_agenti(codice asc,id_azienda asc);
				  //
				  load into table tmp_gruppo_agenti from 'C:\\windows\\temp\\gruppo_agenti.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_agenti;
				  //
				  message 'tabella GRUPPO_AGENTI record trasferiti:'+string(@li_record);
				  //  
				  //  
				  //      
				  /*
				  ANAGRAFICA PROF_REGISTRAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_registrazione')) then
				    drop table tmp_prof_registrazione
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_prof_registrazione(
				    id_prof_registrazione integer not null default autoincrement,
				    codice char(8) not null,
				    descrizione char(40) null,
				    tipo_registrazione char(1) not null,
				    id_mod_registro integer not null,
				    id_valuta integer null,
				    id_tab_iva integer null,
				    id_conto_iva integer null,
				    des_contabile char(40) null,
				    ges_oper_intracomunitarie char(1) null,
				    usa_pagamenti char(1) null,
				    usa_con_effetti char(1) null,
				    usa_insoluti char(1) null,
				    crea_partita char(1) null,
				    tipo_fattura char(1) null default 'N',
				    id_azienda integer not null default 1,
				    primary key(id_prof_registrazione),
				    )  ;
				  //
				  create unique index xak1tmp_prof_registrazione on
				    "dba".tmp_prof_registrazione(codice asc,id_azienda asc);
				  //
				  load into table tmp_prof_registrazione from 'C:\\windows\\temp\\prof_registrazione.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_registrazione;
				  //
				  message 'tabella TMP_PROF_REGISTRAZIONE record trasferiti:'+string(@li_record);
				  //    
				  //  
				  //  
				  */    
				  /*
				  ANAGRAFICA SPESA
				  */  
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa')) then
				    drop table tmp_spesa
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_spesa(
				    id_spesa integer not null default autoincrement,
				    codice char(1) not null,
				    descrizione char(40) null,
				    tipo_importo char(1) null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
				    id_conto_acquisti integer not null,
				    id_conto_vendite integer not null,
				    segue_esenzione char(1) null,
				    mod_cal_iva char(1) null,
				    primary key(id_spesa),
				    )  ;
				  //
				  create unique index xak1tmp_spesa on
				    "dba".TMP_spesa(codice asc);
				  //
				  load into table tmp_spesa from 'C:\\windows\\temp\\spesa.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa;
				  //
				  message 'tabella TMP_SPESA record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //  
				  
				  /*
				  ANAGRAFICA BANCA_APPOGGIO
				
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_appoggio')) then
				    drop table tmp_banca_appoggio
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_banca_appoggio(
				    id_banca_appoggio integer not null,
				    cod_abi char(5) null,
				    den_abi char(40) null,
				    cod_cab char(5) null,
				    den_cab char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null default 'IT',
				    filiale char(40) null,
				    con_interbancaria char(1) null,
				    giorni_franchigia decimal(3) null,
				    primary key(id_banca_appoggio),
				    )  ;
				  //
				  create unique index xak1tmp_banca_appoggio on
				    "dba".tmp_banca_appoggio(cod_abi asc,cod_cab asc);
				  //
				  load into table tmp_banca_appoggio from 'C:\\windows\\temp\\banca_appoggio.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_appoggio;
				  //
				  message 'tabella TMP_BANCA_APPOGGIO record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //      
				  /*
				  ANAGRAFICA BANCA_SOG_COMMERCIALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_sog_commerciale')) then
				    drop table tmp_banca_sog_commerciale
				  end if
				  ;
				  //
				  create  table
				    "dba".tmp_banca_sog_commerciale(
				    id_banca_sog_commerciale integer not null default autoincrement,
				    id_anagrafica integer null,
				    id_banca_appoggio integer not null,
				    conto_corrente char(20) null,
				    cin char(1) null,
				    modo_uso char(1) not null,
				    id_azienda integer not null default 1,
				    primary key(id_banca_sog_commerciale),
				    )  ;
				  //
				  create index xif107tmp_banca_sog_commerciale on
				    "dba".tmp_banca_sog_commerciale(id_banca_appoggio asc);
				  //
				  load into table tmp_banca_sog_commerciale from 'C:\\windows\\temp\\banca_sog_commerciale.txt' format 'ASCII' delimited by '|' quotes off;
				  //
				
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_sog_commerciale;
				  //
				  message 'tabella TMP_BANCA_SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //       
				  */ 
				  message 'FINE LOAD ... ';
				  //
				  message 'INIZIO CREAZIONE INDICI PK  ... ';
				  //
				  //create index xpk_tmp_anagrafica on tmp_anagrafica(id_anagrafica asc);
				  //create index xpk_tmp_area on tmp_area(id_area asc);
				  create index xpk_tmp_articolo on tmp_articolo(id_articolo asc);
				  //create index xpk_tmp_att_svolta on tmp_att_svolta(id_att_svolta asc);
				 // create index xpk_tmp_banca_appoggio on tmp_banca_appoggio(id_banca_appoggio asc);
				  //create index xpk_tmp_banca_sog_commerciale on tmp_banca_sog_commerciale(id_banca_sog_commerciale asc);
				  //create index xpk_tmp_bilancio_cee on tmp_bilancio_cee(id_bilancio_cee asc);
				  //create index xpk_tmp_cat_attivita on tmp_cat_attivita(id_cat_attivita asc);
				  create index xpk_tmp_cat_codifica on tmp_cat_codifica(id_cat_codifica asc);
				  create index xpk_tmp_cat_com_articolo on tmp_cat_com_articolo(id_cat_com_articolo asc);
				  //create index xpk_tmp_cat_com_sc on tmp_cat_com_sc(id_cat_com_sc asc);
				  create index xpk_tmp_cat_fiscale on tmp_cat_fiscale(id_cat_fiscale asc);
				  create index xpk_tmp_cat_merceologica on tmp_cat_merceologica(id_cat_merceologica asc);
				  //create index xpk_tmp_cat_zona on tmp_cat_zona(id_cat_zona asc);
				  create index xpk_tmp_caus_magazzino on tmp_caus_magazzino(id_caus_magazzino asc);
				  create index xpk_tmp_caus_trasporto on tmp_caus_trasporto(id_caus_trasporto asc);
				  create index xpk_tmp_cif on tmp_cif(id_cif asc);
				  create index xpk_tmp_cod_parte on tmp_cod_parte(id_cod_parte asc);
				  create index xpk_tmp_con_pagamento on tmp_con_pagamento(id_con_pagamento asc);
				  //create index xpk_tmp_conto on tmp_conto(id_conto asc);
				  create index xpk_tmp_des_articolo on tmp_des_articolo(id_des_articolo asc);
				  //create index xpk_tmp_destinazione on tmp_destinazione(id_destinazione asc);
				  //create index xpk_tmp_esercizio on tmp_esercizio(id_esercizio asc);
				  //create index xpk_tmp_gruppo on tmp_gruppo(id_gruppo asc);
				  //create index xpk_tmp_gruppo_agenti on tmp_gruppo_agenti(id_gruppo_agenti asc);
				  create index xpk_tmp_gruppo_articoli on tmp_gruppo_articoli(id_gruppo_articoli asc);
				  create index xpk_tmp_lingua on tmp_lingua(id_lingua asc);
				  create index xpk_tmp_linguaggio on tmp_linguaggio(id_linguaggio asc);
				  create index xpk_tmp_listino on tmp_listino(id_listino asc);
				  //create index xpk_tmp_locazione on tmp_locazione(id_locazione asc);
				  create index xpk_tmp_log on tmp_log(id asc);
				  //create index xpk_tmp_magazzino on tmp_magazzino(id_magazzino asc);
				  //create index xpk_tmp_mastro on tmp_mastro(id_mastro asc);
				  //create index xpk_tmp_mod_registro on tmp_mod_registro(id_mod_registro asc);
				  create index xpk_tmp_parte_regola on tmp_parte_regola(id_parte_regola asc);
				  //create index xpk_tmp_pdc on tmp_pdc(id_pdc asc);
				  //create index xpk_tmp_prof_documento on tmp_prof_documento(id_prof_documento asc);
				 // create index xpk_tmp_prof_registrazione on tmp_prof_registrazione(id_prof_registrazione asc);
				  //create index xpk_tmp_reg_fiscale on tmp_reg_fiscale(id_reg_fiscale asc);
				  //create index xpk_tmp_registro on tmp_registro(id_registro asc);
				  create index xpk_tmp_reparto on tmp_reparto(id_reparto asc);
				  create index xpk_tmp_scelta_parte on tmp_scelta_parte(id_scelta_parte asc);
				  create index xpk_tmp_scomposizione on tmp_scomposizione(id_scomposizione asc);
				  //create index xpk_tmp_sog_commerciale on tmp_sog_commerciale(id_sog_commerciale asc);
				  //create index xpk_tmp_sottomastro on tmp_sottomastro(id_sottomastro asc);
				  create index xpk_tmp_spesa on tmp_spesa(id_spesa asc);
				  //create index xpk_tmp_tab_attivita on tmp_tab_attivita(id_tab_attivita asc);
				  create index xpk_tmp_tab_iva on tmp_tab_iva(id_tab_iva asc);
				  create index xpk_tmp_tipo_magazzino on tmp_tipo_magazzino(id_tipo_magazzino asc);
				  create index xpk_tmp_tipo_pagamento on tmp_tipo_pagamento(id_tipo_pagamento asc);
				  create index xpk_tmp_tipo_trasporto on tmp_tipo_trasporto(id_tipo_trasporto asc);
				 // create index xpk_tmp_titolo on tmp_titolo(id_titolo asc);
				 // create index xpk_tmp_tributo on tmp_tributo(id_tributo asc);
				  create index xpk_tmp_unita_conf_base on tmp_unita_conf_base(id_unita_conf_base asc);
				  create index xpk_tmp_unita_confezione on tmp_unita_confezione(id_unita_confezione asc);
				  create index xpk_tmp_unita_misura on tmp_unita_misura(id_unita_misura asc);
				  create index xpk_tmp_valuta on tmp_valuta(id_valuta asc);
				  create index xpk_tmp_variazione on tmp_variazione(id_variazione asc);
				  //
				  message 'FINE CREAZIONE INDICI PK  ... '
				//
				end;        
END IF;        
//TRASFERIMENTO DATI PARIGI

//Tracciabilit lotti (aggiunta miglioria per la stampa trac. a valle affich visualizzi il lotto di dest. anche per le trasformazioni
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_trac1_artdest'
        AND      CNAME = 'lotto_cod_esterno_sl' )) THEN 
        
	alter table tmp_trac1_artdest add lotto_cod_esterno_sl char(30) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_trac1_artdest'
        AND      CNAME = 'cod_articolo_sl' )) THEN 
        
	alter table tmp_trac1_artdest add cod_articolo_sl char(32) default null;
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_trac1_artdest'
        AND      CNAME = 'des_articolo_sl' )) THEN 
        
	alter table tmp_trac1_artdest add des_articolo_sl char(60) default null;
end if;
////////////////////////////

//Correzioni varie duplicazione documenti
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_dup_documento') THEN
        
				ALTER FUNCTION "DBA"."fn_dup_documento"(in @ai_id_documento integer,in @ad_num_progressivo decimal(12),in @ad_prog_globale decimal(16),in @ai_id_prof_doc integer,in @ai_id_registro integer,in @ai_id_caus_mag integer, in @ad_datareg date)
				returns integer
				begin
				  declare @li_id_documento_new integer;
				  declare @ls_sqlstate char(5);
				  declare row_not_found exception for sqlstate value '02000';
				  declare ok exception for sqlstate value '00000';
				  declare @li_id_locazione_1_prop integer;
				  declare @li_id_locazione_2_prop integer;
				  //
				  
				  select id_locazione_1_prop, id_locazione_2_prop
				  into @li_id_locazione_1_prop, @li_id_locazione_2_prop
				  from prof_documento 
				  where id_prof_documento = @ai_id_prof_doc;
				  
				  
				  message 'Inizio fn_dup_documento';
				  message ' Duplicazione del Documento:'+string(@ai_id_documento);
				  if(@ai_id_prof_doc=0 or @ai_id_registro=0 or @ai_id_caus_mag=0) then
				    insert into documento(id_prof_documento,id_registro,num_progressivo,
				      data_registrazione,num_documento,data_documento,data_competenza,
				      id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				      id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				      id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				      id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				      data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				      peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				      id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				      id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				      data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				      sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,
				      stampato,contabilizzato,evaso_totalmente,chius_forzata,
				      sospeso,data_scadenza,creato_in_esenzione,bloccato,prog_globale,
				      //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				      doc_globale,tipo_fattura,segno_iva,id_azienda,
				      ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				      id_locazione_1,id_locazione_2,storno_anticipi,id_variazione, bollo, id_gruppo_agenti_2,
				      data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona)
				      select id_prof_documento,id_registro,@ad_num_progressivo,
				        data_registrazione,num_documento,data_documento,data_competenza,
				        id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				        @ai_id_caus_mag,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				        id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				        id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				        data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				        peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				        id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				        id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				        data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				        sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,'N','N','N','N','N',
				        data_scadenza,creato_in_esenzione,'N',@ad_prog_globale,
				        //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				        doc_globale,tipo_fattura,segno_iva,id_azienda,
				        ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				        id_locazione_1,id_locazione_2,storno_anticipi,id_variazione, bollo, id_gruppo_agenti_2,
				        data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona
				        from documento
				        where id_documento=@ai_id_documento
				  else
				    if(@li_id_locazione_1_prop=0 or @li_id_locazione_1_prop is null) then
				        insert into documento(id_prof_documento,id_registro,num_progressivo,
				          data_registrazione,num_documento,data_documento,data_competenza,
				          id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				          id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				          id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				          id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				          data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				          peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				          id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				          id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				          data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				          sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,
				          stampato,contabilizzato,evaso_totalmente,chius_forzata,
				          sospeso,data_scadenza,creato_in_esenzione,bloccato,prog_globale,
				          //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				          doc_globale,tipo_fattura,segno_iva,id_azienda,
				          ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				          id_locazione_1,id_locazione_2,storno_anticipi,id_variazione,bollo, id_gruppo_agenti_2,
				          data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona)
				          select @ai_id_prof_doc,@ai_id_registro,@ad_num_progressivo,
				            //data_registrazione,num_documento,data_documento,data_competenza,
				            @ad_datareg,num_documento,data_documento,@ad_datareg,
				            id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				            @ai_id_caus_mag,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				            id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				            id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				            data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				            peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				            id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				            id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				            data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				            sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,'N','N','N','N','N',
				            data_scadenza,creato_in_esenzione,'N',@ad_prog_globale,
				            //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				            doc_globale,tipo_fattura,segno_iva,id_azienda,
				            ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				            id_locazione_1,id_locazione_2,storno_anticipi,id_variazione,bollo, id_gruppo_agenti_2,
				            data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona
				            from documento
				            where id_documento=@ai_id_documento
				        else
				            insert into documento(id_prof_documento,id_registro,num_progressivo,
				              data_registrazione,num_documento,data_documento,data_competenza,
				              id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				              id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				              id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				              id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				              data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				              peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				              id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				              id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				              data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				              sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,
				              stampato,contabilizzato,evaso_totalmente,chius_forzata,
				              sospeso,data_scadenza,creato_in_esenzione,bloccato,prog_globale,
				              //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				              doc_globale,tipo_fattura,segno_iva,id_azienda,
				              ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				              id_locazione_1,id_locazione_2,storno_anticipi,id_variazione,bollo, id_gruppo_agenti_2,
				              data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona)
				              select @ai_id_prof_doc,@ai_id_registro,@ad_num_progressivo,
				                //data_registrazione,num_documento,data_documento,data_competenza,
				                @ad_datareg,num_documento,data_documento,@ad_datareg,
				                id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
				                @ai_id_caus_mag,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
				                id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
				                id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
				                data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
				                peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
				                id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
				                id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
				                data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
				                sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,'N','N','N','N','N',
				                data_scadenza,creato_in_esenzione,'N',@ad_prog_globale,
				                //doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
				                doc_globale,tipo_fattura,segno_iva,id_azienda,
				                ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
				                @li_id_locazione_1_prop,@li_id_locazione_2_prop,storno_anticipi,id_variazione,bollo, id_gruppo_agenti_2,
				                data_ric_consegna, num_riga, id_utente, alt_pag, alt_ord, id_cat_zona
				                from documento
				                where id_documento=@ai_id_documento
				        end if
				  end if
				  ;
				  set @ls_sqlstate=sqlstate;
				  message 'aabbbb';
				  if(@ls_sqlstate='00000') then
				    message ' OK'
				  else
				    message '   Si e'' verificato un errore inserendo il documento - SQLSTATE:'+@ls_sqlstate;
				    return 0
				  end if
				  ;
				  //
				  message 'aaa';
				  //
				  set @li_id_documento_new=@@identity;
				  //
				  message ' Documento Inserito:'+string(@li_id_documento_new);
				  //
				  if(@ai_id_prof_doc=0 or @ai_id_registro=0 or @ai_id_caus_mag=0) then
				    insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
				      num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				      qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
				      qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
				      id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				      sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				      peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				      provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				      sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				      tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				      //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				      id_conto,id_azienda,provv_imp_agente,
				      provv_imp_subage,provv_imp_carea,id_riga_lotto,
				      qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
				      provv_agente_2,provv_subage_2,provv_carea_2,
				      provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				      id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				      id_alt_uc1, id_alt_uc2, id_alt_uc3)
				      select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
				        num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				        qta_sconto_merce,0,fat_con_unita_base,fat_con_globale,
				        qta_un_base,0,id_caus_magazzino,id_locazione_1,id_locazione_2,
				        id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				        sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				        peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				        provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				        sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				        tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				        //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				        id_conto,id_azienda,provv_imp_agente,
				        provv_imp_subage,provv_imp_carea,id_riga_lotto,
				        qta_ordinata_fo,ordinato_fo,0,id_gruppo_Agenti_2,
				        provv_agente_2,provv_subage_2,provv_carea_2,
				        provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				        id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				        id_alt_uc1, id_alt_uc2, id_alt_uc3
				        from riga_documento
				        where id_documento=@ai_id_documento order by
				        num_riga asc
				  else
				    
				      if(@li_id_locazione_1_prop=0 or @li_id_locazione_1_prop is null) then
				        insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
				          num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				          qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
				          qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
				          id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				          sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				          peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				          provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				          sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				          tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				          //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				          id_conto,id_azienda,provv_imp_agente,
				          provv_imp_subage,provv_imp_carea,id_riga_lotto,
				          qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
				          provv_agente_2,provv_subage_2,provv_carea_2,
				          provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				          id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				          id_alt_uc1, id_alt_uc2, id_alt_uc3)
				          select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
				            num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				            qta_sconto_merce,0,fat_con_unita_base,fat_con_globale,
				            qta_un_base,0,@ai_id_caus_mag,id_locazione_1,id_locazione_2,
				            id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				            sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				            peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				            provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				            sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				            tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				            //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				            id_conto,id_azienda,provv_imp_agente,
				            provv_imp_subage,provv_imp_carea,id_riga_lotto,
				            qta_ordinata_fo,ordinato_fo,0,id_gruppo_Agenti_2,
				            provv_agente_2,provv_subage_2,provv_carea_2,
				            provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				            id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				            id_alt_uc1, id_alt_uc2, id_alt_uc3
				            from riga_documento
				            where id_documento=@ai_id_documento order by
				            num_riga asc
				       else           
				        insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
				          num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				          qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
				          qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
				          id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				          sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				          peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				          provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				          sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				          tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				          //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				          id_conto,id_azienda,provv_imp_agente,
				          provv_imp_subage,provv_imp_carea,id_riga_lotto,
				          qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
				          provv_agente_2,provv_subage_2,provv_carea_2,
				          provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				          id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				          id_alt_uc1, id_alt_uc2, id_alt_uc3)
				          select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
				            num_riga,id_articolo,descrizione,id_des_articolo,quantita,
				            qta_sconto_merce,0,fat_con_unita_base,fat_con_globale,
				            //qta_un_base,qta_evasa_un_base,@ai_id_caus_mag,@li_id_locazione_1_prop,id_locazione_2,
				            qta_un_base,0,@ai_id_caus_mag,@li_id_locazione_1_prop,@li_id_locazione_2_prop,
				            id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
				            sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
				            peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
				            provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
				            sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
				            tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
				            //id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
				            id_conto,id_azienda,provv_imp_agente,
				            provv_imp_subage,provv_imp_carea,id_riga_lotto,
				            qta_ordinata_fo,ordinato_fo,0,id_gruppo_Agenti_2,
				            provv_agente_2,provv_subage_2,provv_carea_2,
				            provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2,
				            id_art_var1, id_art_var2, id_art_var3, id_distinta, id_operatore,
				            id_alt_uc1, id_alt_uc2, id_alt_uc3
				            from riga_documento
				            where id_documento=@ai_id_documento order by
				            num_riga asc
				        end if
				  end if
				  ;
				  set @ls_sqlstate=sqlstate;
				  message 'Righe Documento ...';
				  if(@ls_sqlstate='00000') then
				    message ' OK'
				  else
				    message '   Si e'' verificato un errore inserendo le righe del documento - SQLSTATE:'+@ls_sqlstate;
				    return 0
				  end if
				  ;
				  //
				  //  CASTELLETTO IVA
				  //
				  insert into cast_iva_documento(id_documento,id_tab_iva,val_omaggi,val_imponibile,
				    val_imp_scontato,val_spese,val_tot_imp_v,val_tot_imp_l,val_tot_iva_v,val_tot_iva_l)
				    select @li_id_documento_new,id_tab_iva,val_omaggi,val_imponibile,val_imp_scontato,
				      val_spese,val_tot_imp_v,val_tot_imp_l,val_tot_iva_v,val_tot_iva_l
				      from cast_iva_documento
				      where id_documento=@ai_id_documento;
				  //
				  //  CASTELLETTO CONTROPARTITA
				  //      
				  insert into cast_cpt_documento(id_documento,id_conto,tipo_riga_cpt,
				    val_imponibile,val_imp_scontato,val_omaggi,val_spese)
				    select @li_id_documento_new,id_conto,tipo_riga_cpt,
				      val_imponibile,val_imp_scontato,val_omaggi,val_spese
				      from cast_cpt_documento
				      where id_documento=@ai_id_documento;
				  //
				  //  SCADENZE
				  //          
				  //insert into scadenza(tipo_scadenza,id_sog_commerciale,data_scadenza,
				  //  id_valuta,cambio,imp_valuta,importo,id_tipo_pagamento,id_banca_azienda,
				  //  id_banca_sog_commerciale,note,ces_denominazione,ces_indirizzo,
				  //  ces_cap,ces_localita,ces_provincia,ces_doc_originale,ces_data_documento,
				  //  stato_scadenza,data_cambiamento_stato,esito_pagamento,scadenza_da_raggruppare,
				  //  id_riga_distinta_banca,id_documento,id_par_aperta,id_scadenza_padre,id_azienda)
				  //  select tipo_scadenza,id_sog_commerciale,data_scadenza,
				  //    id_valuta,cambio,imp_valuta,importo,id_tipo_pagamento,id_banca_azienda,
				  //    id_banca_sog_commerciale,note,ces_denominazione,ces_indirizzo,
				  //    ces_cap,ces_localita,ces_provincia,ces_doc_originale,ces_data_documento,
				  //    stato_scadenza,data_cambiamento_stato,esito_pagamento,scadenza_da_raggruppare,
				  //    id_riga_distinta_banca,@li_id_documento_new,id_par_aperta,id_scadenza_padre,id_azienda
				  //    from scadenza
				  //   where id_documento=@ai_id_documento;
				  return(@li_id_documento_new)
				end;        
end if;        
///////////////////////////////////////////

//////Blocco profili documento (TASSELLI)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'blocca_profilo' )) THEN 
        
				alter table prof_documento add "blocca_profilo" char(1) DEFAULT 'N';
				
				update prof_documento
				set blocca_profilo = 'N';
				commit;
end if; 

////Gestione semplificata costi acquisto (TASSELLI)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'spesa_riga_documento')) THEN
        
				CREATE TABLE "dba"."spesa_riga_documento" (
				"id_riga_documento" integer NOT NULL DEFAULT NULL, 
				"id_spesa" integer NOT NULL DEFAULT NULL, 
				"percentuale" numeric(5,2) DEFAULT NULL, 
				"importo" numeric(18,4) DEFAULT NULL, 
				"id_tab_iva" integer DEFAULT NULL, 
				"mantieni" char(1) DEFAULT NULL , 
				PRIMARY KEY ("id_riga_documento", "id_spesa") , 
				FOREIGN KEY "fk_spesa_riga_documento_1" ("id_riga_documento" ) REFERENCES "dba"."riga_documento" ON DELETE CASCADE ) ;
				
end if;				

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_costo_semp' )) THEN 
        
				alter table pers_par_sistema add id_prof_costo_semp integer default null;
end if; 

///////////////////////////////////////////////////



//SENATORI
if (SELECT codice FROM   AZIENDA)='SENATORI' then
   update oggetti set ogg_oggetto='w_var_documento_semp_17_cx' 
   where ogg_oggetto='w_var_documento_semp_cx';
end if;


///VALIDITA ANAGRAFICA
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'anag_validita') THEN

CREATE TABLE "dba"."anag_validita" 
("id_anag_validita" integer NOT NULL DEFAULT autoincrement, 
"id_anagrafica" integer NOT NULL, "data_inizio" date not null, "data_fine" date not null, 
"rag_soc_1" char(40) NOT NULL DEFAULT NULL, "rag_soc_2" char(40) DEFAULT NULL, 
"indirizzo" char(40) DEFAULT NULL, "cap" char(10) DEFAULT NULL, "localita" char(40) DEFAULT NULL, 
"provincia" char(5) DEFAULT NULL, "nazione" char(5) DEFAULT 'IT', "cod_fiscale" char(16) DEFAULT NULL, 
"par_iva" char(16) DEFAULT NULL, 
PRIMARY KEY ("id_anag_validita"), FOREIGN KEY "fk_anag_val" ("id_anagrafica" ) REFERENCES "dba"."anagrafica" ON DELETE CASCADE);

end if;


ALTER VIEW ws_registri_iva (data_registrazione,num_progressivo,tipo_registro,numero,data_documento,num_documento,descrizione,descrizione_a,importo,segno_reg_iva,imponibile,des_breve,per_aliquota,imposta,imp_valuta,cambio,codice,descrizione_b,simbolo,id_valuta,id_tab_iva,codice_iva,per_detrazione,st_reg_iva,st_reg_iva_a,st_data_reg_iva,st_data_reg_iva_a,ges_sco_giornaliero,ges_beni_rivendita,ges_beni_strumentali,ges_oper_intracomunitarie,id_valuta_es,data_comp_liq_iva,id_reg_pd,registro_des,id_prof_registrazione) AS select reg_pd.data_registrazione,reg_pd.num_progressivo,
 registro.tipo_registro,registro.numero,reg_pd.data_documento,
 reg_pd.num_documento, isnull((select max(v.rag_soc_1) from anag_validita v, sog_commerciale s
 where v.id_anagrafica=s.id_anagrafica and s.id_conto=conto.id_conto 
 and  v.data_inizio<=reg_pd.data_registrazione and v.data_fine>=reg_pd.data_registrazione),conto.descrizione),
reg_pd.descrizione as descrizione_a,
 reg_pd.importo,reg_pd.segno_reg_iva,
 mov_iva.imponibile,tab_iva.des_breve,tab_iva.per_aliquota,mov_iva.imposta,
 reg_pd.imp_valuta,reg_pd.cambio,valuta.codice,valuta.descrizione as descrizione_b,
 valuta.simbolo,valuta.id_valuta,tab_iva.id_tab_iva,
 tab_iva.codice as codice_iva,tab_iva.per_detrazione,reg_pd.st_reg_iva,
 mov_iva.st_reg_iva as st_reg_iva_a,reg_pd.st_data_reg_iva,
 mov_iva.st_data_reg_iva as st_data_reg_iva_a,
 REGISTRO.GES_SCO_GIORNALIERO,tab_iva.ges_beni_rivendita,tab_iva.ges_beni_strumentali,
 prof_registrazione.ges_oper_intracomunitarie,esercizio.id_valuta as id_valuta_es,
 reg_pd.data_comp_liq_iva,reg_pd.id_reg_pd,
 registro.descrizione as registro_des,prof_registrazione.id_prof_registrazione from
 dba.conto,dba.mov_iva,dba.reg_pd,dba.registro,
 dba.tab_iva,dba.valuta,dba.prof_registrazione,dba.esercizio where
 (reg_pd.id_reg_pd = mov_iva.id_reg_pd) and(
 reg_pd.id_conto = conto.id_conto) and(
 registro.id_registro = reg_pd.id_registro) and(
 tab_iva.id_tab_iva = mov_iva.id_tab_iva) and(
 valuta.id_valuta = reg_pd.id_valuta) and(
 reg_pd.id_prof_registrazione = prof_registrazione.id_prof_registrazione) and(
 registro.id_esercizio = esercizio.id_esercizio)
;


ALTER VIEW ws_libro_giornale (id_reg_pd,data_registrazione,num_documento,data_documento,descrizione,id_mov_contabile,id_conto,codice,descrizione_a,dare,avere,st_stampa_bollato,st_data_bollato,prog_stampato,st_stampa_bollato_a,st_data_bollato_a) AS select reg_pd.id_reg_pd,reg_pd.data_registrazione,reg_pd.num_documento,
 reg_pd.data_documento,reg_pd.descrizione,mov_contabile.id_mov_contabile,
 mov_contabile.id_conto,conto.codice,
isnull((select max(v.rag_soc_1) from anag_validita v, sog_commerciale s
 where v.id_anagrafica=s.id_anagrafica and s.id_conto=conto.id_conto 
 and  v.data_inizio<=reg_pd.data_registrazione and v.data_fine>=reg_pd.data_registrazione),conto.descrizione) as descrizione_a,
 mov_contabile.dare,mov_contabile.avere,reg_pd.st_stampa_bollato,
 reg_pd.st_data_bollato,mov_contabile.prog_stampato,
 mov_contabile.st_stampa_bollato as st_stampa_bollato_a,
 mov_contabile.st_data_bollato as st_data_bollato_a from
 dba.conto,dba.mov_contabile,dba.reg_pd,dba.registro where
 (mov_contabile.id_conto = conto.id_conto) and(
 reg_pd.id_reg_pd = mov_contabile.id_reg_pd) and(
 registro.id_registro = reg_pd.id_registro) and(
 registro.tipo_registro <> 'MN');


//////Abbinamento codici a barre per Skorpio (TASSELLI)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'barcabil'
        AND      CNAME = 'id_uc' )) THEN 
        
				alter table barcabil add id_uc integer default null;
				
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'barcodes'
        AND      CNAME = 'id_uc' )) THEN 
        
				alter table barcodes add id_uc integer default null;
end if; 		


///ricerca semplificata documento
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'data_doc_retro' )) THEN 
	alter table par_sistema add data_doc_retro integer default null;
	alter table par_sistema add tipo_doc_retro char(1) default null;
end if; 



//NOTE RIGA DOCUMENTO - messaggio pesi colli
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'doc_avviso_pesi_colli' )) THEN 

	alter table par_sistema add doc_avviso_pesi_colli char(1);
	alter table par_sistema add doc_avviso_in_ordine char(1);
	update par_sistema set doc_avviso_pesi_colli='S';
	update par_sistema set doc_avviso_in_ordine='N';

	IF EXISTS(SELECT 1 FROM   azienda
	        WHERE  (codice = 'CREART' or codice='PRECIUS')) THEN 
		update par_sistema set doc_avviso_pesi_colli='N';
		update par_sistema set doc_avviso_in_ordine='S';
	end if;

end if;


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'riga_documento_produzione') THEN
	CREATE TABLE "dba"."riga_documento_produzione" 
		("id_riga_documento_produzione" integer NOT NULL DEFAULT autoincrement, 
		 "id_anag_modello" integer NULL DEFAULT NULL, 
                 "id_riga_documento" integer NOT NULL DEFAULT NULL, 
                 "data_conferma" date DEFAULT NULL, "quantita" numeric(18,4) DEFAULT NULL, 
                 "prezzo" numeric(18,4) DEFAULT NULL , 
                 PRIMARY KEY ("id_riga_documento_produzione") , 
	FOREIGN KEY "fk_riga_documento_produzione_2" ("id_riga_documento" ) REFERENCES "dba"."riga_documento" ON DELETE RESTRICT ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento_produzione'
        AND      CNAME = 'note_produzione' )) THEN 

	ALTER TABLE riga_documento_produzione ADD note_produzione long varchar DEFAULT NULL;
	ALTER TABLE riga_documento_produzione drop FOREIGN KEY "fk_riga_documento_produzione_1";
	ALTER TABLE riga_documento_produzione drop FOREIGN KEY "fk_riga_documento_produzione_2";
	ALTER TABLE riga_documento_produzione ADD FOREIGN KEY "fk_riga_documento_produzione_2" ("id_riga_documento" ) REFERENCES "dba"."riga_documento" ON DELETE CASCADE;
	ALTER TABLE riga_documento_produzione rename id_anag_modello to id_anag_modello_bis;
	ALTER TABLE riga_documento_produzione add id_anag_modello integer DEFAULT NULL;
	update riga_documento_produzione set id_anag_modello=id_anag_modello_bis;
	ALTER TABLE riga_documento_produzione drop id_anag_modello_bis;
	CREATE UNIQUE INDEX "xk_riga_doc_prod_1" ON "dba"."riga_documento_produzione" ("id_riga_documento" ) ;

	CREATE TABLE "dba"."anag_lavorazione" 
	("id_anag_lavorazione" integer NOT NULL DEFAULT autoincrement, 
	"tipo_anag_lav" char(1) not null,
	"id_articolo" integer DEFAULT NULL, 
	"cod_lavorazione" char(8) NOT NULL, 
	"des_breve_lavorazione" char(40) DEFAULT NULL, 
	"des_lavorazione" long varchar DEFAULT NULL, 
	"prezzo" numeric(18,4) DEFAULT NULL, PRIMARY KEY ("id_anag_lavorazione"));
	CREATE UNIQUE INDEX "xk_anag_lav_codice" ON "dba"."anag_lavorazione" ("cod_lavorazione" ) ;


	call fn_ins_voce_menu('Articoli', 'w_anag_lavorazione_ff', 'Note Aggiuntive Riga Documento', 141);

	IF EXISTS(SELECT 1 FROM   azienda
	        WHERE  codice = 'SENATORI') THEN 
		call fn_ins_voce_menu('Personalizzazioni', 'w_canc_doc_17_wz', 'Cancellazione Documenti', 450);
	end if;

end if; 

call fn_ins_voce_menu('Documenti', 'w_ricalcola_doc_cx', 'Ricalcolo Totali Documenti', 250);


IF (EXISTS(
    SELECT 1 
    FROM sys.systable
    where table_name = 'prof_cespite')) THEN

	IF NOT(EXISTS(
	        SELECT 1 
	        FROM   SYS.SYSCOLUMNS
	        WHERE  TNAME = 'prof_cespite'
	        AND      CNAME = 'rettifica_valore' )) THEN 

		ALTER TABLE prof_cespite add rettifica_valore char(1) DEFAULT 'N';
		update prof_cespite set rettifica_valore='N';

	        INSERT INTO prof_cespite (codice, rettifica_valore, descrizione, prof_base)
                values ('RETT', 'S', 'RETTIFICA VALORE','V');

	end if;
END IF;


IF NOT(EXISTS(
       SELECT 1 FROM   SYS.SYSCOLUMNS
       WHERE  TNAME = 'perc_ric_listini'
       AND      CNAME = 'id_listino' )) THEN 

       ALTER TABLE perc_ric_listini ADD  id_listino integer DEFAULT NULL;

end if;


//////////////Duplicazione documenti (correzione perch alcuni database non hanno un campo "num_riga" che causa errore)
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'num_riga' )) THEN 
        
				alter table documento add num_riga integer default null;
end if;

///////Importazione ddt x Belardi
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'path_bel_impddt' )) THEN 
        
				alter table pers_par_sistema add path_bel_impddt char(80) default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_cat_codifica_default' )) THEN 
        
				alter table par_sistema add id_cat_codifica_default integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_cat_com_art_default' )) THEN 
        
				alter table par_sistema add id_cat_com_art_default integer default null;
end if; 



//SENATORI PERC

ALTER TRIGGER "t_perc_ric_listini_bu".t_perc_ric_listini_bu before update order 2
	on "DBA".perc_ric_listini
	referencing old as deleted new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_listino,0,id_listino)=ifnull(inserted.id_listino,0,inserted.id_listino)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo)
        and id_perc_ric_listini<>inserted.id_perc_ric_listini;
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_perc_ricarico(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,null,null,null,null,null,null,null,null,inserted.id_listino)) as decimal(18))
	  end if
end;


ALTER TRIGGER "t_perc_ric_listini_bi".t_perc_ric_listini_bi before insert order 1
	on "DBA".perc_ric_listini
	referencing new as inserted
	for each row
	begin
	  declare @li_id_perc_ric_listini integer;
	  set @li_id_perc_ric_listini=0;
	  select id_perc_ric_listini into @li_id_perc_ric_listini
	    from perc_ric_listini
	    where ifnull(id_sog_commerciale,0,id_sog_commerciale)=ifnull(inserted.id_sog_commerciale,0,inserted.id_sog_commerciale)
	    and ifnull(id_cat_com_sc,0,id_cat_com_sc)=ifnull(inserted.id_cat_com_sc,0,inserted.id_cat_com_sc)
	    and ifnull(id_articolo,0,id_articolo)=ifnull(inserted.id_articolo,0,inserted.id_articolo)
	    and ifnull(id_listino,0,id_listino)=ifnull(inserted.id_listino,0,inserted.id_listino)
	    and ifnull(id_cat_com_articolo,0,id_cat_com_articolo)=ifnull(inserted.id_cat_com_articolo,0,inserted.id_cat_com_articolo);
	  message 'Condizione di listino: ',@li_id_perc_ric_listini;
	  if @li_id_perc_ric_listini>0 then
	    message 'Condizione di listino gia'' esistente: ',@li_id_perc_ric_listini,'  ',inserted.id_perc_ric_listini;
	    raiserror 99999 'Condizione di listino gia'' esistente ...'+string(@li_id_perc_ric_listini)+'  '+string(inserted.id_perc_ric_listini);
	    rollback work
	  else
	    set inserted.priorita=cast((fn_calc_priorita_perc_ricarico(null,inserted.id_sog_commerciale,inserted.id_cat_com_sc,null,inserted.id_articolo,inserted.id_articolo,inserted.id_cat_com_articolo,inserted.id_cat_merceologica,null,null,null,null,null,null,null,null,inserted.id_listino)) as decimal(18))
	  end if
end;


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_calc_priorita_perc_ricarico') THEN


CREATE FUNCTION "DBA"."fn_calc_priorita_perc_ricarico"(in @id_destinazione integer,in @id_sog_commerciale integer,in @id_cat_com_sc integer,in @id_unita_confezione integer,in @id_art_da integer,in @id_art_a integer,in @id_cat_com_articolo integer,in @id_cat_merceologica integer,in @id_fornitore integer,in @id_produttore integer,in @data_inizio date,in @data_fine date,in @qta_min decimal(18,4),in @qta_max decimal(18,4),in @tras_mezzo char(1),in @id_tipo_trasporto integer,in @id_listino integer)
returns integer
begin
  /*
  Elisa M.                  20/12/00                BL#10276#
  Chiamata da: T_CON_LIS_ARTICOLO_AI, T_CON_LIS_ARTICOLO_AU
  */
  /* Massimo Zurli - modificata secondo le richieste il 06/04/01*/
  declare @li_return integer;
  set @li_return=0;
  if(@id_produttore is not null) then
    set @li_return=@li_return+50000000
  end if
  ;
  if(@id_destinazione is not null) then
    set @li_return=@li_return+30000000
  end if
  ;
  if(@id_sog_commerciale is not null) then
    set @li_return=@li_return+20000000
  end if
  ;
  if(@id_cat_com_sc is not null) then
    set @li_return=@li_return+10000000
  end if
  ;
  if(@id_listino is not null) then
    set @li_return=@li_return+5000000
  end if
  ;
  if(@id_unita_confezione is not null) then
    set @li_return=@li_return+3000000
  end if
  ;
  if(@id_art_da is not null) and(@id_art_a=@id_art_da) then
    set @li_return=@li_return+2000000
  else
    if(@id_art_da is not null) or(@id_art_a is not null) then
      set @li_return=@li_return+1000000
    end if
  end if
  ;
  // BL#10277#i
  if(@id_cat_merceologica is not null) then
    set @li_return=@li_return+1000000
  end if
  ;
  if(@id_cat_com_articolo is not null) then
    set @li_return=@li_return+100000
  end if
  ;
  if(@id_fornitore is not null) then
    set @li_return=@li_return+10000
  end if
  ;
  if(@data_inizio is not null) and(@data_fine is not null) then
    set @li_return=@li_return+200
  end if
  ;
  if(@data_inizio is not null) and(@data_fine is null) then
    set @li_return=@li_return+100
  end if
  ;
  if(@qta_min is not null) and(@qta_max is not null) then
    set @li_return=@li_return+10
  end if
  ;
  if(@tras_mezzo is not null or @id_tipo_trasporto is not null) then
    set @li_return=@li_return+1
  end if
  ;
  return(@li_return)
end;



end if;





IF EXISTS(SELECT 1 FROM   azienda
        WHERE  codice = 'SENATORI') THEN 


	ALTER FUNCTION "DBA"."fn_calc_priorita_perc_ricarico"(in @id_destinazione integer,in @id_sog_commerciale integer,in @id_cat_com_sc integer,in @id_unita_confezione integer,in @id_art_da integer,in @id_art_a integer,in @id_cat_com_articolo integer,in @id_cat_merceologica integer,in @id_fornitore integer,in @id_produttore integer,in @data_inizio date,in @data_fine date,in @qta_min decimal(18,4),in @qta_max decimal(18,4),in @tras_mezzo char(1),in @id_tipo_trasporto integer,in @id_listino integer)
	returns integer
	begin

	  /*
	  Elisa M.                  20/12/00                BL#10276#
	  Chiamata da: T_CON_LIS_ARTICOLO_AI, T_CON_LIS_ARTICOLO_AU
	  */
	  /* Massimo Zurli - modificata secondo le richieste il 06/04/01*/

  declare @li_return integer;
  set @li_return=0;


  if(@id_unita_confezione is not null) then
    set @li_return=@li_return+30000000
  end if
  ;

  if(@id_art_da is not null) and(@id_art_a=@id_art_da) then
    set @li_return=@li_return+20000000
  else
    if(@id_art_da is not null) or(@id_art_a is not null) then
      set @li_return=@li_return+10000000
    end if
  end if
  ;

  if(@id_cat_merceologica is not null) then
    set @li_return=@li_return+3000000
  end if
  ;

  if(@id_listino is not null) then
    set @li_return=@li_return+2000000
  end if
  ;

  if(@id_destinazione is not null) then
    set @li_return=@li_return+1000000
  end if
  ;

  if(@id_sog_commerciale is not null) then
    set @li_return=@li_return+300000
  end if
  ;
  if(@id_cat_com_sc is not null) then
    set @li_return=@li_return+200000
  end if
  ;

  if(@id_cat_com_articolo is not null) then
    set @li_return=@li_return+100000
  end if
  ;

  if(@data_inizio is not null) and(@data_fine is not null) then
    set @li_return=@li_return+200
  end if
  ;

	  return(@li_return)
	end;

end if;


IF EXISTS(SELECT 1 FROM   azienda
        WHERE  codice <> 'PARIGI') THEN 
	call fn_ins_voce_menu('Altre Stampe Contabili', 'w_or_fatture_da_reg_pd_st', 'Fatturato da Contabilit', 75);
end if;

///////////////////BRIGANTI - MADERO per lotti
IF (EXISTS(select 1 from sysforeignkeys 
	where role='fk_movimenti_lotto_2')) THEN 
  ALTER TABLE movimenti_lotto drop FOREIGN KEY "fk_movimenti_lotto_2";	
	ALTER TABLE movimenti_lotto ADD FOREIGN KEY "fk_movimenti_lotto_2" ("id_riga_documento" ) REFERENCES "dba"."riga_documento" ON DELETE CASCADE ;	                             
end if;
//////////////////////////////////////////////

///////////////////BELARDI COMMESSE
IF (EXISTS(select 1 from sysforeignkeys 
	where role='fk_com_bilancio_3')) THEN 
  ALTER TABLE com_bilancio drop FOREIGN KEY "fk_com_bilancio_3";	
	ALTER TABLE com_bilancio ADD FOREIGN KEY "fk_com_bilancio_3" ("id_documento" ) REFERENCES "dba"."documento" ON DELETE CASCADE ;	                             	                                
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_bilancio'
        AND      CNAME = 'quantita' )) THEN 
        
				alter table com_bilancio add quantita numeric(18,4) default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_bilancio'
        AND      CNAME = 'id_locazione' )) THEN 
        
				alter table com_bilancio add id_locazione integer default null;
end if; 
//////////////////////////////////////////////



//NOTE SU CONDIZIONI DI PAGAMENTO
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'con_pagamento'
        AND      CNAME = 'note' )) THEN 
        
				alter table con_pagamento add note char(256) default null;
end if; 

//NOTE SU TIPO TRASPORTO
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tipo_trasporto'
        AND      CNAME = 'note' )) THEN 
        
				alter table tipo_trasporto add note char(256) default null;
end if; 

///Parametri sistema negozi
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_sis_negozi')) THEN
				
				CREATE TABLE "dba"."par_sis_negozi" (
				"id_par_sis_negozi" integer NOT NULL DEFAULT autoincrement, 
				"negozio" char(80) DEFAULT NULL, 
				"id_prof_prepord_7400" integer DEFAULT NULL, 
				"id_prof_ord_7400" integer DEFAULT NULL, 
				"id_caus_prepord_7400" integer DEFAULT NULL, 
				"id_list_variazioni" integer DEFAULT NULL, 
				"id_prof_offerte" integer DEFAULT NULL, 
				"id_prof_chius_offerte" integer DEFAULT NULL, 
				"id_prof_variazioni" integer DEFAULT NULL, 
				"id_prof_vend_rch" integer DEFAULT NULL , 
				PRIMARY KEY ("id_par_sis_negozi")) ;
end if; 
//////////////////////////////////////////

//Proposta destinazione su documenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'id_dest_prop' )) THEN 
        
				alter table prof_documento add id_dest_prop integer default null;
end if; 
//////////////////

//Euroservice
IF (EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'euro_std')) THEN
        
				IF NOT(EXISTS(
				        SELECT 1 
				        FROM   SYS.SYSCOLUMNS
				        WHERE  TNAME = 'euro_std'
				        AND      CNAME = 'perc_scarti' )) THEN 
				        
								alter table euro_std add perc_scarti numeric(5,2) default null;
				end if; 
end if; 



///////////////PARIGI - GRUPPI PRODUZIONE
//Euroservice
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'gruppo_produzione')) THEN

	CREATE TABLE "dba"."gruppo_produzione" ("id_gruppo_produzione" integer NOT NULL DEFAULT autoincrement, 
	"codice" char(20) NOT NULL DEFAULT NULL, "descrizione" char(40) DEFAULT NULL, 
	"id_azienda" integer NOT NULL DEFAULT 1 , PRIMARY KEY ("id_gruppo_produzione")) ;
	CREATE UNIQUE INDEX "ix_gruppo_produzione_1" ON "dba"."gruppo_produzione" ("codice" , "id_azienda" ) ;

	alter table articolo add id_gruppo_produzione integer null;
	alter table articolo add FOREIGN KEY "fk_articolo_16" ("id_gruppo_produzione" ) REFERENCES "dba"."gruppo_produzione" ON DELETE RESTRICT ;

end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'gruppo_produzione'
        AND      CNAME = 'id_sog_commerciale' )) THEN 
        
				alter table gruppo_produzione add id_sog_commerciale integer default null;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sog_commerciale'
        AND      CNAME = 'note_fido' )) THEN 
        
	alter table sog_commerciale add note_fido char(256) default null;
end if; 


//SENATORI BLOCCO TESTA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
        AND      CNAME = 'blocca_testa_doc' )) THEN 
        
	alter table prof_documento ADD blocca_testa_doc char(1) default 'N';
end if; 


update bilancio_cee set id_bil_padre=215 where id_bilancio_cee=230;
update bilancio_cee set id_bil_padre=215 where id_bilancio_cee=231;
update bilancio_cee set id_bil_padre=215 where id_bilancio_cee=232;
update bilancio_cee set id_bil_padre=215 where id_bilancio_cee=233;

//Import DDT da betonsystem BELARDI
//Campo per import ddt trasferimento tra cantieri
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_par_sistema'
        AND      CNAME = 'id_prof_documento2' )) THEN 
        
        alter table cct_par_sistema add id_prof_documento2 integer default null;
end if;

//Campo per import ddt vendita alternativo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_par_sistema'
        AND      CNAME = 'id_prof_documento3' )) THEN 
        
        alter table cct_par_sistema add id_prof_documento3 integer default null;
end if;

//Campo per import ddt vendita alternativo
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cct_par_sistema'
        AND      CNAME = 'id_prof_documento4' )) THEN 
        
        alter table cct_par_sistema add id_prof_documento4 integer default null;
end if;
//////////////////////////

//Pad note costo aggiuntivo distinta
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'note_costoagg' )) THEN 
        
        alter table distinta add note_costoagg char(80) default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'costo_assiale' )) THEN 
        
        alter table distinta add costo_assiale numeric(18,4) default null;
end if;
////////////////////////////////////

///////QUANTITA CON DECIMALI TERMINALI SKORPIO
ALTER TABLE barcodes
modify qta char(10) DEFAULT null;

ALTER TABLE ordpartx
modify qta char(10) DEFAULT null;

ALTER TABLE ordpartx
modify giac char(10) DEFAULT null;

ALTER TABLE conftx
modify qta char(10) DEFAULT null;

ALTER TABLE ordparrx
modify qta char(10) DEFAULT null;

ALTER TABLE confrx
modify qta char(10) DEFAULT null;
//////////////////////////////////////////////

//Registratore di CASSA RCH GLOBE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'rc_rchglobe' )) THEN 
        
        alter table pers_par_sistema add rc_rchglobe char(1) default null;
end if;



//TOUCH SCREEN
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sis_touch'
        AND      CNAME = 'win_DOC' )) THEN 
        
        alter table par_sis_touch add win_DOC char(40) default null;

	IF EXISTS(SELECT 1 FROM   azienda
        WHERE  codice='MADERO') THEN 
	       UPDATE par_sis_touch SET win_DOC='w_touch_doc_cx';	       
	end if;	

end if;

//Data creazione cod_barre
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cod_barre'
        AND      CNAME = 'data_creazione' )) THEN 
        
        alter table cod_barre add data_creazione date default null;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'cod_barre_esteso'
        AND      CNAME = 'data_creazione' )) THEN 
        
        alter table cod_barre_esteso add data_creazione date default null;
end if;

IF (EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_cod_barre_bi')) THEN
        
				ALTER TRIGGER "t_cod_barre_bi" BEFORE INSERT
					ORDER 1 ON "DBA"."cod_barre"
					referencing new as new_con
					for each row
					begin
					    declare @ls_var1 long varchar;
					    declare @ls_var2 long varchar;
					    declare @ls_var3 long varchar;
				        declare @data_creaz date;
					    if new_con.id_art_var1 is null then 
					       set @ls_var1='N'
					    else
					        set @ls_var1=string(new_con.id_art_var1)
					    end if;
					    if new_con.id_art_var2 is null then 
					        set @ls_var2='N'
					    else
					        set @ls_var2=string(new_con.id_art_var2)
					    end if;
					    if new_con.id_art_var3 is null then 
					        set @ls_var3='N'
					    else
					        set @ls_var3=string(new_con.id_art_var3)
					    end if;
						SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
				
				        //impostazione data_creazione
				        set @data_creaz=today(*);
				        SET new_con.data_creazione = @data_creaz;
					end;        
END IF;

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_cod_barre_esteso_bi')) THEN
        
				CREATE TRIGGER "t_cod_barre_esteso_bi" BEFORE INSERT
					ORDER 1 ON "DBA"."cod_barre_esteso"
					referencing new as new_con
					for each row
					begin
				        declare @data_creaz date;
				        //impostazione data_creazione
				        set @data_creaz=today(*);
				        SET new_con.data_creazione = @data_creaz;
					end;        
END IF;
//////////////////////////////////


/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/


//DA ESEGUIRE IN TUTTI GLI SCRIPT


IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'TMP_FATTURATO') THEN
	DROP TABLE TMP_FATTURATO;
end if; 

CREATE TABLE "dba"."tmp_fatturato" 
("cod_1" char(32) DEFAULT NULL, "des_1" char(80) DEFAULT NULL, "cod_2" char(32) DEFAULT NULL, 
"des_2" char(80) DEFAULT NULL, "cod_3" char(32) DEFAULT NULL, "des_3" char(80) DEFAULT NULL, 
"cod_4" char(32) DEFAULT NULL, "des_4" char(80) DEFAULT NULL, "imp_1" numeric(18,4) DEFAULT NULL, 
"imp_2" numeric(18,4) DEFAULT NULL, "cod_art" char(32) DEFAULT NULL, "des_art" char(80) DEFAULT NULL, 
"quantita" numeric(20,6) DEFAULT NULL, "peso_netto" numeric(20,6) DEFAULT NULL, 
"prezzo_netto" numeric(20,6) DEFAULT NULL, "num_progressivo" integer DEFAULT NULL, 
"data_registrazione" date DEFAULT NULL, "id_documento" integer DEFAULT NULL, "id_articolo" integer DEFAULT NULL, 
"id_tmp_fatturato" integer NOT NULL DEFAULT autoincrement, "segno_iva" integer DEFAULT NULL) ;


///////////////////////////////
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_012' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_012','Release 2_01_012  Cometa','S')
        ;

END IF
;

