//INIZIO 2_01_016

//////LOTTO PER LOCAZIONE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'lotto'
        AND      CNAME = 'id_locazione' )) THEN 
		
	ALTER TABLE lotto ADD id_locazione integer DEFAULT NULL;
	update lotto, par_sistema
	set lotto.id_locazione 	= par_sistema.id_locazione
	where lotto.id_locazione is null;
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'lotto'
        AND      CNAME = 'id_lotto_prov' )) THEN 
		
	ALTER TABLE lotto ADD id_lotto_prov integer DEFAULT NULL;
	CREATE INDEX "ix_lotto_4" ON "dba"."lotto" ("id_lotto_prov" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_doc_lotto'
        AND      CNAME = 'id_riga_lotto_prov' )) THEN 
		
	ALTER TABLE riga_doc_lotto ADD id_riga_lotto_prov integer DEFAULT NULL;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_trac_lotti'
        AND      CNAME = 'id_locazione' )) THEN		
		
		ALTER TABLE tmp_trac_lotti ADD id_locazione integer DEFAULT NULL;
		CREATE INDEX "ix_tmp_trac_lotti_2" ON "dba"."tmp_trac_lotti" ("id_locazione" , "lotto_data_doc" , "lotto_cod_esterno" , "articolo_codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tmp_trac2_lotti'
        AND      CNAME = 'id_locazione' )) THEN		
		
		ALTER TABLE tmp_trac2_lotti ADD id_locazione integer DEFAULT NULL;
		CREATE UNIQUE INDEX "ix_tmp_trac2_lotti_2" ON "dba"."tmp_trac2_lotti" ("id_locazione" , "lotto_data_doc" , "lotto_cod_esterno" , "articolo_codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_trac1_arttrasf')) THEN
		
		CREATE TABLE "dba"."tmp_trac1_arttrasf" (
			"id_tmp_trac1_arttrasf" integer NOT NULL DEFAULT autoincrement, 
			"lotto_cod_esterno" char(30) DEFAULT NULL, 
			"lotto_data_scadenza" date DEFAULT NULL, 
			"documento_num_progressivo" integer DEFAULT NULL, 
			"documento_data_registrazione" date DEFAULT NULL, 
			"prof_documento_codice" char(10) DEFAULT NULL, 
			"sog_commerciale_gen_codice" char(8) DEFAULT NULL, 
			"sog_commerciale_gen_rag_soc_1" char(60) DEFAULT NULL, 
			"riga_documento_quantita" numeric(18,4) DEFAULT NULL, 
			"riga_documento_peso_netto" numeric(18,4) DEFAULT NULL, 
			"ra_id_lotto" integer DEFAULT NULL, 
			"ra_id_articolo" integer DEFAULT NULL, 
			"id_tmp_trac_lotti" integer DEFAULT NULL, 
			"lotto_cod_esterno_sl" char(30) DEFAULT NULL, 
			"cod_articolo_sl" char(32) DEFAULT NULL, 
			"des_articolo_sl" char(60) DEFAULT NULL , 
			"mag_destinazione" char(60) DEFAULT NULL , 
			PRIMARY KEY ("id_tmp_trac1_arttrasf") , FOREIGN KEY "fk_tmp_trac1_arttrasf_1" ("id_tmp_trac_lotti" ) REFERENCES "dba"."tmp_trac_lotti" ON DELETE CASCADE ) ;
			
		CREATE INDEX "ix_tmp_trac1_arttrasf_1" ON "dba"."tmp_trac1_arttrasf" ("documento_data_registrazione" , "documento_num_progressivo" , "lotto_cod_esterno" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_trac1_arttrasf_mp')) THEN
		
		CREATE TABLE "dba"."tmp_trac1_arttrasf_mp" (
		"id_tmp_trac1_arttrasf_mp" integer NOT NULL DEFAULT autoincrement, 
		"lotto_cod_esterno" char(30) DEFAULT NULL, 
		"lotto_data_scadenza" date DEFAULT NULL, 
		"documento_num_progressivo" integer DEFAULT NULL, 
		"documento_data_registrazione" date DEFAULT NULL, 
		"prof_documento_codice" char(10) DEFAULT NULL, 
		"sog_commerciale_gen_codice" char(8) DEFAULT NULL, 
		"sog_commerciale_gen_rag_soc_1" char(60) DEFAULT NULL, 
		"riga_documento_quantita" numeric(18,4) DEFAULT NULL, 
		"riga_documento_peso_netto" numeric(18,4) DEFAULT NULL, 
		"ra_id_lotto" integer DEFAULT NULL, 
		"ra_id_articolo" integer DEFAULT NULL, 
		"id_tmp_trac_lotti" integer DEFAULT NULL , 
		"mag_destinazione" char(60) DEFAULT NULL , 		
		PRIMARY KEY ("id_tmp_trac1_arttrasf_mp") , FOREIGN KEY "fk_tmp_trac1_arttrasf_mp_2" ("id_tmp_trac_lotti" ) REFERENCES "dba"."tmp_trac_lotti" ON DELETE CASCADE ) ;
		
		CREATE INDEX "ix_tmp_trac1_arttrasf_mp_1" ON "dba"."tmp_trac1_arttrasf_mp" ("documento_data_registrazione" , "documento_num_progressivo" , "lotto_cod_esterno" ) ;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'tmp_trac2_arttrasf')) THEN
		
		CREATE TABLE "dba"."tmp_trac2_arttrasf" (
		"id_tmp_trac2_arttrasf" integer NOT NULL DEFAULT autoincrement, 
		"riga_documento_peso_netto" numeric(18,4) DEFAULT NULL, 
		"documento_num_progressivo" integer DEFAULT NULL, 
		"documento_data_registrazione" date DEFAULT NULL, 
		"prof_documento_codice" char(10) DEFAULT NULL, 
		"sog_commerciale_gen_codice" char(8) DEFAULT NULL, 
		"sog_commerciale_gen_rag_soc_1" char(60) DEFAULT NULL,
		"id_tmp_trac2_lotti" integer DEFAULT NULL, 
		"ra_id_lotto" integer DEFAULT NULL, 
		"ra_id_articolo" integer DEFAULT NULL , 
		"mag_provenienza" char(60) DEFAULT NULL,
		PRIMARY KEY ("id_tmp_trac2_arttrasf") , FOREIGN KEY "fk_tmp_trac2_arttrasf_2" ("id_tmp_trac2_lotti" ) REFERENCES "dba"."tmp_trac2_lotti" ON DELETE CASCADE ) ;
		CREATE INDEX "ix_tmp_trac2_arttrasf1" ON "dba"."tmp_trac2_arttrasf" ("documento_data_registrazione" , "documento_num_progressivo" ) ;
end if;	
	
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_esi_lotti') THEN
		
		ALTER FUNCTION "DBA"."fn_esi_lotti"(in @id_lotto integer,in @id_magazzino integer,in @fino_al date,in @id_valuta_f integer)
				returns char(80)
				begin
				  /*
				  Elisa Moneti  05/06/2001      BL#13259#
				  07/02/2002      BL#18197#
				
				  Calcolo:
				  . 	"Esistenza Fiscale" (Carichi - Scarichi)
				
				  Argomenti input:
				  . ID Lotto    (Obbligatorio)
				  . ID Magazzino	(Obbligatorio, se 0 tutti i magazzini)
				  . Fino Al     (Obbligatorio)
				
				  Valore di ritorno:
				  . 1 - 20 	carattere --> Esistenza Fisica
				  */
				  //
				  //
				  declare @ld_carichi decimal(18,4);
				  declare @ld_carichi_trasf decimal(18,4); //12.01.10
			      declare @ld_carichi_rien decimal(18,4); //12.01.10
				  declare @ld_scarichi decimal(18,4);
				  declare @ld_scarichi_trasf decimal(18,4); //12.01.10
                  declare @ld_scarichi_rien decimal(18,4); //12.01.10
				  declare @ls_carichi char(20);
				  declare @ls_scarichi char(20);
				  declare @ld_costo_acquisto decimal(18,4);
				  declare @ls_costo_acquisto char(20);
				  /* Valori di ritorno */
				  declare @ld_esi_fisica decimal(18,4);
				  declare @ls_esi_fisica char(20);
				  declare @ls_tipo_mov char(1);
				  //
				  select m.tipo into @ls_tipo_mov
				    from unita_confezione as u,unita_misura as m,lotto as l
				    where l.id_lotto=@id_lotto
				    and u.id_articolo=l.id_articolo
				    and u.unita_base='S'
				    and m.id_unita_misura=u.id_unita_misura;
				  //
				  message ' Tipo Movimentazione:'+@ls_tipo_mov;
				  //
				  if(@ls_tipo_mov='P') then
				    if @id_magazzino=0 then
				      /* 
				      Calcolo l''Esistenza Fisica Totale a Peso
				      */
				      //      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(r.prezzo_netto) 
				
				
				      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				        @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='C'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro;
				
				      //select (Sum(ifnull(r.peso_netto,0, if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi, 
				      //@ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      //  where l.id_lotto=@id_lotto
				      //  and rl.id_lotto=l.id_lotto
				      //  and r.id_riga_lotto=rl.id_riga_lotto
				      //  and c.id_caus_magazzino=r.id_caus_magazzino
				      //  and c.gestisce_lotti='C'
				      //  and d.id_documento=r.id_documento
				      //  and d.data_registrazione<=@fino_al
				      //  and d.id_registro = reg.id_registro;
				
				      //
				      message ' CARICHI A PESO:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				      //
				
				      //select(Sum(ifnull(r.peso_netto,0,r.peso_netto))) into @ld_scarichi
				      //  from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				      //  where l.id_lotto=@id_lotto
				      //  and rl.id_lotto=l.id_lotto
				      //  and r.id_riga_lotto=rl.id_riga_lotto
				      //  and c.id_caus_magazzino=r.id_caus_magazzino
				      //  and c.gestisce_lotti='S'
				      //  and d.id_documento=r.id_documento
				      //  and d.data_registrazione<=@fino_al;
				
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_scarichi
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='S'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro;
				
				      //
				      message ' SCARICHI A PESO:'+string(@ld_scarichi);
                    
                    ////////////////////////////////////////////////////////////////////////////////////////
                    //12.01.10  Scarichi da trasferimento Magazzino partenza
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_scarichi_trasf
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='T'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is null;
				
				      //
				      message ' SCARICHI da TRASF. A PESO:'+string(@ld_scarichi_trasf);

                    //12.01.10  Carichi da trasferimento Magazzino destinazione
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_carichi_trasf
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto_prov
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='T'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is not null;
				
				      message ' CARICHI da TRASF. A PESO:'+string(@ld_carichi_trasf);

                    //12.01.10  Scarichi da Rientro trasferimento Magazzino destinazione
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_scarichi_rien
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='E'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is not null;
				
				      //
				      message ' SCARICHI da Rientro TRASF. A PESO:'+string(@ld_scarichi_rien);


                    //12.01.10  Storno Scarichi da rientro trasferimento Magazzino partenza
				      select(Sum(ifnull(r.peso_netto,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.peso_netto * -1 else r.peso_netto endif))) into @ld_carichi_rien
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto_prov=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='E'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is not null;
				
				      message ' CARICHI da Rientro TRASF. A PESO:'+string(@ld_carichi_rien)
                      ////////////////////////////////////////////////

  
				    end if
				  else //
				    //
				    /* 
				    Calcolo l''Esistenza Fisica Totale a Quantit
				    */
				    //    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(r.prezzo_netto) into @ld_carichi,
				    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				      @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='C'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al;
				
				    //select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
				    //  @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				    //  where l.id_lotto=@id_lotto
				    //  and rl.id_lotto=l.id_lotto
				    //  and r.id_riga_lotto=rl.id_riga_lotto
				    //  and c.id_caus_magazzino=r.id_caus_magazzino
				    //  and c.gestisce_lotti='C'
				    //  and d.id_documento=r.id_documento
				    //  and d.data_registrazione<=@fino_al
                    //  and d.id_registro = reg.id_registro;
				    //
				    message ' CARICHI A QUANTITA:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				    //
				    //
				    //select(Sum(ifnull(r.quantita,0,r.quantita))) into @ld_scarichi
				    //  from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
				    //  where l.id_lotto=@id_lotto
				    //  and rl.id_lotto=l.id_lotto
				    //  and r.id_riga_lotto=rl.id_riga_lotto
				    //  and c.id_caus_magazzino=r.id_caus_magazzino
				    //  and c.gestisce_lotti='S'
				    //  and d.id_documento=r.id_documento
				    //  and d.data_registrazione<=@fino_al;
				
				    select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_scarichi
				      from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='S'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al
                      and d.id_registro = reg.id_registro;
				    //
				    message ' SCARICHI A QUANTITA:'+string(@ld_scarichi);
                    
                    //12.01.10 Scarichi da trasferimento
				    select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_scarichi_trasf
				      from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='T'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al
                      and d.id_registro = reg.id_registro
                      and l.id_lotto_prov is null;
				    //
				    message ' SCARICHI DA TRASF. A QUANTITA:'+string(@ld_scarichi_trasf);

                    //12.01.10 Carichi da trasferimento di mag. destinazione 
				    select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_carichi_trasf
				      from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				      where l.id_lotto=@id_lotto
				      and rl.id_lotto=l.id_lotto
				      and r.id_riga_lotto=rl.id_riga_lotto_prov
				      and c.id_caus_magazzino=r.id_caus_magazzino
				      and c.gestisce_lotti='T'
				      and d.id_documento=r.id_documento
				      and d.data_registrazione<=@fino_al
                      and d.id_registro = reg.id_registro
                      and l.id_lotto_prov is not null;
				    //
				    message ' CARICHI DA TRASF. A QUANTITA:'+string(@ld_carichi_trasf);

                    //12.01.10  Scarichi da Rientro trasferimento Magazzino destinazione
				      select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_scarichi_rien
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='E'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is not null;
				
				      //
				      message ' SCARICHI da Rientro TRASF. A QUANTITA:'+string(@ld_scarichi_rien);

                    //12.01.10  Storno Scarichi da rientro trasferimento Magazzino partenza
				      select(Sum(ifnull(r.quantita,0,if((right(reg.tipo_registro,1) = 'V') and (d.tipo_fattura = 'C')) then r.quantita * -1 else r.quantita endif))) into @ld_carichi_rien
				        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c, registro as reg //17.05.07
				        where l.id_lotto_prov=@id_lotto
				        and rl.id_lotto=l.id_lotto
				        and r.id_riga_lotto=rl.id_riga_lotto
				        and c.id_caus_magazzino=r.id_caus_magazzino
				        and c.gestisce_lotti='E'
				        and d.id_documento=r.id_documento
				        and d.data_registrazione<=@fino_al
				        and d.id_registro = reg.id_registro
                        and l.id_lotto_prov is not null;
				
				      message ' CARICHI da Rientro TRASF. A QUANTITA:'+string(@ld_carichi_rien)
                      ///////////////////////////////////////

				  end if //
				  ; //
                    
                  set @ld_carichi=ifnull(@ld_carichi,0,@ld_carichi)+ifnull(@ld_carichi_trasf,0,@ld_carichi_trasf); //12.01.10
                  set @ld_scarichi=ifnull(@ld_scarichi,0,@ld_scarichi)+ifnull(@ld_scarichi_trasf,0,@ld_scarichi_trasf)+ifnull(@ld_scarichi_rien,0,@ld_scarichi_rien)-ifnull(@ld_carichi_rien,0,@ld_carichi_rien); //12.01.10

				  set @ld_esi_fisica=ifnull(@ld_carichi,0,@ld_carichi)-ifnull(@ld_scarichi,0,@ld_scarichi);                  
				  message ' CARICHI:'+string(@ld_carichi)+' SCARICHI:'+string(@ld_scarichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
				  /* 
				  Costruisco ls stringa di ritorno 
				  */
				  /* Esistenza Fisica */
				  set @ls_esi_fisica=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica))))+STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica));
				  /* Carichi */
				  set @ls_carichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_carichi,0,@ld_carichi))))+STRING(ifnull(@ld_carichi,0,@ld_carichi));
				  /* Scarichi */
				  set @ls_scarichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_scarichi,0,@ld_scarichi))))+STRING(ifnull(@ld_scarichi,0,@ld_scarichi));
				  /* Costo Acquisto */
				  set @ls_costo_acquisto=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto))))+STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto));
				  //
				  return(STRING(@ls_esi_fisica,@ls_carichi,@ls_scarichi,@ls_costo_acquisto))
				end;
end if;
/////////////////////////

/////////PAD 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'tot_scorporato' )) THEN 
		
		ALTER TABLE distinta ADD tot_scorporato char(1) DEFAULT NULL;
		
end if;		
/////////////////////////

//BELARDI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'id_prof_trasf_com' )) THEN 
		
		ALTER TABLE par_sistema_commesse ADD id_prof_trasf_com integer DEFAULT NULL;		
end if;	

IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_com_mov_automatico') THEN
		
		ALTER PROCEDURE "DBA"."sp_com_mov_automatico"(@ai_id_bilancio integer,@ai_id_documento integer,@as_tipo_movimento char(1),@ad_importo decimal(18,4),@ai_id_articolo integer,@ai_id_riga_documento integer)
		as
		begin
		  /*
		  Elisa M.        31/10/2001      BL#16725#
		  */
		  declare @lc_ges_aut_movimenti char(1),
		  @lc_tipo_mov_automatico char(1),
		  @lc_loc_mov_automatico char(1),
		  @li_id_commessa integer
		  /**/
		  message '@ai_id_bilancio:'+string(@ai_id_bilancio)
		  message '@ai_id_documento:'+string(@ai_id_documento)
		  message '@as_tipo_movimento:'+@as_tipo_movimento
		  message '@ad_importo :'+string(@ad_importo)
		  message '@ai_id_articolo :'+string(@ai_id_articolo)
		  message '@ai_id_riga_documento :'+string(@ai_id_riga_documento)
		  
		/* Verifico che per il movimento inserito, */
		  /* nei parametri di sistema sia richiesta */
		  /* la creazione automatica di un movimento e su quale Locazione.*/
		  select @lc_tipo_mov_automatico=c.tipo_mov_automatico,@lc_loc_mov_automatico=c.loc_mov_automatico
			from com_par_prof as c,documento as d
			where d.id_documento=@ai_id_documento
			and c.id_prof_documento=d.id_prof_documento
			and c.tipo=@as_tipo_movimento
		  message '@lc_tipo_mov_automatico:'+@lc_tipo_mov_automatico
		  message '@lc_loc_mov_automatico :'+@lc_loc_mov_automatico
		  /* Se il movimento di bilancio ha la creazione automatica di*/
		  /* un altro movimento su una locazione,*/
		  /* recupero la commessa associata alla locazione indicata*/
		  if(@lc_tipo_mov_automatico is not null and @lc_loc_mov_automatico is not null)
			begin
			  if(@lc_loc_mov_automatico='P')
				select @li_id_commessa=c.id_commessa,@lc_ges_aut_movimenti=c.ges_aut_movimenti
				  from commessa as c,documento as d
				  where c.id_locazione=d.id_locazione_1
				  and d.id_documento=@ai_id_documento
			  else if(@lc_loc_mov_automatico='D')
				  select @li_id_commessa=c.id_commessa,@lc_ges_aut_movimenti=c.ges_aut_movimenti
					from commessa as c,documento as d
					where c.id_locazione=d.id_locazione_2
					and d.id_documento=@ai_id_documento
			  /* Se esiste una commessa associata alla locazione ed */
			  /*  abilitata alla gestione automatica dei movimenti*/
			  /* inserisco un movimento del tipo indicato */
			  /* per la Commessa / Locazione indicata.*/

			if @lc_tipo_mov_automatico = 'S' 
				begin
					set @ad_importo = @ad_importo * -1
					set @lc_tipo_mov_automatico = 'E'
				end
		 
			if @lc_tipo_mov_automatico = 'N' 
				begin
					set @ad_importo = @ad_importo * -1
					set @lc_tipo_mov_automatico = 'R'
				end 

			  if(@li_id_commessa is not null and @lc_ges_aut_movimenti='S')
				/* l''inserimento avviene solo non esiste gi un movimento di quel tipo.*/
				if not(exists(select 1
					from com_bilancio
					where id_commessa=@li_id_commessa
					and id_documento=@ai_id_documento
					and tipo_movimento=@lc_tipo_mov_automatico
					and id_bil_provenienza=@ai_id_bilancio))
				  insert into com_bilancio(id_commessa,id_documento,
					importo,tipo_movimento,id_articolo,id_riga_documento,id_bil_provenienza, provvisorio) values(
					@li_id_commessa,@ai_id_documento,
					@ad_importo,@lc_tipo_mov_automatico,@ai_id_articolo,
					@ai_id_riga_documento,@ai_id_bilancio, 'N')
			end
		end;
end if;
//////////////


/////digital sigla su gruppo agenti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'gruppo_agenti'
        AND      CNAME = 'ag_sigla' )) THEN 
		
	ALTER TABLE gruppo_agenti ADD ag_sigla char(2) DEFAULT NULL;

end if;


/////digital numero seriale
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_documento_produzione'
        AND      CNAME = 'num_seriale' )) THEN 
		
	ALTER TABLE riga_documento_produzione ADD num_seriale char(80) DEFAULT NULL;

end if;


/////varianti distinta
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'distinta'
        AND      CNAME = 'id_art_var1' )) THEN 

	ALTER TABLE "dba"."riga_distinta"  ADD "id_art_var1" integer DEFAULT NULL;
	ALTER TABLE "dba"."riga_distinta"  ADD "id_art_var2" integer DEFAULT NULL;
	ALTER TABLE "dba"."riga_distinta"  ADD "id_art_var3" integer DEFAULT NULL;
	ALTER TABLE "dba"."riga_distinta"  ADD FOREIGN KEY "fk_riga_distinta_var1" ("id_art_var1" ) REFERENCES "dba"."art_var1" ON DELETE RESTRICT;
	ALTER TABLE "dba"."riga_distinta"  ADD FOREIGN KEY "fk_riga_distinta_var2" ("id_art_var2" ) REFERENCES "dba"."art_var2" ON DELETE RESTRICT;
	ALTER TABLE "dba"."riga_distinta"  ADD FOREIGN KEY "fk_riga_distinta_var3" ("id_art_var3" ) REFERENCES "dba"."art_var3" ON DELETE RESTRICT;
	CREATE INDEX "ix_riga_distinta_var1" ON "dba"."riga_distinta" ("id_art_var1" ) ;

	ALTER TABLE "dba"."distinta"  ADD "id_art_var1" integer DEFAULT NULL;
	ALTER TABLE "dba"."distinta"  ADD "id_art_var2" integer DEFAULT NULL;
	ALTER TABLE "dba"."distinta"  ADD "id_art_var3" integer DEFAULT NULL;
	ALTER TABLE "dba"."distinta"  ADD FOREIGN KEY "fk_distinta_var1" ("id_art_var1" ) REFERENCES "dba"."art_var1" ON DELETE RESTRICT;
	ALTER TABLE "dba"."distinta"  ADD FOREIGN KEY "fk_distinta_var2" ("id_art_var2" ) REFERENCES "dba"."art_var2" ON DELETE RESTRICT;
	ALTER TABLE "dba"."distinta"  ADD FOREIGN KEY "fk_distinta_var3" ("id_art_var3" ) REFERENCES "dba"."art_var3" ON DELETE RESTRICT;
	CREATE INDEX "ix_distinta_var1" ON "dba"."distinta" ("id_art_var1" ) ;

	ALTER TABLE "dba"."com_bilancio" ADD FOREIGN KEY "fk_com_bilancio_mc" ("id_mov_contabile" ) REFERENCES "dba"."mov_contabile" ON DELETE CASCADE;

end if;




//Proposta profili CARPRO, SCARPRO
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_carpro' )) THEN 
		
	ALTER TABLE pers_par_sistema ADD id_prof_carpro integer DEFAULT NULL;
end if;
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_prof_scarpro' )) THEN 
		
	ALTER TABLE pers_par_sistema ADD id_prof_scarpro integer DEFAULT NULL;
end if;



//GIESSE
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte2') THEN
		
		ALTER PROCEDURE "DBA"."sp_trasf_cometa_parte2"()
				begin
				  /*
				  Elisa M. 	05/02/2001
				
				  CHIAMATA DA 
				  sp_trasf_dati
				  */
				  /* Stored procedure in Watcom SQL per creare e caricare i dati 
				  nelle tabelle temporanee 
				  */
				  declare @li_record integer;
				  /*
				  TABELLA DI LOG
				  */
				  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
				    create   table "dba".tmp_log(
				      id integer not null default autoincrement,
				      note long varchar null,
				      primary key(id),
				      )  
				  end if
				  ;
				  /*
				  ANAGRAFICA TIPO MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_magazzino')) then
				    drop table tmp_tipo_magazzino
				  end if
				  ;
				  //
				  //create   table "dba".tmp_tipo_magazzino(
				    create table "dba".tmp_tipo_magazzino(
				    id_tipo_magazzino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_tipo_magazzino),
				    ) ;
				  //
				  load into table tmp_tipo_magazzino from 'C:\\temp\\tipo_magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_magazzino;
				  //
				  message 'tabella TMP TIPO MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  if(exists(select 1 from sys.systable where table_name='tmp_magazzino')) then
				    drop table tmp_magazzino
				  end if
				  ;
				  //
				  create table "dba".tmp_magazzino(
				    id_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    note long varchar null,
				    giac_globale char(1) null,
				    id_tipo_magazzino integer null,
				    id_azienda integer null,
				    primary key(id_magazzino),
				    );
				  //
				  load into table tmp_magazzino from 'C:\\temp\\magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_magazzino;
				  //
				  message 'tabella TMP MAGAZZINO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_lingua')) then
				    drop table tmp_lingua
				  end if
				  ;
				  //
				  create table "dba".tmp_lingua(
				    id_lingua integer not null,
				    codice char(5) null,
				    descrizione char(40) null,
				    primary key(id_lingua),
				    ) ;
				  //
				  load into table tmp_lingua from 'C:\\temp\\lingua.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_lingua;
				  //
				  message 'tabella TMP LINGUA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LINGUAGGIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_linguaggio')) then
				    drop table tmp_linguaggio
				  end if
				  ;
				  //
				  create table "dba".tmp_linguaggio(
				    id_linguaggio integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_linguaggio),
				    ) ;
				  //
				  load into table tmp_linguaggio from 'C:\\temp\\linguaggio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_linguaggio;
				  //
				  message 'tabella TMP LINGUAGGIO record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA VALUTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_valuta')) then
				    drop table tmp_valuta
				  end if
				  ;
				  //
				  create table "dba".tmp_valuta(
				    id_valuta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    simbolo char(5) null,
				    cambio decimal(8,4) null,
				    cifra_arrotondamento decimal(3) null,
				    tipo_arrotondamento char(1) null,
				    parita_euro decimal(8,4) null,
				    dec_significativi decimal(1) null,
				    primary key(id_valuta),
				    ) ;
				  //
				  load into table tmp_valuta from 'C:\\temp\\valuta.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_valuta;
				  //
				  message 'tabella TMP VALUTA record trasferiti:'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA LISTINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_listino')) then
				    drop table tmp_listino
				  end if
				  ;
				  //
				  create table "dba".tmp_listino(
				    id_listino integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_valuta integer null,
				    id_azienda integer null,
				    lis_base char(1) null,
                    lis_pref char(1) null,  //17.10.07
				    primary key(id_listino),
				    ) ;
				  //
				  load into table tmp_listino from 'C:\\temp\\listino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_listino;
				  //
				  message 'tabella TMP LISTINO record trasferiti:'+string(@li_record);
				  //    
				  //  
				  /*
				  ANAGRAFICA VARIAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_variazione')) then
				    drop table tmp_variazione
				  end if
				  ;
				  //
				  create table "dba".tmp_variazione(
				    id_variazione integer not null,
				    id_listino integer null,
				    data_inizio date null,
				    data_fine date null,
				    cambio decimal(8,4) null,
				    max_osc_positiva decimal(5,2) null,
				    max_osc_negativa decimal(5,2) null,
				    prezzi_ivati char(1) null,
				    primary key(id_variazione),
				    ) ;
				  //
				  load into table tmp_variazione from 'C:\\temp\\variazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_variazione;
				  //
				  message 'tabella TMP VARIAZIONE record trasferiti:'+string(@li_record);
				  //    
				  if(exists(select 1 from sys.systable where table_name='tmp_con_pagamento')) then
				    drop table tmp_con_pagamento
				  end if
				  ;
				  //
				  create table "dba".tmp_con_pagamento(
				    id_con_pagamento integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    sconto_cassa decimal(5,2) null,
				    primary key(id_con_pagamento),
				    ) ; //
				  load into table tmp_con_pagamento from 'C:\\temp\\con_pagamento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_con_pagamento;
				  //
				  message 'tabella TMP CON PAGAMENTO record trasferiti:'+string(@li_record);
				  /*
				  ANAGRAFICA UNITA MISURA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_misura')) then
				    drop table tmp_unita_misura
				  end if
				  ;
				  //
				  create table "dba".tmp_unita_misura(
				    id_unita_misura integer not null,
				    simbolo char(5) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_unita_misura_riferimento integer null,
				    conversione decimal(8,4) null,
                    n_decimali integer null,    //17.10.07
				    //simbolo_ur char(5) null, //17.10.07
				    primary key(id_unita_misura),
				    ) ;
				  //
				  load into table tmp_unita_misura from 'C:\\temp\\unita_misura.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_misura;
				  //
				  message 'tabella TMP UNITA MISURA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_trasporto')) then
				    drop table tmp_tipo_trasporto
				  end if
				  ;
				  //
				  create table "dba".tmp_tipo_trasporto(
				    id_tipo_trasporto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    spese_gestite char(15) null,
				    primary key(id_tipo_trasporto),
				    ) ; //
				  load into table tmp_tipo_trasporto from 'C:\\temp\\tipo_trasporto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_trasporto;
				  //
				  message 'tabella TMP TIPO TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS TRASPORTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_trasporto')) then
				    drop table tmp_caus_trasporto
				  end if
				  ;
				  //
				  create table "dba".tmp_caus_trasporto(
				    id_caus_trasporto integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_caus_trasporto),
				    ) ; //
				  load into table tmp_caus_trasporto from 'C:\\temp\\caus_trasporto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_trasporto;
				  //
				  message 'tabella TMP CAUS TRASPORTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA TIPO PAGAMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tipo_pagamento')) then
				    drop table tmp_tipo_pagamento
				  end if
				  ;
				  //
				  create table "dba".tmp_tipo_pagamento(
				    id_tipo_pagamento integer not null,
				    codice char(4) null,
				    id_gruppo_esp_sospeso integer null,
				    descrizione char(40) null,
				    mod_stampa char(40) null,
				    ges_cessioni char(1) null,
				    spese_gestite char(15) null,
				    perc_tratte decimal(5,2) null,
				    arr_bollo_tratta decimal(14) null,
				    imp_min_bollo_tratta decimal(14) null,
				    id_prof_reg_dare integer null,
				    id_prof_reg_avere integer null,
				    premi_penalita char(1) null,
				    cod_gruppo_esp_sospeso char(4) null,
				    cod_prof_reg_dare char(8) null,
				    cod_prof_reg_avere char(8) null,
				    primary key(id_tipo_pagamento),
				    ) ;
				  load into table tmp_tipo_pagamento from 'C:\\temp\\tipo_pagamento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tipo_pagamento;
				  //
				  message 'tabella TMP TIPO PAGAMENTO record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA AREA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_area')) then
				    drop table tmp_area
				  end if
				  ;
				  //
				  create   table "dba".tmp_area(
				    id_area integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_area),
				    )  ;
				  load into table tmp_area from 'C:\\temp\\area.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_area;
				  //
				  message 'tabella TMP AREA record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA LOCAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_locazione')) then
				    drop table tmp_locazione
				  end if
				  ;
				  //
				  create   table "dba".tmp_locazione(
				    id_locazione integer not null default autoincrement,
				    id_magazzino integer not null,
				    id_area integer null,
				    corsia char(5) null,
				    scaffale char(5) null,
				    ripiano char(5) null,
				    posizione char(5) null,
				    id_azienda integer null,
				    cod_magazzino char(8) null,
				    cod_area char(8) null,
				    primary key(id_locazione),
				    )  ;
				  load into table tmp_locazione from 'C:\\temp\\locazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_locazione;
				  //
				  message 'tabella TMP LOCAZIONE record trasferiti:'+string(@li_record);
				  //    
				  /*
				  ANAGRAFICA CAUS_MAGAZZINO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_caus_magazzino')) then
				    drop table tmp_caus_magazzino
				  end if
				  ;
				  //
				  create   table "dba".tmp_caus_magazzino(
				    id_caus_magazzino integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    mag_par_richiesto char(1) null,
				    mag_des_richiesto char(1) null,
				    gen_doc_successivi char(1) null,
				    mp_qta_rim_iniziale char(1) null,
				    mp_val_rim_iniziale char(1) null,
				    mp_car_fiscali char(1) null,
				    mp_val_caricato char(1) null,
				    mp_scar_fiscali char(1) null,
				    mp_val_scaricato char(1) null,
				    mp_ord_clienti char(1) null,
				    mp_ord_fornitori char(1) null,
				    mp_vis_clienti char(1) null,
				    mp_vis_fornitori char(1) null,
				    mp_imp_produzione char(1) null,
				    mp_ord_produzione char(1) null,
				    mp_qta_cl_clienti char(1) null,
				    mp_qta_cl_fornitori char(1) null,
				    mp_qta_cl_terzi char(1) null,
				    mp_gruppo_lib_1 char(1) null,
				    mp_gruppo_lib_2 char(1) null,
				    mp_gruppo_lib_3 char(1) null,
				    mp_gruppo_lib_4 char(1) null,
				    mp_ult_costo char(1) null,
				    md_qta_rim_iniziale char(1) null,
				    md_val_rim_iniziale char(1) null,
				    md_car_fiscali char(1) null,
				    md_val_caricato char(1) null,
				    md_scar_fiscali char(1) null,
				    md_val_scaricato char(1) null,
				    md_ord_clienti char(1) null,
				    md_ord_fornitori char(1) null,
				    md_vis_clienti char(1) null,
				    md_vis_fornitori char(1) null,
				    md_imp_produzione char(1) null,
				    md_ord_produzione char(1) null,
				    md_qta_cl_clienti char(1) null,
				    md_qta_cl_fornitori char(1) null,
				    md_qta_cl_terzi char(1) null,
				    md_gruppo_lib_1 char(1) null,
				    md_gruppo_lib_2 char(1) null,
				    md_gruppo_lib_3 char(1) null,
				    md_gruppo_lib_4 char(1) null,
				    md_ult_costo char(1) null,
				    id_azienda integer null,
				    gestisce_lotti char(1) null,
				    mp_ult_scarico char(1) null,
				    md_ult_scarico char(1) null,
				    tipo_valorizzazione char(1) null,
				    primary key(id_caus_magazzino),
				    )  ;
				  load into table tmp_caus_magazzino from 'C:\\temp\\caus_magazzino.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_caus_magazzino;
				  //
				  message 'tabella TMP CAUS MAGAZZINO record trasferiti:'+string(@li_record);
				  //    
				  //    
				  /*
				  ANAGRAFICA TAB_IVA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_iva')) then
				    drop table tmp_tab_iva
				  end if
				  ;
				  //
				  create   table "dba".tmp_tab_iva(
				    id_tab_iva integer not null,
				    codice char(8) null,
				    des_breve char(20) null,
				    des_estesa long varchar null,
				    tipo_iva char(1) null,
				    per_aliquota decimal(5,2) null,
				    per_detrazione decimal(5,2) null,
				    per_ventilazione decimal(5,2) null,
				    ges_plafond char(1) null,
				    ges_oper_intracomunitarie char(1) null,
				    imp_min_fattura decimal(14) null,
				    imp_bollo_fattura decimal(14) null,
				    ges_beni_rivendita char(1) null,
				    ges_beni_strumentali char(1) null,
                    rcharge char(1) null, //17.10.07
				    primary key(id_tab_iva),
				    )  ;
				  load into table tmp_tab_iva from 'C:\\temp\\tab_iva.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_iva;
				  //
				  message 'tabella TAB_IVA record trasferiti:'+string(@li_record);
				  //    
				  //
				  // ANAGRAFICHE CONDIVISE E TABELLE ANAGRAFICHE SULLE QUALI SI BASA  
				  //    
				  //
				  /*
				  ANAGRAFICA BILANCIO_CEE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_bilancio_cee')) then
				    drop table tmp_bilancio_cee
				  end if
				  ;
				  //
				  create   table "dba".tmp_bilancio_cee(
				    id_bilancio_cee integer not null,
				    descrizione varchar(80) null,
				    riferimento decimal(5) null,
				    tipo char(2) null,
				    pos1 char(4) null,
				    pos2 char(4) null,
				    pos3 char(4) null,
				    pos4 char(4) null,
				    flag char(1) null,
				    segno char(2) null,
				    saldo1 decimal(18,4) null,
				    saldo2 decimal(18,4) null,
				    primary key(id_bilancio_cee),
				    )  ;
				  load into table tmp_bilancio_cee from 'C:\\temp\\bilancio_cee.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_bilancio_cee;
				  //
				  message 'tabella BILANCIO_CEE record trasferiti:'+string(@li_record);
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA PDC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_pdc')) then
				    drop table tmp_pdc
				  end if
				  ;
				  //
				  create   table "dba".tmp_pdc(
				    id_pdc integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_pdc),
				    )  ;
				  load into table tmp_pdc from 'C:\\temp\\pdc.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_pdc;
				  //
				  message 'tabella PDC record trasferiti:'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA MASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mastro')) then
				    drop table tmp_mastro
				  end if
				  ;
				  //
				  create   table "dba".tmp_mastro(
				    id_mastro integer not null,
				    id_pdc integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    tipo char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_pdc char(15) null,
				    primary key(id_mastro),
				    )  ;
				  load into table tmp_mastro from 'C:\\temp\\mastro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mastro;
				  //
				  message 'tabella MASTRO record trasferiti:'+string(@li_record);
				  //        
				  //    
				  //
				  /*
				  ANAGRAFICA SOTTOMASTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sottomastro')) then
				    drop table tmp_sottomastro
				  end if
				  ;
				  //
				  create   table "dba".tmp_sottomastro(
				    id_sottomastro integer not null,
				    id_mastro integer null,
				    codice char(2) null,
				    descrizione char(40) null,
				    uso char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    rif_bilancio_cee decimal(5) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    primary key(id_sottomastro),
				    )  ;
				  load into table tmp_sottomastro from 'C:\\temp\\sottomastro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sottomastro;
				  //
				  message 'tabella SOTTOMASTRO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA TITOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_titolo')) then
				    drop table tmp_titolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_titolo(
				    id_titolo integer not null,
				    titolo char(40) null,
				    primary key(id_titolo),
				    )  ;
				  load into table tmp_titolo from 'C:\\temp\\titolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_titolo;
				  //
				  message 'tabella TITOLO record trasferiti:'+string(@li_record);
				  //          
				  //    
				  //
				  /*
				  ANAGRAFICA ATT_SVOLTA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_att_svolta')) then
				    drop table tmp_att_svolta
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_att_svolta(
				    id_att_svolta integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    primary key(id_att_svolta),
				    )  ;
				  load into table tmp_att_svolta from 'C:\\temp\\att_svolta.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_att_svolta;
				  //
				  message 'tabella ATT_SVOLTA record trasferiti:'+string(@li_record);
				  //            
				  //    
				  //
				  /*
				  ANAGRAFICA TRIBUTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tributo')) then
				    drop table tmp_tributo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_tributo(
				    id_tributo integer not null,
				    codice char(8) null,
				    cod_tributo char(4) null,
				    descrizione char(80) null,
				    gruppo char(2) null,
				    per_imponibile decimal(5,2) null,
				    per_tributo decimal(5,2) null,
				    inizio_per_validita date null,
				    fine_per_validita date null,
				    mod_fiscale char(10) null,
				    primary key(id_tributo),
				    )  ;
				  load into table tmp_tributo from 'C:\\temp\\tributo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tributo;
				  //
				  message 'tabella TRIBUTO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //
				  /*
				  ANAGRAFICA ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_anagrafica')) then
				    drop table tmp_anagrafica
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_anagrafica(
				    id_anagrafica integer not null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    cod_fiscale char(16) null,
				    par_iva char(16) null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    nat_giuridica char(1) null,
				    prov_contabile char(1) null,
				    id_valuta integer null,
				    id_tipo_trasporto integer null,
				    id_titolo integer null,
				    id_att_svolta integer null,
				    id_tributo integer null,
				    cog_ritenute char(40) null,
				    nome_ritenute char(40) null,
				    sesso char(1) null,
				    ind_ritenute char(40) null,
				    cap_ritenute char(10) null,
				    loc_ritenute char(40) null,
				    prov_ritenute char(5) null,
				    naz_ritenute char(5) null,
				    data_nas_ritenute date null,
				    luogo_nas_ritenute char(40) null,
				    prov_nas_ritenute char(5) null,
				    naz_nas_ritenute char(5) null,
				    con_previdenziale decimal(5,2) null,
				    cassa_previdenza decimal(5,2) null,
				    rit_previdenziale decimal(5,2) null,
				    isc_enasarco char(1) null,
				    per_enasarco_agente decimal(5,2) null,
				    per_enasarco_conto_agente decimal(5,2) null,
				    id_azienda integer null,
				    bollo char(20) null,
				    codice integer null, //BL#13377#
				    cod_lingua char(15) null,
				    cod_linguaggio char(15) null,
				    cod_valuta char(15) null,
				    cod_tipo_trasporto char(15) null,
				    titolo char(40) null,
				    cod_att_svolta char(15) null,
				    cod_tributo char(15) null,
				    primary key(id_anagrafica),
				    )  ;
				  load into table tmp_anagrafica from 'C:\\temp\\anagrafica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_anagrafica;
				  //
				  message 'tabella ANAGRAFICA record trasferiti:'+string(@li_record);
				  //                
				  //    
				  //
				  /*
				  ANAGRAFICA GRUPPO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo')) then
				    drop table tmp_gruppo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_gruppo(
				    id_gruppo integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_anagrafica integer null,
				    note long varchar null,
				    fido decimal(14) null,
				    id_azienda integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    primary key(id_gruppo),
				    )  ;
				  load into table tmp_gruppo from 'C:\\temp\\gruppo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo;
				  //
				  message 'tabella GRUPPO record trasferiti:'+string(@li_record);
				  //              
				  //    
				  //    
				  //
				  /*
				  ANAGRAFICA CONTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_conto')) then
				    drop table tmp_conto
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_conto(
				    id_conto integer not null,
				    codice char(8) null,
				    id_sottomastro integer null,
				    descrizione char(40) null,
				    id_gruppo integer null,
				    ges_par_aperte char(1) null,
				    id_azienda integer null,
				    id_bilancio_cee integer null,
				    crea_cdc char(1) null, //01.03.10
				    cod_gruppo char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    rif_bilancio_cee decimal(5) null,
				    primary key(id_conto),
				    )  ;
				  load into table tmp_conto from 'C:\\temp\\conto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_conto;
				  //
				  message 'tabella CONTO record trasferiti:'+string(@li_record);
				  //              
				  //      
				  //    
				  //
				  /*
				  ANAGRAFICA CAT_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_attivita')) then
				    drop table tmp_cat_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_attivita(
				    id_cat_attivita integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_attivita),
				    )  ;
				  load into table tmp_cat_attivita from 'C:\\temp\\cat_attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_attivita;
				  //
				  message 'tabella CAT_ATTIVITA record trasferiti:'+string(@li_record);
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_COM_SC
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_sc')) then
				    drop table tmp_cat_com_sc
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_com_sc(
				    id_cat_com_sc integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
                    id_cat_com_sc_superiore integer null, //17.10.07
				    primary key(id_cat_com_sc),
				    )  ;
				  load into table tmp_cat_com_sc from 'C:\\temp\\cat_com_sc.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_sc;
				  //
				  message 'tabella CAT_COM_SC record trasferiti:'+string(@li_record);
				  //              
				  //          
				  //              
				  //        
				  /*
				  ANAGRAFICA CAT_ZONA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_zona')) then
				    drop table tmp_cat_zona
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_cat_zona(
				    id_cat_zona integer not null,
				    codice char(4) null,
				    descrizione char(40) null,
				    id_azienda integer null,
				    primary key(id_cat_zona),
				    )  ;
				  load into table tmp_cat_zona from 'C:\\temp\\cat_zona.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_zona;
				  //
				  message 'tabella CAT_ZONA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SOG_COMMERCIALE
				
				  BL#13377#	-	Modifica AK ANAGRAFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_sog_commerciale')) then
				    drop table tmp_sog_commerciale
				  end if
				  ;
				  //
				  //
				  create   table
				    "dba".tmp_sog_commerciale(
				    id_sog_commerciale integer not null,
				    codice char(8) null,
				    id_anagrafica integer null,
				    tipo char(1) null,
				    id_conto integer null,
				    data_acquisizione date null,
				    data_trasformazione date null,
				    ns_cod_soggetto char(20) null,
				    id_linguaggio integer null,
				    id_cat_attivita integer null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    id_magazzino integer null,
				    fido decimal(14) null,
				    extrafido decimal(14) null,
				    con_fido char(1) null,
				    id_con_pagamento integer null,
				    data_dec_pagamenti char(1) null,
				    giorno_fisso_pagamenti decimal(2) null,
				    scad_raggruppate char(1) null,
				    id_banca_sog_commerciale integer null,
				    id_listino integer null,
				    id_tipo_trasporto integer null,
				    id_sog_com_vettore integer null,
				    per_fatturazione char(1) null,
				    modo_fatturazione char(1) null,
				    con_fattura char(1) null,
				    fat_sos_iva char(1) null,
				    id_tab_iva integer null,
				    num_ns_prot_documenti char(10) null,
				    data_ns_prot_documenti date null,
				    num_lr_prot_documenti char(10) null,
				    data_lr_prot_documenti date null,
				    uff_iva char(40) null,
				    id_prof_registrazione integer null,
				    id_tributo integer null,
				    id_att_svolta integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer not null default 1,
				    id_tipo_agente integer null,
				    imp_fisso decimal(18,4) null,
				    id_valuta integer null,
				    giorni_franchigia decimal(3) null,
				    id_val_prov_agente integer null,
				    crea_gruppo_agenti char(1) null,
				    imp_fisso_ult_elab decimal(18,4) null,
				    imp_premio_budget decimal(18,4) null,
				    ult_elab_definitivo date null,
				    prec_elab_definitivo date null,
				    id_tab_iva_fat_prov integer null,
				    id_gruppo_agenti_2 integer null,
				    id_sog_com_vettore_2 integer null,
				    spese_gestite char(15) null,
                    archiviazione char(1) null, //17.10.07
                    gest_pdf char(1) null, //17.10.07
                    stato_utilizzo char(1) null, //17.10.07
                    note_fido char(256) null, //01.03.10
                    fat_rot_dest char(1) null, //01.03.10
                    mail_fatturazione long varchar null, //01.03.10
                    scheda_trasp char(1) null, //01.03.10
                    iscr_albo_trasp char(80) null, //01.03.10
				    cod_conto char(15) null,
				    cod_sottomastro char(15) null,
				    cod_mastro char(15) null,
				    cod_pdc char(15) null,
				    cod_linguaggio char(15) null,
				    cod_cat_attivita char(15) null,
				    cod_cat_com_sc char(15) null,
				    cod_cat_zona char(15) null,
				    cod_magazzino char(15) null,
				    cod_con_pagamento char(15) null,
				    cod_abi char(5) null,
				    cod_cab char(5) null,
				    codice_anagrafica integer null,
				    cod_listino char(15) null,
				    cod_tipo_trasporto char(15) null,
				    cod_sog_com_vettore char(15) null,
				    cod_tab_iva char(15) null,
				    cod_prof_registrazione char(15) null,
				    cod_tributo char(15) null,
				    cod_att_svolta char(15) null,
				    cod_gruppo_agenti char(15) null,
				    cod_tipo_agente char(15) null,
				    cod_valuta char(15) null,
				    cod_val_prov_agente char(15) null,
				    cod_tab_iva_fat_prov char(15) null,
				    cod_gruppo_Agenti_2 char(15) null,
				    cod_sog_com_vettore_2 char(15) null,
				    primary key(id_sog_commerciale),
				    )  ;
				  load into table tmp_sog_commerciale from 'C:\\temp\\sog_commerciale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_sog_commerciale;
				  //
				  message 'tabella SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //              
				  //              
				  /*
				  ANAGRAFICA TAB_ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_tab_attivita')) then
				    drop table tmp_tab_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_tab_attivita(
				    id_tab_attivita integer not null,
				    codice char(8) null,
				    descrizione long varchar null,
				    primary key(id_tab_attivita),
				    )  ;
				  load into table tmp_tab_attivita from 'C:\\temp\\tab_attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_tab_attivita;
				  //
				  message 'tabella TAB_ATTIVITA record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ATTIVITA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_attivita')) then
				    drop table tmp_attivita
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_attivita(
				    id_attivita integer null,
				    id_tab_attivita integer null,
				    descrizione char(40) null,
				    ges_ventilazione char(1) null,
				    liq_iva char(1) null,
				    tipo_contabilita char(1) null default 'O',
				    id_azienda integer not null default 1,
				    attuale_plafond decimal(18,4) null,
				    cod_tab_attivita char(15) null,
				    )  ;
				  load into table tmp_attivita from 'C:\\temp\\attivita.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_attivita;
				  //
				  message 'tabella ATTIVITA record trasferiti:'+string(@li_record);
				  //  
				  //
				  /*
				  ANAGRAFICA MOD_REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_mod_registro')) then
				    drop table tmp_mod_registro
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_mod_registro(
				    id_mod_registro integer not null,
				    tipo_registro char(2) null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_mod_registro),
				    )  ;
				  load into table tmp_mod_registro from 'C:\\temp\\mod_registro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_mod_registro;
				  //
				  message 'tabella MOD_REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA ESERCIZIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_esercizio')) then
				    drop table tmp_esercizio
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_esercizio(
				    id_esercizio integer not null,
				    codice char(4) null,
				    data_inizio date null,
				    data_fine date null,
				    bloccato char(1) null,
				    ult_data_stampa_bollato date null,
				    num_progressivo decimal(8) null,
				    id_azienda integer null,
				    riporto decimal(18,4) null,
				    prog_scritture char(1) null,
				    id_valuta integer null,
                    stato_cespite char(1) null, //17.10.07
				    cod_valuta char(15) null,
				    primary key(id_esercizio),
				    )  ;
				  load into table tmp_esercizio from 'C:\\temp\\esercizio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_esercizio;
				  //
				  message 'tabella ESERCIZIO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA REGISTRO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_registro')) then
				    drop table tmp_registro
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_registro(
				    id_registro integer not null,
				    id_esercizio integer null,
				    tipo_registro char(2) null,
				    id_mod_registro integer null,
				    numero decimal(8) null,
				    descrizione char(40) null,
				    id_attivita integer null,
				    usa_prorata char(1) null,
				    iva_sospensione char(1) null,
				    ges_sco_giornaliero char(1) null,
				    id_azienda integer null,
				    perc_prorata decimal(5,2) null,
                    max_progressivo integer null, //17.10.07
				    cod_esercizio char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_tab_attivita char(15) null,
				    des_attivita char(40) null,
				    primary key(id_registro),
				    )  ;
				  load into table tmp_registro from 'C:\\temp\\registro.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_registro;
				  //
				  message 'tabella REGISTRO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //
				  //
				  /*
				  ANAGRAFICA PROF_DOCUMENTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_documento')) then
				    drop table tmp_prof_documento
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_prof_documento(
				    cod_caus_magazzino_prop char(15) null,
				    cod_prof_registrazione char(15) null,
				    mod_tipo_registro char(15) null,
				    mod_num_registro decimal(10) null,
				    cod_sog_comm_prop char(15) null,
				    cod_sog_comm_fattura_prop char(15) null,
				    cod_linguaggio_prop char(15) null,
				    cod_lingua_prop char(15) null,
				    cod_valuta_prop char(15) null,
				    cod_listino_prop char(15) null,
				    cod_con_pagamento_prop char(15) null,
				    cod_sog_comm_vettore_1_prop char(15) null,
				    cod_magazzino_1 char(15) null,
				    cod_area_1 char(15) null,
				    corsia_1 char(15) null,
				    ripiano_1 char(15) null,
				    scaffale_1 char(15) null,
				    posizione_1 char(15) null,
				    cod_magazzino_2 char(15) null,
				    cod_area_2 char(15) null,
				    corsia_2 char(15) null,
				    ripiano_2 char(15) null,
				    scaffale_2 char(15) null,
				    posizione_2 char(15) null,
				    cod_caus_trasporto_prop char(15) null,
				    cod_sog_comm_vettore_2_prop char(15) null,
				    id_prof_documento integer not null,
				    id_caus_magazzino_prop integer null,
				    id_prof_registrazione integer null,
				    codice char(8) null,
				    descrizione char(40) null,
				    des_stampa char(40) null,
				    tipo_registro char(2) null,
				    ric_id_registro char(1) null,
				    ric_num_progressivo char(1) null,
				    id_mod_registro_prop integer null,
				    con_data_progressiva char(1) null,
				    ric_num_documento char(1) null default 'M',
				    note_intestazione_prop long varchar null,
				    ric_id_caus_magazzino char(1) null default 'M',
				    int_consentiti char(6) null,
				    ric_id_sog_comm char(1) null default 'M',
				    id_sog_comm_prop integer null,
				    ric_id_magazzino_1 char(1) null default 'M',
				    id_magazzino_1_prop integer null,
				    ric_id_magazzino_2 char(1) null default 'M',
				    id_magazzino_2_prop integer null,
				    ric_id_sog_comm_fattura char(1) null default 'M',
				    id_sog_comm_fattura_prop integer null,
				    ric_lingua_linguaggio char(1) null default 'M',
				    id_linguaggio_prop integer null,
				    id_lingua_prop integer null,
				    ric_id_valuta char(1) null default 'M',
				    id_valuta_prop integer null,
				    ric_id_listino char(1) null default 'M',
				    id_listino_prop integer null,
				    ric_id_con_pagamento char(1) null default 'M',
				    id_con_pagamento_prop integer null,
				    ric_scadenze char(1) null default 'M',
				    ric_id_sog_comm_agente char(1) null default 'M',
				    ric_provvigioni char(1) null default 'M',
				    ric_data_consegna char(1) null default 'M',
				    gg_consegna decimal(4) null,
				    ric_sconti_finanziari char(1) null default 'M',
				    spese_gestite char(15) null,
				    ric_acconti char(1) null default 'M',
				    ric_date_competenza char(1) null default 'M',
				    ric_colli_documento char(1) null default 'M',
				    ric_pesi char(1) null default 'M',
				    ric_volumi char(1) null default 'M',
				    ric_id_tipo_trasporto char(1) null default 'M',
				    ric_id_caus_trasporto char(1) null default 'M',
				    ric_asp_beni char(1) null default 'M',
				    aspetto_beni_prop char(40) null,
				    ric_trasp_mezzo char(1) null default 'M',
				    trasp_mezzo_prop char(1) null,
				    ric_id_sog_comm_vettore_1 char(1) null default 'M',
				    ric_id_sog_comm_vettore_2 char(1) null default 'M',
				    id_sog_comm_vettore_1_prop integer null,
				    ric_mezzo_trasporto char(1) null default 'M',
				    ric_data_trasporto char(1) null default 'M',
				    stampabile char(1) null,
				    stampa_immediata char(1) null,
				    ges_pac_list char(1) null,
				    ges_evas_parziale char(1) null,
				    ges_db char(1) null,
				    ges_matricole char(1) null,
				    con_dis_articoli char(1) null,
				    ges_chius_forzata char(1) null,
				    ges_stato_documento char(1) null,
				    tipo_raggruppamento char(1) null,
				    usa_int_fattura char(1) null,
				    contabilizzabile char(1) null,
				    des_contabile char(40) null,
				    ric_id_unita_confezione_riga char(1) null default 'M',
				    ric_quantita_riga char(1) null default 'M',
				    quantita_prop_riga decimal(18,4) null default 0,
				    ric_unita_base_riga char(1) null default 'M',
				    ric_unita_prezzo_riga char(1) null default 'M',
				    ric_id_caus_magazzino_riga char(1) null default 'M',
				    ric_locazione_1_riga char(1) null default 'M',
				    ric_locazione_2_riga char(1) null default 'M',
				    ric_data_prev_consegna_riga char(1) null default 'M',
				    ric_pesi_riga char(1) null default 'M',
				    ric_dim_riga char(1) null default 'M',
				    ric_colli_riga char(1) null default 'M',
				    ric_id_valuta_riga char(1) null default 'M',
				    ric_id_listino_riga char(1) null default 'M',
				    ric_prezzo_riga char(1) null default 'M',
				    ric_sconto_riga char(1) null default 'M',
				    ric_prezzo_netto_riga char(1) null default 'M',
				    ric_sconto_riga_riga char(1) null default 'M',
				    ric_id_tab_iva_riga char(1) null default 'M',
				    ric_id_sog_comm_agente_riga char(1) null default 'M',
				    ric_provvigioni_riga char(1) null default 'M',
				    ric_val_attribuito_riga char(1) null default 'M',
				    ric_date_competenza_riga char(1) null default 'M',
				    ric_contropartite_riga char(1) null default 'M',
				    evas_virtuale char(1) null,
				    stampa_bloccante char(1) null,
				    contr_esen_der char(1) null,
				    cambio_rical_der char(1) null,
				    stato_scad_generata char(1) null default 'N',
				    pas_di_sblocco char(20) null,
				    pas_chiu_forz char(20) null,
				    tipo_fattura char(1) null,
				    nome_report char(40) null,
				    id_azienda integer null default 1,
				    ric_tipo_fattura char(1) null default 'M',
				    id_locazione_1_prop integer null,
				    id_locazione_2_prop integer null,
				    ric_data_documento char(1) null default 'M',
				    fat_anticipo char(1) null,
				    id_caus_trasporto_prop integer null,
				    id_sog_comm_vettore_2_prop integer null,
				    ric_data_scadenza char(1) null default 'M',
				    gg_scadenza decimal(4) null,
				    non_vis_pag_trasporto char(1) null,
				    non_vis_pag_totali char(1) null,
				    non_vis_pag_contropartite char(1) null,
				    con_scorta_articoli char(1) null,
                    blocco_ricalcolo char(1) null, //17.10.07
                    cal_giac_costi char(1) null, //17.10.07
                    calc_prz_esp_dist char(1) null, //17.10.07
                    sal_automatico integer null, //17.10.07
                    arrot decimal(4,4) null default 0, //17.10.07
                    stampa_in_dett char(1) null, //17.10.07
                    archiviazione_report char(80) null, //17.10.07
                    nome_report_2 char(40) null, //17.10.07
                    stdoc_copie char(1) null, //17.10.07
                    tipo_invio_report char(1) null, //17.10.07
                    gest_doc_alt char(1) null, //17.10.07
                    prezzo_su_riga char(1) null, //17.10.07
                    usa_trasformazione char(1) null, //17.10.07
                    id_locazione_trasf integer null, //17.10.07
                    id_caus_magazzino_trasf integer null, //17.10.07
                    qta_su_riga char(1) null, //17.10.07
                    ult_costo_spese char(1) null, //17.10.07
                    no_ricalc_prz char(1) null, //17.10.07
                    abilita_canc char(1) null, //17.10.07
                    disabilita_rc char(1) null, //17.10.07
                    nuovo_dopo_stampa char(1) null, //17.10.07
                    crea_clis char(1) null, //17.10.07
                    tipo_min_doc char(1) null, //17.10.07
                    imp_min_doc decimal(18,2) null default 0, //17.10.07
                    usa_packing_list char(1) null, //17.10.07
				    primary key(id_prof_documento),
				    )  ;
				  load into table tmp_prof_documento from 'C:\\temp\\prof_documento.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_documento;
				  //
				  message 'tabella PROF_DOCUMENTO record trasferiti:'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA DESTINAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_destinazione')) then
				    drop table tmp_destinazione
				  end if
				  ;
				  //
				  create   table "dba".tmp_destinazione(
				    id_destinazione integer not null,
				    id_sog_commerciale integer null,
				    id_cat_attivita integer null,
				    rag_soc_1 char(40) null,
				    rag_soc_2 char(40) null,
				    id_cat_com_sc integer null,
				    id_cat_zona integer null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null,
				    tipo_destinazione char(1) null,
				    id_magazzino integer null,
				    id_gruppo_agenti integer null,
				    id_azienda integer null,
				    id_gruppo_Agenti_2 integer null,
				    id_con_pagamento integer null,
				    codice integer null,
                    data_prov_setup date null, //17.10.07
                    id_tab_iva integer null, //17.10.07
                    stato_utilizzo char(1) null, //01.03.10
                    id_banca_sog_commerciale integer null, //01.03.10
                    proposta char(1) null, //01.03.10
				    primary key(id_destinazione),
				    )  ;
				  //
				  load into table tmp_destinazione from 'C:\\temp\\destinazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_destinazione;
				  //
				  message 'tabella TMP DESTINAZIONE record trasferiti:'+string(@li_record);
				  //
				  // CODIFICA ARTICOLI # I
				  /*
				  ANAGRAFICA SCOMPOSIZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scomposizione')) then
				    drop table tmp_scomposizione
				  end if
				  ;
				  //
				  create   table "dba".tmp_scomposizione(
				    id_scomposizione integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_scomposizione),
				    )  ;
				  //
				  load into table tmp_scomposizione from 'C:\\temp\\scomposizione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scomposizione;
				  //
				  message 'tabella TMP SCOMPOSIZIONE record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA CAT_CODIFICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_codifica')) then
				    drop table tmp_cat_codifica
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_codifica(
				    id_cat_codifica integer not null,
				    codice char(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lun_fissa char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_codifica),
				    )  ;
				  //
				  load into table tmp_cat_codifica from 'C:\\temp\\cat_codifica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_codifica;
				  //
				  message 'tabella TMP CAT_CODIFICA record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA PARTE_REGOLA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_parte_regola')) then
				    drop table tmp_parte_regola
				  end if
				  ;
				  //
				  create   table "dba".tmp_parte_regola(
				    id_parte_regola integer not null,
				    num_sezione decimal(4) not null,
				    id_scomposizione integer not null,
				    descrizione char(40) null,
				    lunghezza decimal(4) not null,
				    progressivo char(1) null,
				    variante char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_parte_regola),
				    )  ;
				  //
				  load into table tmp_parte_regola from 'C:\\temp\\parte_regola.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_parte_regola;
				  //
				  message 'tabella TMP PARTE_REGOLA record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA COD_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cod_parte')) then
				    drop table tmp_cod_parte
				  end if
				  ;
				  //
				  create   table "dba".tmp_cod_parte(
				    id_cod_parte integer not null,
				    id_cat_codifica integer null,
				    id_parte_regola integer null,
				    mas_input char(32) null,
				    tipo_richiesta char(1) null default 'R',
				    val_proposto char(32) null,
				    car_riempimento char(1) null,
				    solo_in_elenco char(1) null,
				    id_azienda integer not null default 1,
				    primary key(id_cod_parte),
				    )  ;
				  //
				  load into table tmp_cod_parte from 'C:\\temp\\cod_parte.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cod_parte;
				  //
				  message 'tabella TMP COD_PARTE record importati'+string(@li_record);
				  //
				  //
				  /*
				  ANAGRAFICA SCELTA_PARTE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_scelta_parte')) then
				    drop table tmp_scelta_parte
				  end if
				  ;
				  //
				  create   table "dba".tmp_scelta_parte(
				    id_scelta_parte integer not null,
				    id_cod_parte integer not null,
				    scelta char(32) null,
				    descrizione char(40) null,
                    art_par char(1) null, //17.10.07
				    primary key(id_scelta_parte),
				    )  ;
				  //
				  load into table tmp_scelta_parte from 'C:\\temp\\scelta_parte.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_scelta_parte;
				  //
				  message 'tabella TMP SCELTA_PARTE record importati'+string(@li_record);
				  //
				  // CODIFICA ARTICOLI # F
				  //
				  //
				  /*
				  ANAGRAFICA CAT_COM_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_com_articolo')) then
				    drop table tmp_cat_com_articolo
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_com_articolo(
				    id_cat_com_articolo integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_tab_iva integer not null default autoincrement,
				    id_azienda integer not null default 1,
                    cod_intrastat char(40) null, //17.10.07
				    primary key(id_cat_com_articolo),
				    )  ;
				  //
				  load into table tmp_cat_com_articolo from 'C:\\temp\\cat_com_articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_com_articolo;
				  //
				  message 'tabella TMP CAT_COM_ARTICOLO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REG_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reg_fiscale')) then
				    drop table tmp_reg_fiscale
				  end if
				  ;
				  //
				  create   table "dba".tmp_reg_fiscale(
				    id_reg_fiscale integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    primary key(id_reg_fiscale),
				    )  ;
				  //
				  load into table tmp_reg_fiscale from 'C:\\temp\\reg_fiscale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reg_fiscale;
				  //
				  message 'tabella TMP REG_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_MERCEOLOGICA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_merceologica')) then
				    drop table tmp_cat_merceologica
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_merceologica(
				    id_cat_merceologica integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    id_reg_fiscale integer null,
				    id_cat_mer_superiore integer null,
				    id_anag_modello integer null,
				    id_tipo_parte integer null,
				    id_azienda integer not null default 1,
				    primary key(id_cat_merceologica),
				    )  ;
				  //
				  load into table tmp_cat_merceologica from 'C:\\temp\\cat_merceologica.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_merceologica;
				  //
				  message 'tabella TMP CAT_MERCEOLOGICA record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CAT_FISCALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cat_fiscale')) then
				    drop table tmp_cat_fiscale
				  end if
				  ;
				  //
				  create   table "dba".tmp_cat_fiscale(
				    id_cat_fiscale integer not null,
				    codice char(8) not null,
				    descrizione char(40) null,
				    primary key(id_cat_fiscale),
				    )  ;
				  //
				  load into table tmp_cat_fiscale from 'C:\\temp\\cat_fiscale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cat_fiscale;
				  //
				  message 'tabella TMP CAT_FISCALE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA GRUPPO_ARTICOLI
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_articoli')) then
				    drop table tmp_gruppo_articoli
				  end if
				  ;
				  //
				  create   table "dba".tmp_gruppo_articoli(
				    id_gruppo_articoli integer not null,
				    codice char(20) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_gruppo_articoli),
				    )  ;
				  //
				  load into table tmp_gruppo_articoli from 'C:\\temp\\gruppo_articoli.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_articoli;
				  //
				  message 'tabella TMP GRUPPO_ARTICOLI record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA REPARTO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_reparto')) then
				    drop table tmp_reparto
				  end if
				  ;
				  //
				  create   table "dba".tmp_reparto(
				    id_reparto integer not null,
				    codice char(4) not null,
				    descrizione char(40) null,
				    id_azienda integer not null default 1,
				    primary key(id_reparto),
				    )  ;
				  //
				  load into table tmp_reparto from 'C:\\temp\\reparto.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_reparto;
				  //
				  message 'tabella TMP REPARTO record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA UNITA_CONF_BASE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_conf_base')) then
				    drop table tmp_unita_conf_base
				  end if
				  ;
				  //
				  create   table "dba".tmp_unita_conf_base(
				    id_unita_conf_base integer not null,
				    codice char(8) not null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) not null,
				    fat_conversione decimal(8,4) not null,
				    tipo_conversione char(1) not null,
				    molteplicita decimal(18,4) null default 1,
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null default 'S',
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null default 'S',
				    unita_produzione char(1) null,
				    id_azienda integer not null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    id_articolo integer null,
				    primary key(id_unita_conf_base),
				    )  ; //
				  load into table tmp_unita_conf_base from 'C:\\temp\\unita_conf_base.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_conf_base;
				  //
				  message 'tabella TMP UNITA_CONF_BASE record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_cif')) then
				    drop table tmp_cif
				  end if
				  ;
				  //
				  create   table "dba".tmp_cif(
				    id_cif integer not null,
				    codice char(8) not null,
				    cambio decimal(8,4) null,
				    coefficiente decimal(5,2) null,
				    id_azienda integer not null default 1,
				    primary key(id_cif), //
				    )  ;
				  load into table tmp_cif from 'C:\\temp\\cif.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_cif;
				  //
				  message 'tabella TMP CIF record importati'+string(@li_record);
				  //
				  //
				  //
				  /*
				  ANAGRAFICA SPESA_CIF
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa_cif')) then
				    drop table tmp_spesa_cif
				  end if
				  ;
				  //
				  create   table "dba".tmp_spesa_cif(
				    id_cif integer not null,
				    id_spesa integer not null,
				    percentuale decimal(5,2) null,
				    primary key(id_cif,
				    id_spesa),
				    )  ;
				  load into table tmp_spesa_cif from 'C:\\temp\\spesa_cif.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa_cif;
				  //
				  message 'tabella TMP SPESA_CIF record importati'+string(@li_record);
				  //
				  /*
				  ANAGRAFICA ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_articolo')) then
				    drop table tmp_articolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_articolo(
				    id_articolo integer not null,
				    id_cat_codifica integer null,
				    codice char(32) null,
				    descrizione char(80) null,
				    immagine char(255) null,
				    rif_catalogo char(20) null,
				    id_cat_com_articolo integer null,
				    id_cat_merceologica integer null,
				    id_cat_fiscale integer null,
				    id_gruppo_articoli integer null,
				    des_breve char(40) null,
				    id_reparto integer null,
				    id_anagrafica integer null,
				    id_sog_commerciale integer null,
				    id_tab_iva integer null,
				    cod_intrastat char(40) null,
				    data_ora_creazione timestamp null default getdate(*),
				    data_ora_ult_cambiamento timestamp null default getdate(*),
				    data_ora_ult_var_stato timestamp null default getdate(*),
				    stampa_in_inventario char(1) null default 'S',
				    stampa_in_listini char(1) null default 'S',
				    stampa_in_giornale char(1) null default 'S',
				    stampa_in_schede char(1) null default 'S',
				    ges_lotti char(1) null default 'N',
				    ges_matricole char(1) null default 'N',
				    ges_produzione char(1) null default 'N',
				    note long varchar null,
				    utilizzabile char(1) null,
				    stato char(1) null,
				    ges_locazioni char(1) null,
				    giorni_invenduto decimal(4) null,
				    id_azienda integer null default 1,
				    id_cif integer null,
				    costo_aggiuntivo decimal(18,4) null,
				    id_valuta integer null,
				    id_unita_conf_base integer null,
				    prod_interna char(1) null,
				    id_sog_comm_variante integer null,
				    stampa_in_catalogo char(1) null default 'S',
				    giorni_durata integer null,
                    id_art_imballo integer null, //17.10.07
				    primary key(id_articolo),
				    )  ;
				  //
				  create unique index xak1tmp_articolo on
				    "dba".tmp_articolo(codice asc,id_azienda asc);
				  //
				  load into table tmp_articolo from 'C:\\temp\\articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_articolo;
				  //
				  message 'tabella ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA UNITA_CONFEZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_unita_confezione')) then
				    drop table tmp_unita_confezione
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_unita_confezione(
				    id_unita_confezione integer not null,
				    id_articolo integer null,
				    codice char(8) null,
				    id_unita_misura integer null,
				    descrizione char(40) null,
				    app_conversione char(1) null,
				    fat_conversione decimal(8,4) null,
				    tipo_conversione char(1) null,
				    molteplicita decimal(20,12) null default 0, //17.10.07
				    qta_minima decimal(18,4) null default 0,
				    qta_massima decimal(18,4) null default 0,
				    id_unita_mis_peso integer null,
				    peso_netto decimal(18,4) null default 0,
				    peso_lordo decimal(18,4) null default 0,
				    id_unita_mis_volume integer null,
				    dim_l decimal(18,4) null default 0,
				    dim_h decimal(18,4) null default 0,
				    dim_p decimal(18,4) null default 0,
				    unita_base char(1) null,
				    unita_prezzo char(1) null,
				    unita_documenti char(1) null,
				    unita_produzione char(1) null,
				    id_azienda integer null default 1,
				    tipo_stampa_etichette char(10) null,
				    num_colli decimal(8) null,
				    primary key(id_unita_confezione),
				    )  ;
				  //
				  create unique index xak1tmp_unita_confezione on
				    "dba".tmp_unita_confezione(id_articolo asc,codice asc);
				  //
				  load into table tmp_unita_confezione from 'C:\\temp\\unita_confezione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_unita_confezione;
				  //
				  message 'tabella UNITA_CONFEZIONE record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA DES_ARTICOLO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_des_articolo')) then
				    drop table tmp_des_articolo
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_des_articolo(
				    id_des_articolo integer not null,
				    id_articolo integer null,
				    id_sog_commerciale integer null,
				    id_lingua integer null,
				    id_linguaggio integer null,
				    codice char(32) null,
				    descrizione char(40) null,
				    des_estesa long varchar null,
				    id_azienda integer null default 1,
				    primary key(id_des_articolo),
				    )  ;
				  //
				  create unique index tmp_des_articolo_ak001 on
				    "dba".tmp_des_articolo(id_articolo asc,id_sog_commerciale asc,id_lingua asc,id_linguaggio asc);
				  //
				  load into table tmp_des_articolo from 'C:\\temp\\des_articolo.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_des_articolo;
				  //
				  message 'tabella DES_ARTICOLO record trasferiti:'+string(@li_record);
				  //
				  //  
				  //      
				  /*
				  ANAGRAFICA GRUPPO_AGENTI
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_gruppo_agenti')) then
				    drop table tmp_gruppo_agenti
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_gruppo_agenti(
				    id_gruppo_agenti integer not null,
				    codice char(8) null,
				    descrizione char(40) null,
				    id_sog_com_capo_area integer null,
				    id_sog_com_agente integer null,
				    id_sog_com_sub_agente integer null,
				    sconto_riga char(1) null,
				    sconto_finanziario char(1) null,
				    sconto_fin_cassa char(1) null,
				    sconto_fin_incondizionato char(1) null,
				    rip_per_fatturato decimal(5,2) null,
				    rip_per_incassato decimal(5,2) null,
				    mod_liq_provvigione char(1) null,
				    id_azienda integer null default 1,
				    inc_ult_elab decimal(5,2) null,
				    fat_ult_elab decimal(5,2) null,
				    primary key(id_gruppo_agenti),
				    )  ;
				  //
				  create unique index tmp_gruppo_agentiak001 on
				    "dba".tmp_gruppo_agenti(codice asc,id_azienda asc);
				  //
				  load into table tmp_gruppo_agenti from 'C:\\temp\\gruppo_agenti.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_gruppo_agenti;
				  //
				  message 'tabella GRUPPO_AGENTI record trasferiti:'+string(@li_record);
				  //  
				  //  
				  //      
				  /*
				  ANAGRAFICA PROF_REGISTRAZIONE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_prof_registrazione')) then
				    drop table tmp_prof_registrazione
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_prof_registrazione(
				    id_prof_registrazione integer not null default autoincrement,
				    codice char(8) not null,
				    descrizione char(40) null,
				    tipo_registrazione char(1) not null,
				    id_mod_registro integer not null,
				    id_valuta integer null,
				    id_tab_iva integer null,
				    id_conto_iva integer null,
				    des_contabile char(40) null,
				    ges_oper_intracomunitarie char(1) null,
				    usa_pagamenti char(1) null,
				    usa_con_effetti char(1) null,
				    usa_insoluti char(1) null,
				    crea_partita char(1) null,
				    tipo_fattura char(1) null default 'N',
				    id_azienda integer not null default 1,
                    usa_ratei char(1) null, //17.10.07
				    primary key(id_prof_registrazione),
				    )  ;
				  //
				  create unique index xak1tmp_prof_registrazione on
				    "dba".tmp_prof_registrazione(codice asc,id_azienda asc);
				  //
				  load into table tmp_prof_registrazione from 'C:\\temp\\prof_registrazione.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_prof_registrazione;
				  //
				  message 'tabella TMP_PROF_REGISTRAZIONE record trasferiti:'+string(@li_record);
				  //    
				  //  
				  //      
				  /*
				  ANAGRAFICA SPESA
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_spesa')) then
				    drop table tmp_spesa
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_spesa(
				    id_spesa integer not null default autoincrement,
				    codice char(1) not null,
				    descrizione char(40) null,
				    tipo_importo char(1) null,
				    percentuale decimal(5,2) null,
				    importo decimal(18,4) null,
				    id_tab_iva integer null,
				    id_conto_acquisti integer not null,
				    id_conto_vendite integer not null,
				    segue_esenzione char(1) null,
				    mod_cal_iva char(1) null,
                    id_valuta integer null, //17.10.07
				    primary key(id_spesa),
				    )  ;
				  //
				  create unique index xak1tmp_spesa on
				    "dba".TMP_spesa(codice asc);
				  //
				  load into table tmp_spesa from 'C:\\temp\\spesa.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_spesa;
				  //
				  message 'tabella TMP_SPESA record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //      
				  /*
				  ANAGRAFICA BANCA_APPOGGIO
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_appoggio')) then
				    drop table tmp_banca_appoggio
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_banca_appoggio(
				    id_banca_appoggio integer not null,
				    cod_abi char(5) null,
				    den_abi char(40) null,
				    cod_cab char(5) null,
				    den_cab char(40) null,
				    indirizzo char(40) null,
				    cap char(10) null,
				    localita char(40) null,
				    provincia char(5) null,
				    nazione char(5) null default 'IT',
				    filiale char(40) null,
				    con_interbancaria char(1) null,
				    giorni_franchigia decimal(3) null,
				    primary key(id_banca_appoggio),
				    )  ;
				  //
				  create unique index xak1tmp_banca_appoggio on
				    "dba".tmp_banca_appoggio(cod_abi asc,cod_cab asc);
				  //
				  load into table tmp_banca_appoggio from 'C:\\temp\\banca_appoggio.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_appoggio;
				  //
				  message 'tabella TMP_BANCA_APPOGGIO record trasferiti:'+string(@li_record);
				  //      
				  //  
				  //      
				  /*
				  ANAGRAFICA BANCA_SOG_COMMERCIALE
				  */
				  if(exists(select 1 from sys.systable where table_name='tmp_banca_sog_commerciale')) then
				    drop table tmp_banca_sog_commerciale
				  end if
				  ;
				  //
				  create   table
				    "dba".tmp_banca_sog_commerciale(
				    id_banca_sog_commerciale integer not null default autoincrement,
				    id_anagrafica integer null,
				    id_banca_appoggio integer not null,
				    conto_corrente char(20) null,
				    cin char(1) null,
				    modo_uso char(1) not null,
				    id_azienda integer not null default 1,
                    iban_nazione char(2) null, //17.10.07
                    iban_contr_internazionale char(2) null, //17.10.07
				    primary key(id_banca_sog_commerciale),
				    )  ;
				  //
				  create index xif107tmp_banca_sog_commerciale on
				    "dba".tmp_banca_sog_commerciale(id_banca_appoggio asc);
				  //
				  load into table tmp_banca_sog_commerciale from 'C:\\temp\\banca_sog_commerciale.txt' format 'ASCII' delimited by ';' quotes off;
				  //
				  commit work;
				  //
				  select "count"(*) into @li_record
				    from tmp_banca_sog_commerciale;
				  //
				  message 'tabella TMP_BANCA_SOG_COMMERCIALE record trasferiti:'+string(@li_record);
				  //        
				  message 'FINE LOAD ... ';
				  //
				  message 'INIZIO CREAZIONE INDICI PK  ... ';
				  //
				  create index xpk_tmp_anagrafica on tmp_anagrafica(id_anagrafica asc);
				  create index xpk_tmp_area on tmp_area(id_area asc);
				  create index xpk_tmp_articolo on tmp_articolo(id_articolo asc);
				  create index xpk_tmp_att_svolta on tmp_att_svolta(id_att_svolta asc);
				  create index xpk_tmp_banca_appoggio on tmp_banca_appoggio(id_banca_appoggio asc);
				  create index xpk_tmp_banca_sog_commerciale on tmp_banca_sog_commerciale(id_banca_sog_commerciale asc);
				  create index xpk_tmp_bilancio_cee on tmp_bilancio_cee(id_bilancio_cee asc);
				  create index xpk_tmp_cat_attivita on tmp_cat_attivita(id_cat_attivita asc);
				  create index xpk_tmp_cat_codifica on tmp_cat_codifica(id_cat_codifica asc);
				  create index xpk_tmp_cat_com_articolo on tmp_cat_com_articolo(id_cat_com_articolo asc);
				  create index xpk_tmp_cat_com_sc on tmp_cat_com_sc(id_cat_com_sc asc);
				  create index xpk_tmp_cat_fiscale on tmp_cat_fiscale(id_cat_fiscale asc);
				  create index xpk_tmp_cat_merceologica on tmp_cat_merceologica(id_cat_merceologica asc);
				  create index xpk_tmp_cat_zona on tmp_cat_zona(id_cat_zona asc);
				  create index xpk_tmp_caus_magazzino on tmp_caus_magazzino(id_caus_magazzino asc);
				  create index xpk_tmp_caus_trasporto on tmp_caus_trasporto(id_caus_trasporto asc);
				  create index xpk_tmp_cif on tmp_cif(id_cif asc);
				  create index xpk_tmp_cod_parte on tmp_cod_parte(id_cod_parte asc);
				  create index xpk_tmp_con_pagamento on tmp_con_pagamento(id_con_pagamento asc);
				  create index xpk_tmp_conto on tmp_conto(id_conto asc);
				  create index xpk_tmp_des_articolo on tmp_des_articolo(id_des_articolo asc);
				  create index xpk_tmp_destinazione on tmp_destinazione(id_destinazione asc);
				  create index xpk_tmp_esercizio on tmp_esercizio(id_esercizio asc);
				  create index xpk_tmp_gruppo on tmp_gruppo(id_gruppo asc);
				  create index xpk_tmp_gruppo_agenti on tmp_gruppo_agenti(id_gruppo_agenti asc);
				  create index xpk_tmp_gruppo_articoli on tmp_gruppo_articoli(id_gruppo_articoli asc);
				  create index xpk_tmp_lingua on tmp_lingua(id_lingua asc);
				  create index xpk_tmp_linguaggio on tmp_linguaggio(id_linguaggio asc);
				  create index xpk_tmp_listino on tmp_listino(id_listino asc);
				  create index xpk_tmp_locazione on tmp_locazione(id_locazione asc);
				  create index xpk_tmp_magazzino on tmp_magazzino(id_magazzino asc);
				  create index xpk_tmp_mastro on tmp_mastro(id_mastro asc);
				  create index xpk_tmp_mod_registro on tmp_mod_registro(id_mod_registro asc);
				  create index xpk_tmp_parte_regola on tmp_parte_regola(id_parte_regola asc);
				  create index xpk_tmp_pdc on tmp_pdc(id_pdc asc);
				  create index xpk_tmp_prof_documento on tmp_prof_documento(id_prof_documento asc);
				  create index xpk_tmp_prof_registrazione on tmp_prof_registrazione(id_prof_registrazione asc);
				  create index xpk_tmp_reg_fiscale on tmp_reg_fiscale(id_reg_fiscale asc);
				  create index xpk_tmp_registro on tmp_registro(id_registro asc);
				  create index xpk_tmp_reparto on tmp_reparto(id_reparto asc);
				  create index xpk_tmp_scelta_parte on tmp_scelta_parte(id_scelta_parte asc);
				  create index xpk_tmp_scomposizione on tmp_scomposizione(id_scomposizione asc);
				  create index xpk_tmp_sog_commerciale on tmp_sog_commerciale(id_sog_commerciale asc);
				  create index xpk_tmp_sottomastro on tmp_sottomastro(id_sottomastro asc);
				  create index xpk_tmp_spesa on tmp_spesa(id_spesa asc);
				  create index xpk_tmp_tab_attivita on tmp_tab_attivita(id_tab_attivita asc);
				  create index xpk_tmp_tab_iva on tmp_tab_iva(id_tab_iva asc);
				  create index xpk_tmp_tipo_magazzino on tmp_tipo_magazzino(id_tipo_magazzino asc);
				  create index xpk_tmp_tipo_pagamento on tmp_tipo_pagamento(id_tipo_pagamento asc);
				  create index xpk_tmp_tipo_trasporto on tmp_tipo_trasporto(id_tipo_trasporto asc);
				  create index xpk_tmp_titolo on tmp_titolo(id_titolo asc);
				  create index xpk_tmp_tributo on tmp_tributo(id_tributo asc);
				  create index xpk_tmp_unita_conf_base on tmp_unita_conf_base(id_unita_conf_base asc);
				  create index xpk_tmp_unita_confezione on tmp_unita_confezione(id_unita_confezione asc);
				  create index xpk_tmp_unita_misura on tmp_unita_misura(id_unita_misura asc);
				  create index xpk_tmp_valuta on tmp_valuta(id_valuta asc);
				  create index xpk_tmp_variazione on tmp_variazione(id_variazione asc);
				  //
				  message 'FINE CREAZIONE INDICI PK  ... '
				//
				end;
end if;				
//////////////////////////////////////////////////////



//GIORNI CHIUSURA - PARIGI
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'anag_giorno_ch')) THEN
	CREATE TABLE "dba"."anag_giorno_ch" ("id_anag_giorno_ch" integer NOT NULL DEFAULT autoincrement, "id_anagrafica" integer NOT NULL DEFAULT NULL, "giorno" integer NOT NULL DEFAULT NULL, "dname" char(10) NOT NULL DEFAULT NULL, "d_in" date DEFAULT NULL, "d_fn" date DEFAULT NULL, "h_in" time DEFAULT NULL, "h_fn" time DEFAULT NULL , PRIMARY KEY ("id_anag_giorno_ch") , FOREIGN KEY "fk_anag_giorno_ch_1" ("id_anagrafica" ) REFERENCES "dba"."anagrafica" ON DELETE CASCADE ) ;
end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'dest_giorno_ch')) THEN
	CREATE TABLE dest_giorno_ch ("id_dest_giorno_ch" integer NOT NULL DEFAULT autoincrement, "id_destinazione" integer NOT NULL DEFAULT NULL, "giorno" integer NOT NULL DEFAULT NULL, "dname" char(10) NOT NULL DEFAULT NULL, "d_in" date DEFAULT NULL, "d_fn" date DEFAULT NULL, "h_in" time DEFAULT NULL, "h_fn" time DEFAULT NULL , PRIMARY KEY ("id_dest_giorno_ch") , FOREIGN KEY "fk_dest_giorno_ch_1" ("id_destinazione" ) REFERENCES "dba"."destinazione" ON DELETE CASCADE ) ;
end if; 

/////////////////*******************************
//RIGHE NEGATIVE
/////////////////*******************************

ALTER PROCEDURE "DBA"."sp_deriva_riga"(@id_riga integer,@id_ref integer,@qta decimal(18,4),@peso_netto decimal(18,4))
as
begin
  /* Elisa Moneti 		3/09/1998

  Ho Aggiunto la gestione del campo 
  riga_documento.qta_evasa_un_base = qta_evasa * fat_con_globale
  */
  /*
  Elisa Moneti		31/03/1999
  Gestione RIGA_DOCUMENTO.PESO_NETTO_EVASO
  */
  /* dichiarazione variabili*/
  declare @ld_qta_1 decimal(18,4),
  @ld_fat_con_globale decimal(8,4),
  @ls_ev char(1),@ld_qta_evasa decimal(18,4)
  /* Watcom only
  declare  err_notfound exception for sqlstate value '02000'
  */
  /**/
  /* selezione del profilo documento di arrivo per vedere se si tratta*/
  /* solamente di evasione virtuale o no. Per ora l''evasione virtuale "blocca"*/
  /* il conteggio della quantit evasa.*/
  /**/
  select @ls_ev=prof_documento.evas_virtuale
    from "dba".prof_documento,"dba".documento,"dba".riga_documento
    where(prof_documento.id_prof_documento=documento.id_prof_documento)
    and(documento.id_documento=riga_documento.id_documento)
    and(riga_documento.id_documento=@id_riga)
  if sqlcode<>0
    select @ls_ev='N'
  if @ls_ev is null
    select @ls_ev='N'
  if @ls_ev='N'
    begin
      /* selezione del corretto record della riga da evadere*/
      select @ld_qta_1=riga_documento.qta_evasa,
        @ld_fat_con_globale=riga_documento.fat_con_globale
        from "dba".riga_documento
        where riga_documento.id_riga_documento=@id_ref
      if sqlcode=0
        begin
          /* Aggiornamento della Qta evasa unita'' base e del peso netto Evaso  */
          message 'Updating riga ',@id_ref
          select @ld_qta_evasa=@ld_qta_1+@qta
          //2010 - RN - RIGHE NEGATIVE
          //if(@ld_qta_evasa<0) select @ld_qta_evasa=0
          update "dba".riga_documento set
            qta_evasa=IFNULL(@ld_qta_evasa,0,@ld_qta_evasa),
            qta_evasa_un_base=IFNULL(@ld_qta_evasa*@ld_fat_con_globale,0,@ld_qta_evasa*@ld_fat_con_globale),
            peso_netto_evaso=IFNULL(peso_netto_evaso,0,peso_netto_evaso)+@peso_netto
            where riga_documento.id_riga_documento=@id_ref
        /*forza_chius_evasione='N' #bl10490#*/
        end
      else
        message 'ATTENZIONE! Riga ',@id_ref,' non trovata!'
    end
end;


//corr giorno
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mod_registro'
        AND      CNAME = 'note_cassa' )) THEN 
		
	alter table mod_registro add note_cassa char(256);
end if;


call fn_ins_voce_menu('Stampe contabili', 'w_registri_corr_ff', 'Giornaliero Cassa', 63);


///////////////////////////////////////////////////

///INTRASTAT
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'articolo'
        AND      CNAME = 'cod_servizio' )) THEN 
		
		alter table articolo add cod_servizio char(40);
		
		call fn_ins_voce_menu('Tabelle di Codifica', 'w_intra_servizio_gd', 'Servizi', 10);
		call fn_ins_voce_menu('Tabelle di Codifica', 'w_intra_localita_gd', 'Province', 40);
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_servizio') THEN
		
		CREATE TABLE "dba"."intra_servizio" (
		"id_i_servizio" integer NOT NULL DEFAULT autoincrement, 
		"cod_serv" char(8) DEFAULT NULL, 
		"desc_serv" char(40) DEFAULT NULL , 
		PRIMARY KEY ("id_i_servizio")) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quater') THEN
		
		CREATE TABLE "dba"."intra_2quater" (
		"id_i_2quater" integer NOT NULL DEFAULT autoincrement, 
		"id_i_modo_trsp" integer DEFAULT NULL, 
		"id_i_tab_iso" integer DEFAULT NULL, 
		"id_localita" integer DEFAULT NULL, 
		"id_i_cod_cons" integer DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"id_i_servizio" integer DEFAULT NULL, 
		"id_i_nat_trans" integer DEFAULT NULL, 
		"id_i_fronte" integer NOT NULL DEFAULT NULL, 
		"prog_operazioni" numeric(6,0) DEFAULT NULL, 
		"amm_operazioni" numeric(13,0) DEFAULT NULL, 
		"amm_valuta" numeric(13,2) DEFAULT NULL, 
		"massa_netta" numeric(10,2) DEFAULT NULL, 
		"unita_suppl" numeric(10,0) DEFAULT NULL, 
		"valore_stat" numeric(13,0) DEFAULT NULL, 
		"intra_tab_iso" integer DEFAULT NULL , 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL, 		
		PRIMARY KEY ("id_i_2quater") , 
		FOREIGN KEY "fk_intra_2quater_2" ("id_i_cod_cons" ) REFERENCES "dba"."intra_condizioni_consegna" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_8" ("id_i_fronte" ) REFERENCES "dba"."intra_frontespizio_input" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_3" ("id_i_modo_trsp" ) REFERENCES "dba"."intra_modo_trasporto" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_4" ("id_i_nat_trans" ) REFERENCES "dba"."intra_nat_transazione" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_5" ("id_i_servizio" ) REFERENCES "dba"."intra_servizio" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_6" ("id_i_tab_iso" ) REFERENCES "dba"."intra_tab_codici_iso" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_9" ("intra_tab_iso" ) REFERENCES "dba"."intra_tab_codici_iso" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_7" ("id_localita" ) REFERENCES "dba"."localita" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quater_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quinques') THEN
		
		CREATE TABLE "dba"."intra_2quinques" (
		"id_i_2quinques" integer NOT NULL DEFAULT autoincrement, 
		"id_i_nat_trans" integer DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"id_i_servizio" integer DEFAULT NULL, 
		"id_i_fronte" integer NOT NULL DEFAULT NULL, 
		"prog_oper" numeric(6,0) DEFAULT NULL, 
		"rifer" numeric(1,0) DEFAULT NULL, 
		"segn" char(1) DEFAULT NULL, 
		"amm_oper" numeric(13,0) DEFAULT NULL, 
		"amm_valut" numeric(13,2) DEFAULT NULL, 
		"val_stat" numeric(13,0) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL , 
		"cod_sez_dog" numeric(6,0) DEFAULT NULL, 
		"anno_reg_dich" numeric(2,0) DEFAULT NULL, 
		"prot_dich_ret" numeric(6,0) DEFAULT NULL, 
		"prog_sez3_ret" numeric(5,0) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"id_i_tab_iso" integer DEFAULT NULL,		
		PRIMARY KEY ("id_i_2quinques") , 
		FOREIGN KEY "fk_intra_2quinques_4" ("id_i_fronte" ) REFERENCES "dba"."intra_frontespizio_input" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quinques_2" ("id_i_nat_trans" ) REFERENCES "dba"."intra_nat_transazione" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quinques_3" ("id_i_servizio" ) REFERENCES "dba"."intra_servizio" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_2quinques_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quater') THEN
		
		CREATE TABLE "dba"."intra_1quater" (
		"id_i_1quater" integer NOT NULL DEFAULT autoincrement, 
		"id_i_modo_trsp" integer DEFAULT NULL, 
		"id_i_tab_iso" integer DEFAULT NULL, 
		"id_localita" integer DEFAULT NULL, 
		"id_i_cod_cons" integer DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"id_i_servizio" integer DEFAULT NULL, 
		"id_i_nat_trans" integer DEFAULT NULL, 
		"id_i_fronte" integer NOT NULL DEFAULT NULL, 
		"prog_operazioni" numeric(6,0) DEFAULT NULL, 
		"amm_operazioni" numeric(13,0) DEFAULT NULL, 
		"massa_netta" numeric(10,2) DEFAULT NULL, 
		"unita_suppl" numeric(10,0) DEFAULT NULL, 
		"valore_stat" numeric(13,0) DEFAULT NULL , 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL, 
		PRIMARY KEY ("id_i_1quater") , 
		FOREIGN KEY "fk_intra_1quater_2" ("id_i_cod_cons" ) REFERENCES "dba"."intra_condizioni_consegna" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_8" ("id_i_fronte" ) REFERENCES "dba"."intra_frontespizio_input" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_3" ("id_i_modo_trsp" ) REFERENCES "dba"."intra_modo_trasporto" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_4" ("id_i_nat_trans" ) REFERENCES "dba"."intra_nat_transazione" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_5" ("id_i_servizio" ) REFERENCES "dba"."intra_servizio" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_6" ("id_i_tab_iso" ) REFERENCES "dba"."intra_tab_codici_iso" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_7" ("id_localita" ) REFERENCES "dba"."localita" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quater_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;		
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quinques') THEN
		
		CREATE TABLE "dba"."intra_1quinques" (
		"id_i_1quinques" integer NOT NULL DEFAULT autoincrement, 
		"id_i_nat_trans" integer DEFAULT NULL, 
		"id_sog_commerciale" integer DEFAULT NULL, 
		"id_i_servizio" integer DEFAULT NULL, 
		"id_i_fronte" integer NOT NULL DEFAULT NULL, 
		"prog_operaz" numeric(6,0) DEFAULT NULL, 
		"rif" numeric(1,0) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"amm_operaz" numeric(13,0) DEFAULT NULL, 
		"val_stat" numeric(13,0) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL , 
		"cod_sez_dog" numeric(6,0) DEFAULT NULL, 
		"anno_reg_dich" numeric(2,0) DEFAULT NULL, 
		"prot_dich_ret" numeric(6,0) DEFAULT NULL, 
		"prog_sez3_ret" numeric(5,0) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"id_i_tab_iso" integer DEFAULT NULL,
		PRIMARY KEY ("id_i_1quinques") , 
		FOREIGN KEY "fk_intra_1quinques_2" ("id_i_fronte" ) REFERENCES "dba"."intra_frontespizio_input" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quinques_3" ("id_i_nat_trans" ) REFERENCES "dba"."intra_nat_transazione" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quinques_4" ("id_i_servizio" ) REFERENCES "dba"."intra_servizio" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_intra_1quinques_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE RESTRICT ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'amm_compl_sez3' )) THEN 
		
		alter table intra_frontespizio_input add amm_compl_sez3 numeric(13,0) DEFAULT NULL;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'amm_compl_sez4' )) THEN 
		
		alter table intra_frontespizio_input add amm_compl_sez4 numeric(13,0) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'tot_rig_sez3' )) THEN 
		
		alter table intra_frontespizio_input add tot_rig_sez3 numeric(5,0) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'tot_rig_sez4' )) THEN 
		
		alter table intra_frontespizio_input add tot_rig_sez4 numeric(5,0) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'tot_sez3' )) THEN 
		
		alter table intra_frontespizio_input add tot_sez3 numeric(5,0) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_input'
        AND      CNAME = 'tot_sez4' )) THEN 
		
		alter table intra_frontespizio_input add tot_sez4 numeric(5,0) DEFAULT NULL;
end if;		


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quater_dogana') THEN
		
		CREATE TABLE "dba"."intra_1quater_dogana" (
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_servizio" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_sup" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasp" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"prov_dest" varchar(2) DEFAULT NULL, 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL)	;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quinques_dogana') THEN
		
		CREATE TABLE "dba"."intra_1quinques_dogana" (
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"servizio" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL,
		"cod_sez_dog" char(6) DEFAULT NULL, 
		"anno_reg_dich" char(2) DEFAULT NULL, 
		"prot_dich_ret" char(6) DEFAULT NULL, 
		"prog_sez3_ret" char(5) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"paese_pag" char(2) DEFAULT NULL) ;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quater_dog') THEN
		
		CREATE TABLE "dba"."intra_1quater_dog" (
		"id_1quater_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_servizio" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_sup" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasp" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"prov_dest" varchar(2) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,		
		PRIMARY KEY ("id_1quater_dog")) ;		
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1quinques_dog') THEN
		
		CREATE TABLE "dba"."intra_1quinques_dog" (
		"id_1quinques_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"servizio" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		"cod_sez_dog" char(6) DEFAULT NULL, 
		"anno_reg_dich" char(2) DEFAULT NULL, 
		"prot_dich_ret" char(6) DEFAULT NULL, 
		"prog_sez3_ret" char(5) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"paese_pag" char(2) DEFAULT NULL,		
		PRIMARY KEY ("id_1quinques_dog")) ;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_output'
        AND      CNAME = 'num_sez3' )) THEN 
		
		alter table intra_frontespizio_output add num_sez3 char(5) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_output'
        AND      CNAME = 'amm_sez3' )) THEN 
		
		alter table intra_frontespizio_output add amm_sez3 char(13) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_output'
        AND      CNAME = 'num_sez4' )) THEN 
		
		alter table intra_frontespizio_output add num_sez4 char(5) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'intra_frontespizio_output'
        AND      CNAME = 'amm_sez4' )) THEN 
		
		alter table intra_frontespizio_output add amm_sez4 char(13) DEFAULT NULL;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quater_dogana') THEN
		
		CREATE TABLE "dba"."intra_2quater_dogana" (
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_val" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_servizio" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_supp" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasporto" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"paese_origine" varchar(2) DEFAULT NULL, 
		"prov_origine" varchar(2) DEFAULT NULL, 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL);				
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quinques_dogana') THEN
		
		CREATE TABLE "dba"."intra_2quinques_dogana" (
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_valuta" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"servizio" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL,
		"cod_sez_dog" char(6) DEFAULT NULL, 
		"anno_reg_dich" char(2) DEFAULT NULL, 
		"prot_dich_ret" char(6) DEFAULT NULL, 
		"prog_sez3_ret" char(5) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"paese_pag" char(2) DEFAULT NULL) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quater_dog') THEN
		
		CREATE TABLE "dba"."intra_2quater_dog" (
		"id_2quater_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_val" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_servizio" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_supp" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasporto" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"paese_origine" varchar(2) DEFAULT NULL, 
		"prov_origine" varchar(2) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		"numero_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erogaz" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,		
		PRIMARY KEY ("id_2quater_dog")) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2quinques_dog') THEN
		
		CREATE TABLE "dba"."intra_2quinques_dog" (
		"id_2quinques_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_valuta" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"servizio" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL ,
		"cod_sez_dog" char(6) DEFAULT NULL, 
		"anno_reg_dich" char(2) DEFAULT NULL, 
		"prot_dich_ret" char(6) DEFAULT NULL, 
		"prog_sez3_ret" char(5) DEFAULT NULL, 
		"num_fat" char(15) DEFAULT NULL, 
		"data_fat" char(6) DEFAULT NULL, 
		"mod_erog" char(1) DEFAULT NULL, 
		"mod_inc" char(1) DEFAULT NULL,
		"paese_pag" char(2) DEFAULT NULL,
		PRIMARY KEY ("id_2quinques_dog")) ;
end if;			

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1bis_dog') THEN
				
		CREATE TABLE "dba"."intra_1bis_dog" (
		"id_1bis_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_nomenclatura" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_sup" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasp" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"prov_dest" varchar(2) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		PRIMARY KEY ("id_1bis_dog")) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_1ter_dog') THEN
		
		CREATE TABLE "dba"."intra_1ter_dog" (
		"id_1ter_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"nomenclatura" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		PRIMARY KEY ("id_1ter_dog")) ;
end if;			

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_2bis_dog') THEN
		
		CREATE TABLE "dba"."intra_2bis_dog" (
		"id_2bis_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"cod_stato" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_val" char(13) DEFAULT NULL, 
		"cod_nat_transaz" char(1) DEFAULT NULL, 
		"cod_nomenclatura" char(8) DEFAULT NULL, 
		"massa_netta" char(10) DEFAULT NULL, 
		"unita_supp" char(10) DEFAULT NULL, 
		"val_statistico" char(13) DEFAULT NULL, 
		"cond_consegna" char(1) DEFAULT NULL, 
		"modo_trasporto" char(1) DEFAULT NULL, 
		"paese_dest" varchar(2) DEFAULT NULL, 
		"paese_origine" varchar(2) DEFAULT NULL, 
		"prov_origine" varchar(2) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		PRIMARY KEY ("id_2bis_dog")) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'intra_ter_dog') THEN
		
		CREATE TABLE "dba"."intra_ter_dog" (
		"id_ter_dog" integer NOT NULL DEFAULT autoincrement, 
		"intra" varchar(5) DEFAULT 'INTRA', 
		"iva" char(11) DEFAULT NULL, 
		"num_prog_ele" char(6) DEFAULT NULL, 
		"tipo_rec" char(1) DEFAULT NULL, 
		"prog_riga" char(5) DEFAULT NULL, 
		"mese_rif" char(2) DEFAULT NULL, 
		"trim_rif" char(1) DEFAULT NULL, 
		"anno_rif" char(2) DEFAULT NULL, 
		"stato_operatore" varchar(2) DEFAULT NULL, 
		"iva_operatore" varchar(12) DEFAULT NULL, 
		"segno" char(1) DEFAULT NULL, 
		"ammontare" char(13) DEFAULT NULL, 
		"amm_valuta" char(13) DEFAULT NULL, 
		"natura_trans" char(1) DEFAULT NULL, 
		"nomenclatura" char(8) DEFAULT NULL, 
		"val_stat" char(13) DEFAULT NULL, 
		"id_i_fronte" integer DEFAULT NULL , 
		PRIMARY KEY ("id_ter_dog")) ;	
end if;		
/////////////////////////////////////////////////////////



///scadenziario
call fn_ins_voce_menu('Gestione Scadenze', 'w_stp_scad_flt', 'Stampa Scadenziario', 0);



//RATEI RISCONTI
IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mov_contabile'
        AND      CNAME = 'id_mov_rateo' )) THEN 
	ALTER TABLE "dba"."mov_contabile" ADD "id_mov_rateo" integer DEFAULT NULL;
end if;

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mov_contabile'
        AND      CNAME = 'id_mov_risconto' )) THEN 
	ALTER TABLE "dba"."mov_contabile" ADD "id_mov_risconto" integer DEFAULT NULL;
	ALTER TABLE "dba"."mov_contabile" ADD FOREIGN KEY "fk_mov_contabile_4" ("id_mov_rateo" ) REFERENCES "dba"."mov_contabile" ON DELETE RESTRICT;
	ALTER TABLE "dba"."mov_contabile" ADD FOREIGN KEY "fk_mov_contabile_5" ("id_mov_risconto" ) REFERENCES "dba"."mov_contabile" ON DELETE RESTRICT;
	ALTER TABLE "dba"."prof_registrazione" ADD "usa_risconti" char(1) DEFAULT 'N';
end if;
ALTER TABLE "dba"."prof_registrazione" MODIFY "usa_risconti" char(1) DEFAULT 'N';

call fn_ins_voce_menu('Chiusura / Apertura Conti', 'w_ratei_ff', 'Rilevamento Ratei', 5);
call fn_ins_voce_menu('Chiusura / Apertura Conti', 'w_risconti_ff', 'Rilevamento Risconti', 10);
call fn_ins_voce_menu('Chiusura / Apertura Conti', 'w_estratto_competenze_ff', 'Scheda per Competenza', 30);
call fn_ins_voce_menu('Chiusura / Apertura Conti', 'w_bilancio_competenze_cx', 'Bilancio per Competenza', 35);


/////PER I RATEI E RISCONTI
ALTER PROCEDURE "DBA"."sp_aggiorna_saldo_comp"(in @Anno integer,in @Mese integer,in @Conto integer,in @Esercizio integer,in @Mov_Dare dm_Imp_Valuta,in @Mov_Avere dm_Imp_Valuta,in @ID_Mov_Contab integer)
on exception resume
begin
  declare @Dare dm_Imp_Valuta;
  declare @Avere dm_Imp_Valuta;
  declare @ID_Esercizio integer;
  declare @Rat_Risc char;
  declare @err_notfound exception for sqlstate value '02000';
//  select ifNull(@Mov_Avere,0,@Mov_Avere) into @Avere;
//  select ifNull(@Mov_Dare,0,@Mov_Dare) into @Dare;
// set @ID_esercizio=sf_trova_esercizio(@Anno,@Mese);
//  if @ID_esercizio is null then
//    message 'sp_aggiorna_saldo_comp:1: Non esiste esercizio per ',@anno,'-',@mese;
//    raiserror 99999 'Non esiste un esercizio valido...'
//  end if
//  ;  
//  update saldo_mensile set
//    saldo_mensile.Dare_Competenza=IFNULL(saldo_mensile.Dare_Competenza,0,saldo_mensile.Dare_Competenza)+@Dare,
//    saldo_mensile.Avere_Competenza=IFNULL(saldo_mensile.Avere_Competenza,0,saldo_mensile.Avere_Competenza)+@Avere
//    where((saldo_mensile.anno=@Anno) and(saldo_mensile.mese=@Mese)
//    and(saldo_mensile.id_conto=@Conto) and(saldo_mensile.id_esercizio=@ID_Esercizio));
//  if sqlcode<>0 and sqlstate<>@err_notfound then message 'error update no 100'
//  end if
//  ;
//  if sqlstate=@err_notfound then
//    insert into saldo_mensile(id_conto,
//      anno,
//      id_esercizio,
//      mese,
//      dare_Competenza,
//      avere_Competenza,
//      dare,
//      avere,
//     dare_mn,
//      avere_mn) values(
//      @Conto,
//      @Anno,
//      @ID_Esercizio,
//      @Mese,
//      @Dare,
//      @Avere,
//      0,
//      0,
//      0,
//      0)
//  end if
end;


//////parsistema risconti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_conto_risconti_attivi' )) THEN 
		
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_risconti_attivi" integer DEFAULT NULL;
	ALTER TABLE "dba"."par_sistema" ADD "id_conto_risconti_passivi" integer DEFAULT NULL;
end if;


ALTER TRIGGER "t_Mov_Scadenza_Aggiorna_Esito_ai" after insert order 1
on "DBA".Mov_Scadenza
referencing new as new_Mov_Scadenza
for each row
begin
  /* [ANT] 15/12/97
  Chiama la Stored Procedure per l'aggiornamento dell'esito della scadenza. */
  declare @li_id_scadenza integer;
  set @li_id_scadenza=new_Mov_Scadenza.id_scadenza;
  if @li_id_scadenza is not null then
     call sp_Aggiorna_Esito_Scadenza(@li_id_scadenza)
  end if
end;


//////parsistema prezzo prop articolo antichi
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'prop_prezzo_articolo' )) THEN 

	alter table par_sistema add prop_prezzo_articolo char(1);

	if (SELECT codice FROM   AZIENDA)='ANTICHI' then
	   update par_sistema  set prop_prezzo_articolo='S';
   	end if;
	
        //si riferisce al trigger sopra l'ho messo qui per farlo eseguire una volta sola
	update mov_scadenza set note=' ';
end if;


/////PROBLEMA SALDI MENSILI ES CAVALLO TERMOIDRAULICA
ALTER PROCEDURE "DBA"."sp_Mov_Contabile_Op"(in Mov_Dare dm_Imp_Valuta,in Mov_Avere dm_Imp_Valuta,in Data_Inizio_Competenza date,in Data_Fine_Competenza date,in Data_Competenza date,in Conto integer,in Esercizio integer,in @ID_Mov_Contab integer)
on exception resume
begin
  declare Reg_pd integer;
  declare Saldo_Dare dm_Imp_Valuta;
  declare Saldo_Avere dm_Imp_Valuta;
  declare Saldo dm_Imp_Valuta;
  declare Dare_Per_Giorno decimal(18,4);
  declare Avere_Per_Giorno decimal(18,4);
  declare Delta_Mesi integer;
  declare "Count" integer;
  declare Giorni_Mese integer;
  declare Data_Inizio date;
  declare Data_Parziale date;
  declare Dare_Parziale decimal(18,4);
  declare Avere_Parziale decimal(18,4);
  declare Somma_Dare_Parziale decimal(18,4);
  declare Somma_Avere_Parziale decimal(18,4);
  set Somma_Dare_Parziale=0;
  set Somma_Avere_Parziale=0;
  //Provvede ad aggiornare dare & avere competenza
  if(Year(Data_Inizio_Competenza)=Year(Data_Fine_Competenza)) and(Month(Data_Inizio_Competenza)=Month(Data_Fine_Competenza)) then
    //
    //message 'sp_mov_contabile_op:1: Anno:',(Year(Data_Inizio_Competenza)),' Mese:',(Month(Data_Inizio_Competenza));
    //
    call sp_aggiorna_saldo_comp(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),Conto,Esercizio,Mov_Dare,Mov_Avere,@ID_Mov_Contab)
  else
    set Dare_Per_Giorno=Mov_Dare/(datediff(day,Data_Inizio_Competenza,Data_Fine_Competenza)+1);
    set Avere_Per_Giorno=Mov_Avere/(datediff(day,Data_Inizio_Competenza,Data_Fine_Competenza)+1);
    //set Delta_Mesi=datediff(Month,Data_Inizio_Competenza,Data_Fine_Competenza);
    set Delta_Mesi=Month(Data_Fine_Competenza)-Month(Data_Inizio_Competenza)+(12*(Year(Data_Fine_Competenza)-Year(Data_Inizio_Competenza)));
    set Data_Inizio=YMD(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),'01');
    set Giorni_Mese=datediff(day,Data_Inizio_Competenza,dateadd(month,1,Data_Inizio));
    set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
    set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
    set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
    set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
    //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese;
    //
    //message 'sp_mov_contabile_op:2: Anno:',Year(Data_Inizio_Competenza),' Mese:',Month(Data_Inizio_Competenza);
    //
    call sp_aggiorna_saldo_comp(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab);
    set "Count"=2;
    while "Count"<=Delta_Mesi loop
      set Data_Parziale=dateadd(month,"Count"-1,Data_Inizio);
      set Giorni_Mese=datediff(day,Data_Parziale,dateadd(month,"Count",Data_Inizio));
      set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
      set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
      set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
      set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
      //
      //message 'sp_mov_contabile_op:3: Anno:',Year(Data_Parziale),' Mese:',Month(Data_Parziale);
      //
      call sp_aggiorna_saldo_comp(Year(Data_Parziale),Month(Data_Parziale),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab);
      //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese;
      set "Count"="Count"+1
    end loop
    ;
    set Data_Inizio=YMD(Year(Data_Fine_Competenza),Month(Data_Fine_Competenza),'01');
    set Giorni_Mese=datediff(day,Data_Inizio,Data_Fine_Competenza)+1;
    set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
    set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
    set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
    set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
    set Dare_Parziale=Dare_Parziale+Mov_Dare-Somma_Dare_Parziale;
    set Avere_Parziale=Avere_Parziale+Mov_Avere-Somma_Avere_Parziale;
    //
    //message 'sp_mov_contabile_op:4: Anno:',Year(Data_Fine_Competenza),' Mese:',Month(Data_Fine_Competenza);
    //
    call sp_aggiorna_saldo_comp(Year(Data_Fine_Competenza),Month(Data_Fine_Competenza),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab)
  end if //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese
  ; //Provvede ad aggiornare dare & avere
  call sp_aggiorna_saldo(Year(Data_Competenza),Month(Data_Competenza),Data_Competenza,Conto,Esercizio,Mov_Dare,Mov_Avere)
end;


ALTER PROCEDURE "DBA"."sp_scritture_manageriali"(in Mov_Dare dm_Imp_Valuta,in Mov_Avere dm_Imp_Valuta,in Data_Inizio_Competenza date,in Data_Fine_Competenza date,in Data_Competenza date,in Conto integer,in Esercizio integer,in @ID_Mov_Contab integer)
on exception resume
begin
  declare Reg_pd integer;
  declare Saldo_Dare dm_Imp_Valuta;
  declare Saldo_Avere dm_Imp_Valuta;
  declare Saldo dm_Imp_Valuta;
  declare Dare_Per_Giorno decimal(18,4);
  declare Avere_Per_Giorno decimal(18,4);
  declare Delta_Mesi integer;
  declare "Count" integer;
  declare Giorni_Mese integer;
  declare Data_Inizio date;
  declare Data_Parziale date;
  declare Dare_Parziale decimal(18,4);
  declare Avere_Parziale decimal(18,4);
  declare Somma_Dare_Parziale decimal(18,4);
  declare Somma_Avere_Parziale decimal(18,4);
  set Somma_Dare_Parziale=0;
  set Somma_Avere_Parziale=0;
  //Provvede ad aggiornare dare & avere competenza
  if(Year(Data_Inizio_Competenza)=Year(Data_Fine_Competenza)) and(Month(Data_Inizio_Competenza)=Month(Data_Fine_Competenza)) then
    //
    //message 'sp_mov_contabile_op:1: Anno:',(Year(Data_Inizio_Competenza)),' Mese:',(Month(Data_Inizio_Competenza));
    //
    call sp_aggiorna_saldo_comp_MN(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),Conto,Esercizio,Mov_Dare,Mov_Avere,@ID_Mov_Contab)
  else
    set Dare_Per_Giorno=Mov_Dare/(datediff(day,Data_Inizio_Competenza,Data_Fine_Competenza)+1);
    set Avere_Per_Giorno=Mov_Avere/(datediff(day,Data_Inizio_Competenza,Data_Fine_Competenza)+1);
    //set Delta_Mesi=datediff(Month,Data_Inizio_Competenza,Data_Fine_Competenza);
    set Delta_Mesi=Month(Data_Fine_Competenza)-Month(Data_Inizio_Competenza)+(12*(Year(Data_Fine_Competenza)-Year(Data_Inizio_Competenza)));
    set Data_Inizio=YMD(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),'01');
    set Giorni_Mese=datediff(day,Data_Inizio_Competenza,dateadd(month,1,Data_Inizio));
    set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
    set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
    set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
    set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
    //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese;
    //
    //message 'sp_mov_contabile_op:2: Anno:',Year(Data_Inizio_Competenza),' Mese:',Month(Data_Inizio_Competenza);
    //
    call sp_aggiorna_saldo_comp_MN(Year(Data_Inizio_Competenza),Month(Data_Inizio_Competenza),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab);
    set "Count"=2;
    while "Count"<=Delta_Mesi loop
      set Data_Parziale=dateadd(month,"Count"-1,Data_Inizio);
      set Giorni_Mese=datediff(day,Data_Parziale,dateadd(month,"Count",Data_Inizio));
      set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
      set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
      set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
      set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
      //
      //message 'sp_mov_contabile_op:3: Anno:',Year(Data_Parziale),' Mese:',Month(Data_Parziale);
      //
      call sp_aggiorna_saldo_comp_MN(Year(Data_Parziale),Month(Data_Parziale),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab);
      //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese;
      set "Count"="Count"+1
    end loop
    ;
    set Data_Inizio=YMD(Year(Data_Fine_Competenza),Month(Data_Fine_Competenza),'01');
    set Giorni_Mese=datediff(day,Data_Inizio,Data_Fine_Competenza)+1;
    set Dare_Parziale="Truncate"(Giorni_Mese*Dare_Per_Giorno,0);
    set Avere_Parziale="Truncate"(Giorni_Mese*Avere_Per_Giorno,0);
    set Somma_Dare_Parziale=Somma_Dare_Parziale+Dare_Parziale;
    set Somma_Avere_Parziale=Somma_Avere_Parziale+Avere_Parziale;
    set Dare_Parziale=Dare_Parziale+Mov_Dare-Somma_Dare_Parziale;
    set Avere_Parziale=Avere_Parziale+Mov_Avere-Somma_Avere_Parziale;
    //
    //message 'sp_mov_contabile_op:4: Anno:',Year(Data_Fine_Competenza),' Mese:',Month(Data_Fine_Competenza);
    //
    call sp_aggiorna_saldo_comp_MN(Year(Data_Fine_Competenza),Month(Data_Fine_Competenza),Conto,Esercizio,Dare_parziale,Avere_parziale,@ID_Mov_Contab)
  end if //message Data_Inizio_Competenza,' * ',Giorni_Mese,' * ',Dare_Parziale,' * ',Avere_parziale,' * ',Giorni_Mese
  ; //Provvede ad aggiornare dare & avere
  call sp_aggiorna_saldo_MN(Year(Data_Competenza),Month(Data_Competenza),Data_Competenza,Conto,Esercizio,Mov_Dare,Mov_Avere)
end;

ALTER PROCEDURE "DBA"."sp_aggiorna_saldo_comp_MN"(in @Anno integer,in @Mese integer,in @Conto integer,in @Esercizio integer,in @Mov_Dare dm_Imp_Valuta,in @Mov_Avere dm_Imp_Valuta,in @ID_Mov_Contab integer)
on exception resume
begin
  declare @Dare dm_Imp_Valuta;
  declare @Avere dm_Imp_Valuta;
  declare @ID_Esercizio integer;
  declare @Rat_Risc char;
  declare @err_notfound exception for sqlstate value '02000';
//  select ifNull(@Mov_Avere,0,@Mov_Avere) into @Avere;
//  select ifNull(@Mov_Dare,0,@Mov_Dare) into @Dare;
  //message @Anno,' - ',@Mese,' - ',@Conto,' - ',@Esercizio,' - ',@Mov_Dare,' - ',@Mov_Avere;
  //[J, 1997-10-25]: supporto per il multiesercizio
  /* devo trovare l'esercizio giusto a cui applicare i cambiamenti; infatti, poich
  anno e mese potrebbero cadere FUORI dell'esercizio (in uno conseguente),
  devo trovare il modo di influire sull'esercizio giusto. Nota: l'esercizio
  potrebbe NON Esistere... */
//  set @ID_esercizio=sf_trova_esercizio(@Anno,@Mese);
//  if @ID_esercizio is null then
//    message 'sp_aggiorna_saldo_comp:1: Non esiste esercizio per ',@anno,'-',@mese;
//    raiserror 99999 'Non esiste un esercizio valido...'
//  end if
//  ;  
//  update saldo_mensile set
//    saldo_mensile.Dare_mn_Competenza=IFNULL(saldo_mensile.Dare_mn_Competenza,0,saldo_mensile.Dare_mn_Competenza)+@Dare,
//    saldo_mensile.Avere_mn_Competenza=IFNULL(saldo_mensile.Avere_mn_Competenza,0,saldo_mensile.Avere_mn_Competenza)+@Avere
//    where((saldo_mensile.anno=@Anno) and(saldo_mensile.mese=@Mese)
//    and(saldo_mensile.id_conto=@Conto) and(saldo_mensile.id_esercizio=@ID_Esercizio));
//  if sqlcode<>0 and sqlstate<>@err_notfound then message 'error update no 100'
//  end if
//  ;
//  if sqlstate=@err_notfound then
    /*message 'Creazione di un nuovo saldo: Anno ',@Anno,'- Mese ',@Mese,' dare ',@Dare,' avere ',@Avere*/
//    insert into saldo_mensile(id_conto,
//      anno,
//      id_esercizio,
//      mese,
//      dare_mn_Competenza,
//      avere_mn_Competenza) values(
//      @Conto,
//      @Anno,
//      @ID_Esercizio,
//      @Mese,
//      @Dare,
//      @Avere)
//  end if
end;


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sf_agg_trova_esercizio') THEN

	CREATE FUNCTION "DBA"."sf_agg_trova_esercizio"(in @data_comp date)
	returns integer
	on exception resume
	begin
	  declare @esercizio integer;
	  declare err_notfound exception for sqlstate value '02000';
	  select id_esercizio into @esercizio from esercizio
	    where @data_comp between data_inizio and data_fine;
	  if sqlstate=err_notfound then
	    set @esercizio=null
	  end if;
	  return(@esercizio)
	end;

end if;


ALTER PROCEDURE "DBA"."sp_aggiorna_saldo"(in @Anno integer,in @Mese integer, in @data_comp date,in @Conto integer,in @Esercizio integer,in @Mov_Dare dm_Imp_Valuta,in @Mov_Avere dm_Imp_Valuta)
on exception resume
begin
  declare @Dare dm_Imp_Valuta;
  declare @Avere dm_Imp_Valuta;
  declare @ID_Esercizio integer;
  declare @err_notfound exception for sqlstate value '02000';
  //declare @err_no_esercizio exception for sqlstate value '00000';
  select ifNull(@Mov_Avere,0,@Mov_Avere) into @Avere;
  select ifNull(@Mov_Dare,0,@Mov_Dare) into @Dare;
  //[J, 1997-10-25]: supporto per il multiesercizio
  /* devo trovare l'esercizio giusto a cui applicare i cambiamenti; infatti, poich
  anno e mese potrebbero cadere FUORI dell'esercizio (in uno conseguente),
  devo trovare il modo di influire sull'esercizio giusto. Nota: l'esercizio
  potrebbe NON Esistere... */
  //message 'chiamata sf_trova_esercizio da sp_aggiorna_saldo: Anno: ',@anno,' - Mese: ',@mese;
  set @ID_Esercizio=sf_agg_trova_esercizio(@data_comp);
  //message 'sp_aggiorna_saldo:0: esercizio = ',@ID_Esercizio;
  if @ID_Esercizio is null then
    message 'sp_aggiorna_saldo:1: Non esiste esercizio per ',@anno,'-',@mese;
    raiserror 99999 'Non esiste un esercizio valido...'
  end if
  ; // a questo punto l''esercizio  corretto
  //message @Anno,' - ',@Mese,' - ',@Mov_Dare,' - ',@Mov_Avere,' - ';
  //message 'sono prima dell''update...';
  update saldo_mensile set
    saldo_mensile.Dare=IFNULL(saldo_mensile.Dare,0,saldo_mensile.Dare)+@Dare,
    saldo_mensile.Avere=IFNULL(saldo_mensile.Avere,0,saldo_mensile.Avere)+@Avere
    where((saldo_mensile.anno=@Anno) and(saldo_mensile.mese=@Mese)
    and(saldo_mensile.id_conto=@Conto) and(saldo_mensile.id_esercizio=@ID_Esercizio));
  //message 'sqlcode',sqlcode,' - ',sqlstate;
  if sqlcode<>0 and sqlstate<>@err_notfound then message 'error update no 100'
  end if
  ;
  if sqlstate=@err_notfound then
    /*message 'Creazione di un nuovo saldo: Anno ',@Anno,'- Mese ',@Mese,' dare ',@Dare,' avere ',@Avere*/
    insert into saldo_mensile(id_conto,
      anno,
      ID_Esercizio,
      mese,
      dare,
      avere,
      dare_mn,
      avere_mn) values(
      @Conto,
      @Anno,
      @ID_Esercizio,
      @Mese,
      @Dare,
      @Avere,
      0,
      0)
  end if
end;


ALTER PROCEDURE "DBA"."sp_aggiorna_saldo_MN"(in @Anno integer,in @Mese integer,in @data_comp date,in @Conto integer,in @Esercizio integer,in @Mov_Dare dm_Imp_Valuta,in @Mov_Avere dm_Imp_Valuta)
on exception resume
begin
  declare @Dare dm_Imp_Valuta;
  declare @Avere dm_Imp_Valuta;
  declare @ID_Esercizio integer;
  declare @err_notfound exception for sqlstate value '02000';
  //declare @err_no_esercizio exception for sqlstate value '00000';
  select ifNull(@Mov_Avere,0,@Mov_Avere) into @Avere;
  select ifNull(@Mov_Dare,0,@Mov_Dare) into @Dare;
  //[J, 1997-10-25]: supporto per il multiesercizio
  /* devo trovare l'esercizio giusto a cui applicare i cambiamenti; infatti, poich
  anno e mese potrebbero cadere FUORI dell'esercizio (in uno conseguente),
  devo trovare il modo di influire sull'esercizio giusto. Nota: l'esercizio
  potrebbe NON Esistere... */
  //message 'chiamata sf_trova_esercizio da sp_aggiorna_saldo: Anno: ',@anno,' - Mese: ',@mese;
  set @ID_Esercizio=sf_agg_trova_esercizio(@data_comp);
  //message 'sp_aggiorna_saldo:0: esercizio = ',@ID_Esercizio;
  if @ID_Esercizio is null then
    message 'sp_aggiorna_saldo:1: Non esiste esercizio per ',@anno,'-',@mese;
    raiserror 99999 'Non esiste un esercizio valido...'
  end if
  ; // a questo punto l''esercizio  corretto
  //message @Anno,' - ',@Mese,' - ',@Mov_Dare,' - ',@Mov_Avere,' - ';
  //message 'sono prima dell''update...';
  update saldo_mensile set
    saldo_mensile.Dare_mn=ifnull(saldo_mensile.Dare_mn,0,saldo_mensile.Dare_mn)+@Dare,
    saldo_mensile.Avere_mn=ifnull(saldo_mensile.Avere_mn,0,saldo_mensile.Avere_mn)+@Avere
    where((saldo_mensile.anno=@Anno) and(saldo_mensile.mese=@Mese)
    and(saldo_mensile.id_conto=@Conto) and(saldo_mensile.id_esercizio=@ID_Esercizio));
  //message 'sqlcode',sqlcode,' - ',sqlstate;
  if sqlcode<>0 and sqlstate<>@err_notfound then message 'error update no 100'
  end if
  ;
  if sqlstate=@err_notfound then
    /*message 'Creazione di un nuovo saldo: Anno ',@Anno,'- Mese ',@Mese,' dare ',@Dare,' avere ',@Avere*/
    insert into saldo_mensile(id_conto,
      anno,
      ID_Esercizio,
      mese,
      dare_mn,
      avere_mn) values(
      @Conto,
      @Anno,
      @ID_Esercizio,
      @Mese,
      @Dare,
      @Avere)
  end if
end;


//INDICE saldo mensile
IF (EXISTS(
	SELECT 1 
   FROM   SYS.SYSINDEXES
   WHERE  tname = 'SALDO_MENSILE' 
	AND 	 iname = 'ix_saldo_mensile_1')) THEN

   drop index ix_saldo_mensile_1;
END IF;


////FINE SALDI MENSILI TERMOIDRAULICA

///cct spese cambio
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sog_commerciale'
        AND      CNAME = 'note_aggiuntive' )) THEN 
		
	ALTER TABLE "dba"."sog_commerciale" ADD "note_aggiuntive" long varchar DEFAULT NULL;

end if;	

///cct spese cambio
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_conto_spese_bc' )) THEN 
		
	ALTER TABLE par_sistema ADD id_conto_spese_bc integer DEFAULT NULL;		
end if;	


////TIBER FIERA

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'sog_com_note_fiera') THEN

	CREATE TABLE "dba"."sog_com_note_fiera" ("id_sog_com_note_fiera" integer NOT NULL DEFAULT autoincrement, 
						 "id_sog_commerciale" integer NOT NULL DEFAULT NULL, 
						 "note" long varchar DEFAULT NULL, "id_azienda" integer NOT NULL DEFAULT 1, PRIMARY KEY ("id_sog_com_note_fiera"), 
						 FOREIGN KEY "fk_sog_com_note_fiera_1" ("id_sog_commerciale" ) REFERENCES "dba"."sog_commerciale" ON DELETE CASCADE ) ;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sog_com_note_fiera'
        AND      CNAME = 'data_creazione' )) THEN 

	ALTER TABLE sog_com_note_fiera ADD data_creazione DATE NOT NULL DEFAULT NULL;
end if;	


///trigger saldi reg pd
ALTER TRIGGER "t_Reg_PD_Aggiorna_Saldi_au" after update of data_competenza
order 3 on "DBA".reg_pd
referencing old as old_reg_pd new as new_reg_pd
for each row
begin
  declare @ls_tipo_registro char(2);
  declare @ld_old_data_competenza date;
  declare @ld_new_data_competenza date;
  declare @li_old_id_registro integer;
  declare @li_new_id_registro integer;
  declare @li_old_id_esercizio integer;
  declare @li_new_id_esercizio integer;
  declare @ln_dare decimal(18,4);
  declare @ln_avere decimal(18,4);
  declare @ld_data_inizio_competenza date;
  declare @ld_data_fine_competenza date;
  declare @li_id_conto integer;
  declare @li_id_mov_contabile integer;
  declare @li_id_reg_pd integer;
  declare err_notfound exception for sqlstate value '02000';
  declare lcur_mov_contabile dynamic scroll cursor for select mov_contabile.dare,
      mov_contabile.avere,
      mov_contabile.data_inizio_competenza,
      mov_contabile.data_fine_competenza,
      mov_contabile.id_conto,
      mov_contabile.id_mov_contabile
      from mov_contabile
      where mov_contabile.id_reg_pd=@li_id_reg_pd;
  set @ld_old_data_competenza=old_reg_pd.data_competenza;
  set @ld_new_data_competenza=new_reg_pd.data_competenza;
  set @li_old_id_registro=old_reg_pd.id_registro;
  set @li_new_id_registro=new_reg_pd.id_registro;
  set @li_id_reg_pd=new_reg_pd.id_reg_pd;
  select registro.id_esercizio,registro.tipo_registro into @li_old_id_esercizio,
    @ls_tipo_registro from registro
    where registro.id_registro=@li_old_id_registro;
  if @li_old_id_registro<>@li_new_id_registro then
    select registro.id_esercizio,registro.tipo_registro into @li_new_id_esercizio,
      @ls_tipo_registro from registro
      where registro.id_registro=@li_new_id_registro
  else
    set @li_new_id_esercizio=@li_old_id_esercizio
  end if
  ;
  open lcur_mov_contabile;
  Mov_ContabileLoop: loop
    fetch next lcur_mov_contabile into @ln_dare,@ln_avere,@ld_data_inizio_competenza,@ld_data_fine_competenza,@li_id_conto,@li_id_mov_contabile;
    if sqlstate=err_notfound then
      leave Mov_ContabileLoop
    end if
    ;
    if(@ld_Data_Inizio_Competenza=@ld_Data_Fine_Competenza) and(@ld_Data_Fine_Competenza=@ld_old_data_competenza) then
      update mov_contabile set
        data_inizio_competenza=@ld_new_data_competenza,
        data_fine_competenza=@ld_new_data_competenza where current of lcur_mov_contabile
    end if
    ;
    if(@ld_Data_Inizio_Competenza=@ld_Data_Fine_Competenza) then
      if @ls_tipo_registro='MN' then
        call sp_aggiorna_saldo_mn(Year(@ld_old_data_competenza),Month(@ld_old_data_competenza),@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,-@ln_dare,-@ln_avere);
        call sp_aggiorna_saldo_mn(Year(@ld_new_data_competenza),Month(@ld_new_data_competenza),@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,@ln_dare,@ln_avere)
      else
        /*update mov_contabile set
        data_inizio_competenza=@ld_new_data_competenza,
        data_fine_competenza=@ld_new_data_competenza where current of lcur_mov_contabile;*/
        //call sp_Mov_Contabile_op(-@ln_dare,-@ln_avere,@ld_Data_Inizio_Competenza,@ld_Data_Fine_Competenza,@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,@li_id_mov_contabile);
        //call sp_Mov_Contabile_op(-@ln_dare,-@ln_avere,@ld_old_data_competenza,@ld_old_data_competenza,@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,@li_id_mov_contabile);
        //call sp_Mov_Contabile_op(@ln_dare,@ln_avere,@ld_Data_Inizio_Competenza,@ld_Data_Fine_Competenza,@ld_new_data_competenza,@li_id_Conto,@li_new_id_Esercizio,@li_id_mov_contabile)
        call sp_aggiorna_saldo(Year(@ld_old_data_competenza),Month(@ld_old_data_competenza),@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,-@ln_dare,-@ln_avere);
        //call sp_aggiorna_saldo_comp(Year(@ld_old_data_competenza),Month(@ld_old_data_competenza),@li_id_Conto,@li_old_id_Esercizio,-@ln_dare,-@ln_avere,@li_id_mov_contabile);
        call sp_aggiorna_saldo(Year(@ld_new_data_competenza),Month(@ld_new_data_competenza),@ld_old_data_competenza,@li_id_Conto,@li_old_id_Esercizio,@ln_dare,@ln_avere)
      end if
    end if //call sp_aggiorna_saldo_comp(Year(@ld_new_data_competenza),Month(@ld_new_data_competenza),@li_id_Conto,@li_old_id_Esercizio,@ln_dare,@ln_avere,@li_id_mov_contabile)
  end loop Mov_ContabileLoop
  ;
  close lcur_mov_contabile
end;


//RICERCA PERSONALIZZATA
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'articolo_sw' )) THEN 
		
	ALTER TABLE par_sistema ADD articolo_sw char(80) DEFAULT NULL;
end if;


//BLACK LIST
call fn_ins_voce_menu('Anagrafica', 'w_controllo_blacklist_clfo_ff', 'Controllo Black List CL/FO', 130);



/// INIZIO NJAZIONI




IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'nazione'
        AND      CNAME = 'alpha_2' )) THEN 


	IF EXISTS(
	        SELECT 1 
	        FROM   SYS.sysforeignkey
	        WHERE  ROLE = 'fk_localita_1') THEN
		ALTER TABLE localita DROP FOREIGN KEY "fk_localita_1";
	end if;


	IF EXISTS(
	        SELECT 1 
	        FROM   SYS.SYSTABLE
	        WHERE  TABLE_NAME = 'TMP_APP_nazione') THEN
		drop table TMP_APP_nazione;
	end if;
	CREATE TABLE "dba"."TMP_APP_nazione" ("id_nazione" integer NOT NULL DEFAULT autoincrement, "codice" char(2) NOT NULL DEFAULT NULL, "descrizione" char(40) DEFAULT NULL, "id_valuta" integer NOT NULL DEFAULT NULL, "id_lingua" integer NOT NULL DEFAULT NULL, "prov_contabile" char(1) NOT NULL DEFAULT NULL, "id_tab_iva" integer DEFAULT NULL, PRIMARY KEY ("id_nazione") , FOREIGN KEY "fk_nazione_2" ("id_lingua" ) REFERENCES "dba"."lingua" ON DELETE RESTRICT , FOREIGN KEY "fk_nazione_1" ("id_valuta" ) REFERENCES "dba"."valuta" ON DELETE RESTRICT ) ;
	INSERT INTO TMP_APP_nazione ("id_nazione" , "codice" , "descrizione" , "id_valuta" , "id_lingua" , "prov_contabile" , "id_tab_iva" ) SELECT "id_nazione" , "codice" , "descrizione" , "id_valuta" , "id_lingua" , "prov_contabile" , "id_tab_iva" FROM NAZIONE;



alter table localita drop id_nazione;
alter table localita add id_nazione integer default null;

update  localita set id_nazione=null;
DELETE FROM nazionE;

ALTER TABLE "DBA"."NAZIONE" DROP prov_contabile;
ALTER TABLE "DBA"."NAZIONE" ADD prov_contabile char(1) not null default null;

ALTER TABLE "dba"."nazione" modify CODICE char(2) not null default null;
ALTER TABLE "dba"."nazione" add  "black_list" char(1) DEFAULT 'N';
ALTER TABLE "dba"."nazione" add alpha_2 char(2) default null;
ALTER TABLE "dba"."nazione" add alpha_3 char(3) default null;
ALTER TABLE "dba"."nazione" add ISO3166_1 integer default null;

DELETE FROM nazionE;
CREATE UNIQUE INDEX "xk_nazione_1" ON "dba"."nazione" ("codice" ) ;

INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AF','Afghanistan',id_val_euro,id_lingua,'R','N','AF','AFG',4	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AL','Albania',id_val_euro,id_lingua,'E','N','AL','ALB',8	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DZ','Algeria',id_val_euro,id_lingua,'R','N','DZ','DZA',12	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AD','Andorra',id_val_euro,id_lingua,'E','S','AD','AND',20	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AO','Angola',id_val_euro,id_lingua,'R','S','AO','AGO',24	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AI','Anguilla',id_val_euro,id_lingua,'R','S','AI','AIA',660	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AQ','Antartide',id_val_euro,id_lingua,'R','N','AQ','ATA',10	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AG','Antigua e Barbuda',id_val_euro,id_lingua,'R','S','AG','ATG',28	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AN','Antille Olandesi',id_val_euro,id_lingua,'R','S','AN','ANT',530	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SA','Arabia Saudita',id_val_euro,id_lingua,'R','N','SA','SAU',682	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AR','Argentina',id_val_euro,id_lingua,'R','N','AR','ARG',32	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AM','Armenia',id_val_euro,id_lingua,'E','N','AM','ARM',51	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AW','Aruba',id_val_euro,id_lingua,'R','S','AW','ABW',533	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AU','Australia',id_val_euro,id_lingua,'R','N','AU','AUS',36	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AT','Austria',id_val_euro,id_lingua,'U','N','AT','AUT',40	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AZ','Azerbaijan',id_val_euro,id_lingua,'E','N','AZ','AZE',31	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BS','Bahamas',id_val_euro,id_lingua,'R','S','BS','BHS',44	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BH','Bahrain',id_val_euro,id_lingua,'R','S','BH','BHR',48	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BD','Bangladesh',id_val_euro,id_lingua,'R','N','BD','BGD',50	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BB','Barbados',id_val_euro,id_lingua,'R','S','BB','BRB',52	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BE','Belgio',id_val_euro,id_lingua,'U','N','BE','BEL',56	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BZ','Belize',id_val_euro,id_lingua,'R','S','BZ','BLZ',84	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BJ','Benin',id_val_euro,id_lingua,'R','N','BJ','BEN',204	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BM','Bermuda',id_val_euro,id_lingua,'R','S','BM','BMU',60	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BT','Bhutan',id_val_euro,id_lingua,'R','N','BT','BTN',64	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BY','Bielorussia',id_val_euro,id_lingua,'E','N','BY','BLR',112	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BO','Bolivia',id_val_euro,id_lingua,'R','N','BO','BOL',68	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BA','Bosnia Erzegovina',id_val_euro,id_lingua,'E','N','BA','BIH',70	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BW','Botswana',id_val_euro,id_lingua,'R','N','BW','BWA',72	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BR','Brasile',id_val_euro,id_lingua,'R','N','BR','BRA',76	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BN','Brunei Darussalam',id_val_euro,id_lingua,'R','S','BN','BRN',96	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BG','Bulgaria',id_val_euro,id_lingua,'U','N','BG','BGR',100	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BF','Burkina Faso',id_val_euro,id_lingua,'R','N','BF','BFA',854	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BI','Burundi',id_val_euro,id_lingua,'R','N','BI','BDI',108	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KH','Cambogia',id_val_euro,id_lingua,'R','N','KH','KHM',116	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CM','Camerun',id_val_euro,id_lingua,'R','N','CM','CMR',120	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CA','Canada',id_val_euro,id_lingua,'R','N','CA','CAN',124	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CV','Capo Verde',id_val_euro,id_lingua,'R','N','CV','CPV',132	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TD','Ciad',id_val_euro,id_lingua,'R','N','TD','TCD',148	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CL','Cile',id_val_euro,id_lingua,'R','N','CL','CHL',152	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CN','Cina',id_val_euro,id_lingua,'R','N','CN','CHN',156	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CY','Cipro',id_val_euro,id_lingua,'U','S','CY','CYP',196	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VA','Citt del Vaticano',id_val_euro,id_lingua,'E','N','VA','VAT',336	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CO','Colombia',id_val_euro,id_lingua,'R','N','CO','COL',170	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KM','Comore',id_val_euro,id_lingua,'R','N','KM','COM',174	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KP','Corea del Nord',id_val_euro,id_lingua,'R','N','KP','PRK',408	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KR','Corea del Sud',id_val_euro,id_lingua,'R','S','KR','KOR',410	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CI','Costa dAvorio',id_val_euro,id_lingua,'R','N','CI','CIV',384	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CR','Costa Rica',id_val_euro,id_lingua,'R','S','CR','CRI',188	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HR','Croazia',id_val_euro,id_lingua,'E','N','HR','HRV',191	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CU','Cuba',id_val_euro,id_lingua,'R','N','CU','CUB',192	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DK','Danimarca',id_val_euro,id_lingua,'U','S','DK','DNK',208	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DM','Dominica',id_val_euro,id_lingua,'R','N','DM','DMA',212	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'EC','Ecuador',id_val_euro,id_lingua,'R','S','EC','ECU',218	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'EG','Egitto',id_val_euro,id_lingua,'R','N','EG','EGY',818	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IE','Eire',id_val_euro,id_lingua,'U','N','IE','IRL',372	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SV','El Salvador',id_val_euro,id_lingua,'R','N','SV','SLV',222	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AE','Emirati Arabi Uniti',id_val_euro,id_lingua,'R','S','AE','ARE',784	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ER','Eritrea',id_val_euro,id_lingua,'R','N','ER','ERI',232	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'EE','Estonia',id_val_euro,id_lingua,'U','N','EE','EST',233	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ET','Etiopia',id_val_euro,id_lingua,'R','N','ET','ETH',231	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'RU','Federazione Russa',id_val_euro,id_lingua,'E','N','RU','RUS',643	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FJ','Fiji',id_val_euro,id_lingua,'R','N','FJ','FJI',242	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PH','Filippine',id_val_euro,id_lingua,'R','S','PH','PHL',608	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FI','Finlandia',id_val_euro,id_lingua,'U','N','FI','FIN',246	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FR','Francia',id_val_euro,id_lingua,'U','N','FR','FRA',250	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GA','Gabon',id_val_euro,id_lingua,'R','N','GA','GAB',266	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GM','Gambia',id_val_euro,id_lingua,'R','N','GM','GMB',270	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GE','Georgia',id_val_euro,id_lingua,'E','N','GE','GEO',268	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DE','Germania',id_val_euro,id_lingua,'U','N','DE','DEU',276	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GH','Ghana',id_val_euro,id_lingua,'R','N','GH','GHA',288	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'JM','Giamaica',id_val_euro,id_lingua,'R','S','JM','JAM',388	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'JP','Giappone',id_val_euro,id_lingua,'R','N','JP','JPN',392	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GI','Gibilterra',id_val_euro,id_lingua,'R','S','GI','GIB',292	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DJ','Gibuti',id_val_euro,id_lingua,'R','S','DJ','DJI',262	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'JO','Giordania',id_val_euro,id_lingua,'R','N','JO','JOR',400	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GR','Grecia',id_val_euro,id_lingua,'U','N','GR','GRC',300	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GD','Grenada',id_val_euro,id_lingua,'R','S','GD','GRD',308	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GL','Groenlandia',id_val_euro,id_lingua,'R','N','GL','GRL',304	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GP','Guadalupa',id_val_euro,id_lingua,'R','N','GP','GLP',312	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GU','Guam',id_val_euro,id_lingua,'R','N','GU','GUM',316	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GT','Guatemala',id_val_euro,id_lingua,'R','S','GT','GTM',320	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GN','Guinea',id_val_euro,id_lingua,'R','N','GN','GIN',324	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GQ','Guinea Equatoriale',id_val_euro,id_lingua,'R','N','GQ','GNQ',226	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GW','Guinea-Bissau',id_val_euro,id_lingua,'R','N','GW','GNB',624	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GY','Guyana',id_val_euro,id_lingua,'R','N','GY','GUY',328	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GF','Guyana Francese',id_val_euro,id_lingua,'R','N','GF','GUF',254	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HT','Haiti',id_val_euro,id_lingua,'R','N','HT','HTI',332	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HN','Honduras',id_val_euro,id_lingua,'R','N','HN','HND',340	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HK','Hong Kong',id_val_euro,id_lingua,'R','S','HK','HKG',344	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IN','India',id_val_euro,id_lingua,'R','N','IN','IND',356	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ID','Indonesia',id_val_euro,id_lingua,'R','N','ID','IDN',360	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IR','Iran',id_val_euro,id_lingua,'R','N','IR','IRN',364	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IQ','Iraq',id_val_euro,id_lingua,'R','N','IQ','IRQ',368	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IS','Islanda',id_val_euro,id_lingua,'E','N','IS','ISL',352	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'BV','Isola Bouvet',id_val_euro,id_lingua,'R','N','BV','BVT',74	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CX','Isola di Natale',id_val_euro,id_lingua,'R','N','CX','CXR',162	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HM','Isola Heard e Isole McDonald',id_val_euro,id_lingua,'R','N','HM','HMD',334	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NF','Isola Norfolk',id_val_euro,id_lingua,'R','N','NF','NFK',574	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KY','Isole Cayman',id_val_euro,id_lingua,'R','S','KY','CYM',136	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CC','Isole Cocos',id_val_euro,id_lingua,'R','N','CC','CCK',166	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CK','Isole Cook',id_val_euro,id_lingua,'R','S','CK','COK',184	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FK','Isole Falkland',id_val_euro,id_lingua,'R','N','FK','FLK',238	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FO','Isole Faroe',id_val_euro,id_lingua,'R','N','FO','FRO',234	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MP','Isole Marianne Settentrionali',id_val_euro,id_lingua,'R','N','MP','MNP',580	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MH','Isole Marshall',id_val_euro,id_lingua,'R','S','MH','MHL',584	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'UM','Isole Minori degli Stati Uniti America',id_val_euro,id_lingua,'R','N','UM','UMI',581	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SB','Isole Solomon',id_val_euro,id_lingua,'R','N','SB','SLB',90	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TC','Isole Turks e Caicos',id_val_euro,id_lingua,'R','S','TC','TCA',796	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VI','Isole Vergini Americane',id_val_euro,id_lingua,'R','S','VI','VIR',850	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VG','Isole Vergini Britanniche',id_val_euro,id_lingua,'R','S','VG','VGB',92	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IL','Israele',id_val_euro,id_lingua,'R','N','IL','ISR',376	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IT','Italia',id_val_euro,id_lingua,'I','N','IT','ITA',380	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KZ','Kazakhistan',id_val_euro,id_lingua,'R','N','KZ','KAZ',398	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KE','Kenya',id_val_euro,id_lingua,'R','S','KE','KEN',404	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KG','Kirghizistan',id_val_euro,id_lingua,'R','N','KG','KGZ',417	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KI','Kiribati',id_val_euro,id_lingua,'R','S','KI','KIR',296	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KW','Kuwait',id_val_euro,id_lingua,'R','N','KW','KWT',414	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LA','Laos',id_val_euro,id_lingua,'R','N','LA','LAO',418	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LS','Lesotho',id_val_euro,id_lingua,'R','N','LS','LSO',426	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LV','Lettonia',id_val_euro,id_lingua,'U','N','LV','LVA',428	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LB','Libano',id_val_euro,id_lingua,'R','S','LB','LBN',422	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LR','Liberia',id_val_euro,id_lingua,'R','S','LR','LBR',430	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LY','Libia',id_val_euro,id_lingua,'R','N','LY','LBY',434	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LI','Liechtenstein',id_val_euro,id_lingua,'E','S','LI','LIE',438	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LT','Lituania',id_val_euro,id_lingua,'U','N','LT','LTU',440	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LU','Lussemburgo',id_val_euro,id_lingua,'U','S','LU','LUX',442	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MO','Macao',id_val_euro,id_lingua,'R','S','MO','MAC',446	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MK','Macedonia',id_val_euro,id_lingua,'E','N','MK','MKD',807	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MG','Madagascar',id_val_euro,id_lingua,'R','N','MG','MDG',450	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MW','Malawi',id_val_euro,id_lingua,'R','N','MW','MWI',454	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MV','Maldive',id_val_euro,id_lingua,'R','S','MV','MDV',462	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MY','Malesia',id_val_euro,id_lingua,'R','S','MY','MYS',458	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ML','Mali',id_val_euro,id_lingua,'R','N','ML','MLI',466	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MT','Malta',id_val_euro,id_lingua,'U','S','MT','MLT',470	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MA','Marocco',id_val_euro,id_lingua,'R','N','MA','MAR',504	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MQ','Martinica',id_val_euro,id_lingua,'R','N','MQ','MTQ',474	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MR','Mauritania',id_val_euro,id_lingua,'R','N','MR','MRT',478	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MU','Maurizius',id_val_euro,id_lingua,'R','S','MU','MUS',480	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'YT','Mayotte',id_val_euro,id_lingua,'R','N','YT','MYT',175	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MX','Messico',id_val_euro,id_lingua,'R','N','MX','MEX',484	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MD','Moldavia',id_val_euro,id_lingua,'E','N','MD','MDA',498	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MC','Monaco',id_val_euro,id_lingua,'E','S','MC','MCO',492	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MN','Mongolia',id_val_euro,id_lingua,'R','N','MN','MNG',496	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MS','Montserrat',id_val_euro,id_lingua,'R','S','MS','MSR',500	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MZ','Mozambico',id_val_euro,id_lingua,'R','N','MZ','MOZ',508	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'MM','Myanmar',id_val_euro,id_lingua,'R','N','MM','MMR',104	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NA','Namibia',id_val_euro,id_lingua,'R','N','NA','NAM',516	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NR','Nauru',id_val_euro,id_lingua,'R','S','NR','NRU',520	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NP','Nepal',id_val_euro,id_lingua,'R','N','NP','NPL',524	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NI','Nicaragua',id_val_euro,id_lingua,'R','N','NI','NIC',558	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NE','Niger',id_val_euro,id_lingua,'R','N','NE','NER',562	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NG','Nigeria',id_val_euro,id_lingua,'R','N','NG','NGA',566	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NU','Niue',id_val_euro,id_lingua,'R','S','NU','NIU',570	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NO','Norvegia',id_val_euro,id_lingua,'E','N','NO','NOR',578	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NC','Nuova Caledonia',id_val_euro,id_lingua,'R','S','NC','NCL',540	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NZ','Nuova Zelanda',id_val_euro,id_lingua,'R','N','NZ','NZL',554	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'OM','Oman',id_val_euro,id_lingua,'R','S','OM','OMN',512	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'NL','Paesi Bassi',id_val_euro,id_lingua,'U','N','NL','NLD',528	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PK','Pakistan',id_val_euro,id_lingua,'R','N','PK','PAK',586	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PW','Palau',id_val_euro,id_lingua,'R','N','PW','PLW',585	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PA','Panam',id_val_euro,id_lingua,'R','S','PA','PAN',591	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PG','Papua Nuova Guinea',id_val_euro,id_lingua,'R','N','PG','PNG',598	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PY','Paraguay',id_val_euro,id_lingua,'R','N','PY','PRY',600	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PE','Per',id_val_euro,id_lingua,'R','N','PE','PER',604	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PN','Pitcairn',id_val_euro,id_lingua,'R','N','PN','PCN',612	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PF','Polinesia Francese',id_val_euro,id_lingua,'R','S','PF','PYF',258	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PL','Polonia',id_val_euro,id_lingua,'U','N','PL','POL',616	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PR','Porto Rico',id_val_euro,id_lingua,'R','S','PR','PRI',630	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PT','Portogallo',id_val_euro,id_lingua,'U','N','PT','PRT',620	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'QA','Qatar',id_val_euro,id_lingua,'R','N','QA','QAT',634	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GB','Regno Unito',id_val_euro,id_lingua,'U','N','GB','GBR',826	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CZ','Repubblica Ceca',id_val_euro,id_lingua,'U','N','CZ','CZE',203	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CF','Repubblica Centroafricana',id_val_euro,id_lingua,'R','N','CF','CAF',140	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CG','Repubblica del Congo',id_val_euro,id_lingua,'R','N','CG','COG',178	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CD','Repubblica Democratica del Congo',id_val_euro,id_lingua,'R','N','CD','COD',180	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'DO','Repubblica Dominicana',id_val_euro,id_lingua,'R','N','DO','DOM',214	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'RE','Reunion',id_val_euro,id_lingua,'R','N','RE','REU',638	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'RO','Romania',id_val_euro,id_lingua,'U','N','RO','ROU',642	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'RW','Ruanda',id_val_euro,id_lingua,'R','N','RW','RWA',646	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'EH','Sahara Occidentale',id_val_euro,id_lingua,'R','N','EH','ESH',732	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'KN','Saint Kitts e Nevis',id_val_euro,id_lingua,'R','S','KN','KNA',659	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PM','Saint Pierre e Miquelon',id_val_euro,id_lingua,'R','N','PM','SPM',666	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VC','Saint Vincent e Grenadine',id_val_euro,id_lingua,'R','S','VC','VCT',670	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'WS','Samoa',id_val_euro,id_lingua,'R','S','WS','WSM',882	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'AS','Samoa Americane',id_val_euro,id_lingua,'R','N','AS','ASM',16	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SM','San Marino',id_val_euro,id_lingua,'E','S','SM','SMR',674	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LC','Santa Lucia',id_val_euro,id_lingua,'R','S','LC','LCA',662	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SH','Sant Elena',id_val_euro,id_lingua,'R','S','SH','SHN',654	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ST','Sao Tome e Principe',id_val_euro,id_lingua,'R','N','ST','STP',678	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SN','Senegal',id_val_euro,id_lingua,'R','N','SN','SEN',686	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CS','Serbia e Montenegro',id_val_euro,id_lingua,'E','N','CS','SCG',891	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SC','Seychelles',id_val_euro,id_lingua,'R','S','SC','SYC',690	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SL','Sierra Leone',id_val_euro,id_lingua,'R','N','SL','SLE',694	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SG','Singapore',id_val_euro,id_lingua,'R','S','SG','SGP',702	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SY','Siria',id_val_euro,id_lingua,'R','N','SY','SYR',760	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SK','Slovacchia',id_val_euro,id_lingua,'U','N','SK','SVK',703	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SI','Slovenia',id_val_euro,id_lingua,'U','N','SI','SVN',705	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SO','Somalia',id_val_euro,id_lingua,'R','N','SO','SOM',706	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ES','Spagna',id_val_euro,id_lingua,'U','N','ES','ESP',724	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'LK','Sri Lanka',id_val_euro,id_lingua,'R','N','LK','LKA',144	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'FM','Stati Federati della Micronesia',id_val_euro,id_lingua,'R','N','FM','FSM',583	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'US','Stati Uniti America',id_val_euro,id_lingua,'R','N','US','USA',840	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ZA','Sud Africa',id_val_euro,id_lingua,'R','N','ZA','ZAF',710	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'GS','Sud Georgia e Isole Sandwich',id_val_euro,id_lingua,'R','N','GS','SGS',239	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SD','Sudan',id_val_euro,id_lingua,'R','N','SD','SDN',736	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SR','Suriname',id_val_euro,id_lingua,'R','N','SR','SUR',740	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SJ','Svalbard e Jan Mayen',id_val_euro,id_lingua,'R','N','SJ','SJM',744	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SE','Svezia',id_val_euro,id_lingua,'U','N','SE','SWE',752	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'CH','Svizzera',id_val_euro,id_lingua,'E','S','CH','CHE',756	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'SZ','Swaziland',id_val_euro,id_lingua,'R','N','SZ','SWZ',748	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TJ','Tagikistan',id_val_euro,id_lingua,'R','N','TJ','TJK',762	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TH','Tailandia',id_val_euro,id_lingua,'R','N','TH','THA',764	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TW','Taiwan',id_val_euro,id_lingua,'R','S','TW','TWN',158	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TZ','Tanzania',id_val_euro,id_lingua,'R','N','TZ','TZA',834	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'IO','Territori Britannici Oceano Indiano',id_val_euro,id_lingua,'R','N','IO','IOT',92	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TF','Territori Francesi del Sud',id_val_euro,id_lingua,'R','N','TF','ATF',260	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'PS','Territori Palestinesi Occupati',id_val_euro,id_lingua,'R','N','PS','PSE',275	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TL','Timor Est',id_val_euro,id_lingua,'R','N','TL','TLS',626	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TG','Togo',id_val_euro,id_lingua,'R','N','TG','TGO',768	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TK','Tokelau',id_val_euro,id_lingua,'R','N','TK','TKL',772	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TO','Tonga',id_val_euro,id_lingua,'R','S','TO','TON',776	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TT','Trinidad e Tobago',id_val_euro,id_lingua,'R','N','TT','TTO',780	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TN','Tunisia',id_val_euro,id_lingua,'R','N','TN','TUN',788	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TR','Turchia',id_val_euro,id_lingua,'R','N','TR','TUR',792	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TM','Turkmenistan',id_val_euro,id_lingua,'R','N','TM','TKM',795	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'TV','Tuvalu',id_val_euro,id_lingua,'R','S','TV','TUV',798	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'UA','Ucraina',id_val_euro,id_lingua,'E','N','UA','UKR',804	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'UG','Uganda',id_val_euro,id_lingua,'R','N','UG','UGA',800	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'HU','Ungheria',id_val_euro,id_lingua,'U','N','HU','HUN',348	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'UY','Uruguay',id_val_euro,id_lingua,'R','S','UY','URY',858	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'UZ','Uzbekistan',id_val_euro,id_lingua,'R','N','UZ','UZB',860	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VU','Vanuatu',id_val_euro,id_lingua,'R','S','VU','VUT',548	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VE','Venezuela',id_val_euro,id_lingua,'R','N','VE','VEN',862	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'VN','Vietnam',id_val_euro,id_lingua,'R','N','VN','VNM',704	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'WF','Wallis e Futuna',id_val_euro,id_lingua,'R','N','WF','WLF',876	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'YE','Yemen',id_val_euro,id_lingua,'R','N','YE','YEM',887	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ZM','Zambia',id_val_euro,id_lingua,'R','N','ZM','ZMB',894	 FROM PAR_SISTEMA;
INSERT INTO nazione (codice, descrizione, id_valuta, id_lingua, prov_contabile, black_list, alpha_2, alpha_3, iso3166_1) SELECT 'ZW','Zimbabwe',id_val_euro,id_lingua,'R','N','ZW','ZWE',716	 FROM PAR_SISTEMA;


end if;

/////NAZIONI FINE


///ESENZIONE
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'esenzione'
        AND      CNAME = 'max_imp_esente' )) THEN 
		
	ALTER TABLE esenzione ADD "max_imp_esente" decimal(18,4) DEFAULT NULL;
end if;		


ALTER PROCEDURE "DBA"."sp_Aggiorna_Esito_Scadenza"(in @ai_id_scadenza integer)
begin
  /* [ANT] 15/12/97
  Aggiorna il campo Esito_Pagamento della tabella Scadenza. Se il totale importi dei
  Mov_Scadenza collegati  uguale all'importo scadenza => Esito_Pagamento = 'P', altrimenti
  Esito_Pagamento = 'D''.*/
  declare @ldc_tot_mov_scadenza decimal;
  declare @ldc_imp_scadenza decimal;
  declare @lc_esito char;
  declare @LCC_ESITO_PAGATO char;
  declare @LCC_ESITO_DISTINTA char;
  declare @LC_OLDESITO char;
  declare @LCC_ESITO_INSOLUTO char;
  declare @LCC_ESITO_EMESSO char; //BL12932
  declare @ll_padre integer; 
  declare @ll_id_riga_dis_banca integer; //BL12932
  set @LCC_ESITO_PAGATO='P';
  set @LCC_ESITO_INSOLUTO='I';
  set @LCC_ESITO_DISTINTA='D';
  set @LCC_ESITO_EMESSO='E'; //BL12932
  select sum(mov_scadenza.importo) into @ldc_tot_mov_scadenza
    from "dba".mov_scadenza
    where mov_scadenza.id_scadenza=@ai_id_scadenza;
  select scadenza.importo, scadenza.esito_pagamento, id_scadenza_padre into @ldc_imp_scadenza, @LC_OLDESITO, @ll_padre
    from "dba".scadenza
    where scadenza.id_scadenza=@ai_id_scadenza;
  //message '@ldc_tot_mov_scadenza: ',@ldc_tot_mov_scadenza,' - @ldc_imp_scadenza: ',@ldc_imp_scadenza;
  //if @ldc_tot_mov_scadenza=@ldc_imp_scadenza then
  //bl12932 i
  if @ldc_tot_mov_scadenza>=@ldc_imp_scadenza then
    set @lc_esito=@LCC_ESITO_PAGATO
  else
    if @LC_OLDESITO='I' or (@ll_padre>0 and @ll_padre is not null) then
        set @lc_esito=@LCC_ESITO_INSOLUTO
    else 
        set @lc_esito=@LCC_ESITO_EMESSO
    end if;
  end if
  ;
  select scadenza.id_riga_distinta_banca into @ll_id_riga_dis_banca
    from "dba".scadenza
    where scadenza.id_scadenza=@ai_id_scadenza;
  if @ll_id_riga_dis_banca is not null and @ll_id_riga_dis_banca<>0 then
    set @lc_esito=@LCC_ESITO_DISTINTA
  end if
  ; //set @lc_esito=@LCC_ESITO_DISTINTA    
  //bl12932 f    
  update "dba".scadenza set
    esito_pagamento=@lc_esito
    where scadenza.id_scadenza=@ai_id_scadenza
end;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'path_server_sql' )) THEN 
		
	alter table par_sistema add path_server_sql char(256);
end if;


//////////////////////// X MOBSTART
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tv_ges_list'
        AND      CNAME = 'def' )) THEN 
		
		ALTER TABLE "dba"."tv_ges_list" ADD "def" char(1) DEFAULT NULL;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'sk_listini'
        AND      CNAME = 'def' )) THEN 
		
		ALTER TABLE "dba"."sk_listini" ADD "def" char(1) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'barcodes'
        AND      CNAME = 'note' )) THEN 
		
		ALTER TABLE "dba"."barcodes" ADD "note" char(30) DEFAULT NULL;
end if;	
///////////////////////////////////

/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
//DA ESEGUIRE IN TUTTI GLI SCRIPT


IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'TMP_FATTURATO') THEN
	DROP TABLE TMP_FATTURATO;
end if; 



CREATE TABLE "dba"."tmp_fatturato" 
("cod_1" char(32) DEFAULT NULL, "des_1" char(80) DEFAULT NULL, "cod_2" char(32) DEFAULT NULL, 
"des_2" char(80) DEFAULT NULL, "cod_3" char(32) DEFAULT NULL, "des_3" char(80) DEFAULT NULL, 
"cod_4" char(32) DEFAULT NULL, "des_4" char(80) DEFAULT NULL, "imp_1" numeric(18,4) DEFAULT NULL, 
"imp_2" numeric(18,4) DEFAULT NULL, "cod_art" char(32) DEFAULT NULL, "des_art" char(80) DEFAULT NULL, 
"quantita" numeric(20,6) DEFAULT NULL, "peso_netto" numeric(20,6) DEFAULT NULL, 
"prezzo_netto" numeric(20,6) DEFAULT NULL, "num_progressivo" integer DEFAULT NULL, 
"data_registrazione" date DEFAULT NULL, "id_documento" integer DEFAULT NULL, "id_articolo" integer DEFAULT NULL, 
"id_tmp_fatturato" integer NOT NULL DEFAULT autoincrement, "segno_iva" integer DEFAULT NULL) ;


//////
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_016' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_016','Release 2_01_016  Cometa','S')
        ;

END IF
;

