//INIZIO 2_01_017


//Proposta profili CASSA
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_prof_cassa')) THEN 
		
	ALTER TABLE par_sistema ADD id_prof_cassa integer;
end if;



//Causale per reso
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
        AND      CNAME = 'id_caus_reso_default')) THEN 
		
	ALTER TABLE pers_par_sistema ADD id_caus_reso_default integer;
end if;



///////MENU PARAMETRIZZATI
IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'ps_wlogin')) THEN 

	alter table par_sistema add ps_wlogin char(80);
	alter table par_sistema add ps_wmenu char(80);

	IF (select usa_demo from par_sistema)='S' THEN 
	   update par_sistema set ps_wlogin='w_login_contatto';
	end if;

	IF (select isnull(win_doc,'') from par_sis_touch)<>'' and (select count() from par_sis_touch)>0 THEN 
	   update par_sistema p,  par_sis_touch t set p.ps_wmenu=t.win_doc;
	   update par_sistema set ps_wlogin='w_login_touch'
	end if;

	alter table par_sis_touch drop win_doc;

	IF (select isnull(menu_agenti,'N') from par_sistema)='S' THEN 
	   update par_sistema set ps_wmenu='w_menu_pers';
	end if;

	alter table par_sistema drop menu_agenti;

	CREATE TABLE "dba"."harddisk_login" ("id_harddisk_login" integer NOT NULL DEFAULT autoincrement, "seriale_hd" char(80) NOT NULL DEFAULT NULL, "hd_wlogin" char(80) DEFAULT NULL, "hd_wmenu" char(80) DEFAULT NULL, "id_utente" integer DEFAULT NULL, "prop_utente" char(1) DEFAULT NULL , PRIMARY KEY ("id_harddisk_login")) ;
	CREATE UNIQUE INDEX "xk_harddisk_login_1" ON "dba"."harddisk_login" ("seriale_hd" );

end if;


IF not(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mod_registro'
        AND      CNAME = 'hd_serial')) THEN 

	ALTER TABLE mod_registro ADD "hd_serial" char(80) DEFAULT NULL;
	ALTER TABLE mod_registro ADD "id_prof_cassa" integer DEFAULT NULL;
	ALTER TABLE mod_registro ADD "id_sog_cassa" integer DEFAULT NULL;


end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'naz_blacklist')) THEN
	CREATE TABLE "dba"."naz_blacklist" ("id_naz_blacklist" integer NOT NULL DEFAULT autoincrement, "id_nazione" integer NOT NULL DEFAULT NULL, "id_esercizio" integer NOT NULL DEFAULT NULL, "data_inizio" date NOT NULL DEFAULT NULL, "data_fine" date NOT NULL DEFAULT NULL , PRIMARY KEY ("id_naz_blacklist") , FOREIGN KEY "fk_naz_blacklist_1" ("id_nazione" ) REFERENCES "dba"."nazione" ON DELETE RESTRICT , FOREIGN KEY "fk_naz_blacklist_2" ("id_esercizio" ) REFERENCES "dba"."esercizio" ON DELETE RESTRICT ) ;

	insert into naz_blacklist (id_nazione, id_esercizio, data_inizio, data_fine)
	select id_nazione, id_esercizio, data_inizio, data_fine from nazione, esercizio where year(data_inizio)=2010 and black_list='S';

	alter table nazione drop black_list;

end if; 

call fn_ins_voce_menu('Anagrafica', 'w_nazione_lt', 'Nazioni Anagrafica', 8);

call fn_ins_voce_menu('Chiusura / Apertura Conti', 'w_ratei_risconti_controllo_flag_wz', 'Controllo Incongruenze Ratei/Risconti', 40 );




//GENESI
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND    CNAME = 'pref_cod_cl_fiera' ) THEN 
		
	ALTER TABLE "dba"."par_sistema" DROP "pref_cod_cl_fiera";
end if;

//Cometa Chat
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'ip' )) THEN 
		
	ALTER TABLE utenti ADD ip char(20) DEFAULT NULL;
end if;
/////////////////////

//Black List
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'azienda'
        AND      CNAME = 'email_amministrazione' )) THEN 
		
		ALTER TABLE azienda ADD email_amministrazione char(60) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'azienda'
        AND      CNAME = 'web_amministrazione' )) THEN 
		
		ALTER TABLE azienda ADD web_amministrazione char(60) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'legale_rap')) THEN
		
		CREATE TABLE "dba"."legale_rap" (
		"id_legale_rap" integer NOT NULL DEFAULT autoincrement, 
		"cod_fiscale" char(16) DEFAULT NULL, 
		"cod_carica" char(2) DEFAULT NULL, 
		"cognome" char(24) DEFAULT NULL, 
		"nome" char(20) DEFAULT NULL, 
		"sesso" char(1) DEFAULT NULL, 
		"data_nascita" date DEFAULT NULL, 
		"comune_nascita" char(40) DEFAULT NULL, 
		"prov_nascita" char(2) DEFAULT NULL, 
		"comune_residenza" char(40) DEFAULT NULL, 
		"prov_residenza" char(2) DEFAULT NULL, 
		"cap_residenza" char(5) DEFAULT NULL, 
		"via_residenza" char(35) DEFAULT NULL, 
		"telefono" char(12) DEFAULT NULL , 
		"id_azienda" integer NOT NULL DEFAULT 1 ,
		PRIMARY KEY ("id_legale_rap")) ;
		
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'blacklista')) THEN
		
		CREATE TABLE "dba"."blacklista" (
		"id_blacklista" integer NOT NULL DEFAULT autoincrement, 
		"da_data" date DEFAULT NULL, 
		"a_data" date DEFAULT NULL, 
		"tipo_record" char(1) DEFAULT 'A', 
		"codice_fornitura" char(5) DEFAULT NULL, 
		"tipo_fornitore" char(2) DEFAULT NULL, 
		"codice_fiscale" char(16) DEFAULT NULL , 
		PRIMARY KEY ("id_blacklista")) ;
		CREATE INDEX "ix_blacklista" ON "dba"."blacklista" ("da_data" , "a_data" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'blacklistb')) THEN
		
		CREATE TABLE "dba"."blacklistb" (
		"id_blacklistb" integer NOT NULL DEFAULT autoincrement, 
		"tipo_record" char(1) DEFAULT 'B', 
		"codice_fiscale_contribuente" char(16) DEFAULT NULL, 
		"progressivo_modulo" char(8) DEFAULT NULL, 
		"cod_fiscale_software" char(16) DEFAULT NULL, 
		"comunicazione_correttiva" char(1) DEFAULT NULL, 
		"comunicazione_integrativa" char(1) DEFAULT NULL, 
		"anno" char(4) DEFAULT NULL, 
		"mese" char(2) DEFAULT NULL, 
		"trimestre" char(1) DEFAULT NULL, 
		"variazione_periodicita" char(1) DEFAULT NULL, 
		"partita_iva" char(11) DEFAULT NULL, 
		"email" char(100) DEFAULT NULL, 
		"telefono" char(12) DEFAULT NULL, 
		"fax" char(12) DEFAULT NULL, 
		"cognome" char(24) DEFAULT NULL, 
		"nome" char(20) DEFAULT NULL, 
		"sesso" char(1) DEFAULT NULL, 
		"comune_nascita" char(79) DEFAULT NULL, 
		"provincia_nascita" char(2) DEFAULT NULL, 
		"data_nascita" char(8) DEFAULT NULL, 
		"denominazione" char(60) DEFAULT NULL, 
		"natura_giuridica" char(2) DEFAULT NULL, 
		"stato_estero" char(24) DEFAULT NULL, 
		"codice_paese_estero" char(3) DEFAULT NULL, 
		"numero_iva_estero" char(24) DEFAULT NULL, 
		"codice_fiscale_rapp" char(16) DEFAULT NULL, 
		"codice_carica_rapp" char(2) DEFAULT NULL, 
		"codice_fiscale_dich" char(11) DEFAULT NULL, 
		"cognome_rapp" char(24) DEFAULT NULL, 
		"nome_rapp" char(20) DEFAULT NULL, 
		"sesso_rapp" char(1) DEFAULT NULL, 
		"data_nascita_rapp" char(8) DEFAULT NULL, 
		"comune_nascita_rapp" char(40) DEFAULT NULL, 
		"provincia_nascita_rapp" char(2) DEFAULT NULL, 
		"comune_residenza_rapp" char(40) DEFAULT NULL, 
		"provincia_residenza_rapp" char(2) DEFAULT NULL, 
		"cap_residenza_rapp" char(5) DEFAULT NULL, 
		"via_residenza_rapp" char(35) DEFAULT NULL, 
		"telefono_rapp" char(12) DEFAULT NULL, 
		"numero_moduli" char(8) DEFAULT NULL, 
		"firma_dichiarante" char(1) DEFAULT NULL, 
		"codice_fiscale_inter" char(16) DEFAULT NULL, 
		"numero_iscrizione_caf" char(5) DEFAULT NULL, 
		"impegno_telematico" char(1) DEFAULT NULL, 
		"data_impegno" char(8) DEFAULT NULL, 
		"firma_inter" char(1) DEFAULT NULL, 
		"da_data" date DEFAULT NULL, 
		"a_data" date DEFAULT NULL , PRIMARY KEY ("id_blacklistb")) ;
		CREATE INDEX "ix_blacklistb_1" ON "dba"."blacklistb" ("da_data" , "a_data" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'blacklistc')) THEN
		
		CREATE TABLE "dba"."blacklistc" (
		"id_blacklistc" integer NOT NULL DEFAULT autoincrement, 
		"da_data" date DEFAULT NULL, 
		"a_data" date DEFAULT NULL, 
		"tipo_record" char(1) DEFAULT 'C', 
		"codice_fiscale_contr" char(16) DEFAULT NULL, 
		"progressivo_modulo" char(8) DEFAULT NULL, 
		"identificativo_software" char(16) DEFAULT NULL, 
		"a100101a" char(8) DEFAULT 'A100101A', 
		"cognome" char(60) DEFAULT NULL, 
		"a100101b" char(8) DEFAULT 'A100101B', 
		"ragione_sociale" char(60) DEFAULT NULL, 
		"a1001002" char(8) DEFAULT 'A1001002', 
		"nome" char(60) DEFAULT NULL, 
		"a1001003" char(8) DEFAULT 'A1001003', 
		"data_nascita" char(16) DEFAULT NULL, 
		"a1001004" char(8) DEFAULT 'A1001004', 
		"comune_nascita" char(60) DEFAULT NULL, 
		"a1001005" char(8) DEFAULT 'A1001005', 
		"provincia_nascita" char(16) DEFAULT NULL, 
		"a1001006" char(8) DEFAULT 'A1001006', 
		"codice_stato" char(16) DEFAULT NULL, 
		"a1001007" char(8) DEFAULT 'A1001007', 
		"stato" char(16) DEFAULT NULL, 
		"a1001008" char(8) DEFAULT 'A1001008', 
		"localita" char(60) DEFAULT NULL, 
		"a1001009" char(8) DEFAULT 'A1001009', 
		"indirizzo" char(60) DEFAULT NULL, 
		"a1001010" char(8) DEFAULT 'A1001010', 
		"codice_iva" char(16) DEFAULT NULL, 
		"a1001011" char(8) DEFAULT 'A1001011', 
		"codice_fiscale" char(16) DEFAULT NULL, 
		"a1002001" char(8) DEFAULT 'A1002001', 
		"importo_ces" char(16) DEFAULT NULL, 
		"a1003001" char(8) DEFAULT 'A1003001', 
		"imposta_ces" char(16) DEFAULT NULL, 
		"a1004001" char(8) DEFAULT 'A1004001', 
		"importo_prest_ser" char(16) DEFAULT NULL, 
		"a1005001" char(8) DEFAULT 'A1005001', 
		"imposta_prest_ser" char(16) DEFAULT NULL, 
		"a1006001" char(8) DEFAULT 'A1006001', 
		"importo_nonimp_ces" char(16) DEFAULT NULL, 
		"a1007001" char(8) DEFAULT 'A1007001', 
		"importo_nonimp_prest_ser" char(16) DEFAULT NULL, 
		"a1008001" char(8) DEFAULT 'A1008001', 
		"importo_esenti_ces" char(16) DEFAULT NULL, 
		"a1009001" char(8) DEFAULT 'A1009001', 
		"importo_nonsog_ces" char(16) DEFAULT NULL, 
		"a1010001" char(8) DEFAULT 'A1010001', 
		"importo_nonsog_prest_ser" char(16) DEFAULT NULL, 
		"a1011001" char(8) DEFAULT 'A1011001', 
		"importo_notev_ces" char(16) DEFAULT NULL, 
		"a1012001" char(8) DEFAULT 'A1012001', 
		"imposta_notev_ces" char(16) DEFAULT NULL, 
		"a1013001" char(8) DEFAULT 'A1013001', 
		"importo_notev_prest_ser" char(16) DEFAULT NULL, 
		"a1014001" char(8) DEFAULT 'A1014001', 
		"imposta_notev_prest_ser" char(16) DEFAULT NULL, 
		"a1015001" char(8) DEFAULT 'A1015001', 
		"importo_notev_ces_prec" char(16) DEFAULT NULL, 
		"a1016001" char(8) DEFAULT 'A1016001', 
		"imposta_notev_ces_prec" char(16) DEFAULT NULL, 
		"a1017001" char(8) DEFAULT 'A1017001', 
		"importo_notev_prest_ser_prec" char(16) DEFAULT NULL, 
		"a1018001" char(8) DEFAULT 'A1018001', 
		"imposta_notev_prest_ser_prec" char(16) DEFAULT NULL, 
		"a1019001" char(8) DEFAULT 'A1019001', 
		"importo_acq" char(16) DEFAULT NULL, 
		"a1020001" char(8) DEFAULT 'A1020001', 
		"imposta_acq" char(16) DEFAULT NULL, 
		"a1021001" char(8) DEFAULT 'A1021001', 
		"importo_acq_ser" char(16) DEFAULT NULL, 
		"a1022001" char(8) DEFAULT 'A1022001', 
		"imposta_acq_ser" char(16) DEFAULT NULL, 
		"a1023001" char(8) DEFAULT 'A1023001', 
		"importo_nonimp_acq" char(16) DEFAULT NULL, 
		"a1024001" char(8) DEFAULT 'A1024001', 
		"importo_nonimp_acq_ser" char(16) DEFAULT NULL, 
		"a1025001" char(8) DEFAULT 'A1025001', 
		"importo_esenti_acq" char(16) DEFAULT NULL, 
		"a1026001" char(8) DEFAULT 'A1026001', 
		"importo_nonsog_acq" char(16) DEFAULT NULL, 
		"a1027001" char(8) DEFAULT 'A1027001', 
		"importo_nonsog_acq_ser" char(16) DEFAULT NULL, 
		"a1028001" char(8) DEFAULT 'A1028001', 
		"importo_notev_acq" char(16) DEFAULT NULL, 
		"a1029001" char(8) DEFAULT 'A1029001', 
		"imposta_notev_acq" char(16) DEFAULT NULL, 
		"a1030001" char(8) DEFAULT 'A1030001', 
		"importo_notev_acq_ser" char(16) DEFAULT NULL, 
		"a1031001" char(8) DEFAULT 'A1031001', 
		"imposta_notev_acq_ser" char(16) DEFAULT NULL, 
		"a1032001" char(8) DEFAULT 'A1032001', 
		"importo_notev_acq_prec" char(16) DEFAULT NULL, 
		"a1033001" char(8) DEFAULT 'A1033001', 
		"imposta_notev_acq_prec" char(16) DEFAULT NULL, 
		"a1034001" char(8) DEFAULT 'A1034001', 
		"importo_notev_acq_ser_prec" char(16) DEFAULT NULL, 
		"a1035001" char(8) DEFAULT 'A1035001', 
		"imposta_notev_acq_ser_prec" char(16) DEFAULT NULL , 
		PRIMARY KEY ("id_blacklistc")) ;
		CREATE INDEX "ix_blacklistc_1" ON "dba"."blacklistc" ("da_data" , "a_data" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'blacklistz')) THEN
		
		CREATE TABLE "dba"."blacklistz" (
		"id_blacklistz" integer NOT NULL DEFAULT autoincrement, 
		"da_data" date DEFAULT NULL, 
		"a_data" date DEFAULT NULL, 
		"tipo_record" char(1) DEFAULT 'Z', 
		"numero_record_b" char(9) DEFAULT NULL, 
		"numero_record_c" char(9) DEFAULT NULL , 
		PRIMARY KEY ("id_blacklistz")) ;
		CREATE INDEX "ix_blacklistz" ON "dba"."blacklistz" ("da_data" , "a_data" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'nat_giuridica')) THEN
		
		CREATE TABLE "dba"."nat_giuridica" (
		"id_nat_giuridica" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) DEFAULT NULL, 
		"descrizione" char(200) DEFAULT NULL , 
		PRIMARY KEY ("id_nat_giuridica")) ;
		CREATE UNIQUE INDEX "ix_nat_giuridica_1" ON "dba"."nat_giuridica" ("codice" ) ;
		
		insert into nat_giuridica(codice, descrizione) values( '1', 'SOG.RESIDENTI-Societ in accomandita per azioni');
		insert into nat_giuridica(codice, descrizione) values( '2', 'SOG.RESIDENTI-Societ a responsabilit limitata');
		insert into nat_giuridica(codice, descrizione) values( '3', 'SOG.RESIDENTI-Societ per azioni');
		insert into nat_giuridica(codice, descrizione) values( '4', 'SOG.RESIDENTI-Societ cooperative e loro consorzi iscritti nei registri prefettizi e nello schedario della cooperazione');
		insert into nat_giuridica(codice, descrizione) values( '5', 'SOG.RESIDENTI-Altre societ cooperative');
		insert into nat_giuridica(codice, descrizione) values( '6', 'SOG.RESIDENTI-Mutue assicuratrici');
		insert into nat_giuridica(codice, descrizione) values( '7', 'SOG.RESIDENTI-Consorzi con personalit giuridica');
		insert into nat_giuridica(codice, descrizione) values( '8', 'SOG.RESIDENTI-Associazioni riconosciute');
		insert into nat_giuridica(codice, descrizione) values( '9', 'SOG.RESIDENTI-Fondazioni');
		insert into nat_giuridica(codice, descrizione) values('10', 'SOG.RESIDENTI-Altri enti ed istituti con personalit giuridica');
		insert into nat_giuridica(codice, descrizione) values('11', 'SOG.RESIDENTI-Consorzi senza personalit giuridica');
		insert into nat_giuridica(codice, descrizione) values('12', 'SOG.RESIDENTI-Associazioni non riconosciute e comitati');
		insert into nat_giuridica(codice, descrizione) values('13', 'SOG.RESIDENTI-Altre organizzazioni di persone o di beni senza personalit giuridica (escluse le comunioni)');
		insert into nat_giuridica(codice, descrizione) values('14', 'SOG.RESIDENTI-Enti pubblici economici');
		insert into nat_giuridica(codice, descrizione) values('15', 'SOG.RESIDENTI-Enti pubblici non economici');
		insert into nat_giuridica(codice, descrizione) values('16', 'SOG.RESIDENTI-Casse mutue e fondi di previdenza, assistenza, pensioni o simili con o senza personalit giuridica');
		insert into nat_giuridica(codice, descrizione) values('17', 'SOG.RESIDENTI-Opere pie e societ di mutuo soccorso');
		insert into nat_giuridica(codice, descrizione) values('18', 'SOG.RESIDENTI-Enti ospedalieri');
		insert into nat_giuridica(codice, descrizione) values('19', 'SOG.RESIDENTI-Enti ed istituti di previdenza e di assistenza sociale');
		insert into nat_giuridica(codice, descrizione) values('20', 'SOG.RESIDENTI-Aziende autonome di cura, soggiorno e turismo');
		insert into nat_giuridica(codice, descrizione) values('21', 'SOG.RESIDENTI-Aziende regionali, provinciali, comunali e loro consorzi');
		insert into nat_giuridica(codice, descrizione) values('22', 'SOG.RESIDENTI-Societ, organizzazioni ed enti costituiti allestero non altrimenti classificabili con sede dellamministrazione od oggetto principale in Italia');
		insert into nat_giuridica(codice, descrizione) values('23', 'SOG.RESIDENTI-Societ semplici ed equiparate ai sensi dellart. 5, comma 3, lett. b), del TUIR');
		insert into nat_giuridica(codice, descrizione) values('24', 'SOG.RESIDENTI-Societ in nome collettivo ed equiparate ai sensi dellart. 5, comma 3, lett. b), del TUIR');
		insert into nat_giuridica(codice, descrizione) values('25', 'SOG.RESIDENTI-Societ in accomandita semplice');
		insert into nat_giuridica(codice, descrizione) values('26', 'SOG.RESIDENTI-Societ di armamento');
		insert into nat_giuridica(codice, descrizione) values('27', 'SOG.RESIDENTI-Associazione fra artisti e professionisti');
		insert into nat_giuridica(codice, descrizione) values('28', 'SOG.RESIDENTI-Aziende coniugali');
		insert into nat_giuridica(codice, descrizione) values('29', 'SOG.RESIDENTI-GEIE ( Gruppi europei di interesse economico)');
		insert into nat_giuridica(codice, descrizione) values('50', 'SOG.RESIDENTI-Societ per azioni, aziende speciali e consorzi di cui agli artt. 31, 113, 114, 115 e 116 del D.Lgs 18 agosto 2000, n. 267 (Testo Unico delle leggi sullordinamento degli enti locali)');
		insert into nat_giuridica(codice, descrizione) values('51', 'SOG.RESIDENTI-Condomni');
		insert into nat_giuridica(codice, descrizione) values('52', 'SOG.RESIDENTI-Depositi I.V.A.');
		insert into nat_giuridica(codice, descrizione) values('53', 'SOG.RESIDENTI-Societ sportive dilettantistiche costituite in societ di capitali senza fine di lucro');
		insert into nat_giuridica(codice, descrizione) values('54', 'SOG.RESIDENTI-Trust');
		insert into nat_giuridica(codice, descrizione) values('55', 'SOG.RESIDENTI-Amministrazioni pubbliche');
		insert into nat_giuridica(codice, descrizione) values('56', 'SOG.RESIDENTI-Fondazioni bancarie');
		insert into nat_giuridica(codice, descrizione) values('57', 'SOG.RESIDENTI-Societ europea');
		insert into nat_giuridica(codice, descrizione) values('58', 'SOG.RESIDENTI-Societ cooperativa europea');
		insert into nat_giuridica(codice, descrizione) values('30', 'SOG.NON RESIDENTI-Societ semplici, irregolari e di fatto');
		insert into nat_giuridica(codice, descrizione) values('31', 'SOG.NON RESIDENTI-Societ in nome collettivo');
		insert into nat_giuridica(codice, descrizione) values('32', 'SOG.NON RESIDENTI-Societ in accomandita semplice');
		insert into nat_giuridica(codice, descrizione) values('33', 'SOG.NON RESIDENTI-Societ di armamento');
		insert into nat_giuridica(codice, descrizione) values('34', 'SOG.NON RESIDENTI-Associazioni fra professionisti');
		insert into nat_giuridica(codice, descrizione) values('35', 'SOG.NON RESIDENTI-Societ in accomandita per azioni');
		insert into nat_giuridica(codice, descrizione) values('36', 'SOG.NON RESIDENTI-Societ a responsabilit limitata');
		insert into nat_giuridica(codice, descrizione) values('37', 'SOG.NON RESIDENTI-Societ per azioni');
		insert into nat_giuridica(codice, descrizione) values('38', 'SOG.NON RESIDENTI-Consorzi');
		insert into nat_giuridica(codice, descrizione) values('39', 'SOG.NON RESIDENTI-Altri enti ed istituti');
		insert into nat_giuridica(codice, descrizione) values('40', 'SOG.NON RESIDENTI-Associazioni riconosciute, non riconosciute e di fatto');
		insert into nat_giuridica(codice, descrizione) values('41', 'SOG.NON RESIDENTI-Fondazioni');
		insert into nat_giuridica(codice, descrizione) values('42', 'SOG.NON RESIDENTI-Opere pie e societ di mutuo soccorso');
		insert into nat_giuridica(codice, descrizione) values('43', 'SOG.NON RESIDENTI-Altre organizzazioni di persone e di beni');
		insert into nat_giuridica(codice, descrizione) values('44', 'SOG.NON RESIDENTI-Trust');

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'codice_carica')) THEN
		
		CREATE TABLE "dba"."codice_carica" (
		"id_codice_carica" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) DEFAULT NULL, 
		"descrizione" char(200) DEFAULT NULL , 
		PRIMARY KEY ("id_codice_carica")) ;
		CREATE UNIQUE INDEX "ix_codice_carica_1" ON "dba"."codice_carica" ("codice" ) ;
		
		insert into codice_carica(codice, descrizione) values('1', 'Rappresentante legale, negoziale o di fatto, socio amministratore');
		insert into codice_carica(codice, descrizione) values('2', 'Rappresentante di minore, inabilitato o interdetto, amministratore di sostegno, ovvero curatore delleredit giacente,amministratore di eredit devoluta sotto condizione sospensiva o in favore di nascituro non ancora concepito');
		insert into codice_carica(codice, descrizione) values('3', 'Curatore fallimentare');
		insert into codice_carica(codice, descrizione) values('4', 'Commissario liquidatore (liquidazione coatta amministrativa ovvero amministrazione straordinaria)');
		insert into codice_carica(codice, descrizione) values('5', 'Custode giudiziario (custodia giudiziaria), ovvero amministratore giudiziario in qualit di rappresentante dei beni sequestrati ovvero commissario giudiziale (amministrazione controllata)');
		insert into codice_carica(codice, descrizione) values('6', 'Rappresentante fiscale di soggetto non residente');
		insert into codice_carica(codice, descrizione) values('7', 'Erede');
		insert into codice_carica(codice, descrizione) values('8', 'Liquidatore (liquidazione volontaria)');
		insert into codice_carica(codice, descrizione) values('9', 'Soggetto tenuto a presentare la dichiarazione ai fini IVA per conto del soggetto estinto a seguito di operazioni straordinarie o altre trasformazioni sostanziali soggettive (cessionario dazienda, societ beneficiaria, incorporante, conferitaria, ecc.)');
		insert into codice_carica(codice, descrizione) values('10', 'Rappresentante fiscale di soggetto non residente con le limitazioni di cui allart. 44, comma 3, del D.L. n. 331/1993');
		insert into codice_carica(codice, descrizione) values('11', 'Soggetto esercente lattivit tutoria del minore o interdetto in relazione alla funzione istituzionale rivestita');
		insert into codice_carica(codice, descrizione) values('12', 'Liquidatore (liquidazione volontaria di ditta individuale - periodo ante messa in liquidazione)');
		insert into codice_carica(codice, descrizione) values('13', 'Amministratore di condominio');
		insert into codice_carica(codice, descrizione) values('14', 'Soggetto che sottoscrive la dichiarazione per conto di una pubblica amministrazione');
		insert into codice_carica(codice, descrizione) values('15', 'Commissario liquidatore di una pubblica amministrazione');
end if;



//SCADENZE PER GESTIONE SCADENZA PADRE 
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'scadenza'
        AND      CNAME = 'id_scadenza_superiore' )) THEN 
	ALTER TABLE "dba"."scadenza" ADD "id_scadenza_superiore" integer DEFAULT NULL;
end if;

//PAD Tracciabilita
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'riga_distinta'
        AND      CNAME = 'livello_master' )) THEN 
	ALTER TABLE "dba"."riga_distinta" ADD "livello_master" char(1) DEFAULT NULL;	
	//CREATE INDEX "ixc_riga_documento_alt_uc1" ON "DBA"."riga_documento" ( id_alt_uc1 );
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'articolo'
        AND      CNAME = 'tipo_car_scar' )) THEN 

	ALTER TABLE articolo ADD tipo_car_scar char(1) DEFAULT 'N';
	ALTER TABLE cat_merceologica ADD tipo_car_scar char(1) DEFAULT 'N';


	CREATE INDEX "xk_riga_documento_produzione_1" ON "dba"."riga_documento_produzione" ("id_riga_documento" ) ;
	CREATE INDEX "xk_riga_documento_produzione_2" ON "dba"."riga_documento_produzione" ("num_seriale" ) ;

	ALTER TABLE par_sistema ADD gest_serializzazione char(1) DEFAULT 'N';
	ALTER TABLE par_sistema ADD tipo_serial_scar char(1) DEFAULT 'N';   //controllata  - bovina


	DROP INDEX xk_riga_doc_prod_1;

end if;



///fn_ins_voci_menu
ALTER PROCEDURE "DBA"."fn_ins_voce_menu"(@des_padre char(40), @oggetto char(40),@des_oggetto char(40),@ordine integer) /* parameters,... */
as
begin
 
  declare @li_id_oggetto integer,
  @id_voce_padre integer,
  @id_menu integer,
  @conta integer,
  @li_return integer,
  @li_app integer,
  @ll_esiste integer,
  @li_sqlstatus integer,
  @li_id_ogg_app integer
  message 'aa'||string(@des_padre)
  if not(@des_padre is null) and @des_padre<>''
    begin
      declare cur_menu dynamic scroll cursor for select voci_menu.id_voci_menu
          from voci_menu where vmenu_voce=@des_padre and voci_menu.id_oggetti is null
      open cur_menu
      select @li_sqlstatus=0
      select @conta=0
      /**/
      while @li_sqlstatus=0 and @conta<5
        begin
          fetch next cur_menu into @id_voce_padre
          select @li_sqlstatus=@@sqlstatus
          select @conta=@conta + 1
          if(@li_sqlstatus=0)
            begin
              if not(@id_voce_padre is null)
                select @li_return=1
              else
                select @li_return=0
              if(@li_return=1)
                begin
                  message 'ID voce padre:'||string(@id_voce_padre)
                  message 'Oggetto:'||string(@oggetto)
                  //Inserisco sotto voce menu
                  if (@oggetto is null) or (@oggetto='')
                    begin
                      select @li_id_ogg_app=id_voci_menu
                      from voci_menu
                      where vmenu_voce=@des_oggetto
                      message 'sotto menu:'||string(@li_id_ogg_app)
                      if @li_id_ogg_app is null                          
                            insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) 
                                values( @id_voce_padre,@des_oggetto,null,@ordine )
                    end
                  /**/
                  else
                     begin
                       select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       if @li_id_oggetto is null
                          begin
                          insert into oggetti (ogg_oggetto) values (@oggetto)
                          select @li_id_oggetto=max(id_oggetti) from oggetti where ogg_oggetto=@oggetto
                       end 
                      
                      Select @ll_esiste=max(id_voci_menu) from voci_menu
                      where id_oggetti=@li_id_oggetto and id_voci_menu_padre=@id_voce_padre
                      and vmenu_voce=@des_oggetto
                      message 'hh'||string(@ll_esiste)
                      if @ll_esiste is null
                         begin
                         insert into voci_menu(id_voci_menu_padre,vmenu_voce,id_oggetti,vmenu_order) values(
                         @id_voce_padre,@des_oggetto,@li_id_oggetto,@ordine)
                      end 
                  end  
              end
          end
        end
        close cur_menu
    end
end;



//CENTRI DI COSTO - DIGITAL
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'mastro'
        AND      CNAME = 'usa_cdc' )) THEN 

	CREATE TABLE "dba"."cdc" ("id_cdc" integer NOT NULL DEFAULT autoincrement, "cod_cdc" char(8) NOT NULL DEFAULT NULL, "des_cdc" char(80) NOT NULL DEFAULT NULL, "id_cdc_padre" integer DEFAULT NULL, "livello" integer NOT NULL DEFAULT NULL, "cdc_1" integer NOT NULL DEFAULT NULL, "cdc_2" integer NOT NULL DEFAULT NULL, "cdc_3" integer NOT NULL DEFAULT NULL, PRIMARY KEY ("id_cdc")) ;
	CREATE UNIQUE INDEX "xk_cdc_1" ON "dba"."cdc" ("cod_cdc" ) ;

	CREATE TABLE "dba"."cdc_org" ("id_cdc_org" integer NOT NULL DEFAULT autoincrement, "id_cdc" integer NOT NULL DEFAULT NULL, "id_conto" integer NOT NULL DEFAULT NULL, "perc_org" decimal(18,4) DEFAULT NULL , PRIMARY KEY ("id_cdc_org") , FOREIGN KEY "fk_cdc_org_1" ("id_cdc" ) REFERENCES "dba"."cdc" ON DELETE RESTRICT , FOREIGN KEY "fk_cdc_org_2" ("id_conto" ) REFERENCES "dba"."conto" ON DELETE RESTRICT ) ;

	insert into cdc (id_cdc, cod_cdc, des_cdc, livello, cdc_1, cdc_2, cdc_3)
	select           1, 'CDC', 'CDC ' + rag_soc_1 , 0, 0, 0, 0 from azienda;


	call fn_ins_voce_menu('Stampa di Bilancio', '', 'Bilancio CDC', 20 );
	call fn_ins_voce_menu('Bilancio CDC', 'w_cdc_org_cx', 'Centri di Costo', 10 );
	call fn_ins_voce_menu('Bilancio CDC', 'w_cdc_bilancio_ff', 'Stampa CDC', 20 );
	call fn_ins_voce_menu('Bilancio CDC', 'w_cdc_bilancio_mm_ff', 'Stampa Mensile', 30 );


	ALTER TABLE mastro ADD  usa_cdc char(1) DEFAULT 'N';
	ALTER TABLE sys_modulo ADD  usa_cdc char(1) DEFAULT 'N';

end if;

//CDC Commesse
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_scheda') THEN
			
		CREATE TABLE "dba"."com_scheda" (
		"id_com_scheda" integer NOT NULL DEFAULT autoincrement, 
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"copie" char(60) DEFAULT NULL, 
		"collana" char(60) DEFAULT NULL, 
		"descrizione" long varchar DEFAULT NULL, 
		"pagine_int" char(20) DEFAULT NULL, 
		"formato_int" char(20) DEFAULT NULL, 
		"segnature_int" char(100) DEFAULT NULL, 
		"resa_int" char(100) DEFAULT NULL, 
		"colori_int" char(100) DEFAULT NULL, 
		"fogli_int" char(100) DEFAULT NULL, 
		"lastre_int" char(100) DEFAULT NULL, 
		"macchina_int" char(20) DEFAULT NULL, 
		"carta_int" char(100) DEFAULT NULL, 
		"allestimento_int" char(100) DEFAULT NULL, 
		"formato_cop" char(100) DEFAULT NULL, 
		"resa_cop" char(100) DEFAULT NULL, 
		"colori_cop" char(100) DEFAULT NULL, 
		"carta_cop" char(100) DEFAULT NULL, 
		"lastre_cop" char(100) DEFAULT NULL, 
		"macchina_cop" char(100) DEFAULT NULL, 
		"plastifica_cop" char(100) DEFAULT NULL, 
		"descrizione_spec" long varchar DEFAULT NULL , 
		PRIMARY KEY ("id_com_scheda") , FOREIGN KEY "fk_com_scheda_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE ) ;
		CREATE UNIQUE INDEX "ix_com_scheda_1" ON "dba"."com_scheda" ("id_commessa" , "id_com_scheda" ) ;
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_carta_int') THEN
		
		CREATE TABLE "dba"."com_carta_int" (
		"id_com_carta_int" integer NOT NULL DEFAULT autoincrement, 
		"id_com_scheda" integer NOT NULL DEFAULT NULL, 
		"id_articolo" integer DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , 
		PRIMARY KEY ("id_com_carta_int") , 
		FOREIGN KEY "fk_com_carta_int_1" ("id_com_scheda" ) REFERENCES "dba"."com_scheda" ON DELETE CASCADE ) ;		
end if;		

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_carta_cop') THEN
		
		CREATE TABLE "dba"."com_carta_cop" (
		"id_com_carta_cop" integer NOT NULL DEFAULT autoincrement, 
		"id_com_scheda" integer NOT NULL DEFAULT NULL, 
		"id_articolo" integer DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , 
		PRIMARY KEY ("id_com_carta_cop") , 
		FOREIGN KEY "fk_com_carta_cop_1" ("id_com_scheda" ) REFERENCES "dba"."com_scheda" ON DELETE CASCADE ) ;
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'commessa_stato') THEN
		
		CREATE TABLE "dba"."commessa_stato" (
		"id_commessa_stato" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) DEFAULT NULL, 
		"descrizione" char(40) DEFAULT NULL , 
		PRIMARY KEY ("id_commessa_stato")) ;
		CREATE UNIQUE INDEX "ix_commessa_stato_1" ON "dba"."commessa_stato" ("codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'id_commessa_stato' )) THEN 
		
		ALTER TABLE commessa ADD  id_commessa_stato integer DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'libero1' )) THEN 
		
		ALTER TABLE commessa ADD  libero1 char(60) DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'libero2' )) THEN 
		
		ALTER TABLE commessa ADD  libero2 char(60) DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'data_scadenza' )) THEN 
		
		ALTER TABLE commessa ADD  data_scadenza date DEFAULT NULL;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_par_prof'
        AND      CNAME = 'com_righedoc' )) THEN 
		
		ALTER TABLE com_par_prof ADD  com_righedoc char(1) DEFAULT 'N';
end if;


////////////


////SENATORI DATA MODIFICA PREZZ


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prezzo'
        AND      CNAME = 'data_modifica' )) THEN 

	ALTER TABLE prezzo ADD "data_modifica" date DEFAULT today(*);

	set options fire_triggers='OFF';
	update prezzo p, variazione v 
	set p.data_modifica=(select isnull(max(s.data_var),v.data_inizio) from storico_prezzo s where s.id_unita_confezione=p.id_unita_confezione 
	and s.id_variazione=p.id_variazione)
	where p.id_variazione=v.id_variazione;
	set options fire_triggers='ON';


	ALTER TABLE prezzo MODIFY "data_modifica" date DEFAULT today(*) NOT NULL;

	ALTER TABLE artvar_prezzo ADD "data_modifica" date DEFAULT today(*);

	
	set options fire_triggers='OFF';
	update artvar_prezzo p, variazione v 
	set p.data_modifica=(select isnull(max(s.data_var),v.data_inizio) from var_storico_prezzo s where s.id_unita_confezione=p.id_unita_confezione 
	and s.id_variazione=p.id_variazione and s.pk_codice=p.pk_codice)
	where p.id_variazione=v.id_variazione;
	set options fire_triggers='ON';

	ALTER TABLE artvar_prezzo modify "data_modifica" date DEFAULT today(*) NOT NULL;

end if;

if (SELECT codice FROM   AZIENDA)='SENATORI' then

	ALTER TRIGGER "t_artvar_prezzo_bu" BEFORE UPDATE OF "prezzo"

		ORDER 1 ON "DBA"."artvar_prezzo"
	    REFERENCING OLD as old_pz NEW as new_pz

		FOR EACH ROW /* WHEN( search_condition ) */
		BEGIN
		    declare @ls_var1 long varchar;
		    declare @ls_var2 long varchar;
		    declare @ls_var3 long varchar;
        	declare @data_var date;
		declare @id_storico_prezzo integer;
	        declare @arr integer;
	        declare @id_variazione integer;
	        declare @prezzo decimal(20,6);

	        set @id_variazione=new_pz.id_variazione;
        	set @prezzo=new_pz.prezzo;
	        set @data_var=today(*);
		    if new_pz.id_art_var1 is null then 
		       set @ls_var1='N'
		    else
	        	set @ls_var1=string(new_pz.id_art_var1)
		    end if;
		    if new_pz.id_art_var2 is null then 
	        	set @ls_var2='N'
		    else
		        set @ls_var2=string(new_pz.id_art_var2)
		    end if;
		    if new_pz.id_art_var3 is null then 
		        set @ls_var3='N'
		    else
	        	set @ls_var3=string(new_pz.id_art_var3)
		    end if;
			SET new_pz.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;	
	        if old_pz.prezzo<>new_pz.prezzo then
        	    set new_pz.data_modifica=today(*)
	        end if;

	    if @id_variazione=2 or @id_variazione=3 or @id_variazione=4 then
        	select isnull(max(val_arrotondamento),1000000) into @arr from arrotondamento
	        where da_prezzo<=@prezzo and a_prezzo>@prezzo;
	        set @prezzo= ( ceiling( @prezzo * @arr )) / @arr;
        	set new_pz.prezzo=@prezzo;
	     end if;

	END;

	ALTER TRIGGER "t_prezzo_bu" before update OF "prezzo" order 1
		on "DBA".prezzo
		REFERENCING OLD as old_prz NEW as new_prz
		for each row
		begin
 	
		declare @id_variazione integer;
		declare @prezzo decimal(20,6);
		declare @arr integer;
		 
		set @id_variazione=new_prz.id_variazione;
		set @prezzo=new_prz.prezzo;
	    if old_prz.prezzo<>new_prz.prezzo then
	       set new_prz.data_modifica=today(*)
	    end if;

	
	    if @id_variazione=2 or @id_variazione=3 or @id_variazione=4 then
        	select isnull(max(val_arrotondamento),1000000) into @arr from arrotondamento
	        where da_prezzo<=@prezzo and a_prezzo>@prezzo;
        	set @prezzo= ( ceiling( @prezzo * @arr )) / @arr;
	        set new_prz.prezzo=@prezzo;
	    end if;
	END;

end if;

///******** FINE SENATORI



///******** INIZIO CDC - NAVI

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_qualifica'
        AND      CNAME = 'tipo_anag' )) THEN 


	CREATE TABLE "dba"."com_reparto" ("id_com_reparto" integer NOT NULL DEFAULT autoincrement, "codice" char(4) NOT NULL DEFAULT NULL, "descrizione" char(80) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_com_reparto")) ;
	CREATE TABLE "dba"."com_dip_squadra" ("id_com_dip_squadra" integer NOT NULL DEFAULT autoincrement, "codice" char(4) NOT NULL DEFAULT NULL, "descrizione" char(80) DEFAULT NULL, "id_impresa" integer DEFAULT NULL , PRIMARY KEY ("id_com_dip_squadra")) ;

	CREATE TABLE "dba"."com_anag_costi_tipo_scad" ("id_com_anag_costi_tipo_scad" integer NOT NULL DEFAULT autoincrement, "codice" char(4) NOT NULL DEFAULT NULL, "descrizione" char(80) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_com_anag_costi_tipo_scad")) ;
	CREATE TABLE "dba"."com_anag_costi_scad" ("id_com_anag_costi_scad" integer NOT NULL DEFAULT autoincrement, "id_com_anag_costi" integer NOT NULL DEFAULT NULL, "id_com_anag_costi_tipo_scad" integer NOT NULL DEFAULT NULL, "descrizione" char(80) DEFAULT NULL, "stato_scadenza" char(1) NOT NULL DEFAULT NULL, "data_scadenza" date NOT NULL DEFAULT NULL, "importo" decimal(18,2) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_com_anag_costi_scad") , FOREIGN KEY "fk_com_anag_costi_scad_1" ("id_com_anag_costi" ) REFERENCES "dba"."com_anag_costi" ON DELETE CASCADE ) ;
	ALTER TABLE com_anag_costi_tipo_scad ADD tipo_anag char(1) DEFAULT NULL;

	ALTER TABLE com_qualifica ADD tipo_anag char(1) DEFAULT NULL;

	ALTER TABLE com_anag_costi ADD "matricola" char(8) DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "id_anagrafica" integer NULL;
	ALTER TABLE com_anag_costi ADD "data_nascita" date DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "id_com_reparto" integer DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "id_dip_squadra" integer DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "data_inizio" date DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "data_fine" date DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD  FOREIGN KEY "fk_cn_dipendente_1" ("id_com_dip_squadra" ) REFERENCES "dba"."com_dip_squadra" ON DELETE RESTRICT;
	ALTER TABLE com_anag_costi ADD  FOREIGN KEY "fk_cn_dipendente_2" ("id_com_reparto" ) REFERENCES "dba"."com_reparto" ON DELETE RESTRICT;
	ALTER TABLE com_anag_costi ADD  FOREIGN KEY "fk_com_anag_costi_3" ("id_anagrafica" ) REFERENCES "dba"."anagrafica" ON DELETE SET NULL;

	ALTER TABLE com_anag_costi ADD "targa" char(10) DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "proprieta" char(1) DEFAULT NULL;
	ALTER TABLE com_anag_costi ADD "id_proprietario" integer DEFAULT NULL;


end if;

///******** FINE CDC E NAVI


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prog_lotti'
        AND      CNAME = 'data_prelievo_mensile' )) THEN 

	ALTER TABLE prog_lotti ADD data_prelievo_mensile date DEFAULT NULL;
	ALTER TABLE prog_lotti ADD usa_data_prelievo char(1) DEFAULT NULL;

end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'id_prof_acquisto' )) THEN 

	ALTER TABLE par_sistema ADD id_prof_acquisto INTEGER DEFAULT NULL;

end if;

///////////SANSONE - GESTIONE COMMESSE
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'qualifica_utente') THEN
		
		CREATE TABLE "dba"."qualifica_utente" (
		"id_qualifica_utente" integer NOT NULL DEFAULT autoincrement, 
		"codice" char(10) NOT NULL DEFAULT NULL, 
		"descrizione" char(60) DEFAULT NULL , 
		"admin" char(1) DEFAULT 'N' , 
		PRIMARY KEY ("id_qualifica_utente")) ;
		CREATE UNIQUE INDEX "ix_qualifica_utente_1" ON "dba"."qualifica_utente" ("codice" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'utenti'
        AND      CNAME = 'id_qualifica_utente' )) THEN 

		ALTER TABLE utenti ADD id_qualifica_utente INTEGER DEFAULT NULL;

end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_utenti') THEN
		
		CREATE TABLE "dba"."com_utenti" (
		"id_com_utenti" integer NOT NULL DEFAULT autoincrement, 
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"id_utenti" integer NOT NULL DEFAULT NULL, 
		"descrizione" char(50) DEFAULT NULL, 
		"default" char(1) DEFAULT NULL , 
		"id_qualifica_utente" integer NOT NULL DEFAULT NULL,
		PRIMARY KEY ("id_com_utenti") , 
		FOREIGN KEY "fk_com_utenti_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE , 
		FOREIGN KEY "fk_com_utenti_2" ("id_utenti" ) REFERENCES "dba"."utenti" ON DELETE CASCADE ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'ora' )) THEN 
		
		ALTER TABLE annotazione ADD ora time DEFAULT NULL;
end if;		

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'id_commessa' )) THEN 
		
		ALTER TABLE annotazione ADD id_commessa integer DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'annotazione'
        AND      CNAME = 'id_utente' )) THEN 
		
		ALTER TABLE annotazione ADD id_utente integer DEFAULT NULL;
end if;	

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'id_tipo_annotazione' )) THEN 

		ALTER TABLE par_sistema_commesse ADD id_tipo_annotazione INTEGER DEFAULT NULL;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'data_chiusura' )) THEN 
		
		ALTER TABLE commessa ADD data_chiusura date DEFAULT NULL;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'commessa_tv') THEN
		
		CREATE TABLE "dba"."commessa_tv" (
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"id_commessa_padre" integer DEFAULT NULL, 
		"num_riga" numeric(6,0) DEFAULT NULL, 
		"id_root" integer NOT NULL DEFAULT NULL , 
		"budget" numeric(18,4) DEFAULT NULL , 
		PRIMARY KEY ("id_root", "id_commessa") , 
		FOREIGN KEY "fk_commessa_tv_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE , 
		FOREIGN KEY "fk_commessa_tv_2" ("id_commessa_padre" ) REFERENCES "dba"."commessa" ON DELETE CASCADE , 
		FOREIGN KEY "fk_commessa_tv_3" ("id_root" ) REFERENCES "dba"."commessa" ON DELETE CASCADE ) ;
end if;			

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'budget' )) THEN 
		
		ALTER TABLE commessa ADD budget numeric(18,4) DEFAULT NULL;
end if;	

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'comtv_app') THEN
		
		CREATE TABLE "dba"."comtv_app" (
		"id_commessa_rif" integer NOT NULL DEFAULT NULL, 
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"id_utente" integer NOT NULL DEFAULT NULL, 
		"num_riga" integer DEFAULT NULL , 
		"numero" integer DEFAULT NULL ,
		PRIMARY KEY ("id_commessa_rif", "id_commessa", "id_utente")) ;
end if;			


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa_tv'
        AND      CNAME = 'flag' )) THEN 
		
		ALTER TABLE commessa_tv ADD flag char(1) DEFAULT NULL;		
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'ges_livelli' )) THEN 
		
		ALTER TABLE par_sistema_commesse ADD ges_livelli char(1) DEFAULT NULL;		
end if;

IF (EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_anag_costi'
        AND      CNAME = 'matricola' )) THEN 
		
		ALTER TABLE com_anag_costi modify matricola char(30) DEFAULT NULL;		
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'id_anag_costi_att' )) THEN 
		
		ALTER TABLE par_sistema_commesse ADD id_anag_costi_att integer DEFAULT NULL;		
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_costo_attr') THEN
		
		CREATE TABLE "dba"."com_costo_attr" (
		"id_com_costo_attr" integer NOT NULL DEFAULT autoincrement, 
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"id_costo" integer NOT NULL DEFAULT NULL, 
		"data_inizio" date DEFAULT NULL, 
		"data_fine" date DEFAULT NULL , 
		PRIMARY KEY ("id_com_costo_attr") , 
		FOREIGN KEY "fk_com_costo_attr_1" ("id_costo" ) REFERENCES "dba"."com_anag_costi" ON DELETE RESTRICT , 
		FOREIGN KEY "fk_com_costo_attr_2" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE RESTRICT ) ;
		
		CREATE UNIQUE INDEX "ix_com_costo_attr_1" ON "dba"."com_costo_attr" ("id_commessa" , "id_costo" , "data_inizio" ) ;

end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_riga_costo'
        AND      CNAME = 'id_com_costo_attr' )) THEN 
		
		ALTER TABLE com_riga_costo ADD id_com_costo_attr integer DEFAULT NULL;		
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema_commesse'
        AND      CNAME = 'num_ore_giorno' )) THEN 
		
		ALTER TABLE par_sistema_commesse ADD num_ore_giorno integer DEFAULT NULL;		
end if;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'com_storico_budget') THEN
		
		CREATE TABLE "dba"."com_storico_budget" (
		"id_com_storico_budget" integer NOT NULL DEFAULT autoincrement, 
		"id_commessa" integer NOT NULL DEFAULT NULL, 
		"id_utente" integer DEFAULT NULL, 
		"budget" numeric(18,4) DEFAULT NULL, 
		"datavar" date DEFAULT NULL , 
		PRIMARY KEY ("id_com_storico_budget") , 
		FOREIGN KEY "fk_com_storico_budget_1" ("id_commessa" ) REFERENCES "dba"."commessa" ON DELETE CASCADE , 
		FOREIGN KEY "fk_com_storico_budget_2" ("id_utente" ) REFERENCES "dba"."utenti" ON DELETE CASCADE ) ;
		CREATE INDEX "ix_com_storico_budget_1" ON "dba"."com_storico_budget" ("id_commessa" , "id_utente" , "datavar" ) ;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'commessa'
        AND      CNAME = 'id_utente_creaz' )) THEN 
		
		ALTER TABLE commessa ADD id_utente_creaz integer DEFAULT NULL;		
		
		
end if;		

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_com_storico_budget_ai')) THEN
		
		CREATE TRIGGER "t_com_storico_budget_ai" after insert order 1
		on "DBA".commessa
		referencing new as new_commessa
		for each row
		begin

		  declare @id_commessa integer;
		  declare @id_utente integer;
		  declare @budget decimal(18,4);
		  declare @data_var date;
		 
		  set @id_commessa=new_commessa.id_commessa;
		  set @id_utente=new_commessa.id_utente_creaz;
		  set @budget=new_commessa.budget;
		  set @data_var=today(*);

		  insert into "dba".com_storico_budget(id_commessa, id_utente, budget, datavar) 
		  values(@id_commessa, @id_utente, @budget, @data_var)

		end;
end if;		

IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_com_storico_budget_au')) THEN
		
		CREATE TRIGGER "t_com_storico_budget_au" after update order 1
		on "DBA".commessa
		referencing old as old_commessa new as new_commessa
		for each row
		begin
		  declare @id_commessa integer;
		  declare @id_utente integer;
		  declare @budget decimal(18,4);
		  declare @data_var date;
		  declare @id_com_storico_budget integer;

			set @id_commessa=new_commessa.id_commessa;
			set @id_utente=new_commessa.id_utente_creaz;
			set @budget=new_commessa.budget;
			set @data_var=today(*);

			select max(id_com_storico_budget) into @id_com_storico_budget 
			from com_storico_budget
			where id_commessa = @id_commessa
			and id_utente = @id_utente
			and datavar = @data_var;

			if(@id_com_storico_budget is not null) and (@id_com_storico_budget > 0) then
				update com_storico_budget
				set budget = @budget
				where id_com_storico_budget = @id_com_storico_budget

			 else
				insert into "dba".com_storico_budget(id_commessa, id_utente, budget, datavar) 
				values(@id_commessa, @id_utente, @budget, @data_var)
			end if
		end;
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'com_par_prof'
        AND      CNAME = 'com_deriv' )) THEN 
		
		ALTER TABLE com_par_prof ADD com_deriv char(1) DEFAULT 'N';
end if;
////////////////////////////////////

//////Gestione Scarti Lotti
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prog_lotti'
        AND      CNAME = 'id_prof_scarti' )) THEN 
		
		ALTER TABLE prog_lotti ADD id_prof_scarti integer DEFAULT null;
end if;
/////////////


//DATA ORA INSERIMENTO

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'data_inserimento' )) THEN 


	ALTER TABLE documento ADD data_inserimento date DEFAULT today(*);
	ALTER TABLE documento ADD ora_inserimento time DEFAULT now(*);

	ALTER TABLE reg_pd ADD data_inserimento date DEFAULT today(*);
	ALTER TABLE reg_pd ADD ora_inserimento time DEFAULT now(*);

	set options fire_triggers='OFF';
	update reg_pd set data_inserimento=data_registrazione , ora_inserimento=now();
	update documento set data_inserimento=data_registrazione , ora_inserimento=now();
	set options fire_triggers='ON';

	ALTER TABLE documento MODIFY data_inserimento date NOT NULL DEFAULT today(*);
	ALTER TABLE documento MODIFY ora_inserimento time NOT NULL DEFAULT now(*);

	ALTER TABLE reg_pd MODIFY data_inserimento date NOT NULL DEFAULT today(*);
	ALTER TABLE reg_pd MODIFY ora_inserimento time NOT NULL DEFAULT now(*);

end if;

//BANCA SWIFT

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'banca_appoggio'
        AND      CNAME = 'cod_swift' )) THEN 

	ALTER TABLE banca_appoggio ADD cod_swift char(20) DEFAULT NULL;

end if;



IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'destinazione'
        AND      CNAME = 'id_gruppo_destinazione' )) THEN 

	CREATE TABLE "dba"."gruppo_destinazione" ("id_gruppo_destinazione" integer NOT NULL DEFAULT autoincrement, "codice" char(8) NOT NULL DEFAULT NULL, "descrizione" char(80) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_gruppo_destinazione")) ;
	CREATE UNIQUE INDEX "xk_gruppo_destinazione_1" ON "dba"."gruppo_destinazione" ("codice" ) ;

	ALTER TABLE destinazione ADD id_gruppo_destinazione integer DEFAULT NULL;
	ALTER TABLE destinazione ADD FOREIGN KEY fk_destinazione_grd (id_gruppo_destinazione) REFERENCES gruppo_destinazione ON DELETE SET NULL;


end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'destinazione_appoggio' )) THEN 

	ALTER TABLE documento ADD destinazione_appoggio char(256) DEFAULT NULL;

	set options fire_triggers='OFF';
	update documento set destinazione_appoggio='IDEM';
	set options fire_triggers='ON';

end if;

/////////////////
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'par_sis_chiusura') THEN
		
		CREATE TABLE "dba"."par_sis_chiusura" ("id_par_sis_chiusura" integer NOT NULL DEFAULT autoincrement, "id_prof_documento" integer DEFAULT NULL, "id_caus_esi_car" integer DEFAULT NULL, "id_caus_esi_sca" integer DEFAULT NULL, "id_caus_orc_car" integer DEFAULT NULL, "id_caus_orc_sca" integer DEFAULT NULL, "id_caus_orf_car" integer DEFAULT NULL, "id_caus_orf_sca" integer DEFAULT NULL, "id_caus_gr1_car" integer DEFAULT NULL, "id_caus_gr1_sca" integer DEFAULT NULL, "ult_anno_chiuso" char(4) DEFAULT NULL , PRIMARY KEY ("id_par_sis_chiusura")) ;
		CREATE UNIQUE INDEX "pk_par_sis_chiusura" ON "dba"."par_sis_chiusura" ("id_par_sis_chiusura" ) ;
end if;		
/////////////////


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'cal_feste') THEN

	CREATE TABLE "dba"."cal_feste" ("id_cal_feste" integer NOT NULL DEFAULT autoincrement, "anno" integer NOT NULL DEFAULT NULL, "data" date NOT NULL DEFAULT NULL, "stato" char(1) NOT NULL DEFAULT 'N' , PRIMARY KEY ("id_cal_feste")) ;
	CREATE UNIQUE INDEX "fk_cal_feste_1" ON "dba"."cal_feste" ("anno" , "data" ) ;

end if;

call fn_ins_voce_menu('Dati Azienda', 'w_cal_feste_cx', 'Calendario', 9999);

call fn_ins_voce_menu('Anagrafica', 'w_controllo_3000_cl_ff', 'Controllo Fatture/3000', 135);


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'documento'
        AND      CNAME = 'cig' )) THEN 

	ALTER TABLE documento ADD cig char(20) DEFAULT NULL;
	ALTER TABLE documento ADD cup char(20) DEFAULT NULL;
	ALTER TABLE sog_commerciale ADD cig char(20) DEFAULT NULL;
	ALTER TABLE sog_commerciale ADD cup char(20) DEFAULT NULL;
	ALTER TABLE scadenza ADD cig char(20) DEFAULT NULL;
	ALTER TABLE scadenza ADD cup char(20) DEFAULT NULL;

end if;



IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'prof_serial_scar' )) THEN 

	ALTER TABLE "dba"."par_sistema" ADD "prof_serial_scar" char(1) DEFAULT 'N';

end if; 

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
        AND      CNAME = 'item_ctrl_seriale' )) THEN 

	alter table par_sistema add item_ctrl_seriale char(1);

end if; 


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'tipo_pagamento'
        AND      CNAME = 'tipo_pagamento' )) THEN 


	ALTER TABLE tipo_pagamento ADD tipo_pagamento CHAR(1) DEFAULT NULL;
	UPDATE tipo_pagamento SET tipo_pagamento='N';
	ALTER TABLE tipo_pagamento MODIFY tipo_pagamento CHAR(1) DEFAULT NULL NOT NULL;

end if; 


IF NOT(EXISTS(SELECT 1 FROM   SYS.SYSTRIGGERS
        WHERE  TRIGNAME = 't_Reg_PD_Agg_compensi_au')) THEN


	create TRIGGER "t_Reg_PD_Agg_compensi_au" after update order 2
	on "DBA".Reg_Pd
	referencing new as new_reg_pd
	for each row 

	begin

	  update compenso set num_reg_progressivo = new_reg_pd.num_progressivo,
	    data_registrazione = new_reg_pd.data_registrazione,data_competenza = new_reg_pd.data_competenza,
	    num_documento = new_reg_pd.num_documento,data_documento = new_reg_pd.data_documento where
	    id_reg_pd = new_reg_pd.id_reg_pd;

	end;

end if;



////////////***************************************
///////////***** RIEP ANNO INIZIO


IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'riep_articolo') THEN

	alter table par_sistema add art_sw_solo_disp char(1) default 'N';
	update par_sistema set art_sw_solo_disp='N';

	CREATE TABLE "dba"."riep_articolo" ("id_articolo" integer NOT NULL DEFAULT NULL, "ult_costo" numeric(20,6) DEFAULT NULL, 
					"data_ult_costo" date DEFAULT NULL, "primo_costo" numeric(20,6) DEFAULT NULL, "data_primo_costo" date DEFAULT NULL, 
					"qta_rim_iniziale" numeric(18,4) DEFAULT 0, "val_rim_iniziale" numeric(18,4) DEFAULT 0, "qta_caricata" numeric(18,4) DEFAULT 0, 
					"qta_scaricata" numeric(18,4) DEFAULT 0, "val_caricato" numeric(18,4) DEFAULT 0, "val_scaricato" numeric(18,4) DEFAULT NULL, 
					"qta_ord_clienti" numeric(18,4) DEFAULT 0, "qta_ord_fornitori" numeric(18,4) DEFAULT 0, "qta_vis_clienti" numeric(18,4) DEFAULT 0, 
					"qta_vis_fornitori" numeric(18,4) DEFAULT 0, "qta_imp_produzione" numeric(18,4) DEFAULT 0, "qta_ord_produzione" numeric(18,4) DEFAULT 0, 
					"qta_cl_clienti" numeric(18,4) DEFAULT 0, "qta_cl_fornitori" numeric(18,4) DEFAULT 0, "qta_cl_terzi" numeric(18,4) DEFAULT 0, 
					"qta_gruppo_lib_1" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_2" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_3" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_4" numeric(18,4) DEFAULT 0, 
					"id_azienda" integer NOT NULL DEFAULT 1, "data_ult_scarico" date DEFAULT NULL, "peso_caricato" numeric(18,4) DEFAULT NULL, "peso_scaricato" numeric(18,4) DEFAULT NULL, 
					"peso_ord_clienti" numeric(18,4) DEFAULT NULL, "peso_ord_fornitori" numeric(18,4) DEFAULT NULL, "peso_vis_clienti" numeric(18,4) DEFAULT NULL, "peso_vis_fornitori" numeric(18,4) DEFAULT NULL, 
					"peso_imp_produzione" numeric(18,4) DEFAULT NULL, "peso_ord_produzione" numeric(18,4) DEFAULT NULL, "peso_cl_clienti" numeric(18,4) DEFAULT NULL, "peso_cl_fornitori" numeric(18,4) DEFAULT NULL, 
					"peso_gruppo_lib_1" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_2" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_3" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_4" numeric(18,4) DEFAULT NULL, 
					PRIMARY KEY ("id_articolo") , 
                    FOREIGN KEY "fk_riep_articolo_1" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE CASCADE ) ;
	CREATE UNIQUE INDEX "xk_riep_articolo_1" ON "dba"."riep_articolo" ("id_articolo") ;

	CREATE TABLE "dba"."riep_art_var" ("id_articolo" integer NOT NULL DEFAULT NULL, "ult_costo" numeric(20,6) DEFAULT NULL, 
					"data_ult_costo" date DEFAULT NULL, "primo_costo" numeric(20,6) DEFAULT NULL, "data_primo_costo" date DEFAULT NULL, 
					"qta_rim_iniziale" numeric(18,4) DEFAULT 0, "val_rim_iniziale" numeric(18,4) DEFAULT 0, "qta_caricata" numeric(18,4) DEFAULT 0, 
					"qta_scaricata" numeric(18,4) DEFAULT 0, "val_caricato" numeric(18,4) DEFAULT 0, "val_scaricato" numeric(18,4) DEFAULT NULL, 
					"qta_ord_clienti" numeric(18,4) DEFAULT 0, "qta_ord_fornitori" numeric(18,4) DEFAULT 0, "qta_vis_clienti" numeric(18,4) DEFAULT 0, 
					"qta_vis_fornitori" numeric(18,4) DEFAULT 0, "qta_imp_produzione" numeric(18,4) DEFAULT 0, "qta_ord_produzione" numeric(18,4) DEFAULT 0, 
					"qta_cl_clienti" numeric(18,4) DEFAULT 0, "qta_cl_fornitori" numeric(18,4) DEFAULT 0, "qta_cl_terzi" numeric(18,4) DEFAULT 0, 
					"qta_gruppo_lib_1" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_2" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_3" numeric(18,4) DEFAULT 0, "qta_gruppo_lib_4" numeric(18,4) DEFAULT 0, 
					"id_azienda" integer NOT NULL DEFAULT 1, "data_ult_scarico" date DEFAULT NULL, "peso_caricato" numeric(18,4) DEFAULT NULL, "peso_scaricato" numeric(18,4) DEFAULT NULL, 
					"peso_ord_clienti" numeric(18,4) DEFAULT NULL, "peso_ord_fornitori" numeric(18,4) DEFAULT NULL, "peso_vis_clienti" numeric(18,4) DEFAULT NULL, "peso_vis_fornitori" numeric(18,4) DEFAULT NULL, 
					"peso_imp_produzione" numeric(18,4) DEFAULT NULL, "peso_ord_produzione" numeric(18,4) DEFAULT NULL, "peso_cl_clienti" numeric(18,4) DEFAULT NULL, "peso_cl_fornitori" numeric(18,4) DEFAULT NULL, 
					"peso_gruppo_lib_1" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_2" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_3" numeric(18,4) DEFAULT NULL, "peso_gruppo_lib_4" numeric(18,4) DEFAULT NULL, 
					"id_art_var1" integer DEFAULT NULL, "id_art_var2" integer DEFAULT NULL, "id_art_var3" integer DEFAULT NULL, "pk_codice" char(20) NOT NULL DEFAULT NULL , PRIMARY KEY ("id_articolo", "pk_codice") , 
                    FOREIGN KEY "fk_riep_art_var_1" ("id_articolo" ) REFERENCES "dba"."articolo" ON DELETE CASCADE ) ;
	CREATE UNIQUE INDEX "xk_riep_articolo_1" ON "dba"."riep_art_var" ("id_articolo" , "id_art_var1" , "id_art_var2" , "id_art_var3" ) ;
	
	
	
	
	CREATE TRIGGER "t_riep_art_var_bi" BEFORE INSERT
	 ORDER 1 ON "DBA"."riep_art_var"
	 referencing new as new_con
	 for each row
	 begin
		  declare @ls_var1 long varchar;
		  declare @ls_var2 long varchar;
		  declare @ls_var3 long varchar;
		  if new_con.id_art_var1 is null then
			  set @ls_var1='N'
		  else
				set @ls_var1=string(new_con.id_art_var1)
		  end if;
		  if new_con.id_art_var2 is null then
				set @ls_var2='N'
		  else
				set @ls_var2=string(new_con.id_art_var2)
		  end if;
		  if new_con.id_art_var3 is null then
				set @ls_var3='N'
		  else
				set @ls_var3=string(new_con.id_art_var3)
		  end if;
	  SET new_con.pk_codice=@ls_var1+'@'+@ls_var2+'@'+@ls_var3;
	 end;
	
	
	insert into riep_articolo (id_articolo) (select id_articolo from articolo);
	
	
CREATE PROCEDURE "DBA"."sp_gest_caus_art_riepilogo"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Riccardo    02/2011
	  Oggetto: Riepiloghi per Articolo - Variante
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l''unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)

	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino

	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione


    if (@unita_base = 'N') 
        begin
            select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
            from "dba".unita_confezione
            where unita_confezione.unita_base = 'S'
            and unita_confezione.id_articolo = @id_articolo
            select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
            message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
    end    


	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riep_articolo.ult_costo,
	        @Data_Ult_Costo=riep_articolo.data_ult_costo,
	        @Qta_Rim_Iniziale=riep_articolo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riep_articolo.val_rim_iniziale,
	        @Qta_Caricata=riep_articolo.qta_caricata,
	        @Qta_Scaricata=riep_articolo.qta_scaricata,
	        @Val_Caricato=riep_articolo.val_caricato,
	        @Val_Scaricato=riep_articolo.val_scaricato,
	        @Data_Ult_Scarico=riep_articolo.data_ult_scarico,
	        @Qta_Ord_Clienti=riep_articolo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riep_articolo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riep_articolo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riep_articolo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riep_articolo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riep_articolo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riep_articolo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riep_articolo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riep_articolo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riep_articolo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riep_articolo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riep_articolo.qta_gruppo_lib_4,
	        @peso_caricato=riep_articolo.peso_caricato,
	        @peso_scaricato=riep_articolo.peso_scaricato,
	        @peso_ord_clienti=riep_articolo.peso_ord_clienti,
	        @peso_ord_fornitori=riep_articolo.peso_ord_fornitori,
	        @peso_vis_clienti=riep_articolo.peso_vis_clienti,
	        @peso_vis_fornitori=riep_articolo.peso_vis_fornitori,
	        @peso_imp_produzione=riep_articolo.peso_imp_produzione,
	        @peso_ord_produzione=riep_articolo.peso_ord_produzione,
	        @peso_cl_clienti=riep_articolo.peso_cl_clienti,
	        @peso_cl_fornitori=riep_articolo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riep_articolo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riep_articolo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riep_articolo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riep_articolo.peso_gruppo_lib_4
	        from "dba".riep_articolo
	        where(riep_articolo.id_articolo=@Id_Articolo)

	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)

	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end

	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza

	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          if @M_Ord_Clienti='-'
	            begin
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          update riep_articolo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            where (riep_articolo.id_articolo=@Id_Articolo)

	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riep_articolo(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_valuta) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @li_id_valuta) 
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riep_articolo(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_valuta) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @li_id_valuta) 

	                end
	              message ' -> ',sqlstate
	            end
	        end
	    end
	end;	





CREATE PROCEDURE "DBA"."sp_gest_caus_art_riep_var"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Riccardo    02/2011
	  Oggetto: Riepiloghi per Articolo - Variante
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l''unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)

	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino

	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione


    if (@unita_base = 'N') 
        begin
            select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
            from "dba".unita_confezione
            where unita_confezione.unita_base = 'S'
            and unita_confezione.id_articolo = @id_articolo
            select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
            message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
    end    


	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riep_art_var.ult_costo,
	        @Data_Ult_Costo=riep_art_var.data_ult_costo,
	        @Qta_Rim_Iniziale=riep_art_var.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riep_art_var.val_rim_iniziale,
	        @Qta_Caricata=riep_art_var.qta_caricata,
	        @Qta_Scaricata=riep_art_var.qta_scaricata,
	        @Val_Caricato=riep_art_var.val_caricato,
	        @Val_Scaricato=riep_art_var.val_scaricato,
	        @Data_Ult_Scarico=riep_art_var.data_ult_scarico,
	        @Qta_Ord_Clienti=riep_art_var.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riep_art_var.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riep_art_var.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riep_art_var.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riep_art_var.qta_imp_produzione,
	        @Qta_Ord_Produzione=riep_art_var.qta_ord_produzione,
	        @Qta_Cl_Clienti=riep_art_var.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riep_art_var.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riep_art_var.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riep_art_var.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riep_art_var.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riep_art_var.qta_gruppo_lib_4,
	        @peso_caricato=riep_art_var.peso_caricato,
	        @peso_scaricato=riep_art_var.peso_scaricato,
	        @peso_ord_clienti=riep_art_var.peso_ord_clienti,
	        @peso_ord_fornitori=riep_art_var.peso_ord_fornitori,
	        @peso_vis_clienti=riep_art_var.peso_vis_clienti,
	        @peso_vis_fornitori=riep_art_var.peso_vis_fornitori,
	        @peso_imp_produzione=riep_articolo.peso_imp_produzione,
	        @peso_ord_produzione=riep_articolo.peso_ord_produzione,
	        @peso_cl_clienti=riep_articolo.peso_cl_clienti,
	        @peso_cl_fornitori=riep_articolo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riep_articolo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riep_articolo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riep_articolo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riep_articolo.peso_gruppo_lib_4
	        from "dba".riep_articolo
	        where(riep_art_var.id_articolo=@Id_Articolo)
	        and(riep_art_var.pk_codice=@pk_codice)

	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)

	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end

	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza

	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          if @M_Ord_Clienti='-'
	            begin
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          update riep_art_var set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            where (riep_art_var.id_articolo=@Id_Articolo)
	            and(riep_art_var.pk_codice=@pk_codice)

	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riep_art_var(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,
	                    id_valuta) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) 
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riep_art_var(id_articolo,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,                    
	                    id_valuta) values(@ID_Articolo,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) 


	                end
	              message ' -> ',sqlstate
	            end
	        end
	    end
	end;	




ALTER PROCEDURE "DBA"."sp_gest_causale_var"(@Evento char(2),@LaData date,@ID_Esercizio integer,@ID_Attivita integer,@ID_Articolo integer,@ID_Locazione integer,@Anno decimal(4),@Mese decimal(2),@Qta decimal(18,4),@Valore dm_Imp_6_Dec,@Prezzo dm_Imp_6_Dec,@ID_Caus_Magazzino integer,@id_unita_confezione integer,@ll_id_riga_doc_provenienza integer,@peso_netto decimal(18,4),@pk_codice char(20),@id_var1 integer,@id_var2 integer,@id_var3 integer)
	as
	begin
	  /* 
	  Elisa Moneti      29/01/1999
	  Oggetto: Aggiornamento della "Data Ultimo Scarico"
	
	  Elisa M.              21/06/1999 
	  Gestione Ordinato Clienti e Ordinato Fornitori,
	  in seguito alla cancellazione, inserimento o modifica di una riga documento
	  con una causale di mag. che decrementa uno di questi due valori
	
	  Elisa M.    23/05/2000
	  Aggiornamento dell'ultimo costo sia che la movimentazione sia a peso che in quantita'
	
	  Elisa Moneti  20/09/2000      
	  Rif. Bolla 7889 : Aggiornamento dei riepiloghi di magazzino a peso
	
	  Elisa Moneti  31/08/2001
	  BL#15075# -  gestione Valuta per passaggio all''Euro
	  */
	  declare @RowFound integer,
	  @Unita_base char(1),
	  @M_Qta_Rim_Iniziale char(1),
	  @M_Val_Rim_Iniziale char(1),
	  @M_Car_Fiscali char(1),
	  @M_Val_Caricato char(1),
	  @M_Scar_Fiscali char(1),
	  @M_Val_Scaricato char(1),
	  @M_Ult_Scarico char(1),
	  @M_Ord_Clienti char(1),
	  @M_Ord_Fornitori char(1),
	  @M_Vis_Clienti char(1),
	  @M_Vis_Fornitori char(1),
	  @M_Imp_Produzione char(1),
	  @M_Ord_Produzione char(1),
	  @M_Cl_Clienti char(1),
	  @M_Cl_Fornitori char(1),
	  @M_Gruppo_Lib_1 char(1),
	  @M_Gruppo_Lib_2 char(1),
	  @M_Gruppo_Lib_3 char(1),
	  @M_Gruppo_Lib_4 char(1),
	  @M_Ult_Costo char(1),
      /* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
      @ll_molteplicita decimal(20,6),
      @ll_molteplicita_base decimal(20,6),
      /* Controllo che sia l''unita base- Massimo Zurli - fine*/
	  @Qta_Rim_Iniziale decimal(18,4),
	  @Val_Rim_Iniziale decimal(18,4),
	  @Car_Fiscali decimal(18,4),
	  @Val_Caricato decimal(18,4),
	  @Scar_Fiscali decimal(18,4),
	  @Val_Scaricato decimal(18,4),
	  @Data_Ult_Scarico date,
	  @Qta_Caricata decimal(18,4),
	  @Qta_Scaricata decimal(18,4),
	  @Qta_Ord_Clienti decimal(18,4),
	  @Qta_Ord_Fornitori decimal(18,4),
	  @Qta_Vis_Clienti decimal(18,4),
	  @Qta_Vis_Fornitori decimal(18,4),
	  @Qta_Imp_Produzione decimal(18,4),
	  @Qta_Ord_Produzione decimal(18,4),
	  @Qta_Cl_Clienti decimal(18,4),
	  @Qta_Cl_Fornitori decimal(18,4),
	  @Qta_Gruppo_Lib_1 decimal(18,4),
	  @Qta_Gruppo_Lib_2 decimal(18,4),
	  @Qta_Gruppo_Lib_3 decimal(18,4),
	  @Qta_Gruppo_Lib_4 decimal(18,4),
	  @Ult_Costo dm_Imp_6_Dec,
	  @Data_Ult_Costo date,
	  @Ev_Qta decimal(18,4),
	  @Ev_Valore dm_Imp_6_Dec,
	  @mp_car_fiscali char(1),
	  @md_car_fiscali char(1),
	  @ld_qta_ordinata decimal(18,4),
	  @ld_qta_evasa_un_base decimal(18,4),
	  @ll_id_doc_provenienza integer,
	  @ll_id_um_movimentazione integer,
	  @ls_tipo_um char(1),
	  @peso_caricato decimal(18,4),
	  @peso_scaricato decimal(18,4),
	  @peso_ord_clienti decimal(18,4),
	  @peso_ord_fornitori decimal(18,4),
	  @peso_vis_clienti decimal(18,4),
	  @peso_vis_fornitori decimal(18,4),
	  @peso_imp_produzione decimal(18,4),
	  @peso_ord_produzione decimal(18,4),
	  @peso_cl_clienti decimal(18,4),
	  @peso_cl_fornitori decimal(18,4),
	  @peso_gruppo_lib_1 decimal(18,4),
	  @peso_gruppo_lib_2 decimal(18,4),
	  @peso_gruppo_lib_3 decimal(18,4),
	  @peso_gruppo_lib_4 decimal(18,4),
	  @Ev_peso decimal(18,4),
	  @ld_peso_netto_evaso decimal(18,4),
	  @ld_peso_netto_ordinato decimal(18,4),
	  @li_id_valuta integer
	  message 'sp_gest_causale --->'
	  message 'PESO:'||string(@peso_netto)||'QTA.:'||string(@qta)||' VALORE:'+string(@valore)
	  /*
	  Stefano
	  recupero mp_car_fiscali e md_car_fiscale relativamente alla causale
	  di magazzino per sapere se deve essere aggiornato o no il primo costo
	  */
	  select @mp_car_fiscali=mp_car_fiscali,@md_car_fiscali=md_car_fiscali
	    from caus_magazzino
	    where id_caus_magazzino=@ID_Caus_Magazzino
	  /*stefano controlo se l'unita' confezione della riga + un'unita' base; se si aggiorno l''ultimo
	  costo altrimenti no*/
	  select @unita_base=unita_base,@ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita=molteplicita 
	    from "dba".unita_confezione
	    where unita_confezione.id_unita_confezione=@id_unita_confezione
/* Controllo che sia l''unita base- Massimo Zurli - Inizio*/
if (@unita_base = 'N') 
    begin
        select @ll_id_um_movimentazione=id_unita_misura,@ll_molteplicita_base=molteplicita
        from "dba".unita_confezione
        where unita_confezione.unita_base = 'S'
        and unita_confezione.id_articolo = @id_articolo
        select @Qta=(@Qta/@ll_molteplicita)*@ll_molteplicita_base
        message 'Variato:'||@unita_base||'QTA.:'||string(@qta)||' ID  UM:'+string(@ll_id_um_movimentazione)||' Molt:'+string(@ll_molteplicita)
end    
/* Controllo che sia l''unita base - Massimo Zurli - Fine*/
	  select @ls_tipo_um=tipo
	    from unita_misura
	    where id_unita_misura=@ll_id_um_movimentazione
	  if not((@ID_Esercizio is null) or(@ID_Attivita is null) or(@ID_Articolo is null) or(@ID_Locazione is null) or(@Anno is null) or(@Mese is null))
	    begin
	      /*
	      Elisa M.        23/05/00
	      Se la movimentazione e' a peso, il prezzo viene calcolato in base al peso,
	      altrimenti in base alla quantita'
	      */
	      if(@ls_tipo_um='P')
	        begin
	          if(@peso_netto is null) or(@peso_netto=0)
	            begin
	              select @Prezzo=0
	              select @peso_netto=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              /*select @Prezzo=@Valore/@peso_netto*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        end
	      else
	        begin
	          if(@Qta is null) or(@Qta=0)
	            begin
	              select @Prezzo=0
	              select @Qta=0
	            end
	          else
	            begin
	              message '@Prezzo:'+string(@Prezzo)
	              message '@Valore:'+string(@Valore)
	              /*select @Prezzo=@Valore/@Qta*/
	              message '@Prezzo:'+string(@Prezzo)
	            end
	        /*          message ' Prezzo:'||string(@Prezzo)*/
	        end
	      /* BL#15075#i*/
	      select @li_id_valuta=id_valuta
	        from esercizio
	        where id_esercizio=@Id_Esercizio
	      /* BL#15075#f*/
	      /* Carico i valori di causale di magazzino per il magazzino pricipale*/
	      if Substring(@Evento,2,1)='P'
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.mp_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.mp_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.mp_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.mp_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.mp_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.mp_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.mp_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.mp_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.mp_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.mp_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.mp_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.mp_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.mp_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.mp_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.mp_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.mp_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.mp_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.mp_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.mp_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.mp_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      else
	        /* Carico i valori di causale di magazzino per il magazzino secondario*/
	        begin
	          select @M_Qta_Rim_Iniziale=caus_magazzino.md_qta_rim_iniziale,
	            @M_Val_Rim_Iniziale=caus_magazzino.md_val_rim_iniziale,
	            @M_Car_Fiscali=caus_magazzino.md_car_fiscali,
	            @M_Val_Caricato=caus_magazzino.md_val_caricato,
	            @M_Scar_Fiscali=caus_magazzino.md_scar_fiscali,
	            @M_Val_Scaricato=caus_magazzino.md_val_scaricato,
	            @M_Ord_Clienti=caus_magazzino.md_ord_clienti,
	            @M_Ord_Fornitori=caus_magazzino.md_ord_fornitori,
	            @M_Vis_Clienti=caus_magazzino.md_vis_clienti,
	            @M_Vis_Fornitori=caus_magazzino.md_vis_fornitori,
	            @M_Imp_Produzione=caus_magazzino.md_imp_produzione,
	            @M_Ord_Produzione=caus_magazzino.md_ord_produzione,
	            @M_Cl_Clienti=caus_magazzino.md_qta_cl_clienti,
	            @M_Cl_Fornitori=caus_magazzino.md_qta_cl_fornitori,
	            @M_Gruppo_Lib_1=caus_magazzino.md_gruppo_lib_1,
	            @M_Gruppo_Lib_2=caus_magazzino.md_gruppo_lib_2,
	            @M_Gruppo_Lib_3=caus_magazzino.md_gruppo_lib_3,
	            @M_Gruppo_Lib_4=caus_magazzino.md_gruppo_lib_4,
	            @M_Ult_Costo=caus_magazzino.md_ult_costo,
	            @M_Ult_Scarico=caus_magazzino.md_Ult_Scarico
	            from "dba".caus_magazzino
	            where(caus_magazzino.id_caus_magazzino=@ID_Caus_Magazzino)
	        end
	      if Substr(@Evento,1,1)='-'
	        begin
	          select @Ev_Qta=@Qta*-1
	          select @Ev_Valore=@Valore*-1
	          select @Ev_Peso=@Peso_netto*-1
	        end
	      else
	        begin
	          select @Ev_Qta=@Qta*1
	          select @Ev_Valore=@Valore*1
	          select @Ev_Peso=@Peso_netto*1
	        end
	      select @Ult_Costo=riepilogo.ult_costo,
	        @Data_Ult_Costo=riepilogo.data_ult_costo,
	        @Qta_Rim_Iniziale=riepilogo.qta_rim_iniziale,
	        @Val_Rim_Iniziale=riepilogo.val_rim_iniziale,
	        @Qta_Caricata=riepilogo.qta_caricata,
	        @Qta_Scaricata=riepilogo.qta_scaricata,
	        @Val_Caricato=riepilogo.val_caricato,
	        @Val_Scaricato=riepilogo.val_scaricato,
	        @Data_Ult_Scarico=riepilogo.data_ult_scarico,
	        @Qta_Ord_Clienti=riepilogo.qta_ord_clienti,
	        @Qta_Ord_Fornitori=riepilogo.qta_ord_fornitori,
	        @Qta_Vis_Clienti=riepilogo.qta_vis_clienti,
	        @Qta_Vis_Fornitori=riepilogo.qta_vis_fornitori,
	        @Qta_Imp_Produzione=riepilogo.qta_imp_produzione,
	        @Qta_Ord_Produzione=riepilogo.qta_ord_produzione,
	        @Qta_Cl_Clienti=riepilogo.qta_cl_clienti,
	        @Qta_Cl_Fornitori=riepilogo.qta_cl_fornitori,
	        @Qta_Gruppo_Lib_1=riepilogo.qta_gruppo_lib_1,
	        @Qta_Gruppo_Lib_2=riepilogo.qta_gruppo_lib_2,
	        @Qta_Gruppo_Lib_3=riepilogo.qta_gruppo_lib_3,
	        @Qta_Gruppo_Lib_4=riepilogo.qta_gruppo_lib_4,
	        @peso_caricato=riepilogo.peso_caricato,
	        @peso_scaricato=riepilogo.peso_scaricato,
	        @peso_ord_clienti=riepilogo.peso_ord_clienti,
	        @peso_ord_fornitori=riepilogo.peso_ord_fornitori,
	        @peso_vis_clienti=riepilogo.peso_vis_clienti,
	        @peso_vis_fornitori=riepilogo.peso_vis_fornitori,
	        @peso_imp_produzione=riepilogo.peso_imp_produzione,
	        @peso_ord_produzione=riepilogo.peso_ord_produzione,
	        @peso_cl_clienti=riepilogo.peso_cl_clienti,
	        @peso_cl_fornitori=riepilogo.peso_cl_fornitori,
	        @peso_gruppo_lib_1=riepilogo.peso_gruppo_lib_1,
	        @peso_gruppo_lib_2=riepilogo.peso_gruppo_lib_2,
	        @peso_gruppo_lib_3=riepilogo.peso_gruppo_lib_3,
	        @peso_gruppo_lib_4=riepilogo.peso_gruppo_lib_4
	        from "dba".riepilogo
	        where(riepilogo.id_esercizio=@Id_Esercizio)
	        and(riepilogo.id_attivita=@Id_Attivita)
	        and(riepilogo.id_articolo=@Id_Articolo)
	        and(riepilogo.pk_codice=@pk_codice)
	        and(riepilogo.id_locazione=@Id_Locazione)
	        and(riepilogo.anno=@Anno)
	        and(riepilogo.mese=@Mese)
	        and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	      /*      message 'ccc'*/
	      select @RowFound=@@rowcount
	      select @Qta_Rim_Iniziale=isnull(@Qta_Rim_Iniziale,0)
	      select @Val_Rim_Iniziale=isnull(@Val_Rim_Iniziale,0)
	      select @Qta_Caricata=isnull(@Qta_Caricata,0)
	      select @Qta_Scaricata=isnull(@Qta_Scaricata,0)
	      select @Val_Caricato=isnull(@Val_Caricato,0)
	      select @Val_Scaricato=isnull(@Val_Scaricato,0)
	      select @Qta_Ord_Clienti=isnull(@Qta_Ord_Clienti,0)
	      select @Qta_Ord_Fornitori=isnull(@Qta_Ord_Fornitori,0)
	      select @Qta_Vis_Clienti=isnull(@Qta_Vis_Clienti,0)
	      select @Qta_Vis_Fornitori=isnull(@Qta_Vis_Fornitori,0)
	      select @Qta_Imp_Produzione=isnull(@Qta_Imp_Produzione,0)
	      select @Qta_Ord_Produzione=isnull(@Qta_Ord_Produzione,0)
	      select @Qta_Cl_Clienti=isnull(@Qta_Cl_Clienti,0)
	      select @Qta_Cl_Fornitori=isnull(@Qta_Cl_Fornitori,0)
	      select @Qta_Gruppo_Lib_1=isnull(@Qta_Gruppo_Lib_1,0)
	      select @Qta_Gruppo_Lib_2=isnull(@Qta_Gruppo_Lib_2,0)
	      select @Qta_Gruppo_Lib_3=isnull(@Qta_Gruppo_Lib_3,0)
	      select @Qta_Gruppo_Lib_4=isnull(@Qta_Gruppo_Lib_4,0)
	      select @peso_caricato=isnull(@peso_caricato,0)
	      select @peso_scaricato=isnull(@peso_scaricato,0)
	      select @peso_ord_clienti=isnull(@peso_ord_clienti,0)
	      select @peso_ord_fornitori=isnull(@peso_ord_fornitori,0)
	      select @peso_vis_clienti=isnull(@peso_vis_clienti,0)
	      select @peso_vis_fornitori=isnull(@peso_vis_fornitori,0)
	      select @peso_imp_produzione=isnull(@peso_imp_produzione,0)
	      select @peso_ord_produzione=isnull(@peso_ord_produzione,0)
	      select @peso_cl_clienti=isnull(@peso_cl_clienti,0)
	      select @peso_cl_fornitori=isnull(@peso_cl_fornitori,0)
	      select @peso_gruppo_lib_1=isnull(@peso_gruppo_lib_1,0)
	      select @peso_gruppo_lib_2=isnull(@peso_gruppo_lib_2,0)
	      select @peso_gruppo_lib_3=isnull(@peso_gruppo_lib_3,0)
	      select @peso_gruppo_lib_4=isnull(@peso_gruppo_lib_4,0)
	      /*      message 'Ultimo Costo:'||@M_Ult_Costo||' Data_ult_costo:'||string(@Data_ult_costo)||' Data:'||string(@LaData)||' U.B.:'||@unita_base*/
	      if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	        and(@unita_base='S') begin
	          /* BL#20265#i */
	          if @ls_tipo_um='P'
	            begin
	              if(@peso_netto>0)
	                select @ult_costo=@valore/@peso_netto
	              else
	                select @ult_costo=@prezzo
	            end
	          else
	            begin
	              if(@qta>0)
	                select @ult_costo=@valore/@qta
	              else
	                select @ult_costo=@prezzo
	            end
	          /*select @Ult_Costo=@Prezzo*/
	          /* BL#2026#f*/
	          select @Data_Ult_Costo=@LaData
	          message ' aaa Ultimo Costo:'||STRING(@Ult_Costo)||' Data_ult_costo:'||string(@Data_ult_costo)
	        end
	      /*
	      Elisa M.                          21/06/1999
	      Gestione Ordinato Clienti e Ordinato Fornitori
	      */
	      if @ll_id_riga_doc_provenienza<>0 and @ll_id_riga_doc_provenienza is not null
	        select @ld_qta_ordinata=qta_un_base,
	          @ld_qta_evasa_un_base=qta_evasa_un_base,
	          @ll_id_doc_provenienza=id_documento,
	          @ld_peso_netto_ordinato=peso_netto,
	          @ld_peso_netto_evaso=peso_netto_evaso
	          from riga_documento
	          where id_riga_documento=@ll_id_riga_doc_provenienza
	      /*
	      Elisa Moneti
	      29/01/1999
	      Oggetto: Aggiornamento della "Data Ultimo Scarico"
	      */
	      if(@M_Ult_Scarico='S') and(@Data_ult_Scarico<=@LaData or @Data_ult_scarico is null)
	        begin
	          select @Data_Ult_Scarico=@LaData
	        end
	      if @M_Qta_Rim_Iniziale='+'
	        select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale+@Ev_Qta
	      else
	        if @M_Qta_Rim_Iniziale='-'
	          select @Qta_Rim_Iniziale=@Qta_Rim_Iniziale-@Ev_Qta
	      if @M_Val_Rim_Iniziale='+'
	        select @Val_Rim_Iniziale=@Val_Rim_Iniziale+@Ev_Valore
	      else
	        if @M_Val_Rim_Iniziale='-'
	          select @Val_Rim_Iniziale=@Val_Rim_Iniziale-@Ev_Valore
	      if @M_Car_Fiscali='+'
	        begin
	          select @Qta_Caricata=@Qta_Caricata+@Ev_Qta
	          select @peso_caricato=@peso_caricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Car_Fiscali='-'
	            begin
	              select @Qta_Caricata=@Qta_Caricata-@Ev_Qta
	              select @peso_caricato=@peso_caricato-@Ev_peso
	            end
	        end
	      if @M_Scar_Fiscali='+'
	        begin
	          select @Qta_Scaricata=@Qta_Scaricata+@Ev_Qta
	          select @peso_scaricato=@peso_scaricato+@Ev_peso
	        end
	      else
	        begin
	          if @M_Scar_Fiscali='-'
	            begin
	              select @Qta_Scaricata=@Qta_Scaricata-@Ev_Qta
	              select @peso_scaricato=@peso_scaricato-@Ev_peso
	            end
	        end
	      if @M_Val_Caricato='+'
	        select @Val_Caricato=@Val_Caricato+@Ev_Valore
	      else
	        if @M_Val_Caricato='-'
	          select @Val_Caricato=@Val_Caricato-@Ev_Valore
	      if @M_Val_Scaricato='+'
	        select @Val_Scaricato=@Val_Scaricato+@Ev_Valore
	      else
	        if @M_Val_Scaricato='-'
	          select @Val_Scaricato=@Val_Scaricato-@Ev_Valore
	      if @M_Ord_Clienti='+'
	        begin
	          select @Qta_Ord_Clienti=@Qta_Ord_Clienti+@Ev_Qta
	          select @peso_Ord_Clienti=@peso_Ord_Clienti+@Ev_peso
	        end
	      else
	        begin
	          /*
	          Elisa M.                              21/06/1999
	          Gestione Ordinato Clienti
	          */
	          if @M_Ord_Clienti='-'
	            begin
	              /* STORNO (DELETE e prima parte dell''UPDATE) */
	              if substr(@evento,1,1)='-'
	                begin
	                  if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                    select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                  if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                    select @Ev_Peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	                end
	              /* AGGIUNTA (INSERT e seconda parte dell'UPDATE)
	
	              Verifico che la qta evasa o peso evaso della riga 
	              dalla quale deriva (qui arriva gia' aggiornata
	              della qta e del peso del movimento attuale)
	              non sia maggiore della qta ordinata e del peso ordinato
	              */
	              if substr(@evento,1,1)='+'
	                begin
	                  if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                    begin
	                      select @Ev_Qta=@ld_qta_ordinata
	                        -(@ld_qta_evasa_un_base-@Ev_Qta)
	                      if @Ev_Qta<0
	                        select @Ev_Qta=0
	                    end
	                  if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                    begin
	                      select @Ev_peso=@ld_peso_netto_ordinato
	                        -(@ld_peso_netto_evaso-@Ev_peso)
	                      if @Ev_peso<0
	                        select @Ev_peso=0
	                    end
	                end
	              select @Qta_Ord_Clienti=@Qta_Ord_Clienti-@Ev_Qta
	              select @peso_Ord_Clienti=@peso_Ord_Clienti-@Ev_peso
	            end
	        end
	      if @M_Ord_Fornitori='+'
	        begin
	          select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori+@Ev_Qta
	          select @peso_Ord_Fornitori=@peso_Ord_Fornitori+@Ev_peso
	        end
	      else
	        /*
	        Elisa M.                                21/06/1999
	        Gestione Ordinato Fornitori (come Ordinato Clienti)
	        */
	        if @M_Ord_Fornitori='-'
	          begin
	            if substr(@evento,1,1)='-'
	              begin
	                if @ld_qta_evasa_un_base+@Qta>@ld_qta_ordinata
	                  select @Ev_Qta=@ld_qta_evasa_un_base-@ld_qta_ordinata
	                if @ld_peso_netto_evaso+@peso_netto>@ld_peso_netto_ordinato
	                  select @Ev_peso=@ld_peso_netto_evaso-@ld_peso_netto_ordinato
	              end
	            if substr(@evento,1,1)='+'
	              begin
	                if @ld_qta_evasa_un_base>@ld_qta_ordinata
	                  begin
	                    select @Ev_Qta=@ld_qta_ordinata
	                      -(@ld_qta_evasa_un_base-@Ev_Qta)
	                    if @Ev_Qta<0
	                      select @Ev_Qta=0
	                  end
	                if @ld_peso_netto_evaso>@ld_peso_netto_ordinato
	                  begin
	                    select @Ev_peso=@ld_peso_netto_ordinato
	                      -(@ld_peso_netto_evaso-@Ev_peso)
	                    if @Ev_peso<0
	                      select @Ev_peso=0
	                  end
	              end
	            select @Qta_Ord_Fornitori=@Qta_Ord_Fornitori-@Ev_Qta
	            select @peso_Ord_Fornitori=@peso_Ord_Fornitori-@Ev_peso
	          end
	      if @M_Vis_Clienti='+'
	        begin
	          select @Qta_Vis_Clienti=@Qta_Vis_Clienti+@Ev_Qta
	          select @peso_Vis_Clienti=@peso_Vis_Clienti+@Ev_peso
	        end
	      else
	        if @M_Vis_Clienti='-'
	          begin
	            select @Qta_Vis_Clienti=@Qta_Vis_Clienti-@Ev_Qta
	            select @peso_Vis_Clienti=@peso_Vis_Clienti-@Ev_peso
	          end
	      if @M_Vis_Fornitori='+'
	        begin
	          select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori+@Ev_Qta
	          select @peso_Vis_Fornitori=@peso_Vis_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Vis_Fornitori='-'
	          begin
	            select @Qta_Vis_Fornitori=@Qta_Vis_Fornitori-@Ev_Qta
	            select @peso_Vis_Fornitori=@peso_Vis_Fornitori-@Ev_peso
	          end
	      if @M_Imp_Produzione='+'
	        begin
	          select @Qta_Imp_Produzione=@Qta_Imp_Produzione+@Ev_Qta
	          select @peso_Imp_Produzione=@peso_Imp_Produzione+@Ev_peso
	        end
	      else
	        if @M_Imp_Produzione='-'
	          begin
	            select @Qta_Imp_Produzione=@Qta_Imp_Produzione-@Ev_Qta
	            select @peso_Imp_Produzione=@peso_Imp_Produzione-@Ev_peso
	          end
	      if @M_Ord_Produzione='+'
	        begin
	          select @Qta_Ord_Produzione=@Qta_Ord_Produzione+@Ev_Qta
	          select @peso_Ord_Produzione=@peso_Ord_Produzione+@Ev_peso
	        end
	      else
	        if @M_Ord_Produzione='-'
	          begin
	            select @Qta_Ord_Produzione=@Qta_Ord_Produzione-@Ev_Qta
	            select @peso_Ord_Produzione=@peso_Ord_Produzione-@Ev_peso
	          end
	      if @M_Cl_Clienti='+'
	        begin
	          select @Qta_Cl_Clienti=@Qta_Cl_Clienti+@Ev_Qta
	          select @peso_Cl_Clienti=@peso_Cl_Clienti+@Ev_peso
	        end
	      else
	        if @M_Cl_Clienti='-'
	          begin
	            select @Qta_Cl_Clienti=@Qta_Cl_Clienti-@Ev_Qta
	            select @peso_Cl_Clienti=@peso_Cl_Clienti-@Ev_peso
	          end
	      if @M_Cl_Fornitori='+'
	        begin
	          select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori+@Ev_Qta
	          select @peso_Cl_Fornitori=@peso_Cl_Fornitori+@Ev_peso
	        end
	      else
	        if @M_Cl_Fornitori='-'
	          begin
	            select @Qta_Cl_Fornitori=@Qta_Cl_Fornitori-@Ev_Qta
	            select @peso_Cl_Fornitori=@peso_Cl_Fornitori-@Ev_peso
	          end
	      if @M_Gruppo_Lib_1='+'
	        begin
	          select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1+@Ev_Qta
	          select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_1='-'
	          begin
	            select @Qta_Gruppo_Lib_1=@Qta_Gruppo_Lib_1-@Ev_Qta
	            select @peso_Gruppo_Lib_1=@peso_Gruppo_Lib_1-@Ev_peso
	          end
	      if @M_Gruppo_Lib_2='+'
	        begin
	          select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2+@Ev_Qta
	          select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_2='-'
	          begin
	            select @Qta_Gruppo_Lib_2=@Qta_Gruppo_Lib_2-@Ev_Qta
	            select @peso_Gruppo_Lib_2=@peso_Gruppo_Lib_2-@Ev_peso
	          end
	      if @M_Gruppo_Lib_3='+'
	        begin
	          select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3+@Ev_Qta
	          select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_3='-'
	          begin
	            select @Qta_Gruppo_Lib_3=@Qta_Gruppo_Lib_3-@Ev_Qta
	            select @peso_Gruppo_Lib_3=@peso_Gruppo_Lib_3-@Ev_peso
	          end
	      if @M_Gruppo_Lib_4='+'
	        begin
	          select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4+@Ev_Qta
	          select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4+@Ev_peso
	        end
	      else
	        if @M_Gruppo_Lib_4='-'
	          begin
	            select @Qta_Gruppo_Lib_4=@Qta_Gruppo_Lib_4-@Ev_Qta
	            select @peso_Gruppo_Lib_4=@peso_Gruppo_Lib_4-@Ev_peso
	          end
	      if @RowFound=1
	        begin
	          /*                       // BL#14237#*/
	          /*          if Substr(@Evento,1,1)='+'*/
	          /*            begin*/
	          /*              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)*/
	          update riepilogo set
	            ult_costo=@Ult_Costo,
	            data_ult_costo=@Data_ult_costo,
	            qta_rim_iniziale=@Qta_Rim_Iniziale,
	            val_rim_iniziale=@Val_Rim_Iniziale,
	            qta_caricata=@Qta_Caricata,
	            qta_scaricata=@Qta_Scaricata,
	            val_caricato=@Val_Caricato,
	            val_scaricato=@Val_Scaricato,
	            data_ult_scarico=@Data_ult_scarico,
	            qta_ord_clienti=@Qta_Ord_Clienti,
	            qta_ord_fornitori=@Qta_Ord_Fornitori,
	            qta_vis_clienti=@Qta_Vis_Clienti,
	            qta_vis_fornitori=@Qta_Vis_Fornitori,
	            qta_imp_produzione=@Qta_Imp_Produzione,
	            qta_ord_produzione=@Qta_Ord_Produzione,
	            qta_cl_clienti=@Qta_Cl_Clienti,
	            qta_cl_fornitori=@Qta_Cl_Fornitori,
	            qta_gruppo_lib_1=@Qta_Gruppo_Lib_1,
	            qta_gruppo_lib_2=@Qta_Gruppo_Lib_2,
	            qta_gruppo_lib_3=@Qta_Gruppo_Lib_3,
	            qta_gruppo_lib_4=@Qta_Gruppo_Lib_4,
	            /* Elisa M.     21/09/2000      BL7889*/
	            peso_caricato=@peso_caricato,
	            peso_scaricato=@peso_scaricato,
	            peso_ord_clienti=@peso_ord_clienti,
	            peso_ord_fornitori=@peso_ord_fornitori,
	            peso_vis_clienti=@peso_vis_clienti,
	            peso_vis_fornitori=@peso_vis_fornitori,
	            peso_imp_produzione=@peso_imp_produzione,
	            peso_ord_produzione=@peso_ord_produzione,
	            peso_cl_clienti=@peso_cl_clienti,
	            peso_cl_fornitori=@peso_cl_fornitori,
	            peso_gruppo_lib_1=@peso_gruppo_lib_1,
	            peso_gruppo_lib_2=@peso_gruppo_lib_2,
	            peso_gruppo_lib_3=@peso_gruppo_lib_3,
	            peso_gruppo_lib_4=@peso_gruppo_lib_4
	            /**/
	            where(riepilogo.id_esercizio=@Id_Esercizio)
	            and(riepilogo.id_attivita=@Id_Attivita)
	            and(riepilogo.id_articolo=@Id_Articolo)
	            and(riepilogo.pk_codice=@pk_codice)
	            and(riepilogo.id_locazione=@Id_Locazione)
	            and(riepilogo.anno=@Anno)
	            and(riepilogo.mese=@Mese)
	            and(riepilogo.id_valuta=@li_id_valuta) /* BL#15075#*/
	        end
	      else
	        begin
	          if Substr(@Evento,1,1)='+'
	            begin
	              /* BL#14142                */
	              /*              execute sp_ultimo_costo @id_articolo,@LaData,1,@Data_Ult_costo,@Ult_Costo   */
	              if(@M_Ult_Costo='S') and((@Data_ult_costo<=@LaData) or @Data_ult_costo is null)
	                and(@unita_base='S') begin
	                  /* BL#20265#i */
	                  if @ls_tipo_um='P'
	                    if(@peso_netto>0)
	                      select @ult_costo=@valore/@peso_netto
	                    else
	                      select @ult_costo=@valore
	                  else
	                    if(@qta>0)
	                      select @ult_costo=@valore/@qta
	                    else
	                      select @ult_costo=@valore
	                  /*select @Ult_Costo=@Prezzo*/
	                  /* BL#2026#f*/
	                  select @Data_Ult_Costo=@LaData
	                end
	              else
	                /*BL#14142#i*/
	                begin
	                  select @Ult_Costo=0
	                  select @Data_Ult_Costo=null
	                end
	              /*BL#14142#f*/
	              if(@mp_car_fiscali is not null) or(@md_car_fiscali is not null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    primo_costo,
	                    data_primo_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,
	                    /* BL#15075#*/
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Prezzo,
	                    Today(*),
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889*/
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              if(@mp_car_fiscali is null) and(@md_car_fiscali is null) begin
	                  insert into "dba".riepilogo(id_esercizio,
	                    id_attivita,
	                    id_articolo,
	                    id_locazione,
	                    anno,
	                    mese,
	                    ult_costo,
	                    data_ult_costo,
	                    qta_rim_iniziale,
	                    val_rim_iniziale,
	                    qta_caricata,
	                    qta_scaricata,
	                    val_caricato,
	                    val_scaricato,
	                    qta_ord_clienti,
	                    qta_ord_fornitori,
	                    qta_vis_clienti,
	                    qta_vis_fornitori,
	                    qta_Imp_Produzione,
	                    qta_ord_produzione,
	                    qta_cl_clienti,
	                    qta_cl_fornitori,
	                    qta_gruppo_lib_1,
	                    qta_gruppo_lib_2,
	                    qta_gruppo_lib_3,
	                    qta_gruppo_lib_4,
	                    data_ult_scarico,
	                    /* BL7889 */
	                    peso_caricato,
	                    peso_scaricato,
	                    peso_ord_clienti,
	                    peso_ord_fornitori,
	                    peso_vis_clienti,
	                    peso_vis_fornitori,
	                    peso_imp_produzione,
	                    peso_ord_produzione,
	                    peso_cl_clienti,
	                    peso_cl_fornitori,
	                    peso_gruppo_lib_1,
	                    peso_gruppo_lib_2,
	                    peso_gruppo_lib_3,
	                    peso_gruppo_lib_4,
	                    id_art_var1,
	                    id_art_var2,
	                    id_art_var3,                    
	                    id_valuta) values(@ID_Esercizio,
	                    @ID_Attivita,
	                    @ID_Articolo,
	                    @ID_Locazione,
	                    @Anno,
	                    @Mese,
	                    @Ult_Costo,
	                    @Data_ult_costo,
	                    @Qta_Rim_Iniziale,
	                    @Val_Rim_Iniziale,
	                    @Qta_Caricata,
	                    @Qta_Scaricata,
	                    @Val_Caricato,
	                    @Val_Scaricato,
	                    @Qta_Ord_Clienti,
	                    @Qta_Ord_Fornitori,
	                    @Qta_Vis_Clienti,
	                    @Qta_Vis_Fornitori,
	                    @Qta_Imp_Produzione,
	                    @Qta_Ord_Produzione,
	                    @Qta_Cl_Clienti,
	                    @Qta_Cl_Fornitori,
	                    @Qta_Gruppo_Lib_1,
	                    @Qta_Gruppo_Lib_2,
	                    @Qta_Gruppo_Lib_3,
	                    @Qta_Gruppo_Lib_4,
	                    @Data_ult_scarico,
	                    /* BL7889 */
	                    @peso_caricato,
	                    @peso_scaricato,
	                    @peso_ord_clienti,
	                    @peso_ord_fornitori,
	                    @peso_vis_clienti,
	                    @peso_vis_fornitori,
	                    @peso_imp_produzione,
	                    @peso_ord_produzione,
	                    @peso_cl_clienti,
	                    @peso_cl_fornitori,
	                    @peso_gruppo_lib_1,
	                    @peso_gruppo_lib_2,
	                    @peso_gruppo_lib_3,
	                    @peso_gruppo_lib_4,
	                    @id_var1,
	                    @id_var2,
	                    @id_var3,
	                    @li_id_valuta) /* BL#15075#*/
	                end
	              message ' -> ',sqlstate
	            end
	        end

	execute "dba".sp_gest_caus_art_riepilogo @Evento, @LaData, @ID_Esercizio, @ID_Attivita, @ID_Articolo, @ID_Locazione, @Anno, @Mese, @Qta, @Valore, @Prezzo, @ID_Caus_Magazzino, @id_unita_confezione, @ll_id_riga_doc_provenienza, @peso_netto, @pk_codice, @id_var1, @id_var2, @id_var3

	//////***  solo quando servira per varianti - execute "dba".sp_gest_caus_art_riep_var @Evento, @LaData, @ID_Esercizio, @ID_Attivita, @ID_Articolo, @ID_Locazione, @Anno, @Mese, @Qta, @Valore, @Prezzo, @ID_Caus_Magazzino, @id_unita_confezione, @ll_id_riga_doc_provenienza, @peso_netto, @pk_codice, @id_var1, @id_var2, @id_var3


	    end
	end;




end if;

call fn_ins_voce_menu('Utility', 'w_ricalcolo_riep_anno_wz', 'Ricalcolo Riepiloghi Articolo', 55);

///////////***** RIEP ANNO FINE





/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
//DA ESEGUIRE IN TUTTI GLI SCRIPT


IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'TMP_FATTURATO') THEN
	DROP TABLE TMP_FATTURATO;
end if; 



CREATE TABLE "dba"."tmp_fatturato" 
("cod_1" char(32) DEFAULT NULL, "des_1" char(80) DEFAULT NULL, "cod_2" char(32) DEFAULT NULL, 
"des_2" char(80) DEFAULT NULL, "cod_3" char(32) DEFAULT NULL, "des_3" char(80) DEFAULT NULL, 
"cod_4" char(32) DEFAULT NULL, "des_4" char(80) DEFAULT NULL, "imp_1" numeric(18,4) DEFAULT NULL, 
"imp_2" numeric(18,4) DEFAULT NULL, "cod_art" char(32) DEFAULT NULL, "des_art" char(80) DEFAULT NULL, 
"quantita" numeric(20,6) DEFAULT NULL, "peso_netto" numeric(20,6) DEFAULT NULL, 
"prezzo_netto" numeric(20,6) DEFAULT NULL, "num_progressivo" integer DEFAULT NULL, 
"data_registrazione" date DEFAULT NULL, "id_documento" integer DEFAULT NULL, "id_articolo" integer DEFAULT NULL, 
"id_tmp_fatturato" integer NOT NULL DEFAULT autoincrement, "segno_iva" integer DEFAULT NULL) ;


//////
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_017' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_017','Release 2_01_017  Cometa','S')
        ;

END IF
;

